# gtk-fortran

**This branch is for GTK 4**

The gtk-fortran project aims to offer scientists programming in Fortran a cross-platform library to build Graphical User Interfaces (GUI). Gtk-fortran is a partial GTK / Fortran binding 100% written in Fortran, thanks to the C / Fortran interoperability features introduced in the Fortran 2003 standard.

To install gtk-fortran, you can follow the quick instructions in the `INSTALL` file or the more [detailed instructions](https://github.com/vmagnin/gtk-fortran/wiki/Installation) on the wiki documentation.

Full documentation (wiki tab):
[https://github.com/vmagnin/gtk-fortran/wiki](https://github.com/vmagnin/gtk-fortran/wiki)

Please post bugs on GitHub:
[https://github.com/vmagnin/gtk-fortran/issues](https://github.com/vmagnin/gtk-fortran/issues)


# Files in this directory

* `README.md`: the present file.
* `CHANGELOG.md`: list of the releases with main changes.
* `CITATION.cff`: file used by the GitHub interface (button "Cite this repository").
* `CMakeLists.txt`: main CMake instructions to build the project.
* `codemeta.json`: metadata about the project.
* `fpm.toml`: Fortran Package Manager manifest.
* `INSTALL`: quick installation instructions (see the Wiki for more details).
* `LICENSE`: text of the GNU GPL v3 license.
* `LICENSE_EXCEPTION`: text of the GCC Runtime Library Exception version 3.1.
* `README-high-level`: about the High Level part of the gtk-fortran library.
* `VERSIONS`: a CSV file with the gtk-fortran, GTK, GLib and distribution versions.


# Citing gtk-fortran

Please acknowledge the use of gtk-fortran by citing the following publication:

Vincent MAGNIN, James TAPPIN, Jens HUNGER, Jerry DE LISLE, "gtk-fortran: a GTK+ binding to build Graphical User Interfaces in Fortran", _Journal of Open Source Software,_ 4(34), 1109, 12th January 2019, [https://doi.org/10.21105/joss.01109](https://doi.org/10.21105/joss.01109)

# gtk-fortran -- High level interfaces

The high level interface for gtk-fortran is in the source file
gtk-hl.f90. This provides a number of higher level interfaces to the
GTK widget system, with the intent of making GUI construction more
accessible to scientific programmers (the feel should not be too alien
to anyone who has developed GUIs in IDL). The routines make use of the
optional arguments in Fortran>=90 to simplify creating and initializing widgets.

## Modules list:

* gtk_hl: A wrapper that includes all of the other modules.

* gtk_hl_assistant: A bundled interface for the assistant widget.

* gtk_hl_button: Implements interfaces to various kinds of button.

* gtk_hl_chooser: Implements file choosers that do not need variadic
       arguments.

* gtk_hl_combobox: Implements interfaces to text comboboxes.

* gtk_hl_container: Implements interfaces to: Window, box, table
       (implemented as grid in GTK 3.x), notebook and scrolled window.

* gtk_hl_dialog: Implements a message dialog widget that does not require
       variadic calls.

* gtk_hl_entry: Implements interfaces to entry and textview widgets.

* gtk_hl_infobar: An interface to the infobar widget. Removes much of the
       complexity of putting a message into the widget.

* gtk_hl_misc: Miscellaneous interfaces, mostly used by other modules.

* gtk_hl_progress: Implements progress bars, including "m of n" settings
       and automated text addition.

* gtk_hl_spin_slider: Implements spin boxes and sliders (including
       convenient integer interfaces).

* gtk_hl_tree: Implements interfaces to the list & tree widgets.


In addition two graphics modules are available, but are not automatically
included with the gtk_hl module:

* gtk_draw_hl: Implements interfaces to drawing areas and their
       relationship to Cairo. (N.B. The reversed naming convention is a
       historical accident). Drawing areas created with this module
       have the necessary features to be used as drawing surfaces by
       plplot.

* gdk_pixbuf_hl: Implements convenient interfaces to GDK pixbufs and
       formats.

Several demos are provided in the examples/ directory: they have the
prefix hl_.

# gtk-fortran logo

## Contains
In this directory, you will find:

- `gtk-fortran-logo.svg`: the logo created with Inkscape. The blue color of the GTK cube, which HSL (hue, saturation, lightness) values are (211, 49, 63), was replaced in 2023 by a purple whose hue (270) is the same as the hue of the Fortran logo.
- The logo in PNG format, in three sizes:
  - `logo-gtk-fortran-small.png`: 99x38 pixels.
  - `logo-gtk-fortran.png`: 299x115 pixels.
  - `logo-gtk-fortran-big.png`: 799x307 pixels.

## Licenses

The gtk-fortran logo uses the GTK logo (by Andreas Nilsson) and so is also under GNU Free Documentation License Version 1.2 or later & Creative Commons Attribution-Share Alike 3.0 Unported license. Its font is DejaVu Sans, a font under a free license.

# Tutorials programs

This directory contains the different stages of the program described in the wiki tutorial [My first gtk-fortran application](https://github.com/vmagnin/gtk-fortran/wiki/Tutorial-1).

# gtk-fortran source files

In the following filenames, the ? character is the GTK major version.

## gtk-fortran core

- `gtk-fortran.f90`: a `gtk-?-fortran` command to show information about the library.
- `*-auto.f90` and `*-auto.in`: these files contains the Fortran interfaces to the C functions of the various GTK libraries. They are generated by the `cfwrapper/cfwrapper.py` script.
- `api_compability.f90`: contains the `gtk_os_dependent` module to keep API compatibility, following some changes in GTK 4.2.0.
- `gtk-fortran-index.csv`: list of all the interfaces generated in the `*-auto.f90` files, with the name of the library, the name of the function, its status (deprecated or not), the names of the `.f90` file and the `.h` file, the C prototype of the function and the Fortran definition. Generated by the `cfwrapper/cfwrapper.py` script.
- `gtk-fortran_types.csv`: list of all the GLib / GTK types used in the prototypes of the C functions. Generated by the `cfwrapper/cfwrapper.py` script.
- `gtk-fortran_funptr.csv`: list of all the funptr types used in the prototypes of the C functions. Generated by the `cfwrapper/cfwrapper.py` script.
- `gtk.f90`: it contains the gtk module, which will be used by every GTK program. The `g_signal_connect()` and `gtk_init()` subroutines are defined here. The `gtkenums-auto.*` and `gtk-auto.*` files are automatically included.
- `gtk-sup.f90`: this module contains some supplementary material useful for writing GTK programs in Fortran.
- `gtk-fortran.pc.in`: template used by CMake to generate the `gtk-?-fortran.pc` pkg-config file.
- `extract_events.pl`: extracts the structure definitions for GDK events from the GDK header files.
  - `gdkevents-auto.f90`: Fortran GDK events structures generated by `extract_events.pl`.
- `extract_enums.pl`: find the enumerator constants in a Fortran source file and write them out to a simple list.
  - `gtk-enumerators.lis`: list generated by `extract_enums.pl`.

## High Level interface

- `gtk_hl.f90`: the `gtk_hl` main Fortran module, which includes the other `gtk-hl-*` modules:
  - `gtk-*hl-*.f90`
- `gdk-pixbuf-hl.f90`: some routines to facilitate the use of GDK pixbufs from Fortran.

## Various scripts

- `show_versions.sh`: shows the versions of the main tools and libraries used in gtk-fortran.
- `screenshots.sh`: automatically launches each gtk-fortran example and take a PNG screenshot using the `scrot` command. A suffix is added to the name of the example.
- `build.sh`: an interactive script to build, install and test gtk-fortran using CMake. It can be called by `cfwrapper.py` with the `-b` option.
- `test_extra.sh`: an interactive script to test projects gtk-fortran-extra and gtkzero_fpm before gtk-fortran release.
- `alt_build_test.sh`: an alternative simple build system, using the directory `../build/byscript` and finally launching one by one the examples for testing.
- `usemodules.pl`: scan a Fortran source file or files for GTK (etc.) routines. This is a somewhat 'tighter' replacement for `usemodules.py`.
  - `gtk-modules.txt`: the `USE` statements to copy/paste in your programs, generated by `usemodules.pl`.
  - `gtk-fortran-modscan.man`: man page of the `gtk-?-fortran-modscan` command (`usemodules.pl`).
- `usemodules.py`: this program scan all the Fortran files in the given directory and subdirectories to generate `USE` statements you can paste in your gtk-fortran programs. It also print warnings if you use deprecated GTK functions, and finally displays all the GTK functions used in a directory. It generates:
  - `usemodules.txt`: the `USE` statements to copy/paste in your programs, generated by `usemodules.py`.
- `tools.py`: that module contains functions used by `usemodules.py` and `cfwrapper/cfwrapper.py`.
- `extract_hl_doc.py`: generates markdown files for the HL gtk-fortran documentation.

# gtkf-sketcher

A gtk-fortran Code Sketcher using UI XML definitions. It will automatically generate gtk-fortran code to accelerate your development.

This directory contains:
- `gtkf-sketcher.f90`
- `gtkf-sketcher.glade`: the UI XML definitions for `gtkf-sketcher.f90`
- `example.glade`: a UI XML file you can use as an example to test gtkf-sketcher.
- `default.options`: the options used in `gtkf-sketcher.f90`.
- `data`: this directory contains the text licenses proposed by the sketcher.

# gtk-fortran & PLplot

In this directory there are a few examples of using the [PLplot library](http://plplot.sourceforge.net/) in conjunction with gtk-fortran. PLplot is a scientific graphics library that has a modern Fortran binding.

## Requirements

- Either CMake and pkg-config, or fpm (Fortran Package Manager).
- gtk-fortran: including for these examples the high-level modules gtk\_hl and gtk\_draw\_hl.
- PLplot>=5.13: including the Cairo drivers.

A wrapper module `plplot_extra.mod` is created by the gtk-fortran system to allow access to the `pl_cmd()` routine in PLplot which is not in its Fortran binding. It provides low-level access to the system and is needed to correctly configure the "extcairo" driver.

## Concept

The example codes here use the "extcairo" driver in PLplot to write to the backing surface of a GTK drawable created by `hl_gtk_drawing_area_new`.

The typical program structure is summarized as:

### Main:

- Create the GTK widgets, including a drawing area.
- Realize the widget hierarchy.
- Call the PLplot drawing routine(s).
- Enter the event loop.

### Handlers:

- Handle events and if needed, call the PLplot drawing routine(s) with updated settings.

### PLplot drawing:

- Connect PLplot's output to the backing surface (see below).
- Make the plot(s).
- Call `gtk_widget_queue_draw` on the drawing area to force a redraw.

### Globals:

- For convenience in all examples I've put all the `use` statements and any global variables into a separate module that can be used by all of the other units.

###  In the example codes these are:

* The main program (called `cairo_plplot_ex<n>`).
* The common module (`common_ex<n>`).
* The drawing module (`plplot_code_ex<n>`).
* The handlers (`handlers_ex<n>`).


## Connecting PLplot's output to the drawing area

For the "extcairo" driver, output is to an externally-created cairo context. So here you need to create a cairo context connected to the backing surface (this is most easily done with
`hl_gtk_drawing_area_cairo_new`). And then use `pl_cmd` to connect PLplot's output to the context.  To do this the following code needs to precede the call to `plinit` (or `plstar`):

    ! Get a cairo context from the drawing area.
    cc = hl_gtk_drawing_area_cairo_new(area)

    !  Initialize plplot
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    write(geometry, "(I0,'x',I0)") width, height
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

And then after `plinit` you need:

    call pl_cmd(PLESC_DEVINIT, cc)

A Fortran interface to `pl_cmd` is provided by the `plplot_extra` module.


## Building the examples

If PLplot is found when building gtk-fortran, then the interface module for `pl_cmd` will be built and installed and the examples will be built by CMake. The instructions that follow are therefore only needed if you want to build them manually for some reason.

The PLplot example(s) are most easily built if gtk-fortran has been installed. Then it is simply a matter of:

    gfortran -o hl_plplot<x>e hl_plplot<x>e.f90 $(pkg-config --cflags --libs \
             gtk-<n>-fortran  plplot-fortran plplot)

where `<x>` is the number of the example, and `<n>` is the GTK major version you are using.

The examples are derived from the Fortran versions of examples 1, 4, 8, 30 and 17 on the PLplot web site:

- hl_plplot1e: Basic x-y plots on multiple pages.
- hl_plplot4e: Log plots, using 2 drawing areas.
- hl_plplot8e: 3-D data display.
- hl_plplot17e: Strip charts, shows continuous updating.
- hl_plplot30e: Transparency.

## Known issues

Different releases of GFortran, let alone different fortran compilers, may not read each other's module files, therefore PLplot must be built with the same compiler as gtk-fortran.

If you wish to explicitly exclude building and installing PLplot support, then when running cmake, include the option `-D
EXCLUDE_PLPLOT=true` (e.g.: `cmake -D EXCLUDE_PLPLOT=true ..`)

## When using gtk-fortran as a fpm dependency

Put in the `fpm.toml` manifest of your project:

```toml
[dependencies]
gtk-fortran = { git = "https://github.com/vmagnin/gtk-fortran.git", branch = "gtk4" }

[build]
link = ["plplot", "plplotfortran"]
external-modules = ["plplot"]
```

and build and run your project with:

```bash
$  fpm run --flag '$(pkg-config --cflags --libs plplot plplot-fortran)'
```

# CMake additional modules

This directory contains the modules to be loaded by `include()` or `find_package()` before checking the default CMake modules:

- `cmake_uninstall.cmake.in`: generic code from https://gitlab.kitware.com/cmake/community/-/wikis/FAQ#can-i-do-make-uninstall-with-cmake
- `DefaultFlags.cmake`: defines default Release and Debug flags for compilers.

# cfwrapper source files

- `cfwrapper/cfwrapper.py`: this is the precious heart of gtk-fortran. Developers use it to automatically parse the GTK libraries header files. It generates:
  - `../*-auto.f90`: these files contains the Fortran interfaces to the C functions of the various GTK libraries.
  - `../gtk-fortran-index.csv`: list of all the interfaces generated in the `*-auto.f90` files, with the name of the library, the name of the function, its status (deprecated or not), the names of the `.f90` file and the `.h` file, the C prototype of the function and the Fortran definition.
  - `cfwrapper/gtk-fortran-hash.pkl`: the SHA1 hash of all `*-auto.f90` files. Useful for the development of `cfwrapper.py` to detect modifications in the resulting `.f90` files.
  - `cfwrapper/cfwrapper-errors.csv`: for the developers, a list of problems encountered by the `cfwrapper.py` script when parsing the `.h` files. Not pushed in GitHub.
  - `../../VERSIONS`: a CSV file with the gtk-fortran, GTK, GLib and distribution versions used to generate the library. It is used by the build system.
- `cfwrapper/run_tests.py`: for testing some functions of the cfwrapper.
- Other `*.py` files: the modules used by `cfwrapper.py`.

# Gtk-fortran Example Programs

This directory contains example programs for the GTK 4 version of gtk-fortran. They are automatically built by CMake but any example may also be individually built on a system with `gtk-4-fortran` installed with the command:

```bash
$ gfortran <name>.f90 -o <name> $(pkg-config --cflags --libs gtk-4-fortran)
```

Among those examples:

- `gtkzero_gapp.f90` just opens an empty GTK window. Based on GtkApplication and GApplication.
- `gtkhello.f90` opens a window with two buttons.
- The `*pixbuf*.f90` examples demonstrate pixel drawing (bitmap drawing). The `pixbuf_without_gui.f9`0 example draws a Sierpinski triangle in a PNG file, without using a GUI.
- The `cairo*.f90` examples demonstrates vectorial drawing using Cairo. And `cairo-basics.f90` also saves the drawing in a SVG file and a PDF file.
- `bazaar.f90` is used for testing various widgets and functions.
    - `demo_sound.ogg` will be played when you click on Button1.
- `gio_demo.f90`: this is a very basic demo to get started with GIO. It uses
Fortran I/O to read text from the keyboard & writes it to the file `gio_demo.dat` in the current directory.
- `gtkbuilder2.f90` demonstrates how you can use an UI XML file to create your graphical user interface.
- `list_demo.f90` demonstrates how to use GtkTreeView for displaying trees and lists.
- `menubar.f90` demonstrates a menubar based on GMenu and GAction. It also uses CSS styles.
- `notebooks.f90` demonstrates how to use GtkNotebook, a tabbed notebook container.
- `regex.f90` (no GUI) demonstrates how to use GLib regular expressions functions.
- `hl_*` examples use the "high-level" interface.
    - `hl_pbar.f90`: a progress bar.
    - ...
- `tests.f90` (no GUI) is testing things about ISO_C_BINDING and the relations between Fortran types and GLib types.
- `tests_gtk_sup.f90` (no GUI) is testing functions and structures defined in the `gtk_sup` module.

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 2020-05-28 (GTK 4), 2020-07-14
!------------------------------------------------------------------------------

module handlers
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_spin_slider
  use gtk, only: gtk_button_new, gtk_window_set_child, &
       & gtk_spin_button_get_value, gtk_spin_button_new, &
       & gtk_spin_button_set_value, gtk_window_destroy, &
       & gtk_widget_show, TRUE, FALSE

  implicit none
  type(c_ptr) :: base, box, slid, islid, win, qbut, spin, ispin

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Exit called"
    call gtk_window_destroy(win)
  end subroutine my_destroy

  subroutine slider1(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    ! Moved the float slider, set the int spinner and report
    real(c_double) :: val

    val = hl_gtk_slider_get_value(widget)
    print *, "FP slider moved to", val
    call hl_gtk_spin_button_set_value(spin, val)
  end subroutine slider1

  subroutine slider2(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    ! Moved the int slider, set the int spinner and report
    integer(c_int) :: ival

    ival = nint(hl_gtk_slider_get_value(widget), c_int)
    print *, 'INT slider moved to', ival
    call hl_gtk_spin_button_set_value(ispin, ival)
  end subroutine slider2

  subroutine spinner1(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    ! Moved the FP spinner, set the FP slider & report
    real(c_double) :: val

    val = hl_gtk_spin_button_get_value(widget)
    print *, "FP spinner moved to", val
    call hl_gtk_slider_set_value(slid, val)
  end subroutine spinner1

  subroutine spinner2(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    ! Move the int spinner, set the int slider & report
    integer(c_int) :: ival

    ival = nint(hl_gtk_spin_button_get_value(widget), c_int)
    print *, 'INT spinner moved to', ival
    call hl_gtk_slider_set_value(islid, ival)
  end subroutine spinner2

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata

    ! Create a window and 2 boxes, one horizontal,one vertical
    win = gtk_application_window_new(app)
    call gtk_window_set_title(win, "Sliders demo"//c_null_char)

    base = hl_gtk_box_new()
    call gtk_window_set_child(win, base)
    box = hl_gtk_box_new(horizontal=TRUE, homogeneous=TRUE)
    call hl_gtk_box_pack(base, box)

    ! make a floating point vertical slider with a range 0-10 and step 0.1
    ! put it in the horizontal box
    slid = hl_gtk_slider_new(0._c_double, 10._c_double, 0.1_c_double, &
         & vertical = TRUE, value_changed=c_funloc(slider1), length=200_c_int)
    call hl_gtk_box_pack(box, slid)

    ! Now an integer slider from 0-64 and put it in the horizontal box
    islid = hl_gtk_slider_new(0_c_int, 64_c_int, vertical=TRUE, &
         & value_changed=c_funloc(slider2), length=200_c_int)
    call hl_gtk_box_pack(box, islid)

    ! Make a spin button with range 0-10 and step 0.1 and put it in
    ! the vertical box
    spin = hl_gtk_spin_button_new(0._c_double, 10._c_double, 0.1_c_double, &
         & value_changed=c_funloc(spinner1))
    call hl_gtk_box_pack(base, spin)

    ! Make an integer spin button with range from 0-64 and put it in the
    ! vertical box
    ispin = hl_gtk_spin_button_new(0_c_int, 64_c_int, &
         & value_changed=c_funloc(spinner2), &
         & wrap=TRUE)
    call hl_gtk_box_pack(base, ispin)

    ! Finally make a quit button, put that in the vertical box and put
    ! the vertical box in the window.

    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base, qbut)

    ! Realize & enter event loop
    call gtk_widget_show(win)
  end subroutine activate
end module handlers


program sliders
  ! SLIDERS
  ! Demo of sliders & spin buttons
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_sliders"//c_null_char, &
                             & c_funloc(activate))
end program sliders

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 2020-06-12 (GTK 4), 2020-07-15
!------------------------------------------------------------------------------

module ln_handlers
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_tree
  use gtk_hl_entry
  use gtk, only: gtk_button_new, gtk_window_set_child, gtk_widget_show, &
               & gtk_window_destroy
  use g, only: alloca, g_object_set_property

  implicit none
  ! The widgets. (Strictly only those that need to be accessed
  ! by the handlers need to go here).
  type(c_ptr) :: ihwin,ihscrollcontain,ihlist, base, &
       &  qbut, lbl

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Exit called"
    call gtk_window_destroy(ihwin)
  end subroutine my_destroy

  subroutine list_select(list, gdata) bind(c)
    type(c_ptr), value, intent(in) :: list, gdata
    integer(c_int) :: nsel
    integer(c_int), dimension(:), allocatable :: selections
    integer(c_int) :: n, n3
    integer(c_int64_t) :: n4
    real(c_float) :: nlog
    character(len=30) :: name
    character(len=10) :: nodd
    character :: code, ucode
    integer(c_int) :: icode, iucode

    nsel = hl_gtk_listn_get_selections(C_NULL_PTR, selections, list)
    if (nsel == 0) then
       print *, "No selection"
       return
    end if

    ! Find and print the selected row(s)
    print *, nsel,"Rows selected"
    print *, selections
    if (nsel == 1) then
       call hl_gtk_listn_get_cell(ihlist, selections(1), 0_c_int, svalue=name)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 1_c_int, ivalue=n)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 2_c_int, ivalue=n3)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 4_c_int, l64value=n4)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 3_c_int, fvalue=nlog)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 5_c_int, svalue=nodd)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 6_c_int, svalue=code)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 7_c_int, svalue=ucode)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 6_c_int, ivalue=icode)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 7_c_int, ivalue=iucode)
       print "('Row:',I3,' Name: ',a,' N:',I3,' 3N:',I4,' N**4:',I7,&
            &' log(n):',F7.5,' Odd?: ',a, ' Code:',a,a)", &
            & selections(1), trim(name), n, n3, n4, nlog, nodd, code, ucode
       print *, ichar(code), ichar(ucode)
       print *, icode, iucode
    end if

    deallocate(selections)
  end subroutine list_select

  subroutine display_int(col, cell, model, iter, data) bind(c)
    type(c_ptr), value, intent(in) :: col, cell, model, iter, data

    ! Formatting routine attached via hl_gtk_listn_set_cell_data_func
    ! Note that the column index is passed via the DATA argument, so
    ! far as I can see the only other way is to use constants.
    character(len=10) :: rstring
    integer(c_int) :: ival
    type(gvalue), target :: ivalue, svalue
    type(c_ptr) :: val_ptr
    integer(c_int), pointer :: colno

    call c_f_pointer(data, colno)

    call gtk_tree_model_get_value(model, iter, colno, c_loc(ivalue))
    ival = g_value_get_int(c_loc(ivalue))

    write(rstring, "(I7.6)") ival

    val_ptr = c_loc(svalue)
    val_ptr = g_value_init(val_ptr, G_TYPE_STRING)

    call g_value_set_string(val_ptr, trim(rstring)//c_null_char)
    call g_object_set_property(cell, "text"//c_null_char, val_ptr)
  end subroutine display_int

  subroutine cell_edited(renderer, path, text, gdata) bind(c)
    type(c_ptr), value, intent(in) :: renderer, path, text, gdata

    ! Callback for edited cells.
    character(len=200) :: fpath, ftext
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    integer :: ios
    type(c_ptr) :: pcol, list
    integer(c_int) :: n

    call convert_c_string(path, fpath)
    read(fpath, *) irow
    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)
    call convert_c_string(text, ftext)
    list = g_object_get_data(renderer, "view"//c_null_char)

    if (icol == 0) then
       call hl_gtk_listn_set_cell(list, irow, icol, &
            & svalue=trim(ftext))
    else
       read(ftext, *, iostat=ios) n
       if (ios /= 0) return
       call hl_gtk_listn_set_cell(ihlist, irow, 2_c_int, &
            & ivalue=3_c_int*n)
       call hl_gtk_listn_set_cell(ihlist, irow, 3_c_int, fvalue=log10(real(n)))
       call hl_gtk_listn_set_cell(ihlist, irow, 4_c_int, &
            & l64value=int(n,c_int64_t)**4)
       call hl_gtk_listn_set_cell(ihlist, irow, 5_c_int, ivalue=mod(n,2_c_int))
       ! Note we set the N value last as this is a sortable column, if we
       ! are sorted on ODD/EVEN it will probably still go wrong.
       call hl_gtk_listn_set_cell(ihlist, irow, 1_c_int, ivalue=n)
    end if
  end subroutine cell_edited

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    character(len=35) :: line
    integer(c_int) :: i, ltr
    integer(type_kind), dimension(8) :: ctypes
    character(len=20), dimension(8) :: titles
    integer(c_int), dimension(8) :: sortable, editable
    integer(c_int), target :: fmt_col = 2
    character(kind=c_char), dimension(10) :: codes

    ! Create the window:
    ihwin = gtk_application_window_new(app)
    call gtk_window_set_title(ihwin, "multi-column list demo"//c_null_char)

    ! Now make a column box & put it into the window
    base = hl_gtk_box_new()
    call gtk_window_set_child(ihwin, base)

    ! Now make a multi column list with multiple selections enabled
    ctypes = [ G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT, G_TYPE_FLOAT, &
         & G_TYPE_UINT64, G_TYPE_BOOLEAN, G_TYPE_CHAR, G_TYPE_UCHAR ]
    sortable = [ FALSE, TRUE, FALSE, FALSE, FALSE, TRUE, TRUE, FALSE ]
    editable = [ TRUE, TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE ]
    codes = [ 'A', 'X', 'B', '?', 'A', 'C', char(185), 'u', '*', char(201)]

    titles(1) = "Name"
    titles(2) = "N"
    titles(3) = "3N"
    titles(4) = "Log(n)"
    titles(5) = "N**4"
    titles(6) = "Odd?"
    titles(7) = "Code"
    titles(8) = "Ucode"

    ihlist = hl_gtk_listn_new(ihscrollcontain, types=ctypes, &
         & changed=c_funloc(list_select),&
         & multiple=TRUE, height=250_c_int, swidth=600_c_int, titles=titles, &
         & sortable=sortable, editable=editable, &
         & edited=c_funloc(cell_edited))

    call hl_gtk_listn_set_cell_data_func(ihlist, fmt_col, &
         & func=c_funloc(display_int), &
         & data=c_loc(fmt_col))

    ! Now put 10 rows into it
    do i=1,10
       call hl_gtk_listn_ins(ihlist)
       write(line,"('List entry number ',I0)") i
       ltr=len_trim(line)+1
       line(ltr:ltr)=c_null_char
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 0_c_int, svalue=line)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 1_c_int, ivalue=i)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 2_c_int, ivalue=3_c_int*i)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 3_c_int, &
            & fvalue=log10(real(i)))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 4_c_int, &
            & l64value=int(i,c_int64_t)**4)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 5_c_int, &
            & ivalue=mod(i,2_c_int))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 6_c_int, svalue=codes(i))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 7_c_int, svalue=codes(i))
    end do

    ! A silly idea to test a hunch
    print *, codes
    codes = char(ichar(codes)-2)
    print *, codes

    ! It is the scrollcontainer that is placed into the box.
    call hl_gtk_box_pack(base, ihscrollcontain)

    ! Add a note about editable columns
    lbl = gtk_label_new("The ""Name"" and ""N"" columns are editable"//c_null_char)
    call hl_gtk_box_pack(base, lbl)

    ! Also a quit button
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base,qbut)

    ! realize the window
    print *, "Created"
    call gtk_widget_show(ihwin)
    print *, "Realized"
    end subroutine activate
end module ln_handlers


program list_n
  ! LIST_N
  ! Demo of multi column list
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use ln_handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_list_n"//c_null_char, &
                             & c_funloc(activate))
end program list_n

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Example using GtkBuilder
! Jens Hunger, 04-01-2011
! Last modified: vmagnin 2020-06-20 (GTK 4 version), 2024-05-08

module widgets
  use, intrinsic :: iso_c_binding

  implicit none
  ! Declares the used GTK widgets:
  type(c_ptr) :: window, builder
  ! A GTK/GLib main loop:
  type(c_ptr) :: my_gmainloop
end module


module handlers
  use, intrinsic :: iso_c_binding
  use g, only: g_main_loop_quit
  use widgets, only: my_gmainloop

  implicit none

contains
  !*************************************
  ! User defined event handlers go here
  !*************************************

  ! "destroy" is a GtkObject signal
  subroutine destroy(widget, gdata) bind(c)
    !GCC$ ATTRIBUTES DLLEXPORT :: destroy
    type(c_ptr), value, intent(in) :: widget, gdata

    print *, "My destroy!"
    call g_main_loop_quit(my_gmainloop)
  end subroutine destroy

  ! "clicked" is a GtkButton signal
  subroutine hello(widget, gdata) bind(c)
    !GCC$ ATTRIBUTES DLLEXPORT :: hello
    type(c_ptr), value, intent(in) :: widget, gdata

    print *, "Hello World!"
  end subroutine hello

  subroutine button2clicked(widget, gdata) bind(c)
    !GCC$ ATTRIBUTES DLLEXPORT :: button2clicked
    type(c_ptr), value, intent(in) :: widget, gdata

    print *, "Button 2 clicked!"
  end subroutine button2clicked
end module handlers


program gtkbuilder
  use gtk, only: gtk_init, gtk_builder_new_from_file, gtk_builder_get_object, gtk_widget_show, FALSE
  use g, only: g_object_unref, g_main_loop_new, g_main_loop_run
  use widgets

  implicit none

  ! Initialize the GTK Library:
  call gtk_init()

  ! Create a new GtkBuilder object, parse the file 'gtkbuilder.ui'
  ! (generated with Cambalache) and add its content:
  builder = gtk_builder_new_from_file("gtkbuilder.ui"//c_null_char)

  ! Get a pointer to the GObject "window" from GtkBuilder:
  window = gtk_builder_get_object(builder, "window"//c_null_char)

  ! Free all memory used by XML stuff:
  call g_object_unref(builder)

  ! Show the Application Window:
  call gtk_widget_show(window)

  ! Create and enter the GTK/GLib main loop:
  my_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
  call g_main_loop_run(my_gmainloop)

end program gtkbuilder

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2021 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! The gtk-?-fortran command prints information about gtk-fortran.
! Contributors: Vincent Magnin 2021-01-29
! Last modifications: 2023-02-02
!------------------------------------------------------------------------------

module handlers_gtk_fortran
  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only: compiler_version
  use gtk, only: gtk_get_major_version, gtk_get_minor_version, &
               & gtk_get_micro_version
  use gtk_sup, only: c_f_string_copy_alloc
  use g, only: g_get_prgname, g_get_os_info

  implicit none

  contains

  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    character(:), allocatable :: name_string, os_string
    integer :: suffix_pos
    type(c_ptr) :: ret

    call c_f_string_copy_alloc(g_get_prgname(), name_string)
    ! Removing the .exe suffix if the OS is Windows:
    suffix_pos = index(name_string, ".exe")
    if (suffix_pos /= 0) name_string = name_string(1:suffix_pos-1)

    ! That function may return NULL with some OS:
    ret = g_get_os_info("PRETTY_NAME"//c_null_char)
    if (c_associated(ret)) then
      call c_f_string_copy_alloc(ret, os_string)
    else
      os_string = "?"
    end if

    print '(2A)', name_string, " (GTK @GTK_SEMANTIC_VERSION@ and GLib @GLIB_SEMANTIC_VERSION@)"
    print '(3A,I0,A1,I0,A1,I0)', "Compiled with "//compiler_version()//" on ", os_string, &
      & ", linked to GTK ", gtk_get_major_version(),".", gtk_get_minor_version(), ".", gtk_get_micro_version()

    print *
    print '(A)', "Licensed under GNU GPLv3 or later with the GCC Runtime Library &
                 &Exception version 3.1"
    print '(A)', "This is free software: you are free to change and redistribute it."
    print '(A)', "There is NO WARRANTY, to the extent permitted by law."
    print *
    print '(A)', "Usage example:"
    print '(3A)', "gfortran my_app.f90 $(pkg-config --cflags --libs ", TRIM(name_string), ")"
    print *
    print '(A)', "Documentation: https://github.com/vmagnin/gtk-fortran/wiki"
    print '(A)', "Bug reports:   https://github.com/vmagnin/gtk-fortran/issues"
  end subroutine activate
end module handlers_gtk_fortran


program gtk_fortran
  use gtk, only: gtk_application_new, g_signal_connect, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers_gtk_fortran

  implicit none
  integer(c_int)     :: status
  type(c_ptr)        :: app

  app = gtk_application_new("gtk-fortran.command"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  status = g_application_run(app, 0_c_int, [c_null_ptr])
  if (status /= 0) print '(A, I0)', ">>> GApplication error: ", status

  call g_object_unref(app)
end program gtk_fortran

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! PLplot code derived from PLplot's example 8 by Alan W. Irwin
! Last modifications: vmagnin 2020-06-24 (GTK 4), 2020-12-20
!------------------------------------------------------------------------------

module common_ex8
  use, intrinsic :: iso_c_binding
  ! Gtk includes
  use gtk, only: gtk_application_window_new, &
       & gtk_label_new, gtk_window_set_child, &
       & gtk_check_button_get_active, gtk_window_destroy, &
       & gtk_widget_get_allocation, gtk_widget_queue_draw, &
       & gtk_widget_show, FALSE, g_signal_connect_swapped

  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_spin_slider
  use gtk_hl_chooser
  use gtk_draw_hl
  use gdk_pixbuf_hl
  use plplot_extra

  implicit none
  type(c_ptr) :: window, draw, alt_sl, az_sl, fun_but, col_but, &
       & facet_but, scont_but, bcont_but, qbut
  integer(c_int) :: disp_type=0, ifun=1
  real(c_double) :: alt=30._c_double, az=60._c_double
  integer(c_int) :: width, height
  type(c_ptr) :: my_app
end module common_ex8


module plplot_code_ex8
  use plplot, PI => PL_PI
  use common_ex8

  implicit none

contains
  subroutine draw_08(area, type, alt, az, rosen)
    type(c_ptr), intent(in) :: area
    integer, intent(in) :: type, rosen
    real(plflt), intent(in) :: alt, az
    integer i, j, xpts, ypts, xdim, ydim
    !      xdim is the leading dimension of z, xpts <= xdim is the leading
    !      dimension of z that is defined.
    parameter (xdim=99, ydim=100, xpts=35, ypts=46)
    real(plflt) x(xdim), y(ydim), z(xdim,ypts), xx, yy, r

    character(len=80) :: title
    character(len=20) :: geometry
    type(c_ptr) :: cc

    ! needed for use as functions instead of subroutines
    integer :: plparseopts_rc
    integer :: plsetopt_rc

    integer nlevel
    parameter (nlevel = 10)
    real(plflt) zmin, zmax, step, clevel(nlevel)
    ! Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if (plparseopts_rc /= 0) stop "plparseopts error"

    write(title, "('#frPLplot Example 8 - Alt=',I3,', Az=',I3)")&
         & nint(alt), nint(az)

    do i = 1,xpts
       x(i) = dble(i-1-(xpts/2))/dble (xpts/2)
       if (rosen == 1) x(i) = 1.5_plflt*x(i)
    enddo
    do j = 1,ypts
       y(j) = dble(j-1-(ypts/2))/dble (ypts/2)
       if (rosen == 1) y(j) = y(j) + 0.5_plflt
    enddo

    do i=1,xpts
       xx = x(i)
       do j=1,ypts
          yy = y(j)
          if (rosen == 1) then
             z(i,j) = (1._plflt - xx)**2 + 100._plflt*(yy - xx**2)**2
             !            The log argument may be zero for just the right grid.
             if (z(i,j) > 0._plflt) then
                z(i,j) = log(z(i,j))
             else
                z(i,j) = -5._plflt
             endif
          else
             !            sombrero function
             r = sqrt(xx*xx + yy*yy)
             z(i,j) = exp(-r*r) * cos(2.0_plflt*PI*r)
          endif
       enddo
    enddo
    call a2mnmx(z, xpts, ypts, zmin, zmax, xdim)
    step = (zmax-zmin)/(nlevel+1)
    do i = 1, nlevel
       clevel(i) = zmin + step*i
    enddo

    ! Get a cairo context from the drawing area.
    cc = hl_gtk_drawing_area_cairo_new(area)

    !  Initialize plplot
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    write(geometry, "(I0,'x',I0)") width, height
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

    call plinit

    ! Tell the "extcairo" driver where the context is located.
    call pl_cmd(PLESC_DEVINIT, cc)

    call pllightsource(1._plflt, 1._plflt, 1._plflt)

    call pladv(0)
    call plclear()
    call plvpor(0.0_plflt, 1.0_plflt, 0.0_plflt, 0.9_plflt )
    call plwind(-1.0_plflt, 1.0_plflt, -0.9_plflt, 1.1_plflt )
    call plcol0(3)
    call plmtex('t', 1.0_plflt, 0.5_plflt, 0.5_plflt, title)
    call plcol0(1)
    if (rosen == 1) then
       call plw3d(1.0_plflt, 1.0_plflt, 1.0_plflt, -1.5_plflt, &
            1.5_plflt, -0.5_plflt, 1.5_plflt, zmin, zmax, alt,az)
    else
       call plw3d(1.0_plflt, 1.0_plflt, 1.0_plflt, -1.0_plflt, &
            1.0_plflt, -1.0_plflt, 1.0_plflt, zmin, zmax, alt,az)
    endif
    call plbox3('bnstu','x axis', 0.0_plflt, 0, &
         'bnstu', 'y axis', 0.0_plflt, 0, &
         'bcdmnstuv','z axis', 0.0_plflt, 0)
    call plcol0(2)

    if (type == 0) then
       call cmap1_init(1)
    else
       call cmap1_init(0)
    end if

    if (iand(type, ior(ior(BASE_CONT, SURF_CONT), TOP_CONT)) /= 0) then
       call plsurf3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
            type, clevel)
    else
       call plsurf3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
            type, clevel(nlevel:1))
    end if
    call plend

    call gtk_widget_queue_draw(area)
    call hl_gtk_drawing_area_cairo_destroy(cc)

  end subroutine draw_08

  !----------------------------------------------------------------------------
  subroutine cmap1_init(gray)
    !      For gray == 1, basic grayscale variation from half-dark
    !      to light.  Otherwise, hue variations around the front of the
    !      colour wheel from blue to green to red with constant lightness
    !      and saturation.

    use plplot
    implicit none
    integer gray
    real(plflt) i(0:1), h(0:1), l(0:1), s(0:1)
    !      left boundary
    i(0) = 0._plflt
    !      right boundary
    i(1) = 1._plflt
    if (gray == 1) then
       !        hue -- low: red (arbitrary if s=0)
       h(0) = 0.0_plflt
       !        hue -- high: red (arbitrary if s=0)
       h(1) = 0.0_plflt
       !        lightness -- low: half-dark
       l(0) = 0.5_plflt
       !        lightness -- high: light
       l(1) = 1.0_plflt
       !        minimum saturation
       s(0) = 0.0_plflt
       !        minimum saturation
       s(1) = 0.0_plflt
    else
       !        This combination of hues ranges from blue to cyan to green to yellow
       !        to red (front of colour wheel) with constant lightness = 0.6
       !        and saturation = 0.8.

       !        hue -- low: blue
       h(0) = 240._plflt
       !        hue -- high: red
       h(1) = 0.0_plflt
       !        lightness -- low:
       l(0) = 0.6_plflt
       !        lightness -- high:
       l(1) = 0.6_plflt
       !        saturation
       s(0) = 0.8_plflt
       !        minimum saturation
       s(1) = 0.8_plflt
    endif
    call plscmap1n(256)
    call plscmap1l(.false., i, h, l, s)
  end subroutine cmap1_init

  !----------------------------------------------------------------------------
  !      Subroutine a2mnmx
  !      Minimum and the maximum elements of a 2-d array.

  subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)
    use plplot
    implicit none

    integer   i, j, nx, ny, xdim
    real(plflt)    f(xdim, ny), fmin, fmax

    fmax = f(1, 1)
    fmin = fmax
    do j = 1, ny
       do  i = 1, nx
          fmax = max(fmax, f(i, j))
          fmin = min(fmin, f(i, j))
       enddo
    enddo
  end subroutine a2mnmx
end module plplot_code_ex8


module handlers_ex8
  use plplot_code_ex8
  implicit none

contains

  ! Callback function for quitting the application:
  subroutine my_destroy (window, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value, intent(in) :: window, gdata

    print *, "my_destroy()"
    call gtk_window_destroy(window)
  end subroutine my_destroy

  subroutine set_azimuth(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    az = real(hl_gtk_slider_get_value(widget), c_double)
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_azimuth

  subroutine set_altitude(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    alt = real(hl_gtk_slider_get_value(widget), c_double)
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_altitude

  subroutine set_rosen(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    ifun = gtk_check_button_get_active(widget)
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_rosen

  subroutine set_colour(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_check_button_get_active(widget) == 1) then
       disp_type = ior(disp_type, MAG_COLOR)
    else
       disp_type = iand(disp_type, not(MAG_COLOR))
    end if
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_colour

  subroutine set_facet(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_check_button_get_active(widget) == 1) then
       disp_type = ior(disp_type, FACETED)
    else
       disp_type = iand(disp_type, not(FACETED))
    end if
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_facet

  subroutine set_scont(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_check_button_get_active(widget) == 1) then
       disp_type = ior(disp_type, SURF_CONT)
    else
       disp_type = iand(disp_type, not(SURF_CONT))
    end if
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_scont

  subroutine set_bcont(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_check_button_get_active(widget) == 1) then
       disp_type = ior(disp_type, BASE_CONT)
    else
       disp_type = iand(disp_type, not(BASE_CONT))
    end if
    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine set_bcont

  subroutine resize_area(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    type(gtkallocation), target:: alloc

    call gtk_widget_get_allocation(draw,c_loc(alloc))
    call hl_gtk_drawing_area_resize(draw)
    print *, "resize", alloc%width, alloc%height
    width=alloc%width
    height=alloc%height

    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine resize_area

  subroutine dump_screen(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    type(c_ptr) :: pixb
    character(len=120), dimension(:), allocatable :: files
    character(len=120) :: the_file
    integer(c_int) :: ipick

     ipick = hl_gtk_file_chooser_show(files, create=TRUE, current=TRUE, &
         & title="Output image file"//c_null_char, &
         & filter=['image/png ', 'image/jpeg', 'image/tiff'], &
         & parent=window)

    if (c_f_logical(ipick)) then
       the_file = files(1)
       print *, "File: ", the_file
       pixb = hl_gtk_drawing_area_get_gdk_pixbuf(draw)
       call hl_gdk_pixbuf_save(pixb, file=the_file)
    end if
  end subroutine dump_screen


  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: base, btable, junk

    ! Create the window:
    window = gtk_application_window_new(app)

    height = 600
    width = 600  ! Must be a multiple of 4

    base = hl_gtk_box_new()
    call gtk_window_set_child(window, base)

    ! The drawing area for the plot
    draw = hl_gtk_drawing_area_new(size=[width, height], &
         & has_alpha = FALSE, size_allocate=c_funloc(resize_area))
    call hl_gtk_box_pack(base, draw)

    ! Put the direction settings in a table.
    btable=hl_gtk_table_new(2,2, homogeneous=FALSE)
    call hl_gtk_box_pack(base, btable, expand=FALSE)

    junk=gtk_label_new("Azimuth:"//c_null_char)
    call hl_gtk_table_attach(btable, junk, 0, 0, xopts=0, yopts=0)
    az_sl = hl_gtk_slider_new(0, 360, initial_value=int(az), &
         & value_changed=c_funloc(set_azimuth))
    call hl_gtk_table_attach(btable, az_sl, 1, 0, yopts=0)

    ! N.B. Elevation <0 doesn't seem to work.
    junk=gtk_label_new("Elevation:"//c_null_char)
    call hl_gtk_table_attach(btable, junk, 0, 1, xopts=0, yopts=0)
    alt_sl = hl_gtk_slider_new(0, 90, initial_value=int(alt), &
         & value_changed=c_funloc(set_altitude))
    call hl_gtk_table_attach(btable, alt_sl, 1, 1, yopts=0)

    ! And another table for the selectors
    btable=hl_gtk_table_new(homogeneous=TRUE)
    call hl_gtk_box_pack(base, btable, expand=FALSE)

    fun_but = hl_gtk_check_button_new("Rosen"//c_null_char, &
         & toggled=c_funloc(set_rosen), initial_state=ifun)
    call hl_gtk_table_attach(btable, fun_but, 0, 0, yopts=0, xopts=0)

    col_but=hl_gtk_check_button_new("Colour level"//c_null_char, &
         & toggled=c_funloc(set_colour))
    call hl_gtk_table_attach(btable,col_but, 1, 0, yopts=0, xopts=0)

    facet_but=hl_gtk_check_button_new("Facets"//c_null_char, &
         & toggled=c_funloc(set_facet))
    call hl_gtk_table_attach(btable,facet_but, 2, 0, yopts=0, xopts=0)

    scont_but=hl_gtk_check_button_new("Surface contours"//c_null_char, &
         & toggled=c_funloc(set_scont))
    call hl_gtk_table_attach(btable, scont_but, 0, 1, yopts=0, xopts=0)

    bcont_but=hl_gtk_check_button_new("Base contours"//c_null_char, &
         & toggled=c_funloc(set_bcont))
    call hl_gtk_table_attach(btable, bcont_but, 1, 1, yopts=0, xopts=0)

    junk = hl_gtk_button_new("Dump"//c_new_line//"Screen"//c_null_char, &
         & clicked=c_funloc(dump_screen))
    call hl_gtk_table_attach(btable, junk, 3, 0, yopts=0, &
         & xopts=0, yspan=2)

    qbut=hl_gtk_button_new("Quit"//c_null_char)
    call g_signal_connect_swapped(qbut, "clicked"//c_null_char, &
                                & c_funloc(my_destroy), window)

    call hl_gtk_box_pack(base, qbut, expand=FALSE)

    call gtk_widget_show(window)

    call draw_08(draw, disp_type, alt, az, ifun)
  end subroutine activate
end module handlers_ex8


program cairo_plplot_ex8
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
  use handlers_ex8
  implicit none

  my_app = hl_gtk_application_new("gtk-fortran.plplot.hl_plplot8e"//c_null_char, &
                             & c_funloc(activate))
end program cairo_plplot_ex8

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2020 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------
! Vincent MAGNIN, 2020-05-12, based on gtkzero_gapp.f90
! Last modified: 2021-01-22
! A GTK application with two buttons.
! https://developer.gnome.org/gtk4/unstable/gtk-getting-started.html
! https://developer.gnome.org/gio/stable/GApplication.html
!-------------------------------------------------------------------------------

!*************************************
! User defined event handlers go here
!*************************************
! Note that events are a special type of signals, coming from
! the X Window system. Callback functions must have an event argument.
module handlers

  use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_funloc, c_null_char
  use gtk, only: FALSE, gtk_window_set_default_size,  &
               & gtk_window_set_title, gtk_window_destroy, &
               & g_signal_connect, g_signal_connect_swapped, &
               & gtk_widget_show, gtk_application_window_new, &
               & gtk_box_new, gtk_box_append, gtk_window_set_child, &
               & GTK_ORIENTATION_VERTICAL, GTK_ORIENTATION_HORIZONTAL, &
               & gtk_button_new_with_label, gtk_button_new_with_mnemonic, &
               & gtk_widget_set_margin_start, gtk_widget_set_margin_end, &
               & gtk_widget_set_margin_top, gtk_widget_set_margin_bottom
  implicit none

contains
  ! Callback function for the signal "activate" emitted by g_application_run().
  ! We use a subroutine because it should return void.
  ! The GUI is defined here.
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: window
    type(c_ptr) :: box
    type(c_ptr) :: button1, button2

    ! Create the window:
    window = gtk_application_window_new(app)
    ! Not compulsory, but can be used if you want a larger window:
    !call gtk_window_set_default_size(window, 300, 200)
    ! Don't forget that C strings must end with a null char:
    call gtk_window_set_title(window, "Hello GLib & GTK world!"//c_null_char)

    !******************************************************************
    ! Adding widgets in the window:
    !******************************************************************
    ! You need a box where to arrange your buttons, separated by 10 pixels:
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 10_c_int)
    ! Perhaps you prefer a vertical organization:
    !box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 10_c_int)
    ! Set the border width (10 pixels) around the box:
    call gtk_widget_set_margin_start (box, 10_c_int)
    call gtk_widget_set_margin_end (box, 10_c_int)
    call gtk_widget_set_margin_top (box, 10_c_int)
    call gtk_widget_set_margin_bottom (box, 10_c_int)
    ! You need a container where to put the box, it will manage layout:
    call gtk_window_set_child(window, box)

    ! It's easy to create a button:
    button1 = gtk_button_new_with_label("I say hello"//c_null_char)
    ! Let's pack the button in the box:
    call gtk_box_append(box, button1)
    ! You can associate one or several callback functions with the button,
    ! "clicked" is a GtkButton signal emitted when you click on it:
    call g_signal_connect(button1, "clicked"//c_null_char, &
                        & c_funloc(button1clicked))
    call g_signal_connect(button1, "clicked"//c_null_char, c_funloc(hello))

    ! For that second button, there is an ALT+g keyboard shortcut:
    button2 = gtk_button_new_with_mnemonic("I don't know why you say _goodbye"&
                                          &//c_null_char)
    ! Let's pack the second button in the box (from left to right):
    call gtk_box_append(box, button2)
    ! Let's associate one callback function when that button is clicked.
    ! Here the gtk_window_destroy() function will be applied
    ! to window instead of button2:
    call g_signal_connect_swapped(button2, "clicked"//c_null_char, &
                                & c_funloc(gtk_window_destroy), window)
    !******************************************************************

    ! If you don't show it, nothing will appear on screen...
    call gtk_widget_show(window)

  end subroutine activate

  ! The two callback functions for the button1, here subroutines
  ! because the C prototype returns void:
  ! void user_function (GtkButton *button, gpointer   user_data)
  ! https://developer.gnome.org/gtk4/stable/GtkButton.html#GtkButton-clicked
  subroutine hello(widget, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: widget, gdata

    print *, "So I say Hello GTK World!"
  end subroutine hello

  subroutine button1clicked(widget, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: widget, gdata

    print *, "Button 1 clicked!"
  end subroutine button1clicked

end module handlers

!*******************************************************************************
! In the main program, we declare the GTK application, connect it to its
! "activate" function where we will create the GUI,
! and finally call the GLib main loop.
!*******************************************************************************
program gtkhello

  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
  ! We will use those GTK functions and values. The "only" statement can improve
  ! significantly the compilation time:
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers

  implicit none
  integer(c_int)     :: status
  type(c_ptr)        :: app

  ! First, let's create a GTK application (it will initialize GTK).
  ! The application ID must contain at least one point:
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-id-is-valid
  app = gtk_application_new("gtk-fortran.examples.gtkhello"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  ! The activate signal will be sent by g_application_run().
  ! The c_funloc() function returns the C address of the callback function.
  ! The c_null_ptr means no data is transfered to the callback function.
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  ! Now, the whole application will be managed by GLib (=> main loop).
  ! Note that commandline arguments argc, argv are not passed.
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-run
  status = g_application_run(app, 0_c_int, [c_null_ptr])

  print *, "You have exited the GLib main loop, bye, bye..."

  ! Memory is freed:
  call g_object_unref(app)

end program gtkhello

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public
! License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin, Ian Harvey (IanH0073)
! Last modifications: vmagnin+IanH0073 2019-02-21, vmagnin 2020-06-08 (GTK 4),
!   jtappin 2023-09-22, florianober 2025-03-27
!------------------------------------------------------------------------------
!*
! Supplementary material
!
! This module contains some supplementary material useful for writing GTK
! programs in Fortran.  The functions are not listed in the
! gtk-fortran-index.csv file, either because they are not (currenty) extracted
! by the automatic tools, or because they are just convenient functions
! added here.
module gtk_sup
  ! Currently it contains:
  !
  ! * GTYPE: Definitions of the integer length and the values for each type.
  ! * GtkTreeIter: Type definition, and its clear procedure.
  ! * GValue: Pseudo type definition, and its clear procedure.
  ! * GtkTextIter: Type definition.
  ! * GError: Type definition.
  ! * Interfaces for string conversions.
  ! * Boolean conversion routines.
  ! * Miscellaneous functions.
  !
  !/

  use, intrinsic :: iso_c_binding
  use gtk, only: TRUE, FALSE
  use g, only: g_type_fundamental

  implicit none

  public :: clear_gtktreeiter, clear_gvalue, c_f_string_chars, c_f_string_ptr,&
          & c_f_string_copy_alloc, c_f_string_copy, &
          & convert_c_string_scalar, convert_c_string_array, &
          & convert_c_string_scalar_cptr, convert_c_string_array_cptr, &
          & convert_f_string_a, convert_f_string_s, &
          & c_f_logical, f_c_logical4, &
          & f_c_logical1, is_UNIX_OS, fdate, copy_file

  !============================================================================
  !+
  ! Gtype
  ! The various Gtype definitions from the gtype.h file.
  !-

  ! Gtype definitions
  integer, parameter :: type_kind = c_size_t
  integer(c_int), parameter :: g_type_fundamental_shift=2
  integer(type_kind), parameter :: G_TYPE_INVALID = &
       & ishft(0_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_NONE = &
       & ishft(1_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_INTERFACE = &
       & ishft(2_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_CHAR = &
       & ishft(3_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_UCHAR = &
       & ishft(4_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_BOOLEAN = &
       & ishft(5_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_INT = &
       & ishft(6_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_UINT = &
       & ishft(7_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_LONG = &
       & ishft(8_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_ULONG = &
       & ishft(9_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_INT64 = &
       & ishft(10_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_UINT64 = &
       & ishft(11_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_ENUM = &
       & ishft(12_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_FLAGS = &
       & ishft(13_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_FLOAT = &
       & ishft(14_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_DOUBLE = &
       & ishft(15_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_STRING = &
       & ishft(16_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_POINTER = &
       & ishft(17_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_BOXED = &
       & ishft(18_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_PARAM = &
       & ishft(19_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_OBJECT = &
       & ishft(20_type_kind, g_type_fundamental_shift)
  integer(type_kind), parameter :: G_TYPE_VARIANT = &
       & ishft(21_type_kind, g_type_fundamental_shift)

  !============================================================================
  !+
  ! Iterators and Gvalues
  ! These structures are always allocated in the calling program, rather
  ! than being declared as pointers and leaving GTK to allocate them.
  !
  ! * GtkTreeIter, Iterator for TreeView widgets
  ! * GtkTextIter, Iterator for TextView widgets
  ! * GValue, A value container.
  !-

  ! Define a GtkTreeIter (this has to be pre-allocated in the calls)
  type, bind(c) :: gtktreeiter
     integer(c_int) :: intv = 0
     type(c_ptr) :: p0 = C_NULL_PTR, p1 = C_NULL_PTR, p2 = C_NULL_PTR
  end type gtktreeiter

  !+
  ! Define a spacemaker for GValue. It's 24 bytes on 64 bit, thus
  ! three 64-bit integers. On 32 bits, it uses only 20 bytes over the 24.
  ! A GValue is an opaque structure:
  ! https://docs.gtk.org/gobject/struct.Value.html
  !-
  type, bind(c) :: gvalue
      integer(kind=c_int64_t), dimension(3) :: i64 = [0, 0, 0]
  end type gvalue

  ! Define a GtkTextIter (this has to be pre-allocated in the calls)
  type, bind(c) :: gtktextiter
     type(c_ptr)    :: d1, d2
     integer(c_int) :: d3, d4, d5, d6, d7, d8
     type(c_ptr)    :: d9, d10
     integer(c_int) :: d11, d12, d13
     type(c_ptr)    :: d14
  end type gtktextiter

  !+
  ! GError
  ! GError is a transparent structure that returns error information.
  !-
  type, bind(c) :: gerror
     integer(c_int32_t) :: domain
     integer(c_int) :: code
     type(c_ptr) :: message    ! A C pointer to the error message.
  end type gerror

  !============================================================================
  ! Interfaces for conversions
  ! Some are available with two names:
  ! convert_c_string = c_f_string
  ! convert_f_string = f_c_string
  !============================================================================
  interface c_f_string
     module procedure convert_c_string_scalar
     module procedure convert_c_string_array
     module procedure convert_c_string_scalar_cptr
     module procedure convert_c_string_array_cptr
  end interface c_f_string

  interface convert_c_string
     module procedure convert_c_string_scalar
     module procedure convert_c_string_array
     module procedure convert_c_string_scalar_cptr
     module procedure convert_c_string_array_cptr
  end interface convert_c_string

  interface f_c_string
     module procedure convert_f_string_a
     module procedure convert_f_string_aa
     module procedure convert_f_string_s
  end interface f_c_string

  interface convert_f_string
     module procedure convert_f_string_a
     module procedure convert_f_string_aa
     module procedure convert_f_string_s
  end interface convert_f_string

  ! Interfaces for logical conversion
  interface f_c_logical
     module procedure f_c_logical4
     module procedure f_c_logical1
  end interface f_c_logical

  ! String conversion routines below lazily use the C standard library function
  ! strlen(). If this is not available for some bizarre reason, then a
  ! simple index of the null character will suffice.
  ! Contributed by Ian Harvey, 2014.
  interface
    function strlen(str) bind(c, name='strlen')
      import :: c_size_t, c_ptr
      implicit none
      type(c_ptr), intent(in), value :: str
      integer(c_size_t) :: strlen
    end function strlen
  end interface

contains
  !============================================================================
  ! These 2 clear_ routines are only needed of you need to re-initialize
  ! the types. The definitions include the initial setting to zero or NULL.
  !============================================================================

  !+
  subroutine clear_gtktreeiter(iter)
    type(gtktreeiter), intent(inout) :: iter

    ! Clear a tree iterator
    !
    ! ITER |  gtktreeiter |  required |  The iterator to clear
    !-

    iter%intv = 0
    iter%p0   = C_NULL_PTR
    iter%p1   = C_NULL_PTR
    iter%p2   = C_NULL_PTR
  end subroutine clear_gtktreeiter

  !+
  subroutine clear_gvalue(gval)
    type(gvalue), intent(inout) :: gval

    ! Clear a GValue
    !
    ! GVAL |  gvalue |  required |  The GValue to clear.
    !-
    gval%i64 = [0, 0, 0]
  end subroutine clear_gvalue

  !============================================================================
  ! Some string conversion routines
  !============================================================================
  !+
  subroutine c_f_string_copy_alloc(the_ptr, f_string)
    type(c_ptr), intent(in) :: the_ptr
    character(:), intent(out), allocatable :: f_string
    character(kind=c_char), pointer :: f_array(:)
    integer :: i

    ! Create a default character deferred length allocatable copy of the
    ! value of a C string. This function should be preferred to
    ! c_f_string_copy() when using a Fortran>=2008 compiler. An advantage is
    ! that the trim() function will generally not be needed.
    !
    ! THE_PTR |  string |  required |   The C string to be converted.
    ! F_STRING |  f_string |  required |  A Scalar Fortran string.
    !
    !-
    ! Contributed by Ian Harvey, 2014

    call c_f_pointer(the_ptr, f_array, [strlen(the_ptr)])
    allocate(character(size(f_array)) :: f_string)

    do concurrent (i = 1:size(f_array))
      f_string(i:i) = f_array(i)
    end do
  end subroutine c_f_string_copy_alloc

  !+
  subroutine c_f_string_copy(the_ptr, f_string, status)
    type(c_ptr), intent(in) :: the_ptr
    character(*), intent(out) :: f_string
    integer, intent(out), optional :: status
    character(kind=c_char), pointer :: f_array(:)
    integer :: i

    ! Create a default character fixed length copy of the value of a C string.
    !
    ! THE_PTR |  string |  required |   The C string to be converted.
    ! F_STRING |  f_string |  required |  A Scalar Fortran string.
    ! STATUS |  integer |  optional |  Is set to -1 if the Fortran string is too short.
    !
    ! If the Fortran string is too short, the C string is truncated.
    !-

    call c_f_pointer(the_ptr, f_array, [strlen(the_ptr)])

    do i = 1, size(f_array)
      if (i > len(f_string)) then
        if (present(status)) status = -1
        return
      end if

      f_string(i:i) = f_array(i)
    end do

    ! i here is size(f_array) + 1. Define the remainder of f_string:
    f_string(i:) = ''

    if (present(status)) status = 0
  end subroutine c_f_string_copy

  !+
  subroutine c_f_string_chars(c_string, f_string)
    character(len=1, kind=C_char), intent(in) :: c_string(*)
    character(len=*), intent(out) :: f_string
    integer :: i

    ! Copy a C string, passed as a char-array reference, to a Fortran string.
    ! String routine from C_interface_module by Joseph M. Krahn:
    ! http://fortranwiki.org/fortran/show/c_interface_module
    !
    ! C_STRING |  chars array |  required |   The C chars array to be converted.
    ! F_STRING |  f_string |  required |  A Scalar Fortran string.
    !
    !-

    i = 1
    do while (c_string(i) /= c_null_char .and. i <= len(f_string))
      f_string(i:i) = c_string(i)
      i = i + 1
    end do

    if (i < len(f_string)) f_string(i:) = ' '
  end subroutine c_f_string_chars

  !+
  subroutine c_f_string_ptr(c_string, f_string)
    type(C_ptr), intent(in) :: c_string
    character(len=*), intent(out) :: f_string
    character(len=1, kind=C_char), dimension(:), pointer :: p_chars
    integer :: i

    ! Copy a C string, passed by pointer, to a Fortran string.
    ! If the C pointer is NULL, the Fortran string is blanked.
    ! c_string must be NUL terminated, or at least as long as f_string.
    ! If c_string is longer, it is truncated. Otherwise, f_string is
    ! blank-padded at the end.
    !
    ! C_STRING |  string |  required |   The C string to be converted.
    ! F_STRING |  f_string |  required |  A Scalar Fortran string.
    !
    !-

    if (.not. c_associated(c_string)) then
      f_string = ' '
    else
      call c_f_pointer(c_string, p_chars, [huge(0)])

      i = 1
      do while (p_chars(i) /= c_null_char .and. i <= len(f_string))
        f_string(i:i) = p_chars(i)
        i = i + 1
      end do

      if (i < len(f_string)) f_string(i:) = ' '
    end if
  end subroutine c_f_string_ptr

  !============================
  ! convert_c_string interface
  !============================
  !+
  subroutine convert_c_string_scalar(textptr, f_string, status)
    character(kind=c_char), dimension(:), intent(in) :: textptr
    character(len=*), intent(out) :: f_string
    integer(c_int), intent(out), optional :: status

    ! Convert a null-terminated C-string to a Fortran string
    !
    ! TEXTPTR |  string |  required |   The C string to be converted.
    ! F_STRING |  f_string |  required |  A Scalar Fortran string.
    ! STATUS |  integer |  optional |  Is set to -1 if the Fortran string is too short.
    !
    ! Usually called via the convert_c_string generic interface.
    !-
    ! Contributed by jtappin and Ian Harvey.

    integer :: i

    do i = 1, size(textptr)
      if (textptr(i) == c_null_char) exit
      if (i > len(f_string)) then
        if (present(status)) status = -1  ! Output string not long enough
        return
      end if
      f_string(i:i) = textptr(i)
    end do

    f_string(i:) = ''

    if (present(status)) status = 0
  end subroutine convert_c_string_scalar

  !+
  subroutine convert_c_string_array(textptr, f_string, status)
    character(kind=c_char), dimension(:), intent(in) :: textptr
    character(len=*), intent(out), dimension(:), allocatable :: f_string
    integer, intent(out), optional :: status

    ! Convert a null-terminated LF-separated C-string into a Fortran
    ! string array
    !
    ! TEXTPTR |  string |  required |   The C string to be converted.
    ! F_STRING |  f_string() |  required |  A Fortran string array.
    ! STATUS |  integer |  optional |  Is set to -1 if the Fortran string is too short for any line.
    !
    ! Usually called via the convert_c_string generic interface.
    !-

    integer :: i, j, ii, count

    count = 1
    i = 1
    do
       if (i > size(textptr)) exit
       if (textptr(i) == c_null_char) exit
       if (textptr(i) == c_new_line) count = count+1
       i = i + 1
    end do
    allocate(f_string(count))

    if (present(status)) status = 0
    ii = 1
    do j = 1, count
       f_string(j) = ""
       do i = 1, len(f_string)
          if (ii > size(textptr)) then
             if (j < count .and. present(status)) status = -1
             return
          end if

          if (textptr(ii) == c_null_char) return
          if (textptr(ii) == c_new_line) then
             ii = ii + 1
             exit
          end if
          f_string(j)(i:i) = textptr(ii)
          ii = ii + 1
       end do
       if (i > len(f_string) .and. present(status)) &
            & status = -1  ! Output string not long enough
    end do
  end subroutine convert_c_string_array

  !+
  subroutine convert_c_string_scalar_cptr(ctext, f_string, status)
    type(c_ptr), intent(in) :: ctext
    character(len=*), intent(out) :: f_string
    integer, intent(out), optional :: status

    ! Convert a null-terminated C-string to a Fortran string
    !
    ! CTEXT |  c_ptr |  required |   A C poiner to string to be converted.
    ! F_STRING |  f_string |  required |  A Scalar Fortran string.
    ! STATUS |  integer |  optional |  Is set to -1 if the Fortran string is too short.
    !
    ! Usually called via the convert_c_string generic interface.
    !-
    ! Contributed by jtappin and Ian Harvey.

    integer :: i
    character(kind=c_char), dimension(:), pointer :: textptr

    call c_f_pointer(ctext, textptr, [ strlen(ctext) ])

    do i = 1, size(textptr)
      if (i > len(f_string)) then
        if (present(status)) status = -1  ! Output string not long enough
        return
      end if
      f_string(i:i)=textptr(i)
    end do

    f_string(i:) = ''
    if (present(status)) status = 0
  end subroutine convert_c_string_scalar_cptr

  !+
  subroutine convert_c_string_array_cptr(ctext, f_string, status)
    type(c_ptr), intent(in) :: ctext
    character(len=*), intent(out), dimension(:), allocatable :: f_string
    integer, intent(out), optional :: status

    ! Convert a null-terminated LF-separated C-string into a Fortran
    ! string array
    !
    ! CTEXT |  c_ptr |  required |   A C poiner to string to be converted.
    ! F_STRING |  f_string() |  required |  A  Fortran string. array
    ! STATUS |  integer |  optional |  Is set to -1 if the Fortran string is too short for any of the lines.
    !
    ! Usually called via the convert_c_string generic interface.
    !-

    integer :: i, j, ii, count
    character(kind=c_char), dimension(:), pointer :: textptr

    call c_f_pointer(ctext, textptr, [ strlen(ctext) ])
    ! count = COUNT(textptr == c_new_line)
    count = 1
    i = 1
    do
       if (i > size(textptr)) exit
       if (textptr(i) == c_new_line) count = count + 1
       i = i + 1
    end do
    allocate(f_string(count))

    if (present(status)) status = 0

    ii = 1
    do j = 1, count
       f_string(j) = ""
       do i = 1, len(f_string)
          if (ii > size(textptr)) then
             return
          end if

          if (textptr(ii) == c_new_line) then
             ii = ii + 1
             exit
          end if
          f_string(j)(i:i) = textptr(ii)
          ii = ii + 1
       end do
       if (i > len(f_string) .and. present(status)) &
            & status = -1  ! Output string not long enough
    end do
  end subroutine convert_c_string_array_cptr

  !============================
  ! convert_f_string interface
  !============================
  !+
  subroutine convert_f_string_a(f_string, textptr, length)
    character(len=*), intent(in), dimension(:) :: f_string
    character(kind=c_char), dimension(:), intent(out), allocatable :: textptr
    integer(c_int), intent(out), optional :: length

    ! Convert a Fortran string array into a null-terminated, LF_separated
    ! C-string
    !
    ! F_STRING |  f_string |  required |  The Fortran string to convert
    ! TEXTPR |  string |  required |  A C type string, (allocatable).
    ! LENGTH |  c_int |  optional |  The length of the generated C string.
    !-

    integer :: lcstr, i, j, ii, nfstr
    integer, dimension(:), allocatable :: lfstr

    nfstr = size(f_string)
    allocate(lfstr(nfstr))
    lfstr = len_trim(f_string)

    lcstr = sum(lfstr)
    do i = 1, nfstr-1
       if (lfstr(i) == 0) then
          lcstr = lcstr + 1
       else if (f_string(i)(lfstr(i):lfstr(i)) /= c_null_char .and. &
            & f_string(i)(lfstr(i):lfstr(i)) /= c_new_line) then
          lcstr = lcstr + 1
       end if
    end do
    if (lfstr(nfstr) == 0) then
       lcstr = lcstr + 1
    else if (f_string(nfstr)(lfstr(nfstr):lfstr(nfstr)) /= c_null_char) then
       lcstr = lcstr + 1
    end if

    allocate(textptr(lcstr))
    if (present(length)) length = lcstr

    ii = 1
    do i = 1, nfstr
       do j = 1, lfstr(i)
          if (j == lfstr(i) .and. &
               & (f_string(i)(j:j) == c_null_char .or. &
               & (f_string(i)(j:j) == c_new_line .and. i /= nfstr))) exit
          textptr(ii) = f_string(i)(j:j)
          ii = ii + 1
       end do
       if (i < nfstr) then
          textptr(ii) = c_new_line
       else
          textptr(ii) = c_null_char
       end if
       ii = ii + 1
    end do
  end subroutine convert_f_string_a
  
  !+
  subroutine convert_f_string_aa(f_string, textptr, length)
    character(len=*), intent(in), dimension(:) :: f_string
    character(kind=c_char), dimension(:,:), intent(out), &
         & allocatable :: textptr
    integer(kind=c_int), intent(out), optional, &
         & dimension(:), allocatable :: length

    ! Convert a fortran string array into an array of null-terminated
    ! C strings. 
    !
    ! F_STRING: f_string: required: The fortran string to convert
    ! TEXTPR: string: required: A C type string, (allocatable) 2-D
    ! 	fortran array.
    ! LENGTH: c_int: optional: An allocatable integer array to return
    ! the lengths of the strings.	
    !-

    integer :: lcstr, i, j, nfstr
    integer, dimension(:), allocatable :: lfstr

    nfstr = size(f_string)
    allocate(lfstr(nfstr))
    lfstr = len_trim(f_string)
    lcstr = maxval(lfstr)+1    ! Add 1 for the NULL terminator on the
    ! longest element

    allocate(textptr(lcstr,nfstr))
    if (present(length)) then
       allocate(length(nfstr))
       length = lfstr
    end if

    do i = 1, nfstr
       do j = 1, lfstr(i)
          textptr(j,i) = f_string(i)(j:j)
       end do
       textptr(j,i) = c_null_char
    end do
  end subroutine convert_f_string_aa
  

  !+
  subroutine convert_f_string_s(f_string, textptr, length)
    character(len=*), intent(in) :: f_string
    character(kind=c_char), dimension(:), intent(out), allocatable :: textptr
    integer(c_int), intent(out), optional :: length

    ! Convert a Fortran string into a null-terminated C-string
    !
    ! F_STRING |  f_string |  required |  The Fortran string to convert
    ! TEXTPR |  string |  required |  A C type string, (allocatable).
    ! LENGTH |  c_int |  optional |  The length of the generated C string.
    !-

    integer :: lcstr, j
    logical :: add_null

    lcstr = len_trim(f_string)
    if (lcstr == 0) then
       lcstr = lcstr + 1
       add_null = .true.
    else if (f_string(lcstr:lcstr) /= c_null_char) then
       lcstr = lcstr + 1
       add_null = .true.
    else
       add_null = .false.
    end if

    allocate(textptr(lcstr))
    if (present(length)) length = lcstr

    do j = 1, len_trim(f_string)
       textptr(j) = f_string(j:j)
    end do

    if (add_null) textptr(lcstr) = c_null_char
  end subroutine convert_f_string_s

  !============================================================================
  ! Boolean conversion routines
  ! f_c_logical interface is available for logical(1) and logical(4)
  !============================================================================
  !+
  function c_f_logical(cbool)
    logical :: c_f_logical
    integer(c_int), intent(in) :: cbool

    ! Convert a gboolean to a Fortran logical
    !
    ! CBOOL |  boolean |  required |  The Gboolean to convert.
    !-

    if (cbool == FALSE) then
       c_f_logical = .false.
    else
       c_f_logical = .true.
    end if
  end function c_f_logical

  !+
  function f_c_logical4(flog)
    integer(c_int) :: f_c_logical4
    logical, intent(in) :: flog

    ! Convert a Fortran default logical to a gboolean
    !
    ! FLOG |  logical |  required |  The Fortran logical to convert.
    !
    ! Usually accessed via the generic f_c_logical interface
    !-

    if (flog) then
       f_c_logical4 = TRUE
    else
       f_c_logical4 = FALSE
    end if
  end function f_c_logical4

  !+
  function f_c_logical1(flog)
    integer(c_int) :: f_c_logical1
    logical(1), intent(in) :: flog

    ! Convert a Fortran 1-byte logical to a gboolean
    !
    ! FLOG |  logical*1 |  required |  The Fortran logical to convert.
    !
    ! Usually accessed via the generic f_c_logical interface
    !-

    if (flog) then
       f_c_logical1 = TRUE
    else
       f_c_logical1 = FALSE
    end if
  end function f_c_logical1

  !============================================================================
  ! Miscellaneous
  !============================================================================

  !+
  function is_UNIX_OS()
    use g, only: g_get_current_dir

    logical :: is_UNIX_OS
    character(:), allocatable :: path

    ! Returns .true. if the OS is of the UNIX type. On a Windows system, it
    ! will return .false. because an absolute path can not begin by a slash.
    !-

    call c_f_string_copy_alloc(g_get_current_dir(), path)

    if (path(1:1) == "/") then
        is_UNIX_OS = .true.
    else
        is_UNIX_OS = .false.
    endif
  end function is_UNIX_OS

  !+
  function fdate()
    character(29) :: fdate
    character(8)  :: date
    character(10) :: time
    character(5)  :: zone

    ! Returns date, time and timezone in a string without spaces,
    ! for example: 2022-05-06T15:58:43.790+02:00
    !-
    ! Contributed by IanH0073 (issue #81)

    call date_and_time(date, time, zone)
    fdate = date(1:4) // '-' // date(5:6) // '-' // date(7:8)  &
            // 'T' // time(1:2) // ':' // time(3:4) // ':' // time(5:10)  &
            // zone(1:3) // ':' // zone(4:5)
  end function fdate

  ! A function to copy a text file
  ! Used especially in sketcher/gtkf-sketcher.f90
  subroutine copy_file(source, destination)
    character(*), intent(in) :: source
    character(*), intent(in) :: destination
    character(len=256, kind=c_char) :: line
    integer :: status_read, input, output

    open(newunit=output, file=destination, action='write')
    open(newunit=input,  file=source, action='read')
    do
      read(input, '(A)', iostat=status_read) line
      if ( status_read /= 0 ) exit
      write(output, '(A)') line(1:len_trim(line))
    enddo
    close(input)
    close(output)
  end subroutine copy_file

end module gtk_sup

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! PLplot code derived from PLplot's example 17 by Alan W. Irwin
! Last modifications: vmagnin 2020-06-10 (GTK 4), 2022-06-09
!------------------------------------------------------------------------------

module common_ex17
  use gtk, only: gtk_button_new, gtk_drawing_area_new, &
       & gtk_widget_show, gtk_window_new, gtk_init, &
       & gtk_widget_queue_draw, gtk_window_set_child
  use g, only: g_usleep, g_main_context_iteration, g_main_context_pending

  use gtk_draw_hl
  use plplot_extra

  implicit none
  integer(c_int) :: height, width
  integer(c_int) :: run_status = TRUE
  type(c_ptr) :: window
  type(c_ptr) :: my_gmainloop
end module common_ex17


module plplot_code_ex17
  use plplot, PI => PL_PI
  use common_ex17

  implicit none
  integer, save :: id1, n=0
  logical :: autoy, acc
  real(plflt) :: y1, y2, y3, y4, ymin, ymax, xlab, ylab
  real(plflt) :: t, tmin, tmax, tjump, dt, noise
  type(c_ptr) :: cc
  integer :: colbox, collab, colline(4), styline(4)
  character(len=20) :: legline(4)
  character(len=20) :: toplab

contains

  subroutine x17f95(area)
    type(c_ptr), intent(in) :: area
    character(len=20) :: geometry
    ! Needed for use as functions instead of subroutines
    integer :: plparseopts_rc
    integer :: plsetopt_rc
    ! Define colour map 0 to match the "GRAFFER" colour table in
    ! place of the PLPLOT default.
    integer, parameter, dimension(16) :: rval = [255, 0, 255, &
         & 0, 0, 0, 255, 255, 255, 127, 0, 0, 127, 255, 85, 170], &
         & gval = [ 255, 0, 0, 255, 0, 255, 0, 255, 127, 255, 255, 127, &
         & 0, 0, 85, 170], &
         & bval = [ 255, 0, 0, 0, 255, 255, 255, 0, 0, 0, 127, 255, 255, &
         & 127, 85, 170]

    ! Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if (plparseopts_rc /= 0) stop "plparseopts error"

    ! Get a cairo context from the drawing area.
    cc = hl_gtk_drawing_area_cairo_new(area)

    ! Initialize plplot
    call plscmap0(rval, gval, bval)
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    write(geometry, "(I0,'x',I0)") width, height
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! Specify some reasonable defaults for ymin and ymax
    ! The plot will grow automatically if needed (but not shrink)
    ymin = -0.1_plflt
    ymax = 0.1_plflt

    ! Specify initial tmin and tmax -- this determines length of window.
    ! Also specify maximum jump in t
    ! This can accomodate adaptive timesteps
    tmin = 0._plflt
    tmax = 50._plflt
    ! percentage of plot to jump
    tjump = 0.3_plflt

    ! Axes options same as plbox.
    ! Only automatic tick generation and label placement allowed
    ! Eventually I'll make this fancier
    colbox = 1
    collab = 1
    ! pens color and line style
    styline(1) = 1
    colline(1) = 1
    styline(2) = 3
    colline(2) = 3
    styline(3) = 4
    colline(3) = 4
    styline(4) = 5
    colline(4) = 5

    ! pens legend
    legline(1) = 'sum'
    legline(2) = 'sin'
    legline(3) = 'sin*noi'
    legline(4) = 'sin+noi'

    ! legend position
    xlab = 0._plflt
    ylab = 0.25_plflt

    ! autoscale y
    autoy = .true.
    ! scrip, don't accumulate
    acc = .false.

    ! Initialize plplot
    call plinit()
    ! Tell the "extcairo" driver where the context is located.
    call pl_cmd(PLESC_DEVINIT, cc)

    call pladv(0)
    call plvsta()

    ! Create a 4-pen strip chart
    call plstripc(id1, 'bcnst', 'bcnstv', &
         tmin, tmax, tjump, ymin, ymax, &
         xlab, ylab, &
         autoy, acc, &
         colbox, collab, &
         colline, styline, legline, &
         't', '', 'Strip chart demo')

    ! autoscale y
    autoy = .false.
    ! accumulate
    acc = .true.

    ! This is to represent a loop over time
    ! Let's try a random walk process
    y1 = 0.0_plflt
    y2 = 0.0_plflt
    y3 = 0.0_plflt
    y4 = 0.0_plflt
    dt = 0.1_plflt

    call gtk_widget_queue_draw(area)
  end subroutine x17f95


  subroutine add_point(area)
    type(c_ptr), intent(in) :: area

    n = n + 1

    t = dble(n) * dt
    noise = plrandd() - 0.5_plflt
    y1 = y1 + noise
    y2 = sin(t*PI/18._plflt)
    y3 = y2 * noise
    y4 = y2 + noise/3._plflt

    ! There is no need for all pens to have the same number of
    ! points or being equally time spaced.
    if ( mod(n,2) /= 0 ) then
       call plstripa(id1, 0, t, y1)
    endif
    if ( mod(n,3) /= 0 ) then
       call plstripa(id1, 1, t, y2)
    endif
    if ( mod(n,4) /= 0 ) then
       call plstripa(id1, 2, t, y3)
    endif
    if ( mod(n,5) /= 0 ) then
       call plstripa(id1, 3, t, y4)
    end if

    call gtk_widget_queue_draw(area)
  end subroutine add_point


  subroutine close_strip
    ! Destroy strip chart and its memory
    call plstripd(id1)
    call plend()
    call hl_gtk_drawing_area_cairo_destroy(cc)
  end subroutine close_strip

end module plplot_code_ex17


module handlers_ex17
  use, intrinsic :: iso_c_binding
  use plplot_code_ex17

  implicit none

contains

  subroutine delete_cb (widget, event, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, event, gdata

    call close_strip()
    run_status = FALSE
  end subroutine delete_cb

  subroutine quit_cb(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call close_strip()
    run_status = FALSE
  end subroutine quit_cb

  subroutine pending_events ()
    integer(c_int) :: boolresult
    do while(IAND(g_main_context_pending(c_null_ptr), run_status) /= FALSE)
       ! False for non-blocking:
       boolresult = g_main_context_iteration(c_null_ptr, FALSE)
    end do
  end subroutine pending_events
end module handlers_ex17


program cairo_plplot_ex17
  use handlers_ex17
  use gtk_hl_container
  use gtk_hl_button
  use gtk_draw_hl

  implicit none
  type(c_ptr) :: drawing, base, qbut

  height = 500
  width = 1000

  call gtk_init()

  window = hl_gtk_window_new("PLplot x17 / gtk-fortran (extcairo)"//c_null_char, &
       & destroy = c_funloc(delete_cb))
  base = hl_gtk_box_new()
  call gtk_window_set_child(window, base)

  drawing = hl_gtk_drawing_area_new(size=[width, height], &
       & has_alpha = FALSE)

  call hl_gtk_box_pack(base, drawing)

  qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(quit_cb))
  call hl_gtk_box_pack(base, qbut, expand=FALSE)

  call gtk_widget_show(window)

  ! Preparing the plot:
  call x17f95(drawing)

  ! Note that here rather than using g_main_loop_run we look for events ourselves
  ! this makes it easy to add a point every 1/10s.
  ! An alternative would be to use g_timeout_add to control the updates
  ! (see the hl_plplot17e_gto.f90 example).

  do
     call pending_events()
     if (run_status == FALSE) exit
     call g_usleep(100000_c_long) ! So we don't burn CPU cycles
     call add_point(drawing)
  end do

  print *, "All done"
end program cairo_plplot_ex17

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by Vincent MAGNIN, 02-24-2011, last modified: 2022-10-03
! ****************
! Automated tests
! ****************
! This program is testing things about ISO_C_BINDING and the relations
! between Fortran types and GLib types. If it generates errors, post
! an issue on GitHub with information on your system
! (OS version, GTK version, compiler...) and the error message.

module tests
  use gtk, only: TRUE, FALSE, gtk_get_major_version, gtk_get_minor_version, &
                 gtk_get_micro_version
  use gtk_sup, only: c_f_string_copy_alloc
  use g, only: g_ascii_tolower, g_bit_storage, g_hostname_is_ip_address, &
    g_random_double, g_random_double_range, g_random_int, &
    g_random_int_range, g_variant_get_boolean, g_variant_get_byte, g_variant_get_double,&
    g_variant_get_int16, g_variant_get_int32, &
    g_variant_get_uint16, g_variant_get_uint32, &
    g_variant_new_boolean, g_variant_new_byte, g_variant_new_double, g_variant_new_int16,&
    g_variant_new_int32, g_variant_new_uint16,&
    g_variant_new_uint32, g_variant_unref, g_get_os_info
  use, intrinsic :: iso_fortran_env, only: compiler_version
  use, intrinsic :: iso_c_binding

  implicit none

contains
  integer function test_iso_c_binding()
    integer :: errors

    errors = 0
    if (C_SIGNED_CHAR < 0) then
      print *, "C_SIGNED_CHAR", C_SIGNED_CHAR
      errors = errors + 1
    end if
    if (C_SHORT < 0) then
      print *, "C_SHORT", C_SHORT
      errors = errors + 1
    end if
    if (C_INT < 0) then
      print *, "C_INT", C_INT
      errors = errors + 1
    end if
    if (C_LONG < 0) then
      print *, "C_LONG", C_LONG
      errors = errors + 1
    end if
    if (C_LONG_LONG < 0) then
      print *, "C_LONG_LONG", C_LONG_LONG
      errors = errors + 1
    end if
    if (C_SIZE_T < 0) then
      print *, "C_SIZE_T", C_SIZE_T
      errors = errors + 1
    end if
    if (C_INTPTR_T < 0) then
      print *, "C_INTPTR_T", C_INTPTR_T
      errors = errors + 1
    end if
    if (C_INTMAX_T < 0) then
      print *, "C_INTMAX_T", C_INTMAX_T
      errors = errors + 1
    end if
    if (C_INT8_T < 0) then
      print *, "C_INT8_T", C_INT8_T
      errors = errors + 1
    end if
    if (C_INT16_T < 0) then
      print *, "C_INT16_T", C_INT16_T
      errors = errors + 1
    end if
    if (C_INT32_T < 0) then
      print *, "C_INT32_T", C_INT32_T
      errors = errors + 1
    end if
    if (C_INT64_T < 0) then
      print *, "C_INT64_T", C_INT64_T
      errors = errors + 1
    end if
    if (C_INT_LEAST8_T < 0) then
      print *, "C_INT_LEAST8_T", C_INT_LEAST8_T
      errors = errors + 1
    end if
    if (C_INT_LEAST16_T < 0) then
      print *, "C_INT_LEAST16_T", C_INT_LEAST16_T
      errors = errors + 1
    end if
    if (C_INT_LEAST32_T < 0) then
      print *, "C_INT_LEAST32_T", C_INT_LEAST32_T
      errors = errors + 1
    end if
    if (C_INT_LEAST64_T < 0) then
      print *, "C_INT_LEAST64_T", C_INT_LEAST64_T
      errors = errors + 1
    end if
    if (C_INT_FAST8_T < 0) then
      print *, "C_INT_FAST8_T", C_INT_FAST8_T
      errors = errors + 1
    end if
    if (C_INT_FAST16_T < 0) then
      print *, "C_INT_FAST16_T", C_INT_FAST16_T
      errors = errors + 1
    end if
    if (C_INT_FAST32_T < 0) then
      print *, "C_INT_FAST32_T", C_INT_FAST32_T
      errors = errors + 1
    end if
    if (C_INT_FAST64_T < 0) then
      print *, "C_INT_FAST64_T", C_INT_FAST64_T
      errors = errors + 1
    end if
    if (C_FLOAT < 0) then
      print *, "C_FLOAT", C_FLOAT
      errors = errors + 1
    end if
    if (C_DOUBLE < 0) then
      print *, "C_DOUBLE", C_DOUBLE
      errors = errors + 1
    end if
    if (C_LONG_DOUBLE < 0) then
      print *, "C_LONG_DOUBLE", C_LONG_DOUBLE
      errors = errors + 1
    end if
    if (C_FLOAT_COMPLEX < 0) then
      print *, "C_FLOAT_COMPLEX", C_FLOAT_COMPLEX
      errors = errors + 1
    end if
    if (C_DOUBLE_COMPLEX < 0) then
      print *, "C_DOUBLE_COMPLEX", C_DOUBLE_COMPLEX
      errors = errors + 1
    end if
    if (C_LONG_DOUBLE_COMPLEX < 0) then
      print *, "C_LONG_DOUBLE_COMPLEX", C_LONG_DOUBLE_COMPLEX
      errors = errors + 1
    end if
    if (C_BOOL < 0) then
      print *, "C_BOOL", C_BOOL
      errors = errors + 1
    end if
    if (C_CHAR < 0) then
      print *, "C_CHAR", C_CHAR
      errors = errors + 1
    end if

    test_iso_c_binding = errors
  end function test_iso_c_binding


  integer function test_c_char_in_out()
    integer :: i
    integer :: errors
    character(kind=c_char) :: c

    errors = 0
    do i=0, 64, +1
      c = char(i)
      if (g_ascii_tolower(int(i,c_int8_t)) /= int(i,c_int8_t)) then
        print *, "ERROR gchar g_ascii_tolower (gchar c): ", i, g_ascii_tolower(int(i,c_int8_t))
        errors = errors + 1
      end if
    end do

    do i=65, 90, +1
      c = char(i)
      if (g_ascii_tolower(int(i,c_int8_t)) /= int(i,c_int8_t)+32) then
        print *, "ERROR gchar g_ascii_tolower (gchar c): ", i, g_ascii_tolower(int(i,c_int8_t))
        errors = errors + 1
      end if
    end do

    do i=91, 255, +1
      c = char(i)
      if (g_ascii_tolower(int(i,c_int8_t)) /= int(i,c_int8_t)) then
        print *, "ERROR gchar g_ascii_tolower (gchar c): ", i, g_ascii_tolower(int(i,c_int8_t))
        errors = errors + 1
      end if
    end do

    test_c_char_in_out = errors
  end function test_c_char_in_out


  integer function test_gdouble_in_out()
    integer :: i
    integer :: errors
    real(c_double) :: a, b, r, rmin, rmax
    type(c_ptr) :: gv
    !See the official documentation:
    !http://library.gnome.org/devel/glib/stable/glib-GVariant.html
    !http://library.gnome.org/devel/glib/stable/glib-GVariantType.html
    !GVariant *          g_variant_new_double   (gdouble value);
    !gdouble             g_variant_get_double   (GVariant *value);
    errors = 0
    do i = -308, +308
      a = 10.0_c_double ** i
      gv = g_variant_new_double(a)
      b = g_variant_get_double(gv)
      if (a /= b) then
        print *, "ERROR g_random_double_range:", i, a, b
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do
    !    ! gdouble g_random_double_range (gdouble begin, gdouble end);
    !    function g_random_double_range(begin, end) bind(c)
    !      use, intrinsic :: iso_c_binding, only: c_double
    !      real(c_double) :: g_random_double_range
    !      real(c_double), value :: begin
    !      real(c_double), value :: end
    !    end function
    rmin = -10.0_c_double
    rmax = +100.0_c_double
    do i = 1, 10000, +1
      r = g_random_double_range(rmin, rmax)
      if ((r<rmin).or.(r>rmax)) then
        print *, "ERROR g_random_double_range:", r
        errors = errors + 1
      end if
    end do

    test_gdouble_in_out = errors
  end function test_gdouble_in_out


  integer function test_gulong_in()
    integer :: i
    integer :: errors
    integer(c_long) :: nb
    integer(c_int) :: r
    !    ! guint g_bit_storage (gulong number) G_GNUC_CONST;
    !    function g_bit_storage(number) bind(c)
    !      use, intrinsic :: iso_c_binding, only: c_int, c_long
    !      integer(c_int) :: g_bit_storage
    !      integer(c_long), value :: number
    !    end function
    errors = 0
    ! Fortran integers are signed. 32 bits integers are in [-2147483648, +2147483647],
    ! and the C language guarantee [-2147483647, +2147483647] for long.
    ! C language: typedef unsigned long   gulong;
    do i = 1, 31, +1
      ! Writing 2**i - 1 could overflow with some compilers (ifort):
      nb = 2_c_long**i - 1
      r = g_bit_storage(nb)
      if (i /= r) then
        print *, "ERROR g_bit_storage:", i, nb, r
        errors = errors + 1
      end if
    end do

    test_gulong_in = errors
  end function test_gulong_in


  integer function test_uint16_in_out()
    integer :: i
    integer :: errors
    integer(c_int16_t) :: a, b
    integer(c_int32_t) :: c, d
    type(c_ptr) :: gv
    !! GVariant * g_variant_new_uint16 (guint16 uint16);
    !function g_variant_new_uint16(uint16) bind(c)
    !  use, intrinsic :: iso_c_binding, only: c_ptr, c_int16_t
    !  type(c_ptr) :: g_variant_new_uint16
    !  integer(c_int16_t), value :: uint16
    !end function

    !! guint16 g_variant_get_uint16 (GVariant *value);
    !function g_variant_get_uint16(value) bind(c)
    !  use, intrinsic :: iso_c_binding, only: c_int16_t, c_ptr
    !  integer(c_int16_t) :: g_variant_get_uint16
    !  type(c_ptr), value :: value
    !end function

    ! INTEGER(2) ranges from -32768 to 32767
    ! uint16 ranges from 0 to 65535.
    !***********************************
    ! We must be careful because the following loop is undefined in the Fortran Standard:
    ! do a = 0, 32767
    !                 1
    ! Warning: DO loop at (1) is undefined as it overflows [-Wundefined-do-loop]
    ! With some compilers, it will run OK, with others a will become <0 and the
    ! loop will never end...
    !***********************************
    errors = 0
    do a = 0, 32766
      gv = g_variant_new_uint16(a)
      b = g_variant_get_uint16(gv)
      if (a /= b) then
        print *, "ERROR g_variant_get_uint16:", a, b
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do

    a = 32767
    gv = g_variant_new_uint16(a)
    b = g_variant_get_uint16(gv)
    if (a /= b) then
      print *, "ERROR g_variant_get_uint16:", a, b
      errors = errors + 1
    end if
    call g_variant_unref(gv)

    do c = 32768, 65535
      a = transfer(c, a)
      gv = g_variant_new_uint16(a)
      b = g_variant_get_uint16(gv)
      d = transfer(b, d)
      do i = bit_size(b),  bit_size(d)-1
        d= ibclr(d, i)
      end do

      if (a /= b) then
        print *, "ERROR g_variant_get_uint16:", a, b
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do

    test_uint16_in_out = errors
  end function test_uint16_in_out


  integer function test_int16_in_out()
    integer(c_int16_t) :: a, b
    integer :: errors, i
    type(c_ptr) :: gv

    errors = 0

    do i = -32768, 32767
       a = int(i,c_int16_t)
       gv = g_variant_new_int16(a)
       b = g_variant_get_int16(gv)
       if (a /= b) then
          print *, "ERROR g_variant_get_int16:", a, b
          errors = errors + 1
       end if
       call g_variant_unref(gv)
    end do

    test_int16_in_out = errors
  end function test_int16_in_out


  integer function test_int32_in_out()
    integer :: i
    integer :: errors
    integer(c_int32_t) :: r, rmin, rmax
    integer(c_int32_t) :: a, b
    type(c_ptr) :: gv
    !GVariant *          g_variant_new_int32    (gint32 value);
    !gint32              g_variant_get_int32    (GVariant *value);
    errors = 0
    !***********************************
    ! We must be careful because the following loop is undefined in the Fortran Standard:
    ! do a = -huge(b), huge(b), +65536
    !
    ! Warning: DO loop at is undefined as it overflows [-Wundefined-do-loop]
    ! With some compilers, it will run OK (GFortran), with others a will become <0 and the
    ! loop will never end (ifort)...
    !***********************************
    do a = -huge(b), huge(b)-65536, +65536
      gv = g_variant_new_int32(a)
      b = g_variant_get_int32(gv)
      if (a /= b) then
        print *, "ERROR g_variant_get_int32:", a, b
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do

    !    ! gint32 g_random_int_range (gint32 begin, gint32 end);
    !    function g_random_int_range(begin, end) bind(c)
    !      use, intrinsic :: iso_c_binding, only: c_int32_t
    !      integer(c_int32_t) :: g_random_int_range
    !      integer(c_int32_t), value :: begin
    !      integer(c_int32_t), value :: end
    !    end function
    rmin = -10
    rmax = +100
    do i = 1, 10000, +1
      ! Returns a random number over the range [rmin..rmax-1]:
      r = g_random_int_range(rmin, rmax)
      if ((r < rmin).or.(r >= rmax)) then
        print *, "ERROR g_random_double_range:", r
        errors = errors + 1
      end if
    end do

    test_int32_in_out = errors
  end function test_int32_in_out


  integer function test_uint32_in_out()
    integer :: i
    integer :: errors
    integer(c_int32_t) :: a, b
    integer(c_int64_t) :: c, d
    type(c_ptr) :: gv

    errors = 0
    ! INTEGER(4) ranges from -2147483648 to +2147483647
    ! uint32 ranges from 0 to 4294967295
    !***********************************
    ! We must be careful because the following loop is undefined in the Fortran Standard:
    ! do a = 0, 2147483647, +65536
    !
    ! With some compilers, it will run OK, with others a will become <0 and the
    ! loop will never end...
    !***********************************
    do a = 0, 2147483647-65536, +65536
      gv = g_variant_new_uint32(a)
      b = g_variant_get_uint32(gv)
      if (a /= b) then
        print *, "ERROR g_variant_get_uint32:", a, b
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do

    a = 2147483647
    gv = g_variant_new_uint32(a)
    b = g_variant_get_uint32(gv)
    if (a /= b) then
      print *, "ERROR g_variant_get_uint32:", a, b
      errors = errors + 1
    end if
    call g_variant_unref(gv)

    do c = 2147483648_8, 4294967295_8, +65536
      a = transfer(c, a)
      gv = g_variant_new_uint32(a)
      b = g_variant_get_uint32(gv)
      d = transfer(b, d)
      do i = bit_size(b),  bit_size(d)-1
        d= ibclr(d, i)
      end do

      if (a /= b) then
        print *, "ERROR g_variant_get_uint32:", a, b
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do

    test_uint32_in_out = errors
  end function test_uint32_in_out


  integer function test_guchar_in_out()
    integer(c_int16_t) :: i, j
    integer :: errors
    character(kind=c_char) :: a, b
    type(c_ptr) :: gv
    !GVariant *          g_variant_new_byte     (guchar value);
    !guchar              g_variant_get_byte     (GVariant *value);
    errors = 0
    do i = 0, 255, +1
      a = char(i)
      gv = g_variant_new_byte(int(i,c_int8_t))
      j = g_variant_get_byte(gv)
      b = achar(j)
      if ((a /= b) .or. (iand(i,255_c_int16_t) /= iand(j, 255_c_int16_t))) then
        print *, "ERROR test_guchar_in_out:", a, b, i, j
        errors = errors + 1
      end if
      call g_variant_unref(gv)
    end do

    test_guchar_in_out = errors
  end function test_guchar_in_out


  integer function test_gboolean_in_out()
    integer(c_int) :: l1, l2, l3, l4
    integer :: errors
    type(c_ptr) :: gv
    !GVariant *          g_variant_new_boolean  (gboolean value);
    !gboolean            g_variant_get_boolean               (GVariant *value);
    errors = 0
    l1 = TRUE
    gv = g_variant_new_boolean(l1)
    l2 = g_variant_get_boolean(gv)
    print *, l1, l2
    if (l1 /= l2) then
        print *, "ERROR g_variant_get_boolean:", l1, l2
        errors = errors + 1
    end if
    call g_variant_unref(gv)

    l1 = FALSE
    gv = g_variant_new_boolean(l1)
    l2 = g_variant_get_boolean(gv)
    print *, l1, l2
    if (l1 /= l2) then
        print *, "ERROR g_variant_get_boolean:", l1, l2
        errors = errors + 1
    end if

  !      ! gboolean g_hostname_is_ip_address (const gchar *hostname);
  !    function g_hostname_is_ip_address(hostname) bind(c)
  !      use, intrinsic :: iso_c_binding, only: c_bool, c_char
  !      logical(c_bool) :: g_hostname_is_ip_address
  !      character(kind=c_char), dimension(*) :: hostname
  !    end function
    l1 = g_hostname_is_ip_address("192.168.0.1"//c_null_char)
    l2 = g_hostname_is_ip_address("1AA.168.0.1"//c_null_char)
    l3 = g_hostname_is_ip_address("blabla"//c_null_char)
    l4 = g_hostname_is_ip_address("192.168,0.1"//c_null_char)
    if ((l1 /= TRUE) .or. (l2 /= FALSE) .or. (l3 /= FALSE) .or. (l4 /= FALSE)) then
      print *, "ERROR g_hostname_is_ip_address:", l1, l2, l3, l4
      errors = errors + 1
    end if
    call g_variant_unref(gv)

    test_gboolean_in_out = errors
  end function test_gboolean_in_out

end module tests


program gtk_fortran_test
  use tests

  implicit none
  integer :: errors
  character(:), allocatable :: os_string
  type(c_ptr) :: ret

  print '(A)', "Testing iso_c_binding with GTK and GLib..."

  ! That function may return NULL with some OS:
  ret = g_get_os_info("PRETTY_NAME"//c_null_char)
  if (c_associated(ret)) then
    call c_f_string_copy_alloc(ret, os_string)
  else
    os_string = "?"
  end if

  print '(3A,I0,A1,I0,A1,I0)', "Compiled with "//compiler_version()//" on ", os_string, &
      & ", linked to GTK ", gtk_get_major_version(),".", gtk_get_minor_version(), ".", gtk_get_micro_version()

  print '(A)', "test_iso_c_binding()"
  errors = test_iso_c_binding()
  print '(A)', "test_c_char_in_out()"
  errors = errors +  test_c_char_in_out()
  print '(A)', "test_guchar_in_out()"
  errors = errors +  test_guchar_in_out()
  print '(A)', "test_gdouble_in_out()"
  errors = errors +  test_gdouble_in_out()
  print '(A)', "test_gulong_in()"
  errors = errors +  test_gulong_in()
  print '(A)', "test_int16_in_out()"
  errors = errors +  test_int16_in_out()
  print '(A)', "test_uint16_in_out()"
  errors = errors +  test_uint16_in_out()
  print '(A)', "test_int32_in_out()"
  errors = errors +  test_int32_in_out()
  print '(A)', "test_uint32_in_out()"
  errors = errors +  test_uint32_in_out()
  print '(A)', "test_gboolean_in_out()"
  errors = errors +  test_gboolean_in_out()

  print *
  print '(I3, A)', errors, " errors"

end program gtk_fortran_test

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 02-20-2019, 2020-07-14
!------------------------------------------------------------------------------

module tr_handlers
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_tree
  use gtk, only: gtk_button_new, gtk_widget_show, gtk_window_destroy, &
               & gtk_window_set_child
  use g, only: alloca

  implicit none
  ! The widgets. (Strictly only those that need to be accessed
  ! by the handlers need to go here).
  type(c_ptr) :: ihwin,ihscrollcontain,ihlist, base, &
       &  qbut, dbut, lbl

contains

  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Exit called"
    call gtk_window_destroy(ihwin)
  end subroutine my_destroy

  subroutine del_row(but, gdata) bind(c)
    type(c_ptr), value, intent(in) :: but, gdata
    integer(c_int), dimension(:,:), allocatable :: selections
    integer(c_int), dimension(:), allocatable :: dep
    integer(c_int) :: nsel

    nsel = hl_gtk_tree_get_selections(ihlist, selections, &
         & depths=dep)

    if (nsel /= 1) then
       print *, "Not a single selection"
       return
    end if

    call hl_gtk_tree_rem(ihlist, selections(:dep(1),1))

    call gtk_widget_set_sensitive(but, FALSE)
  end subroutine del_row

  subroutine list_select(list, gdata) bind(c)
    type(c_ptr), value, intent(in) :: list, gdata
    integer(c_int) :: nsel
    integer(c_int), dimension(:,:), allocatable :: selections
    integer(c_int), dimension(:), allocatable :: dep
    integer(c_int) :: n, n3
    integer(c_int64_t) :: n4
    real(c_float) :: nlog
    character(len=30) :: name
    character(len=10) :: nodd
    integer :: i
    nsel = hl_gtk_tree_get_selections(C_NULL_PTR, selections, selection=list, &
         & depths=dep)
    if (nsel == 0) then
       print *, "No selection"
       return
    end if

    ! Find and print the selected row(s)
    print *, nsel,"Rows selected"
    print *, "Depths", dep
    print *, "Rows"
    do i = 1, nsel
       print *, selections(:dep(i),i)
    end do

    if (nsel == 1) then
       call hl_gtk_tree_get_cell(ihlist, selections(:dep(1),1), 0_c_int, &
            & svalue=name)
       call hl_gtk_tree_get_cell(ihlist, selections(:dep(1),1), 1_c_int, &
            & ivalue=n)
       call hl_gtk_tree_get_cell(ihlist, selections(:dep(1),1), 2_c_int, &
            & ivalue=n3)
       call hl_gtk_tree_get_cell(ihlist, selections(:dep(1),1), 4_c_int, &
            & l64value=n4)
       call hl_gtk_tree_get_cell(ihlist, selections(:dep(1),1), 3_c_int, &
            & fvalue=nlog)
       call hl_gtk_tree_get_cell(ihlist, selections(:dep(1),1), 5_c_int,&
            & svalue=nodd)
       print "('Name: ',a,' N:',I3,' 3N:',I4,' N**4:',I7,&
            &' log(n):',F7.5,' Odd?: ',a)", trim(name), &
            & n, n3, n4, nlog, nodd
       call gtk_widget_set_sensitive(dbut, TRUE)
    else
       call gtk_widget_set_sensitive(dbut, FALSE)
    end if

    deallocate(selections)
  end subroutine list_select

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    character(len=35) :: line
    integer(c_int) :: i, ltr, j
    integer(type_kind), dimension(6) :: ctypes
    character(len=20), dimension(6) :: titles
    integer(c_int), dimension(6) :: sortable, editable

    ! Create a window that will hold the widget system
    ihwin = gtk_application_window_new(app)
    call gtk_window_set_title(ihwin, "Tree view demo"//c_null_char)

    ! Now make a column box & put it into the window
    base = hl_gtk_box_new()
    call gtk_window_set_child(ihwin, base)

    ! Now make a multi column list with multiple selections enabled
    ctypes = [ G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT, G_TYPE_FLOAT, &
         & G_TYPE_UINT64, G_TYPE_BOOLEAN ]
    sortable = [ FALSE, TRUE, FALSE, FALSE, FALSE, TRUE ]
    editable = [ TRUE, FALSE, TRUE, FALSE, FALSE, FALSE ]

    titles(1) = "Name"
    titles(2) = "N"
    titles(3) = "3N"
    titles(4) = "Log(n)"
    titles(5) = "N**4"
    titles(6) = "Odd?"

    ihlist = hl_gtk_tree_new(ihscrollcontain, types=ctypes, &
         & changed=c_funloc(list_select),&
         &  multiple=TRUE, height=250_c_int, swidth=400_c_int, titles=titles, &
         & sortable=sortable, editable=editable)

    ! Now put 10 top level rows into it
    do i=1,10
       call hl_gtk_tree_ins(ihlist, row = [ -1_c_int ])
       write(line,"('List entry number ',I0)") i
       ltr=len_trim(line)+1
       line(ltr:ltr)=c_null_char
       call hl_gtk_tree_set_cell(ihlist, absrow=i-1_c_int, col=0_c_int, &
            & svalue=line)
       call hl_gtk_tree_set_cell(ihlist, absrow=i-1_c_int, col=1_c_int, &
            & ivalue=i)
       call hl_gtk_tree_set_cell(ihlist, absrow=i-1_c_int, col=2_c_int, &
            & ivalue=3_c_int*i)
       call hl_gtk_tree_set_cell(ihlist, absrow=i-1_c_int, col=3_c_int, &
            & fvalue=log10(real(i)))
       call hl_gtk_tree_set_cell(ihlist, absrow=i-1_c_int, col=4_c_int, &
            & l64value=int(i,c_int64_t)**4)
       call hl_gtk_tree_set_cell(ihlist, absrow=i-1_c_int, col=5_c_int, &
            & ivalue=mod(i,2_c_int))
    end do

    ! Add some child rows
    do j = 2, 6, 2
       call hl_gtk_tree_ins(ihlist, row = [ j, -1_c_int ], count=5)
       do i = 1, 5
          write(line,"('List entry number',I0,':',I0)") j+1,i
          ltr=len_trim(line)+1
          line(ltr:ltr)=c_null_char
          call hl_gtk_tree_set_cell(ihlist, row=[ j, i-1_c_int], col=0_c_int, &
               & svalue=line)
          call hl_gtk_tree_set_cell(ihlist, row=[ j, i-1_c_int], col=1_c_int, &
               & ivalue=i)
          call hl_gtk_tree_set_cell(ihlist, row=[ j, i-1_c_int], col=2_c_int, &
               & ivalue=3_c_int*i)
          call hl_gtk_tree_set_cell(ihlist, row=[ j, i-1_c_int], col=3_c_int, &
               & fvalue=log10(real(i)))
          call hl_gtk_tree_set_cell(ihlist, row=[ j, i-1_c_int], col=4_c_int, &
               & l64value=int(i,c_int64_t)**4)
          call hl_gtk_tree_set_cell(ihlist, row=[ j, i-1_c_int], col=5_c_int, &
               & ivalue=mod(i,2_c_int))
       end do
    end do

    ! It is the scrollcontainer that is placed into the box.
    call hl_gtk_box_pack(base, ihscrollcontain)

    ! Add a note about editable columns
    lbl = gtk_label_new("The ""Name"" and ""3N"" columns are editable"&
         & //c_null_char)
    call hl_gtk_box_pack(base, lbl)

    ! Delete selected row
    dbut = hl_gtk_button_new("Delete selected row"//c_null_char, &
         & clicked=c_funloc(del_row), &
         & tooltip="Delete the selected row"//c_null_char, sensitive=FALSE)

    call hl_gtk_box_pack(base, dbut)

    ! Also a quit button
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base,qbut)

    ! realize the window
    call gtk_widget_show(ihwin)
  end subroutine activate
end module tr_handlers

program tree
  ! TREE
  ! Demo of a tree
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use tr_handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_tree"//c_null_char, &
                             & c_funloc(activate))
end program tree

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by James Tappin
! Last modification: 2011-11-21

! --------------------------------------------------------
! gtk-hl-combobox.f90
! Generated: Tue Oct 29 17:12:20 2013 GMT
! Generated for  GTK version: 3.10.0.
! Generated for GLIB version: 2.38.0.
! --------------------------------------------------------


!*
! ComboBox
module gtk_hl_combobox
  ! This interface implements the GtkComboBoxText widget for making a chooser.
  ! While this has more limited capabilities than the full GtkComboBox, it
  ! is adequate for the vast majority of uses.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding
  ! Autogenerated use's
  use gtk, only: gtk_combo_box_get_active, gtk_combo_box_new,&
       & gtk_combo_box_set_active, &
       & gtk_widget_set_sensitive, gtk_widget_set_tooltip_text,&
       & gtk_combo_box_text_get_active_text, gtk_combo_box_text_new,&
       & gtk_combo_box_text_new_with_entry, &
       & gtk_combo_box_text_remove, &
       & gtk_combo_box_text_append_text,&
       & gtk_combo_box_text_insert_text,&
       & gtk_combo_box_text_prepend_text,&
       & gtk_combo_box_text_remove_all, &
       & gtk_combo_box_get_model, gtk_tree_model_iter_n_children, &
       & TRUE, FALSE, g_signal_connect

  implicit none

  interface hl_gtk_combo_box_delete
     module procedure hl_gtk_combo_box_delete_single
     module procedure hl_gtk_combo_box_delete_multi
     module procedure hl_gtk_combo_box_delete_all
  end interface hl_gtk_combo_box_delete

contains
  !+
  function hl_gtk_combo_box_new(has_entry, changed, data, initial_choices, &
       & sensitive, tooltip, active) result(cbox)

    type(c_ptr) :: cbox
    integer(c_int), intent(in), optional :: has_entry
    type(c_funptr), optional :: changed
    type(c_ptr), intent(in), optional :: data
    character(len=*), dimension(:), intent(in), optional :: initial_choices
    integer(c_int), intent(in), optional :: sensitive
    character(kind=c_char), dimension(*), optional, intent(in) :: tooltip
    integer(c_int), optional, intent(in) :: active

    ! Creator for the combobox.
    !
    ! HAS_ENTRY |  boolean |  optional |  Set to TRUE to add an entry field.
    ! CHANGED |  c_funptr |  optional |  Callback routine for the "changed" signal.
    ! DATA |  c_ptr |  optional |  User data for the changed callback.
    ! INITIAL_CHOICES |  string() |  optional |  Initial list of choices.
    ! SENSITIVE |  boolean |  optional |  Set to FALSE to make the widget start in an insensitive state.
    ! TOOLTIP |  string |  optional |  A tooltip to display when the pointer is held over the widget.
    ! ACTIVE |  c_int |  optional |  The initial active selection.
    !-

    integer(c_int) :: ientry
    integer(c_int) :: i

    if (present(has_entry)) then
       ientry = has_entry
    else
       ientry = FALSE
    end if

    if (ientry == TRUE) then
       cbox = gtk_combo_box_text_new_with_entry()
    else
       cbox = gtk_combo_box_text_new()
    end if

    if (present(initial_choices)) then
       do i=1,size(initial_choices)
          call gtk_combo_box_text_append_text(cbox, &
               & trim(initial_choices(i))//C_NULL_CHAR)
       end do
    end if

    if (present(active)) call gtk_combo_box_set_active(cbox, active)

    if (present(changed)) then
       if (present(data)) then
          call g_signal_connect(cbox, "changed"//C_NULL_CHAR, changed, data)
       else
          call g_signal_connect(cbox, "changed"//C_NULL_CHAR, changed)
       end if
    end if

    if (present(sensitive)) call gtk_widget_set_sensitive(cbox, sensitive)
    if (present(tooltip)) call gtk_widget_set_tooltip_text(cbox, tooltip)
  end function hl_gtk_combo_box_new

  !+
  subroutine hl_gtk_combo_box_add_text(cbox, text, index, at_start)

    type(c_ptr), intent(in) :: cbox
    character(kind=c_char), dimension(*), optional :: text
    integer(c_int), intent(in), optional :: index
    integer(c_int), intent(in), optional :: at_start

    ! Add a new choice to a combo box.
    !
    ! CBOX |  c_ptr |  required |  The combo box to modify.
    ! TEXT |  string |  required |  The text to add.
    ! INDEX |  c_int |  optional |  The location at which to add the text.
    ! AT_START |  boolean |  optional |  If set to TRUE and INDEX is not given then add the text at the start of the list.
    !
    ! If neither INDEX nor AT_START is present the text is appended.
    !-

    integer(c_int) :: prepend

    if (present(index)) then
       call gtk_combo_box_text_insert_text(cbox, index, text)
    else
       if (present(at_start)) then
          prepend = at_start
       else
          prepend = FALSE
       end if
       if (prepend == TRUE) then
          call gtk_combo_box_text_prepend_text(cbox, text)
       else
          call gtk_combo_box_text_append_text(cbox, text)
       end if
    end if
  end subroutine hl_gtk_combo_box_add_text

  !+
  subroutine hl_gtk_combo_box_delete_single(cbox, index)

    type(c_ptr), intent(in) :: cbox
    integer(c_int), intent(in) :: index

    ! Delete a line from a combo box
    !
    ! CBOX |  c_ptr |  required |  The combo box to update
    ! INDEX |  c_int |  required |  The index of the choce to remove
    !
    ! Usually called via the generic hl_gtk_combo_box_delete interface.
    !-

    call gtk_combo_box_text_remove(cbox, index)

  end subroutine hl_gtk_combo_box_delete_single

  !+
  subroutine hl_gtk_combo_box_delete_multi(cbox, index)

    type(c_ptr), intent(in) :: cbox
    integer(c_int), dimension(:), intent(in) :: index

    ! Delete lines from a combo box
    !
    ! CBOX |  c_ptr |  required |  The combo box to update
    ! INDEX |  c_int() |  required |  The index of the choce to remove
    !
    ! Usually called via the generic hl_gtk_combo_box_delete interface.
    !-

    integer(c_int) :: i

    do i = size(index),1,-1
       call gtk_combo_box_text_remove(cbox, index(i))
    end do
  end subroutine hl_gtk_combo_box_delete_multi

  !+
  subroutine hl_gtk_combo_box_delete_all(cbox)

    type(c_ptr), intent(in) :: cbox

    ! Delete all lines from a combo box
    !
    ! CBOX |  c_ptr |  required |  The combo box to update
    !
    ! Usually called via the generic hl_gtk_combo_box_delete interface.
    !-

    call gtk_combo_box_text_remove_all(cbox)

  end subroutine hl_gtk_combo_box_delete_all
  !+
  function hl_gtk_combo_box_get_active(cbox, text, ftext) result(index)

    integer(c_int) :: index
    type(c_ptr), intent(in) :: cbox
    type(c_ptr), intent(out), optional :: text
    character(len=*), intent(out), optional :: ftext

    ! Get the selection from a combo box
    !
    ! CBOX |  c_ptr |  required |  The combo box to query.
    ! TEXT |  c_ptr |  optional |  C pointer to the text.
    ! FTEXT |  fstring |  optional |  The string as a Fortran string.
    !-

    type(c_ptr), target :: ctext

    index = gtk_combo_box_get_active(cbox)

    if (present(text) .or. present(ftext)) then
      ctext = gtk_combo_box_text_get_active_text(cbox)
       ! This is a bit ugly
       if (present(ftext)) &
            & call convert_c_string(ctext, ftext)

       if (present(text)) text=ctext
    end if
  end function hl_gtk_combo_box_get_active

  !+
  function hl_gtk_combo_box_n_entries(cbox) result(count)
    integer(c_int) :: count
    type(c_ptr), intent(in) :: cbox

    ! Find the number of entries in a combo box.
    !
    ! CBOX |  c_ptr |  required |  The combo box to query.
    !-

    type(c_ptr) :: model

    model = gtk_combo_box_get_model(cbox)
    count = gtk_tree_model_iter_n_children (model, C_NULL_PTR)

  end function hl_gtk_combo_box_n_entries

end module gtk_hl_combobox

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by Vincent Magnin and Jerry DeLisle
! Last modifications: vmagnin+Ian Harvey 2019-02-21, vmagnin 2022-05-06
!------------------------------------------------------------------------------

module global_widgets
  use, intrinsic :: iso_c_binding, only: c_ptr, c_char, c_int
  type(c_ptr) :: my_pixbuf, my_drawing_area, spinButton1, spinButton2, spinButton3
  type(c_ptr) :: textView, buffer, scrolled_window, statusBar, combo1
  character(kind=c_char), dimension(:), pointer :: pixel
  integer(c_int) :: nch, rowstride, width, height, pixwidth, pixheight
  logical :: computing = .false.
  character(len=80) :: string
end module global_widgets

module handlers
  use gtk, only: gtk_application_window_new, gtk_window_destroy, &
  & g_signal_connect, g_signal_connect_swapped, &
  & gtk_window_set_child, gtk_expander_set_child, gtk_box_append, &
  & gtk_scrolled_window_set_child, gtk_drawing_area_new, &
  & gtk_drawing_area_set_content_width, gtk_drawing_area_set_content_height, &
  & gtk_drawing_area_set_draw_func, &
  & gtk_widget_queue_draw, gtk_widget_show, &
  & gtk_window_set_default_size, gtk_window_set_title, &
  & TRUE, FALSE, GDK_COLORSPACE_RGB, &
  & gtk_grid_new, gtk_grid_attach, gtk_button_new_with_label,&
  & gtk_box_new, gtk_spin_button_new,&
  & gtk_adjustment_new, gtk_spin_button_get_value, gtk_label_new, &
  & gtk_expander_new_with_mnemonic, gtk_expander_set_expanded, &
  & gtk_toggle_button_new_with_label, gtk_toggle_button_get_active, gtk_notebook_new,&
  & gtk_notebook_append_page, gtk_text_view_new, gtk_text_view_get_buffer, &
  & gtk_text_buffer_set_text, gtk_scrolled_window_new, &
  & gtk_text_buffer_insert_at_cursor, gtk_statusbar_new, &
  & gtk_statusbar_push, gtk_statusbar_pop, gtk_statusbar_get_context_id, &
  & gtk_button_new_with_mnemonic, gtk_link_button_new_with_label, &
  & gtk_toggle_button_new_with_mnemonic, gtk_label_new_with_mnemonic, &
  & gtk_window_set_mnemonics_visible, gtk_combo_box_text_new, &
  & gtk_combo_box_text_append_text, gtk_combo_box_text_get_active_text, &
  & gtk_combo_box_text_insert_text, gtk_spin_button_set_value, gtk_spin_button_update,&
  & GTK_ORIENTATION_VERTICAL, gtk_grid_set_column_homogeneous, &
  & gtk_grid_set_row_homogeneous, gtk_statusbar_remove_all, &
  & gtk_widget_set_vexpand

  use g, only: g_usleep, g_main_context_iteration, g_main_context_pending
  use, intrinsic :: iso_c_binding, only: c_int, c_ptr, c_null_ptr, c_null_char, C_NEW_LINE
  use, intrinsic :: iso_fortran_env, only: wp=>real64, int8

  implicit none
  type(c_ptr)    :: my_window
  ! run_status is TRUE until the user closes the top window:
  integer(c_int) :: run_status = TRUE
  integer(c_int) :: boolresult

contains
  ! Our callback function before destroying the window:
  recursive subroutine destroy_signal(widget, event, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, event, gdata

    print *, "Your destroy_signal() function has been invoked !"
    ! Some functions and subroutines need to know that it's finished:
    run_status = FALSE
    call gtk_window_destroy(my_window)
  end subroutine destroy_signal

  ! This function is needed to update the GUI during long computations.
  ! https://developer.gnome.org/glib/stable/glib-The-Main-Event-Loop.html
  recursive subroutine pending_events ()
    do while(IAND(g_main_context_pending(c_null_ptr), run_status) /= FALSE)
      ! FALSE for non-blocking:
      boolresult = g_main_context_iteration(c_null_ptr, FALSE)
    end do
  end subroutine pending_events

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  ! https://developer.gnome.org/gtk4/stable/GtkDrawingArea.html#gtk-drawing-area-set-draw-func
  subroutine my_draw_function(widget, my_cairo_context, width, height, gdata) bind(c)
    use cairo, only: cairo_paint
    use gdk, only: gdk_cairo_set_source_pixbuf
    use global_widgets, only: my_pixbuf

    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height

    ! We redraw the pixbuf:
    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 0d0, 0d0)
    call cairo_paint(my_cairo_context)
  end subroutine my_draw_function

  ! GtkButton signal emitted by the "Compute" button
  ! In this example, this function is declared recursive because it can be
  ! called a second time from the Julia_set() subroutine:
  recursive subroutine firstbutton (widget, gdata ) bind(c)
    use global_widgets

    integer(c_int)                 :: message_id
    type(c_ptr), value, intent(in) :: widget, gdata
    complex(wp)                    :: c
    integer                        :: iterations

    if (.not. computing) then
      ! Get computation parameters:
      c = gtk_spin_button_get_value (spinButton1) + &
          & (0.0_wp, 1.0_wp)*gtk_spin_button_get_value (spinButton2)
      iterations = INT(gtk_spin_button_get_value (spinButton3))

      ! Print them in the text buffer:
      write(string, '("c=",F9.6,"+i*",F9.6,"   ", I8, " iterations")') c, iterations
      call gtk_text_buffer_insert_at_cursor (buffer, string//C_NEW_LINE &
                                           & //c_null_char, -1_c_int)

      message_id = gtk_statusbar_push (statusBar, gtk_statusbar_get_context_id(&
                                     & statusBar, "Julia"//c_null_char),&
                                     & "Computing..."//c_null_char)

      ! Compute the image:
      call Julia_set(-2.0_wp, +2.0_wp, -2.0_wp, +2.0_wp, c, iterations)

      ! If Julia_set() was quitted because of a delete_event, we can not use
      ! the statusBar because it has been destroyed:
      if (run_status == TRUE) then
        message_id = gtk_statusbar_push (statusBar, gtk_statusbar_get_context_id(&
                                       & statusBar, "Julia"//c_null_char),&
                                       & "Finished."//c_null_char)
      end if
    else
      print *, "Already computing !"
    end if
  end subroutine firstbutton

  ! GtkComboBox signal emitted when the user selects predifined c values of
  ! interesting Julia sets in the combo box:
  subroutine firstCombo (widget, gdata ) bind(c)
    use, intrinsic :: iso_c_binding, only: c_double, c_f_pointer
    use gtk_sup, only: c_f_string_copy_alloc
    use global_widgets

    type(c_ptr), value, intent(in) :: widget, gdata
    real(c_double)                 :: x, y
    integer                        :: choice
    character(:), allocatable      :: my_string

    ! Get the value selected by the user:
    call c_f_string_copy_alloc( gtk_combo_box_text_get_active_text(combo1), my_string)
    read(my_string, *) choice

    select case (choice)
    case(1)
      x = +0.0_wp
      y = +1.0_wp
    case(2)
      x = -1.0_wp
      y = +0.0_wp
    case(3)
      x = -0.8_wp
      y = +0.2_wp
    case(4)
      x = +0.39_wp
      y = +0.60_wp
    case(5)
      x = -0.2_wp
      y = +0.8_wp
    case(6)
      x = -0.8_wp
      y = +0.4_wp
    case(7)
      x = +0.39_wp
      y = +0.00_wp
    end select

    ! Update the spin buttons real(c) and imag(c):
    call gtk_spin_button_set_value (spinButton1, x)
    call gtk_spin_button_set_value (spinButton2, y)
  end subroutine firstCombo

  ! GtkButton signal emitted by the button "Save as PNG":
  subroutine secondbutton (widget, gdata) bind(c)
    use gdk_pixbuf, only: gdk_pixbuf_savev
    use global_widgets

    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int)                 :: cstatus, message_id

    ! Save the picture if the computation is finished:
    if (.not. computing) then
      ! https://developer.gnome.org/gdk-pixbuf/stable/gdk-pixbuf-File-saving.html
      ! https://mail.gnome.org/archives/gtk-list/2004-October/msg00186.html
      cstatus = gdk_pixbuf_savev(my_pixbuf, "julia.png"//c_null_char, &
                & "png"//c_null_char, c_null_ptr, c_null_ptr, c_null_ptr)

      if (cstatus == TRUE) then
        string = "Successfully saved: julia.png"//c_null_char
      else
        string = "Failed"//c_null_char
      end if

      message_id = gtk_statusbar_push (statusBar, gtk_statusbar_get_context_id(&
                         & statusBar, "Julia"//c_null_char), TRIM(string))
    end if
  end subroutine secondbutton

  ! GtkToggleButton signal emitted when the "Pause" button is clicked.
  ! This function is declared recursive because it will be pressed a first time
  ! to pause and a second time to end pause (from the "do while" loop):
  recursive subroutine firstToggle (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_long
    use global_widgets

    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int)                 :: message_id

    ! The button is pressed:
    if (gtk_toggle_button_get_active(widget) == TRUE) then
      ! Print messages:
      call gtk_text_buffer_insert_at_cursor (buffer, &
              & "In pause"//C_NEW_LINE//c_null_char, -1_c_int)
      message_id = gtk_statusbar_push (statusBar, gtk_statusbar_get_context_id(&
                                      &statusBar, "Julia"//c_null_char), &
                                      &"In pause..."//c_null_char)
      ! The Pause loop must handle events in order to avoid the blocking of
      ! the GUI:
      do while (gtk_toggle_button_get_active(widget) == TRUE)
        call pending_events
        if (run_status == FALSE) exit ! Exit if we had a destroy signal
        call g_usleep(50000_c_long)   ! In microseconds
      end do
    else  ! The button is raised:
      call gtk_text_buffer_insert_at_cursor (buffer, &
                            & "Not in pause"//C_NEW_LINE//c_null_char, -1_c_int)
      ! Remove the "In pause..." message from the status bar:
      call gtk_statusbar_pop (statusBar, gtk_statusbar_get_context_id(statusBar,&
                            & "Julia"//c_null_char))
    end if
  end subroutine firstToggle

  ! Callback function for the signal "activate" emitted by g_application_run().
  ! We use a subroutine because it should return void.
  ! The GUI is defined here.
  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_f_pointer, c_null_funptr
    use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, &
                      & gdk_pixbuf_get_rowstride, gdk_pixbuf_new
    use global_widgets
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr)    :: table, button1, button2, button3, box1
    type(c_ptr)    :: label1, label2, label3, label4
    type(c_ptr)    :: toggle1, expander, notebook, notebookLabel1, notebookLabel2
    type(c_ptr)    :: linkButton
    integer(c_int) :: message_id, firstTab, secondTab

    ! Create the window:
    my_window = gtk_application_window_new(app)
    call g_signal_connect(my_window, "destroy"//c_null_char, &
                        & c_funloc(destroy_signal))
   ! Don't forget that C strings must end with a null char:
    call gtk_window_set_title(my_window, "Julia Set"//c_null_char)
    ! Properties of the main window :
    width  = 700
    height = 700
    call gtk_window_set_default_size(my_window, width, height)

    !******************************************************************
    ! Adding widgets in the window:
    !******************************************************************
    ! The four buttons:
    button1 = gtk_button_new_with_mnemonic ("_Compute"//c_null_char)
    call g_signal_connect (button1, "clicked"//c_null_char, c_funloc(firstbutton))
    button2 = gtk_button_new_with_mnemonic ("_Save as PNG"//c_null_char)
    call g_signal_connect (button2, "clicked"//c_null_char, c_funloc(secondbutton))
    button3 = gtk_button_new_with_mnemonic ("_Exit"//c_null_char)
    call g_signal_connect (button3, "clicked"//c_null_char, c_funloc(destroy_signal))
    toggle1 = gtk_toggle_button_new_with_mnemonic ("_Pause"//c_null_char)
    call g_signal_connect (toggle1, "toggled"//c_null_char, c_funloc(firstToggle))

    ! The spin buttons to set the parameters:
    label1 = gtk_label_new("real(c)"//c_null_char)
    spinButton1 = gtk_spin_button_new (gtk_adjustment_new(-0.835d0,-2d0,+2d0,0.05d0,0.5d0,0d0),0.05d0, 7_c_int)
    label2 = gtk_label_new("imag(c) "//c_null_char)
    spinButton2 = gtk_spin_button_new (gtk_adjustment_new(-0.2321d0, -2d0,+2d0,0.05d0,0.5d0,0d0),0.05d0, 7_c_int)
    label3 = gtk_label_new("iterations"//c_null_char)
    spinButton3 = gtk_spin_button_new (gtk_adjustment_new(100000d0,1d0,+1000000d0,10d0,100d0,0d0),10d0, 0_c_int)

    ! The combo box with predifined values of interesting Julia sets:
    label4 = gtk_label_new("Predefined values:"//c_null_char)
    combo1 = gtk_combo_box_text_new()
    call gtk_combo_box_text_append_text(combo1, "1"//c_null_char)
    call gtk_combo_box_text_append_text(combo1, "2"//c_null_char)
    call gtk_combo_box_text_append_text(combo1, "3"//c_null_char)
    call gtk_combo_box_text_append_text(combo1, "4"//c_null_char)
    call gtk_combo_box_text_append_text(combo1, "5"//c_null_char)
    call gtk_combo_box_text_append_text(combo1, "6"//c_null_char)
    call gtk_combo_box_text_append_text(combo1, "7"//c_null_char)
    call g_signal_connect (combo1, "changed"//c_null_char, c_funloc(firstCombo))

    ! A clickable URL link:
    linkButton = gtk_link_button_new_with_label ( &
                          &"http://en.wikipedia.org/wiki/Julia_set"//c_null_char,&
                          &"More on Julia sets"//c_null_char)

    ! A table container will contain buttons and labels:
    table = gtk_grid_new ()
    call gtk_grid_set_column_homogeneous(table, TRUE)
    call gtk_grid_set_row_homogeneous(table, TRUE)
    call gtk_grid_attach(table, button1, 0_c_int, 3_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, button2, 1_c_int, 3_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, button3, 3_c_int, 3_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, label1, 0_c_int, 0_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, label2, 0_c_int, 1_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, label3, 0_c_int, 2_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, spinButton1, 1_c_int, 0_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, spinButton2, 1_c_int, 1_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, spinButton3, 1_c_int, 2_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, linkButton, 3_c_int, 0_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, label4, 2_c_int, 0_c_int, 1_c_int, 1_c_int)
    call gtk_grid_attach(table, combo1, 2_c_int, 1_c_int, 1_c_int,1_c_int)
    call gtk_grid_attach(table, toggle1, 2_c_int, 3_c_int, 1_c_int,1_c_int)

    ! The table is contained in an expander, which is contained in the vertical box:
    expander = gtk_expander_new_with_mnemonic ("_The parameters:"//c_null_char)
    call gtk_expander_set_child(expander, table)
    call gtk_expander_set_expanded(expander, TRUE)

    ! We create a vertical box container:
    box1 = gtk_box_new (GTK_ORIENTATION_VERTICAL, 10_c_int)
    call gtk_box_append(box1, expander)

    ! We need a widget where to draw our pixbuf.
    ! The drawing area is contained in the vertical box:
    pixwidth  = 500
    pixheight = 500
    my_drawing_area = gtk_drawing_area_new()
    call gtk_drawing_area_set_content_width(my_drawing_area, pixwidth)
    call gtk_drawing_area_set_content_height(my_drawing_area, pixheight)
    call gtk_drawing_area_set_draw_func(my_drawing_area, &
                     & c_funloc(my_draw_function), c_null_ptr, c_null_funptr)

    ! We define a notebook with two tabs "Graphics" and "Messages":
    notebook = gtk_notebook_new ()
    call gtk_widget_set_vexpand (notebook, TRUE)
    notebookLabel1 = gtk_label_new_with_mnemonic("_Graphics"//c_null_char)
    firstTab = gtk_notebook_append_page (notebook, my_drawing_area, notebookLabel1)

    textView = gtk_text_view_new ()
    buffer = gtk_text_view_get_buffer (textView)
    call gtk_text_buffer_set_text (buffer, "Julia Set"//C_NEW_LINE// &
        & "You can copy this text and even edit it !"//C_NEW_LINE//c_null_char,&
        & -1_c_int)
    scrolled_window = gtk_scrolled_window_new()
    notebookLabel2 = gtk_label_new_with_mnemonic("_Messages"//c_null_char)
    call gtk_scrolled_window_set_child(scrolled_window, textView)
    secondTab = gtk_notebook_append_page (notebook, scrolled_window, notebookLabel2)

    call gtk_box_append(box1, notebook)
    call gtk_widget_set_vexpand (box1, TRUE)

    ! The window status bar can be used to print messages:
    statusBar = gtk_statusbar_new ()
    message_id = gtk_statusbar_push (statusBar, gtk_statusbar_get_context_id(statusBar, &
                & "Julia"//c_null_char), "Waiting..."//c_null_char)
    call gtk_box_append(box1, statusBar)

    ! Let's finalize the GUI:
    call gtk_window_set_child(my_window, box1)
    call gtk_window_set_mnemonics_visible (my_window, TRUE)
    call gtk_widget_show(my_window)

    ! We create a "pixbuffer" to store the pixels of the image:
    my_pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8_c_int, pixwidth, pixheight)
    nch = gdk_pixbuf_get_n_channels(my_pixbuf)
    rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)
    call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf), pixel, [pixwidth*pixheight*nch])
    ! We use char() for "pixel" because we need unsigned integers.
    ! This pixbuffer has no Alpha channel (15% faster), only RGB.
    pixel = char(0)
    !******************************************************************

    ! If you don't show it, nothing will appear on screen...
    call gtk_widget_show(my_window)
  end subroutine activate

  !*********************************************
  ! Julia Set
  ! http://en.wikipedia.org/wiki/Julia_set
  ! The scientific computing is done here
  !*********************************************
  subroutine Julia_set(xmin, xmax, ymin, ymax, c, itermax)
    use, intrinsic :: iso_c_binding
    use global_widgets

    integer     :: i, j, k, p, itermax
    real(wp)    :: x, y, xmin, xmax, ymin, ymax ! coordinates in the complex plane
    complex(wp) :: c, z
    real(wp)    :: scx, scy       ! scales
    integer(int8)  :: red, green, blue     ! rgb color
    real(wp)    :: t0, t1

    computing = .true.
    call cpu_time(t0)

    scx = ((xmax - xmin) / pixwidth)   ! x scale
    scy = ((ymax - ymin) / pixheight)  ! y scale

    ! We compute the colour of each pixel (i,j):
    do i=0, pixwidth-1
      ! We provoke a draw event only once in a while to improve performances:
      if (mod(i,10) == 0) then
        call gtk_widget_queue_draw(my_drawing_area)
      end if

      x = xmin + scx * i
      do j=0, pixheight-1
        y = ymin + scy * j
        z = cmplx(x, y, kind=wp)   ! Starting point
        k = 1
        do while ((k <= itermax) .and. ((z%re**2 + z%im**2)<4.0_wp))
          z = z*z + c
          k = k + 1
        end do

        if (k>itermax) then
          ! Black pixel:
          red   = 0
          green = 0
          blue  = 0
        else
          ! Colour palette:
          red   = int(min(255, k*2),  int8)
          green = int(min(255, k*5),  int8)
          blue  = int(min(255, k*10), int8)
        end if

        ! We write in the pixbuffer:
        p = i * nch + j * rowstride + 1
        pixel(p)   = char(red)
        pixel(p+1) = char(green)
        pixel(p+2) = char(blue)

        ! This subroutine processes GTK events that occurs during the computation:
        call pending_events()
        if (run_status == FALSE) return ! Exit subroutine if we had a delete event.
      end do
    end do

    ! Final update of the display:
    call gtk_widget_queue_draw(my_drawing_area)

    computing = .false.

    call cpu_time(t1)
    write(string, '("System time = ",F8.3, " s")') t1-t0
    call gtk_text_buffer_insert_at_cursor (buffer, &
                                      & string//C_NEW_LINE//c_null_char, -1_c_int)
  end subroutine Julia_set

end module handlers

!*******************************************************************************
! In the main program, we declare the GTK application, connect it to its
! "activate" function where we will create the GUI,
! and finally call the GLib main loop.
!*******************************************************************************
program julia_pixbuf

  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
  ! We will use those GTK functions and values. The "only" statement can improve
  ! significantly the compilation time:
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers

  implicit none
  integer(c_int)     :: status
  type(c_ptr)        :: app

  ! First, let's create a GTK application (it will initialize GTK).
  ! The application ID must contain at least one point:
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-id-is-valid
  app = gtk_application_new("gtk-fortran.examples.julia_pixbuf"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  ! The activate signal will be sent by g_application_run().
  ! The c_funloc() function returns the C address of the callback function.
  ! The c_null_ptr means no data is transfered to the callback function.
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  ! Now, the whole application will be managed by GLib (=> main loop).
  ! Note that commandline arguments argc, argv are not passed.
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-run
  status = g_application_run(app, 0_c_int, [c_null_ptr])

  print *, "You have exited the GLib main loop, bye, bye..."

  ! Memory is freed:
  call g_object_unref(app)

end program julia_pixbuf

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 2020-06-02 (GTK 4 version)
!------------------------------------------------------------------------------

module handlers
!  use gth_hl
  use gtk_hl_container
  use gtk_hl_progress
  use gtk_hl_button
  use gtk, only: gtk_button_new, gtk_window_set_child, gtk_window_destroy, &
       & gtk_progress_bar_new, gtk_widget_show, gtk_window_new, &
       & gtk_init
  use g, only: g_usleep, g_main_context_iteration, g_main_context_pending

  implicit none
  type(c_ptr) :: win,bar,pbar,qbut, box
  integer(c_int) :: run_status = TRUE
  integer(c_int) :: boolresult

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value :: widget, gdata
    print *, "Exit called"
    run_status = FALSE
    call gtk_window_destroy(win)
  end subroutine my_destroy

  ! This function is needed to update the GUI during long computations.
  ! https://developer.gnome.org/glib/stable/glib-The-Main-Event-Loop.html
  subroutine pending_events ()
    do while(IAND(g_main_context_pending(c_null_ptr), run_status) /= FALSE)
      ! FALSE for non-blocking:
      boolresult = g_main_context_iteration(c_null_ptr, FALSE)
    end do
  end subroutine pending_events

end module handlers

program progress
  ! PROGRESS
  ! Examples of progress bars

  use handlers

  implicit none
  integer :: t0, t1, istep
  real(c_double) :: bval

  ! Initialize gtk & create a window for the heirarchy
  call gtk_init()
  win = hl_gtk_window_new("Progress"//c_null_char, destroy=c_funloc(my_destroy))

  ! Make a column box to contain our widgets and put it in the window
  box = hl_gtk_box_new()
  call gtk_window_set_child(win, box)

  ! Make 2 horizontal progress bars and put them in the box
  bar = hl_gtk_progress_bar_new()
  call hl_gtk_box_pack(box, bar)
  pbar = hl_gtk_progress_bar_new(step=0.05_c_double)
  call hl_gtk_box_pack(box, pbar)

  ! Make a quit button and put that in the box.
  qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
  call hl_gtk_box_pack(box, qbut)

  ! Display the window
  call gtk_widget_show(win)

  ! Get the epoch in milliseconds and start a counter
  call system_clock(t0)
  istep = 0

  ! event loop
  do
     call pending_events()
     if (run_status == FALSE) exit
     call g_usleep(10000_c_long) ! So we don't burn CPU cycles
     istep = istep+1
     call system_clock(t1)
     bval = real(t1-t0,c_double)/10000.
     if (bval > 1._c_double) exit
     call hl_gtk_progress_bar_set(bar, bval, string=TRUE)
     if (mod(istep, 20) == 0) &
          & call hl_gtk_progress_bar_set(pbar, text="Working"//c_null_char)
     ! There's an issue with string arguments in overloaded procedures
  end do

  print *, "Bye..."
end program progress

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2013 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Last modification: vmagnin 2023-03-14

program g_io_demo

  ! This is a very basic demo to get started with GIO. It uses Fortran I/O to
  ! read text from the keyboard & writes it to the file gio_demo.dat in the
  ! current directory.

  use, intrinsic :: iso_c_binding
  use gtk_sup

  !********************************
  ! Gtk modules for gio_demo.f90
  use g, only: g_file_new_for_path, g_file_replace, g_object_unref, &
       & g_output_stream_close, g_output_stream_write

  use gtk, only: FALSE, G_FILE_CREATE_NONE


  character(len=80) :: str
  integer(c_int8_t), dimension(80), target :: istr

  type(c_ptr) :: file, stream
  type(gerror), target :: errmsg
  character(len=120) :: errtxt
  integer(4) :: ios, i
  integer(c_size_t) :: ncput, nchars
  integer(c_int) :: iok

  file = g_file_new_for_path('gio_demo.dat'//c_null_char)

  ! Use g_file_replace here so that it won't crash if the file exists.
  stream = g_file_replace(file, c_null_char, FALSE, G_FILE_CREATE_NONE, &
       & c_null_ptr, c_loc(errmsg))

  if (.not. c_associated(stream)) then
     call c_f_string(errmsg%message, errtxt)
     print *, errtxt
     stop
  end if

  do
     write(*, "(a)", advance='no') "Text> "
     read(*, "(a)", iostat=ios) str
     if (ios /= 0) exit

     nchars = len_trim(str)
     do i = 1, int(nchars, kind=4)
        istr(i) = int(ichar(str(i:i)), kind=c_int8_t)
     end do
     istr(nchars+1) = ichar(c_new_line)

     ncput = g_output_stream_write(stream, c_loc(istr), &
          & nchars+1, c_null_ptr, c_loc(errmsg))
     if (ncput < 0_c_size_t) then
        call c_f_string(errmsg%message, errtxt)
        print *, errtxt
        stop
     end if
  end do

  iok = g_output_stream_close(stream, c_null_ptr, c_loc(errmsg))
  call g_object_unref(stream)
  if (.not. c_f_logical(iok)) then
     call c_f_string(errmsg%message, errtxt)
     print *, errtxt
     stop
  end if

  call g_object_unref(file)
  print *
end program g_io_demo

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! This program is used to test various GTK widgets and functions
! Contributors: Vincent Magnin, James Tappin
! GTK 4 version: vmagnin 2020-05-28, 2024-03-26
!------------------------------------------------------------------------------

module various_functions
  use, intrinsic :: iso_c_binding
  use gtk_sup, only: c_f_string_copy_alloc
  implicit none

  contains

  subroutine some_glib_functions()
    use g, only: g_get_user_name, g_get_application_name, g_get_host_name, &
               & g_get_home_dir, g_get_current_dir, g_format_size, &
               & g_get_os_info

    ! Automatic reallocation is used for that string:
    character(:), allocatable :: my_string
    type(c_ptr) :: ret

    call c_f_string_copy_alloc(g_get_user_name(), my_string)
    print *, "Hello ", my_string

    call c_f_string_copy_alloc(g_get_host_name(), my_string)
    print *, "Host name: ", my_string

    call c_f_string_copy_alloc(g_get_application_name(), my_string)
    print *, "Application name: ", my_string

    call c_f_string_copy_alloc(g_get_home_dir(), my_string)
    print *, "Home dir: ", my_string

    call c_f_string_copy_alloc(g_get_current_dir(), my_string)
    print *, "Current dir: ", my_string
    if (my_string(1:1) == "/") then
        print *, "UNIX OS"
    else
        print *, "Not UNIX OS"
    endif

    ! That function may return NULL with some OS:
    ret = g_get_os_info("PRETTY_NAME"//c_null_char)
    if (c_associated(ret)) then
      call c_f_string_copy_alloc(ret, my_string)
    else
      my_string = "?"
    end if
    print *, "Your OS: ", my_string

    call c_f_string_copy_alloc(g_format_size (123456789_c_int64_t), my_string)
    print *, "g_format_size: ", my_string
  end subroutine some_glib_functions
end module various_functions


module my_widgets
  use, intrinsic :: iso_c_binding

  implicit none
  type(c_ptr) :: window
  type(c_ptr) :: box1, table
  type(c_ptr) :: button1, button2, button3, button4, label1
  type(c_ptr) :: entry1
  type(c_ptr) :: progress
  type(c_ptr) :: view, buffer, scrolled_window
  type(c_ptr) :: my_drawing_area, my_pixbuf
  type(c_ptr) :: dialog
  type(c_ptr) :: media
end module


module handlers
  use gtk, only: gtk_about_dialog_new, gtk_about_dialog_set_authors, &
  & gtk_about_dialog_set_comments, &
  & gtk_about_dialog_set_license_type, GTK_LICENSE_GPL_3_0, &
  & gtk_about_dialog_set_program_name, gtk_application_window_new, &
  & gtk_about_dialog_set_website, gtk_window_set_transient_for, &
  & gtk_button_new, gtk_button_new_with_label, &
  & gtk_window_set_child, gtk_scrolled_window_set_child, &
  & gtk_drawing_area_new, gtk_drawing_area_set_draw_func, &
  & gtk_entry_get_buffer, gtk_entry_buffer_get_text, gtk_entry_new, &
  & gtk_label_new, &
  & gtk_progress_bar_new, gtk_progress_bar_pulse, &
  & gtk_progress_bar_set_fraction, gtk_progress_bar_set_text, &
  & gtk_scrolled_window_new,&
  & gtk_grid_attach, gtk_grid_new, gtk_text_buffer_set_text,&
  & gtk_text_view_get_buffer, gtk_text_view_new, gtk_window_destroy, &
  & gtk_widget_show, gtk_window_set_title, &
  & g_signal_connect, g_signal_connect_swapped, &
  & FALSE, TRUE, GDK_COLORSPACE_RGB, GDK_COLORSPACE_RGB,&
  & gtk_grid_set_row_homogeneous, &
  & gtk_grid_set_column_homogeneous, &
  & gtk_widget_set_margin_start, gtk_widget_set_margin_end, &
  & gtk_widget_set_margin_top, gtk_widget_set_margin_bottom, &
  & gtk_get_major_version, gtk_get_minor_version, gtk_get_micro_version, &
  & gtk_widget_set_name, gtk_css_provider_new, gtk_widget_get_display, &
  & gtk_css_provider_load_from_data, gtk_style_context_add_provider_for_display

  use g, only: g_object_unref

  use cairo, only: cairo_create, cairo_curve_to, cairo_destroy, cairo_line_to, &
  & cairo_move_to, cairo_paint, cairo_set_line_width, cairo_set_source, &
  & cairo_set_source_rgb, cairo_stroke

  use gdk, only: gdk_cairo_set_source_pixbuf

  use gdk_pixbuf, only: gdk_pixbuf_get_has_alpha, gdk_pixbuf_get_n_channels, &
  & gdk_pixbuf_get_pixels, gdk_pixbuf_get_rowstride, gdk_pixbuf_new

  use my_widgets

  implicit none

contains
  !*************************************
  ! User defined event handlers go here
  !*************************************

  ! Callback function for the signal "activate" emitted by g_application_run().
  ! We use a subroutine because it should return void.
  ! The GUI is defined here.
  subroutine activate(app, gdata) bind(c)
    use various_functions, only: some_glib_functions

    type(c_ptr), value, intent(in)  :: app, gdata
    type(c_ptr) :: css_provider, gdk_display

    ! Create the window:
    window = gtk_application_window_new(app)
    ! Don't forget that C strings must end with a null char:
    call gtk_window_set_title(window, "A great bazaar to test widgets..."//&
                                     & c_null_char)

    print '(A4,I0,A1,I0,A1,I0)', "GTK ", gtk_get_major_version(),".", &
         & gtk_get_minor_version(), ".", gtk_get_micro_version()
    call some_glib_functions()

    !******************************************************************
    ! Adding widgets in the window:
    !******************************************************************
    table = gtk_grid_new ()
    call gtk_grid_set_column_homogeneous(table, TRUE)
    call gtk_grid_set_row_homogeneous(table, TRUE)
    ! Set the border width around the container:
    call gtk_widget_set_margin_start (table, 10_c_int)
    call gtk_widget_set_margin_end (table, 10_c_int)
    call gtk_widget_set_margin_top (table, 10_c_int)
    call gtk_widget_set_margin_bottom (table, 10_c_int)
    call gtk_window_set_child(window, table)

    button1 = gtk_button_new_with_label ("Button1"//c_null_char)
    call gtk_grid_attach(table, button1, 0_c_int, 0_c_int, 1_c_int, 1_c_int)
    call g_signal_connect (button1, "clicked"//c_null_char, c_funloc(firstbutton))

    button2 = gtk_button_new_with_label ("Button2"//c_null_char)
    call gtk_grid_attach(table, button2, 1_c_int, 0_c_int, 1_c_int, 1_c_int)
    call g_signal_connect (button2, "clicked"//c_null_char, c_funloc(secondbutton))

    button3 = gtk_button_new_with_label ("Exit"//c_null_char)
    call gtk_grid_attach(table, button3, 2_c_int, 0_c_int, 1_c_int, 1_c_int)
    call g_signal_connect (button3, "clicked"//c_null_char, c_funloc(destroy))

    button4 = gtk_button_new_with_label ("About"//c_null_char)
    call gtk_grid_attach(table, button4, 3_c_int, 0_c_int, 1_c_int, 1_c_int)
    call g_signal_connect (button4, "clicked"//c_null_char, c_funloc(aboutbutton))

    label1 = gtk_label_new("My label"//c_null_char)
    call gtk_grid_attach(table, label1, 0_c_int, 1_c_int, 1_c_int, 1_c_int)

    entry1 = gtk_entry_new()
    call gtk_grid_attach(table, entry1, 1_c_int, 1_c_int, 1_c_int, 1_c_int)

    progress = gtk_progress_bar_new()
    call gtk_progress_bar_set_fraction (progress, 0.15d0)
    call gtk_progress_bar_set_text (progress, "My progress bar"//c_null_char)
    call gtk_grid_attach(table, progress, 1_c_int, 2_c_int, 3_c_int, 1_c_int)

    ! https://docs.gtk.org/gtk4/ctor.TextView.new.html
    view = gtk_text_view_new()
    buffer = gtk_text_view_get_buffer(view)
    call gtk_text_buffer_set_text(buffer, &
        & "This is just a great bazaar where I can test widgets."//c_new_line//&
        & "Click on Button1 to hear a little melody"//c_new_line//&
        & "composed with the ForSynth Fortran project:"//c_new_line//&
        & "https://github.com/vmagnin/forsynth"//c_new_line//c_new_line//&
        & "You can edit this text. And it is scrollable."//c_null_char, -1_c_int)

    ! Let's change the background color and the font of the TextView:
    call gtk_widget_set_name (view, "my_TextView"//c_null_char)
    css_provider = gtk_css_provider_new()
    gdk_display = gtk_widget_get_display(window)
    call gtk_css_provider_load_from_data(css_provider, &
        & "textview#my_TextView {background-color: Ivory;font-family: monospace;font-size:14px;}", -1_c_size_t)
    call gtk_style_context_add_provider_for_display(gdk_display, css_provider, 800_c_int)

    scrolled_window = gtk_scrolled_window_new()
    call gtk_scrolled_window_set_child(scrolled_window, view)
    call gtk_grid_attach(table, scrolled_window, 0_c_int, 3_c_int, 3_c_int, 3_c_int)

    my_drawing_area = gtk_drawing_area_new()
    ! https://docs.gtk.org/gtk4/method.DrawingArea.set_draw_func.html
    call gtk_drawing_area_set_draw_func(my_drawing_area, &
                     & c_funloc(my_draw_function), c_null_ptr, c_null_funptr)
    call gtk_grid_attach(table, my_drawing_area, 0_c_int, 6_c_int, 3_c_int, 6_c_int)

    call gtk_widget_show(window)
  end subroutine activate

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  subroutine my_draw_function(widget, my_cairo_context, width, height, gdata) bind(c)
    use, intrinsic :: iso_fortran_env, only: wp=>real64

    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height
    type(c_ptr) :: my_pixbuf
    character(kind=c_char), dimension(:), pointer :: pixel
    integer(c_int) :: i, nch, rowstride
    integer :: j
    integer :: x, y

    print *, "my_draw_function()"

    ! A black horizontal line:
    call cairo_set_source_rgb(my_cairo_context, 0d0, 0d0, 0d0)
    call cairo_set_line_width(my_cairo_context, 1d0)
    call cairo_move_to(my_cairo_context, 100d0, 20d0)
    call cairo_line_to(my_cairo_context, 300d0, 20d0)
    call cairo_stroke(my_cairo_context)
    ! A red diagonal line:
    call cairo_set_source_rgb(my_cairo_context, 1d0, 0d0, 0d0)
    call cairo_set_line_width(my_cairo_context, 0.5d0)
    call cairo_move_to(my_cairo_context, 50d0, 0d0)
    call cairo_line_to(my_cairo_context, 150d0, 100d0)
    call cairo_stroke(my_cairo_context)

    !*************
    ! Pixbuffers :
    !*************
    my_pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE, 8_c_int, width, height)
    nch = gdk_pixbuf_get_n_channels(my_pixbuf)
    rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)
    print *, rowstride, nch, gdk_pixbuf_get_has_alpha(my_pixbuf)
    call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf), pixel, [width*height*nch])

    ! pixel is an array with 4 bytes per pixel (RGBA)
    ! We use chars because we need unsigned integers
    do i=1, width*height*nch, nch
      pixel(i)   = char(0)    ! Red
      pixel(i+1) = char(0)    ! Green
      pixel(i+2) = char(255)  ! Blue
      pixel(i+3) = char(100)  ! Opacity (Alpha channel)
    end do

    ! (0,0) is the top left corner
    ! 0<=x<width, 0<=y<height

    ! Green sinus:
    do j=0, width-1
      x = j
      y = height/2 + int(50 * sin(j/10.0_wp))
      i = x * nch + y * rowstride + 1
      pixel(i)   = char(0)    ! Red
      pixel(i+1) = char(255)  ! Green
      pixel(i+2) = char(0)    ! Blue
      pixel(i+3) = char(255)  ! Opacity (Alpha channel)
    end do

    ! We redraw the pixbuf:
    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 20d0, 0d0)

    ! Another Cairo element (will also appear below the pixbuf):
    ! A red cubic Bézier spline:
    ! https://cairographics.org/manual/cairo-Paths.html#cairo-curve-to
    call cairo_set_line_width(my_cairo_context, 3d0)
    call cairo_move_to(my_cairo_context, 360d0, 20d0)
    call cairo_curve_to(my_cairo_context, 60d0, 50d0, 135d0, 45d0, 400d0, 150d0)
    call cairo_stroke(my_cairo_context)

    call cairo_paint(my_cairo_context)
  end subroutine my_draw_function

  ! GtkObject signal:
  subroutine destroy (widget, gdata) bind(c)
    use gtk_sup, only: c_f_string_copy_alloc

    type(c_ptr), value, intent(in) :: widget, gdata
    type(c_ptr) :: buffer
    character(:), allocatable :: my_string

    print *, "my destroy"

    buffer = gtk_entry_get_buffer(entry1)
    call c_f_string_copy_alloc(gtk_entry_buffer_get_text(buffer), my_string)
    print *, "Entry box: ", my_string

    ! This is the end of the program:
    call gtk_window_destroy(window)
  end subroutine destroy

  ! Callback function for the signal "notify::ended" emitted by the media stream.
  ! We use a subroutine because it should return void.
  subroutine sound_ended(object, gdata) bind(c)
    type(c_ptr), value, intent(in) :: object, gdata
    ! Free the media pointer both on C and Fortran sides:
    call g_object_unref(object)
    media = c_null_ptr
  end subroutine

  ! GtkButton signal:
  subroutine firstbutton (widget, gdata) bind(c)
    use gtk, only: gtk_media_file_new_for_filename, gtk_media_stream_set_volume, gtk_media_stream_play, &
                 & gtk_media_stream_get_playing
    type(c_ptr), value, intent(in) :: widget, gdata

    print *, "Is there anybody in there? Just nod if you can hear me"

    if (.not.c_associated(media)) then
      ! It plays a little melody
      ! https://docs.gtk.org/gtk4/class.MediaFile.html
      media = gtk_media_file_new_for_filename("demo_sound.ogg"//c_null_char)
      call gtk_media_stream_set_volume(media, 1.0_c_double)
      call gtk_media_stream_play(media)
      call g_signal_connect(media, "notify::ended"//c_null_char, c_funloc(sound_ended), c_null_ptr)

      if (gtk_media_stream_get_playing(media) == FALSE) print *, "ERROR: have you installed the libgtk-4-media-gstreamer backend?"
    else
      print *, "Be patient, the music is not yet ended!"
    end if
  end subroutine firstbutton

  ! GtkButton signal:
  subroutine secondbutton (widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call gtk_progress_bar_pulse (progress)
  end subroutine secondbutton

  ! GtkButton signal:
  subroutine aboutbutton (widget, gdata) bind(c)
    use gtk_sup, only: f_c_string

    type(c_ptr), value, intent(in) :: widget, gdata
    ! Authors of bazaar.f90 (list returned by git blame bazaar.f90):
    character(len=14, kind=c_char), dimension(2), parameter :: authors = &
                                          & ["Vincent MAGNIN", "James TAPPIN  "]
    character(kind=c_char), dimension(:), allocatable :: string
    character(kind=c_char), pointer, dimension(:) :: credit
    type(c_ptr), dimension(:), allocatable :: c_ptr_array
    integer :: i

    dialog = gtk_about_dialog_new()
    ! https://docs.gtk.org/gtk4/method.Window.set_transient_for.html
    call gtk_window_set_transient_for(dialog, window)
    call gtk_about_dialog_set_program_name(dialog, "The gtk-fortran bazaar"//c_null_char)
    call gtk_about_dialog_set_license_type(dialog, GTK_LICENSE_GPL_3_0)
    call gtk_about_dialog_set_comments(dialog, "The gtk-fortran project &
    & aims to offer scientists programming in Fortran a cross-platform library &
    &to build Graphical User Interfaces (GUI)."//c_new_line//" Gtk-fortran&
    & is a partial GTK / Fortran binding 100% written in Fortran, thanks&
    & to the ISO_C_BINDING module for interoperability between C and Fortran,&
    & which is a part of the Fortran 2003 standard."//c_new_line//" GTK &
    &is a free software cross-platform graphical library available for &
    &Linux, UNIX, Windows and MacOs."//c_null_char)
    call gtk_about_dialog_set_website(dialog, &
                  & "https://github.com/vmagnin/gtk-fortran/wiki"//c_null_char)

    ! To add authors we need a pointer toward a null terminated array of strings.
    ! This code comes from src/gtk-hl-dialog.f90:
    allocate(c_ptr_array(size(authors)+1))

    do i = 1, size(authors)
      call f_c_string(authors(i), string)
      allocate(credit(size(string)))
      ! A Fortran pointer toward the Fortran string:
      credit(:) = string(:)
      ! Store the C address in the array:
      c_ptr_array(i) = c_loc(credit(1))
      nullify(credit)
    end do
    ! The array must be null terminated:
    c_ptr_array(size(authors)+1) = c_null_ptr
    ! https://docs.gtk.org/gtk4/method.AboutDialog.set_authors.html
    call gtk_about_dialog_set_authors(dialog, c_ptr_array)
    deallocate(c_ptr_array)

    call gtk_widget_show(dialog)
  end subroutine aboutbutton
end module handlers

!*******************************************************************************
! In the main program, we declare the GTK application, connect it to its
! "activate" function which will create the GUI,
! and finally call the GLib main loop.
!*******************************************************************************
program bazaar
  use, intrinsic :: iso_c_binding
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE, g_signal_connect
  use g, only: g_application_run, g_object_unref
  use handlers, only: activate

  implicit none
  integer(c_int) :: status
  type(c_ptr)    :: app

  app = gtk_application_new("gtk-fortran.examples.bazaar"//c_null_char, &
                          & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program bazaar

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin
! Last modification: 2012-08-30, vmagnin 2020-06-11 (GTK 4)

!*
! Infobar
module gtk_hl_infobar
  ! Convenience interface for the GtkInfoBar widget.
  ! This is created because the routine for adding multiple buttons is
  ! variadic, and setting the message involves several levels of indirection.
  !/

  use, intrinsic :: iso_c_binding
  use gtk_sup
  use g, only: g_object_set_data, g_object_get_data
  use gtk, only: gtk_info_bar_add_child, gtk_info_bar_add_button, &
       & gtk_info_bar_new, gtk_info_bar_get_revealed, &
       & gtk_info_bar_set_revealed, &
       & gtk_info_bar_set_default_response, gtk_info_bar_set_message_type, &
       & gtk_info_bar_set_response_sensitive, gtk_label_new, &
       & gtk_label_set_text, &
       & gtk_widget_show, gtk_widget_hide, g_signal_connect, TRUE, FALSE

  implicit none

contains
  !+
  function hl_gtk_info_bar_new(buttons, ids, response, data_response, close, &
       & data_close, auto_show, type, default, horizontal, buttons_below) &
       & result(infobar)
    type(c_ptr) :: infobar
    character(len=*,kind=c_char), dimension(:), intent(in), optional :: buttons
    integer(c_int), dimension(:), intent(in), optional :: ids
    type(c_funptr), optional :: response, close
    type(c_ptr), intent(in), optional :: data_response, data_close
    integer(c_int), intent(in), optional :: auto_show, type, default
    integer(c_int), intent(in), optional :: horizontal, buttons_below

    ! Create a new info bar.
    !
    ! BUTTONS |  f_string() |  optional |  The buttons to add to the
    ! IDS |  c_int() |  optional |  The response IDs for the buttons. If buttons are specified and no IDS are given, then the button index is used.
    ! RESPONSE |  c_funptr |  optional |  The handler for a button pressed (has an extra argument which is the button ID.
    ! DATA_RESPONSE |  c_ptr |  optional |  User data to pass to the response handler.
    ! CLOSE |  c_funptr |  optional |  The handler for closing the bar by a key action.
    ! DATA_CLOSE |  c_ptr |  optional |  User data to pass to the close handler.
    ! AUTO_SHOW |  boolean |  optional |  Whether the info bar should be displayed when its parent is shown. Default=FALSE.
    ! TYPE |  c_int |  optional |  The initial message type.
    ! DEFAULT |  c_int |  optional |  Set the initial default response ID.
    ! HORIZONTAL | boolean |  optional | Set to TRUE to lay the buttons in a row rather than a column. **Removed from GTK 4.**
    ! BUTTONS_BELOW |  boolean |  optional |  Set to TRUE to place the buttons below the message rather than to the right.
    !-

    integer(c_int) :: i, id
    integer(c_int) :: no_auto
    type(c_ptr) :: label, junk

    infobar = gtk_info_bar_new()

    label = gtk_label_new (c_null_char)
    call gtk_info_bar_add_child (infobar, label)
    ! To keep track of the label inside the infobar object:
    call g_object_set_data (infobar, "info_label"//c_null_char, label)
    call gtk_widget_show (label)

    if (present(horizontal)) then
       print *, "Removed from GTK 4: GtkOrientable in GtkInfoBar"
    end if

    if (present(buttons_below)) then
       if (c_f_logical(buttons_below)) then
         print *, "Removed from GTK 4: GtkOrientable in GtkInfoBar"
       else
         print *, "Removed from GTK 4: GtkOrientable in GtkInfoBar"
       end if
    end if

    if (present(buttons)) then
       do i = 1, size(buttons)
          if (present(ids)) then
             id = ids(i)
          else
             id = i-1
          end if
          junk = gtk_info_bar_add_button(infobar, &
               & trim(buttons(i))//c_null_char, id)
       end do
    end if

    if (present(response)) then
       if (present(data_response)) then
          call g_signal_connect(infobar, "response"//c_null_char, &
               & response, data_response)
       else
          call g_signal_connect(infobar, "response"//c_null_char, &
               & response)
       end if
    end if
    if (present(close)) then
       if (present(data_close)) then
          call g_signal_connect(infobar, "close"//c_null_char, &
               & close, data_close)
       else
          call g_signal_connect(infobar, "close"//c_null_char, &
               & close)
       end if
    end if

    if (present(auto_show)) then
       no_auto = f_c_logical(auto_show /= FALSE)
    else
       no_auto = TRUE
    end if
    call gtk_info_bar_set_revealed(infobar, no_auto)
    if (no_auto == TRUE) call gtk_widget_hide(infobar)

    if (present(type)) &
         & call gtk_info_bar_set_message_type(infobar,type)
    if (present(default)) &
         & call gtk_info_bar_set_default_response(infobar, default)

  end function hl_gtk_info_bar_new

  !+
  subroutine hl_gtk_info_bar_message(infobar, message, type, default, &
       & ids, state)
    type(c_ptr), intent(in) :: infobar
    character(kind=c_char), dimension(*), intent(in) :: message
    integer(c_int), intent(in), optional :: type, default
    integer(c_int), intent(in), optional, dimension(:) :: ids, state

    ! Show a message in an infobar
    !
    ! INFOBAR |  c_ptr |  required |  The infobar to update.
    ! MESSAGE |  c_str |  required |  The message to display.
    ! TYPE |  c_int |  optional |  The severity level of the message.
    ! DEFAULT |  c_int |  optional |  Set the default response ID.
    ! IDS |  c_int() |  optional |  Response IDs whose sensitivity will be set.
    ! STATE |  boolean() |  optional |  Sensitivity states of the IDS.
    !
    ! To set buttons to be sensitive or not, you must give BOTH ids
    ! and state, and they must be the same length.
    !-

    type(c_ptr) :: label
    integer :: i

    ! We retrieve the label we have named "info_label" inside the infobar:
    label = g_object_get_data (infobar, "info_label"//c_null_char)
    call gtk_label_set_text(label, message)

    if (present(type)) &
         & call gtk_info_bar_set_message_type(infobar,type)
    if (present(default)) &
         & call gtk_info_bar_set_default_response(infobar, default)

    if (present(ids) .and. present(state)) then
       do i = 1, min(size(ids),size(state))
          call gtk_info_bar_set_response_sensitive (infobar, ids(i), &
               & state(i))
       end do
    end if

    if (c_f_logical(gtk_info_bar_get_revealed(infobar))) &
         & call gtk_widget_show(infobar)

  end subroutine hl_gtk_info_bar_message

end module gtk_hl_infobar

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin
! Last modifications: 2012-12-31, vmagnin 2020-06-19 (GTK 4 version),
!                     2023-08-07
!------------------------------------------------------------------------------

!*
! File Choosers
module gtk_hl_chooser
  ! hl_gtk_file_chooser_new and _show implement a general chooser
  ! dialogue via the file_chooser_widget (file_choose_dialog only has
  ! variadic constructors).
  !
  ! Filters may be either patterns (e.g. '*.f90' or '2011*.lis') or mime types
  ! (e.g. 'image/png' or 'text/*'). The constructors recognise the difference by
  ! the presence or absence of a '/' character. Each filter is a
  ! comma-separated list, which may contain any mixture of patterns and mime
  ! types (e.g. '*.png,image/tiff,*.jpg'). If a name is not provided, then
  ! the filter specification is used as the name.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only: error_unit

  ! Auto generated use's
  use g, only: g_list_model_get_n_items, g_list_model_get_item, &
             & g_main_loop_new, g_main_loop_run, g_main_loop_quit, &
             & g_file_new_for_path, g_file_get_path, g_object_unref
  use gtk, only: gtk_box_append, gtk_dialog_add_button, &
       & gtk_dialog_get_content_area, gtk_dialog_new, &
       & gtk_entry_get_buffer, gtk_entry_buffer_set_text, &
       & gtk_file_chooser_add_filter, &
       & gtk_file_chooser_get_current_folder, &
       & gtk_file_chooser_set_current_folder, &
       & gtk_file_chooser_set_current_name, gtk_file_chooser_set_file, &
       & gtk_file_chooser_set_select_multiple, &
       & gtk_file_chooser_widget_new, gtk_file_chooser_get_files, &
       & gtk_file_filter_add_mime_type, gtk_file_filter_add_pattern, &
       & gtk_file_filter_new, gtk_file_filter_set_name, &
       & gtk_window_destroy, gtk_widget_show, gtk_window_close, &
       & gtk_window_set_default_size, gtk_window_set_destroy_with_parent, &
       & gtk_window_set_modal, gtk_window_set_title, &
       & gtk_window_set_transient_for, g_signal_connect, TRUE, FALSE, &
       & GTK_RESPONSE_DELETE_EVENT, GTK_RESPONSE_CANCEL, GTK_RESPONSE_APPLY, &
       & GTK_FILE_CHOOSER_ACTION_OPEN, GTK_FILE_CHOOSER_ACTION_SAVE, &
       & GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER

  ! Building the chooser uses a number of other high-level interfaces.

  use gtk_hl_container
  use gtk_hl_entry
  use gtk_hl_button

  implicit none
  type(c_ptr) :: dialog_gmainloop
  !+
  type, bind(c) :: hl_gtk_chooser_info
     type(c_ptr) :: chooser=C_NULL_PTR, chooser_sel_list=C_NULL_PTR
     type(c_ptr) :: chooser_curdir=C_NULL_PTR, fentry=C_NULL_PTR
     integer(c_int) :: iselect=0
  end type hl_gtk_chooser_info

  ! These items must be shared between the file chooser widget and its event
  ! handler or the filter editor. They are passed to the signal handlers
  ! via the user data argument. Even though it's never used in the C code,
  ! it still has to be bind(c) otherwise c_loc() will croak on it.
  !-

contains
  !+
  function hl_gtk_file_chooser_new(chooser_info, cdir, directory, create, &
       & multiple, allow_uri, show_hidden, confirm_overwrite, title, &
       & initial_dir, current, initial_file, filter, filter_name, parent, &
       & all, wsize, edit_filters) result(dialog)

    type(c_ptr) :: dialog
    type(hl_gtk_chooser_info), intent(out), target :: chooser_info
    character(len=*), intent(out), optional :: cdir
    integer(c_int), intent(in), optional :: directory, create, multiple
    integer(c_int), intent(in), optional :: allow_uri, show_hidden
    integer(c_int), intent(in), optional :: confirm_overwrite
    character(kind=c_char), dimension(*), intent(in), optional :: title, initial_dir, initial_file
    integer(c_int), intent(in), optional :: current
    character(len=*), dimension(:), intent(in), optional :: filter
    character(len=*), dimension(:), intent(in), optional :: filter_name
    type(c_ptr), intent(in), optional :: parent
    integer(c_int), intent(in), optional :: all
    integer(c_int), intent(in), dimension(2), optional :: wsize
    integer(c_int), intent(in), optional :: edit_filters

    ! Create a file chooser widget.
    !
    ! CHOOSER_INFO |  hl_gtk_chooser_info |  required |  IDs and flags of various subwidgets needed to process the dialog actions.
    ! CDIR |  string |  optional |  The directory from which they were chosen.
    ! DIRECTORY |  boolean |  optional |  Set to TRUE to select directories instead of files.
    ! CREATE |  boolean |  optional |  Set to FALSE to prohibit creating new files.
    ! MULTIPLE |  boolean |  optional |  Set to TRUE to allow the selection of multiple files.
    ! ALLOW_URI | boolean |  optional | Set to TRUE to allow nonlocal selections. **Removed from GTK 4.**
    ! SHOW_HIDDEN | boolean |  optional | Set to TRUE to show hidden files. **Removed from GTK 4.**
    ! CONFIRM_OVERWRITE | boolean |  optional | Set to TRUE to request confirmation of an overwrite (only used if CREATE is TRUE). **Removed from GTK 4.**
    ! TITLE |  string |  optional |  Title for the window.
    ! INITIAL_DIR |  string |  optional |  Set the initial directory here instead of the current directory.
    ! CURRENT |  boolean |  optional |  Use to force start in current directory.
    ! INITIAL_FILE |  string |  optional |  Set the initial file selection.
    ! FILTER |  string() |  optional |   The file selection filter. Elements may either be patterns or mime types. Each filter is a comma-separated list of patterns
    ! FILTER_NAME |  string() |  optional |  Names for the filters
    ! PARENT |  c_ptr |  optional |  Parent window for the dialogue.
    ! ALL |  boolean |  optional |  Set to TRUE to add an all-files filter pattern
    ! WSIZE |  c_int(2) |  optional |  Set the size for the dialog.
    ! EDIT_FILTERS | boolean |  optional | Set to TRUE to proves an entry window to add extra filters. **Removed from GTK 4.**
    !-

    type(c_ptr) :: content, junk, gfilter
    integer(c_int) :: icreate, idir, action, lval
    integer(c_int) :: i, idx0, idx1

    ! Create a modal dialogue
    dialog = gtk_dialog_new()
    call gtk_window_set_modal(dialog, TRUE)
    if (present(title)) call gtk_window_set_title(dialog, title)
    if (present(wsize)) then
       call gtk_window_set_default_size(dialog, wsize(1),&
            & wsize(2))
    else
       call gtk_window_set_default_size(dialog, 700_c_int, 500_c_int)
    end if

    if (present(parent)) then
       call gtk_window_set_transient_for(dialog, parent)
       call gtk_window_set_destroy_with_parent(dialog, TRUE)
    end if

    ! Attach the action buttonsa to the dialogue
    junk = gtk_dialog_add_button(dialog, "_Open"//C_NULL_CHAR, GTK_RESPONSE_APPLY)
    junk = gtk_dialog_add_button(dialog, "_Cancel"//C_NULL_CHAR, &
         & GTK_RESPONSE_CANCEL)

    ! Decode the action

    if (present(create)) then
       icreate = create
    else
       icreate = TRUE
    end if

    if (present(directory)) then
       idir = directory
    else
       idir = FALSE
    end if

    if (idir == TRUE) then
       action = GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER
    else
       if (icreate == TRUE) then
          ! "Indicates save mode. The file chooser will let the user pick
          ! an existing file, or type in a new filename."
          action = GTK_FILE_CHOOSER_ACTION_SAVE
       else
          action = GTK_FILE_CHOOSER_ACTION_OPEN
       end if
    end if

    ! Create the chooser & put it in the content area
    content = gtk_dialog_get_content_area(dialog)
    ! https://developer.gnome.org/gtk4/unstable/GtkFileChooserWidget.html
    chooser_info%chooser = gtk_file_chooser_widget_new(action)
    call gtk_box_append(content, chooser_info%chooser)

    ! Multiple selections
    if (present(multiple)) then
       lval = multiple
    else
       lval = FALSE
    end if
    call gtk_file_chooser_set_select_multiple(chooser_info%chooser, lval)

    ! Hidden files
    if (present(show_hidden)) then
       print *, "Removed from GTK 4: show_hidden"
       lval = show_hidden
    else
       lval = FALSE
    end if

    ! Confirm overwrite
    if (icreate == TRUE) then
       if (present(confirm_overwrite)) then
          print *, "Removed from GTK 4: confirm_overwrite"
          lval = confirm_overwrite
       else
          lval = FALSE
       end if
    end if

    ! Initial directory (precedes file so if file contains a dir it
    ! will overwrite)
    if (present(initial_dir)) then
       lval = gtk_file_chooser_set_current_folder(chooser_info%chooser, &
            & g_file_new_for_path(initial_dir), c_null_ptr)
    else if (present(current)) then
       if (c_f_logical(current)) then
            lval = gtk_file_chooser_set_current_folder(chooser_info%chooser, &
            & g_file_new_for_path("."//c_null_char), c_null_ptr)
       end if
    end if

    ! Initial file

    if (present(initial_file)) then
       if (action == GTK_FILE_CHOOSER_ACTION_SAVE) then
          call gtk_file_chooser_set_current_name(chooser_info%chooser, &
               & initial_file)
       else
          lval = gtk_file_chooser_set_file(chooser_info%chooser, &
               & g_file_new_for_path(initial_file), c_null_ptr)
       end if
    end if

    ! Set up filters
    if (present(filter)) then
       do i = 1, size(filter)
          gfilter = gtk_file_filter_new()

          idx0 = 1
          do
             idx1 = index(filter(i)(idx0:),',')+idx0-2
             if (idx1 < idx0) then
                if (index(filter(i)(idx0:), '/') == 0) then
                   call gtk_file_filter_add_pattern(gfilter, &
                        & trim(adjustl(filter(i)(idx0:)))//c_null_char)
                else
                   call gtk_file_filter_add_mime_type(gfilter, &
                        & trim(adjustl(filter(i)(idx0:)))//c_null_char)
                end if
                exit
             else
                if (index(filter(i)(idx0:idx1), '/') == 0) then
                   call gtk_file_filter_add_pattern(gfilter, &
                        & trim(adjustl(filter(i)(idx0:idx1)))//c_null_char)
                else
                   call gtk_file_filter_add_mime_type(gfilter, &
                        & trim(adjustl(filter(i)(idx0:idx1)))//c_null_char)
                end if
                idx0=idx1+2
             end if
          end do
          if (present(filter_name)) then
             call gtk_file_filter_set_name(gfilter, &
                  & trim(filter_name(i))//c_null_char)
          else
             call gtk_file_filter_set_name(gfilter, &
                  & trim(filter(i))//c_null_char)
          end if
          call gtk_file_chooser_add_filter(chooser_info%chooser, gfilter)
       end do
       if (present(all)) then
          if (all == TRUE) then
             gfilter = gtk_file_filter_new()
             call gtk_file_filter_add_pattern(gfilter, &
                  & "*"//c_null_char)
             call gtk_file_filter_set_name(gfilter, &
                  "All Files"//c_null_char)
             call gtk_file_chooser_add_filter(chooser_info%chooser, gfilter)
          end if
       end if
    end if

    ! Add an entry box for extra filters.
    if (present(edit_filters)) then
       if (edit_filters == TRUE) then
          print *, "Removed from GTK 4: edit_filters, gtk_file_chooser_set_extra_widget"
       end if
    end if

    call g_signal_connect(dialog, "response"//c_null_char, &
         & c_funloc(hl_gtk_chooser_resp_cb), c_loc(chooser_info))

  end function hl_gtk_file_chooser_new

  !+
  function hl_gtk_file_chooser_show(files, cdir, directory, create, &
       & multiple, allow_uri, show_hidden, confirm_overwrite, title, &
       & initial_dir, current, initial_file, filter, filter_name, parent, &
       & all, wsize, edit_filters) result(isel)

    integer(c_int) :: isel
    character(len=*), dimension(:), intent(out), allocatable :: files
    character(len=*), intent(out), optional :: cdir
    integer(c_int), intent(in), optional :: directory, create, multiple
    integer(c_int), intent(in), optional :: allow_uri, show_hidden
    integer(c_int), intent(in), optional :: confirm_overwrite
    character(kind=c_char), dimension(*), intent(in), optional :: title, initial_dir, initial_file
    integer(c_int), intent(in), optional :: current
    character(len=*), dimension(:), intent(in), optional :: filter
    character(len=*), dimension(:), intent(in), optional :: filter_name
    type(c_ptr), intent(in), optional :: parent
    integer(c_int), intent(in), optional :: all
    integer(c_int), intent(in), dimension(2), optional :: wsize
    integer(c_int), intent(in), optional :: edit_filters

    ! Create and show a file chooser widget.
    !
    ! FILES |  string() |  required |  The file or files selected.
    ! CDIR |  string |  optional |  The directory from which they were chosen.
    ! DIRECTORY |  boolean |  optional |  Set to TRUE to select directories instead of files.
    ! CREATE |  boolean |  optional |  Set to FALSE to prohibit creating new files.
    ! MULTIPLE |  boolean |  optional |  Set to TRUE to allow the selection of multiple files.
    ! ALLOW_URI |  boolean |  optional |  Set to TRUE to allow nonlocal selections.
    ! SHOW_HIDDEN | boolean |  optional | Set to TRUE to show hidden files. **Removed from GTK 4.**
    ! CONFIRM_OVERWRITE | boolean |  optional | Set to TRUE to request confirmation of an overwrite (only used if CREATE is TRUE). **Removed from GTK 4.**
    ! TITLE |  string |  optional |  Title for the window.
    ! INITIAL_DIR |  string |  optional |  Set the initial directory here instead of the current directory.
    ! CURRENT |  boolean |  optional |  Use to force start in current directory.
    ! INITIAL_FILE |  string |  optional |  Set the initial file selection.
    ! FILTER |  string() |  optional |   The file selection filter. Elements may either be patterns or mime types. Each filter is a comma-separated list of patterns
    ! FILTER_NAME |  string() |  optional |  Names for the filters
    ! PARENT |  c_ptr |  optional |  Parent window for the dialogue.
    ! ALL |  boolean |  optional |  Set to TRUE to add an all-files filter pattern
    ! WSIZE |  c_int(2) |  optional |  Set the size for the dialog.
    ! EDIT_FILTERS | boolean |  optional | Set to TRUE to proves an entry window to add extra filters. **Removed from GTK 4.**
    !
    ! Returns TRUE if one or more files was selected, FALSE otherwise.
    !-

    type(c_ptr) :: dialog, g_file
    type(hl_gtk_chooser_info) :: chooser_info
    integer(c_int) :: i, nsel

    dialog =  hl_gtk_file_chooser_new(chooser_info, cdir, directory, create, &
         & multiple, allow_uri, show_hidden, confirm_overwrite, title, &
         & initial_dir, current, initial_file, filter, filter_name, parent, &
         & all, wsize, edit_filters)

    call gtk_widget_show(dialog)

    ! The callback function is defined in hl_gtk_file_chooser_new()
    dialog_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
    call g_main_loop_run(dialog_gmainloop)

    isel = chooser_info%iselect

    if (chooser_info%iselect == TRUE) then
       ! Number of selected files:
       nsel = g_list_model_get_n_items(chooser_info%chooser_sel_list)
       allocate(files(nsel))
       ! Store the paths of selected files:
       do i = 1, nsel
          ! It's a list of GFiles:
          g_file = g_list_model_get_item(chooser_info%chooser_sel_list, i-1_c_int)
          call convert_c_string(g_file_get_path(g_file), files(i))
          call g_object_unref(g_file)
       end do
       call g_object_unref(chooser_info%chooser_sel_list)

       if (present(cdir)) call convert_c_string(g_file_get_path( &
                                       & chooser_info%chooser_curdir), cdir)
    end if

    call gtk_window_close(dialog)
  end function hl_gtk_file_chooser_show



  !+
  subroutine hl_gtk_chooser_resp_cb(dialog, response, gdata) bind(c)

    type(c_ptr), value :: dialog
    integer(c_int), value :: response
    type(c_ptr), value :: gdata

    ! Callback for the "response" signal of the chooser
    !
    ! DIALOG |  c_ptr |  required |  The dialog sending the response
    ! RESPONSE |  c_int |  required |  The response code.
    ! GDATA |  c_ptr |  required |  User data used to return a select/cancel value
    !
    ! The application developer should never need to use this routine directly.
    !-

    type(hl_gtk_chooser_info), pointer :: chooser_info

    call c_f_pointer(gdata, chooser_info)

    select case (response)
    case (GTK_RESPONSE_DELETE_EVENT)
       chooser_info%iselect = FALSE
    case (GTK_RESPONSE_CANCEL)
       chooser_info%iselect = FALSE
    case (GTK_RESPONSE_APPLY)
       chooser_info%iselect = TRUE
       chooser_info%chooser_sel_list = &
               & gtk_file_chooser_get_files(chooser_info%chooser)
       chooser_info%chooser_curdir = &
            & gtk_file_chooser_get_current_folder(chooser_info%chooser)
    case default
       chooser_info%iselect = FALSE
       write(error_unit,*) &
            & "hl_gtk_chooser_resp_cb:: Invalid response received", response
    end select

    call g_main_loop_quit(dialog_gmainloop)
  end subroutine hl_gtk_chooser_resp_cb

  !+
  subroutine hl_gtk_chooser_filt_cb(widget, gdata) bind(c)

    type(c_ptr), value :: widget
    type(c_ptr), value :: gdata

    ! Callback for the new filter entry.
    !
    ! WIDGET |  c_ptr |  required |  The widget sending the signal
    ! GDATA |  c_ptr |  required |  User data used to return a select/cancel value
    !
    ! The application developer should never need to use this routine directly.
    !-

    type(hl_gtk_chooser_info), pointer :: chooser_info

    character(len=60) :: filter
    type(c_ptr) :: gfilter, buffer
    integer :: idx0, idx1

    call c_f_pointer(gdata, chooser_info)

    call hl_gtk_entry_get_text(chooser_info%fentry, filter)
    if (filter == "") return   ! No filter was given.

    gfilter = gtk_file_filter_new()

    idx0 = 1
    do
       idx1 = index(filter(idx0:),',')+idx0-2
       if (idx1 < idx0) then
          if (index(filter(idx0:), '/') == 0) then
             call gtk_file_filter_add_pattern(gfilter, &
                  & trim(adjustl(filter(idx0:)))//c_null_char)
          else
             call gtk_file_filter_add_mime_type(gfilter, &
                  & trim(adjustl(filter(idx0:)))//c_null_char)
          end if
          exit
       else
          if (index(filter(idx0:idx1), '/') == 0) then
             call gtk_file_filter_add_pattern(gfilter, &
                  & trim(adjustl(filter(idx0:idx1)))//c_null_char)
          else
             call gtk_file_filter_add_mime_type(gfilter, &
                  & trim(adjustl(filter(idx0:idx1)))//c_null_char)
          end if
          idx0=idx1+2
       end if
    end do
    call gtk_file_filter_set_name(gfilter, &
         & trim(filter)//c_null_char)

    call gtk_file_chooser_add_filter(chooser_info%chooser, gfilter)

    buffer = gtk_entry_get_buffer(chooser_info%fentry)
    ! number of caracters = -1 for automatic length:
    call gtk_entry_buffer_set_text (buffer, C_NULL_CHAR, -1)

  end subroutine hl_gtk_chooser_filt_cb
end module gtk_hl_chooser

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2021 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
! Contributed by Vincent Magnin, 2021-03-03
! Last modifications: 2021-03-04
!-------------------------------------------------------------------------------
! This example desmonstrates how to use GLib regular expressions to search a
! pattern in a text, and make replacements. That GLib part is based on the PCRE
! library: http://www.pcre.org/
! https://developer.gnome.org/glib/stable/glib-Perl-compatible-regular-expressions.html

program glib_regex
    use, intrinsic :: iso_c_binding
    use g, only: g_regex_new, g_regex_match, g_match_info_matches, &
               & g_match_info_fetch, g_match_info_next, g_free, g_regex_unref, &
               & g_match_info_free, g_regex_replace
    use gtk_sup, only: c_f_logical, convert_c_string

    implicit none
    logical :: found, matched
    type(c_ptr) :: regex, a_result
    type(c_ptr), target :: matchInfo
    character(*), parameter :: content= &
        &"Our first widget in our app is an empty window: we have defined a C &
        &pointer toward that object and we have created it using &
        &gtk_application_window_new(app). Don't forget to call the &
        &gtk_widget_show_all() function if you want your window to appear on &
        &screen! Note that in GTK 3, all widgets are hidden by default and that&
        & is why we use _show_all(). In GTK 4, on the contrary, the widgets &
        &inside a window are all shown by default and the gtk_widget_show_all()&
        & function was removed: you will use instead call gtk_widget_show(window)."
    character(200) :: fstring
    character(1000) :: modified_text

    print *, "ORIGINAL TEXT:"
    print *, content
    print *
    print *, "LET'S LOOK FOR THE FUNCTIONS CITED IN THE TEXT:"
    regex = g_regex_new("(\w+)\(([a-zA-Z0-9_, ]*)\)"//c_null_char, 0, 0, c_null_ptr)
    found = c_f_logical(g_regex_match(regex, content//c_null_char, 0, c_loc(matchInfo)))

    if (.not. found) then
        print *, "NO MATCH."
    else
        print *, "SOME MATCHES WERE FOUND:"
        do while (c_f_logical(g_match_info_matches(matchInfo)))
            a_result = g_match_info_fetch(matchInfo, 0)
            call convert_c_string(a_result, fstring)
            print *, trim(fstring)
            call g_free(a_result)

            matched = c_f_logical(g_match_info_next(matchInfo, c_null_ptr))
        end do

        print *
        print *, "LET'S REPLACE THOSE FUNCTIONS BY 6 STARS IN THE TEXT:"
        call convert_c_string(g_regex_replace(regex, content//c_null_char, &
         & -1_c_size_t, 0, "******"//c_null_char, 0, c_null_ptr), modified_text)
        print *, trim(modified_text)
    end if

    call g_match_info_free(matchInfo)
    call g_regex_unref(regex)
end program glib_regex

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by Jerry DeLisle and Vincent Magnin
! GTK 4 version: vmagnin 2020-05-19
! Last modifications: vmagnin 2023-04-25
!------------------------------------------------------------------------------

module handlers
  use gtk, only: gtk_application_window_new, gtk_window_set_child, &
  & gtk_drawing_area_set_content_width, gtk_drawing_area_set_content_height, &
  & gtk_drawing_area_set_draw_func, gtk_drawing_area_new, &
  & gtk_widget_queue_draw, gtk_widget_show, gtk_window_set_default_size, &
  & gtk_window_set_title, gtk_window_set_resizable, &
  & TRUE, FALSE, GDK_COLORSPACE_RGB, g_signal_connect, &
  & CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL

  use cairo, only: cairo_arc, cairo_create, cairo_curve_to, cairo_destroy, &
  & cairo_get_target, cairo_line_to, cairo_move_to, cairo_new_sub_path, &
  & cairo_paint, cairo_select_font_face, cairo_set_font_size, &
  & cairo_set_line_width, cairo_set_source, cairo_set_source_rgb, &
  & cairo_show_text, cairo_stroke, cairo_surface_write_to_png

  use gdk, only: gdk_cairo_set_source_pixbuf

  use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, &
  & gdk_pixbuf_get_rowstride, gdk_pixbuf_new

  use g, only: g_main_context_iteration, g_main_context_pending

  use, intrinsic :: iso_fortran_env, only: wp=>real64, dp=>real64, int8
  use, intrinsic :: iso_c_binding

  implicit none
  type(c_ptr)    :: my_gmainloop
  integer(c_int) :: run_status = TRUE
  integer(c_int) :: boolresult
  type(c_ptr)    :: my_pixbuf
  character(kind=c_char), dimension(:), pointer :: pixel
  integer(c_int) :: nch, rowstride, width, height, pwidth, pheight
  logical :: write_png
  ! Mathematical window:
  real(wp), parameter :: xmin = -2.0_wp
  real(wp), parameter :: xmax = +1.0_wp
  real(wp), parameter :: ymin = -1.5_wp
  real(wp), parameter :: ymax = +1.5_wp

contains
  ! This function is needed to update the GUI during long computations.
  ! https://docs.gtk.org/glib/main-loop.html
  subroutine pending_events ()
    do while(IAND(g_main_context_pending(c_null_ptr), run_status) /= FALSE)
      ! FALSE for non-blocking:
      boolresult = g_main_context_iteration(c_null_ptr, FALSE)
    end do
  end subroutine pending_events

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  ! https://docs.gtk.org/gtk4/method.DrawingArea.set_draw_func.html
  subroutine my_draw_function(widget, my_cairo_context, width, height, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height
    integer :: cstatus, i
    real(dp), parameter :: pi = acos(-1._dp)
    real(dp) :: Ox, Oy, X_circle
    real(dp) :: X_cardio, teta, ro

    print *, "Entering my_draw_function()"

    ! Pixel coordinates of the mathematical origin:
    Ox = width  * (0._dp - xmin) / (xmax - xmin)
    Oy = height * (ymax - 0._dp) / (ymax - ymin)

    ! We draw the Mandelbrot set pixbuf in the Cairo context, starting from
    ! the top left corner:
    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 0._dp, 0._dp)
    call cairo_paint(my_cairo_context)

    ! Text:
    call cairo_select_font_face(my_cairo_context, "Arial"//c_null_char, &
                            & CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)

    ! Draw cartesian axes, in white:
    call cairo_set_source_rgb(my_cairo_context, 1._dp, 1._dp, 1._dp)
    call cairo_set_line_width(my_cairo_context, 2._dp)
    ! Horizontal axis:
    call cairo_move_to(my_cairo_context, 0._dp,                Oy)
    call cairo_line_to(my_cairo_context, real(width, KIND=dp), Oy)
    ! Vertical axis:
    call cairo_move_to(my_cairo_context, Ox, 0._dp)
    call cairo_line_to(my_cairo_context, Ox, real(height, KIND=dp))
    call cairo_stroke(my_cairo_context)
    ! Texts on the axes:
    call cairo_set_font_size (my_cairo_context, 20._dp)
    call cairo_move_to(my_cairo_context, width - 20._wp, Oy - 10._dp)
    call cairo_show_text (my_cairo_context, "x"//c_null_char)
    call cairo_move_to(my_cairo_context, Ox - 20._wp, +20._dp)
    call cairo_show_text (my_cairo_context, "y"//c_null_char)
    call cairo_move_to(my_cairo_context, Ox - 20._wp, Oy + 20._dp)
    call cairo_show_text (my_cairo_context, "O"//c_null_char)
    call cairo_set_font_size (my_cairo_context, 32._dp)
    call cairo_move_to(my_cairo_context, width / 10._dp, height / 10._dp)
    call cairo_show_text (my_cairo_context, "Mandelbrot set"//c_null_char)

    ! Circle of radius 1/4 centered around −1, in yellow:
    call cairo_set_source_rgb(my_cairo_context, 1._dp, 1._dp, 0._dp)
    call cairo_set_line_width(my_cairo_context, 3._dp)
    call cairo_new_sub_path(my_cairo_context)
    X_circle = width  * (-1._dp - xmin) / (xmax - xmin)
    call cairo_arc(my_cairo_context, X_circle, Oy, width / (xmax-xmin) / 4._dp, 0._dp, 2._dp*pi)
    call cairo_stroke(my_cairo_context)
    call cairo_set_font_size (my_cairo_context, 20._dp)
    call cairo_move_to(my_cairo_context, X_circle, Oy - 10._dp)
    call cairo_show_text (my_cairo_context, "circle"//c_null_char)

    ! Main cardioid centered on A(1/4, 0) with polar equation ro(teta) = 1/2*(1 − cos teta)
    X_cardio = width  * (1._dp/4._dp - xmin) / (xmax - xmin)
    call cairo_move_to(my_cairo_context, X_cardio, Oy)
    do i = 1, 100
      teta = (i * 2._dp * pi) / 100._dp
      ro = (1._dp - cos(teta)) / 2._dp
      ro = ro * width / (xmax - xmin)
      call cairo_line_to(my_cairo_context, X_cardio + ro*cos(teta), Oy + ro*sin(teta))
    end do
    call cairo_stroke(my_cairo_context)
    call cairo_move_to(my_cairo_context, Ox + 5._dp, Oy - 10._dp)
    call cairo_show_text (my_cairo_context, "cardioid"//c_null_char)

    ! The image is written to PNG only one time:
    if (write_png) then
      cstatus = cairo_surface_write_to_png(cairo_get_target(my_cairo_context),&
                                         & "cairo-tests.png"//c_null_char)
      print *, "Writing cairo-tests.png: ", cstatus
      write_png = .false.
    end if
  end subroutine my_draw_function

  ! The GUI is defined here:
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    type(c_ptr)     :: my_window
    type(c_ptr)     :: my_drawing_area
    integer(c_int)  :: width, height
    integer         :: bytes

    ! Properties of the main window:
    my_window = gtk_application_window_new(app)
    width  = 748
    height = 748
    call gtk_window_set_default_size(my_window, width, height)
    call gtk_window_set_resizable(my_window, FALSE)
    call gtk_window_set_title(my_window, "Cairo tests: mixing vector graphics with a pixbuf (gtk-fortran)"//c_null_char)

    my_drawing_area = gtk_drawing_area_new()
    call gtk_drawing_area_set_content_width(my_drawing_area, width)
    call gtk_drawing_area_set_content_height(my_drawing_area, height)
    call gtk_drawing_area_set_draw_func(my_drawing_area, &
                        & c_funloc(my_draw_function), c_null_ptr, c_null_funptr)

    ! Dimensions of the Mandelbrot set picture:
    pwidth  = width
    pheight = height
    ! "Creates a new GdkPixbuf structure and allocates a buffer for it":
    ! RGB, no alpha channel (FALSE), 8 bits per color sample, width, height
    my_pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8_c_int, pwidth, pheight)
    ! Queries the number of channels of a pixbuf:
    nch = gdk_pixbuf_get_n_channels(my_pixbuf)
    print *, "Number of channels of the pixbuf: ", nch
    ! "Queries the rowstride of a pixbuf, which is the number of bytes between
    ! the start of a row and the start of the next row":
    rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)
    print *, "Rowstride of the pixbuf: ", rowstride
    bytes = pwidth * pheight * nch
    print *, "Size (bytes) of the pixbuf: ", bytes

    call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf), pixel, [bytes])
    ! Drawing the whole set:
    call Mandelbrot_set(my_drawing_area, 1000_4)
    write_png = .true.

    call gtk_window_set_child(my_window, my_drawing_area)

    call gtk_widget_show(my_window)
  end subroutine activate

  !*********************************************
  ! A tribute to Benoit MANDELBROT (1924-2010)
  ! http://en.wikipedia.org/wiki/Mandelbrot_set
  !*********************************************
  subroutine Mandelbrot_set(my_drawing_area, itermax)
    type(c_ptr)   :: my_drawing_area
    integer       :: i, j, k, p, itermax
    real(wp)      :: x, y    ! coordinates in the complex plane
    complex(wp)   :: c, z
    real(wp)      :: scx, scy             ! scales
    real(wp)      :: t0, t1
    integer(int8) :: red, green, blue     ! rgb color
    integer, parameter :: factor = 8

    print *, "Entering Mandelbrot_set() subroutine"

    call cpu_time(t0)
    scx = (xmax - xmin) / pwidth   ! x scale
    scy = (ymax - ymin) / pheight  ! y scale

    do i = 0, pwidth-1
      x = xmin + scx * i

      do j = 0, pheight-1
        y = ymin + scy * j

        c = cmplx(x, y, kind=wp)    ! Starting point
        z = (0.0_wp, 0.0_wp)        ! z0
        k = 1
        do while ((k <= itermax) .and. ((z%re**2 + z%im**2) < 4.0_wp))
          z = z*z + c
          k = k + 1
        end do

        if (k > itermax) then
          ! Black pixel:
          red   = 0
          green = 0
          blue  = 0
        else
          ! Fortran purple is #734f96 : (115, 79, 150)
          red   = int(min(255, factor*k),  int8)
          green = int(min(255, nint(factor*k*79./115.)),  int8)
          blue  = int(min(255, nint(factor*k*150./115.)), int8)
        end if

        p = i * nch + j * rowstride + 1
        pixel(p)   = char(red)
        pixel(p+1) = char(green)
        pixel(p+2) = char(blue)
      end do
      ! This subroutine processes GTK events as needed during the computation
      ! (not really useful in that fast computation example)
      if (mod(i, 50) == 0) then
        call pending_events()
        if (run_status == FALSE) return   ! Exit if we had a delete event
      end if
    end do

    ! We only draw the image at the end of that fast computation:
    call gtk_widget_queue_draw(my_drawing_area)

    call cpu_time(t1)
    print '(A, F6.2, A)', "System time = ", t1-t0, " s"
  end subroutine mandelbrot_set

end module handlers

!***********************************************************
! We create a GtkApplication:
!***********************************************************
program cairo_tests
  use, intrinsic :: iso_c_binding
  use gtk, only: gtk_application_new, g_signal_connect, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers, only: activate

  implicit none
  integer(c_int) :: exit_status
  type(c_ptr)    :: app

  app = gtk_application_new("gtk-fortran.examples.cairo-tests"//c_null_char, &
                          & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  exit_status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program cairo_tests

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public
!  License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin
! Last modification: 2012-08-30, vmagnin 2020-06-04 (GTK 4), 2020-07-15
!
!! A demo of the HL infobar widget.
!------------------------------------------------------------------------------

module ib_handers
!  use gth_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_infobar
  use gtk, only: gtk_window_set_child, gtk_window_destroy, &
       & gtk_widget_show, TRUE, FALSE, &
       & GTK_MESSAGE_INFO, GTK_MESSAGE_WARNING, &
       & GTK_MESSAGE_QUESTION, GTK_MESSAGE_ERROR, GTK_MESSAGE_OTHER

  implicit none
  type(c_ptr) :: tlwindow, infobar
  enum, bind(c)
    enumerator :: my_quit
    enumerator :: my_no
    enumerator :: my_yes
    enumerator :: my_ok
    enumerator :: my_print
    enumerator :: my_ignore
  end enum

contains

  subroutine delete_h(widget, data) bind(c)
   type(c_ptr), value, intent(in) :: widget, data
   print *, "Exit called"
   call gtk_window_destroy(tlwindow)
  end subroutine delete_h

  subroutine response_h(widget, id, data) bind(c)
   type(c_ptr), value, intent(in) :: widget, data
   integer(c_int), value, intent(in) :: id

   select case(id)
   case(my_quit)
      print *, "Pressed 'QUIT'"
      call gtk_window_destroy(tlwindow)
      return
   case(my_yes)
      print *, "Pressed 'YES'"
   case(my_no)
      print *, "Pressed 'NO'"
   case(my_ok)
      print *, "Pressed 'OK'"
   case(my_ignore)
   end select
  end subroutine response_h

  subroutine button_h(widget, data) bind(c)
   type(c_ptr), value, intent(in) :: widget, data

   integer(c_int), pointer :: index
   integer(c_int), parameter, dimension(5) :: ids=[my_ok, my_yes, &
        & my_no, my_ignore, my_quit]

   call c_f_pointer(data, index)

   select case (index)
   case(0)
      call hl_gtk_info_bar_message(infobar, &
           & "For your informatation"//c_null_char, &
           & type=GTK_MESSAGE_INFO, ids=ids, &
           & state=[TRUE, FALSE, FALSE, TRUE, FALSE], &
           & default=my_ok)
   case(1)
      call hl_gtk_info_bar_message(infobar, &
           & "Take care"//c_null_char, &
           & type=GTK_MESSAGE_WARNING, ids=ids, &
           & state=[TRUE, FALSE, FALSE, TRUE, FALSE], &
           & default=my_ignore)
   case(2)
      call hl_gtk_info_bar_message(infobar, &
           & "This is BAD!!!!"//c_null_char, &
           & type=GTK_MESSAGE_ERROR, ids=ids, &
           & state=[FALSE, FALSE, FALSE, TRUE, TRUE], &
           & default=my_quit)
   case(3)
      call hl_gtk_info_bar_message(infobar, &
           & "Are you certain"//c_null_char, &
           & type=GTK_MESSAGE_QUESTION, ids=ids, &
           & state=[FALSE, TRUE, TRUE, TRUE, FALSE], &
           & default=my_no)
   case(4)
      call hl_gtk_info_bar_message(infobar, &
           & "Something else again"//c_null_char, &
           & type=GTK_MESSAGE_OTHER, ids=ids, &
           & state=[TRUE, FALSE, FALSE, TRUE, TRUE], &
           & default=my_ignore)
   end select
  end subroutine button_h


  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    integer(c_int), dimension(5), target :: button_states = &
         & [0,1,2,3,4]
    type(c_ptr) :: jb, junk

    ! Create the window:
    tlwindow = gtk_application_window_new(app)
    call gtk_window_set_title(tlwindow, "InfoBar demo"//c_null_char)

    jb = hl_gtk_table_new()
    call gtk_window_set_child(tlwindow, jb)

    junk=hl_gtk_button_new("Info"//c_null_char, &
         & clicked=c_funloc(button_h), data=c_loc(button_states(1)))
    call hl_gtk_table_attach(jb, junk, 0_c_int, 0_c_int, yopts=0_c_int)
    junk=hl_gtk_button_new("Warning"//c_null_char, &
         & clicked=c_funloc(button_h), data=c_loc(button_states(2)))
    call hl_gtk_table_attach(jb, junk, 1_c_int, 0_c_int, yopts=0_c_int)
    junk=hl_gtk_button_new("Error"//c_null_char, &
         & clicked=c_funloc(button_h), data=c_loc(button_states(3)))
    call hl_gtk_table_attach(jb, junk, 2_c_int, 0_c_int, yopts=0_c_int)
    junk=hl_gtk_button_new("Question"//c_null_char, &
         & clicked=c_funloc(button_h), data=c_loc(button_states(4)))
    call hl_gtk_table_attach(jb, junk, 3_c_int, 0_c_int, yopts=0_c_int)
    junk=hl_gtk_button_new("Other"//c_null_char, &
         & clicked=c_funloc(button_h), data=c_loc(button_states(5)))
    call hl_gtk_table_attach(jb, junk, 4_c_int, 0_c_int, yopts=0_c_int)

    infobar = hl_gtk_info_bar_new(buttons=&
         & [character(len=6) :: 'OK','Yes','No','Ignore','Quit'], &
         & ids=[my_ok, my_yes, my_no, my_ignore, my_quit], &
         & response=c_funloc(response_h), horizontal=TRUE, buttons_below=TRUE)

    call hl_gtk_table_attach(jb,infobar,0_c_int,1_c_int, &
         & xspan=5_c_int, yopts=0_c_int)

    ! Realize & enter event loop
    call gtk_widget_show(tlwindow)
    end subroutine activate
end module ib_handers


program hl_infobar
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use ib_handers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_infobar"//c_null_char, &
                             & c_funloc(activate))
end program hl_infobar

! Automatically generated by extract_events.pl on Thu Apr 24 09:04:10 2025 Z
! Please do not modify (unless you really know what you're doing).
! This file is part of the gtk-fortran GTK+ Fortran Interface library.
! GNU General Public License version 3

module gdk_events
  ! GDK events and related structures
  ! Automatically extracted from gdktypes.h & gdkevents.h
  use, intrinsic :: iso_c_binding

  implicit none

  type, bind(c) :: GdkRectangle
    integer(kind=c_int) :: x, y    ! enum int
    integer(kind=c_int) :: width, height    ! enum int
  end type GdkRectangle

  type, bind(c) :: GdkKeymapKey
    integer(kind=c_int) :: keycode  ! guint
    integer(kind=c_int) :: group    ! enum int
    integer(kind=c_int) :: level    ! enum int
  end type GdkKeymapKey

end module gdk_events

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2013 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin, 2013-01-26
! Last modifications: vmagnin 2020-06-19 (GTK 4), 2023-03-30
!------------------------------------------------------------------------------

module v_handlers
  use, intrinsic :: iso_c_binding

  use gdk_pixbuf_hl
  use gtk_draw_hl
  use gtk_hl_chooser
  use gtk_hl_combobox

  !************************************
  ! GTK modules for hl_cairo_viewer.f90
  !************************************
  use cairo, only: cairo_status, cairo_status_to_string
  use gdk_pixbuf, only: gdk_pixbuf_get_height, gdk_pixbuf_get_width
  use gtk, only: gtk_combo_box_get_active, gtk_combo_box_set_active, &
       & gtk_widget_set_sensitive, gtk_window_set_child, &
       & gtk_widget_show, gtk_window_destroy, TRUE, FALSE, &
       & g_signal_connect, gtk_widget_get_name
  use g, only: g_timeout_add
  use gtk_sup, only: c_f_string_copy_alloc

  implicit none
  character(len=256), dimension(:), allocatable :: file_list
  integer(c_int) :: current_file
  type(c_ptr) :: tl_window, view, prev, next, selector

contains

  ! Callback function of the "Quit" button:
  subroutine delete_v (widget, gdata)  bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call gtk_window_destroy(tl_window)
  end subroutine delete_v


  function show_at_start(selector) bind(c)
    ! This function is needed to show image passed as argument
    ! in the command line.
    ! See https://github.com/vmagnin/gtk-fortran/issues/224
    integer(c_int) :: show_at_start
    type(c_ptr), value, intent(in) :: selector

    ! Will cause show_image() to be called by the combobox:
    call gtk_combo_box_set_active(selector, current_file)
    ! This function will be launched only once if it returns FALSE:
    show_at_start = FALSE
  end function


  recursive subroutine show_image(widget, gdata)  bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int), pointer :: istep
    integer(c_int) :: nx, ny
    type(c_ptr) :: pixbuf
    character(len=120) :: errm=''
    character(:), allocatable :: widget_name

    call c_f_string_copy_alloc(gtk_widget_get_name(widget), widget_name)

    if (widget_name == "GtkApplicationWindow") then
       ! If the widget is the main window, it means
       ! it has been resized. We redraw the same file.
    else
      ! When clicking on Prev and Next buttons, data -1 or +1 is passed:
      if (c_associated(gdata)) then
         call c_f_pointer(gdata, istep)
         current_file = current_file + istep
         call gtk_combo_box_set_active(selector, current_file)
      else
         current_file = gtk_combo_box_get_active(widget)
         if (current_file < 0) return
      end if
    end if

    ! Depending on the number of loaded images, the Next and Prev buttons
    ! may be activated (sensitive) or not:
    call gtk_widget_set_sensitive(prev, f_c_logical(current_file > 0))
    call gtk_widget_set_sensitive(next, &
         & f_c_logical(current_file < size(file_list)-1))

    errm = ''
    pixbuf = hl_gdk_pixbuf_new(trim(file_list(current_file+1))//c_null_char, &
         & error=errm)
    if (errm /= "") then
       write(error_unit, "(2A)") "Failed to open: ", &
            & trim(file_list(current_file+1))
       write(error_unit, "(2A)") "        ", trim(errm)
    else
       nx = gdk_pixbuf_get_width(pixbuf)
       ny = gdk_pixbuf_get_height(pixbuf)

       call hl_gtk_drawing_area_resize(view, [nx, ny])
       call hl_gtk_drawing_area_draw_pixbuf(view, pixbuf)
    end if
  end subroutine show_image


  subroutine add_files(widget, gdata)  bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    character(len=256), dimension(:), allocatable :: new_files, tmp
    logical, pointer :: idelete
    integer(c_int) :: ipick, i

    ipick = hl_gtk_file_chooser_show(new_files, &
         & create=FALSE, multiple=TRUE, filter=["image/*"], &
         & parent=tl_window, all=TRUE)

    if (.not. c_f_logical(ipick)) return

    call c_f_pointer(gdata, idelete)

    if (idelete) then
       ! If idelete is .true., the file_list is reinitialized
       ! (may happen at start or with the "Replace files" button):
       if (allocated(file_list)) deallocate(file_list)
       allocate(file_list(size(new_files)))
       file_list(:) = new_files(:)
       call hl_gtk_combo_box_delete(selector)
    else
       ! A file is added to the list:
       allocate(tmp(size(file_list)))
       tmp(:) = file_list(:)
       if (allocated(file_list)) deallocate(file_list)
       allocate(file_list(size(tmp)+size(new_files)))
       file_list(:size(tmp)) = tmp(:)
       file_list(size(tmp)+1:) = new_files(:)
       if (current_file < 0) current_file = 0
    end if

    ! Update the combobox:
    do i = 1, size(new_files)
       call hl_gtk_combo_box_add_text(selector, trim(new_files(i))//c_null_char)
    end do

    if (current_file < 0 .and. size(file_list) > 0) current_file = 0

    call gtk_combo_box_set_active(selector, current_file)
    call gtk_widget_set_sensitive(selector, f_c_logical(size(file_list)>0))
    call gtk_widget_set_sensitive(next, &
                                & f_c_logical(current_file < size(file_list)-1))
  end subroutine add_files

  subroutine activate(app, gdata) bind(c)
    use gtk, only: gtk_application_window_new, gtk_window_set_title

    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    integer(c_int) :: nfiles, i, istat
    integer(c_int) :: timeid
    integer(c_int), dimension(2), target :: direction = [-1, 1]
    logical, dimension(2), target :: iremove = [.false., .true.]
    type(c_ptr) :: scroll, base, jb, junk, cmsg
    character(len=120) :: err_msg

    ! Do filenames were passed in the command line?
    nfiles = command_argument_count()
    allocate(file_list(nfiles))

    if (nfiles > 0) then
       do i = 1, nfiles
          call get_command_argument(i, value=file_list(i))
          print *, file_list(i)
       end do
       current_file = 0
    else
       current_file = -1
    end if

    tl_window = gtk_application_window_new(app)
    call gtk_window_set_title(tl_window, "Simple Image Viewer (gtk-fortran)"//c_null_char)
    print *, "Note that you can pass filenames as arguments in the command line"

    base = hl_gtk_box_new()
    call gtk_window_set_child(tl_window, base)

    view = hl_gtk_drawing_area_new(scroll=scroll, ssize=[600_c_int, 600_c_int], &
         & has_alpha=TRUE, cairo_status=istat)
    if (istat /= 0) then
       cmsg = cairo_status_to_string(istat)
       call c_f_string(cmsg, err_msg)
       write(error_unit, "(2a)") "hl_cairo_viewer: ", trim(err_msg)
       stop
    end if

    call hl_gtk_box_pack(base, scroll)

    ! To contain buttons (except Quit):
    jb = hl_gtk_box_new(horizontal=TRUE)
    call hl_gtk_box_pack(base, jb)

    prev = hl_gtk_button_new("< Prev"//c_null_char, &
         & clicked=c_funloc(show_image), data=c_loc(direction(1)), &
         & tooltip="Go to the previous image."//c_null_char,&
         & sensitive=FALSE)
    call hl_gtk_box_pack(jb, prev, expand=FALSE)

    selector = hl_gtk_combo_box_new(changed=c_funloc(show_image), &
         & sensitive=f_c_logical(nfiles > 0), tooltip=&
         & "selector an image to show"//c_null_char)
    call hl_gtk_box_pack(jb, selector, expand=TRUE)

    next = hl_gtk_button_new("Next >"//c_null_char, &
         & clicked=c_funloc(show_image), data=c_loc(direction(2)), &
         & tooltip="Go to the next image."//c_null_char, &
         & sensitive=f_c_logical(nfiles > 0))
    call hl_gtk_box_pack(jb, next, expand=FALSE)

    ! Filling the combobox with files:
    if (nfiles > 0) then
       do i = 1, nfiles
          call hl_gtk_combo_box_add_text(selector, &
               & trim(file_list(i))//c_null_char)
       end do
    end if

    ! iremove(1) is .false. and iremove(2) is .true.:
    junk = hl_gtk_button_new("Add files"//c_null_char, &
         & clicked=c_funloc(add_files), data=c_loc(iremove(1)), &
         & tooltip="Pick files to add to the list."//c_null_char)
    call hl_gtk_box_pack(jb, junk, expand=FALSE)

    junk = hl_gtk_button_new("Replace files"//c_null_char, &
         & clicked=c_funloc(add_files), data=c_loc(iremove(2)), &
         & tooltip="Pick files to replace the list."//c_null_char)
    call hl_gtk_box_pack(jb, junk, expand=FALSE)

    ! This button is in the first (vertical) box:
    junk=hl_gtk_button_new("Quit"//c_null_char, &
         & clicked=c_funloc(delete_v), tooltip=&
         & "Quit the viewer."//c_null_char)
    call hl_gtk_box_pack(base, junk)

    call gtk_widget_show(tl_window)

    ! At start, the Add window is opened if no filename was passed in the command line:
    if (nfiles == 0) call add_files(tl_window, c_loc(iremove(2)))

    ! Will show an image passed in the command line, after the
    ! termination of the activate subroutine (100 ms):
    if (current_file >= 0) timeid = g_timeout_add(100_c_int, c_funloc(show_at_start), selector)

    ! If the window is resized, its default_width and/or default-height properties
    ! are modified and the signal means the image needs to be redrawn:
    call g_signal_connect(tl_window, "notify::default-width"//c_null_char,  c_funloc(show_image))
    call g_signal_connect(tl_window, "notify::default-height"//c_null_char, c_funloc(show_image))
  end subroutine activate
end module v_handlers


program hl_cairo_viewer
  ! A very simple image viewer
  use v_handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_cairo_viewer"//c_null_char, &
                             & c_funloc(activate))
end program hl_cairo_viewer

! Do not modify this file automatically generated by cfwrapper.py using:
! gtk-fortran 4.8.0, GTK 4.18.4, GLib 2.84.1, Fedora 42 x86_64
! This file is part of the gtk-fortran library, distributed under
! GNU General Public License version 3.

module cairo
use, intrinsic :: iso_c_binding
implicit none
interface

!--------------------------------------------------
! /usr/include/cairo/cairo-deprecated.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/cairo/cairo-ft.h
!--------------------------------------------------
! 
!cairo_font_face_t * cairo_ft_font_face_create_for_ft_face (FT_Face face, int load_flags);
function cairo_ft_font_face_create_for_ft_face(face, load_flags) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_ft_font_face_create_for_ft_face
  type(c_ptr), value :: face
  integer(c_int), value :: load_flags
end function

! 
!void cairo_ft_font_face_set_synthesize (cairo_font_face_t *font_face, unsigned int synth_flags);
subroutine cairo_ft_font_face_set_synthesize(font_face, synth_flags) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: font_face
  integer(c_int), value :: synth_flags
end subroutine

! 
!void cairo_ft_font_face_unset_synthesize (cairo_font_face_t *font_face, unsigned int synth_flags);
subroutine cairo_ft_font_face_unset_synthesize(font_face, synth_flags) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: font_face
  integer(c_int), value :: synth_flags
end subroutine

! 
!unsigned int cairo_ft_font_face_get_synthesize (cairo_font_face_t *font_face);
function cairo_ft_font_face_get_synthesize(font_face) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_ft_font_face_get_synthesize
  type(c_ptr), value :: font_face
end function

! 
!FT_Face cairo_ft_scaled_font_lock_face (cairo_scaled_font_t *scaled_font);
function cairo_ft_scaled_font_lock_face(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_ft_scaled_font_lock_face
  type(c_ptr), value :: scaled_font
end function

! 
!void cairo_ft_scaled_font_unlock_face (cairo_scaled_font_t *scaled_font);
subroutine cairo_ft_scaled_font_unlock_face(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
end subroutine

! 
!cairo_font_face_t * cairo_ft_font_face_create_for_pattern (FcPattern *pattern);
function cairo_ft_font_face_create_for_pattern(pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_ft_font_face_create_for_pattern
  type(c_ptr), value :: pattern
end function

! 
!void cairo_ft_font_options_substitute (const cairo_font_options_t *options, FcPattern *pattern);
subroutine cairo_ft_font_options_substitute(options, pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: options
  type(c_ptr), value :: pattern
end subroutine

!--------------------------------------------------
! /usr/include/cairo/cairo-ps.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_ps_surface_create (const char *filename, double width_in_points, double height_in_points);
function cairo_ps_surface_create(filename, width_in_points, height_in_points)&
& bind(c)
  import :: c_ptr, c_char, c_double
  implicit none
  type(c_ptr) :: cairo_ps_surface_create
  character(kind=c_char), dimension(*) :: filename
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end function

! 
!cairo_surface_t * cairo_ps_surface_create_for_stream (cairo_write_func_t write_func, void *closure, double width_in_points, double height_in_points);
function cairo_ps_surface_create_for_stream(write_func, closure,&
& width_in_points, height_in_points) bind(c)
  import :: c_ptr, c_funptr, c_double
  implicit none
  type(c_ptr) :: cairo_ps_surface_create_for_stream
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end function

! 
!void cairo_ps_surface_restrict_to_level (cairo_surface_t *surface, cairo_ps_level_t level);
subroutine cairo_ps_surface_restrict_to_level(surface, level) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: level
end subroutine

! 
!void cairo_ps_get_levels (cairo_ps_level_t const **levels, int *num_levels);
subroutine cairo_ps_get_levels(levels, num_levels) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: levels
  type(c_ptr), value :: num_levels
end subroutine

! 
!const char * cairo_ps_level_to_string (cairo_ps_level_t level);
function cairo_ps_level_to_string(level) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_ps_level_to_string
  integer(c_int), value :: level
end function

! 
!void cairo_ps_surface_set_eps (cairo_surface_t *surface, cairo_bool_t eps);
subroutine cairo_ps_surface_set_eps(surface, eps) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: eps
end subroutine

! 
!cairo_bool_t cairo_ps_surface_get_eps (cairo_surface_t *surface);
function cairo_ps_surface_get_eps(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_ps_surface_get_eps
  type(c_ptr), value :: surface
end function

! 
!void cairo_ps_surface_set_size (cairo_surface_t *surface, double width_in_points, double height_in_points);
subroutine cairo_ps_surface_set_size(surface, width_in_points,&
& height_in_points) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: surface
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end subroutine

! 
!void cairo_ps_surface_dsc_comment (cairo_surface_t *surface, const char *comment);
subroutine cairo_ps_surface_dsc_comment(surface, comment) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: comment
end subroutine

! 
!void cairo_ps_surface_dsc_begin_setup (cairo_surface_t *surface);
subroutine cairo_ps_surface_dsc_begin_setup(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!void cairo_ps_surface_dsc_begin_page_setup (cairo_surface_t *surface);
subroutine cairo_ps_surface_dsc_begin_page_setup(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

!--------------------------------------------------
! /usr/include/cairo/cairo-gobject.h
!--------------------------------------------------
! 
!GType cairo_gobject_context_get_type (void);
function cairo_gobject_context_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_context_get_type
end function

! 
!GType cairo_gobject_device_get_type (void);
function cairo_gobject_device_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_device_get_type
end function

! 
!GType cairo_gobject_matrix_get_type (void);
function cairo_gobject_matrix_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_matrix_get_type
end function

! 
!GType cairo_gobject_pattern_get_type (void);
function cairo_gobject_pattern_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_pattern_get_type
end function

! 
!GType cairo_gobject_surface_get_type (void);
function cairo_gobject_surface_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_surface_get_type
end function

! 
!GType cairo_gobject_rectangle_get_type (void);
function cairo_gobject_rectangle_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_rectangle_get_type
end function

! 
!GType cairo_gobject_scaled_font_get_type (void);
function cairo_gobject_scaled_font_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_scaled_font_get_type
end function

! 
!GType cairo_gobject_font_face_get_type (void);
function cairo_gobject_font_face_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_font_face_get_type
end function

! 
!GType cairo_gobject_font_options_get_type (void);
function cairo_gobject_font_options_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_font_options_get_type
end function

! 
!GType cairo_gobject_rectangle_int_get_type (void);
function cairo_gobject_rectangle_int_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_rectangle_int_get_type
end function

! 
!GType cairo_gobject_region_get_type (void);
function cairo_gobject_region_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_region_get_type
end function

! 
!GType cairo_gobject_glyph_get_type (void);
function cairo_gobject_glyph_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_glyph_get_type
end function

! 
!GType cairo_gobject_text_cluster_get_type (void);
function cairo_gobject_text_cluster_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_text_cluster_get_type
end function

! 
!GType cairo_gobject_status_get_type (void);
function cairo_gobject_status_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_status_get_type
end function

! 
!GType cairo_gobject_content_get_type (void);
function cairo_gobject_content_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_content_get_type
end function

! 
!GType cairo_gobject_operator_get_type (void);
function cairo_gobject_operator_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_operator_get_type
end function

! 
!GType cairo_gobject_antialias_get_type (void);
function cairo_gobject_antialias_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_antialias_get_type
end function

! 
!GType cairo_gobject_fill_rule_get_type (void);
function cairo_gobject_fill_rule_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_fill_rule_get_type
end function

! 
!GType cairo_gobject_line_cap_get_type (void);
function cairo_gobject_line_cap_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_line_cap_get_type
end function

! 
!GType cairo_gobject_line_join_get_type (void);
function cairo_gobject_line_join_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_line_join_get_type
end function

! 
!GType cairo_gobject_text_cluster_flags_get_type (void);
function cairo_gobject_text_cluster_flags_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_text_cluster_flags_get_type
end function

! 
!GType cairo_gobject_font_slant_get_type (void);
function cairo_gobject_font_slant_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_font_slant_get_type
end function

! 
!GType cairo_gobject_font_weight_get_type (void);
function cairo_gobject_font_weight_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_font_weight_get_type
end function

! 
!GType cairo_gobject_subpixel_order_get_type (void);
function cairo_gobject_subpixel_order_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_subpixel_order_get_type
end function

! 
!GType cairo_gobject_hint_style_get_type (void);
function cairo_gobject_hint_style_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_hint_style_get_type
end function

! 
!GType cairo_gobject_hint_metrics_get_type (void);
function cairo_gobject_hint_metrics_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_hint_metrics_get_type
end function

! 
!GType cairo_gobject_font_type_get_type (void);
function cairo_gobject_font_type_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_font_type_get_type
end function

! 
!GType cairo_gobject_path_data_type_get_type (void);
function cairo_gobject_path_data_type_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_path_data_type_get_type
end function

! 
!GType cairo_gobject_device_type_get_type (void);
function cairo_gobject_device_type_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_device_type_get_type
end function

! 
!GType cairo_gobject_surface_type_get_type (void);
function cairo_gobject_surface_type_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_surface_type_get_type
end function

! 
!GType cairo_gobject_format_get_type (void);
function cairo_gobject_format_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_format_get_type
end function

! 
!GType cairo_gobject_pattern_type_get_type (void);
function cairo_gobject_pattern_type_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_pattern_type_get_type
end function

! 
!GType cairo_gobject_extend_get_type (void);
function cairo_gobject_extend_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_extend_get_type
end function

! 
!GType cairo_gobject_filter_get_type (void);
function cairo_gobject_filter_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_filter_get_type
end function

! 
!GType cairo_gobject_region_overlap_get_type (void);
function cairo_gobject_region_overlap_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: cairo_gobject_region_overlap_get_type
end function

!--------------------------------------------------
! /usr/include/cairo/cairo-tee.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_tee_surface_create (cairo_surface_t *primary);
function cairo_tee_surface_create(primary) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_tee_surface_create
  type(c_ptr), value :: primary
end function

! 
!void cairo_tee_surface_add (cairo_surface_t *abstract_surface, cairo_surface_t *target);
subroutine cairo_tee_surface_add(abstract_surface, target) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: abstract_surface
  type(c_ptr), value :: target
end subroutine

! 
!void cairo_tee_surface_remove (cairo_surface_t *abstract_surface, cairo_surface_t *target);
subroutine cairo_tee_surface_remove(abstract_surface, target) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: abstract_surface
  type(c_ptr), value :: target
end subroutine

! 
!cairo_surface_t * cairo_tee_surface_index (cairo_surface_t *abstract_surface, unsigned int index);
function cairo_tee_surface_index(abstract_surface, index) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_tee_surface_index
  type(c_ptr), value :: abstract_surface
  integer(c_int), value :: index
end function

!--------------------------------------------------
! /usr/include/cairo/cairo.h
!--------------------------------------------------
! 
!int cairo_version (void);
function cairo_version() bind(c)
  import :: c_int
  implicit none
  integer(c_int) :: cairo_version
end function

! 
!const char* cairo_version_string (void);
function cairo_version_string() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_version_string
end function

! 
!void cairo_pattern_set_dither (cairo_pattern_t *pattern, cairo_dither_t dither);
subroutine cairo_pattern_set_dither(pattern, dither) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: pattern
  integer(c_int), value :: dither
end subroutine

! 
!cairo_dither_t cairo_pattern_get_dither (cairo_pattern_t *pattern);
function cairo_pattern_get_dither(pattern) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_dither
  type(c_ptr), value :: pattern
end function

! 
!cairo_t * cairo_create (cairo_surface_t *target);
function cairo_create(target) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_create
  type(c_ptr), value :: target
end function

! 
!cairo_t * cairo_reference (cairo_t *cr);
function cairo_reference(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_reference
  type(c_ptr), value :: cr
end function

! 
!void cairo_destroy (cairo_t *cr);
subroutine cairo_destroy(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!unsigned int cairo_get_reference_count (cairo_t *cr);
function cairo_get_reference_count(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_reference_count
  type(c_ptr), value :: cr
end function

! 
!void * cairo_get_user_data (cairo_t *cr, const cairo_user_data_key_t *key);
function cairo_get_user_data(cr, key) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_get_user_data
  type(c_ptr), value :: cr
  type(c_ptr), value :: key
end function

! 
!cairo_status_t cairo_set_user_data (cairo_t *cr, const cairo_user_data_key_t *key, void *user_data, cairo_destroy_func_t destroy);
function cairo_set_user_data(cr, key, user_data, destroy) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_set_user_data
  type(c_ptr), value :: cr
  type(c_ptr), value :: key
  type(c_ptr), value :: user_data
  type(c_funptr), value :: destroy
end function

! 
!void cairo_save (cairo_t *cr);
subroutine cairo_save(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_restore (cairo_t *cr);
subroutine cairo_restore(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_push_group (cairo_t *cr);
subroutine cairo_push_group(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_push_group_with_content (cairo_t *cr, cairo_content_t content);
subroutine cairo_push_group_with_content(cr, content) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: content
end subroutine

! 
!cairo_pattern_t * cairo_pop_group (cairo_t *cr);
function cairo_pop_group(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_pop_group
  type(c_ptr), value :: cr
end function

! 
!void cairo_pop_group_to_source (cairo_t *cr);
subroutine cairo_pop_group_to_source(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_set_operator (cairo_t *cr, cairo_operator_t op);
subroutine cairo_set_operator(cr, op) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: op
end subroutine

! 
!void cairo_set_source (cairo_t *cr, cairo_pattern_t *source);
subroutine cairo_set_source(cr, source) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: source
end subroutine

! 
!void cairo_set_source_rgb (cairo_t *cr, double red, double green, double blue);
subroutine cairo_set_source_rgb(cr, red, green, blue) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
end subroutine

! 
!void cairo_set_source_rgba (cairo_t *cr, double red, double green, double blue, double alpha);
subroutine cairo_set_source_rgba(cr, red, green, blue, alpha) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
  real(c_double), value :: alpha
end subroutine

! 
!void cairo_set_source_surface (cairo_t *cr, cairo_surface_t *surface, double x, double y);
subroutine cairo_set_source_surface(cr, surface, x, y) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: surface
  real(c_double), value :: x
  real(c_double), value :: y
end subroutine

! 
!void cairo_set_tolerance (cairo_t *cr, double tolerance);
subroutine cairo_set_tolerance(cr, tolerance) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: tolerance
end subroutine

! 
!void cairo_set_antialias (cairo_t *cr, cairo_antialias_t antialias);
subroutine cairo_set_antialias(cr, antialias) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: antialias
end subroutine

! 
!void cairo_set_fill_rule (cairo_t *cr, cairo_fill_rule_t fill_rule);
subroutine cairo_set_fill_rule(cr, fill_rule) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: fill_rule
end subroutine

! 
!void cairo_set_line_width (cairo_t *cr, double width);
subroutine cairo_set_line_width(cr, width) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: width
end subroutine

! 
!void cairo_set_hairline (cairo_t *cr, cairo_bool_t set_hairline);
subroutine cairo_set_hairline(cr, set_hairline) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: set_hairline
end subroutine

! 
!void cairo_set_line_cap (cairo_t *cr, cairo_line_cap_t line_cap);
subroutine cairo_set_line_cap(cr, line_cap) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: line_cap
end subroutine

! 
!void cairo_set_line_join (cairo_t *cr, cairo_line_join_t line_join);
subroutine cairo_set_line_join(cr, line_join) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  integer(c_int), value :: line_join
end subroutine

! 
!void cairo_set_dash (cairo_t *cr, const double *dashes, int num_dashes, double offset);
subroutine cairo_set_dash(cr, dashes, num_dashes, offset) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: dashes
  integer(c_int), value :: num_dashes
  real(c_double), value :: offset
end subroutine

! 
!void cairo_set_miter_limit (cairo_t *cr, double limit);
subroutine cairo_set_miter_limit(cr, limit) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: limit
end subroutine

! 
!void cairo_translate (cairo_t *cr, double tx, double ty);
subroutine cairo_translate(cr, tx, ty) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: tx
  real(c_double), value :: ty
end subroutine

! 
!void cairo_scale (cairo_t *cr, double sx, double sy);
subroutine cairo_scale(cr, sx, sy) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: sx
  real(c_double), value :: sy
end subroutine

! 
!void cairo_rotate (cairo_t *cr, double angle);
subroutine cairo_rotate(cr, angle) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: angle
end subroutine

! 
!void cairo_transform (cairo_t *cr, const cairo_matrix_t *matrix);
subroutine cairo_transform(cr, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_set_matrix (cairo_t *cr, const cairo_matrix_t *matrix);
subroutine cairo_set_matrix(cr, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_identity_matrix (cairo_t *cr);
subroutine cairo_identity_matrix(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_user_to_device (cairo_t *cr, double *x, double *y);
subroutine cairo_user_to_device(cr, x, y) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x
  type(c_ptr), value :: y
end subroutine

! 
!void cairo_user_to_device_distance (cairo_t *cr, double *dx, double *dy);
subroutine cairo_user_to_device_distance(cr, dx, dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: dx
  type(c_ptr), value :: dy
end subroutine

! 
!void cairo_device_to_user (cairo_t *cr, double *x, double *y);
subroutine cairo_device_to_user(cr, x, y) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x
  type(c_ptr), value :: y
end subroutine

! 
!void cairo_device_to_user_distance (cairo_t *cr, double *dx, double *dy);
subroutine cairo_device_to_user_distance(cr, dx, dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: dx
  type(c_ptr), value :: dy
end subroutine

! 
!void cairo_new_path (cairo_t *cr);
subroutine cairo_new_path(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_move_to (cairo_t *cr, double x, double y);
subroutine cairo_move_to(cr, x, y) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: x
  real(c_double), value :: y
end subroutine

! 
!void cairo_new_sub_path (cairo_t *cr);
subroutine cairo_new_sub_path(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_line_to (cairo_t *cr, double x, double y);
subroutine cairo_line_to(cr, x, y) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: x
  real(c_double), value :: y
end subroutine

! 
!void cairo_curve_to (cairo_t *cr, double x1, double y1, double x2, double y2, double x3, double y3);
subroutine cairo_curve_to(cr, x1, y1, x2, y2, x3, y3) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: x1
  real(c_double), value :: y1
  real(c_double), value :: x2
  real(c_double), value :: y2
  real(c_double), value :: x3
  real(c_double), value :: y3
end subroutine

! 
!void cairo_arc (cairo_t *cr, double xc, double yc, double radius, double angle1, double angle2);
subroutine cairo_arc(cr, xc, yc, radius, angle1, angle2) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: xc
  real(c_double), value :: yc
  real(c_double), value :: radius
  real(c_double), value :: angle1
  real(c_double), value :: angle2
end subroutine

! 
!void cairo_arc_negative (cairo_t *cr, double xc, double yc, double radius, double angle1, double angle2);
subroutine cairo_arc_negative(cr, xc, yc, radius, angle1, angle2) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: xc
  real(c_double), value :: yc
  real(c_double), value :: radius
  real(c_double), value :: angle1
  real(c_double), value :: angle2
end subroutine

! 
!void cairo_rel_move_to (cairo_t *cr, double dx, double dy);
subroutine cairo_rel_move_to(cr, dx, dy) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: dx
  real(c_double), value :: dy
end subroutine

! 
!void cairo_rel_line_to (cairo_t *cr, double dx, double dy);
subroutine cairo_rel_line_to(cr, dx, dy) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: dx
  real(c_double), value :: dy
end subroutine

! 
!void cairo_rel_curve_to (cairo_t *cr, double dx1, double dy1, double dx2, double dy2, double dx3, double dy3);
subroutine cairo_rel_curve_to(cr, dx1, dy1, dx2, dy2, dx3, dy3) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: dx1
  real(c_double), value :: dy1
  real(c_double), value :: dx2
  real(c_double), value :: dy2
  real(c_double), value :: dx3
  real(c_double), value :: dy3
end subroutine

! 
!void cairo_rectangle (cairo_t *cr, double x, double y, double width, double height);
subroutine cairo_rectangle(cr, x, y, width, height) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: x
  real(c_double), value :: y
  real(c_double), value :: width
  real(c_double), value :: height
end subroutine

! 
!void cairo_close_path (cairo_t *cr);
subroutine cairo_close_path(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_path_extents (cairo_t *cr, double *x1, double *y1, double *x2, double *y2);
subroutine cairo_path_extents(cr, x1, y1, x2, y2) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x1
  type(c_ptr), value :: y1
  type(c_ptr), value :: x2
  type(c_ptr), value :: y2
end subroutine

! 
!void cairo_paint (cairo_t *cr);
subroutine cairo_paint(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_paint_with_alpha (cairo_t *cr, double alpha);
subroutine cairo_paint_with_alpha(cr, alpha) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: alpha
end subroutine

! 
!void cairo_mask (cairo_t *cr, cairo_pattern_t *pattern);
subroutine cairo_mask(cr, pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: pattern
end subroutine

! 
!void cairo_mask_surface (cairo_t *cr, cairo_surface_t *surface, double surface_x, double surface_y);
subroutine cairo_mask_surface(cr, surface, surface_x, surface_y) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: surface
  real(c_double), value :: surface_x
  real(c_double), value :: surface_y
end subroutine

! 
!void cairo_stroke (cairo_t *cr);
subroutine cairo_stroke(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_stroke_preserve (cairo_t *cr);
subroutine cairo_stroke_preserve(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_fill (cairo_t *cr);
subroutine cairo_fill(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_fill_preserve (cairo_t *cr);
subroutine cairo_fill_preserve(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_copy_page (cairo_t *cr);
subroutine cairo_copy_page(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_show_page (cairo_t *cr);
subroutine cairo_show_page(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!cairo_bool_t cairo_in_stroke (cairo_t *cr, double x, double y);
function cairo_in_stroke(cr, x, y) bind(c)
  import :: c_int, c_ptr, c_double
  implicit none
  integer(c_int) :: cairo_in_stroke
  type(c_ptr), value :: cr
  real(c_double), value :: x
  real(c_double), value :: y
end function

! 
!cairo_bool_t cairo_in_fill (cairo_t *cr, double x, double y);
function cairo_in_fill(cr, x, y) bind(c)
  import :: c_int, c_ptr, c_double
  implicit none
  integer(c_int) :: cairo_in_fill
  type(c_ptr), value :: cr
  real(c_double), value :: x
  real(c_double), value :: y
end function

! 
!cairo_bool_t cairo_in_clip (cairo_t *cr, double x, double y);
function cairo_in_clip(cr, x, y) bind(c)
  import :: c_int, c_ptr, c_double
  implicit none
  integer(c_int) :: cairo_in_clip
  type(c_ptr), value :: cr
  real(c_double), value :: x
  real(c_double), value :: y
end function

! 
!void cairo_stroke_extents (cairo_t *cr, double *x1, double *y1, double *x2, double *y2);
subroutine cairo_stroke_extents(cr, x1, y1, x2, y2) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x1
  type(c_ptr), value :: y1
  type(c_ptr), value :: x2
  type(c_ptr), value :: y2
end subroutine

! 
!void cairo_fill_extents (cairo_t *cr, double *x1, double *y1, double *x2, double *y2);
subroutine cairo_fill_extents(cr, x1, y1, x2, y2) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x1
  type(c_ptr), value :: y1
  type(c_ptr), value :: x2
  type(c_ptr), value :: y2
end subroutine

! 
!void cairo_reset_clip (cairo_t *cr);
subroutine cairo_reset_clip(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_clip (cairo_t *cr);
subroutine cairo_clip(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_clip_preserve (cairo_t *cr);
subroutine cairo_clip_preserve(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
end subroutine

! 
!void cairo_clip_extents (cairo_t *cr, double *x1, double *y1, double *x2, double *y2);
subroutine cairo_clip_extents(cr, x1, y1, x2, y2) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x1
  type(c_ptr), value :: y1
  type(c_ptr), value :: x2
  type(c_ptr), value :: y2
end subroutine

! 
!cairo_rectangle_list_t * cairo_copy_clip_rectangle_list (cairo_t *cr);
function cairo_copy_clip_rectangle_list(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_copy_clip_rectangle_list
  type(c_ptr), value :: cr
end function

! 
!void cairo_rectangle_list_destroy (cairo_rectangle_list_t *rectangle_list);
subroutine cairo_rectangle_list_destroy(rectangle_list) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: rectangle_list
end subroutine

! 
!void cairo_tag_begin (cairo_t *cr, const char *tag_name, const char *attributes);
subroutine cairo_tag_begin(cr, tag_name, attributes) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: tag_name
  character(kind=c_char), dimension(*) :: attributes
end subroutine

! 
!void cairo_tag_end (cairo_t *cr, const char *tag_name);
subroutine cairo_tag_end(cr, tag_name) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: tag_name
end subroutine

! 
!cairo_glyph_t * cairo_glyph_allocate (int num_glyphs);
function cairo_glyph_allocate(num_glyphs) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_glyph_allocate
  integer(c_int), value :: num_glyphs
end function

! 
!void cairo_glyph_free (cairo_glyph_t *glyphs);
subroutine cairo_glyph_free(glyphs) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: glyphs
end subroutine

! 
!cairo_text_cluster_t * cairo_text_cluster_allocate (int num_clusters);
function cairo_text_cluster_allocate(num_clusters) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_text_cluster_allocate
  integer(c_int), value :: num_clusters
end function

! 
!void cairo_text_cluster_free (cairo_text_cluster_t *clusters);
subroutine cairo_text_cluster_free(clusters) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: clusters
end subroutine

! 
!cairo_font_options_t * cairo_font_options_create (void);
function cairo_font_options_create() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_font_options_create
end function

! 
!cairo_font_options_t * cairo_font_options_copy (const cairo_font_options_t *original);
function cairo_font_options_copy(original) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_font_options_copy
  type(c_ptr), value :: original
end function

! 
!void cairo_font_options_destroy (cairo_font_options_t *options);
subroutine cairo_font_options_destroy(options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: options
end subroutine

! 
!cairo_status_t cairo_font_options_status (cairo_font_options_t *options);
function cairo_font_options_status(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_status
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_merge (cairo_font_options_t *options, const cairo_font_options_t *other);
subroutine cairo_font_options_merge(options, other) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: options
  type(c_ptr), value :: other
end subroutine

! 
!cairo_bool_t cairo_font_options_equal (const cairo_font_options_t *options, const cairo_font_options_t *other);
function cairo_font_options_equal(options, other) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_equal
  type(c_ptr), value :: options
  type(c_ptr), value :: other
end function

! 
!unsigned long cairo_font_options_hash (const cairo_font_options_t *options);
function cairo_font_options_hash(options) bind(c)
  import :: c_long, c_ptr
  implicit none
  integer(c_long) :: cairo_font_options_hash
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_set_antialias (cairo_font_options_t *options, cairo_antialias_t antialias);
subroutine cairo_font_options_set_antialias(options, antialias) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: antialias
end subroutine

! 
!cairo_antialias_t cairo_font_options_get_antialias (const cairo_font_options_t *options);
function cairo_font_options_get_antialias(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_antialias
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_set_subpixel_order (cairo_font_options_t *options, cairo_subpixel_order_t subpixel_order);
subroutine cairo_font_options_set_subpixel_order(options, subpixel_order)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: subpixel_order
end subroutine

! 
!cairo_subpixel_order_t cairo_font_options_get_subpixel_order (const cairo_font_options_t *options);
function cairo_font_options_get_subpixel_order(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_subpixel_order
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_set_hint_style (cairo_font_options_t *options, cairo_hint_style_t hint_style);
subroutine cairo_font_options_set_hint_style(options, hint_style) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: hint_style
end subroutine

! 
!cairo_hint_style_t cairo_font_options_get_hint_style (const cairo_font_options_t *options);
function cairo_font_options_get_hint_style(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_hint_style
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_set_hint_metrics (cairo_font_options_t *options, cairo_hint_metrics_t hint_metrics);
subroutine cairo_font_options_set_hint_metrics(options, hint_metrics) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: hint_metrics
end subroutine

! 
!cairo_hint_metrics_t cairo_font_options_get_hint_metrics (const cairo_font_options_t *options);
function cairo_font_options_get_hint_metrics(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_hint_metrics
  type(c_ptr), value :: options
end function

! 
!const char * cairo_font_options_get_variations (cairo_font_options_t *options);
function cairo_font_options_get_variations(options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_font_options_get_variations
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_set_variations (cairo_font_options_t *options, const char *variations);
subroutine cairo_font_options_set_variations(options, variations) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: options
  character(kind=c_char), dimension(*) :: variations
end subroutine

! 
!void cairo_font_options_set_color_mode (cairo_font_options_t *options, cairo_color_mode_t color_mode);
subroutine cairo_font_options_set_color_mode(options, color_mode) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: color_mode
end subroutine

! 
!cairo_color_mode_t cairo_font_options_get_color_mode (const cairo_font_options_t *options);
function cairo_font_options_get_color_mode(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_color_mode
  type(c_ptr), value :: options
end function

! 
!unsigned int cairo_font_options_get_color_palette (const cairo_font_options_t *options);
function cairo_font_options_get_color_palette(options) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_color_palette
  type(c_ptr), value :: options
end function

! 
!void cairo_font_options_set_color_palette (cairo_font_options_t *options, unsigned int palette_index);
subroutine cairo_font_options_set_color_palette(options, palette_index) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: palette_index
end subroutine

! 
!void cairo_font_options_set_custom_palette_color (cairo_font_options_t *options, unsigned int index, double red, double green, double blue, double alpha);
subroutine cairo_font_options_set_custom_palette_color(options, index, red,&
& green, blue, alpha) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: options
  integer(c_int), value :: index
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
  real(c_double), value :: alpha
end subroutine

! 
!cairo_status_t cairo_font_options_get_custom_palette_color (cairo_font_options_t *options, unsigned int index, double *red, double *green, double *blue, double *alpha);
function cairo_font_options_get_custom_palette_color(options, index, red,&
& green, blue, alpha) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_options_get_custom_palette_color
  type(c_ptr), value :: options
  integer(c_int), value :: index
  type(c_ptr), value :: red
  type(c_ptr), value :: green
  type(c_ptr), value :: blue
  type(c_ptr), value :: alpha
end function

! 
!void cairo_select_font_face (cairo_t *cr, const char *family, cairo_font_slant_t slant, cairo_font_weight_t weight);
subroutine cairo_select_font_face(cr, family, slant, weight) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: family
  integer(c_int), value :: slant
  integer(c_int), value :: weight
end subroutine

! 
!void cairo_set_font_size (cairo_t *cr, double size);
subroutine cairo_set_font_size(cr, size) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: cr
  real(c_double), value :: size
end subroutine

! 
!void cairo_set_font_matrix (cairo_t *cr, const cairo_matrix_t *matrix);
subroutine cairo_set_font_matrix(cr, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_get_font_matrix (cairo_t *cr, cairo_matrix_t *matrix);
subroutine cairo_get_font_matrix(cr, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_set_font_options (cairo_t *cr, const cairo_font_options_t *options);
subroutine cairo_set_font_options(cr, options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: options
end subroutine

! 
!void cairo_get_font_options (cairo_t *cr, cairo_font_options_t *options);
subroutine cairo_get_font_options(cr, options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: options
end subroutine

! 
!void cairo_set_font_face (cairo_t *cr, cairo_font_face_t *font_face);
subroutine cairo_set_font_face(cr, font_face) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: font_face
end subroutine

! 
!cairo_font_face_t * cairo_get_font_face (cairo_t *cr);
function cairo_get_font_face(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_get_font_face
  type(c_ptr), value :: cr
end function

! 
!void cairo_set_scaled_font (cairo_t *cr, const cairo_scaled_font_t *scaled_font);
subroutine cairo_set_scaled_font(cr, scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: scaled_font
end subroutine

! 
!cairo_scaled_font_t * cairo_get_scaled_font (cairo_t *cr);
function cairo_get_scaled_font(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_get_scaled_font
  type(c_ptr), value :: cr
end function

! 
!void cairo_show_text (cairo_t *cr, const char *utf8);
subroutine cairo_show_text(cr, utf8) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: utf8
end subroutine

! 
!void cairo_show_glyphs (cairo_t *cr, const cairo_glyph_t *glyphs, int num_glyphs);
subroutine cairo_show_glyphs(cr, glyphs, num_glyphs) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: glyphs
  integer(c_int), value :: num_glyphs
end subroutine

! 
!void cairo_show_text_glyphs (cairo_t *cr, const char *utf8, int utf8_len, const cairo_glyph_t *glyphs, int num_glyphs, const cairo_text_cluster_t *clusters, int num_clusters, cairo_text_cluster_flags_t cluster_flags);
subroutine cairo_show_text_glyphs(cr, utf8, utf8_len, glyphs, num_glyphs,&
& clusters, num_clusters, cluster_flags) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: utf8
  integer(c_int), value :: utf8_len
  type(c_ptr), value :: glyphs
  integer(c_int), value :: num_glyphs
  type(c_ptr), value :: clusters
  integer(c_int), value :: num_clusters
  integer(c_int), value :: cluster_flags
end subroutine

! 
!void cairo_text_path (cairo_t *cr, const char *utf8);
subroutine cairo_text_path(cr, utf8) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: utf8
end subroutine

! 
!void cairo_glyph_path (cairo_t *cr, const cairo_glyph_t *glyphs, int num_glyphs);
subroutine cairo_glyph_path(cr, glyphs, num_glyphs) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: glyphs
  integer(c_int), value :: num_glyphs
end subroutine

! 
!void cairo_text_extents (cairo_t *cr, const char *utf8, cairo_text_extents_t *extents);
subroutine cairo_text_extents(cr, utf8, extents) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: cr
  character(kind=c_char), dimension(*) :: utf8
  type(c_ptr), value :: extents
end subroutine

! 
!void cairo_glyph_extents (cairo_t *cr, const cairo_glyph_t *glyphs, int num_glyphs, cairo_text_extents_t *extents);
subroutine cairo_glyph_extents(cr, glyphs, num_glyphs, extents) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: glyphs
  integer(c_int), value :: num_glyphs
  type(c_ptr), value :: extents
end subroutine

! 
!void cairo_font_extents (cairo_t *cr, cairo_font_extents_t *extents);
subroutine cairo_font_extents(cr, extents) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: extents
end subroutine

! 
!cairo_font_face_t * cairo_font_face_reference (cairo_font_face_t *font_face);
function cairo_font_face_reference(font_face) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_font_face_reference
  type(c_ptr), value :: font_face
end function

! 
!void cairo_font_face_destroy (cairo_font_face_t *font_face);
subroutine cairo_font_face_destroy(font_face) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: font_face
end subroutine

! 
!unsigned int cairo_font_face_get_reference_count (cairo_font_face_t *font_face);
function cairo_font_face_get_reference_count(font_face) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_face_get_reference_count
  type(c_ptr), value :: font_face
end function

! 
!cairo_status_t cairo_font_face_status (cairo_font_face_t *font_face);
function cairo_font_face_status(font_face) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_face_status
  type(c_ptr), value :: font_face
end function

! 
!cairo_font_type_t cairo_font_face_get_type (cairo_font_face_t *font_face);
function cairo_font_face_get_type(font_face) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_font_face_get_type
  type(c_ptr), value :: font_face
end function

! 
!void * cairo_font_face_get_user_data (cairo_font_face_t *font_face, const cairo_user_data_key_t *key);
function cairo_font_face_get_user_data(font_face, key) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_font_face_get_user_data
  type(c_ptr), value :: font_face
  type(c_ptr), value :: key
end function

! 
!cairo_status_t cairo_font_face_set_user_data (cairo_font_face_t *font_face, const cairo_user_data_key_t *key, void *user_data, cairo_destroy_func_t destroy);
function cairo_font_face_set_user_data(font_face, key, user_data, destroy)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_font_face_set_user_data
  type(c_ptr), value :: font_face
  type(c_ptr), value :: key
  type(c_ptr), value :: user_data
  type(c_funptr), value :: destroy
end function

! 
!cairo_scaled_font_t * cairo_scaled_font_create (cairo_font_face_t *font_face, const cairo_matrix_t *font_matrix, const cairo_matrix_t *ctm, const cairo_font_options_t *options);
function cairo_scaled_font_create(font_face, font_matrix, ctm, options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_scaled_font_create
  type(c_ptr), value :: font_face
  type(c_ptr), value :: font_matrix
  type(c_ptr), value :: ctm
  type(c_ptr), value :: options
end function

! 
!cairo_scaled_font_t * cairo_scaled_font_reference (cairo_scaled_font_t *scaled_font);
function cairo_scaled_font_reference(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_scaled_font_reference
  type(c_ptr), value :: scaled_font
end function

! 
!void cairo_scaled_font_destroy (cairo_scaled_font_t *scaled_font);
subroutine cairo_scaled_font_destroy(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
end subroutine

! 
!unsigned int cairo_scaled_font_get_reference_count (cairo_scaled_font_t *scaled_font);
function cairo_scaled_font_get_reference_count(scaled_font) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_scaled_font_get_reference_count
  type(c_ptr), value :: scaled_font
end function

! 
!cairo_status_t cairo_scaled_font_status (cairo_scaled_font_t *scaled_font);
function cairo_scaled_font_status(scaled_font) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_scaled_font_status
  type(c_ptr), value :: scaled_font
end function

! 
!cairo_font_type_t cairo_scaled_font_get_type (cairo_scaled_font_t *scaled_font);
function cairo_scaled_font_get_type(scaled_font) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_scaled_font_get_type
  type(c_ptr), value :: scaled_font
end function

! 
!void * cairo_scaled_font_get_user_data (cairo_scaled_font_t *scaled_font, const cairo_user_data_key_t *key);
function cairo_scaled_font_get_user_data(scaled_font, key) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_scaled_font_get_user_data
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: key
end function

! 
!cairo_status_t cairo_scaled_font_set_user_data (cairo_scaled_font_t *scaled_font, const cairo_user_data_key_t *key, void *user_data, cairo_destroy_func_t destroy);
function cairo_scaled_font_set_user_data(scaled_font, key, user_data, destroy)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_scaled_font_set_user_data
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: key
  type(c_ptr), value :: user_data
  type(c_funptr), value :: destroy
end function

! 
!void cairo_scaled_font_extents (cairo_scaled_font_t *scaled_font, cairo_font_extents_t *extents);
subroutine cairo_scaled_font_extents(scaled_font, extents) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: extents
end subroutine

! 
!void cairo_scaled_font_text_extents (cairo_scaled_font_t *scaled_font, const char *utf8, cairo_text_extents_t *extents);
subroutine cairo_scaled_font_text_extents(scaled_font, utf8, extents) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: scaled_font
  character(kind=c_char), dimension(*) :: utf8
  type(c_ptr), value :: extents
end subroutine

! 
!void cairo_scaled_font_glyph_extents (cairo_scaled_font_t *scaled_font, const cairo_glyph_t *glyphs, int num_glyphs, cairo_text_extents_t *extents);
subroutine cairo_scaled_font_glyph_extents(scaled_font, glyphs, num_glyphs,&
& extents) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: glyphs
  integer(c_int), value :: num_glyphs
  type(c_ptr), value :: extents
end subroutine

! 
!cairo_status_t cairo_scaled_font_text_to_glyphs (cairo_scaled_font_t *scaled_font, double x, double y, const char *utf8, int utf8_len, cairo_glyph_t **glyphs, int *num_glyphs, cairo_text_cluster_t **clusters, int *num_clusters, cairo_text_cluster_flags_t *cluster_flags);
function cairo_scaled_font_text_to_glyphs(scaled_font, x, y, utf8, utf8_len,&
& glyphs, num_glyphs, clusters, num_clusters, cluster_flags) bind(c)
  import :: c_int, c_ptr, c_double, c_char
  implicit none
  integer(c_int) :: cairo_scaled_font_text_to_glyphs
  type(c_ptr), value :: scaled_font
  real(c_double), value :: x
  real(c_double), value :: y
  character(kind=c_char), dimension(*) :: utf8
  integer(c_int), value :: utf8_len
  type(c_ptr), value :: glyphs
  type(c_ptr), value :: num_glyphs
  type(c_ptr), value :: clusters
  type(c_ptr), value :: num_clusters
  type(c_ptr), value :: cluster_flags
end function

! 
!cairo_font_face_t * cairo_scaled_font_get_font_face (cairo_scaled_font_t *scaled_font);
function cairo_scaled_font_get_font_face(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_scaled_font_get_font_face
  type(c_ptr), value :: scaled_font
end function

! 
!void cairo_scaled_font_get_font_matrix (cairo_scaled_font_t *scaled_font, cairo_matrix_t *font_matrix);
subroutine cairo_scaled_font_get_font_matrix(scaled_font, font_matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: font_matrix
end subroutine

! 
!void cairo_scaled_font_get_ctm (cairo_scaled_font_t *scaled_font, cairo_matrix_t *ctm);
subroutine cairo_scaled_font_get_ctm(scaled_font, ctm) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: ctm
end subroutine

! 
!void cairo_scaled_font_get_scale_matrix (cairo_scaled_font_t *scaled_font, cairo_matrix_t *scale_matrix);
subroutine cairo_scaled_font_get_scale_matrix(scaled_font, scale_matrix)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: scale_matrix
end subroutine

! 
!void cairo_scaled_font_get_font_options (cairo_scaled_font_t *scaled_font, cairo_font_options_t *options);
subroutine cairo_scaled_font_get_font_options(scaled_font, options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: scaled_font
  type(c_ptr), value :: options
end subroutine

! 
!cairo_font_face_t * cairo_toy_font_face_create (const char *family, cairo_font_slant_t slant, cairo_font_weight_t weight);
function cairo_toy_font_face_create(family, slant, weight) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: cairo_toy_font_face_create
  character(kind=c_char), dimension(*) :: family
  integer(c_int), value :: slant
  integer(c_int), value :: weight
end function

! 
!const char * cairo_toy_font_face_get_family (cairo_font_face_t *font_face);
function cairo_toy_font_face_get_family(font_face) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_toy_font_face_get_family
  type(c_ptr), value :: font_face
end function

! 
!cairo_font_slant_t cairo_toy_font_face_get_slant (cairo_font_face_t *font_face);
function cairo_toy_font_face_get_slant(font_face) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_toy_font_face_get_slant
  type(c_ptr), value :: font_face
end function

! 
!cairo_font_weight_t cairo_toy_font_face_get_weight (cairo_font_face_t *font_face);
function cairo_toy_font_face_get_weight(font_face) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_toy_font_face_get_weight
  type(c_ptr), value :: font_face
end function

! 
!cairo_font_face_t * cairo_user_font_face_create (void);
function cairo_user_font_face_create() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_user_font_face_create
end function

! 
!void cairo_user_font_face_set_init_func (cairo_font_face_t *font_face, cairo_user_scaled_font_init_func_t init_func);
subroutine cairo_user_font_face_set_init_func(font_face, init_func) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: font_face
  type(c_funptr), value :: init_func
end subroutine

! 
!void cairo_user_font_face_set_render_glyph_func (cairo_font_face_t *font_face, cairo_user_scaled_font_render_glyph_func_t render_glyph_func);
subroutine cairo_user_font_face_set_render_glyph_func(font_face,&
& render_glyph_func) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: font_face
  type(c_funptr), value :: render_glyph_func
end subroutine

! 
!void cairo_user_font_face_set_render_color_glyph_func (cairo_font_face_t *font_face, cairo_user_scaled_font_render_glyph_func_t render_glyph_func);
subroutine cairo_user_font_face_set_render_color_glyph_func(font_face,&
& render_glyph_func) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: font_face
  type(c_funptr), value :: render_glyph_func
end subroutine

! 
!void cairo_user_font_face_set_text_to_glyphs_func (cairo_font_face_t *font_face, cairo_user_scaled_font_text_to_glyphs_func_t text_to_glyphs_func);
subroutine cairo_user_font_face_set_text_to_glyphs_func(font_face,&
& text_to_glyphs_func) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: font_face
  type(c_funptr), value :: text_to_glyphs_func
end subroutine

! 
!void cairo_user_font_face_set_unicode_to_glyph_func (cairo_font_face_t *font_face, cairo_user_scaled_font_unicode_to_glyph_func_t unicode_to_glyph_func);
subroutine cairo_user_font_face_set_unicode_to_glyph_func(font_face,&
& unicode_to_glyph_func) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: font_face
  type(c_funptr), value :: unicode_to_glyph_func
end subroutine

! 
!cairo_user_scaled_font_init_func_t cairo_user_font_face_get_init_func (cairo_font_face_t *font_face);
function cairo_user_font_face_get_init_func(font_face) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_user_font_face_get_init_func
  type(c_ptr), value :: font_face
end function

! 
!cairo_user_scaled_font_render_glyph_func_t cairo_user_font_face_get_render_glyph_func (cairo_font_face_t *font_face);
function cairo_user_font_face_get_render_glyph_func(font_face) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_user_font_face_get_render_glyph_func
  type(c_ptr), value :: font_face
end function

! 
!cairo_user_scaled_font_render_glyph_func_t cairo_user_font_face_get_render_color_glyph_func (cairo_font_face_t *font_face);
function cairo_user_font_face_get_render_color_glyph_func(font_face) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_user_font_face_get_render_color_glyph_func
  type(c_ptr), value :: font_face
end function

! 
!cairo_user_scaled_font_text_to_glyphs_func_t cairo_user_font_face_get_text_to_glyphs_func (cairo_font_face_t *font_face);
function cairo_user_font_face_get_text_to_glyphs_func(font_face) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_user_font_face_get_text_to_glyphs_func
  type(c_ptr), value :: font_face
end function

! 
!cairo_user_scaled_font_unicode_to_glyph_func_t cairo_user_font_face_get_unicode_to_glyph_func (cairo_font_face_t *font_face);
function cairo_user_font_face_get_unicode_to_glyph_func(font_face) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_user_font_face_get_unicode_to_glyph_func
  type(c_ptr), value :: font_face
end function

! 
!cairo_pattern_t * cairo_user_scaled_font_get_foreground_marker (cairo_scaled_font_t *scaled_font);
function cairo_user_scaled_font_get_foreground_marker(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_user_scaled_font_get_foreground_marker
  type(c_ptr), value :: scaled_font
end function

! 
!cairo_pattern_t * cairo_user_scaled_font_get_foreground_source (cairo_scaled_font_t *scaled_font);
function cairo_user_scaled_font_get_foreground_source(scaled_font) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_user_scaled_font_get_foreground_source
  type(c_ptr), value :: scaled_font
end function

! 
!cairo_operator_t cairo_get_operator (cairo_t *cr);
function cairo_get_operator(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_operator
  type(c_ptr), value :: cr
end function

! 
!cairo_pattern_t * cairo_get_source (cairo_t *cr);
function cairo_get_source(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_get_source
  type(c_ptr), value :: cr
end function

! 
!double cairo_get_tolerance (cairo_t *cr);
function cairo_get_tolerance(cr) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_get_tolerance
  type(c_ptr), value :: cr
end function

! 
!cairo_antialias_t cairo_get_antialias (cairo_t *cr);
function cairo_get_antialias(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_antialias
  type(c_ptr), value :: cr
end function

! 
!cairo_bool_t cairo_has_current_point (cairo_t *cr);
function cairo_has_current_point(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_has_current_point
  type(c_ptr), value :: cr
end function

! 
!void cairo_get_current_point (cairo_t *cr, double *x, double *y);
subroutine cairo_get_current_point(cr, x, y) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: x
  type(c_ptr), value :: y
end subroutine

! 
!cairo_fill_rule_t cairo_get_fill_rule (cairo_t *cr);
function cairo_get_fill_rule(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_fill_rule
  type(c_ptr), value :: cr
end function

! 
!double cairo_get_line_width (cairo_t *cr);
function cairo_get_line_width(cr) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_get_line_width
  type(c_ptr), value :: cr
end function

! 
!cairo_bool_t cairo_get_hairline (cairo_t *cr);
function cairo_get_hairline(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_hairline
  type(c_ptr), value :: cr
end function

! 
!cairo_line_cap_t cairo_get_line_cap (cairo_t *cr);
function cairo_get_line_cap(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_line_cap
  type(c_ptr), value :: cr
end function

! 
!cairo_line_join_t cairo_get_line_join (cairo_t *cr);
function cairo_get_line_join(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_line_join
  type(c_ptr), value :: cr
end function

! 
!double cairo_get_miter_limit (cairo_t *cr);
function cairo_get_miter_limit(cr) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_get_miter_limit
  type(c_ptr), value :: cr
end function

! 
!int cairo_get_dash_count (cairo_t *cr);
function cairo_get_dash_count(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_get_dash_count
  type(c_ptr), value :: cr
end function

! 
!void cairo_get_dash (cairo_t *cr, double *dashes, double *offset);
subroutine cairo_get_dash(cr, dashes, offset) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: dashes
  type(c_ptr), value :: offset
end subroutine

! 
!void cairo_get_matrix (cairo_t *cr, cairo_matrix_t *matrix);
subroutine cairo_get_matrix(cr, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: matrix
end subroutine

! 
!cairo_surface_t * cairo_get_target (cairo_t *cr);
function cairo_get_target(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_get_target
  type(c_ptr), value :: cr
end function

! 
!cairo_surface_t * cairo_get_group_target (cairo_t *cr);
function cairo_get_group_target(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_get_group_target
  type(c_ptr), value :: cr
end function

! 
!cairo_path_t * cairo_copy_path (cairo_t *cr);
function cairo_copy_path(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_copy_path
  type(c_ptr), value :: cr
end function

! 
!cairo_path_t * cairo_copy_path_flat (cairo_t *cr);
function cairo_copy_path_flat(cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_copy_path_flat
  type(c_ptr), value :: cr
end function

! 
!void cairo_append_path (cairo_t *cr, const cairo_path_t *path);
subroutine cairo_append_path(cr, path) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: cr
  type(c_ptr), value :: path
end subroutine

! 
!void cairo_path_destroy (cairo_path_t *path);
subroutine cairo_path_destroy(path) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: path
end subroutine

! 
!cairo_status_t cairo_status (cairo_t *cr);
function cairo_status(cr) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_status
  type(c_ptr), value :: cr
end function

! 
!const char * cairo_status_to_string (cairo_status_t status);
function cairo_status_to_string(status) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_status_to_string
  integer(c_int), value :: status
end function

! 
!cairo_device_t * cairo_device_reference (cairo_device_t *device);
function cairo_device_reference(device) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_device_reference
  type(c_ptr), value :: device
end function

! 
!cairo_device_type_t cairo_device_get_type (cairo_device_t *device);
function cairo_device_get_type(device) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_device_get_type
  type(c_ptr), value :: device
end function

! 
!cairo_status_t cairo_device_status (cairo_device_t *device);
function cairo_device_status(device) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_device_status
  type(c_ptr), value :: device
end function

! 
!cairo_status_t cairo_device_acquire (cairo_device_t *device);
function cairo_device_acquire(device) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_device_acquire
  type(c_ptr), value :: device
end function

! 
!void cairo_device_release (cairo_device_t *device);
subroutine cairo_device_release(device) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: device
end subroutine

! 
!void cairo_device_flush (cairo_device_t *device);
subroutine cairo_device_flush(device) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: device
end subroutine

! 
!void cairo_device_finish (cairo_device_t *device);
subroutine cairo_device_finish(device) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: device
end subroutine

! 
!void cairo_device_destroy (cairo_device_t *device);
subroutine cairo_device_destroy(device) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: device
end subroutine

! 
!unsigned int cairo_device_get_reference_count (cairo_device_t *device);
function cairo_device_get_reference_count(device) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_device_get_reference_count
  type(c_ptr), value :: device
end function

! 
!void * cairo_device_get_user_data (cairo_device_t *device, const cairo_user_data_key_t *key);
function cairo_device_get_user_data(device, key) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_device_get_user_data
  type(c_ptr), value :: device
  type(c_ptr), value :: key
end function

! 
!cairo_status_t cairo_device_set_user_data (cairo_device_t *device, const cairo_user_data_key_t *key, void *user_data, cairo_destroy_func_t destroy);
function cairo_device_set_user_data(device, key, user_data, destroy) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_device_set_user_data
  type(c_ptr), value :: device
  type(c_ptr), value :: key
  type(c_ptr), value :: user_data
  type(c_funptr), value :: destroy
end function

! 
!cairo_surface_t * cairo_surface_create_similar (cairo_surface_t *other, cairo_content_t content, int width, int height);
function cairo_surface_create_similar(other, content, width, height) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_surface_create_similar
  type(c_ptr), value :: other
  integer(c_int), value :: content
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!cairo_surface_t * cairo_surface_create_similar_image (cairo_surface_t *other, cairo_format_t format, int width, int height);
function cairo_surface_create_similar_image(other, format, width, height)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_surface_create_similar_image
  type(c_ptr), value :: other
  integer(c_int), value :: format
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!cairo_surface_t * cairo_surface_map_to_image (cairo_surface_t *surface, const cairo_rectangle_int_t *extents);
function cairo_surface_map_to_image(surface, extents) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_surface_map_to_image
  type(c_ptr), value :: surface
  type(c_ptr), value :: extents
end function

! 
!void cairo_surface_unmap_image (cairo_surface_t *surface, cairo_surface_t *image);
subroutine cairo_surface_unmap_image(surface, image) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
  type(c_ptr), value :: image
end subroutine

! 
!cairo_surface_t * cairo_surface_create_for_rectangle (cairo_surface_t *target, double x, double y, double width, double height);
function cairo_surface_create_for_rectangle(target, x, y, width, height)&
& bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr) :: cairo_surface_create_for_rectangle
  type(c_ptr), value :: target
  real(c_double), value :: x
  real(c_double), value :: y
  real(c_double), value :: width
  real(c_double), value :: height
end function

! 
!cairo_surface_t * cairo_surface_create_observer (cairo_surface_t *target, cairo_surface_observer_mode_t mode);
function cairo_surface_create_observer(target, mode) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_surface_create_observer
  type(c_ptr), value :: target
  integer(c_int), value :: mode
end function

! 
!cairo_status_t cairo_surface_observer_add_paint_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_paint_callback(abstract_surface, func,&
& data) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_paint_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_add_mask_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_mask_callback(abstract_surface, func, data)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_mask_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_add_fill_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_fill_callback(abstract_surface, func, data)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_fill_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_add_stroke_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_stroke_callback(abstract_surface, func,&
& data) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_stroke_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_add_glyphs_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_glyphs_callback(abstract_surface, func,&
& data) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_glyphs_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_add_flush_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_flush_callback(abstract_surface, func,&
& data) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_flush_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_add_finish_callback (cairo_surface_t *abstract_surface, cairo_surface_observer_callback_t func, void *data);
function cairo_surface_observer_add_finish_callback(abstract_surface, func,&
& data) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_add_finish_callback
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: func
  type(c_ptr), value :: data
end function

! 
!cairo_status_t cairo_surface_observer_print (cairo_surface_t *abstract_surface, cairo_write_func_t write_func, void *closure);
function cairo_surface_observer_print(abstract_surface, write_func, closure)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_observer_print
  type(c_ptr), value :: abstract_surface
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
end function

! 
!double cairo_surface_observer_elapsed (cairo_surface_t *abstract_surface);
function cairo_surface_observer_elapsed(abstract_surface) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_surface_observer_elapsed
  type(c_ptr), value :: abstract_surface
end function

! 
!cairo_status_t cairo_device_observer_print (cairo_device_t *abstract_device, cairo_write_func_t write_func, void *closure);
function cairo_device_observer_print(abstract_device, write_func, closure)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_device_observer_print
  type(c_ptr), value :: abstract_device
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
end function

! 
!double cairo_device_observer_elapsed (cairo_device_t *abstract_device);
function cairo_device_observer_elapsed(abstract_device) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_device_observer_elapsed
  type(c_ptr), value :: abstract_device
end function

! 
!double cairo_device_observer_paint_elapsed (cairo_device_t *abstract_device);
function cairo_device_observer_paint_elapsed(abstract_device) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_device_observer_paint_elapsed
  type(c_ptr), value :: abstract_device
end function

! 
!double cairo_device_observer_mask_elapsed (cairo_device_t *abstract_device);
function cairo_device_observer_mask_elapsed(abstract_device) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_device_observer_mask_elapsed
  type(c_ptr), value :: abstract_device
end function

! 
!double cairo_device_observer_fill_elapsed (cairo_device_t *abstract_device);
function cairo_device_observer_fill_elapsed(abstract_device) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_device_observer_fill_elapsed
  type(c_ptr), value :: abstract_device
end function

! 
!double cairo_device_observer_stroke_elapsed (cairo_device_t *abstract_device);
function cairo_device_observer_stroke_elapsed(abstract_device) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_device_observer_stroke_elapsed
  type(c_ptr), value :: abstract_device
end function

! 
!double cairo_device_observer_glyphs_elapsed (cairo_device_t *abstract_device);
function cairo_device_observer_glyphs_elapsed(abstract_device) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: cairo_device_observer_glyphs_elapsed
  type(c_ptr), value :: abstract_device
end function

! 
!cairo_surface_t * cairo_surface_reference (cairo_surface_t *surface);
function cairo_surface_reference(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_surface_reference
  type(c_ptr), value :: surface
end function

! 
!void cairo_surface_finish (cairo_surface_t *surface);
subroutine cairo_surface_finish(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!void cairo_surface_destroy (cairo_surface_t *surface);
subroutine cairo_surface_destroy(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!cairo_device_t * cairo_surface_get_device (cairo_surface_t *surface);
function cairo_surface_get_device(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_surface_get_device
  type(c_ptr), value :: surface
end function

! 
!unsigned int cairo_surface_get_reference_count (cairo_surface_t *surface);
function cairo_surface_get_reference_count(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_surface_get_reference_count
  type(c_ptr), value :: surface
end function

! 
!cairo_status_t cairo_surface_status (cairo_surface_t *surface);
function cairo_surface_status(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_surface_status
  type(c_ptr), value :: surface
end function

! 
!cairo_surface_type_t cairo_surface_get_type (cairo_surface_t *surface);
function cairo_surface_get_type(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_surface_get_type
  type(c_ptr), value :: surface
end function

! 
!cairo_content_t cairo_surface_get_content (cairo_surface_t *surface);
function cairo_surface_get_content(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_surface_get_content
  type(c_ptr), value :: surface
end function

! 
!cairo_status_t cairo_surface_write_to_png (cairo_surface_t *surface, const char *filename);
function cairo_surface_write_to_png(surface, filename) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: cairo_surface_write_to_png
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: filename
end function

! 
!cairo_status_t cairo_surface_write_to_png_stream (cairo_surface_t *surface, cairo_write_func_t write_func, void *closure);
function cairo_surface_write_to_png_stream(surface, write_func, closure)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_write_to_png_stream
  type(c_ptr), value :: surface
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
end function

! 
!void * cairo_surface_get_user_data (cairo_surface_t *surface, const cairo_user_data_key_t *key);
function cairo_surface_get_user_data(surface, key) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_surface_get_user_data
  type(c_ptr), value :: surface
  type(c_ptr), value :: key
end function

! 
!cairo_status_t cairo_surface_set_user_data (cairo_surface_t *surface, const cairo_user_data_key_t *key, void *user_data, cairo_destroy_func_t destroy);
function cairo_surface_set_user_data(surface, key, user_data, destroy) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_set_user_data
  type(c_ptr), value :: surface
  type(c_ptr), value :: key
  type(c_ptr), value :: user_data
  type(c_funptr), value :: destroy
end function

! 
!void cairo_surface_get_mime_data (cairo_surface_t *surface, const char *mime_type, const unsigned char **data, unsigned long *length);
subroutine cairo_surface_get_mime_data(surface, mime_type, data, length)&
& bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: mime_type
  type(c_ptr), value :: data
  type(c_ptr), value :: length
end subroutine

! 
!cairo_status_t cairo_surface_set_mime_data (cairo_surface_t *surface, const char *mime_type, const unsigned char *data, unsigned long length, cairo_destroy_func_t destroy, void *closure);
function cairo_surface_set_mime_data(surface, mime_type, data, length, destroy,&
& closure) bind(c)
  import :: c_int, c_ptr, c_char, c_long, c_funptr
  implicit none
  integer(c_int) :: cairo_surface_set_mime_data
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: mime_type
  type(c_ptr), value :: data
  integer(c_long), value :: length
  type(c_funptr), value :: destroy
  type(c_ptr), value :: closure
end function

! 
!cairo_bool_t cairo_surface_supports_mime_type (cairo_surface_t *surface, const char *mime_type);
function cairo_surface_supports_mime_type(surface, mime_type) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: cairo_surface_supports_mime_type
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: mime_type
end function

! 
!void cairo_surface_get_font_options (cairo_surface_t *surface, cairo_font_options_t *options);
subroutine cairo_surface_get_font_options(surface, options) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
  type(c_ptr), value :: options
end subroutine

! 
!void cairo_surface_flush (cairo_surface_t *surface);
subroutine cairo_surface_flush(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!void cairo_surface_mark_dirty (cairo_surface_t *surface);
subroutine cairo_surface_mark_dirty(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!void cairo_surface_mark_dirty_rectangle (cairo_surface_t *surface, int x, int y, int width, int height);
subroutine cairo_surface_mark_dirty_rectangle(surface, x, y, width, height)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: x
  integer(c_int), value :: y
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

! 
!void cairo_surface_set_device_scale (cairo_surface_t *surface, double x_scale, double y_scale);
subroutine cairo_surface_set_device_scale(surface, x_scale, y_scale) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: surface
  real(c_double), value :: x_scale
  real(c_double), value :: y_scale
end subroutine

! 
!void cairo_surface_get_device_scale (cairo_surface_t *surface, double *x_scale, double *y_scale);
subroutine cairo_surface_get_device_scale(surface, x_scale, y_scale) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
  type(c_ptr), value :: x_scale
  type(c_ptr), value :: y_scale
end subroutine

! 
!void cairo_surface_set_device_offset (cairo_surface_t *surface, double x_offset, double y_offset);
subroutine cairo_surface_set_device_offset(surface, x_offset, y_offset) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: surface
  real(c_double), value :: x_offset
  real(c_double), value :: y_offset
end subroutine

! 
!void cairo_surface_get_device_offset (cairo_surface_t *surface, double *x_offset, double *y_offset);
subroutine cairo_surface_get_device_offset(surface, x_offset, y_offset) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
  type(c_ptr), value :: x_offset
  type(c_ptr), value :: y_offset
end subroutine

! 
!void cairo_surface_set_fallback_resolution (cairo_surface_t *surface, double x_pixels_per_inch, double y_pixels_per_inch);
subroutine cairo_surface_set_fallback_resolution(surface, x_pixels_per_inch,&
& y_pixels_per_inch) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: surface
  real(c_double), value :: x_pixels_per_inch
  real(c_double), value :: y_pixels_per_inch
end subroutine

! 
!void cairo_surface_get_fallback_resolution (cairo_surface_t *surface, double *x_pixels_per_inch, double *y_pixels_per_inch);
subroutine cairo_surface_get_fallback_resolution(surface, x_pixels_per_inch,&
& y_pixels_per_inch) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
  type(c_ptr), value :: x_pixels_per_inch
  type(c_ptr), value :: y_pixels_per_inch
end subroutine

! 
!void cairo_surface_copy_page (cairo_surface_t *surface);
subroutine cairo_surface_copy_page(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!void cairo_surface_show_page (cairo_surface_t *surface);
subroutine cairo_surface_show_page(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
end subroutine

! 
!cairo_bool_t cairo_surface_has_show_text_glyphs (cairo_surface_t *surface);
function cairo_surface_has_show_text_glyphs(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_surface_has_show_text_glyphs
  type(c_ptr), value :: surface
end function

! 
!cairo_surface_t * cairo_image_surface_create (cairo_format_t format, int width, int height);
function cairo_image_surface_create(format, width, height) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_image_surface_create
  integer(c_int), value :: format
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!int cairo_format_stride_for_width (cairo_format_t format, int width);
function cairo_format_stride_for_width(format, width) bind(c)
  import :: c_int
  implicit none
  integer(c_int) :: cairo_format_stride_for_width
  integer(c_int), value :: format
  integer(c_int), value :: width
end function

! 
!cairo_surface_t * cairo_image_surface_create_for_data (unsigned char *data, cairo_format_t format, int width, int height, int stride);
function cairo_image_surface_create_for_data(data, format, width, height,&
& stride) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_image_surface_create_for_data
  type(c_ptr), value :: data
  integer(c_int), value :: format
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: stride
end function

! 
!unsigned char * cairo_image_surface_get_data (cairo_surface_t *surface);
function cairo_image_surface_get_data(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_image_surface_get_data
  type(c_ptr), value :: surface
end function

! 
!cairo_format_t cairo_image_surface_get_format (cairo_surface_t *surface);
function cairo_image_surface_get_format(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_image_surface_get_format
  type(c_ptr), value :: surface
end function

! 
!int cairo_image_surface_get_width (cairo_surface_t *surface);
function cairo_image_surface_get_width(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_image_surface_get_width
  type(c_ptr), value :: surface
end function

! 
!int cairo_image_surface_get_height (cairo_surface_t *surface);
function cairo_image_surface_get_height(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_image_surface_get_height
  type(c_ptr), value :: surface
end function

! 
!int cairo_image_surface_get_stride (cairo_surface_t *surface);
function cairo_image_surface_get_stride(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_image_surface_get_stride
  type(c_ptr), value :: surface
end function

! 
!cairo_surface_t * cairo_image_surface_create_from_png (const char *filename);
function cairo_image_surface_create_from_png(filename) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: cairo_image_surface_create_from_png
  character(kind=c_char), dimension(*) :: filename
end function

! 
!cairo_surface_t * cairo_image_surface_create_from_png_stream (cairo_read_func_t read_func, void *closure);
function cairo_image_surface_create_from_png_stream(read_func, closure) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr) :: cairo_image_surface_create_from_png_stream
  type(c_funptr), value :: read_func
  type(c_ptr), value :: closure
end function

! 
!cairo_surface_t * cairo_recording_surface_create (cairo_content_t content, const cairo_rectangle_t *extents);
function cairo_recording_surface_create(content, extents) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_recording_surface_create
  integer(c_int), value :: content
  type(c_ptr), value :: extents
end function

! 
!void cairo_recording_surface_ink_extents (cairo_surface_t *surface, double *x0, double *y0, double *width, double *height);
subroutine cairo_recording_surface_ink_extents(surface, x0, y0, width, height)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: surface
  type(c_ptr), value :: x0
  type(c_ptr), value :: y0
  type(c_ptr), value :: width
  type(c_ptr), value :: height
end subroutine

! 
!cairo_bool_t cairo_recording_surface_get_extents (cairo_surface_t *surface, cairo_rectangle_t *extents);
function cairo_recording_surface_get_extents(surface, extents) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_recording_surface_get_extents
  type(c_ptr), value :: surface
  type(c_ptr), value :: extents
end function

! 
!cairo_pattern_t * cairo_pattern_create_raster_source (void *user_data, cairo_content_t content, int width, int height);
function cairo_pattern_create_raster_source(user_data, content, width, height)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_pattern_create_raster_source
  type(c_ptr), value :: user_data
  integer(c_int), value :: content
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!void cairo_raster_source_pattern_set_callback_data (cairo_pattern_t *pattern, void *data);
subroutine cairo_raster_source_pattern_set_callback_data(pattern, data) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_ptr), value :: data
end subroutine

! 
!void * cairo_raster_source_pattern_get_callback_data (cairo_pattern_t *pattern);
function cairo_raster_source_pattern_get_callback_data(pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_raster_source_pattern_get_callback_data
  type(c_ptr), value :: pattern
end function

! 
!void cairo_raster_source_pattern_set_acquire (cairo_pattern_t *pattern, cairo_raster_source_acquire_func_t acquire, cairo_raster_source_release_func_t release);
subroutine cairo_raster_source_pattern_set_acquire(pattern, acquire, release)&
& bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_funptr), value :: acquire
  type(c_funptr), value :: release
end subroutine

! 
!void cairo_raster_source_pattern_get_acquire (cairo_pattern_t *pattern, cairo_raster_source_acquire_func_t *acquire, cairo_raster_source_release_func_t *release);
subroutine cairo_raster_source_pattern_get_acquire(pattern, acquire, release)&
& bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_funptr), value :: acquire
  type(c_funptr), value :: release
end subroutine

! 
!void cairo_raster_source_pattern_set_snapshot (cairo_pattern_t *pattern, cairo_raster_source_snapshot_func_t snapshot);
subroutine cairo_raster_source_pattern_set_snapshot(pattern, snapshot) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_funptr), value :: snapshot
end subroutine

! 
!cairo_raster_source_snapshot_func_t cairo_raster_source_pattern_get_snapshot (cairo_pattern_t *pattern);
function cairo_raster_source_pattern_get_snapshot(pattern) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_raster_source_pattern_get_snapshot
  type(c_ptr), value :: pattern
end function

! 
!void cairo_raster_source_pattern_set_copy (cairo_pattern_t *pattern, cairo_raster_source_copy_func_t copy);
subroutine cairo_raster_source_pattern_set_copy(pattern, copy) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_funptr), value :: copy
end subroutine

! 
!cairo_raster_source_copy_func_t cairo_raster_source_pattern_get_copy (cairo_pattern_t *pattern);
function cairo_raster_source_pattern_get_copy(pattern) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_raster_source_pattern_get_copy
  type(c_ptr), value :: pattern
end function

! 
!void cairo_raster_source_pattern_set_finish (cairo_pattern_t *pattern, cairo_raster_source_finish_func_t finish);
subroutine cairo_raster_source_pattern_set_finish(pattern, finish) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_funptr), value :: finish
end subroutine

! 
!cairo_raster_source_finish_func_t cairo_raster_source_pattern_get_finish (cairo_pattern_t *pattern);
function cairo_raster_source_pattern_get_finish(pattern) bind(c)
  import :: c_funptr, c_ptr
  implicit none
  type(c_funptr) :: cairo_raster_source_pattern_get_finish
  type(c_ptr), value :: pattern
end function

! 
!cairo_pattern_t * cairo_pattern_create_rgb (double red, double green, double blue);
function cairo_pattern_create_rgb(red, green, blue) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr) :: cairo_pattern_create_rgb
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
end function

! 
!cairo_pattern_t * cairo_pattern_create_rgba (double red, double green, double blue, double alpha);
function cairo_pattern_create_rgba(red, green, blue, alpha) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr) :: cairo_pattern_create_rgba
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
  real(c_double), value :: alpha
end function

! 
!cairo_pattern_t * cairo_pattern_create_for_surface (cairo_surface_t *surface);
function cairo_pattern_create_for_surface(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_pattern_create_for_surface
  type(c_ptr), value :: surface
end function

! 
!cairo_pattern_t * cairo_pattern_create_linear (double x0, double y0, double x1, double y1);
function cairo_pattern_create_linear(x0, y0, x1, y1) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr) :: cairo_pattern_create_linear
  real(c_double), value :: x0
  real(c_double), value :: y0
  real(c_double), value :: x1
  real(c_double), value :: y1
end function

! 
!cairo_pattern_t * cairo_pattern_create_radial (double cx0, double cy0, double radius0, double cx1, double cy1, double radius1);
function cairo_pattern_create_radial(cx0, cy0, radius0, cx1, cy1, radius1)&
& bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr) :: cairo_pattern_create_radial
  real(c_double), value :: cx0
  real(c_double), value :: cy0
  real(c_double), value :: radius0
  real(c_double), value :: cx1
  real(c_double), value :: cy1
  real(c_double), value :: radius1
end function

! 
!cairo_pattern_t * cairo_pattern_create_mesh (void);
function cairo_pattern_create_mesh() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_pattern_create_mesh
end function

! 
!cairo_pattern_t * cairo_pattern_reference (cairo_pattern_t *pattern);
function cairo_pattern_reference(pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_pattern_reference
  type(c_ptr), value :: pattern
end function

! 
!void cairo_pattern_destroy (cairo_pattern_t *pattern);
subroutine cairo_pattern_destroy(pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pattern
end subroutine

! 
!unsigned int cairo_pattern_get_reference_count (cairo_pattern_t *pattern);
function cairo_pattern_get_reference_count(pattern) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_reference_count
  type(c_ptr), value :: pattern
end function

! 
!cairo_status_t cairo_pattern_status (cairo_pattern_t *pattern);
function cairo_pattern_status(pattern) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_status
  type(c_ptr), value :: pattern
end function

! 
!void * cairo_pattern_get_user_data (cairo_pattern_t *pattern, const cairo_user_data_key_t *key);
function cairo_pattern_get_user_data(pattern, key) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_pattern_get_user_data
  type(c_ptr), value :: pattern
  type(c_ptr), value :: key
end function

! 
!cairo_status_t cairo_pattern_set_user_data (cairo_pattern_t *pattern, const cairo_user_data_key_t *key, void *user_data, cairo_destroy_func_t destroy);
function cairo_pattern_set_user_data(pattern, key, user_data, destroy) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_pattern_set_user_data
  type(c_ptr), value :: pattern
  type(c_ptr), value :: key
  type(c_ptr), value :: user_data
  type(c_funptr), value :: destroy
end function

! 
!cairo_pattern_type_t cairo_pattern_get_type (cairo_pattern_t *pattern);
function cairo_pattern_get_type(pattern) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_type
  type(c_ptr), value :: pattern
end function

! 
!void cairo_pattern_add_color_stop_rgb (cairo_pattern_t *pattern, double offset, double red, double green, double blue);
subroutine cairo_pattern_add_color_stop_rgb(pattern, offset, red, green, blue)&
& bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: pattern
  real(c_double), value :: offset
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
end subroutine

! 
!void cairo_pattern_add_color_stop_rgba (cairo_pattern_t *pattern, double offset, double red, double green, double blue, double alpha);
subroutine cairo_pattern_add_color_stop_rgba(pattern, offset, red, green, blue,&
& alpha) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: pattern
  real(c_double), value :: offset
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
  real(c_double), value :: alpha
end subroutine

! 
!void cairo_mesh_pattern_begin_patch (cairo_pattern_t *pattern);
subroutine cairo_mesh_pattern_begin_patch(pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pattern
end subroutine

! 
!void cairo_mesh_pattern_end_patch (cairo_pattern_t *pattern);
subroutine cairo_mesh_pattern_end_patch(pattern) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pattern
end subroutine

! 
!void cairo_mesh_pattern_curve_to (cairo_pattern_t *pattern, double x1, double y1, double x2, double y2, double x3, double y3);
subroutine cairo_mesh_pattern_curve_to(pattern, x1, y1, x2, y2, x3, y3) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: pattern
  real(c_double), value :: x1
  real(c_double), value :: y1
  real(c_double), value :: x2
  real(c_double), value :: y2
  real(c_double), value :: x3
  real(c_double), value :: y3
end subroutine

! 
!void cairo_mesh_pattern_line_to (cairo_pattern_t *pattern, double x, double y);
subroutine cairo_mesh_pattern_line_to(pattern, x, y) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: pattern
  real(c_double), value :: x
  real(c_double), value :: y
end subroutine

! 
!void cairo_mesh_pattern_move_to (cairo_pattern_t *pattern, double x, double y);
subroutine cairo_mesh_pattern_move_to(pattern, x, y) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: pattern
  real(c_double), value :: x
  real(c_double), value :: y
end subroutine

! 
!void cairo_mesh_pattern_set_control_point (cairo_pattern_t *pattern, unsigned int point_num, double x, double y);
subroutine cairo_mesh_pattern_set_control_point(pattern, point_num, x, y)&
& bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: pattern
  integer(c_int), value :: point_num
  real(c_double), value :: x
  real(c_double), value :: y
end subroutine

! 
!void cairo_mesh_pattern_set_corner_color_rgb (cairo_pattern_t *pattern, unsigned int corner_num, double red, double green, double blue);
subroutine cairo_mesh_pattern_set_corner_color_rgb(pattern, corner_num, red,&
& green, blue) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: pattern
  integer(c_int), value :: corner_num
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
end subroutine

! 
!void cairo_mesh_pattern_set_corner_color_rgba (cairo_pattern_t *pattern, unsigned int corner_num, double red, double green, double blue, double alpha);
subroutine cairo_mesh_pattern_set_corner_color_rgba(pattern, corner_num, red,&
& green, blue, alpha) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: pattern
  integer(c_int), value :: corner_num
  real(c_double), value :: red
  real(c_double), value :: green
  real(c_double), value :: blue
  real(c_double), value :: alpha
end subroutine

! 
!void cairo_pattern_set_matrix (cairo_pattern_t *pattern, const cairo_matrix_t *matrix);
subroutine cairo_pattern_set_matrix(pattern, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_pattern_get_matrix (cairo_pattern_t *pattern, cairo_matrix_t *matrix);
subroutine cairo_pattern_get_matrix(pattern, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pattern
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_pattern_set_extend (cairo_pattern_t *pattern, cairo_extend_t extend);
subroutine cairo_pattern_set_extend(pattern, extend) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: pattern
  integer(c_int), value :: extend
end subroutine

! 
!cairo_extend_t cairo_pattern_get_extend (cairo_pattern_t *pattern);
function cairo_pattern_get_extend(pattern) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_extend
  type(c_ptr), value :: pattern
end function

! 
!void cairo_pattern_set_filter (cairo_pattern_t *pattern, cairo_filter_t filter);
subroutine cairo_pattern_set_filter(pattern, filter) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: pattern
  integer(c_int), value :: filter
end subroutine

! 
!cairo_filter_t cairo_pattern_get_filter (cairo_pattern_t *pattern);
function cairo_pattern_get_filter(pattern) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_filter
  type(c_ptr), value :: pattern
end function

! 
!cairo_status_t cairo_pattern_get_rgba (cairo_pattern_t *pattern, double *red, double *green, double *blue, double *alpha);
function cairo_pattern_get_rgba(pattern, red, green, blue, alpha) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_rgba
  type(c_ptr), value :: pattern
  type(c_ptr), value :: red
  type(c_ptr), value :: green
  type(c_ptr), value :: blue
  type(c_ptr), value :: alpha
end function

! 
!cairo_status_t cairo_pattern_get_surface (cairo_pattern_t *pattern, cairo_surface_t **surface);
function cairo_pattern_get_surface(pattern, surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_surface
  type(c_ptr), value :: pattern
  type(c_ptr), value :: surface
end function

! 
!cairo_status_t cairo_pattern_get_color_stop_rgba (cairo_pattern_t *pattern, int index, double *offset, double *red, double *green, double *blue, double *alpha);
function cairo_pattern_get_color_stop_rgba(pattern, index, offset, red, green,&
& blue, alpha) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_color_stop_rgba
  type(c_ptr), value :: pattern
  integer(c_int), value :: index
  type(c_ptr), value :: offset
  type(c_ptr), value :: red
  type(c_ptr), value :: green
  type(c_ptr), value :: blue
  type(c_ptr), value :: alpha
end function

! 
!cairo_status_t cairo_pattern_get_color_stop_count (cairo_pattern_t *pattern, int *count);
function cairo_pattern_get_color_stop_count(pattern, count) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_color_stop_count
  type(c_ptr), value :: pattern
  type(c_ptr), value :: count
end function

! 
!cairo_status_t cairo_pattern_get_linear_points (cairo_pattern_t *pattern, double *x0, double *y0, double *x1, double *y1);
function cairo_pattern_get_linear_points(pattern, x0, y0, x1, y1) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_linear_points
  type(c_ptr), value :: pattern
  type(c_ptr), value :: x0
  type(c_ptr), value :: y0
  type(c_ptr), value :: x1
  type(c_ptr), value :: y1
end function

! 
!cairo_status_t cairo_pattern_get_radial_circles (cairo_pattern_t *pattern, double *x0, double *y0, double *r0, double *x1, double *y1, double *r1);
function cairo_pattern_get_radial_circles(pattern, x0, y0, r0, x1, y1, r1)&
& bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_pattern_get_radial_circles
  type(c_ptr), value :: pattern
  type(c_ptr), value :: x0
  type(c_ptr), value :: y0
  type(c_ptr), value :: r0
  type(c_ptr), value :: x1
  type(c_ptr), value :: y1
  type(c_ptr), value :: r1
end function

! 
!cairo_status_t cairo_mesh_pattern_get_patch_count (cairo_pattern_t *pattern, unsigned int *count);
function cairo_mesh_pattern_get_patch_count(pattern, count) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_mesh_pattern_get_patch_count
  type(c_ptr), value :: pattern
  type(c_ptr), value :: count
end function

! 
!cairo_path_t * cairo_mesh_pattern_get_path (cairo_pattern_t *pattern, unsigned int patch_num);
function cairo_mesh_pattern_get_path(pattern, patch_num) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_mesh_pattern_get_path
  type(c_ptr), value :: pattern
  integer(c_int), value :: patch_num
end function

! 
!cairo_status_t cairo_mesh_pattern_get_corner_color_rgba (cairo_pattern_t *pattern, unsigned int patch_num, unsigned int corner_num, double *red, double *green, double *blue, double *alpha);
function cairo_mesh_pattern_get_corner_color_rgba(pattern, patch_num,&
& corner_num, red, green, blue, alpha) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_mesh_pattern_get_corner_color_rgba
  type(c_ptr), value :: pattern
  integer(c_int), value :: patch_num
  integer(c_int), value :: corner_num
  type(c_ptr), value :: red
  type(c_ptr), value :: green
  type(c_ptr), value :: blue
  type(c_ptr), value :: alpha
end function

! 
!cairo_status_t cairo_mesh_pattern_get_control_point (cairo_pattern_t *pattern, unsigned int patch_num, unsigned int point_num, double *x, double *y);
function cairo_mesh_pattern_get_control_point(pattern, patch_num, point_num, x,&
& y) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_mesh_pattern_get_control_point
  type(c_ptr), value :: pattern
  integer(c_int), value :: patch_num
  integer(c_int), value :: point_num
  type(c_ptr), value :: x
  type(c_ptr), value :: y
end function

! 
!void cairo_matrix_init (cairo_matrix_t *matrix, double xx, double yx, double xy, double yy, double x0, double y0);
subroutine cairo_matrix_init(matrix, xx, yx, xy, yy, x0, y0) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: xx
  real(c_double), value :: yx
  real(c_double), value :: xy
  real(c_double), value :: yy
  real(c_double), value :: x0
  real(c_double), value :: y0
end subroutine

! 
!void cairo_matrix_init_identity (cairo_matrix_t *matrix);
subroutine cairo_matrix_init_identity(matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: matrix
end subroutine

! 
!void cairo_matrix_init_translate (cairo_matrix_t *matrix, double tx, double ty);
subroutine cairo_matrix_init_translate(matrix, tx, ty) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: tx
  real(c_double), value :: ty
end subroutine

! 
!void cairo_matrix_init_scale (cairo_matrix_t *matrix, double sx, double sy);
subroutine cairo_matrix_init_scale(matrix, sx, sy) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: sx
  real(c_double), value :: sy
end subroutine

! 
!void cairo_matrix_init_rotate (cairo_matrix_t *matrix, double radians);
subroutine cairo_matrix_init_rotate(matrix, radians) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: radians
end subroutine

! 
!void cairo_matrix_translate (cairo_matrix_t *matrix, double tx, double ty);
subroutine cairo_matrix_translate(matrix, tx, ty) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: tx
  real(c_double), value :: ty
end subroutine

! 
!void cairo_matrix_scale (cairo_matrix_t *matrix, double sx, double sy);
subroutine cairo_matrix_scale(matrix, sx, sy) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: sx
  real(c_double), value :: sy
end subroutine

! 
!void cairo_matrix_rotate (cairo_matrix_t *matrix, double radians);
subroutine cairo_matrix_rotate(matrix, radians) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: matrix
  real(c_double), value :: radians
end subroutine

! 
!cairo_status_t cairo_matrix_invert (cairo_matrix_t *matrix);
function cairo_matrix_invert(matrix) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_matrix_invert
  type(c_ptr), value :: matrix
end function

! 
!void cairo_matrix_multiply (cairo_matrix_t *result, const cairo_matrix_t *a, const cairo_matrix_t *b);
subroutine cairo_matrix_multiply(result, a, b) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: result
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end subroutine

! 
!void cairo_matrix_transform_distance (const cairo_matrix_t *matrix, double *dx, double *dy);
subroutine cairo_matrix_transform_distance(matrix, dx, dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: matrix
  type(c_ptr), value :: dx
  type(c_ptr), value :: dy
end subroutine

! 
!void cairo_matrix_transform_point (const cairo_matrix_t *matrix, double *x, double *y);
subroutine cairo_matrix_transform_point(matrix, x, y) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: matrix
  type(c_ptr), value :: x
  type(c_ptr), value :: y
end subroutine

! 
!cairo_region_t * cairo_region_create (void);
function cairo_region_create() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_region_create
end function

! 
!cairo_region_t * cairo_region_create_rectangle (const cairo_rectangle_int_t *rectangle);
function cairo_region_create_rectangle(rectangle) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_region_create_rectangle
  type(c_ptr), value :: rectangle
end function

! 
!cairo_region_t * cairo_region_create_rectangles (const cairo_rectangle_int_t *rects, int count);
function cairo_region_create_rectangles(rects, count) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_region_create_rectangles
  type(c_ptr), value :: rects
  integer(c_int), value :: count
end function

! 
!cairo_region_t * cairo_region_copy (const cairo_region_t *original);
function cairo_region_copy(original) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_region_copy
  type(c_ptr), value :: original
end function

! 
!cairo_region_t * cairo_region_reference (cairo_region_t *region);
function cairo_region_reference(region) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_region_reference
  type(c_ptr), value :: region
end function

! 
!void cairo_region_destroy (cairo_region_t *region);
subroutine cairo_region_destroy(region) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: region
end subroutine

! 
!cairo_bool_t cairo_region_equal (const cairo_region_t *a, const cairo_region_t *b);
function cairo_region_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! 
!cairo_status_t cairo_region_status (const cairo_region_t *region);
function cairo_region_status(region) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_status
  type(c_ptr), value :: region
end function

! 
!void cairo_region_get_extents (const cairo_region_t *region, cairo_rectangle_int_t *extents);
subroutine cairo_region_get_extents(region, extents) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: region
  type(c_ptr), value :: extents
end subroutine

! 
!int cairo_region_num_rectangles (const cairo_region_t *region);
function cairo_region_num_rectangles(region) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_num_rectangles
  type(c_ptr), value :: region
end function

! 
!void cairo_region_get_rectangle (const cairo_region_t *region, int nth, cairo_rectangle_int_t *rectangle);
subroutine cairo_region_get_rectangle(region, nth, rectangle) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: region
  integer(c_int), value :: nth
  type(c_ptr), value :: rectangle
end subroutine

! 
!cairo_bool_t cairo_region_is_empty (const cairo_region_t *region);
function cairo_region_is_empty(region) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_is_empty
  type(c_ptr), value :: region
end function

! 
!cairo_region_overlap_t cairo_region_contains_rectangle (const cairo_region_t *region, const cairo_rectangle_int_t *rectangle);
function cairo_region_contains_rectangle(region, rectangle) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_contains_rectangle
  type(c_ptr), value :: region
  type(c_ptr), value :: rectangle
end function

! 
!cairo_bool_t cairo_region_contains_point (const cairo_region_t *region, int x, int y);
function cairo_region_contains_point(region, x, y) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_contains_point
  type(c_ptr), value :: region
  integer(c_int), value :: x
  integer(c_int), value :: y
end function

! 
!void cairo_region_translate (cairo_region_t *region, int dx, int dy);
subroutine cairo_region_translate(region, dx, dy) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: region
  integer(c_int), value :: dx
  integer(c_int), value :: dy
end subroutine

! 
!cairo_status_t cairo_region_subtract (cairo_region_t *dst, const cairo_region_t *other);
function cairo_region_subtract(dst, other) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_subtract
  type(c_ptr), value :: dst
  type(c_ptr), value :: other
end function

! 
!cairo_status_t cairo_region_subtract_rectangle (cairo_region_t *dst, const cairo_rectangle_int_t *rectangle);
function cairo_region_subtract_rectangle(dst, rectangle) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_subtract_rectangle
  type(c_ptr), value :: dst
  type(c_ptr), value :: rectangle
end function

! 
!cairo_status_t cairo_region_intersect (cairo_region_t *dst, const cairo_region_t *other);
function cairo_region_intersect(dst, other) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_intersect
  type(c_ptr), value :: dst
  type(c_ptr), value :: other
end function

! 
!cairo_status_t cairo_region_intersect_rectangle (cairo_region_t *dst, const cairo_rectangle_int_t *rectangle);
function cairo_region_intersect_rectangle(dst, rectangle) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_intersect_rectangle
  type(c_ptr), value :: dst
  type(c_ptr), value :: rectangle
end function

! 
!cairo_status_t cairo_region_union (cairo_region_t *dst, const cairo_region_t *other);
function cairo_region_union(dst, other) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_union
  type(c_ptr), value :: dst
  type(c_ptr), value :: other
end function

! 
!cairo_status_t cairo_region_union_rectangle (cairo_region_t *dst, const cairo_rectangle_int_t *rectangle);
function cairo_region_union_rectangle(dst, rectangle) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_union_rectangle
  type(c_ptr), value :: dst
  type(c_ptr), value :: rectangle
end function

! 
!cairo_status_t cairo_region_xor (cairo_region_t *dst, const cairo_region_t *other);
function cairo_region_xor(dst, other) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_xor
  type(c_ptr), value :: dst
  type(c_ptr), value :: other
end function

! 
!cairo_status_t cairo_region_xor_rectangle (cairo_region_t *dst, const cairo_rectangle_int_t *rectangle);
function cairo_region_xor_rectangle(dst, rectangle) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_region_xor_rectangle
  type(c_ptr), value :: dst
  type(c_ptr), value :: rectangle
end function

! 
!void cairo_debug_reset_static_data (void);
subroutine cairo_debug_reset_static_data() bind(c)
  implicit none
end subroutine

!--------------------------------------------------
! /usr/include/cairo/cairo-xlib.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_xlib_surface_create (Display *dpy, Drawable drawable, Visual *visual, int width, int height);
function cairo_xlib_surface_create(dpy, drawable, visual, width, height)&
& bind(c)
  import :: c_ptr, c_long, c_int
  implicit none
  type(c_ptr) :: cairo_xlib_surface_create
  type(c_ptr), value :: dpy
  integer(c_long), value :: drawable
  type(c_ptr), value :: visual
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!cairo_surface_t * cairo_xlib_surface_create_for_bitmap (Display *dpy, Pixmap bitmap, Screen *screen, int width, int height);
function cairo_xlib_surface_create_for_bitmap(dpy, bitmap, screen, width,&
& height) bind(c)
  import :: c_ptr, c_long, c_int
  implicit none
  type(c_ptr) :: cairo_xlib_surface_create_for_bitmap
  type(c_ptr), value :: dpy
  integer(c_long), value :: bitmap
  type(c_ptr), value :: screen
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!void cairo_xlib_surface_set_size (cairo_surface_t *surface, int width, int height);
subroutine cairo_xlib_surface_set_size(surface, width, height) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

! 
!void cairo_xlib_surface_set_drawable (cairo_surface_t *surface, Drawable drawable, int width, int height);
subroutine cairo_xlib_surface_set_drawable(surface, drawable, width, height)&
& bind(c)
  import :: c_ptr, c_long, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_long), value :: drawable
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

! 
!Display * cairo_xlib_surface_get_display (cairo_surface_t *surface);
function cairo_xlib_surface_get_display(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_xlib_surface_get_display
  type(c_ptr), value :: surface
end function

! 
!Drawable cairo_xlib_surface_get_drawable (cairo_surface_t *surface);
function cairo_xlib_surface_get_drawable(surface) bind(c)
  import :: c_long, c_ptr
  implicit none
  integer(c_long) :: cairo_xlib_surface_get_drawable
  type(c_ptr), value :: surface
end function

! 
!Screen * cairo_xlib_surface_get_screen (cairo_surface_t *surface);
function cairo_xlib_surface_get_screen(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_xlib_surface_get_screen
  type(c_ptr), value :: surface
end function

! 
!Visual * cairo_xlib_surface_get_visual (cairo_surface_t *surface);
function cairo_xlib_surface_get_visual(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_xlib_surface_get_visual
  type(c_ptr), value :: surface
end function

! 
!int cairo_xlib_surface_get_depth (cairo_surface_t *surface);
function cairo_xlib_surface_get_depth(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_xlib_surface_get_depth
  type(c_ptr), value :: surface
end function

! 
!int cairo_xlib_surface_get_width (cairo_surface_t *surface);
function cairo_xlib_surface_get_width(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_xlib_surface_get_width
  type(c_ptr), value :: surface
end function

! 
!int cairo_xlib_surface_get_height (cairo_surface_t *surface);
function cairo_xlib_surface_get_height(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_xlib_surface_get_height
  type(c_ptr), value :: surface
end function

! 
!void cairo_xlib_device_debug_cap_xrender_version (cairo_device_t *device, int major_version, int minor_version);
subroutine cairo_xlib_device_debug_cap_xrender_version(device, major_version,&
& minor_version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: device
  integer(c_int), value :: major_version
  integer(c_int), value :: minor_version
end subroutine

! 
!void cairo_xlib_device_debug_set_precision (cairo_device_t *device, int precision);
subroutine cairo_xlib_device_debug_set_precision(device, precision) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: device
  integer(c_int), value :: precision
end subroutine

! 
!int cairo_xlib_device_debug_get_precision (cairo_device_t *device);
function cairo_xlib_device_debug_get_precision(device) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_xlib_device_debug_get_precision
  type(c_ptr), value :: device
end function

!--------------------------------------------------
! /usr/include/cairo/cairo-version.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/cairo/cairo-script.h
!--------------------------------------------------
! 
!cairo_device_t * cairo_script_create (const char *filename);
function cairo_script_create(filename) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: cairo_script_create
  character(kind=c_char), dimension(*) :: filename
end function

! 
!cairo_device_t * cairo_script_create_for_stream (cairo_write_func_t write_func, void *closure);
function cairo_script_create_for_stream(write_func, closure) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr) :: cairo_script_create_for_stream
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
end function

! 
!void cairo_script_write_comment (cairo_device_t *script, const char *comment, int len);
subroutine cairo_script_write_comment(script, comment, len) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr), value :: script
  character(kind=c_char), dimension(*) :: comment
  integer(c_int), value :: len
end subroutine

! 
!void cairo_script_set_mode (cairo_device_t *script, cairo_script_mode_t mode);
subroutine cairo_script_set_mode(script, mode) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: script
  integer(c_int), value :: mode
end subroutine

! 
!cairo_script_mode_t cairo_script_get_mode (cairo_device_t *script);
function cairo_script_get_mode(script) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_script_get_mode
  type(c_ptr), value :: script
end function

! 
!cairo_surface_t * cairo_script_surface_create (cairo_device_t *script, cairo_content_t content, double width, double height);
function cairo_script_surface_create(script, content, width, height) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr) :: cairo_script_surface_create
  type(c_ptr), value :: script
  integer(c_int), value :: content
  real(c_double), value :: width
  real(c_double), value :: height
end function

! 
!cairo_surface_t * cairo_script_surface_create_for_target (cairo_device_t *script, cairo_surface_t *target);
function cairo_script_surface_create_for_target(script, target) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_script_surface_create_for_target
  type(c_ptr), value :: script
  type(c_ptr), value :: target
end function

! 
!cairo_status_t cairo_script_from_recording_surface (cairo_device_t *script, cairo_surface_t *recording_surface);
function cairo_script_from_recording_surface(script, recording_surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_script_from_recording_surface
  type(c_ptr), value :: script
  type(c_ptr), value :: recording_surface
end function

!--------------------------------------------------
! /usr/include/cairo/cairo-pdf.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_pdf_surface_create (const char *filename, double width_in_points, double height_in_points);
function cairo_pdf_surface_create(filename, width_in_points, height_in_points)&
& bind(c)
  import :: c_ptr, c_char, c_double
  implicit none
  type(c_ptr) :: cairo_pdf_surface_create
  character(kind=c_char), dimension(*) :: filename
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end function

! 
!cairo_surface_t * cairo_pdf_surface_create_for_stream (cairo_write_func_t write_func, void *closure, double width_in_points, double height_in_points);
function cairo_pdf_surface_create_for_stream(write_func, closure,&
& width_in_points, height_in_points) bind(c)
  import :: c_ptr, c_funptr, c_double
  implicit none
  type(c_ptr) :: cairo_pdf_surface_create_for_stream
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end function

! 
!void cairo_pdf_surface_restrict_to_version (cairo_surface_t *surface, cairo_pdf_version_t version);
subroutine cairo_pdf_surface_restrict_to_version(surface, version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: version
end subroutine

! 
!void cairo_pdf_get_versions (cairo_pdf_version_t const **versions, int *num_versions);
subroutine cairo_pdf_get_versions(versions, num_versions) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: versions
  type(c_ptr), value :: num_versions
end subroutine

! 
!const char * cairo_pdf_version_to_string (cairo_pdf_version_t version);
function cairo_pdf_version_to_string(version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_pdf_version_to_string
  integer(c_int), value :: version
end function

! 
!void cairo_pdf_surface_set_size (cairo_surface_t *surface, double width_in_points, double height_in_points);
subroutine cairo_pdf_surface_set_size(surface, width_in_points,&
& height_in_points) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: surface
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end subroutine

! 
!int cairo_pdf_surface_add_outline (cairo_surface_t *surface, int parent_id, const char *utf8, const char *link_attribs, cairo_pdf_outline_flags_t flags);
function cairo_pdf_surface_add_outline(surface, parent_id, utf8, link_attribs,&
& flags) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: cairo_pdf_surface_add_outline
  type(c_ptr), value :: surface
  integer(c_int), value :: parent_id
  character(kind=c_char), dimension(*) :: utf8
  character(kind=c_char), dimension(*) :: link_attribs
  integer(c_int), value :: flags
end function

! 
!void cairo_pdf_surface_set_metadata (cairo_surface_t *surface, cairo_pdf_metadata_t metadata, const char *utf8);
subroutine cairo_pdf_surface_set_metadata(surface, metadata, utf8) bind(c)
  import :: c_ptr, c_int, c_char
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: metadata
  character(kind=c_char), dimension(*) :: utf8
end subroutine

! 
!void cairo_pdf_surface_set_custom_metadata (cairo_surface_t *surface, const char *name, const char *value);
subroutine cairo_pdf_surface_set_custom_metadata(surface, name, value) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: name
  character(kind=c_char), dimension(*) :: value
end subroutine

! 
!void cairo_pdf_surface_set_page_label (cairo_surface_t *surface, const char *utf8);
subroutine cairo_pdf_surface_set_page_label(surface, utf8) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr), value :: surface
  character(kind=c_char), dimension(*) :: utf8
end subroutine

! 
!void cairo_pdf_surface_set_thumbnail_size (cairo_surface_t *surface, int width, int height);
subroutine cairo_pdf_surface_set_thumbnail_size(surface, width, height) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

!--------------------------------------------------
! /usr/include/cairo/cairo-script-interpreter.h
!--------------------------------------------------
! 
!cairo_script_interpreter_t * cairo_script_interpreter_create (void);
function cairo_script_interpreter_create() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_script_interpreter_create
end function

! 
!void cairo_script_interpreter_install_hooks (cairo_script_interpreter_t *ctx, const cairo_script_interpreter_hooks_t *hooks);
subroutine cairo_script_interpreter_install_hooks(ctx, hooks) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: ctx
  type(c_ptr), value :: hooks
end subroutine

! 
!cairo_status_t cairo_script_interpreter_run (cairo_script_interpreter_t *ctx, const char *filename);
function cairo_script_interpreter_run(ctx, filename) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: cairo_script_interpreter_run
  type(c_ptr), value :: ctx
  character(kind=c_char), dimension(*) :: filename
end function

! 
!cairo_status_t cairo_script_interpreter_feed_stream (cairo_script_interpreter_t *ctx, FILE *stream);
function cairo_script_interpreter_feed_stream(ctx, stream) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_script_interpreter_feed_stream
  type(c_ptr), value :: ctx
  type(c_ptr), value :: stream
end function

! 
!cairo_status_t cairo_script_interpreter_feed_string (cairo_script_interpreter_t *ctx, const char *line, int len);
function cairo_script_interpreter_feed_string(ctx, line, len) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: cairo_script_interpreter_feed_string
  type(c_ptr), value :: ctx
  character(kind=c_char), dimension(*) :: line
  integer(c_int), value :: len
end function

! 
!unsigned int cairo_script_interpreter_get_line_number (cairo_script_interpreter_t *ctx);
function cairo_script_interpreter_get_line_number(ctx) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_script_interpreter_get_line_number
  type(c_ptr), value :: ctx
end function

! 
!cairo_script_interpreter_t * cairo_script_interpreter_reference (cairo_script_interpreter_t *ctx);
function cairo_script_interpreter_reference(ctx) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_script_interpreter_reference
  type(c_ptr), value :: ctx
end function

! 
!cairo_status_t cairo_script_interpreter_finish (cairo_script_interpreter_t *ctx);
function cairo_script_interpreter_finish(ctx) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_script_interpreter_finish
  type(c_ptr), value :: ctx
end function

! 
!cairo_status_t cairo_script_interpreter_destroy (cairo_script_interpreter_t *ctx);
function cairo_script_interpreter_destroy(ctx) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_script_interpreter_destroy
  type(c_ptr), value :: ctx
end function

! 
!cairo_status_t cairo_script_interpreter_translate_stream (FILE *stream, cairo_write_func_t write_func, void *closure);
function cairo_script_interpreter_translate_stream(stream, write_func, closure)&
& bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: cairo_script_interpreter_translate_stream
  type(c_ptr), value :: stream
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
end function

!--------------------------------------------------
! /usr/include/cairo/cairo-features.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/cairo/cairo-xlib-xrender.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_xlib_surface_create_with_xrender_format (Display *dpy, Drawable drawable, Screen *screen, XRenderPictFormat *format, int width, int height);
function cairo_xlib_surface_create_with_xrender_format(dpy, drawable, screen,&
& format, width, height) bind(c)
  import :: c_ptr, c_long, c_int
  implicit none
  type(c_ptr) :: cairo_xlib_surface_create_with_xrender_format
  type(c_ptr), value :: dpy
  integer(c_long), value :: drawable
  type(c_ptr), value :: screen
  type(c_ptr), value :: format
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!XRenderPictFormat * cairo_xlib_surface_get_xrender_format (cairo_surface_t *surface);
function cairo_xlib_surface_get_xrender_format(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_xlib_surface_get_xrender_format
  type(c_ptr), value :: surface
end function

!--------------------------------------------------
! /usr/include/cairo/cairo-xcb.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_xcb_surface_create (xcb_connection_t *connection, xcb_drawable_t drawable, xcb_visualtype_t *visual, int width, int height);
function cairo_xcb_surface_create(connection, drawable, visual, width, height)&
& bind(c)
  import :: c_ptr, c_int32_t, c_int
  implicit none
  type(c_ptr) :: cairo_xcb_surface_create
  type(c_ptr), value :: connection
  integer(c_int32_t), value :: drawable
  type(c_ptr), value :: visual
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!cairo_surface_t * cairo_xcb_surface_create_for_bitmap (xcb_connection_t *connection, xcb_screen_t *screen, xcb_pixmap_t bitmap, int width, int height);
function cairo_xcb_surface_create_for_bitmap(connection, screen, bitmap, width,&
& height) bind(c)
  import :: c_ptr, c_int32_t, c_int
  implicit none
  type(c_ptr) :: cairo_xcb_surface_create_for_bitmap
  type(c_ptr), value :: connection
  type(c_ptr), value :: screen
  integer(c_int32_t), value :: bitmap
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!cairo_surface_t * cairo_xcb_surface_create_with_xrender_format (xcb_connection_t *connection, xcb_screen_t *screen, xcb_drawable_t drawable, xcb_render_pictforminfo_t *format, int width, int height);
function cairo_xcb_surface_create_with_xrender_format(connection, screen,&
& drawable, format, width, height) bind(c)
  import :: c_ptr, c_int32_t, c_int
  implicit none
  type(c_ptr) :: cairo_xcb_surface_create_with_xrender_format
  type(c_ptr), value :: connection
  type(c_ptr), value :: screen
  integer(c_int32_t), value :: drawable
  type(c_ptr), value :: format
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! 
!void cairo_xcb_surface_set_size (cairo_surface_t *surface, int width, int height);
subroutine cairo_xcb_surface_set_size(surface, width, height) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

! 
!void cairo_xcb_surface_set_drawable (cairo_surface_t *surface, xcb_drawable_t drawable, int width, int height);
subroutine cairo_xcb_surface_set_drawable(surface, drawable, width, height)&
& bind(c)
  import :: c_ptr, c_int32_t, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int32_t), value :: drawable
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

! 
!xcb_connection_t * cairo_xcb_device_get_connection (cairo_device_t *device);
function cairo_xcb_device_get_connection(device) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: cairo_xcb_device_get_connection
  type(c_ptr), value :: device
end function

! 
!void cairo_xcb_device_debug_cap_xshm_version (cairo_device_t *device, int major_version, int minor_version);
subroutine cairo_xcb_device_debug_cap_xshm_version(device, major_version,&
& minor_version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: device
  integer(c_int), value :: major_version
  integer(c_int), value :: minor_version
end subroutine

! 
!void cairo_xcb_device_debug_cap_xrender_version (cairo_device_t *device, int major_version, int minor_version);
subroutine cairo_xcb_device_debug_cap_xrender_version(device, major_version,&
& minor_version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: device
  integer(c_int), value :: major_version
  integer(c_int), value :: minor_version
end subroutine

! 
!void cairo_xcb_device_debug_set_precision (cairo_device_t *device, int precision);
subroutine cairo_xcb_device_debug_set_precision(device, precision) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: device
  integer(c_int), value :: precision
end subroutine

! 
!int cairo_xcb_device_debug_get_precision (cairo_device_t *device);
function cairo_xcb_device_debug_get_precision(device) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_xcb_device_debug_get_precision
  type(c_ptr), value :: device
end function

!--------------------------------------------------
! /usr/include/cairo/cairo-svg.h
!--------------------------------------------------
! 
!cairo_surface_t * cairo_svg_surface_create (const char *filename, double width_in_points, double height_in_points);
function cairo_svg_surface_create(filename, width_in_points, height_in_points)&
& bind(c)
  import :: c_ptr, c_char, c_double
  implicit none
  type(c_ptr) :: cairo_svg_surface_create
  character(kind=c_char), dimension(*) :: filename
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end function

! 
!cairo_surface_t * cairo_svg_surface_create_for_stream (cairo_write_func_t write_func, void *closure, double width_in_points, double height_in_points);
function cairo_svg_surface_create_for_stream(write_func, closure,&
& width_in_points, height_in_points) bind(c)
  import :: c_ptr, c_funptr, c_double
  implicit none
  type(c_ptr) :: cairo_svg_surface_create_for_stream
  type(c_funptr), value :: write_func
  type(c_ptr), value :: closure
  real(c_double), value :: width_in_points
  real(c_double), value :: height_in_points
end function

! 
!void cairo_svg_surface_restrict_to_version (cairo_surface_t *surface, cairo_svg_version_t version);
subroutine cairo_svg_surface_restrict_to_version(surface, version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: version
end subroutine

! 
!void cairo_svg_get_versions (cairo_svg_version_t const **versions, int *num_versions);
subroutine cairo_svg_get_versions(versions, num_versions) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: versions
  type(c_ptr), value :: num_versions
end subroutine

! 
!const char * cairo_svg_version_to_string (cairo_svg_version_t version);
function cairo_svg_version_to_string(version) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: cairo_svg_version_to_string
  integer(c_int), value :: version
end function

! 
!void cairo_svg_surface_set_document_unit (cairo_surface_t *surface, cairo_svg_unit_t unit);
subroutine cairo_svg_surface_set_document_unit(surface, unit) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: surface
  integer(c_int), value :: unit
end subroutine

! 
!cairo_svg_unit_t cairo_svg_surface_get_document_unit (cairo_surface_t *surface);
function cairo_svg_surface_get_document_unit(surface) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: cairo_svg_surface_get_document_unit
  type(c_ptr), value :: surface
end function

end interface
end module cairo

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modifications: jerryd 2020-06-05 (GTK 4), vmagnin 2022-05-06
!------------------------------------------------------------------------------

module l1_handlers
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_tree
  use gtk_hl_entry
  use gtk, only: gtk_button_new, gtk_check_button_new, &
       & gtk_entry_get_text_length, gtk_entry_new, &
       & gtk_entry_get_buffer, gtk_entry_buffer_get_text, &
       & gtk_entry_buffer_set_text, &
       & gtk_check_button_get_active,&
       & gtk_check_button_set_active, gtk_widget_show, &
       & gtk_window_destroy, gtk_window_set_child
  use g, only: alloca

  implicit none
  ! The widgets. (Strictly only those that need to be accessed
  ! by the handlers need to go here).
  type(c_ptr) :: ihwin,ihscrollcontain,ihlist, base, &
       & newline, qbut, dbut, dabut, jbox, jbox2, abut, swbut

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    print *, "Exit called"
    call gtk_window_destroy(ihwin)
  end subroutine my_destroy

  recursive subroutine list_select(list, gdata) bind(c)
    type(c_ptr), value, intent(in) :: list, gdata

    integer, pointer :: fdata
    integer(c_int) :: nsel
    integer(c_int), dimension(:), allocatable :: selections

    if (c_associated(gdata)) then
       call c_f_pointer(gdata, fdata)
       nsel = hl_gtk_list1_get_selections(C_NULL_PTR, selections, list)
       if (nsel == 0) return

       if (fdata == 0) then
          ! Find and print the selected row(s)
          print *, nsel,"Rows selected"
          print *, selections
          deallocate(selections)
       else    ! Delete the selected row
          call gtk_check_button_set_active(dbut, FALSE)
          fdata = 0
          print *, "Delete row:", selections(1)
          call hl_gtk_list1_rem(ihlist, selections(1))
       end if
    end if

  end subroutine list_select

  subroutine text_cr(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer, pointer :: fdata

    if (c_associated(gdata)) then
       call c_f_pointer(gdata, fdata)
       fdata = 1
    end if
  end subroutine text_cr

  subroutine b_click(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    integer, pointer :: fdata
    type(c_ptr) :: buffer
    integer(c_int16_t) :: ntext
    character(:), allocatable :: ftext

    if (c_associated(gdata)) then
       call c_f_pointer(gdata, fdata)

       if (fdata == 1) then
          ntext = gtk_entry_get_text_length(newline)
          buffer = gtk_entry_get_buffer(newline)
          call c_f_string_copy_alloc(gtk_entry_buffer_get_text(buffer), ftext)

          print *, len(ftext), ntext, ftext
          ! Inserts at the end of the list:
          call hl_gtk_list1_ins(ihlist, ftext//c_null_char)

          ! Clears the buffer and the entry:
          buffer = gtk_entry_get_buffer(newline)
          ! number of caracters = -1 for automatic length:
          call gtk_entry_buffer_set_text (buffer, ""//c_null_char, -1)
       end if
    end if
  end subroutine b_click

  subroutine del_toggle(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer, pointer :: fdata

    if (c_associated(gdata)) then
       call c_f_pointer(gdata, fdata)
       fdata = gtk_check_button_get_active(widget)
    end if
  end subroutine del_toggle

  subroutine delete_all(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call hl_gtk_list1_rem(ihlist)
  end subroutine delete_all

  subroutine swap_rows(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer(c_int) :: nsel, nrows
    integer(c_int), dimension(:), allocatable :: selections
    integer :: i

    nsel = hl_gtk_list1_get_selections(ihlist, selections)
    nrows = hl_gtk_list1_get_n_rows(ihlist)

    select case(nsel)
    case(0) ! No selected rows (roll the list)
       allocate(selections(nrows))
       selections = [ (i-1, i=1, nrows) ]
       selections = cshift(selections, 1)
       call hl_gtk_list1_reorder(ihlist, selections)
    case(1) ! One row selected (move it up one unless it's the first)
       if (selections(1) == 0) then
          call hl_gtk_list1_move_row(ihlist, selections(1), 1_c_int, after=TRUE)
       else
          call hl_gtk_list1_move_row(ihlist, selections(1), &
               & selections(1)-1_c_int)
       end if
    case default ! Multiple selections (swap first 2 selected rows)
       call hl_gtk_list1_swap_rows(ihlist, selections(1), selections(2))
    end select

    deallocate(selections)
  end subroutine swap_rows

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    character(len=35) :: line
    integer :: i, ltr
    integer, target :: iappend=1, idel=0

    ! Create the window:
    ihwin = gtk_application_window_new(app)
    call gtk_window_set_title(ihwin, "List demo"//c_null_char)

    ! Now make a column box & put it into the window
    base = hl_gtk_box_new()
    call gtk_window_set_child(ihwin, base)

    ! Now make a single column list with multiple selections enabled
    ihlist = hl_gtk_list1_new(ihscrollcontain, changed=c_funloc(list_select),&
         & data=c_loc(idel), multiple=TRUE, height=400_c_int, &
         & title="My list"//c_null_char)

    ! Now put 10 rows into it
    do i=1,10
       write(line,"('List entry number ',I0)") i
       ltr=len_trim(line)+1
       line(ltr:ltr)=c_null_char
       print *, line
       call hl_gtk_list1_ins(ihlist, line)
    end do

    ! It is the scrollcontainer that is placed into the box.
    call hl_gtk_box_pack(base, ihscrollcontain)

    ! Make row box put it in the column box and put an editable
    ! 1-line text widget and a button in it
    jbox = hl_gtk_box_new(horizontal=TRUE)
    call hl_gtk_box_pack(base, jbox)

    newline = hl_gtk_entry_new(len=35_c_int, editable=TRUE, &
         & activate=c_funloc(text_cr), data=c_loc(iappend), &
         & tooltip="Enter some text followed by <CR>"//c_new_line//&
         &"then click 'Append' to add it to the list"//c_null_char)
    call hl_gtk_box_pack(jbox, newline)
    abut = hl_gtk_button_new("Append"//c_null_char, clicked=c_funloc(b_click),&
         & data=c_loc(iappend))
    call hl_gtk_box_pack(jbox, abut)

    ! Make a row box and put it in the main box
    jbox2 = hl_gtk_box_new(horizontal=TRUE)
    call hl_gtk_box_pack(base, jbox2)
    ! Make a checkbox button and put it in the row box
    dbut = hl_gtk_check_button_new("Delete line"//c_null_char,&
         & toggled=c_funloc(del_toggle), initial_state=FALSE, &
         & data=c_loc(idel), &
         & tooltip="Set this then click on a line to delete it"//c_null_char)
    call hl_gtk_box_pack(jbox2, dbut)

    ! And a delete all button.
    dabut = hl_gtk_button_new("Clear"//c_null_char, clicked=c_funloc(delete_all))
    call hl_gtk_box_pack(jbox2, dabut)

    ! And a swap rows button
    swbut = hl_gtk_button_new("Swap rows"//c_null_char, clicked=c_funloc(swap_rows))
    call hl_gtk_box_pack(jbox2, swbut)

    ! Also a quit button
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base,qbut)

    ! realize the window
    call gtk_widget_show(ihwin)
  end subroutine activate
end module l1_handlers


program list1
  ! LIST1
  ! Demo of single column list
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use l1_handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_list1"//c_null_char, &
                             & c_funloc(activate))
end program list1

! $ gfortran -Wall -Wextra -std=f2008 -pedantic -g my_first_gtk_app4.f90 $(pkg-config --cflags --libs gtk-4-fortran)

module handlers
  use, intrinsic :: iso_c_binding
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE, &
               & gtk_application_window_new, gtk_widget_show, &
               & gtk_window_set_child, gtk_box_append, &
               & gtk_window_set_title, g_signal_connect, &
               & gtk_box_new, gtk_button_new_with_label, &
               & GTK_ORIENTATION_VERTICAL, FALSE

  use g, only: g_application_run, g_object_unref

  implicit none

  contains

  subroutine my_button_clicked(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Button clicked!"
  end subroutine

  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in) :: app, gdata
    type(c_ptr) :: window
    type(c_ptr) :: box, my_button

    window = gtk_application_window_new(app)
    call gtk_window_set_title(window, "Hello world!"//c_null_char)

    box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 10_c_int)
    call gtk_window_set_child(window, box)
    my_button = gtk_button_new_with_label("Compute"//c_null_char)
    call gtk_box_append(box, my_button)
    call g_signal_connect(my_button, "clicked"//c_null_char, c_funloc(my_button_clicked))

    call gtk_widget_show(window)
  end subroutine activate
end module handlers

program my_first_gtk_app
  use handlers

  implicit none
  type(c_ptr)    :: app
  integer(c_int) :: status

  app = gtk_application_new("gtk-fortran.my_first_gtk_app"//c_null_char, &
                          & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), c_null_ptr)
  status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
! ---------------------------------------------------------
! Contributed by James Tappin (2012)
! Last modification: vmagnin 2020-05-28 (GTK 4), 2020-10-21
! ---------------------------------------------------------

!*
! Text Entry
module gtk_hl_entry
  ! Convenience functions for both single and multiple line text boxes.
  !
  ! The single line is just wrappers for the GtkEntry widget.
  !
  ! The multi line editor is based around the GtkTextView widget family.
  ! The HL interface hides the text buffer from the user, except in some
  ! callbacks where the signal is attached to the buffer not the view.
  !
  ! If you do need to access the text buffer directly it can be obtained with
  ! the gtk_text_view_get_buffer function, or it can be returned via the
  ! optional BUFFER argument to the constructor.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only: error_unit

  ! auto-generated use's
  use gtk, only: gtk_scrolled_window_set_child, gtk_editable_set_editable,&
       & gtk_entry_buffer_get_text, gtk_entry_buffer_set_text, &
       & gtk_entry_get_text_length, &
       & gtk_entry_new, gtk_entry_get_buffer, &
       & gtk_entry_set_activates_default, gtk_entry_set_max_length,&
       & gtk_scrolled_window_new,&
       & gtk_scrolled_window_set_policy, gtk_text_buffer_delete,&
       & gtk_text_buffer_get_char_count, gtk_text_buffer_get_end_iter&
       &, gtk_text_buffer_get_insert,&
       & gtk_text_buffer_get_iter_at_line,&
       & gtk_text_buffer_get_iter_at_line_offset,&
       & gtk_text_buffer_get_iter_at_mark,&
       & gtk_text_buffer_get_line_count, gtk_text_buffer_get_modified&
       &, gtk_text_buffer_get_selection_bound,&
       & gtk_text_buffer_get_selection_bounds,&
       & gtk_text_buffer_get_start_iter, gtk_text_buffer_get_text,&
       & gtk_text_buffer_insert, gtk_text_buffer_insert_at_cursor,&
       & gtk_text_buffer_new, gtk_text_buffer_set_modified,&
       & gtk_text_buffer_set_text, gtk_text_iter_forward_char,&
       & gtk_text_iter_forward_chars, gtk_text_iter_forward_line,&
       & gtk_text_iter_forward_lines, gtk_text_iter_get_line,&
       & gtk_text_iter_get_line_offset, gtk_text_iter_get_offset,&
       & gtk_text_view_get_buffer, gtk_text_view_new,&
       & gtk_text_view_new_with_buffer, gtk_text_view_set_editable,&
       & gtk_widget_set_sensitive, gtk_widget_set_size_request,&
       & gtk_widget_set_tooltip_text, GTK_POLICY_AUTOMATIC, &
       & TRUE, FALSE, g_signal_connect

  implicit none

contains
  !+
  function hl_gtk_entry_new(len, editable, activate, data, tooltip, value, &
       & sensitive, changed, data_changed, delete_text, data_delete_text, &
       & insert_text, data_insert_text, focus_in_event, focus_out_event, &
       & data_focus_in, data_focus_out, size) result(entry)

    type(c_ptr) :: entry
    integer(c_int), intent(in), optional :: len
    integer(c_int), intent(in), optional :: editable
    type(c_funptr), optional :: activate, focus_in_event, focus_out_event
    type(c_ptr), optional :: data
    character(kind=c_char), dimension(*), intent(in), optional :: tooltip, value
    integer(c_int), intent(in), optional :: sensitive
    type(c_funptr), optional :: changed, delete_text, insert_text
    type(c_ptr), optional :: data_changed, data_delete_text, data_insert_text
    type(c_ptr), optional :: data_focus_in, data_focus_out
    integer(c_int), intent(in), optional :: size
    type(c_ptr) :: buffer

    ! Higher level text entry box
    !
    ! LEN |  integer |  optional |  The maximum length of the entry field.
    ! EDITABLE |  boolean |  optional |  whether the entry box can be edited by the user
    ! ACTIVATE |  c_funptr |  optional |  Callback function for the "activate" signal
    ! DATA |  c_ptr |  optional |  Data to be passed to the activate callback (this is a plain DATA because the changed and other signals were added later.
    ! TOOLTIP |  string |  optional |  tooltip to be displayed when the pointer is held over the button.
    ! VALUE |  string |  optional |  An initial value for the entry box.
    ! SENSITIVE |  boolean |  optional |  Whether the widget should initially be sensitive or not.
    ! CHANGED |  c_funptr |  optional |  Callback for the "changed" signal.
    ! DATA_CHANGED |  c_ptr |  optional |  Data to be passed to the changed callback.
    ! DELETE_TEXT |  c_funptr |  optional |  Callback for the "delete-text" signal.
    ! DATA_DELETE_TEXT |  c_ptr |  optional |  Data to be passed to the delete_text callback
    ! INSERT_TEXT |  c_funptr |  optional |  Callback for the "insert-text" signal.
    ! DATA_INSERT_TEXT |  c_ptr |  optional |  Data to be passed to the insert_text callback
    ! FOCUS_OUT_EVENT |  c_funptr |  optional |  Callback for the "focus-out-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_OUT |  c_ptr |  optional |  Data to pass to the focus_out_event callback
    ! FOCUS_IN_EVENT |  c_funptr |  optional |  Callback for the "focus-in-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_IN |  c_ptr |  optional |  Data to pass to the focus_in_event callback
    ! SIZE |  integer  |  optional  |  The X-size request for the widget. Y is set to default (-1). Note that Gtk may make the widget bigger than this if expand/fill options in the packing require it.
    !-

    entry = gtk_entry_new()
    call gtk_entry_set_activates_default(entry, TRUE)

    if (present(len)) call gtk_entry_set_max_length(entry, len)
    if (present(size)) call gtk_widget_set_size_request(entry, size, -1_c_int)

    if (present(editable)) &
         & call gtk_editable_set_editable(entry, editable)

   if (present(value)) then
     buffer = gtk_entry_get_buffer(entry)
     ! number of caracters = -1 for automatic length:
     call gtk_entry_buffer_set_text (buffer, value, -1)
   end if

    if (present(activate)) then
       if (present(data)) then
          call g_signal_connect(entry, &
               & "activate"//C_NULL_CHAR, activate, data)
       else
          call g_signal_connect(entry, &
               & "activate"//C_NULL_CHAR, activate)
       end if
    end if

    if (present(changed)) then
       if (present(data_changed)) then
          call g_signal_connect(entry, "changed"//C_NULL_CHAR, changed, &
               & data_changed)
       else
          call g_signal_connect(entry, "changed"//C_NULL_CHAR, changed)
       end if
    end if
    if (present(delete_text)) then
       if (present(data_delete_text)) then
          call g_signal_connect(entry, "delete-text"//C_NULL_CHAR, &
               & delete_text, data_delete_text)
       else
          call g_signal_connect(entry, "delete-text"//C_NULL_CHAR, delete_text)
       end if
    end if
    if (present(insert_text)) then
       if (present(data_insert_text)) then
          call g_signal_connect(entry, "insert-text"//C_NULL_CHAR, &
               & insert_text, data_insert_text)
       else
          call g_signal_connect(entry, "insert-text"//C_NULL_CHAR, insert_text)
       end if
    end if
    if (present(focus_out_event)) then
       if (present(data_focus_out)) then
          call g_signal_connect(entry, &
               & "focus-out-event"//C_NULL_CHAR, focus_out_event, &
               & data_focus_out)
       else
          call g_signal_connect(entry, &
               & "focus-out-event"//C_NULL_CHAR, focus_out_event)
       end if
    end if

    if (present(focus_in_event)) then
       if (present(data_focus_in)) then
          call g_signal_connect(entry, &
               & "focus-in-event"//C_NULL_CHAR, focus_in_event, data_focus_in)
       else
          call g_signal_connect(entry, &
               & "focus-in-event"//C_NULL_CHAR, focus_in_event)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(entry, tooltip)

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(entry, sensitive)

  end function hl_gtk_entry_new

  !+
  subroutine hl_gtk_entry_get_text(entry, text, status)

    type(c_ptr), intent(in) :: entry
    character(len=*), intent(out) :: text
    integer(c_int), optional, intent(out) :: status

    ! Return the text in an entry box as a fortran string.
    !
    ! ENTRY |  c_ptr |  required |  The text entry to read
    ! TEXT |  f_string |  required |  The text read.
    ! STATUS |  c_int |  optional |  Returns -1 if the string is truncated.
    !
    ! To return the text as a c-pointer use gtk_entry_get_text
    !-

    type(c_ptr) :: buffer
    integer(c_int16_t) :: ntext
    integer(c_int) :: istat
    istat = 0

    ntext = gtk_entry_get_text_length(entry)
    if (ntext == 0) then
       text=''
       return
    end if

    buffer = gtk_entry_get_buffer(entry)
    call c_f_string_copy(gtk_entry_buffer_get_text(buffer), text)

    if (present(status)) status=istat
  end subroutine hl_gtk_entry_get_text

  !+
  function hl_gtk_text_view_new(scroll, editable, changed, data_changed, &
       & insert_text, data_insert_text, delete_range, data_delete_range, &
       & initial_text, sensitive, tooltip, ssize, buffer, focus_in_event, &
       & focus_out_event, data_focus_in, data_focus_out, hscroll_policy, &
       & vscroll_policy) result(view)

    type(c_ptr) :: view
    type(c_ptr), intent(out), optional :: scroll
    integer(c_int), intent(in), optional :: editable
    type(c_funptr), optional :: changed, insert_text, delete_range
    type(c_ptr), optional :: data_changed, data_insert_text, data_delete_range
    character(kind=c_char, len=*), dimension(:), intent(in), &
         & optional :: initial_text
    integer(c_int), intent(in), optional :: sensitive
    character(kind=c_char), dimension(*), optional :: tooltip
    integer(c_int), dimension(:), optional :: ssize
    type(c_ptr), intent(out), optional :: buffer
    type(c_funptr), optional :: focus_in_event, focus_out_event
    type(c_ptr), optional :: data_focus_in, data_focus_out
    integer(c_int), intent(in), optional :: hscroll_policy, vscroll_policy

    ! A multiline text edit widget
    !
    ! SCROLL |  c_ptr |  optional |  A scrolled window in which the text editor is placed. If it is present, then it must be used used for packing the widget into your application. If it is not used, then scroll bars will not be added if the text goes beyond the edge of the box.
    ! EDITABLE |  boolean |  optional |  Set to FALSE to make a non-editable text box.
    ! CHANGED |  c_funptr |  optional |  Callback for the "activate" signal.
    ! DATA_CHANGED |  c_ptr |  optional |  User data to pass to/from the activate callback
    ! INSERT_TEXT |  c_funptr |  optional |  Callback for the "insert-text" signal. This handler is attached to the text buffer not the text view.
    ! DATA_INSERT_TEXT |  c_ptr |  optional |  User data for the insert-text callback.
    ! DELETE_RANGE |  c_funptr |  optional |  Callback for the "delete-range" signal. This handler is attached to the text buffer not the text view.
    ! DATA_DELETE_RANGE |  c_ptr |  optional |  User data for the delete-range callback.
    ! INITIAL_TEXT |  string() |  optional |  Initial text to put in the text window.
    ! SENSITIVE |  boolean |  optional |  Set to FALSE to make the widget start in an insensitive state.
    ! TOOLTIP |  string |  optional |  A tooltip to display when the pointer is held over the widget.
    ! SSIZE |  c_int(2) |  optional |  Size of the scroll widget.
    ! BUFFER |  c_ptr |  optional |  Variable to return the buffer pointer
    ! FOCUS_OUT_EVENT |  c_funptr |  optional |  Callback for the "focus-out-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_OUT |  c_ptr |  optional |  Data to pass to the focus_out_event callback
    ! FOCUS_IN_EVENT |  c_funptr |  optional |  Callback for the "focus-in-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_IN |  c_ptr |  optional |  Data to pass to the focus_in_event callback
    ! HSCROLL_POLICY |  int |  optional |  Horizontal scrolling policy for the containing scroll window (default AUTOMATIC).
    ! VSCROLL_POLICY |  int |  optional |  Vertical scrolling policy for the containing scroll window (default AUTOMATIC).
    !
    ! NOTE -- The insert-text and delete-range callbacks take extra arguments.
    ! They are called before the buffer is actually modified. The changed
    ! callback is called after the change.
    !-

    type(c_ptr) :: tbuf
    character(kind=c_char), dimension(:), allocatable :: text0
    type(gtktextiter), target :: iter
    integer(c_int) :: itextlen, hscroll, vscroll

    tbuf = gtk_text_buffer_new(C_NULL_PTR)
    view = gtk_text_view_new_with_buffer(tbuf)

    if (present(scroll)) then
       if (present(hscroll_policy)) then
          hscroll = hscroll_policy
       else
          hscroll = GTK_POLICY_AUTOMATIC
       end if
       if (present(vscroll_policy)) then
          vscroll = vscroll_policy
       else
          vscroll = GTK_POLICY_AUTOMATIC
       end if
       scroll = gtk_scrolled_window_new()
       call gtk_scrolled_window_set_policy(scroll,  hscroll, vscroll)
       if (present(ssize)) &
            & call gtk_widget_set_size_request(scroll, ssize(1), ssize(2))
       call gtk_scrolled_window_set_child(scroll, view)
    else if (present(ssize)) then
       call gtk_widget_set_size_request(view, ssize(1), ssize(2))
    end if

    if (present(editable)) then
       call gtk_text_view_set_editable(view, editable)
    else
       call gtk_text_view_set_editable(view, TRUE)
    end if

    ! If there's an initial value, set it before binding the signals.
    if (present(initial_text)) then
       call gtk_text_buffer_get_start_iter(tbuf, c_loc(iter))
      if (len(initial_text) > 1) then
          call convert_f_string(initial_text, text0)
           call gtk_text_buffer_insert(tbuf, c_loc(iter), text0, -1_c_int)
          deallocate(text0)
       else
          if (initial_text(size(initial_text)) == c_null_char) then
             itextlen = -1
          else
             itextlen = size(initial_text)
          end if
          call gtk_text_buffer_insert(tbuf, c_loc(iter), initial_text, &
               & itextlen)
       end if
    end if

    ! Attach the various signals
    if (present(changed)) then
       if (present(data_changed)) then
          call g_signal_connect(tbuf, "changed"//c_null_char, changed, &
               & data_changed)
       else
          call g_signal_connect(tbuf, "changed"//c_null_char, changed)
       end if
    end if
    if (present(insert_text)) then
       if (present(data_insert_text)) then
          call g_signal_connect(tbuf, "insert-text"//c_null_char, insert_text, &
               & data_insert_text)
       else
          call g_signal_connect(tbuf, "insert-text"//c_null_char, insert_text)
       end if
    end if
    if (present(delete_range)) then
       if (present(data_delete_range)) then
          call g_signal_connect(tbuf, "delete-range"//c_null_char, delete_range, &
               & data_delete_range)
       else
          call g_signal_connect(tbuf, "delete-range"//c_null_char, delete_range)
       end if
    end if

    if (present(focus_out_event)) then
       if (present(data_focus_out)) then
          call g_signal_connect(view, &
               & "focus-out-event"//C_NULL_CHAR, focus_out_event, data_focus_out)
       else
          call g_signal_connect(view, &
               & "focus-out-event"//C_NULL_CHAR, focus_out_event)
       end if
    end if

    if (present(focus_in_event)) then
       if (present(data_focus_in)) then
          call g_signal_connect(view, &
               & "focus-in-event"//C_NULL_CHAR, focus_in_event, data_focus_in)
       else
          call g_signal_connect(view, &
               & "focus-in-event"//C_NULL_CHAR, focus_in_event)
       end if
    end if

    if (present(sensitive)) call gtk_widget_set_sensitive(view, sensitive)
    if (present(tooltip)) call gtk_widget_set_tooltip_text(view, tooltip)
    if (present(buffer)) buffer = tbuf

  end function hl_gtk_text_view_new

  !+
  subroutine hl_gtk_text_view_insert(view, text, line, column, replace, &
       & at_cursor, buffer)

    type(c_ptr), intent(in) :: view
    character(len=*), dimension(:), intent(in) :: text
    integer(c_int), optional, intent(in) :: line, column
    integer(c_int), optional, intent(in) :: replace, at_cursor
    type(c_ptr), intent(in), optional :: buffer

    ! Insert text to an text view
    !
    ! VIEW |  c_ptr |  required |  The text view into which to insert.
    ! TEXT |  string() |  required |  The text to insert.
    ! LINE |  c_int |  optional |  The line at which to insert (if omitted, then the text is appended).
    ! COLUMN |  c_int |  optional |  The column as which to insert the text (If omitted, then insert at the start of the line).
    ! REPLACE |  boolean |  optional |  If set to TRUE and LINE and COLUMN are omitted then replace the text in the buffer.
    ! AT_CURSOR |  boolean |  optional |  Set to TRUE to insert the text at the cursor.
    ! BUFFER |  c_ptr |  optional |  The text buffer in which to insert the text If this is given, then VIEW is ignored -- used in signal handlers attached to the buffer.
    !-

    type(c_ptr) :: tbuf
    type(gtktextiter), target :: iter
    integer(c_int) :: icol, irep, atc, found
    character(kind=c_char), dimension(:), allocatable :: text0

    if (present(buffer)) then
       tbuf = buffer
    else
       tbuf= gtk_text_view_get_buffer(view)
    end if

    call convert_f_string(text, text0)

    ! Check if we are going to insert at the cursor, and if so do so.
    if (present(at_cursor)) then
       atc = at_cursor
    else
       atc = FALSE
    end if

    if (atc == TRUE) then
       call gtk_text_buffer_insert_at_cursor(tbuf, text0, -1_c_int)
       deallocate(text0)
       return
    end if

    if (present(line)) then
       if (present(column)) then
          icol = column
       else
          icol = 0
       end if
       if (present(replace)) then
          call hl_gtk_text_view_delete(C_NULL_PTR, line=line, column=icol, &
               & n_chars=size(text0, kind=c_int), buffer=tbuf)
       end if
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(iter), &
            & line, column)
    else
       if (present(replace)) then
          irep = replace
       else
          irep = FALSE
       end if
       if (irep == TRUE) then
          call gtk_text_buffer_set_text(tbuf, text0, -1_c_int)
          deallocate(text0)
          return
       end if
       call gtk_text_buffer_get_end_iter(tbuf, c_loc(iter))
    end if

    call gtk_text_buffer_insert(tbuf, c_loc(iter), text0, -1_c_int)
    deallocate(text0)
  end subroutine hl_gtk_text_view_insert

  !+
  subroutine hl_gtk_text_view_delete(view, line, column, n_chars, n_lines, &
       & buffer)

    type(c_ptr), intent(in) :: view
    integer(c_int), intent(in), optional :: line, column, n_chars, n_lines
    type(c_ptr), intent(in), optional :: buffer

    ! Delete from a text view
    !
    ! VIEW |  c_ptr |  required |  The text view from which to delete.
    ! LINE |  c_int |  optional |  The line at which to start the deletion
    ! COLUMN |  c_int |  optional |  The column at which to start the deletion. required if N_CHARS is given. Ignored if N_LINES is given.
    ! N_CHARS |  c_int |  optional |  How many characters to delete.
    ! N_LINES |  c_int |  optional |  How many lines to delete.
    ! BUFFER |  c_ptr |  optional |  The text buffer from which to delete. If this is given, then VIEW is ignored, used in signal handlers attached to the buffer.
    !
    ! If no location specifiers are given then the buffer is cleared
    !-

    type(c_ptr) :: tbuf
    type(gtktextiter), target :: s_iter, e_iter
    integer(c_int) :: isok, found

    ! Input checking
    if (present(n_chars) .and. present(n_lines)) then
       write(error_unit, *) &
            & "hl_gtk_text_view_delete:: May not specify both N_CHARS and N_LINES"
       return
    end if

    if (present(n_chars) .and. .not. present(column)) then
       write(error_unit, *) &
            & "hl_gtk_text_view_delete:: Character delete requires a start column"
       return
    end if

    ! Find the buffer

    if (present(buffer)) then
       tbuf = buffer
    else
       tbuf = gtk_text_view_get_buffer(view)
    end if

    if (present(n_chars)) then
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(s_iter), &
            & line, column)
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(e_iter), &
            & line, column)
       isok = gtk_text_iter_forward_chars(c_loc(e_iter), n_chars)
    else if (present(n_lines)) then
       found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(s_iter), line)
       found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(e_iter), line)
       isok = gtk_text_iter_forward_lines(c_loc(e_iter), n_lines)
    else
       call gtk_text_buffer_get_start_iter(tbuf, c_loc(s_iter))
       call gtk_text_buffer_get_end_iter(tbuf, c_loc(e_iter))
    end if

    call gtk_text_buffer_delete(tbuf, c_loc(s_iter), c_loc(e_iter))
  end subroutine hl_gtk_text_view_delete

  !+
  subroutine hl_gtk_text_view_get_text(view, text, start_line, start_column, &
       & end_line, end_column, hidden, buffer)

    type(c_ptr), intent(in) :: view
    character(len=*), dimension(:), allocatable, intent(out) :: text
    integer(c_int), intent(in), optional :: start_column, start_line, &
         & end_line, end_column
    integer(c_int), intent(in), optional :: hidden
    type(c_ptr), intent(in), optional :: buffer

    ! Get text from s text view.
    !
    ! VIEW |  c_ptr |  required |  The text view to read.
    ! TEXT |  string() |  required |  A variable to contain the output text.
    ! START_LINE |  c_int |  optional |  The first line to read.
    ! START_COLUMN |  c_int |  optional |  The column at which to start reading.
    ! END_LINE |  c_int |  optional |  The last line to read.
    ! END_COLUMN |  c_int |  optional |  The column at which to stop reading.
    ! HIDDEN |  boolean |  optional |  If set to FALSE, then do not get hidden characters
    ! BUFFER |  c_ptr |  optional |  The text buffer from which to read. If this is given, then VIEW is ignored, useful for signal handlers attached to the buffer.
    !
    ! Note the rules for selection.
    !
    ! * If no selection arguments are present, the whole text is returned.
    ! * If either start_column or end_column is absent, but the matching line
    ! is present, then selection is by line.
    ! * If end_line is absent, but both columns are present, then the selection
    ! is within start_line
    ! * If neither start_line nor start_column is present, then the selection is
    ! from the start of the buffer
    ! * If neither end_line nor end_column is present, then the selection is
    ! to the end of the buffer.
    !-

    type(c_ptr) :: tbuf, ctext0
    character(kind=c_char), dimension(:), pointer :: ftext0
    type(gtktextiter), target :: s_iter, e_iter
    integer(c_int) :: ihid, found
    integer :: nchars_r

    if (present(buffer)) then
       tbuf = buffer
    else
       tbuf = gtk_text_view_get_buffer(view)
    end if

    ! Fully specified
    if (present(start_line) .and. present(start_column) .and. &
         & present(end_line) .and. present(end_column)) then
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(s_iter), &
            & start_line, start_column)
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(e_iter), &
            & end_line, end_column)

       ! Both columns only start line
    else if (present(start_line) .and. present(start_column) .and. &
         &  present(end_column)) then
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(s_iter), &
            & start_line, start_column)
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(e_iter), &
            & start_line, end_column)

       ! Both lines, at least one column not given
    else if (present(start_line) .and. present(start_column)) then
       found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(s_iter), &
            & start_line)
       found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(e_iter), &
            & end_line)

       ! Fully specified start, no end
    else if (present(start_line) .and. present(start_column)) then
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(s_iter), &
            & start_line, start_column)
       call gtk_text_buffer_get_end_iter(tbuf, c_loc(e_iter))

       ! Start line only
    else if (present(start_line)) then
       found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(s_iter), &
            & start_line)
       call gtk_text_buffer_get_end_iter(tbuf, c_loc(e_iter))

       ! Fully specified end, no start
    else if (present(end_line) .and. present(end_column)) then
       call gtk_text_buffer_get_start_iter(tbuf, c_loc(s_iter))
       found=gtk_text_buffer_get_iter_at_line_offset(tbuf, c_loc(e_iter), &
            & start_line, end_column)

       ! End line only
    else if (present(end_line)) then
       call gtk_text_buffer_get_start_iter(tbuf, c_loc(s_iter))
       found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(e_iter), &
            & end_line)

       ! Should only get here with nothing specified
    else
       call gtk_text_buffer_get_start_iter(tbuf, c_loc(s_iter))
       call gtk_text_buffer_get_end_iter(tbuf, c_loc(e_iter))
    end if

    if (present(hidden)) then
       ihid = hidden
    else
       ihid = TRUE
    end if
    ctext0 = gtk_text_buffer_get_text(tbuf, c_loc(s_iter), c_loc(e_iter), ihid)
    nchars_r = int(gtk_text_iter_get_offset(c_loc(e_iter)) - &
         & gtk_text_iter_get_offset(c_loc(s_iter))) + 1

    call c_f_pointer(ctext0, ftext0, [ nchars_r ])
    call convert_c_string(ftext0, text)

  end subroutine hl_gtk_text_view_get_text

  !+
  function hl_gtk_text_view_get_cursor(view, buffer) result(ipos)

    integer(c_int), dimension(3) :: ipos
    type(c_ptr), intent(in) :: view
    type(c_ptr), intent(in), optional :: buffer

    ! Get the current cursor location
    !
    ! VIEW |  c_ptr |  required |  The text view to query
    ! BUFFER |  c_ptr |  optional |  The buffer to query (if given, then VIEW is ignored).
    !
    ! Returns a 3-element array with the line, column and offset of the cursor
    !-

    type(c_ptr) :: tbuf, mark
    type(gtktextiter), target :: iter

    if (present(buffer)) then
       tbuf = buffer
    else
       tbuf = gtk_text_view_get_buffer(view)
    end if

    mark = gtk_text_buffer_get_insert(tbuf)
    call gtk_text_buffer_get_iter_at_mark(tbuf, c_loc(iter), mark)
    ipos(1) = gtk_text_iter_get_line(c_loc(iter))
    ipos(2) = gtk_text_iter_get_line_offset(c_loc(iter))
    ipos(3) = gtk_text_iter_get_offset(c_loc(iter))
  end function hl_gtk_text_view_get_cursor

  !+
  function hl_gtk_text_view_get_selection(view, s_start, s_end, buffer) &
       & result(issel)

    integer(c_int) :: issel
    type(c_ptr), intent(in) :: view
    integer(c_int), dimension(3), intent(out) :: s_start, s_end
    type(c_ptr), intent(in), optional :: buffer

    ! Get the selection range
    !
    ! VIEW |  c_ptr |  required |  The text view to query.
    ! S_START |  c_int() |  required |  The start of the selection. (line, column, offset)
    ! S_END |  c_int() |  required |  The end of the selection. (line, column, offset)
    ! BUFFER |  c_ptr |  optional |  The text buffer to query. If present, then the view argument is ignored.
    !
    ! Returns TRUE if there is a selection, FALSE if there isn't
    !-

    type(c_ptr) :: tbuf
    type(gtktextiter), target :: s_iter, e_iter

    if (present(buffer)) then
       tbuf = buffer
    else
       tbuf = gtk_text_view_get_buffer(view)
    end if

    issel = gtk_text_buffer_get_selection_bounds(tbuf, c_loc(s_iter), &
         & c_loc(e_iter))

    if (issel == FALSE) then ! No selection
       s_start(:) = -1
       s_end(:) = -1
    else
       s_start(1) = gtk_text_iter_get_line(c_loc(s_iter))
       s_start(2) = gtk_text_iter_get_line_offset(c_loc(s_iter))
       s_start(3) = gtk_text_iter_get_offset(c_loc(s_iter))
       s_end(1) = gtk_text_iter_get_line(c_loc(e_iter))
       s_end(2) = gtk_text_iter_get_line_offset(c_loc(e_iter))
       s_end(3) = gtk_text_iter_get_offset(c_loc(e_iter))
    end if
  end function hl_gtk_text_view_get_selection

  !+
  function hl_gtk_text_view_get_modified(view) result(ismod)

    integer(c_int) :: ismod
    type(c_ptr), intent(in) :: view

    ! Check if the buffer of a text view is modified
    !
    ! VIEW |  c_ptr |  required |  The text view to check.
    !
    ! N.B. No BUFFER argument is provided as gtk_text_buffer_get_modified
    ! is just a single call
    !-

    type(c_ptr) :: tbuf

    tbuf = gtk_text_view_get_buffer(view)
    ismod = gtk_text_buffer_get_modified(tbuf)

  end function hl_gtk_text_view_get_modified

  !+
  subroutine hl_gtk_text_view_set_modified(view, state)

    type(c_ptr), intent(in) :: view
    integer(c_int), intent(in) :: state

    ! Set/clear the modified flag on the text buffer of a text view
    !
    ! VIEW |  c_ptr |  required |  The text view to set
    ! STATE |  boolean |  required |  The state to set the flag to.
    !-

    type(c_ptr) :: tbuf

    tbuf = gtk_text_view_get_buffer(view)
    call gtk_text_buffer_set_modified(tbuf, state)

  end subroutine hl_gtk_text_view_set_modified

  !+
  subroutine hl_gtk_text_view_get_info(view, nlines, nchars, ncline, buffer)

    type(c_ptr), intent(in) :: view
    integer(c_int), intent(out), optional :: nlines, nchars
    integer(c_int), intent(out), optional, allocatable, dimension(:) :: ncline
    type(c_ptr), intent(in), optional :: buffer

    ! Get various useful information about a text view
    !
    ! VIEW |  c_ptr |  required |  The view to query
    ! NLINES |  c_int |  optional |  Return the number of lines in the view
    ! NCHARS |  c_int |  optional |  Return the number of characters in the view
    ! NCLINE |  c_int() |  optional |  Return the nuber of characters in each line. Must be an allocatable array.
    ! BUFFER |  c_ptr |  optional |  If present use this buffer and ignore the VIEW argument
    !-

    type(c_ptr) :: tbuf
    type(gtktextiter), target :: i1, i2
    integer(c_int) :: nl, found
    integer(c_int) :: i
    if (present(buffer)) then
       tbuf = buffer
    else
       tbuf = gtk_text_view_get_buffer(view)
    end if

    if (present(nlines) .or. present(ncline)) &
         &  nl = gtk_text_buffer_get_line_count(tbuf)
    if (present(nlines)) nlines = nl

    if (present(nchars)) &
         & nchars = gtk_text_buffer_get_char_count(tbuf)

    if (present(ncline)) then
       allocate(ncline(nl))
       call gtk_text_buffer_get_start_iter(tbuf, c_loc(i1))
       do i = 1, nl-1
          found=gtk_text_buffer_get_iter_at_line(tbuf, c_loc(i2), i)
          ncline(i) = gtk_text_iter_get_offset(c_loc(i2)) - &
               & gtk_text_iter_get_offset(c_loc(i1))-1
          i1 = i2
       end do
       call gtk_text_buffer_get_end_iter(tbuf, c_loc(i2))
       ncline(nl) = gtk_text_iter_get_offset(c_loc(i2)) - &
               & gtk_text_iter_get_offset(c_loc(i1))
    end if
  end subroutine hl_gtk_text_view_get_info
end module gtk_hl_entry

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by Jerry DeLisle and Vincent Magnin
! Last modification: vmagnin 2022-04-05

module handlers
  use gtk, only: gtk_window_set_child, gtk_drawing_area_new, &
  & gtk_drawing_area_set_content_width, gtk_drawing_area_set_content_height, &
  & gtk_drawing_area_set_draw_func, &
  & gtk_widget_queue_draw, gtk_widget_show, gtk_window_new, &
  & gtk_window_set_default_size, gtk_window_set_title, &
  & GDK_COLORSPACE_RGB, gtk_init, g_signal_connect, FALSE, TRUE

  use cairo, only: cairo_create, cairo_destroy, cairo_paint, cairo_set_source

  use gdk, only: gdk_cairo_set_source_pixbuf

  use g, only: g_main_loop_new, g_main_loop_run, g_main_context_iteration, &
             & g_main_context_pending, g_main_loop_quit

  use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, &
                      & gdk_pixbuf_get_rowstride, gdk_pixbuf_new
  use, intrinsic :: iso_c_binding, only: c_int, c_ptr, c_char, c_null_ptr, c_null_char

  implicit none
  type(c_ptr)    :: my_gmainloop
  ! run_status is TRUE until the user closes the top window:
  integer(c_int) :: run_status = TRUE
  integer(c_int) :: boolresult
  type(c_ptr)    :: my_pixbuf
  character(kind=c_char), dimension(:), pointer :: pixel
  integer(c_int) :: nch, rowstride, width, height
  logical :: computing = .false.

contains
  ! Our callback function before destroying the window:
  subroutine destroy_signal(widget, event, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, event, gdata

    print *, "Your destroy_signal() function has been invoked !"
    ! Some functions and subroutines need to know that it's finished:
    run_status = FALSE
    ! Makes the innermost invocation of the main loop return when it regains control:
    if (.not. computing)   call g_main_loop_quit(my_gmainloop)
  end subroutine destroy_signal

  ! This function is needed to update the GUI during long computations.
  ! https://developer.gnome.org/glib/stable/glib-The-Main-Event-Loop.html
  subroutine pending_events ()
    do while(IAND(g_main_context_pending(c_null_ptr), run_status) /= FALSE)
      ! FALSE for non-blocking:
      boolresult = g_main_context_iteration(c_null_ptr, FALSE)
    end do
  end subroutine pending_events

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  ! https://developer.gnome.org/gtk4/stable/GtkDrawingArea.html#gtk-drawing-area-set-draw-func
  subroutine my_draw_function(widget, my_cairo_context, width, height, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height

    ! We redraw the pixbuf:
    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 0d0, 0d0)
    call cairo_paint(my_cairo_context)
  end subroutine my_draw_function

end module handlers


module scientific_computation
  use, intrinsic :: iso_fortran_env, only: wp=>real64, int8

  implicit none

contains
  !*********************************************
  ! A tribute to Benoit MANDELBROT (1924-2010)
  ! http://en.wikipedia.org/wiki/Mandelbrot_set
  !*********************************************
  subroutine Mandelbrot_set(my_drawing_area, xmin, xmax, ymin, ymax, itermax)
    ! Whole set: xmin=-2.0_wp, xmax=+1.0_wp, ymin=-1.5_wp, ymax=+1.5_wp, itermax=1000
    ! Seahorse valley:  around x=-0.743643887037151, y=+0.13182590420533, itermax=5000
    use handlers

    type(c_ptr)   :: my_drawing_area
    integer       :: i, j, k, p, itermax
    real(wp)      :: x, y, xmin, xmax, ymin, ymax ! coordinates in the complex plane
    complex(wp)   :: c, z
    real(wp)      :: scx, scy             ! scales
    integer(int8) :: red, green, blue     ! rgb color
    real(wp)      :: t0, t1

    computing = .true.
    call cpu_time(t0)
    scx = (xmax-xmin) / width   ! x scale
    scy = (ymax-ymin) / height  ! y scale

    do i=0, width-1
      ! **************************************************************************
      ! Needed if you want to display progressively the result during computation.
      ! We provoke a draw event only once in a while to avoid degrading
      ! the performances:
      ! **************************************************************************
      if (mod(i, 10_c_int) == 0) then
        call gtk_widget_queue_draw(my_drawing_area)
      end if

      x = xmin + scx * i
      do j=0, height-1
        y = ymin + scy * j
        c = cmplx(x, y, kind=wp)    ! Starting point
        z = (0.0_wp, 0.0_wp)        ! z0
        k = 1
        do while ((k <= itermax) .and. ((z%re**2 + z%im**2) < 4.0_wp))
          z = z*z + c
          k = k + 1
        end do

        if (k > itermax) then
          ! Black pixel:
          red   = 0
          green = 0
          blue  = 0
        else
          ! Colour palette:
          red   = int(min(255, k*2),  int8)
          green = int(min(255, k*5),  int8)
          blue  = int(min(255, k*10), int8)
        end if

        ! We write in the pixbuffer, using char() because we need unsigned integers:
        p = i * nch + j * rowstride + 1
        pixel(p)   = char(red)
        pixel(p+1) = char(green)
        pixel(p+2) = char(blue)

      end do
      ! **************************************************************************
      ! You need to manage the GTK events during computation:
      ! **************************************************************************
      call pending_events()
      if (run_status == FALSE) return ! Exit if we had a destroy signal.
    end do

    ! Final update of the display:
    call gtk_widget_queue_draw(my_drawing_area)

    call cpu_time(t1)
    print '(A, F6.2, A)', "CPU time = ", t1-t0, " s"

    computing = .false.
  end subroutine mandelbrot_set
end module scientific_computation


!***********************************************
! We define the GUI and then call the main loop:
!***********************************************
program mandelbrot
  use, intrinsic :: iso_c_binding, only: c_ptr, c_null_funptr, c_funloc, c_f_pointer
  use handlers
  use scientific_computation

  implicit none
  type(c_ptr) :: my_window
  type(c_ptr) :: my_drawing_area

  call gtk_init()

  ! Properties of the main window :
  width  = 700
  height = 700
  my_window = gtk_window_new()
  call gtk_window_set_default_size(my_window, width, height)
  call gtk_window_set_title(my_window, &
                    & "A tribute to Benoit MANDELBROT (1924-2010)"//c_null_char)
  call g_signal_connect(my_window, "destroy"//c_null_char, &
                      & c_funloc(destroy_signal))

  ! We need a widget where to draw our pixbuf:
  my_drawing_area = gtk_drawing_area_new()
  call gtk_drawing_area_set_content_width(my_drawing_area, width)
  call gtk_drawing_area_set_content_height(my_drawing_area, height)
  call gtk_drawing_area_set_draw_func(my_drawing_area, &
                   & c_funloc(my_draw_function), c_null_ptr, c_null_funptr)

  call gtk_window_set_child(my_window, my_drawing_area)

  call gtk_widget_show(my_window)

  ! We create a pixbuffer to store the pixels of the image:
  ! "Creates a new GdkPixbuf structure and allocates a buffer for it":
  ! RGB, no alpha channel (FALSE), 8 bits per color sample, width, height
  my_pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8_c_int, width, height)
  ! Queries the number of channels of a pixbuf:
  nch = gdk_pixbuf_get_n_channels(my_pixbuf)
  print *, "Number of channels of the pixbuf: ", nch
  ! "Queries the rowstride of a pixbuf, which is the number of bytes between
  ! the start of a row and the start of the next row":
  rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)
  print *, "Rowstride of the pixbuf: ", rowstride

  ! We need a pointer toward the pixel buffer:
  call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf), pixel, [width*height*nch])

  ! Scientific computing:
  call Mandelbrot_set(my_drawing_area, -2.0_wp, +1.0_wp, -1.5_wp, +1.5_wp, 10000_4)

  ! The window will stay opened after the computation, but we need to verify
  ! that the user has not closed the window during the computation.
  ! https://developer.gnome.org/glib/stable/glib-The-Main-Event-Loop.html
  if (run_status /= FALSE) then
    my_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
    call g_main_loop_run(my_gmainloop)
  end if

  print *, "All done"
end program mandelbrot

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-----------------------------------------------------------------
! Contributed by James Tappin 2011-11-30
! Last modification: vmagnin 2020-06-17 (GTK 4),
! vmagnin 2020-12-20
!-----------------------------------------------------------------


!*
! Buttons
module gtk_hl_button
  ! Convenience interfaces for regular buttons, checkboxes.
  !/

  use gtk_sup
  use gtk_hl_misc
  use, intrinsic :: iso_c_binding
  ! autogenerated use's
  use gtk, only: gtk_button_new, gtk_button_new_with_label,&
       & gtk_check_button_new, gtk_check_button_new_with_label,&
       & gtk_check_button_set_active, &
       & gtk_toggle_button_set_active, gtk_button_get_child, &
       & gtk_widget_set_sensitive, gtk_widget_set_tooltip_text, &
       & gtk_label_new, gtk_label_set_markup, gtk_button_set_child, &
       & gtk_button_set_label, gtk_toggle_button_new, &
       & gtk_toggle_button_new_with_label, &
       & TRUE, FALSE, g_signal_connect

  use g, only: g_slist_length, g_slist_nth, g_slist_nth_data

  implicit none

contains
  !+
  function hl_gtk_button_new(label, clicked, data, tooltip, sensitive, &
       & is_markup) result(but)

    type(c_ptr) :: but
    character(kind=c_char), dimension(*), intent(in) :: label
    type(c_funptr), optional :: clicked
    type(c_ptr), optional :: data
    character(kind=c_char), dimension(*), intent(in), optional :: tooltip
    integer(c_int), intent(in), optional :: sensitive
    integer(c_int), optional, intent(in) :: is_markup

    ! Higher-level button
    !
    ! LABEL |  string |  required |  The label on the button
    ! CLICKED |  c_funptr |  optional |  callback routine for the "clicked" signal
    ! DATA |  c_ptr |  optional |  Data to be passed to the clicked callback
    ! TOOLTIP |  string |  optional |  tooltip to be displayed when the pointer is held over the button.
    ! SENSITIVE |  boolean |  optional |  Whether the widget should initially be sensitive or not.
    ! IS_MARKUP |  boolean |  optional |  Set this to TRUE if the label contains Pango markup.
    !-

    type(c_ptr) :: label_w
    logical :: markup

    if (present(is_markup)) then
       markup = c_f_logical(is_markup)
    else
       markup = .false.
    end if

    if(markup) then
       but = gtk_button_new()
       label_w=gtk_label_new(c_null_char)
       call gtk_label_set_markup(label_w, label)
       call gtk_button_set_child(but, label_w)
    else
       but=gtk_button_new_with_label(label)
    end if

    if (present(clicked)) then
       if (present(data)) then
          call g_signal_connect(but, "clicked"//C_NULL_CHAR, &
               & clicked, data)
       else
          call g_signal_connect(but, "clicked"//C_NULL_CHAR, &
               & clicked)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(but, tooltip)
    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(but, sensitive)

  end function hl_gtk_button_new

  !+
  subroutine hl_gtk_button_set_label(button, label, is_markup)
    type(c_ptr), intent(in) :: button
    character(kind=c_char), dimension(*), intent(in) :: label
    integer(c_int), intent(in), optional :: is_markup

    ! Set the label of a button, including using markup.
    !
    ! BUTTON |  c_ptr |  required |  The button to modify.
    ! LABEL |  string |  required |  The new label for the button.
    ! IS_MARKUP |  boolean |  optional |  Set this to TRUE if the label contains pango markup.
    !-

    logical :: markup
    type(c_ptr) :: label_w

    if (present(is_markup)) then
       markup = c_f_logical(is_markup)
    else
       markup = .false.
    end if

    if (markup) then
       label_w = gtk_button_get_child(button)
       call gtk_label_set_markup(label_w, label)
    else
       call gtk_button_set_label(button, label)
    end if
  end subroutine hl_gtk_button_set_label

  !+
  function hl_gtk_check_button_new(label, toggled, data, tooltip, &
       & initial_state, sensitive, is_markup, toggle) result(but)

    type(c_ptr) :: but
    character(kind=c_char), dimension(*), intent(in) :: label
    type(c_funptr), optional :: toggled
    type(c_ptr), optional :: data
    character(kind=c_char), dimension(*), intent(in), optional :: tooltip
    integer(c_int), intent(in), optional :: initial_state
    integer(c_int), intent(in), optional :: sensitive, is_markup, toggle

    ! Higher level check box.
    !
    ! LABEL |  string |  required |   The label on the button.
    ! TOGGLED |  c_funptr |  optional |  Callback function for the "toggled" signal.
    ! DATA |  c_ptr |  optional |  Data to pass to/from the toggled callback.
    ! TOOLTIP |  string |  optional |  A tooltip for the check_button.
    ! INITIAL_STATE |  integer |  optional |  set the initial state of the check_button.
    ! SENSITIVE |  boolean |  optional |  Whether the widget should initially be sensitive or not.
    ! IS_MARKUP |  boolean |  optional |  Set this to TRUE if the label contains Pango markup.
    ! TOGGLE |  boolean |  optional |  Set this to TRUE to make a toggle button rather than a check button.
    !-

    type(c_ptr) :: label_w
    logical :: markup
    logical :: is_toggle


    if (present(is_markup)) then
       markup = c_f_logical(is_markup)
    else
       markup = .false.
    end if
    if (present(toggle)) then
       is_toggle = c_f_logical(toggle)
    else
       is_toggle = .false.
    end if

    if(markup) then
       if (is_toggle) then
          but = gtk_toggle_button_new()
       else
          but = gtk_check_button_new()
       end if
       label_w=gtk_label_new(c_null_char)
       call gtk_label_set_markup(label_w, label)
       call gtk_button_set_child(but, label_w)
    else
       if (is_toggle) then
          but = gtk_toggle_button_new_with_label(label)
       else
          but = gtk_check_button_new_with_label(label)
       end if
    end if

    if (present(initial_state)) then
       if (is_toggle) then
          call gtk_toggle_button_set_active(but, initial_state)
       else
          call gtk_check_button_set_active(but, initial_state)
       end if
    end if

    if (present(toggled)) then
       if (present(data)) then
          call g_signal_connect(but, "toggled"//c_null_char, toggled, data)
       else
          call g_signal_connect(but, "toggled"//c_null_char, toggled)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(but, tooltip)

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(but, sensitive)

  end function hl_gtk_check_button_new

  !+
  subroutine hl_gtk_button_set_label_markup(but, label)
    type(c_ptr) :: but
    character(kind=c_char), dimension(*), intent(in) :: label

    ! Set a markup label on a button
    !
    ! BUT |  c_ptr |  required |  The button to relabel
    ! LABEL |  string |  required |  The string (with Pango markup) to apply.
    !
    ! Normally if the label does not need Pango markup, then
    ! gtk_button_set_label can be used.
    !-

    call hl_gtk_bin_set_label_markup(but, label)

  end subroutine hl_gtk_button_set_label_markup
end module gtk_hl_button

! Do not modify this file automatically generated by cfwrapper.py using:
! gtk-fortran 4.8.0, GTK 4.18.4, GLib 2.84.1, Fedora 42 x86_64
! This file is part of the gtk-fortran library, distributed under
! GNU General Public License version 3.

module graphene
use, intrinsic :: iso_c_binding
implicit none
interface

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-rect.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_rect_t * graphene_rect_alloc (void);
function graphene_rect_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_rect_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_free (graphene_rect_t *r);
subroutine graphene_rect_free(r) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_rect_t * graphene_rect_init (graphene_rect_t *r, float x, float y, float width, float height);
function graphene_rect_init(r, x, y, width, height) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_rect_init
  type(c_ptr), value :: r
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: width
  real(c_float), value :: height
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_rect_t * graphene_rect_init_from_rect (graphene_rect_t *r, const graphene_rect_t *src);
function graphene_rect_init_from_rect(r, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_rect_init_from_rect
  type(c_ptr), value :: r
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_rect_equal (const graphene_rect_t *a, const graphene_rect_t *b);
function graphene_rect_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_rect_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_rect_t * graphene_rect_normalize (graphene_rect_t *r);
function graphene_rect_normalize(r) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_rect_normalize
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_rect_normalize_r (const graphene_rect_t *r, graphene_rect_t *res);
subroutine graphene_rect_normalize_r(r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_get_center (const graphene_rect_t *r, graphene_point_t *p);
subroutine graphene_rect_get_center(r, p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_get_top_left (const graphene_rect_t *r, graphene_point_t *p);
subroutine graphene_rect_get_top_left(r, p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_get_top_right (const graphene_rect_t *r, graphene_point_t *p);
subroutine graphene_rect_get_top_right(r, p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_get_bottom_right (const graphene_rect_t *r, graphene_point_t *p);
subroutine graphene_rect_get_bottom_right(r, p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_get_bottom_left (const graphene_rect_t *r, graphene_point_t *p);
subroutine graphene_rect_get_bottom_left(r, p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_rect_get_x (const graphene_rect_t *r);
function graphene_rect_get_x(r) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_rect_get_x
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_rect_get_y (const graphene_rect_t *r);
function graphene_rect_get_y(r) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_rect_get_y
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_rect_get_width (const graphene_rect_t *r);
function graphene_rect_get_width(r) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_rect_get_width
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_rect_get_height (const graphene_rect_t *r);
function graphene_rect_get_height(r) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_rect_get_height
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_rect_get_area (const graphene_rect_t *r);
function graphene_rect_get_area(r) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_rect_get_area
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_union (const graphene_rect_t *a, const graphene_rect_t *b, graphene_rect_t *res);
subroutine graphene_rect_union(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_rect_intersection (const graphene_rect_t *a, const graphene_rect_t *b, graphene_rect_t *res);
function graphene_rect_intersection(a, b, res) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_rect_intersection
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_rect_contains_point (const graphene_rect_t *r, const graphene_point_t *p);
function graphene_rect_contains_point(r, p) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_rect_contains_point
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_rect_contains_rect (const graphene_rect_t *a, const graphene_rect_t *b);
function graphene_rect_contains_rect(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_rect_contains_rect
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_rect_t * graphene_rect_offset (graphene_rect_t *r, float d_x, float d_y);
function graphene_rect_offset(r, d_x, d_y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_rect_offset
  type(c_ptr), value :: r
  real(c_float), value :: d_x
  real(c_float), value :: d_y
end function

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_rect_offset_r (const graphene_rect_t *r, float d_x, float d_y, graphene_rect_t *res);
subroutine graphene_rect_offset_r(r, d_x, d_y, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: r
  real(c_float), value :: d_x
  real(c_float), value :: d_y
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_rect_t * graphene_rect_inset (graphene_rect_t *r, float d_x, float d_y);
function graphene_rect_inset(r, d_x, d_y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_rect_inset
  type(c_ptr), value :: r
  real(c_float), value :: d_x
  real(c_float), value :: d_y
end function

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_rect_inset_r (const graphene_rect_t *r, float d_x, float d_y, graphene_rect_t *res);
subroutine graphene_rect_inset_r(r, d_x, d_y, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: r
  real(c_float), value :: d_x
  real(c_float), value :: d_y
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_DEPRECATED_IN_1_4_FOR (graphene_rect_round)
!graphene_rect_t * graphene_rect_round_to_pixel (graphene_rect_t *r);
function graphene_rect_round_to_pixel(r) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_rect_round_to_pixel
  type(c_ptr), value :: r
end function

! GRAPHENE_DEPRECATED_IN_1_10_FOR (graphene_rect_round_extents)
!void graphene_rect_round (const graphene_rect_t *r, graphene_rect_t *res);
subroutine graphene_rect_round(r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_rect_round_extents (const graphene_rect_t *r, graphene_rect_t *res);
subroutine graphene_rect_round_extents(r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_rect_interpolate (const graphene_rect_t *a, const graphene_rect_t *b, double factor, graphene_rect_t *res);
subroutine graphene_rect_interpolate(a, b, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_rect_expand (const graphene_rect_t *r, const graphene_point_t *p, graphene_rect_t *res);
subroutine graphene_rect_expand(r, p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!const graphene_rect_t * graphene_rect_zero (void);
function graphene_rect_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_rect_zero
end function

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_rect_scale (const graphene_rect_t *r, float s_h, float s_v, graphene_rect_t *res);
subroutine graphene_rect_scale(r, s_h, s_v, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: r
  real(c_float), value :: s_h
  real(c_float), value :: s_v
  type(c_ptr), value :: res
end subroutine

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-point.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point_t * graphene_point_alloc (void);
function graphene_point_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point_free (graphene_point_t *p);
subroutine graphene_point_free(p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point_t * graphene_point_init (graphene_point_t *p, float x, float y);
function graphene_point_init(p, x, y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_point_init
  type(c_ptr), value :: p
  real(c_float), value :: x
  real(c_float), value :: y
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point_t * graphene_point_init_from_point (graphene_point_t *p, const graphene_point_t *src);
function graphene_point_init_from_point(p, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point_init_from_point
  type(c_ptr), value :: p
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_4
!graphene_point_t * graphene_point_init_from_vec2 (graphene_point_t *p, const graphene_vec2_t *src);
function graphene_point_init_from_vec2(p, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point_init_from_vec2
  type(c_ptr), value :: p
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_point_equal (const graphene_point_t *a, const graphene_point_t *b);
function graphene_point_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_point_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_point_distance (const graphene_point_t *a, const graphene_point_t *b, float *d_x, float *d_y);
function graphene_point_distance(a, b, d_x, d_y) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_point_distance
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: d_x
  type(c_ptr), value :: d_y
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_point_near (const graphene_point_t *a, const graphene_point_t *b, float epsilon);
function graphene_point_near(a, b, epsilon) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: graphene_point_near
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_float), value :: epsilon
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point_interpolate (const graphene_point_t *a, const graphene_point_t *b, double factor, graphene_point_t *res);
subroutine graphene_point_interpolate(a, b, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_point_to_vec2 (const graphene_point_t *p, graphene_vec2_t *v);
subroutine graphene_point_to_vec2(p, v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: v
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_point_t * graphene_point_zero (void);
function graphene_point_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point_zero
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-macros.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-frustum.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_2
!graphene_frustum_t * graphene_frustum_alloc (void);
function graphene_frustum_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_frustum_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_frustum_free (graphene_frustum_t *f);
subroutine graphene_frustum_free(f) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: f
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_frustum_t * graphene_frustum_init (graphene_frustum_t *f, const graphene_plane_t *p0, const graphene_plane_t *p1, const graphene_plane_t *p2, const graphene_plane_t *p3, const graphene_plane_t *p4, const graphene_plane_t *p5);
function graphene_frustum_init(f, p0, p1, p2, p3, p4, p5) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_frustum_init
  type(c_ptr), value :: f
  type(c_ptr), value :: p0
  type(c_ptr), value :: p1
  type(c_ptr), value :: p2
  type(c_ptr), value :: p3
  type(c_ptr), value :: p4
  type(c_ptr), value :: p5
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_frustum_t * graphene_frustum_init_from_frustum (graphene_frustum_t *f, const graphene_frustum_t *src);
function graphene_frustum_init_from_frustum(f, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_frustum_init_from_frustum
  type(c_ptr), value :: f
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_frustum_t * graphene_frustum_init_from_matrix (graphene_frustum_t *f, const graphene_matrix_t *matrix);
function graphene_frustum_init_from_matrix(f, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_frustum_init_from_matrix
  type(c_ptr), value :: f
  type(c_ptr), value :: matrix
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_frustum_contains_point (const graphene_frustum_t *f, const graphene_point3d_t *point);
function graphene_frustum_contains_point(f, point) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_frustum_contains_point
  type(c_ptr), value :: f
  type(c_ptr), value :: point
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_frustum_intersects_sphere (const graphene_frustum_t *f, const graphene_sphere_t *sphere);
function graphene_frustum_intersects_sphere(f, sphere) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_frustum_intersects_sphere
  type(c_ptr), value :: f
  type(c_ptr), value :: sphere
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_frustum_intersects_box (const graphene_frustum_t *f, const graphene_box_t *box);
function graphene_frustum_intersects_box(f, box) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_frustum_intersects_box
  type(c_ptr), value :: f
  type(c_ptr), value :: box
end function

! GRAPHENE_AVAILABLE_IN_1_6
!bool graphene_frustum_equal (const graphene_frustum_t *a, const graphene_frustum_t *b);
function graphene_frustum_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_frustum_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-euler.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_alloc (void);
function graphene_euler_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_euler_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_euler_free (graphene_euler_t *e);
subroutine graphene_euler_free(e) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: e
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_init (graphene_euler_t *e, float x, float y, float z);
function graphene_euler_init(e, x, y, z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_euler_init
  type(c_ptr), value :: e
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_init_with_order (graphene_euler_t *e, float x, float y, float z, graphene_euler_order_t order);
function graphene_euler_init_with_order(e, x, y, z, order) bind(c)
  import :: c_ptr, c_float, c_int
  implicit none
  type(c_ptr) :: graphene_euler_init_with_order
  type(c_ptr), value :: e
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
  integer(c_int), value :: order
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_init_from_matrix (graphene_euler_t *e, const graphene_matrix_t *m, graphene_euler_order_t order);
function graphene_euler_init_from_matrix(e, m, order) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_euler_init_from_matrix
  type(c_ptr), value :: e
  type(c_ptr), value :: m
  integer(c_int), value :: order
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_init_from_quaternion (graphene_euler_t *e, const graphene_quaternion_t *q, graphene_euler_order_t order);
function graphene_euler_init_from_quaternion(e, q, order) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_euler_init_from_quaternion
  type(c_ptr), value :: e
  type(c_ptr), value :: q
  integer(c_int), value :: order
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_init_from_vec3 (graphene_euler_t *e, const graphene_vec3_t *v, graphene_euler_order_t order);
function graphene_euler_init_from_vec3(e, v, order) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_euler_init_from_vec3
  type(c_ptr), value :: e
  type(c_ptr), value :: v
  integer(c_int), value :: order
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_t * graphene_euler_init_from_euler (graphene_euler_t *e, const graphene_euler_t *src);
function graphene_euler_init_from_euler(e, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_euler_init_from_euler
  type(c_ptr), value :: e
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_10
!graphene_euler_t * graphene_euler_init_from_radians (graphene_euler_t *e, float x, float y, float z, graphene_euler_order_t order);
function graphene_euler_init_from_radians(e, x, y, z, order) bind(c)
  import :: c_ptr, c_float, c_int
  implicit none
  type(c_ptr) :: graphene_euler_init_from_radians
  type(c_ptr), value :: e
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
  integer(c_int), value :: order
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_euler_equal (const graphene_euler_t *a, const graphene_euler_t *b);
function graphene_euler_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_euler_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_euler_get_x (const graphene_euler_t *e);
function graphene_euler_get_x(e) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_euler_get_x
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_euler_get_y (const graphene_euler_t *e);
function graphene_euler_get_y(e) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_euler_get_y
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_euler_get_z (const graphene_euler_t *e);
function graphene_euler_get_z(e) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_euler_get_z
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_euler_order_t graphene_euler_get_order (const graphene_euler_t *e);
function graphene_euler_get_order(e) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_euler_get_order
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_euler_get_alpha (const graphene_euler_t *e);
function graphene_euler_get_alpha(e) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_euler_get_alpha
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_euler_get_beta (const graphene_euler_t *e);
function graphene_euler_get_beta(e) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_euler_get_beta
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_euler_get_gamma (const graphene_euler_t *e);
function graphene_euler_get_gamma(e) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_euler_get_gamma
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_euler_to_vec3 (const graphene_euler_t *e, graphene_vec3_t *res);
subroutine graphene_euler_to_vec3(e, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: e
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_euler_to_matrix (const graphene_euler_t *e, graphene_matrix_t *res);
subroutine graphene_euler_to_matrix(e, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: e
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_euler_to_quaternion (const graphene_euler_t *e, graphene_quaternion_t *res);
subroutine graphene_euler_to_quaternion(e, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: e
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_euler_reorder (const graphene_euler_t *e, graphene_euler_order_t order, graphene_euler_t *res);
subroutine graphene_euler_reorder(e, order, res) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: e
  integer(c_int), value :: order
  type(c_ptr), value :: res
end subroutine

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-vec3.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec3_t * graphene_vec3_alloc (void);
function graphene_vec3_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_free (graphene_vec3_t *v);
subroutine graphene_vec3_free(v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec3_t * graphene_vec3_init (graphene_vec3_t *v, float x, float y, float z);
function graphene_vec3_init(v, x, y, z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_vec3_init
  type(c_ptr), value :: v
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec3_t * graphene_vec3_init_from_vec3 (graphene_vec3_t *v, const graphene_vec3_t *src);
function graphene_vec3_init_from_vec3(v, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_init_from_vec3
  type(c_ptr), value :: v
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec3_t * graphene_vec3_init_from_float (graphene_vec3_t *v, const float *src);
function graphene_vec3_init_from_float(v, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_init_from_float
  type(c_ptr), value :: v
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_to_float (const graphene_vec3_t *v, float *dest);
subroutine graphene_vec3_to_float(v, dest) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: dest
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_add (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_add(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_subtract (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_subtract(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_multiply (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_multiply(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_divide (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_divide(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_cross (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_cross(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec3_dot (const graphene_vec3_t *a, const graphene_vec3_t *b);
function graphene_vec3_dot(a, b) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec3_dot
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec3_length (const graphene_vec3_t *v);
function graphene_vec3_length(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec3_length
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_normalize (const graphene_vec3_t *v, graphene_vec3_t *res);
subroutine graphene_vec3_normalize(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_vec3_scale (const graphene_vec3_t *v, float factor, graphene_vec3_t *res);
subroutine graphene_vec3_scale(v, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: v
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_vec3_negate (const graphene_vec3_t *v, graphene_vec3_t *res);
subroutine graphene_vec3_negate(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_vec3_equal (const graphene_vec3_t *v1, const graphene_vec3_t *v2);
function graphene_vec3_equal(v1, v2) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_vec3_equal
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_vec3_near (const graphene_vec3_t *v1, const graphene_vec3_t *v2, float epsilon);
function graphene_vec3_near(v1, v2, epsilon) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: graphene_vec3_near
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  real(c_float), value :: epsilon
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_min (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_min(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_max (const graphene_vec3_t *a, const graphene_vec3_t *b, graphene_vec3_t *res);
subroutine graphene_vec3_max(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_vec3_interpolate (const graphene_vec3_t *v1, const graphene_vec3_t *v2, double factor, graphene_vec3_t *res);
subroutine graphene_vec3_interpolate(v1, v2, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec3_get_x (const graphene_vec3_t *v);
function graphene_vec3_get_x(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec3_get_x
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec3_get_y (const graphene_vec3_t *v);
function graphene_vec3_get_y(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec3_get_y
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec3_get_z (const graphene_vec3_t *v);
function graphene_vec3_get_z(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec3_get_z
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_get_xy (const graphene_vec3_t *v, graphene_vec2_t *res);
subroutine graphene_vec3_get_xy(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_get_xy0 (const graphene_vec3_t *v, graphene_vec3_t *res);
subroutine graphene_vec3_get_xy0(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_get_xyz0 (const graphene_vec3_t *v, graphene_vec4_t *res);
subroutine graphene_vec3_get_xyz0(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_get_xyz1 (const graphene_vec3_t *v, graphene_vec4_t *res);
subroutine graphene_vec3_get_xyz1(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec3_get_xyzw (const graphene_vec3_t *v, float w, graphene_vec4_t *res);
subroutine graphene_vec3_get_xyzw(v, w, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: v
  real(c_float), value :: w
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec3_t * graphene_vec3_zero (void);
function graphene_vec3_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_zero
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec3_t * graphene_vec3_one (void);
function graphene_vec3_one() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_one
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec3_t * graphene_vec3_x_axis (void);
function graphene_vec3_x_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_x_axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec3_t * graphene_vec3_y_axis (void);
function graphene_vec3_y_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_y_axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec3_t * graphene_vec3_z_axis (void);
function graphene_vec3_z_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec3_z_axis
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-simd4x4f.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_simd4x4f_transpose_in_place (graphene_simd4x4f_t *s);
subroutine graphene_simd4x4f_transpose_in_place(s) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: s
end subroutine

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-simd4f.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-vec4.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec4_t * graphene_vec4_alloc (void);
function graphene_vec4_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_free (graphene_vec4_t *v);
subroutine graphene_vec4_free(v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec4_t * graphene_vec4_init (graphene_vec4_t *v, float x, float y, float z, float w);
function graphene_vec4_init(v, x, y, z, w) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_vec4_init
  type(c_ptr), value :: v
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
  real(c_float), value :: w
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec4_t * graphene_vec4_init_from_vec4 (graphene_vec4_t *v, const graphene_vec4_t *src);
function graphene_vec4_init_from_vec4(v, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_init_from_vec4
  type(c_ptr), value :: v
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec4_t * graphene_vec4_init_from_vec3 (graphene_vec4_t *v, const graphene_vec3_t *src, float w);
function graphene_vec4_init_from_vec3(v, src, w) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_vec4_init_from_vec3
  type(c_ptr), value :: v
  type(c_ptr), value :: src
  real(c_float), value :: w
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec4_t * graphene_vec4_init_from_vec2 (graphene_vec4_t *v, const graphene_vec2_t *src, float z, float w);
function graphene_vec4_init_from_vec2(v, src, z, w) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_vec4_init_from_vec2
  type(c_ptr), value :: v
  type(c_ptr), value :: src
  real(c_float), value :: z
  real(c_float), value :: w
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec4_t * graphene_vec4_init_from_float (graphene_vec4_t *v, const float *src);
function graphene_vec4_init_from_float(v, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_init_from_float
  type(c_ptr), value :: v
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_to_float (const graphene_vec4_t *v, float *dest);
subroutine graphene_vec4_to_float(v, dest) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: dest
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_add (const graphene_vec4_t *a, const graphene_vec4_t *b, graphene_vec4_t *res);
subroutine graphene_vec4_add(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_subtract (const graphene_vec4_t *a, const graphene_vec4_t *b, graphene_vec4_t *res);
subroutine graphene_vec4_subtract(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_multiply (const graphene_vec4_t *a, const graphene_vec4_t *b, graphene_vec4_t *res);
subroutine graphene_vec4_multiply(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_divide (const graphene_vec4_t *a, const graphene_vec4_t *b, graphene_vec4_t *res);
subroutine graphene_vec4_divide(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec4_dot (const graphene_vec4_t *a, const graphene_vec4_t *b);
function graphene_vec4_dot(a, b) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec4_dot
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec4_length (const graphene_vec4_t *v);
function graphene_vec4_length(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec4_length
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_normalize (const graphene_vec4_t *v, graphene_vec4_t *res);
subroutine graphene_vec4_normalize(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_vec4_scale (const graphene_vec4_t *v, float factor, graphene_vec4_t *res);
subroutine graphene_vec4_scale(v, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: v
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_vec4_negate (const graphene_vec4_t *v, graphene_vec4_t *res);
subroutine graphene_vec4_negate(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_vec4_equal (const graphene_vec4_t *v1, const graphene_vec4_t *v2);
function graphene_vec4_equal(v1, v2) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_vec4_equal
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_vec4_near (const graphene_vec4_t *v1, const graphene_vec4_t *v2, float epsilon);
function graphene_vec4_near(v1, v2, epsilon) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: graphene_vec4_near
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  real(c_float), value :: epsilon
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_min (const graphene_vec4_t *a, const graphene_vec4_t *b, graphene_vec4_t *res);
subroutine graphene_vec4_min(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_max (const graphene_vec4_t *a, const graphene_vec4_t *b, graphene_vec4_t *res);
subroutine graphene_vec4_max(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_vec4_interpolate (const graphene_vec4_t *v1, const graphene_vec4_t *v2, double factor, graphene_vec4_t *res);
subroutine graphene_vec4_interpolate(v1, v2, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec4_get_x (const graphene_vec4_t *v);
function graphene_vec4_get_x(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec4_get_x
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec4_get_y (const graphene_vec4_t *v);
function graphene_vec4_get_y(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec4_get_y
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec4_get_z (const graphene_vec4_t *v);
function graphene_vec4_get_z(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec4_get_z
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec4_get_w (const graphene_vec4_t *v);
function graphene_vec4_get_w(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec4_get_w
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_get_xy (const graphene_vec4_t *v, graphene_vec2_t *res);
subroutine graphene_vec4_get_xy(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec4_get_xyz (const graphene_vec4_t *v, graphene_vec3_t *res);
subroutine graphene_vec4_get_xyz(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec4_t * graphene_vec4_zero (void);
function graphene_vec4_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_zero
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec4_t * graphene_vec4_one (void);
function graphene_vec4_one() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_one
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec4_t * graphene_vec4_x_axis (void);
function graphene_vec4_x_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_x_axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec4_t * graphene_vec4_y_axis (void);
function graphene_vec4_y_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_y_axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec4_t * graphene_vec4_z_axis (void);
function graphene_vec4_z_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_z_axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec4_t * graphene_vec4_w_axis (void);
function graphene_vec4_w_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec4_w_axis
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-plane.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_2
!graphene_plane_t * graphene_plane_alloc (void);
function graphene_plane_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_plane_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_plane_free (graphene_plane_t *p);
subroutine graphene_plane_free(p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_plane_t * graphene_plane_init (graphene_plane_t *p, const graphene_vec3_t *normal, float constant);
function graphene_plane_init(p, normal, constant) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_plane_init
  type(c_ptr), value :: p
  type(c_ptr), value :: normal
  real(c_float), value :: constant
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_plane_t * graphene_plane_init_from_vec4 (graphene_plane_t *p, const graphene_vec4_t *src);
function graphene_plane_init_from_vec4(p, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_plane_init_from_vec4
  type(c_ptr), value :: p
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_plane_t * graphene_plane_init_from_plane (graphene_plane_t *p, const graphene_plane_t *src);
function graphene_plane_init_from_plane(p, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_plane_init_from_plane
  type(c_ptr), value :: p
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_plane_t * graphene_plane_init_from_point (graphene_plane_t *p, const graphene_vec3_t *normal, const graphene_point3d_t *point);
function graphene_plane_init_from_point(p, normal, point) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_plane_init_from_point
  type(c_ptr), value :: p
  type(c_ptr), value :: normal
  type(c_ptr), value :: point
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_plane_t * graphene_plane_init_from_points (graphene_plane_t *p, const graphene_point3d_t *a, const graphene_point3d_t *b, const graphene_point3d_t *c);
function graphene_plane_init_from_points(p, a, b, c) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_plane_init_from_points
  type(c_ptr), value :: p
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: c
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_plane_normalize (const graphene_plane_t *p, graphene_plane_t *res);
subroutine graphene_plane_normalize(p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_plane_negate (const graphene_plane_t *p, graphene_plane_t *res);
subroutine graphene_plane_negate(p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_plane_equal (const graphene_plane_t *a, const graphene_plane_t *b);
function graphene_plane_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_plane_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_plane_distance (const graphene_plane_t *p, const graphene_point3d_t *point);
function graphene_plane_distance(p, point) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_plane_distance
  type(c_ptr), value :: p
  type(c_ptr), value :: point
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_plane_get_normal (const graphene_plane_t *p, graphene_vec3_t *normal);
subroutine graphene_plane_get_normal(p, normal) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: normal
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_plane_get_constant (const graphene_plane_t *p);
function graphene_plane_get_constant(p) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_plane_get_constant
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_plane_transform (const graphene_plane_t *p, const graphene_matrix_t *matrix, const graphene_matrix_t *normal_matrix, graphene_plane_t *res);
subroutine graphene_plane_transform(p, matrix, normal_matrix, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: matrix
  type(c_ptr), value :: normal_matrix
  type(c_ptr), value :: res
end subroutine

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-box.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_2
!graphene_box_t * graphene_box_alloc (void);
function graphene_box_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_free (graphene_box_t *box);
subroutine graphene_box_free(box) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_box_t * graphene_box_init (graphene_box_t *box, const graphene_point3d_t *min, const graphene_point3d_t *max);
function graphene_box_init(box, min, max) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_init
  type(c_ptr), value :: box
  type(c_ptr), value :: min
  type(c_ptr), value :: max
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_box_t * graphene_box_init_from_points (graphene_box_t *box, unsigned int n_points, const graphene_point3d_t *points);
function graphene_box_init_from_points(box, n_points, points) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_box_init_from_points
  type(c_ptr), value :: box
  integer(c_int), value :: n_points
  type(c_ptr), value :: points
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_box_t * graphene_box_init_from_vectors (graphene_box_t *box, unsigned int n_vectors, const graphene_vec3_t *vectors);
function graphene_box_init_from_vectors(box, n_vectors, vectors) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_box_init_from_vectors
  type(c_ptr), value :: box
  integer(c_int), value :: n_vectors
  type(c_ptr), value :: vectors
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_box_t * graphene_box_init_from_box (graphene_box_t *box, const graphene_box_t *src);
function graphene_box_init_from_box(box, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_init_from_box
  type(c_ptr), value :: box
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_box_t * graphene_box_init_from_vec3 (graphene_box_t *box, const graphene_vec3_t *min, const graphene_vec3_t *max);
function graphene_box_init_from_vec3(box, min, max) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_init_from_vec3
  type(c_ptr), value :: box
  type(c_ptr), value :: min
  type(c_ptr), value :: max
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_expand (const graphene_box_t *box, const graphene_point3d_t *point, graphene_box_t *res);
subroutine graphene_box_expand(box, point, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: point
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_expand_vec3 (const graphene_box_t *box, const graphene_vec3_t *vec, graphene_box_t *res);
subroutine graphene_box_expand_vec3(box, vec, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: vec
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_expand_scalar (const graphene_box_t *box, float scalar, graphene_box_t *res);
subroutine graphene_box_expand_scalar(box, scalar, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: box
  real(c_float), value :: scalar
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_union (const graphene_box_t *a, const graphene_box_t *b, graphene_box_t *res);
subroutine graphene_box_union(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_box_intersection (const graphene_box_t *a, const graphene_box_t *b, graphene_box_t *res);
function graphene_box_intersection(a, b, res) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_box_intersection
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_box_get_width (const graphene_box_t *box);
function graphene_box_get_width(box) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_box_get_width
  type(c_ptr), value :: box
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_box_get_height (const graphene_box_t *box);
function graphene_box_get_height(box) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_box_get_height
  type(c_ptr), value :: box
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_box_get_depth (const graphene_box_t *box);
function graphene_box_get_depth(box) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_box_get_depth
  type(c_ptr), value :: box
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_get_size (const graphene_box_t *box, graphene_vec3_t *size);
subroutine graphene_box_get_size(box, size) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: size
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_get_center (const graphene_box_t *box, graphene_point3d_t *center);
subroutine graphene_box_get_center(box, center) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: center
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_get_min (const graphene_box_t *box, graphene_point3d_t *min);
subroutine graphene_box_get_min(box, min) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: min
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_get_max (const graphene_box_t *box, graphene_point3d_t *max);
subroutine graphene_box_get_max(box, max) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: max
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_box_get_bounding_sphere (const graphene_box_t *box, graphene_sphere_t *sphere);
subroutine graphene_box_get_bounding_sphere(box, sphere) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: box
  type(c_ptr), value :: sphere
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_box_contains_point (const graphene_box_t *box, const graphene_point3d_t *point);
function graphene_box_contains_point(box, point) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_box_contains_point
  type(c_ptr), value :: box
  type(c_ptr), value :: point
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_box_contains_box (const graphene_box_t *a, const graphene_box_t *b);
function graphene_box_contains_box(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_box_contains_box
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_box_equal (const graphene_box_t *a, const graphene_box_t *b);
function graphene_box_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_box_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_2
!const graphene_box_t * graphene_box_zero (void);
function graphene_box_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_zero
end function

! GRAPHENE_AVAILABLE_IN_1_2
!const graphene_box_t * graphene_box_one (void);
function graphene_box_one() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_one
end function

! GRAPHENE_AVAILABLE_IN_1_2
!const graphene_box_t * graphene_box_minus_one (void);
function graphene_box_minus_one() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_minus_one
end function

! GRAPHENE_AVAILABLE_IN_1_2
!const graphene_box_t * graphene_box_one_minus_one (void);
function graphene_box_one_minus_one() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_one_minus_one
end function

! GRAPHENE_AVAILABLE_IN_1_2
!const graphene_box_t * graphene_box_infinite (void);
function graphene_box_infinite() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_infinite
end function

! GRAPHENE_AVAILABLE_IN_1_2
!const graphene_box_t * graphene_box_empty (void);
function graphene_box_empty() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_box_empty
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-point3d.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point3d_t * graphene_point3d_alloc (void);
function graphene_point3d_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point3d_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point3d_free (graphene_point3d_t *p);
subroutine graphene_point3d_free(p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point3d_t * graphene_point3d_init (graphene_point3d_t *p, float x, float y, float z);
function graphene_point3d_init(p, x, y, z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_point3d_init
  type(c_ptr), value :: p
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point3d_t * graphene_point3d_init_from_point (graphene_point3d_t *p, const graphene_point3d_t *src);
function graphene_point3d_init_from_point(p, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point3d_init_from_point
  type(c_ptr), value :: p
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_point3d_t * graphene_point3d_init_from_vec3 (graphene_point3d_t *p, const graphene_vec3_t *v);
function graphene_point3d_init_from_vec3(p, v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point3d_init_from_vec3
  type(c_ptr), value :: p
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point3d_to_vec3 (const graphene_point3d_t *p, graphene_vec3_t *v);
subroutine graphene_point3d_to_vec3(p, v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: v
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_point3d_equal (const graphene_point3d_t *a, const graphene_point3d_t *b);
function graphene_point3d_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_point3d_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_point3d_near (const graphene_point3d_t *a, const graphene_point3d_t *b, float epsilon);
function graphene_point3d_near(a, b, epsilon) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: graphene_point3d_near
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_float), value :: epsilon
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point3d_scale (const graphene_point3d_t *p, float factor, graphene_point3d_t *res);
subroutine graphene_point3d_scale(p, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: p
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point3d_cross (const graphene_point3d_t *a, const graphene_point3d_t *b, graphene_point3d_t *res);
subroutine graphene_point3d_cross(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_point3d_dot (const graphene_point3d_t *a, const graphene_point3d_t *b);
function graphene_point3d_dot(a, b) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_point3d_dot
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_point3d_length (const graphene_point3d_t *p);
function graphene_point3d_length(p) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_point3d_length
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point3d_normalize (const graphene_point3d_t *p, graphene_point3d_t *res);
subroutine graphene_point3d_normalize(p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!float graphene_point3d_distance (const graphene_point3d_t *a, const graphene_point3d_t *b, graphene_vec3_t *delta);
function graphene_point3d_distance(a, b, delta) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_point3d_distance
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: delta
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_point3d_interpolate (const graphene_point3d_t *a, const graphene_point3d_t *b, double factor, graphene_point3d_t *res);
subroutine graphene_point3d_interpolate(a, b, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_point3d_normalize_viewport (const graphene_point3d_t *p, const graphene_rect_t *viewport, float z_near, float z_far, graphene_point3d_t *res);
subroutine graphene_point3d_normalize_viewport(p, viewport, z_near, z_far, res)&
& bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: p
  type(c_ptr), value :: viewport
  real(c_float), value :: z_near
  real(c_float), value :: z_far
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_point3d_t * graphene_point3d_zero (void);
function graphene_point3d_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_point3d_zero
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-sphere.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_2
!graphene_sphere_t * graphene_sphere_alloc (void);
function graphene_sphere_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_sphere_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_sphere_free (graphene_sphere_t *s);
subroutine graphene_sphere_free(s) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: s
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_sphere_t * graphene_sphere_init (graphene_sphere_t *s, const graphene_point3d_t *center, float radius);
function graphene_sphere_init(s, center, radius) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_sphere_init
  type(c_ptr), value :: s
  type(c_ptr), value :: center
  real(c_float), value :: radius
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_sphere_t * graphene_sphere_init_from_points (graphene_sphere_t *s, unsigned int n_points, const graphene_point3d_t *points, const graphene_point3d_t *center);
function graphene_sphere_init_from_points(s, n_points, points, center) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_sphere_init_from_points
  type(c_ptr), value :: s
  integer(c_int), value :: n_points
  type(c_ptr), value :: points
  type(c_ptr), value :: center
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_sphere_t * graphene_sphere_init_from_vectors (graphene_sphere_t *s, unsigned int n_vectors, const graphene_vec3_t *vectors, const graphene_point3d_t *center);
function graphene_sphere_init_from_vectors(s, n_vectors, vectors, center)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_sphere_init_from_vectors
  type(c_ptr), value :: s
  integer(c_int), value :: n_vectors
  type(c_ptr), value :: vectors
  type(c_ptr), value :: center
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_sphere_get_center (const graphene_sphere_t *s, graphene_point3d_t *center);
subroutine graphene_sphere_get_center(s, center) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: s
  type(c_ptr), value :: center
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_sphere_get_radius (const graphene_sphere_t *s);
function graphene_sphere_get_radius(s) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_sphere_get_radius
  type(c_ptr), value :: s
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_sphere_is_empty (const graphene_sphere_t *s);
function graphene_sphere_is_empty(s) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_sphere_is_empty
  type(c_ptr), value :: s
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_sphere_equal (const graphene_sphere_t *a, const graphene_sphere_t *b);
function graphene_sphere_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_sphere_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_sphere_contains_point (const graphene_sphere_t *s, const graphene_point3d_t *point);
function graphene_sphere_contains_point(s, point) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_sphere_contains_point
  type(c_ptr), value :: s
  type(c_ptr), value :: point
end function

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_sphere_distance (const graphene_sphere_t *s, const graphene_point3d_t *point);
function graphene_sphere_distance(s, point) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_sphere_distance
  type(c_ptr), value :: s
  type(c_ptr), value :: point
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_sphere_get_bounding_box (const graphene_sphere_t *s, graphene_box_t *box);
subroutine graphene_sphere_get_bounding_box(s, box) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: s
  type(c_ptr), value :: box
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_sphere_translate (const graphene_sphere_t *s, const graphene_point3d_t *point, graphene_sphere_t *res);
subroutine graphene_sphere_translate(s, point, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: s
  type(c_ptr), value :: point
  type(c_ptr), value :: res
end subroutine

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-types.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-size.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_size_t * graphene_size_alloc (void);
function graphene_size_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_size_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_size_free (graphene_size_t *s);
subroutine graphene_size_free(s) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: s
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_size_t * graphene_size_init (graphene_size_t *s, float width, float height);
function graphene_size_init(s, width, height) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_size_init
  type(c_ptr), value :: s
  real(c_float), value :: width
  real(c_float), value :: height
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_size_t * graphene_size_init_from_size (graphene_size_t *s, const graphene_size_t *src);
function graphene_size_init_from_size(s, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_size_init_from_size
  type(c_ptr), value :: s
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_size_equal (const graphene_size_t *a, const graphene_size_t *b);
function graphene_size_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_size_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_size_scale (const graphene_size_t *s, float factor, graphene_size_t *res);
subroutine graphene_size_scale(s, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: s
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_size_interpolate (const graphene_size_t *a, const graphene_size_t *b, double factor, graphene_size_t *res);
subroutine graphene_size_interpolate(a, b, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_size_t * graphene_size_zero (void);
function graphene_size_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_size_zero
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-triangle.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_2
!graphene_triangle_t * graphene_triangle_alloc (void);
function graphene_triangle_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_triangle_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_free (graphene_triangle_t *t);
subroutine graphene_triangle_free(t) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_triangle_t * graphene_triangle_init_from_point3d (graphene_triangle_t *t, const graphene_point3d_t *a, const graphene_point3d_t *b, const graphene_point3d_t *c);
function graphene_triangle_init_from_point3d(t, a, b, c) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_triangle_init_from_point3d
  type(c_ptr), value :: t
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: c
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_triangle_t * graphene_triangle_init_from_vec3 (graphene_triangle_t *t, const graphene_vec3_t *a, const graphene_vec3_t *b, const graphene_vec3_t *c);
function graphene_triangle_init_from_vec3(t, a, b, c) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_triangle_init_from_vec3
  type(c_ptr), value :: t
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: c
end function

! GRAPHENE_AVAILABLE_IN_1_10
!graphene_triangle_t * graphene_triangle_init_from_float (graphene_triangle_t *t, const float *a, const float *b, const float *c);
function graphene_triangle_init_from_float(t, a, b, c) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_triangle_init_from_float
  type(c_ptr), value :: t
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: c
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_get_points (const graphene_triangle_t *t, graphene_point3d_t *a, graphene_point3d_t *b, graphene_point3d_t *c);
subroutine graphene_triangle_get_points(t, a, b, c) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: c
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_get_vertices (const graphene_triangle_t *t, graphene_vec3_t *a, graphene_vec3_t *b, graphene_vec3_t *c);
subroutine graphene_triangle_get_vertices(t, a, b, c) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: c
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!float graphene_triangle_get_area (const graphene_triangle_t *t);
function graphene_triangle_get_area(t) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_triangle_get_area
  type(c_ptr), value :: t
end function

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_get_midpoint (const graphene_triangle_t *t, graphene_point3d_t *res);
subroutine graphene_triangle_get_midpoint(t, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_get_normal (const graphene_triangle_t *t, graphene_vec3_t *res);
subroutine graphene_triangle_get_normal(t, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_get_plane (const graphene_triangle_t *t, graphene_plane_t *res);
subroutine graphene_triangle_get_plane(t, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_triangle_get_bounding_box (const graphene_triangle_t *t, graphene_box_t *res);
subroutine graphene_triangle_get_bounding_box(t, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: t
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_triangle_get_barycoords (const graphene_triangle_t *t, const graphene_point3d_t *p, graphene_vec2_t *res);
function graphene_triangle_get_barycoords(t, p, res) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_triangle_get_barycoords
  type(c_ptr), value :: t
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end function

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_triangle_get_uv (const graphene_triangle_t *t, const graphene_point3d_t *p, const graphene_vec2_t *uv_a, const graphene_vec2_t *uv_b, const graphene_vec2_t *uv_c, graphene_vec2_t *res);
function graphene_triangle_get_uv(t, p, uv_a, uv_b, uv_c, res) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_triangle_get_uv
  type(c_ptr), value :: t
  type(c_ptr), value :: p
  type(c_ptr), value :: uv_a
  type(c_ptr), value :: uv_b
  type(c_ptr), value :: uv_c
  type(c_ptr), value :: res
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_triangle_contains_point (const graphene_triangle_t *t, const graphene_point3d_t *p);
function graphene_triangle_contains_point(t, p) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_triangle_contains_point
  type(c_ptr), value :: t
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_triangle_equal (const graphene_triangle_t *a, const graphene_triangle_t *b);
function graphene_triangle_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_triangle_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-version.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-version-macros.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-matrix.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_alloc (void);
function graphene_matrix_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_free (graphene_matrix_t *m);
subroutine graphene_matrix_free(m) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_identity (graphene_matrix_t *m);
function graphene_matrix_init_identity(m) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_init_identity
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_from_float (graphene_matrix_t *m, const float *v);
function graphene_matrix_init_from_float(m, v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_init_from_float
  type(c_ptr), value :: m
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_from_vec4 (graphene_matrix_t *m, const graphene_vec4_t *v0, const graphene_vec4_t *v1, const graphene_vec4_t *v2, const graphene_vec4_t *v3);
function graphene_matrix_init_from_vec4(m, v0, v1, v2, v3) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_init_from_vec4
  type(c_ptr), value :: m
  type(c_ptr), value :: v0
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  type(c_ptr), value :: v3
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_from_matrix (graphene_matrix_t *m, const graphene_matrix_t *src);
function graphene_matrix_init_from_matrix(m, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_init_from_matrix
  type(c_ptr), value :: m
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_perspective (graphene_matrix_t *m, float fovy, float aspect, float z_near, float z_far);
function graphene_matrix_init_perspective(m, fovy, aspect, z_near, z_far)&
& bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_matrix_init_perspective
  type(c_ptr), value :: m
  real(c_float), value :: fovy
  real(c_float), value :: aspect
  real(c_float), value :: z_near
  real(c_float), value :: z_far
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_ortho (graphene_matrix_t *m, float left, float right, float top, float bottom, float z_near, float z_far);
function graphene_matrix_init_ortho(m, left, right, top, bottom, z_near, z_far)&
& bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_matrix_init_ortho
  type(c_ptr), value :: m
  real(c_float), value :: left
  real(c_float), value :: right
  real(c_float), value :: top
  real(c_float), value :: bottom
  real(c_float), value :: z_near
  real(c_float), value :: z_far
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_look_at (graphene_matrix_t *m, const graphene_vec3_t *eye, const graphene_vec3_t *center, const graphene_vec3_t *up);
function graphene_matrix_init_look_at(m, eye, center, up) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_init_look_at
  type(c_ptr), value :: m
  type(c_ptr), value :: eye
  type(c_ptr), value :: center
  type(c_ptr), value :: up
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_matrix_t * graphene_matrix_init_frustum (graphene_matrix_t *m, float left, float right, float bottom, float top, float z_near, float z_far);
function graphene_matrix_init_frustum(m, left, right, bottom, top, z_near,&
& z_far) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_matrix_init_frustum
  type(c_ptr), value :: m
  real(c_float), value :: left
  real(c_float), value :: right
  real(c_float), value :: bottom
  real(c_float), value :: top
  real(c_float), value :: z_near
  real(c_float), value :: z_far
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_scale (graphene_matrix_t *m, float x, float y, float z);
function graphene_matrix_init_scale(m, x, y, z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_matrix_init_scale
  type(c_ptr), value :: m
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_translate (graphene_matrix_t *m, const graphene_point3d_t *p);
function graphene_matrix_init_translate(m, p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_matrix_init_translate
  type(c_ptr), value :: m
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_rotate (graphene_matrix_t *m, float angle, const graphene_vec3_t *axis);
function graphene_matrix_init_rotate(m, angle, axis) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_matrix_init_rotate
  type(c_ptr), value :: m
  real(c_float), value :: angle
  type(c_ptr), value :: axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_skew (graphene_matrix_t *m, float x_skew, float y_skew);
function graphene_matrix_init_skew(m, x_skew, y_skew) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_matrix_init_skew
  type(c_ptr), value :: m
  real(c_float), value :: x_skew
  real(c_float), value :: y_skew
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_matrix_t * graphene_matrix_init_from_2d (graphene_matrix_t *m, double xx, double yx, double xy, double yy, double x_0, double y_0);
function graphene_matrix_init_from_2d(m, xx, yx, xy, yy, x_0, y_0) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr) :: graphene_matrix_init_from_2d
  type(c_ptr), value :: m
  real(c_double), value :: xx
  real(c_double), value :: yx
  real(c_double), value :: xy
  real(c_double), value :: yy
  real(c_double), value :: x_0
  real(c_double), value :: y_0
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_is_identity (const graphene_matrix_t *m);
function graphene_matrix_is_identity(m) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_is_identity
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_is_2d (const graphene_matrix_t *m);
function graphene_matrix_is_2d(m) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_is_2d
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_is_backface_visible (const graphene_matrix_t *m);
function graphene_matrix_is_backface_visible(m) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_is_backface_visible
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_is_singular (const graphene_matrix_t *m);
function graphene_matrix_is_singular(m) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_is_singular
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_to_float (const graphene_matrix_t *m, float *v);
subroutine graphene_matrix_to_float(m, v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: v
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_to_2d (const graphene_matrix_t *m, double *xx, double *yx, double *xy, double *yy, double *x_0, double *y_0);
function graphene_matrix_to_2d(m, xx, yx, xy, yy, x_0, y_0) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_to_2d
  type(c_ptr), value :: m
  type(c_ptr), value :: xx
  type(c_ptr), value :: yx
  type(c_ptr), value :: xy
  type(c_ptr), value :: yy
  type(c_ptr), value :: x_0
  type(c_ptr), value :: y_0
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_get_row (const graphene_matrix_t *m, unsigned int index_, graphene_vec4_t *res);
subroutine graphene_matrix_get_row(m, index_, res) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: m
  integer(c_int), value :: index_
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_matrix_get_value (const graphene_matrix_t *m, unsigned int row, unsigned int col);
function graphene_matrix_get_value(m, row, col) bind(c)
  import :: c_float, c_ptr, c_int
  implicit none
  real(c_float) :: graphene_matrix_get_value
  type(c_ptr), value :: m
  integer(c_int), value :: row
  integer(c_int), value :: col
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_multiply (const graphene_matrix_t *a, const graphene_matrix_t *b, graphene_matrix_t *res);
subroutine graphene_matrix_multiply(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_matrix_determinant (const graphene_matrix_t *m);
function graphene_matrix_determinant(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_determinant
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_transform_vec4 (const graphene_matrix_t *m, const graphene_vec4_t *v, graphene_vec4_t *res);
subroutine graphene_matrix_transform_vec4(m, v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_transform_vec3 (const graphene_matrix_t *m, const graphene_vec3_t *v, graphene_vec3_t *res);
subroutine graphene_matrix_transform_vec3(m, v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_transform_point (const graphene_matrix_t *m, const graphene_point_t *p, graphene_point_t *res);
subroutine graphene_matrix_transform_point(m, p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_transform_point3d (const graphene_matrix_t *m, const graphene_point3d_t *p, graphene_point3d_t *res);
subroutine graphene_matrix_transform_point3d(m, p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_transform_rect (const graphene_matrix_t *m, const graphene_rect_t *r, graphene_quad_t *res);
subroutine graphene_matrix_transform_rect(m, r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_transform_bounds (const graphene_matrix_t *m, const graphene_rect_t *r, graphene_rect_t *res);
subroutine graphene_matrix_transform_bounds(m, r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_transform_sphere (const graphene_matrix_t *m, const graphene_sphere_t *s, graphene_sphere_t *res);
subroutine graphene_matrix_transform_sphere(m, s, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: s
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_transform_box (const graphene_matrix_t *m, const graphene_box_t *b, graphene_box_t *res);
subroutine graphene_matrix_transform_box(m, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_matrix_transform_ray (const graphene_matrix_t *m, const graphene_ray_t *r, graphene_ray_t *res);
subroutine graphene_matrix_transform_ray(m, r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_project_point (const graphene_matrix_t *m, const graphene_point_t *p, graphene_point_t *res);
subroutine graphene_matrix_project_point(m, p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_project_rect_bounds (const graphene_matrix_t *m, const graphene_rect_t *r, graphene_rect_t *res);
subroutine graphene_matrix_project_rect_bounds(m, r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_project_rect (const graphene_matrix_t *m, const graphene_rect_t *r, graphene_quad_t *res);
subroutine graphene_matrix_project_rect(m, r, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: r
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_untransform_point (const graphene_matrix_t *m, const graphene_point_t *p, const graphene_rect_t *bounds, graphene_point_t *res);
function graphene_matrix_untransform_point(m, p, bounds, res) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_untransform_point
  type(c_ptr), value :: m
  type(c_ptr), value :: p
  type(c_ptr), value :: bounds
  type(c_ptr), value :: res
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_untransform_bounds (const graphene_matrix_t *m, const graphene_rect_t *r, const graphene_rect_t *bounds, graphene_rect_t *res);
subroutine graphene_matrix_untransform_bounds(m, r, bounds, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: r
  type(c_ptr), value :: bounds
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_unproject_point3d (const graphene_matrix_t *projection, const graphene_matrix_t *modelview, const graphene_point3d_t *point, graphene_point3d_t *res);
subroutine graphene_matrix_unproject_point3d(projection, modelview, point, res)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: projection
  type(c_ptr), value :: modelview
  type(c_ptr), value :: point
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_translate (graphene_matrix_t *m, const graphene_point3d_t *pos);
subroutine graphene_matrix_translate(m, pos) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: pos
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_rotate (graphene_matrix_t *m, float angle, const graphene_vec3_t *axis);
subroutine graphene_matrix_rotate(m, angle, axis) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: angle
  type(c_ptr), value :: axis
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_rotate_x (graphene_matrix_t *m, float angle);
subroutine graphene_matrix_rotate_x(m, angle) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: angle
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_rotate_y (graphene_matrix_t *m, float angle);
subroutine graphene_matrix_rotate_y(m, angle) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: angle
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_rotate_z (graphene_matrix_t *m, float angle);
subroutine graphene_matrix_rotate_z(m, angle) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: angle
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_rotate_quaternion (graphene_matrix_t *m, const graphene_quaternion_t *q);
subroutine graphene_matrix_rotate_quaternion(m, q) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: q
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_matrix_rotate_euler (graphene_matrix_t *m, const graphene_euler_t *e);
subroutine graphene_matrix_rotate_euler(m, e) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: e
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_scale (graphene_matrix_t *m, float factor_x, float factor_y, float factor_z);
subroutine graphene_matrix_scale(m, factor_x, factor_y, factor_z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: factor_x
  real(c_float), value :: factor_y
  real(c_float), value :: factor_z
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_skew_xy (graphene_matrix_t *m, float factor);
subroutine graphene_matrix_skew_xy(m, factor) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: factor
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_skew_xz (graphene_matrix_t *m, float factor);
subroutine graphene_matrix_skew_xz(m, factor) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: factor
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_skew_yz (graphene_matrix_t *m, float factor);
subroutine graphene_matrix_skew_yz(m, factor) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: factor
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_transpose (const graphene_matrix_t *m, graphene_matrix_t *res);
subroutine graphene_matrix_transpose(m, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_matrix_inverse (const graphene_matrix_t *m, graphene_matrix_t *res);
function graphene_matrix_inverse(m, res) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_inverse
  type(c_ptr), value :: m
  type(c_ptr), value :: res
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_perspective (const graphene_matrix_t *m, float depth, graphene_matrix_t *res);
subroutine graphene_matrix_perspective(m, depth, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: m
  real(c_float), value :: depth
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_normalize (const graphene_matrix_t *m, graphene_matrix_t *res);
subroutine graphene_matrix_normalize(m, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_matrix_get_x_translation (const graphene_matrix_t *m);
function graphene_matrix_get_x_translation(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_get_x_translation
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_matrix_get_y_translation (const graphene_matrix_t *m);
function graphene_matrix_get_y_translation(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_get_y_translation
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_10
!float graphene_matrix_get_z_translation (const graphene_matrix_t *m);
function graphene_matrix_get_z_translation(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_get_z_translation
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_matrix_get_x_scale (const graphene_matrix_t *m);
function graphene_matrix_get_x_scale(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_get_x_scale
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_matrix_get_y_scale (const graphene_matrix_t *m);
function graphene_matrix_get_y_scale(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_get_y_scale
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_matrix_get_z_scale (const graphene_matrix_t *m);
function graphene_matrix_get_z_scale(m) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_matrix_get_z_scale
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_interpolate (const graphene_matrix_t *a, const graphene_matrix_t *b, double factor, graphene_matrix_t *res);
subroutine graphene_matrix_interpolate(a, b, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_matrix_near (const graphene_matrix_t *a, const graphene_matrix_t *b, float epsilon);
function graphene_matrix_near(a, b, epsilon) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: graphene_matrix_near
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_float), value :: epsilon
end function

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_matrix_equal (const graphene_matrix_t *a, const graphene_matrix_t *b);
function graphene_matrix_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_matrix_equal_fast (const graphene_matrix_t *a, const graphene_matrix_t *b);
function graphene_matrix_equal_fast(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_equal_fast
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_matrix_print (const graphene_matrix_t *m);
subroutine graphene_matrix_print(m) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: m
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_matrix_decompose (const graphene_matrix_t *m, graphene_vec3_t *translate, graphene_vec3_t *scale, graphene_quaternion_t *rotate, graphene_vec3_t *shear, graphene_vec4_t *perspective);
function graphene_matrix_decompose(m, translate, scale, rotate, shear,&
& perspective) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_matrix_decompose
  type(c_ptr), value :: m
  type(c_ptr), value :: translate
  type(c_ptr), value :: scale
  type(c_ptr), value :: rotate
  type(c_ptr), value :: shear
  type(c_ptr), value :: perspective
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-gobject.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_point_get_type (void);
function graphene_point_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_point_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_point3d_get_type (void);
function graphene_point3d_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_point3d_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_size_get_type (void);
function graphene_size_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_size_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_rect_get_type (void);
function graphene_rect_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_rect_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_vec2_get_type (void);
function graphene_vec2_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_vec2_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_vec3_get_type (void);
function graphene_vec3_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_vec3_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_vec4_get_type (void);
function graphene_vec4_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_vec4_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_quad_get_type (void);
function graphene_quad_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_quad_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_quaternion_get_type (void);
function graphene_quaternion_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_quaternion_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_0
!GType graphene_matrix_get_type (void);
function graphene_matrix_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_matrix_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_2
!GType graphene_plane_get_type (void);
function graphene_plane_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_plane_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_2
!GType graphene_frustum_get_type (void);
function graphene_frustum_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_frustum_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_2
!GType graphene_sphere_get_type (void);
function graphene_sphere_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_sphere_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_2
!GType graphene_box_get_type (void);
function graphene_box_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_box_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_2
!GType graphene_triangle_get_type (void);
function graphene_triangle_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_triangle_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_2
!GType graphene_euler_get_type (void);
function graphene_euler_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_euler_get_type
end function

! GRAPHENE_AVAILABLE_IN_1_4
!GType graphene_ray_get_type (void);
function graphene_ray_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: graphene_ray_get_type
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-ray.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_4
!graphene_ray_t * graphene_ray_alloc (void);
function graphene_ray_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_ray_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_ray_free (graphene_ray_t *r);
subroutine graphene_ray_free(r) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!graphene_ray_t * graphene_ray_init (graphene_ray_t *r, const graphene_point3d_t *origin, const graphene_vec3_t *direction);
function graphene_ray_init(r, origin, direction) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_ray_init
  type(c_ptr), value :: r
  type(c_ptr), value :: origin
  type(c_ptr), value :: direction
end function

! GRAPHENE_AVAILABLE_IN_1_4
!graphene_ray_t * graphene_ray_init_from_ray (graphene_ray_t *r, const graphene_ray_t *src);
function graphene_ray_init_from_ray(r, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_ray_init_from_ray
  type(c_ptr), value :: r
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_4
!graphene_ray_t * graphene_ray_init_from_vec3 (graphene_ray_t *r, const graphene_vec3_t *origin, const graphene_vec3_t *direction);
function graphene_ray_init_from_vec3(r, origin, direction) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_ray_init_from_vec3
  type(c_ptr), value :: r
  type(c_ptr), value :: origin
  type(c_ptr), value :: direction
end function

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_ray_get_origin (const graphene_ray_t *r, graphene_point3d_t *origin);
subroutine graphene_ray_get_origin(r, origin) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: origin
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_ray_get_direction (const graphene_ray_t *r, graphene_vec3_t *direction);
subroutine graphene_ray_get_direction(r, direction) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: direction
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_ray_get_position_at (const graphene_ray_t *r, float t, graphene_point3d_t *position);
subroutine graphene_ray_get_position_at(r, t, position) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: r
  real(c_float), value :: t
  type(c_ptr), value :: position
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!float graphene_ray_get_distance_to_point (const graphene_ray_t *r, const graphene_point3d_t *p);
function graphene_ray_get_distance_to_point(r, p) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_ray_get_distance_to_point
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_4
!float graphene_ray_get_distance_to_plane (const graphene_ray_t *r, const graphene_plane_t *p);
function graphene_ray_get_distance_to_plane(r, p) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_ray_get_distance_to_plane
  type(c_ptr), value :: r
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_4
!bool graphene_ray_equal (const graphene_ray_t *a, const graphene_ray_t *b);
function graphene_ray_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_ray_get_closest_point_to_point (const graphene_ray_t *r, const graphene_point3d_t *p, graphene_point3d_t *res);
subroutine graphene_ray_get_closest_point_to_point(r, p, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: r
  type(c_ptr), value :: p
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!graphene_ray_intersection_kind_t graphene_ray_intersect_sphere (const graphene_ray_t *r, const graphene_sphere_t *s, float *t_out);
function graphene_ray_intersect_sphere(r, s, t_out) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_intersect_sphere
  type(c_ptr), value :: r
  type(c_ptr), value :: s
  type(c_ptr), value :: t_out
end function

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_ray_intersects_sphere (const graphene_ray_t *r, const graphene_sphere_t *s);
function graphene_ray_intersects_sphere(r, s) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_intersects_sphere
  type(c_ptr), value :: r
  type(c_ptr), value :: s
end function

! GRAPHENE_AVAILABLE_IN_1_10
!graphene_ray_intersection_kind_t graphene_ray_intersect_box (const graphene_ray_t *r, const graphene_box_t *b, float *t_out);
function graphene_ray_intersect_box(r, b, t_out) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_intersect_box
  type(c_ptr), value :: r
  type(c_ptr), value :: b
  type(c_ptr), value :: t_out
end function

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_ray_intersects_box (const graphene_ray_t *r, const graphene_box_t *b);
function graphene_ray_intersects_box(r, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_intersects_box
  type(c_ptr), value :: r
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_10
!graphene_ray_intersection_kind_t graphene_ray_intersect_triangle (const graphene_ray_t *r, const graphene_triangle_t *t, float *t_out);
function graphene_ray_intersect_triangle(r, t, t_out) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_intersect_triangle
  type(c_ptr), value :: r
  type(c_ptr), value :: t
  type(c_ptr), value :: t_out
end function

! GRAPHENE_AVAILABLE_IN_1_10
!bool graphene_ray_intersects_triangle (const graphene_ray_t *r, const graphene_triangle_t *t);
function graphene_ray_intersects_triangle(r, t) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_ray_intersects_triangle
  type(c_ptr), value :: r
  type(c_ptr), value :: t
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-quad.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quad_t * graphene_quad_alloc (void);
function graphene_quad_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quad_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quad_free (graphene_quad_t *q);
subroutine graphene_quad_free(q) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quad_t * graphene_quad_init (graphene_quad_t *q, const graphene_point_t *p1, const graphene_point_t *p2, const graphene_point_t *p3, const graphene_point_t *p4);
function graphene_quad_init(q, p1, p2, p3, p4) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quad_init
  type(c_ptr), value :: q
  type(c_ptr), value :: p1
  type(c_ptr), value :: p2
  type(c_ptr), value :: p3
  type(c_ptr), value :: p4
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quad_t * graphene_quad_init_from_rect (graphene_quad_t *q, const graphene_rect_t *r);
function graphene_quad_init_from_rect(q, r) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quad_init_from_rect
  type(c_ptr), value :: q
  type(c_ptr), value :: r
end function

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_quad_contains (const graphene_quad_t *q, const graphene_point_t *p);
function graphene_quad_contains(q, p) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_quad_contains
  type(c_ptr), value :: q
  type(c_ptr), value :: p
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quad_bounds (const graphene_quad_t *q, graphene_rect_t *r);
subroutine graphene_quad_bounds(q, r) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: r
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_point_t *graphene_quad_get_point (const graphene_quad_t *q, unsigned int index_);
function graphene_quad_get_point(q, index_) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: graphene_quad_get_point
  type(c_ptr), value :: q
  integer(c_int), value :: index_
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-vec2.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec2_t * graphene_vec2_alloc (void);
function graphene_vec2_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_free (graphene_vec2_t *v);
subroutine graphene_vec2_free(v) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec2_t * graphene_vec2_init (graphene_vec2_t *v, float x, float y);
function graphene_vec2_init(v, x, y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_vec2_init
  type(c_ptr), value :: v
  real(c_float), value :: x
  real(c_float), value :: y
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec2_t * graphene_vec2_init_from_vec2 (graphene_vec2_t *v, const graphene_vec2_t *src);
function graphene_vec2_init_from_vec2(v, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_init_from_vec2
  type(c_ptr), value :: v
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_vec2_t * graphene_vec2_init_from_float (graphene_vec2_t *v, const float *src);
function graphene_vec2_init_from_float(v, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_init_from_float
  type(c_ptr), value :: v
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_to_float (const graphene_vec2_t *v, float *dest);
subroutine graphene_vec2_to_float(v, dest) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: dest
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_add (const graphene_vec2_t *a, const graphene_vec2_t *b, graphene_vec2_t *res);
subroutine graphene_vec2_add(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_subtract (const graphene_vec2_t *a, const graphene_vec2_t *b, graphene_vec2_t *res);
subroutine graphene_vec2_subtract(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_multiply (const graphene_vec2_t *a, const graphene_vec2_t *b, graphene_vec2_t *res);
subroutine graphene_vec2_multiply(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_divide (const graphene_vec2_t *a, const graphene_vec2_t *b, graphene_vec2_t *res);
subroutine graphene_vec2_divide(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec2_dot (const graphene_vec2_t *a, const graphene_vec2_t *b);
function graphene_vec2_dot(a, b) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec2_dot
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec2_length (const graphene_vec2_t *v);
function graphene_vec2_length(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec2_length
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_normalize (const graphene_vec2_t *v, graphene_vec2_t *res);
subroutine graphene_vec2_normalize(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_vec2_scale (const graphene_vec2_t *v, float factor, graphene_vec2_t *res);
subroutine graphene_vec2_scale(v, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: v
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_vec2_negate (const graphene_vec2_t *v, graphene_vec2_t *res);
subroutine graphene_vec2_negate(v, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: v
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_vec2_near (const graphene_vec2_t *v1, const graphene_vec2_t *v2, float epsilon);
function graphene_vec2_near(v1, v2, epsilon) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: graphene_vec2_near
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  real(c_float), value :: epsilon
end function

! GRAPHENE_AVAILABLE_IN_1_2
!bool graphene_vec2_equal (const graphene_vec2_t *v1, const graphene_vec2_t *v2);
function graphene_vec2_equal(v1, v2) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_vec2_equal
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_min (const graphene_vec2_t *a, const graphene_vec2_t *b, graphene_vec2_t *res);
subroutine graphene_vec2_min(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_vec2_max (const graphene_vec2_t *a, const graphene_vec2_t *b, graphene_vec2_t *res);
subroutine graphene_vec2_max(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_vec2_interpolate (const graphene_vec2_t *v1, const graphene_vec2_t *v2, double factor, graphene_vec2_t *res);
subroutine graphene_vec2_interpolate(v1, v2, factor, res) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: v1
  type(c_ptr), value :: v2
  real(c_double), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec2_get_x (const graphene_vec2_t *v);
function graphene_vec2_get_x(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec2_get_x
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_vec2_get_y (const graphene_vec2_t *v);
function graphene_vec2_get_y(v) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_vec2_get_y
  type(c_ptr), value :: v
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec2_t * graphene_vec2_zero (void);
function graphene_vec2_zero() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_zero
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec2_t * graphene_vec2_one (void);
function graphene_vec2_one() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_one
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec2_t * graphene_vec2_x_axis (void);
function graphene_vec2_x_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_x_axis
end function

! GRAPHENE_AVAILABLE_IN_1_0
!const graphene_vec2_t * graphene_vec2_y_axis (void);
function graphene_vec2_y_axis() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_vec2_y_axis
end function

!--------------------------------------------------
! /usr/include/graphene-1.0/graphene-quaternion.h
!--------------------------------------------------
! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_alloc (void);
function graphene_quaternion_alloc() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quaternion_alloc
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_free (graphene_quaternion_t *q);
subroutine graphene_quaternion_free(q) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init (graphene_quaternion_t *q, float x, float y, float z, float w);
function graphene_quaternion_init(q, x, y, z, w) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_quaternion_init
  type(c_ptr), value :: q
  real(c_float), value :: x
  real(c_float), value :: y
  real(c_float), value :: z
  real(c_float), value :: w
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init_identity (graphene_quaternion_t *q);
function graphene_quaternion_init_identity(q) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quaternion_init_identity
  type(c_ptr), value :: q
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init_from_quaternion (graphene_quaternion_t *q, const graphene_quaternion_t *src);
function graphene_quaternion_init_from_quaternion(q, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_quaternion
  type(c_ptr), value :: q
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init_from_vec4 (graphene_quaternion_t *q, const graphene_vec4_t *src);
function graphene_quaternion_init_from_vec4(q, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_vec4
  type(c_ptr), value :: q
  type(c_ptr), value :: src
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init_from_matrix (graphene_quaternion_t *q, const graphene_matrix_t *m);
function graphene_quaternion_init_from_matrix(q, m) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_matrix
  type(c_ptr), value :: q
  type(c_ptr), value :: m
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init_from_angles (graphene_quaternion_t *q, float deg_x, float deg_y, float deg_z);
function graphene_quaternion_init_from_angles(q, deg_x, deg_y, deg_z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_angles
  type(c_ptr), value :: q
  real(c_float), value :: deg_x
  real(c_float), value :: deg_y
  real(c_float), value :: deg_z
end function

! GRAPHENE_AVAILABLE_IN_1_4
!graphene_quaternion_t * graphene_quaternion_init_from_radians (graphene_quaternion_t *q, float rad_x, float rad_y, float rad_z);
function graphene_quaternion_init_from_radians(q, rad_x, rad_y, rad_z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_radians
  type(c_ptr), value :: q
  real(c_float), value :: rad_x
  real(c_float), value :: rad_y
  real(c_float), value :: rad_z
end function

! GRAPHENE_AVAILABLE_IN_1_0
!graphene_quaternion_t * graphene_quaternion_init_from_angle_vec3 (graphene_quaternion_t *q, float angle, const graphene_vec3_t *axis);
function graphene_quaternion_init_from_angle_vec3(q, angle, axis) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_angle_vec3
  type(c_ptr), value :: q
  real(c_float), value :: angle
  type(c_ptr), value :: axis
end function

! GRAPHENE_AVAILABLE_IN_1_2
!graphene_quaternion_t * graphene_quaternion_init_from_euler (graphene_quaternion_t *q, const graphene_euler_t *e);
function graphene_quaternion_init_from_euler(q, e) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: graphene_quaternion_init_from_euler
  type(c_ptr), value :: q
  type(c_ptr), value :: e
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_to_vec4 (const graphene_quaternion_t *q, graphene_vec4_t *res);
subroutine graphene_quaternion_to_vec4(q, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_to_matrix (const graphene_quaternion_t *q, graphene_matrix_t *m);
subroutine graphene_quaternion_to_matrix(q, m) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: m
end subroutine

! GRAPHENE_AVAILABLE_IN_1_2
!void graphene_quaternion_to_angles (const graphene_quaternion_t *q, float *deg_x, float *deg_y, float *deg_z);
subroutine graphene_quaternion_to_angles(q, deg_x, deg_y, deg_z) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: deg_x
  type(c_ptr), value :: deg_y
  type(c_ptr), value :: deg_z
end subroutine

! GRAPHENE_AVAILABLE_IN_1_4
!void graphene_quaternion_to_radians (const graphene_quaternion_t *q, float *rad_x, float *rad_y, float *rad_z);
subroutine graphene_quaternion_to_radians(q, rad_x, rad_y, rad_z) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: rad_x
  type(c_ptr), value :: rad_y
  type(c_ptr), value :: rad_z
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_to_angle_vec3 (const graphene_quaternion_t *q, float *angle, graphene_vec3_t *axis);
subroutine graphene_quaternion_to_angle_vec3(q, angle, axis) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: angle
  type(c_ptr), value :: axis
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!bool graphene_quaternion_equal (const graphene_quaternion_t *a, const graphene_quaternion_t *b);
function graphene_quaternion_equal(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: graphene_quaternion_equal
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!float graphene_quaternion_dot (const graphene_quaternion_t *a, const graphene_quaternion_t *b);
function graphene_quaternion_dot(a, b) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: graphene_quaternion_dot
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_invert (const graphene_quaternion_t *q, graphene_quaternion_t *res);
subroutine graphene_quaternion_invert(q, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_normalize (const graphene_quaternion_t *q, graphene_quaternion_t *res);
subroutine graphene_quaternion_normalize(q, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: q
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_0
!void graphene_quaternion_slerp (const graphene_quaternion_t *a, const graphene_quaternion_t *b, float factor, graphene_quaternion_t *res);
subroutine graphene_quaternion_slerp(a, b, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_quaternion_multiply (const graphene_quaternion_t *a, const graphene_quaternion_t *b, graphene_quaternion_t *res);
subroutine graphene_quaternion_multiply(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_quaternion_scale (const graphene_quaternion_t *q, float factor, graphene_quaternion_t *res);
subroutine graphene_quaternion_scale(q, factor, res) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: q
  real(c_float), value :: factor
  type(c_ptr), value :: res
end subroutine

! GRAPHENE_AVAILABLE_IN_1_10
!void graphene_quaternion_add (const graphene_quaternion_t *a, const graphene_quaternion_t *b, graphene_quaternion_t *res);
subroutine graphene_quaternion_add(a, b, res) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: a
  type(c_ptr), value :: b
  type(c_ptr), value :: res
end subroutine

end interface
end module graphene

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by Jerry DeLisle and Vincent Magnin
! Event handling & Zoom : James Tappin
! Last modifications: vmagnin 2020-12-18, 2021-01-22
!------------------------------------------------------------------------------

module handlers
  use cairo, only: cairo_paint
  use gdk, only: gdk_cairo_set_source_pixbuf
  use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, &
       & gdk_pixbuf_get_rowstride, gdk_pixbuf_new
  use gtk, only: gtk_application_window_new, gtk_application_new, &
       & gtk_window_set_default_size, gtk_box_new, &
       & gtk_window_set_child, gtk_box_append, gtk_drawing_area_new,  &
       & gtk_label_new, gtk_label_set_text, &
       & gtk_statusbar_new, gtk_statusbar_push, &
       & gtk_widget_queue_draw, &
       & gtk_drawing_area_set_draw_func, &
       & gtk_widget_set_size_request, gtk_widget_show, gtk_window_new, &
       & gtk_window_set_title, gtk_init, g_signal_connect, TRUE, FALSE, &
       & GTK_ORIENTATION_VERTICAL, GDK_COLORSPACE_RGB, &
       & gtk_gesture_click_new, gtk_widget_add_controller, &
       & gtk_event_controller_get_widget, gtk_event_controller_motion_new, &
       & gtk_gesture_single_get_current_button, &
       & gtk_gesture_single_set_button, gtk_event_controller_scroll_new, &
       & GTK_EVENT_CONTROLLER_SCROLL_VERTICAL
  use g, only: g_main_context_iteration, &
             & g_main_context_pending, &
             & g_application_run, g_object_unref
  use, intrinsic :: iso_c_binding

  implicit none
  integer(c_int) :: run_status = TRUE
  integer(c_int) :: boolresult
  type(c_ptr) :: my_pixbuf, status_bar, rangeid
  character(kind=c_char), dimension(:,:,:), pointer :: pixel
  integer(c_int) :: nch, rowstride, width, height
  logical :: need_point     ! even/odd point flag
  logical :: computing_flag
  character(len=120) :: rangestr
  real(c_double) :: mxmin, mxmax, mymin, mymax
  integer(c_int) :: mouse_x, mouse_y

contains
  ! User defined event handlers go here

  ! This function is needed to update the GUI during long computations.
  ! https://developer.gnome.org/glib/stable/glib-The-Main-Event-Loop.html
  subroutine pending_events ()
    do while(IAND(g_main_context_pending(c_null_ptr), run_status) /= FALSE)
      ! FALSE for non-blocking:
      boolresult = g_main_context_iteration(c_null_ptr, FALSE)
    end do
  end subroutine pending_events

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  ! https://developer.gnome.org/gtk4/stable/GtkDrawingArea.html#gtk-drawing-area-set-draw-func
  subroutine draw(widget, my_cairo_context, width, height, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height

    ! We redraw the pixbuf:
    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 0d0, 0d0)
    call cairo_paint(my_cairo_context)
  end subroutine draw

  ! Click callback function ("pressed" signal):
  subroutine click_cb(gesture, n_press, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: gesture, gdata
    integer(c_int), value, intent(in) :: n_press
    real(c_double), value, intent(in) :: x, y
    real(c_double), save :: x0, y0
    real(c_double) :: x1, y1
    type(c_ptr) :: drawing_area
    integer(c_int) :: id

    print *, "Button ", gtk_gesture_single_get_current_button(gesture)
    print *, n_press, " click(s) at ", int(x), int(y)

    if (n_press > 1) then
      print *, "Double clicks have no effect!"
      return
    end if

    if (computing_flag) then
      print *, "Be patient..."
      return
    end if

    drawing_area = gtk_event_controller_get_widget(gesture)

    if (gtk_gesture_single_get_current_button(gesture) == 3) then
       ! Right button => reset to full set
       need_point=.false.
       call set_limits
       call mandelbrot_set(drawing_area, 1000_c_int)
       id = gtk_statusbar_push(status_bar, 0_c_int, &
            & "Left|Centre mark: region corner, Right: Reset, "//&
            & "Wheel: Zoom in/out"//c_null_char)
    else if (.not. need_point) then
       need_point=.true.
       print *, "First point"
       call mand_xy(int(x, c_int), int(y, c_int), x0, y0)
       id = gtk_statusbar_push(status_bar, 0_c_int, &
            & "Click the opposite corner of the region"//c_null_char)
    else if (need_point) then ! Already have one point
       need_point=.false.
       print *, "Second point"

       call mand_xy(int(x, c_int), int(y, c_int), x1, y1)
       ! If it is not a double-click, we zoom:
       if ((min(x0,x1)/=max(x0,x1)).and.(min(y0,y1)/=max(y0,y1))) then
         mxmin=min(x0,x1)
         mxmax=max(x0,x1)
         mymin=min(y0,y1)
         mymax=max(y0,y1)
       end if

       write(rangestr, &
            & "('Xmin: ',g11.4,' Xmax: ',g11.4,' Range: ',g11.4,' Ymin: '"//&
            & ",g11.4,' Ymax: ', g11.4,' Range: ',g11.4)") &
            & mxmin, mxmax, mxmax-mxmin, mymin, mymax, mymax-mymin
       call gtk_label_set_text(rangeid, trim(rangestr)//c_null_char)

       call mandelbrot_set(drawing_area, 1000_c_int)
       id = gtk_statusbar_push(status_bar, 0_c_int, &
            & "Left|Centre: mark region corner, "//&
            & "Right: Reset, Wheel: Zoom in/out"//c_null_char)
    end if
  end subroutine click_cb

  ! Scroll callback function ("scroll" signal):
  recursive subroutine scroll_cb(controller, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    real(c_double), value, intent(in) :: x, y
    type(c_ptr) :: drawing_area
    ! Mathematical coordinates:
    real(c_double) :: xr, yr, xx, yy
    integer(c_int) :: id

    print *, "Scroll x,y= ", x, y
    ! We need to redraw the area:
    drawing_area = gtk_event_controller_get_widget(controller)

    if (computing_flag) return             ! One wheel step at a time !

    if (y > 0) then ! Zoom out
       call mand_xy(mouse_x, mouse_y, xx, yy)
       xr=min(mxmax-mxmin, 1.5_c_double)
       yr=min(mymax-mymin, 1.5_c_double)
    else ! Zoom in
       call mand_xy(mouse_x, mouse_y, xx, yy)
       xr = (mxmax-mxmin)/4._c_double
       yr = (mymax-mymin)/4._c_double
    end if

    mxmax=xx+xr
    mxmin=xx-xr
    if (mxmax > 1._c_double) then
       mxmax = 1._c_double
       mxmin = mxmax - 2._c_double * xr
    else if (mxmin < -2._c_double) then
       mxmin = -2._c_double
       mxmax = mxmin + 2._c_double * xr
    end if

    mymin = yy-yr
    mymax = yy+yr
    if (mymax > 1.5_c_double) then
       mymax = 1.5_c_double
       mymin = mymax - 2._c_double * yr
    else if (mymin < -1.5_c_double) then
       mymin = -1.5_c_double
       mymax = mymin + 2._c_double * yr
    end if

    write(rangestr, &
         & "('Xmin: ',g11.4,' Xmax: ',g11.4,' Range: ',g11.4,' Ymin: ',"//&
         & "g11.4,' Ymax: ', g11.4,' Range: ',g11.4)") &
         & mxmin, mxmax, mxmax-mxmin, mymin, mymax, mymax-mymin
    call gtk_label_set_text(rangeid, trim(rangestr)//c_null_char)
    print *, "Window:", mxmin,mxmax,mymin, mymax

    call mandelbrot_set(drawing_area, 1000_c_int)

    id = gtk_statusbar_push(status_bar, 0_c_int, &
         & "Left|Centre: mark region corner, "//&
         & "Right: Reset, Wheel: Zoom in/out"//c_null_char)
  end subroutine scroll_cb

  ! Motion callback function ("motion" signal):
  subroutine motion_cb(controller, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    real(c_double), value, intent(in) :: x, y

    print *, "Motion x,y= ", x, y
    mouse_x = nint(x)
    mouse_y = nint(y)
  end subroutine motion_cb

  subroutine set_limits()
    mxmin = -2.0_c_double
    mxmax = 1.0_c_double
    mymin = -1.5_c_double
    mymax = 1.5_c_double
  end subroutine set_limits

  subroutine mand_xy(ix, iy, x, y)
    integer(c_int), intent(in) :: ix, iy
    real(c_double), intent(out) :: x, y
    real(c_double) :: scx, scy

    scx = (mxmax-mxmin)/real(width, c_double)   ! x scale
    scy = (mymax-mymin)/real(height, c_double)  ! y scale

    x = mxmin + scx * real(ix, c_double)
    y = mymin + scy * real(iy, c_double)
  end subroutine mand_xy

  !*********************************************
  ! A tribute to Benoit MANDELBROT (1924-2010)
  ! http://en.wikipedia.org/wiki/Mandelbrot_set
  !*********************************************
  subroutine mandelbrot_set(my_drawing_area, itermax)
    ! Whole set: xmin=-2.0_wp, xmax=+1.0_wp, ymin=-1.5_wp, ymax=+1.5_wp, itermax=1000
    ! Seahorse valley:  around x=-0.743643887037151, y=+0.13182590420533, itermax=5000
    type(c_ptr), intent(in) :: my_drawing_area
    integer(c_int), intent(in) :: itermax
    integer(c_int)    :: i, j, k
    real(c_double)    :: x, y ! coordinates in the complex plane
    complex(c_double) :: c, z
    integer(c_int8_t) :: red, green, blue     ! rgb color
    real(c_double)    :: t0, t1
    integer :: it

    computing_flag = .true.

    call system_clock(it)
    t0=real(it, c_double)/1000._c_double

    do i=0, width-1
       ! **************************************************************************
       ! Needed if you want to display progressively the result during computation.
       ! We provoke a draw event only once in a while to avoid degrading
       ! the performances:
       ! **************************************************************************
       if (mod(i, 10_c_int) == 0) then
         call gtk_widget_queue_draw(my_drawing_area)
       end if

       do j=0, height-1
          call mand_xy(i, j, x, y)
          c = cmplx(x, y, kind=c_double)          ! Starting point
          z = (0.0_c_double, 0.0_c_double)        ! z0
          k = 1
          do while ((k <= itermax) .and. ((z%re**2 + z%im**2)<4.0_c_double))
             z = z*z+c
             k = k+1
          end do

          if (k>itermax) then
             ! Black pixel:
             red   = 0
             green = 0
             blue  = 0
          else
             red   = int(min(255, k*2),  KIND=c_int8_t)
             green = int(min(255, k*5),  KIND=c_int8_t)
             blue  = int(min(255, k*10), KIND=c_int8_t)
          end if

          ! We write in the pixbuffer:
          pixel(1,i+1,j+1)=char(red)
          pixel(2,i+1,j+1)=char(green)
          pixel(3,i+1,j+1)=char(blue)
          pixel(4,i+1,j+1)=char(255)  ! Opacity (alpha channel)

       end do
       ! **************************************************************************
       ! You need to manage the GTK events during computation:
       ! **************************************************************************
       call pending_events()
       if (run_status == FALSE) return ! Exit if we had a delete event.
    end do

    call gtk_widget_queue_draw(my_drawing_area)

    call system_clock(it)
    t1=real(it, c_double)/1000._c_double
    print *, "System time = ", t1-t0

    computing_flag = .false.
    need_point     = .false.
  end subroutine mandelbrot_set

  ! The GUI is defined here:
  subroutine activate(app, gdata) bind(c)
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    type(c_ptr) :: my_window, jb
    type(c_ptr) :: my_drawing_area, controller, controller2, controller3
    integer :: i, j
    integer(c_int) :: id

    my_window = gtk_application_window_new(app)

    ! Properties of the main window :
    width = 700
    height = 700
    call gtk_window_set_default_size(my_window, width, height)
    call gtk_window_set_title(my_window, &
         & "A tribute to Benoit MANDELBROT (1924-2010)"//c_null_char)

    jb = gtk_box_new(GTK_ORIENTATION_VERTICAL, 0_c_int)
    call gtk_window_set_child(my_window, jb)

    my_drawing_area = gtk_drawing_area_new()
    call gtk_widget_set_size_request(my_drawing_area, &
         & width, height)

    call gtk_drawing_area_set_draw_func(my_drawing_area, &
                     & c_funloc(draw), c_null_ptr, c_null_funptr)

    ! We need a gesture controller to detect mouse clicks:
    ! https://developer.gnome.org/gtk4/stable/GtkGestureClick.html
    ! https://developer.gnome.org/gtk4/stable/GtkWidget.html#gtk-widget-add-controller
    controller = gtk_gesture_click_new()
    ! 0 to listen to all buttons (button 1 by default):
    call gtk_gesture_single_set_button (controller, 0_c_int)
    call g_signal_connect(controller, "pressed"//c_null_char, &
                                        & c_funloc(click_cb))
    call gtk_widget_add_controller(my_drawing_area, controller)

    ! And a controller for scrolling:
    ! https://developer.gnome.org/gtk4/stable/GtkEventControllerScroll.html
    controller2 = gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL)
    call g_signal_connect(controller2, "scroll"//c_null_char, &
                                        & c_funloc(scroll_cb))
    call gtk_widget_add_controller(my_drawing_area, controller2)
    ! And a controller to detect motion and know where is the mouse:
    ! https://developer.gnome.org/gtk4/stable/GtkEventControllerMotion.html
    controller3 = gtk_event_controller_motion_new ()
    call g_signal_connect(controller3, "motion"//c_null_char, &
                                        & c_funloc(motion_cb))
    call gtk_widget_add_controller(my_drawing_area, controller3)
    mouse_x = 0
    mouse_y = 0

    call gtk_box_append(jb, my_drawing_area)

    ! Set the initial view
    call set_limits()
    write(rangestr, &
         & "('Xmin: ',g11.4,' Xmax: ',g11.4,' Range: ',g11.4,' Ymin: ',g11.4,' Ymax: ', g11.4,' Range: ',g11.4)") &
         & mxmin,  mxmax, mxmax-mxmin, mymin, mymax, mymax-mymin
    rangeid = gtk_label_new(trim(rangestr)//c_null_char)
    call gtk_box_append(jb, rangeid)

    status_bar = gtk_statusbar_new()
    call gtk_box_append(jb, status_bar)
    id = gtk_statusbar_push(status_bar, 0_c_int, &
         & "Left|Centre: mark region corner, "//&
         & "Right: Reset, Wheel: Zoom in/out"//c_null_char)

    call gtk_widget_show(my_window)

    ! We create a pixbuffer to store the pixels of the image:
    my_pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE, 8_c_int, width, height)
    nch = gdk_pixbuf_get_n_channels(my_pixbuf)
    call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf), pixel, &
         &int([nch, width, height]))
    rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)

    ! We use char() because we need unsigned integers.
    ! Our pixbuffer has an Alpha channel but is possible to create a pixbuffer
    ! with only Red, Green, Blue.
    do i=1, height
       do j=1, width
          pixel(1,j,i)=char(0)     ! Red
          pixel(2,j,i)=char(0)     ! Green
          pixel(3,j,i)=char(0)     ! Blue
          pixel(4,j,i)=char(255)   ! Opacity (Alpha channel)
       end do
    end do

    call Mandelbrot_set(my_drawing_area, 1000_c_int)

  end subroutine activate
end module handlers

! We create a GtkApplication:
program mandelbrot_pixbuf_zoom
  use, intrinsic :: iso_c_binding, only: c_int, c_ptr, c_funloc, c_null_char, c_null_ptr
  use gtk, only: gtk_application_new, g_signal_connect, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers, only: activate

  implicit none
  integer(c_int) :: exit_status
  type(c_ptr)    :: app

  app = gtk_application_new("gtk-fortran.examples.mandelbrot-pixbuf-zoom"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  exit_status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program mandelbrot_pixbuf_zoom

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! GTK 4 version: vmagnin 2020-06-08, 2020-07-15
! https://developer.gnome.org/gtk4/stable/GtkDialog.html
!------------------------------------------------------------------------------

module handlers
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_dialog
  use gtk, only: gtk_button_new, gtk_window_set_child, &
       & gtk_widget_show, gtk_window_destroy

  implicit none
  type(c_ptr) :: win, box, label

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Exit called"
    call gtk_window_destroy(win)
  end subroutine my_destroy

  subroutine msg_alert(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int) :: resp
    character(len=40), dimension(5) :: msg

    msg(1) = "ALERT"
    msg(2) = ""
    msg(3) = "You have pressed an alert button"
    msg(4) = ""
    msg(5) = "You know that's dangerous"

    resp = hl_gtk_message_dialog_show(msg, GTK_BUTTONS_OK, &
         & "ALERT"//c_null_char, &
         & type=GTK_MESSAGE_WARNING, parent=win)
    print *, "hl_dialog.f90 resp=", resp
  end subroutine msg_alert

  subroutine msg_quit(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int) :: resp
    character(len=40), dimension(3) :: msg

    msg(1) ="QUIT?"
    msg(2) = ""
    msg(3) = "Do you really want to quit?"

    resp = hl_gtk_message_dialog_show(msg, GTK_BUTTONS_YES_NO, &
         & "QUIT"//c_null_char, parent=win)
    if (resp == GTK_RESPONSE_YES) call gtk_window_destroy(win)
  end subroutine msg_quit

  subroutine msg_about(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call hl_gtk_about_dialog_gtk_fortran(win)
  end subroutine msg_about


  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    type(c_ptr) :: but

    ! Make a window & put a horizontal box in it
    win = gtk_application_window_new(app)
    call gtk_window_set_title(win, "Dialog demo"//c_null_char)

    box = hl_gtk_box_new(horizontal=TRUE, spacing=10_c_int)
    call gtk_window_set_child(win, box)

    ! 3 Buttons one shows a message, the next an about dialog and the
    ! last a confirm exit dialog
    but = hl_gtk_button_new('Alert'//c_null_char, clicked=c_funloc(msg_alert))
    call hl_gtk_box_pack(box, but)

    but = hl_gtk_button_new("About"//c_null_char, clicked=c_funloc(msg_about))
    call hl_gtk_box_pack(box, but)

    but = hl_gtk_button_new('Quit'//c_null_char, clicked=c_funloc(msg_quit))
    call hl_gtk_box_pack(box, but)

    ! Display the window
    call gtk_widget_show(win)
    end subroutine activate
end module handlers


program dialog_demo
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_dialog"//c_null_char, &
                             & c_funloc(activate))
end program dialog_demo

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------
! Contributed by: James Tappin, last modification: 2012-02-08
! vmagnin, 2022-04-15, 2023-03-10
!-------------------------------------------------------------------------------

module plplot_extra
  implicit none

  ! Interface for the PLplot pl_cmd() routine, not available
  ! in the Fortran binding, but in the plplot.h header file:
  interface
    ! Front-end to driver escape function. In principle this can be used
    ! to pass just about anything directly to the driver:
    subroutine pl_cmd(cmd, arg) bind(c)
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      implicit none
      ! A PLESC command to pass to the driver:
      integer(c_int), value :: cmd
      ! Data associated with the cmd command:
      type(c_ptr), value :: arg
    end subroutine pl_cmd
  end interface
end module plplot_extra

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! Last modifications: vmagnin 2020-06-17 (GTK 4), 2022-04-05
!------------------------------------------------------------------------------

module cl_handlers
  !********************************
  ! Gtk modules for hl_cairo_clock.f90
  !********************************
  use cairo, only: cairo_arc, cairo_fill, cairo_fill_preserve, cairo_line_to, &
       & cairo_move_to, cairo_new_path, cairo_paint, cairo_rectangle, &
       & cairo_select_font_face, cairo_set_font_size, cairo_set_line_cap, &
       & cairo_set_line_width, cairo_set_source_rgb, cairo_set_source_rgba, &
       & cairo_show_text, cairo_stroke
  use g, only: g_timeout_add
  use gdk, only: gdk_keyval_from_name
  use gtk, only: gtk_window_set_child, gtk_window_destroy, &
       & gtk_widget_get_allocation, gtk_widget_queue_draw, &
       & gtk_widget_show, TRUE, FALSE, GDK_CONTROL_MASK, &
       & CAIRO_LINE_CAP_ROUND, CAIRO_FONT_SLANT_NORMAL, &
       & CAIRO_FONT_WEIGHT_BOLD
  use gdk_pixbuf_hl
  use gtk_draw_hl
  use gtk_hl_container
  use gdk_events
  use, intrinsic :: iso_c_binding

  implicit none
  integer(c_int) :: height=250_c_int, width=250_c_int
  real(c_double), parameter :: pi = acos(-1.0_c_double)
  integer, dimension(8) :: t0 = 0
  type(c_ptr) :: window
  type(c_ptr) :: app

contains

  function show_time(area) bind(c)
    integer(c_int) :: show_time
    type(c_ptr), value, intent(in) :: area

    integer, dimension(8) :: dat
    type(c_ptr) :: cr
    character(len=3) :: sdate

    character(len=4), parameter, dimension(12) :: mnames = &
         & ['JAN'//c_null_char, 'FEB'//c_null_char, 'MAR'//c_null_char, &
         &   'APR'//c_null_char, 'MAY'//c_null_char, 'JUN'//c_null_char, &
         &   'JUL'//c_null_char, 'AUG'//c_null_char, 'SEP'//c_null_char, &
         &   'OCT'//c_null_char, 'NOV'//c_null_char, 'DEC'//c_null_char ]
    integer :: i
    real(c_double) :: r0, r1, x0, x1, y0, y1, th, xc, yc, ycs
    real(c_double) :: xb, xt, yb, yt, radius, scale_factor

    show_time = TRUE

    call date_and_time(values=dat)
    if (all(dat(5:7) == t0(5:7))) return

    t0 = dat

    cr = hl_gtk_drawing_area_cairo_new(area)

    xc = real(width, c_double) / 2._c_double
    yc = real(height, c_double) / 2._c_double
    radius = min(xc, yc)
    scale_factor = radius/125._c_double

    if (height > width) then
       xb = 0._c_double
       xt = real(width, c_double)
       yt = yc - xc
       yb = yc + xc
    else if (height < width) then
       xb = xc - yc
       xt = xc + yc
       yt = 0._c_double
       yb = real(height, c_double)
    else
       xb = 0._c_double
       xt = real(width, c_double)
       yt = 0._c_double
       yb = real(height, c_double)
    end if

    ! Background
    call cairo_set_source_rgb(cr, 0.3_c_double, 0.0_c_double, &
         & 0.0_c_double)
    call cairo_rectangle(cr, 0._c_double, 0._c_double,&
         & real(width, c_double), real(height, c_double))
    call cairo_paint(cr)

    ! Face
    r0 = radius * 0.85_c_double
    call cairo_set_source_rgb(cr, 0.3_c_double, 0.3_c_double, 0._c_double)
    call cairo_new_path(cr)
    call cairo_move_to(cr, xc+r0, yc)
    call cairo_arc(cr, xc, yc, r0, 0._c_double, 2.*pi)
    call cairo_fill(cr)

    ! Sub face
    r0 =  radius * 0.25_c_double
    call cairo_set_source_rgb(cr, 0.2_c_double, 0.7_c_double, 0.7_c_double)
    ycs = yc + 0.375_c_double*radius
    call cairo_new_path(cr)
    call cairo_move_to(cr, xc+r0, ycs)
    call cairo_arc(cr, xc, ycs, r0, 0._c_double, 2.*pi)
    call cairo_fill(cr)

    ! Clock dials
    ! Main
    call cairo_set_source_rgb(cr, 1._c_double, 1._c_double, &
         & 1._c_double)
    call cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND)
    do i = 1, 60
       if (mod(i,15) == 0) then
          call cairo_set_line_width(cr, 5._c_double)
          r0 = radius * 0.75_c_double
          r1 = radius * 0.9_c_double
       else if (mod(i,5) == 0) then
          call cairo_set_line_width(cr, 4._c_double)
          r0 = radius * 0.8_c_double
          r1 = radius * 0.9_c_double
       else
          call cairo_set_line_width(cr, 2._c_double)
          r0 = radius * 0.8_c_double
          r1 = radius * 0.85_c_double
       end if
       th = real(i,c_double)*pi/30._c_double

       x0 = sin(th)*r0+xc
       x1 = sin(th)*r1+xc
       y0 = cos(th)*r0+yc
       y1 = cos(th)*r1+yc

       call cairo_move_to(cr, x0, y0)
       call cairo_line_to(cr, x1, y1)
       call cairo_stroke(cr)
    end do

    ! Seconds
    do i = 1, 60
       if (mod(i,15) == 0) then
          call cairo_set_line_width(cr, 2._c_double)
          r0 = radius * 0.2_c_double
          r1 = radius * 0.275_c_double
       else if (mod(i,5) == 0) then
          call cairo_set_line_width(cr, 1._c_double)
          r0 = radius * 0.225_c_double
          r1 = radius * 0.275_c_double
       else
          call cairo_set_line_width(cr, 1._c_double)
          r0 = radius * 0.225_c_double
          r1 = radius * 0.25_c_double
       end if
       th = real(i,c_double)*pi/30._c_double

       x0 = sin(th)*r0+xc
       x1 = sin(th)*r1+xc
       y0 = cos(th)*r0+ycs
       y1 = cos(th)*r1+ycs

       call cairo_move_to(cr, x0, y0)
       call cairo_line_to(cr, x1, y1)
       call cairo_stroke(cr)
    end do

    !  Date
    if (dat(5) >= 12) then
       call cairo_set_source_rgb(cr, 0._c_double, 0._c_double, 0._c_double)
    else
       call cairo_set_source_rgb(cr, 1._c_double, 1._c_double, 1._c_double)
    end if
    call cairo_select_font_face(cr, "sans-serif"//c_null_char, &
         & CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD)
    x0 = xc - 0.6_c_double*radius
    call cairo_set_line_width(cr, 1._c_double)
    call cairo_rectangle(cr, x0-2.*scale_factor, yc+10.*scale_factor, &
         & 42._c_double*scale_factor,-16._c_double*scale_factor)
    call cairo_fill_preserve(cr)
    if (dat(5) < 12) then
       call cairo_set_source_rgb(cr, 0._c_double, 0._c_double, 0._c_double)
    else
       call cairo_set_source_rgb(cr, 1._c_double, 1._c_double, 1._c_double)
    end if
    call cairo_stroke(cr)
    call cairo_set_font_size (cr, 12._c_double*scale_factor)
    write(sdate,"(I2.2,a1)") dat(3), char(0)
    call cairo_move_to(cr, x0,yc+6.*scale_factor)
    call cairo_show_text(cr, sdate)
    call cairo_set_font_size (cr, 9._c_double*scale_factor)
    call cairo_show_text(cr, ' '//mnames(dat(2)))

    ! Second hand
    ! Trail
    th = real(dat(7),c_double) * pi / 30._c_double - pi/2._c_double
    r0 = radius * 0.24_c_double
    do i = 1, 15
       call cairo_set_source_rgba(cr, 1._c_double, 0.1_c_double, &
            & 1._c_double, 1._c_double-real(i,c_double)/15._c_double)
       call cairo_new_path(cr)
       call cairo_move_to(cr, xc, ycs)
       call cairo_arc(cr, xc, ycs, r0, th-pi/30._c_double, th)
       call cairo_fill(cr)
       th = th-pi/30._c_double
    end do

    ! Hand
    call cairo_set_source_rgb(cr, .6_c_double, 0.1_c_double, &
         & .6_c_double)
    call cairo_set_line_width(cr, 2._c_double)

    th = real(dat(7),c_double) * pi / 30._c_double
    x1 = r0*sin(th) + xc
    x0 = xc
    y1 = -r0*cos(th) + ycs
    y0 = ycs

    call cairo_move_to(cr, x0, y0)
    call cairo_line_to(cr, x1, y1)
    call cairo_stroke(cr)

    ! Hour hand
    call cairo_set_source_rgb(cr, 0.1_c_double, 0.8_c_double, &
         & 1._c_double)
    call cairo_set_line_width(cr, 8._c_double)
    r0 = radius * 0.6_c_double
    th = (real(mod(dat(5),12),c_double) + &
         & real(dat(6),c_double)/60._c_double + &
         & real(dat(7), c_double)/3600._c_double) * pi / 6._c_double
    x1 = r0*sin(th) + xc
    x0 = -r0*sin(th)/10._c_double + xc
    y1 = -r0*cos(th) + yc
    y0 = r0*cos(th)/10._c_double + yc

    call cairo_move_to(cr, x0, y0)
    call cairo_line_to(cr, x1, y1)
    call cairo_stroke(cr)

    ! Minute hand
    call cairo_set_source_rgba(cr, 1.0_c_double, 1._c_double, &
         & 0.1_c_double, 0.9_c_double)
    call cairo_set_line_width(cr, 3._c_double)
    r0 = min(xc,yc) * 0.85_c_double

    th = (real(dat(6),c_double) + &
         & real(dat(7),c_double)/60._c_double) * pi / 30._c_double
    x1 = r0*sin(th) + xc
    x0 = -r0*sin(th)/10._c_double + xc
    y1 = -r0*cos(th) + yc
    y0 = r0*cos(th)/10._c_double + yc

    call cairo_move_to(cr, x0, y0)
    call cairo_line_to(cr, x1, y1)
    call cairo_stroke(cr)

    call hl_gtk_drawing_area_cairo_destroy(cr)
    call gtk_widget_queue_draw(area)
  end function show_time


  subroutine clock_resize(area, data) bind(c)
    type(c_ptr), value :: area, data

    type(gtkallocation), target:: alloc
    integer(c_int) :: irv

    call gtk_widget_get_allocation(area,c_loc(alloc))
    width = alloc%width
    height = alloc%height

    call hl_gtk_drawing_area_resize(area)

    t0(:) = 0
    irv = show_time(area)
  end subroutine clock_resize


  ! GTK 4 : key callback function ("key-pressed" signal):
  ! https://developer.gnome.org/gdk4/stable/gdk4-Keyboard-Handling.html
  function clock_key(controller, keyval, keycode, state, gdata) result(ret) bind(c)
    type(c_ptr), value, intent(in) :: controller, gdata
    integer(c_int), value, intent(in) :: keyval, keycode, state
    logical(c_bool) :: ret
    integer(c_int) :: key_q

    key_q = gdk_keyval_from_name("q"//c_null_char)
    ! CTRL+Q will close the program:
    if ((iand(state, GDK_CONTROL_MASK) /= 0).and.(keyval == key_q)) then
      call gtk_window_destroy(window)
    end if

    ret = .true.
  end function clock_key

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: drawing
    integer(c_int) :: icont, timeid

    ! Create the window:
    window = gtk_application_window_new(app)
    call gtk_window_set_title(window, "Cairo Clock (CTRL+Q to quit)"//c_null_char)

    drawing = hl_gtk_drawing_area_new(has_alpha = TRUE, &
         & size_allocate=c_funloc(clock_resize), &
         & key_press_event=c_funloc(clock_key))

    call gtk_window_set_child(window, drawing)
    call gtk_widget_show(window)

    icont =  show_time(drawing)

    timeid = g_timeout_add(300_c_int, c_funloc(show_time), drawing)
  end subroutine activate
end module cl_handlers


program cairo_clock
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
  use cl_handlers
  implicit none

  app = hl_gtk_application_new("gtk-fortran.examples.hl_cairo_clock"//c_null_char, &
                             & c_funloc(activate))
end program cairo_clock

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin
! Last modification: 2011-11-21, vmagnin 2020-06-25
!------------------------------------------------------------------------------

!*
! Progress Bar
module gtk_hl_progress
  ! Implements the GtkProgressBar widget. Includes the facility to
  ! make a bar display "n of m" as well as the usual fraction.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding
  ! Autogenerated use's
  use gtk, only: gtk_orientable_set_orientation, gtk_progress_bar_new, &
       & gtk_progress_bar_pulse, gtk_progress_bar_set_fraction,&
       & gtk_progress_bar_set_pulse_step,&
       & gtk_progress_bar_set_text, &
       & gtk_progress_bar_set_show_text, &
       & gtk_progress_bar_set_inverted, &
       & GTK_ORIENTATION_VERTICAL,  GTK_ORIENTATION_HORIZONTAL, &
       & TRUE, FALSE

  implicit none

  ! A progress bar value can be given as a fraction or m of n
  interface hl_gtk_progress_bar_set
     module procedure  hl_gtk_progress_bar_set_f
     module procedure  hl_gtk_progress_bar_set_ii
  end interface hl_gtk_progress_bar_set

contains

  !+
  function hl_gtk_progress_bar_new(vertical, reversed, step) result(bar)

    type(c_ptr) :: bar
    integer(c_int), optional :: vertical, reversed
    real(c_double), optional :: step

    ! Intializer for a progress bar
    !
    ! VERTICAL |  boolean |  optional |  The orientation of the bar.
    ! REVERSED |  boolean |  optional |  Whether the direction of the bar should be reversed.
    ! STEP |  double |  optional |  The fractional step to advance when pulsing the bar
    !-

    bar = gtk_progress_bar_new()

    if (present(vertical)) then
       if (vertical == TRUE) then
          call gtk_orientable_set_orientation (bar, &
               & GTK_ORIENTATION_VERTICAL)
       else
          call gtk_orientable_set_orientation (bar, &
               & GTK_ORIENTATION_HORIZONTAL)
       end if
    end if

    if (present(reversed)) call gtk_progress_bar_set_inverted(bar, reversed)

    if (present(step)) &
         & call gtk_progress_bar_set_pulse_step(bar, step)

  end function hl_gtk_progress_bar_new

  !+
  subroutine hl_gtk_progress_bar_set_f(bar, val, string, text)

    type(c_ptr) :: bar
    real(c_double), optional :: val
    integer(c_int), optional :: string
    character(len=*), intent(in), optional:: text

    ! Set the value of a progress bar (fraction or pulse)
    !
    ! BAR |  c_ptr |  required |  The bar to set
    ! VAL |  double |  optional |  The value to set. If absent, the bar is pulsed
    ! STRING |  boolean |  optional |  Whether to put a string on the bar.
    ! TEXT |  string |  optional |  Text to put in the bar, (overrides STRING)
    !
    ! This routine is normally accessed via the generic interface
    ! hl_gtk_progress_bar_set
    !-

    character(len=50) :: sval

    ! If no value given pulse the bar
    if (.not. present(val)) then
       call gtk_progress_bar_pulse(bar)
    else
       ! Determine the fraction to fill & fill it
       call gtk_progress_bar_set_fraction(bar, val)
    end if

    ! If annotation is needed, add it.
    if (present(text)) then
       call gtk_progress_bar_set_text (bar, text//c_null_char)
       call gtk_progress_bar_set_show_text(bar, TRUE)
    else if (present(string)) then
       if (string == FALSE .or. .not. present(val)) return
       ! Otherwise we display a percentage
       write(sval, "(F5.1,'%')") val*100.

       call gtk_progress_bar_set_text (bar, trim(sval)//c_null_char)
       call gtk_progress_bar_set_show_text(bar, TRUE)
    else
       call gtk_progress_bar_set_show_text(bar, FALSE)
    end if
  end subroutine hl_gtk_progress_bar_set_f

  !+
  subroutine hl_gtk_progress_bar_set_ii(bar, val, maxv, string, text)

    type(c_ptr) :: bar
    integer(c_int) :: val, maxv
    integer(c_int), optional :: string
    character(len=*), intent(in), optional:: text

    ! Set the value of a progress bar (n of m)
    !
    ! BAR |  c_ptr |  required |  The bar to set
    ! VAL |  int |  required |  The value to set.
    ! MAXV |  int |  required |  The maximum value for the bar
    ! STRING |  boolean |  optional |  Whether to put a string on the bar.
    ! TEXT |  string |  optional |  Text to put in the bar, (overrides STRING)
    !
    ! This routine is normally accessed via the generic interface
    ! hl_gtk_progress_bar_set
    !-

    real(c_double) :: frac
    character(len=50) :: sval

    frac = real(val,c_double)/real(maxv,c_double)
    call gtk_progress_bar_set_fraction(bar, frac)

    ! If annotation is needed, add it.
    if (present(text)) then
       call gtk_progress_bar_set_text (bar, text//c_null_char)
       call gtk_progress_bar_set_show_text(bar, TRUE)
    else if (present(string)) then
       if (string == FALSE) return
       ! Otherwise we display n or m
       write(sval, "(I0,' of ',I0)") val, maxv
       call gtk_progress_bar_set_text (bar, trim(sval)//c_null_char)
       call gtk_progress_bar_set_show_text(bar, TRUE)
    else
       call gtk_progress_bar_set_show_text(bar, FALSE)
    end if
  end subroutine hl_gtk_progress_bar_set_ii
end module gtk_hl_progress

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin
! Last modifications: 2012-01-07, vmagnin 2020-06-05 (GTK 4 version)
!                     2020-08-25
!------------------------------------------------------------------------------
!*
! Assistant
module gtk_hl_assistant
  ! High-level interface to the GtkAssistant widget
  !/

  use, intrinsic :: iso_c_binding

  ! Autogenerated use's

  !********************************
  ! Gtk modules for gtk-hl-assistant.f90
  use gtk, only: gtk_assistant_append_page, gtk_assistant_get_current_page, &
       & gtk_assistant_get_nth_page, gtk_assistant_insert_page, &
       & gtk_assistant_new, gtk_assistant_set_forward_page_func, &
       & gtk_assistant_set_page_complete, gtk_assistant_set_page_title, &
       & gtk_assistant_set_page_type, &
       & gtk_window_destroy, gtk_window_set_default_size, &
       & gtk_window_set_icon_name, &
       & gtk_window_set_title, gtk_window_set_transient_for, g_signal_connect, &
       & TRUE, FALSE, GTK_ASSISTANT_PAGE_INTRO, GTK_ASSISTANT_PAGE_CONFIRM, &
       & GTK_ASSISTANT_PAGE_SUMMARY, &
       & gtk_widget_set_margin_start, gtk_widget_set_margin_end, &
       & gtk_widget_set_margin_top, gtk_widget_set_margin_bottom

  implicit none

contains
  !+
  function hl_gtk_assistant_new(title, destroy, delete_event, data_destroy, &
       & data_delete_event, close, data_close, cancel, data_cancel, &
       & border, wsize, parent, icon, icon_file, &
       & icon_name, forward, data_forward) result(asstnt)

    type(c_ptr) :: asstnt
    character(kind=c_char), dimension(*), intent(in), optional :: title
    type(c_funptr), optional :: destroy, delete_event, close, cancel
    type(c_ptr), optional :: data_destroy, data_delete_event, data_close, &
         & data_cancel
    integer(c_int), optional, intent(in) :: border
    integer(c_int), optional, intent(in), dimension(2) :: wsize
    type(c_ptr), optional :: parent
    type(c_ptr), intent(in), optional :: icon
    character(kind=c_char), dimension(*), intent(in), optional :: icon_name, &
         & icon_file
    type(c_funptr), optional :: forward
    type(c_ptr), optional, intent(in) :: data_forward

    ! Higher level interface to make a GtkAssistant
    !
    ! TITLE |  String |  optional |  Title for the window
    ! DESTROY |  c_funptr |  optional |  Callback for the "destroy" signal
    ! DELETE_EVENT |  c_funptr |  optional |  Callback for the "delete-event" signal
    ! CLOSE |  c_funptr |  optional |  Callback for when the assistant is completed
    ! CANCEL |  c_funptr |  optional |  Callback for the Cancel operation.
    ! DATA_DESTROY |  c_ptr |  optional |  Data to be passed to the destroy signal handler
    ! DATA_DELETE_EVENT |  c_ptr |  optional |  Data to be passed to the delete_event signal handler
    ! DATA_CLOSE |  c_ptr |  optional |  Data to be passed to the close signal
    ! DATA_CANCEL |  c_ptr |  optional |  Data to be passed to the cancel signal.
    ! BORDER |  integer |  optional |  Size of the window border
    ! WSIZE |  integer(2) |  optional |  Size of the window
    ! PARENT |  c_ptr |  optional |  An optional parent window for the new window.
    ! ICON |  c_ptr |  optional  |  A GdkPixbuf containing the icon for the window.
    ! ICON_FILE |  String  |  optional  |  A file from which to read the icon for the window.
    ! ICON_NAME |  String  |  optional  |  The name of a standard icon to use for the window.
    ! FORWARD |  c_funptr |  optional |  A function to handle paging.
    ! DATA_FORWARD |  c_ptr |  optional |  Data for the paging function.
    !
    ! At most one way of setting the icon should be given, if more than one
    ! is specified the priority is ICON, ICON_FILE, ICON_NAME.
    !
    ! If the CLOSE and/or CANCEL keys are not given then the DESTROY handler is
    ! used if available, otherwise a default that just destroys the widget.
    !-

    asstnt = gtk_assistant_new()

    if (present(title)) call gtk_window_set_title(asstnt, title)

    if (present(border)) then
      call gtk_widget_set_margin_start (asstnt, border)
      call gtk_widget_set_margin_end (asstnt, border)
      call gtk_widget_set_margin_top (asstnt, border)
      call gtk_widget_set_margin_bottom (asstnt, border)
    end if

    if (present(wsize)) &
         & call gtk_window_set_default_size(asstnt, wsize(1), wsize(2))

    if (present(delete_event)) then
       if (present(data_delete_event)) then
          call g_signal_connect(asstnt, "delete-event"//C_NULL_CHAR, &
               & delete_event, data_delete_event)
       else
          call g_signal_connect(asstnt, "delete-event"//C_NULL_CHAR, &
               & delete_event)
       end if
    end if

    if (present(destroy)) then
       if (present(data_destroy)) then
          call g_signal_connect(asstnt, "destroy"//C_NULL_CHAR, destroy, &
               & data_destroy)
       else
          call g_signal_connect(asstnt, "destroy"//C_NULL_CHAR, destroy)
       end if
    end if

    if (present(cancel)) then
       if (present(data_cancel)) then
          call g_signal_connect(asstnt, "cancel"//c_null_char, &
               & cancel, data_cancel)
       else
          call g_signal_connect(asstnt, "cancel"//c_null_char, &
               & cancel)
       end if
    else if (present(destroy)) then
       if (present(data_destroy)) then
          call g_signal_connect(asstnt, "cancel"//C_NULL_CHAR, destroy, &
               & data_destroy)
       else
          call g_signal_connect(asstnt, "cancel"//C_NULL_CHAR, destroy)
       end if
    else
       call g_signal_connect(asstnt, "cancel"//C_NULL_CHAR, &
            & c_funloc(hl_gtk_assistant_destroy))
    end if

    if (present(close)) then
       if (present(data_close)) then
          call g_signal_connect(asstnt, "close"//c_null_char, &
               & close, data_close)
       else
          call g_signal_connect(asstnt, "close"//c_null_char, &
               & close)
       end if
    else if (present(destroy)) then
       if (present(data_destroy)) then
          call g_signal_connect(asstnt, "close"//C_NULL_CHAR, destroy, &
               & data_destroy)
       else
          call g_signal_connect(asstnt, "close"//C_NULL_CHAR, destroy)
       end if
    else
       call g_signal_connect(asstnt, "close"//C_NULL_CHAR, &
            & c_funloc(hl_gtk_assistant_destroy))
    end if

    if (present(parent)) call gtk_window_set_transient_for(asstnt, parent)

    if (present(icon)) then
       print *, "Removed from GTK 4: call gtk_window_set_icon(asstnt, icon)"
    else if (present(icon_file)) then
       print *, "Removed from GTK 4: icon_ok = gtk_window_set_icon_from_file (asstnt, icon_file, c_null_ptr)"
    else if (present(icon_name)) then
       call gtk_window_set_icon_name(asstnt, icon_name)
    end if

    if (present(forward)) then
       if (present(data_forward)) then
          call gtk_assistant_set_forward_page_func(asstnt, forward, &
               & data_forward, c_null_funptr)
       else
          call gtk_assistant_set_forward_page_func(asstnt, forward, &
               & c_null_ptr, c_null_funptr)
       end if
    end if

  end function hl_gtk_assistant_new

  !+
  subroutine hl_gtk_assistant_add_page(asstnt, page, type, page_title, &
       & complete, position)

    type(c_ptr), intent(in) :: asstnt, page
    integer(c_int), intent(in) :: type
    character(kind=c_char), dimension(*), intent(in), optional :: page_title
    integer(c_int), intent(in), optional :: complete
    integer(c_int), intent(in), optional :: position

    ! Add a page to a GtkAssistant
    !
    ! ASSTNT |  c_ptr |  required |  The Assistant to which to add the page.
    ! PAGE |  c_ptr |  required |  The widget to add to the assistant.
    ! TYPE |  c_int |  required |  The type of page (from the GtkAssistantPageType enumeration).
    ! PAGE_TITLE |  string |  optional |  A title for the page.
    ! COMPLETE |  boolean |  optional |  Can the use advance? (Default FALSE, unless type is GTK_ASSISTANT_PAGE_INTRO, GTK_ASSISTANT_PAGE_CONFIRM, or GTK_ASSISTANT_PAGE_SUMMARY).
    ! POSITION |  c_int |  optional |  The position of the page in the sequence (Append the page if omitted).
    !
    ! N.B. Supplying handlers for actions within the page is the responsibility
    ! of the code creating the page. In particular, a page that is initially
    ! flagged as incomplete must have an action that sets the complete flag.
    !-

    integer(c_int) :: idx

    if (present(position)) then
       idx = gtk_assistant_insert_page(asstnt, page, position)
    else
       idx = gtk_assistant_append_page(asstnt, page)
    end if

    call gtk_assistant_set_page_type(asstnt, page, type)

    if (present(page_title)) &
         & call gtk_assistant_set_page_title(asstnt, page, page_title)

    if (present(complete)) then
       call gtk_assistant_set_page_complete(asstnt, page, complete)
    else if (type == GTK_ASSISTANT_PAGE_INTRO .or.&
         & type == GTK_ASSISTANT_PAGE_SUMMARY .or.&
         & type == GTK_ASSISTANT_PAGE_CONFIRM) then
       call gtk_assistant_set_page_complete(asstnt, page, TRUE)
    else
       call gtk_assistant_set_page_complete(asstnt, page, FALSE)
    end if

  end subroutine hl_gtk_assistant_add_page

  !+
  function hl_gtk_assistant_get_current_page(asstnt, pageno) result(page)
    type(c_ptr) :: page
    type(c_ptr), intent(in) :: asstnt
    integer(c_int), intent(out), optional :: pageno

    ! Return the current page of an assistant.
    !
    ! ASSTNT |  c_ptr |  required |  The assistant to query
    !
    ! The returns the widget of the current page. To get the page
    ! number only just use gtk_assistant_get_current_page,
    !-

    integer(c_int) :: ipage

    ipage =  gtk_assistant_get_current_page(asstnt)
    page = gtk_assistant_get_nth_page(asstnt, ipage)

    if (present(pageno)) pageno = ipage

  end function hl_gtk_assistant_get_current_page

  !+
  subroutine hl_gtk_assistant_set_page_complete(asstnt, state, &
       & page, pageno)

    type(c_ptr), intent(in) :: asstnt
    integer(c_int), intent(in) :: state
    type(c_ptr), intent(in), optional :: page
    integer(c_int), intent(in), optional :: pageno

    ! Set the completion state of a page of an assistant
    !
    ! ASSTNT |  c_ptr |  required |  The assistant with the page.
    ! STATE |  boolean |  required |  The completion state.
    ! PAGE |  c_ptr |  optional |  The page whose state is to be set.
    ! PAGENO |  c_int |  optional |  The page number to set.
    !
    ! If neither PAGE nor PAGENO is given then the current page is used.
    !-

    type(c_ptr) :: cpage

    if (present(page)) then
       cpage = page
    else if (present(pageno)) then
       cpage = gtk_assistant_get_nth_page(asstnt, pageno)
    else
       cpage = hl_gtk_assistant_get_current_page(asstnt)
    end if

    call gtk_assistant_set_page_complete (asstnt, cpage, state)

  end subroutine hl_gtk_assistant_set_page_complete

  !+
  subroutine hl_gtk_assistant_destroy(widget, data) bind(c)
    type(c_ptr), value, intent(in) :: widget, data

    call gtk_window_destroy(widget)
  end subroutine hl_gtk_assistant_destroy
end module gtk_hl_assistant

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin,
! originally derived from cairo_basics.f90 by Vincent Magnin & Jerry DeLisle
! Last modifications: vmagnin 2020-06-17 (GTK 4), 2022-04-05
!------------------------------------------------------------------------------

module handlers
  use, intrinsic :: iso_c_binding

  !********************************
  ! Gtk modules for hl_cairo1.f90
  !********************************
  use cairo, only: cairo_arc, cairo_curve_to, cairo_get_target, &
       & cairo_line_to, cairo_move_to, cairo_new_sub_path, cairo_paint, &
       & cairo_rectangle, cairo_select_font_face, cairo_set_font_size, &
       & cairo_set_line_width, cairo_set_source_rgb, cairo_show_text, &
       & cairo_stroke, cairo_surface_write_to_png
  use gdk, only: gdk_device_get_name, gdk_keyval_from_name, gdk_keyval_name
  use gtk, only: gtk_window_set_child, gtk_window_destroy, &
       & gtk_widget_queue_draw, gtk_widget_show, gtk_init, TRUE, FALSE, &
       & GDK_CONTROL_MASK, &
       & CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL, &
       & gtk_event_controller_get_current_event_device, &
       & gtk_gesture_single_get_current_button
  use gdk_events

  use gdk_pixbuf_hl
  use gtk_draw_hl
  use gtk_hl_container
  use gtk_sup

  implicit none
  type(c_ptr) :: my_window
  type(c_ptr) :: my_cairo_context
  integer(c_int) :: boolresult
  logical :: boolevent
  integer(c_int) :: width, height
  logical :: rflag = .false.
  integer(c_int) :: xp0, yp0

contains
  ! User defined event handlers go here

  ! GTK 4: Click callback function ("pressed" signal):
  subroutine button_event_h(gesture, n_press, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: gesture, gdata
    integer(c_int), value, intent(in) :: n_press
    real(c_double), value, intent(in) :: x, y
    type(c_ptr) :: device, dcname
    character(len=80) :: dname

    print *, "Button ", gtk_gesture_single_get_current_button(gesture)
    print *, n_press, " click(s) at ", int(x), int(y)

    if (n_press > 1) then
      print *, "Multiple clicks"
    end if

    device = gtk_event_controller_get_current_event_device(gesture)
    dcname = gdk_device_get_name(device)
    call c_f_string(dcname, dname)
    print *, "Device: ",trim(dname)
  end subroutine button_event_h

  ! GTK 4: Click callback function ("released" signal):
  subroutine button_release_h(gesture, n_press, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: gesture, gdata
    integer(c_int), value, intent(in) :: n_press
    real(c_double), value, intent(in) :: x, y

    print *, "Button released: ", gtk_gesture_single_get_current_button(gesture)
  end subroutine button_release_h

  ! GTK 4: Motion callback function ("motion" signal):
  subroutine motion_event_h(controller, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    real(c_double), value, intent(in) :: x, y

    write(*, "(2I5,A)", advance='no') nint(x), nint(y), c_carriage_return
  end subroutine motion_event_h

  ! GTK 4 : Scroll callback function ("scroll" signal):
  subroutine scroll_event_h(controller, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    real(c_double), value, intent(in) :: x, y

    print *, "Scroll event detected : x,y= ", x, y
  end subroutine scroll_event_h

  ! GTK 4 : motion callback function ("enter" signal):
  subroutine enter_event_h(controller, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    real(c_double), value, intent(in) :: x, y

    print *, "Enter event detected : x,y= ", x, y
  end subroutine enter_event_h

  ! GTK 4 : motion callback function ("leave" signal):
  subroutine leave_event_h(controller, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    print *, "Leave event detected"
  end subroutine leave_event_h

  ! GTK 4 : key callback function ("key-pressed" signal):
  ! https://developer.gnome.org/gdk4/stable/gdk4-Keyboard-Handling.html
  function key_event_h(controller, keyval, keycode, state, gdata) result(ret) bind(c)
    type(c_ptr), value, intent(in) :: controller, gdata
    integer(c_int), value, intent(in) :: keyval, keycode, state
    logical(c_bool) :: ret
    character(len=20) :: keyname
    integer(c_int) :: key_q

    call convert_c_string(gdk_keyval_name(keyval), keyname)
    print *, "Keyval: ",keyval," Name: ", trim(keyname), "      Keycode: ", &
             & keycode, " Modifier: ", state

    key_q = gdk_keyval_from_name("q"//c_null_char)
    ! CTRL+Q will close the program:
    if ((iand(state, GDK_CONTROL_MASK) /= 0).and.(keyval == key_q)) then
      call gtk_window_destroy(my_window)
    end if

    ret = .true.
  end function key_event_h


  subroutine draw_pattern(widget)
    type(c_ptr) :: widget
    real(c_double), parameter :: pi = acos(-1.0_c_double)
    integer :: cstatus
    integer :: t

    my_cairo_context = hl_gtk_drawing_area_cairo_new(widget)
    if (.not. c_associated(my_cairo_context)) then
       print *, "ERROR failed to create cairo context"
       return
    end if

    ! Background
    call cairo_set_source_rgb(my_cairo_context, 0.6_c_double, 0.6_c_double, &
         & 0.6_c_double)
    call cairo_rectangle(my_cairo_context, 0._c_double, 0._c_double,&
         & real(width, c_double), real(height, c_double))
    call cairo_paint(my_cairo_context)

    ! Bezier curve:
    call cairo_set_source_rgb(my_cairo_context, 0.9_c_double, 0.8_c_double, &
         & 0.8_c_double)
    call cairo_set_line_width(my_cairo_context, 4._c_double)
    call cairo_move_to(my_cairo_context, 0._c_double, 0._c_double)
    call cairo_curve_to(my_cairo_context, 600._c_double, 50._c_double, &
         & 115._c_double, 545._c_double, &
         & real(width, c_double), real(height, c_double))
    call cairo_stroke(my_cairo_context)

    ! Lines:
    call cairo_set_source_rgb(my_cairo_context, 0._c_double, 0.5_c_double, &
         & 0.5_c_double)
    call cairo_set_line_width(my_cairo_context, 2._c_double)
    do t = 0, int(height), +20
       call cairo_move_to(my_cairo_context, 0._c_double, real(t, c_double))
       call cairo_line_to(my_cairo_context, real(t, c_double), &
            & real(height, c_double))
       call cairo_stroke(my_cairo_context)
    end do

    ! Text:
    call cairo_set_source_rgb(my_cairo_context, 0._c_double, 0._c_double, &
         & 1._c_double)
    call cairo_select_font_face(my_cairo_context, "Times"//c_null_char, &
         & CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
    call cairo_set_font_size (my_cairo_context, 40._c_double)
    call cairo_move_to(my_cairo_context, 100._c_double, 30._c_double)
    call cairo_show_text (my_cairo_context, "gtk-fortran"//c_null_char)
    call cairo_move_to(my_cairo_context, 100._c_double, 75._c_double)
    call cairo_show_text (my_cairo_context, "Cairo & Fortran are good friends"//c_null_char)

    ! Circles:
    call cairo_new_sub_path(my_cairo_context)
    do t = 1, 50
       call cairo_set_source_rgb(my_cairo_context, t/50._c_double, &
            & 0._c_double, 0._c_double)
       call cairo_set_line_width(my_cairo_context, 5._c_double*t/50._c_double)
       call cairo_arc(my_cairo_context, 353._c_double+ &
            & 200._c_double*cos(t*2_c_double*pi/50), &
            & 350._c_double+200._c_double*sin(t*2._c_double*pi/50.), &
            & 50._c_double, 0._c_double, 2.*pi)
       call cairo_stroke(my_cairo_context)
    end do

    ! Save:
    cstatus = cairo_surface_write_to_png(cairo_get_target(my_cairo_context), &
         & "cairo.png"//c_null_char)

    call gtk_widget_queue_draw(widget)
    call hl_gtk_drawing_area_cairo_destroy(my_cairo_context)
  end subroutine draw_pattern

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: my_drawing_area
    type(c_ptr) :: my_scroll_box

    ! Properties of the main window :
    width = 700
    height = 700
    ! Create the window:
    my_window = gtk_application_window_new(app)
    call gtk_window_set_title(my_window, "Cairo events demo (CTRL+Q to quit)"//c_null_char)

    my_drawing_area = hl_gtk_drawing_area_new(&
         & scroll=my_scroll_box, &
         & size = [width, height ], &
         & ssize = [ 400_c_int, 300_c_int ], &
         & button_press_event=c_funloc(button_event_h), &
         & button_release_event=c_funloc(button_release_h), &
         & scroll_event=c_funloc(scroll_event_h), &
         & enter_event=c_funloc(enter_event_h), &
         & leave_event=c_funloc(leave_event_h), &
         & key_press_event=c_funloc(key_event_h), &
         & motion_event=c_funloc(motion_event_h))

    call gtk_window_set_child(my_window, my_scroll_box)

    call gtk_widget_show(my_window)
    call draw_pattern(my_drawing_area)
  end subroutine activate
end module handlers


program cairo_basics_click
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_cairo1"//c_null_char, &
                             & c_funloc(activate))
end program cairo_basics_click

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2021 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------
! Contributed by: Jerry DeLisle, 2021-02-24
! Last modifications: vmagnin 2023-08-30
! This example demonstrates a menu bar and is based on:
!   https://github.com/ToshioCP/Gtk4-tutorial/blob/main/src/menu/menu2.c
!-------------------------------------------------------------------------------

module handlers
  use gtk, only: gtk_application_new, g_signal_connect, FALSE, TRUE, &
               & gtk_window_maximize, gtk_window_unmaximize, &
               & gtk_css_provider_load_from_data, gtk_application_window_new, &
               & gtk_window_set_title, gtk_window_set_default_size, &
               & gtk_label_new, gtk_widget_set_name, gtk_window_set_child, &
               & gtk_application_set_menubar, &
               & gtk_application_window_set_show_menubar, &
               & gtk_application_set_accels_for_action, &
               & gtk_css_provider_new, gtk_widget_get_display, &
               & gtk_css_provider_load_from_data, g_application_flags_none, &
               & gtk_style_context_add_provider_for_display, gtk_window_present
  use gtk_sup, only: convert_c_string, f_c_string
  use g, only: g_variant_new_boolean, g_variant_get_boolean, &
             & g_variant_new_string, g_variant_get_string, g_variant_type_new, &
             & g_simple_action_set_state, g_action_change_state, &
             & g_application_run, g_application_quit, &
             & g_simple_action_new_stateful, &
             & g_simple_action_new, g_menu_new, g_menu_item_new, &
             & g_action_map_add_action, g_menu_append_item, &
             & g_object_unref, g_menu_append_section, g_menu_append_submenu
  use, intrinsic :: iso_c_binding, only: c_null_ptr, c_null_char, c_ptr, c_int, c_char, &
                         & c_funloc, c_loc, c_size_t

  implicit none
  type(c_ptr) :: app, provider

contains

  !*************************************************
  ! The three callback functions of the menu items:
  !*************************************************
  subroutine fullscreen_changed (act, avalue, win) bind(c)
    type(c_ptr), value, intent(in) :: act, avalue, win
    logical :: state

    ! This is the correct way to convert a boolean integer to logical.
    state = transfer(g_variant_get_boolean (avalue), state)

    if (state) then
      call gtk_window_maximize (win)
    else
      call gtk_window_unmaximize (win)
    end if
    call g_simple_action_set_state (act, avalue)
  end subroutine

  subroutine color_activated (act, param, win) bind(c)
    type(c_ptr), value, intent(in) :: act, param, win
    type(c_ptr) :: param_string
    character(kind=c_char, len=40):: color, color_str

    ! Get the C string from param
    param_string = g_variant_get_string (param, c_null_ptr)

    ! Convert it to a Fortran string
    call convert_c_string(param_string, color_str)
    print *, "The color will be: "//trim(color_str)//"!"

    color = "label#lb {background-color: "//trim(color_str)//"; }"//c_null_char

    print *, "Let's change the color!"
    call gtk_css_provider_load_from_data (provider, color, -1_c_size_t)
    call g_action_change_state (act, param)
  end subroutine

  subroutine quit_activated (act, param, win) bind(c)
    type(c_ptr), value, intent(in) :: act, param, win

    print *, "QUIT!"
    call g_application_quit (app)
  end subroutine

  !*******************************************************
  ! The activate callback function of the GtkApplication:
  !*******************************************************
  subroutine activate (app, user_data) bind(c)
    type(c_ptr), value, intent(in)  :: app, user_data
    type(c_ptr) :: win, display, lb, act_fullscreen, &
                 & act_color, act_quit
    type(c_ptr) :: menubar, menu, section1, section2, section3, &
      & menu_item_red, menu_item_green, &
      & menu_item_blue, menu_item_quit, menu_item_fullscreen
    integer(c_size_t) :: length = -1_c_size_t
    character(kind=c_char), dimension(:), allocatable :: stringtmp
    character(kind=c_char), pointer, dimension(:) :: accels
    type(c_ptr), dimension(:), allocatable :: c_ptr_array

    win = gtk_application_window_new (app)
    call gtk_window_set_title (win, "menubar"//c_null_char)
    call gtk_window_set_default_size (win, 400, 300)

    lb = gtk_label_new (""//c_null_char)
    call gtk_widget_set_name (lb, "lb"//c_null_char)  ! the name is used by CSS Selector.
    call gtk_window_set_child (win, lb)

    act_fullscreen = g_simple_action_new_stateful ("fullscreen"//c_null_char, &
                                  & c_null_ptr, g_variant_new_boolean (FALSE))
    act_color = g_simple_action_new_stateful ("color"//c_null_char, &
                                  & g_variant_type_new("s"//c_null_char), &
                                  & g_variant_new_string ("red"//c_null_char))
    act_quit = g_simple_action_new ("quit"//c_null_char, c_null_ptr)
  
    ! To add an accelerator we need a pointer toward a null terminated array
    ! of strings, but in the present case the array will contain only one string
    ! (it is possible to have several accelerators for the same action): 
    allocate(c_ptr_array(1+1))
    call f_c_string("<Ctrl>q"//c_null_char, stringtmp)
    allocate(accels(size(stringtmp)))
    ! A Fortran pointer toward the Fortran string:
    accels(:) = stringtmp(:)
    ! Store the C address in the array:
    c_ptr_array(1) = c_loc(accels(1))
    nullify(accels)
    ! The array must be null terminated:
    c_ptr_array(2) = c_null_ptr
    ! https://docs.gtk.org/gtk4/method.Application.set_accels_for_action.html
    call gtk_application_set_accels_for_action(app, "app.quit"//c_null_char, c_ptr_array)
    deallocate(c_ptr_array)

    menubar = g_menu_new ()
    menu = g_menu_new ()
    section1 = g_menu_new ()
    section2 = g_menu_new ()
    section3 = g_menu_new ()
    menu_item_fullscreen = g_menu_item_new ("Full Screen"//c_null_char, "win.fullscreen"//c_null_char)
    menu_item_red = g_menu_item_new ("Red"//c_null_char, "win.color::red"//c_null_char)
    menu_item_green = g_menu_item_new ("Green"//c_null_char, "win.color::green"//c_null_char)
    menu_item_blue = g_menu_item_new ("Blue"//c_null_char, "win.color::blue"//c_null_char)
    menu_item_quit = g_menu_item_new ("Quit"//c_null_char, "app.quit"//c_null_char)

    call g_signal_connect (act_fullscreen, "change-state"//c_null_char, c_funloc(fullscreen_changed), win)
    call g_signal_connect (act_color, "activate"//c_null_char, c_funloc (color_activated), win)
    call g_signal_connect (act_quit, "activate"//c_null_char, c_funloc (quit_activated), app)
    call g_action_map_add_action (win, act_fullscreen)
    call g_action_map_add_action (win, act_color)
    call g_action_map_add_action (app, act_quit)

    call g_menu_append_item (section1, menu_item_fullscreen)
    call g_menu_append_item (section2, menu_item_red)
    call g_menu_append_item (section2, menu_item_green)
    call g_menu_append_item (section2, menu_item_blue)
    call g_menu_append_item (section3, menu_item_quit)
    call g_object_unref (menu_item_red)
    call g_object_unref (menu_item_green)
    call g_object_unref (menu_item_blue)
    call g_object_unref (menu_item_fullscreen)
    call g_object_unref (menu_item_quit)

    call g_menu_append_section (menu, c_null_char, section1)
    call g_menu_append_section (menu, "Color"//c_null_char, section2)
    call g_menu_append_section (menu, c_null_char, section3)
    call g_menu_append_submenu (menubar, "Menu"//c_null_char, menu)

    call gtk_application_set_menubar (app, menubar)
    call gtk_application_window_set_show_menubar (win, TRUE)

    provider = gtk_css_provider_new ()
    display = gtk_widget_get_display (win)
    call gtk_css_provider_load_from_data (provider, "label#lb {background-color: red;}"//c_null_char, length)
    call gtk_style_context_add_provider_for_display (display, provider, 800)

    call gtk_window_present (win)
  end subroutine
end module handlers

program menu_example
  use handlers

  implicit none

  integer(c_int) :: app_stat

  app = gtk_application_new ("gtk-fortran.examples.menubar"//c_null_char, &
                          & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, &
                      & c_funloc(activate), c_null_ptr)

  app_stat = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref (app)
end program

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 2020-06-03 (GTK 4 version), 2020-07-10
!------------------------------------------------------------------------------

module handlers
  use, intrinsic :: iso_c_binding
!  use gth_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk, only: gtk_window_set_child, gtk_label_new, &
       & gtk_widget_show, gtk_window_destroy, TRUE, FALSE

  implicit none
  type(c_ptr) :: win, base, nbook, qbut, table
  type(c_ptr) :: my_gmainloop

contains

  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value :: widget, gdata

    print *, "Exit called"
    call gtk_window_destroy(win)
  end subroutine my_destroy

  subroutine bpress(widget, gdata) bind(c)
    type(c_ptr), value :: widget, gdata
    integer(c_int), pointer :: fdata

    call c_f_pointer(gdata, fdata)
    print *, "Pressed button ", fdata
  end subroutine bpress


  subroutine activate(app, gdata) bind(c)
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    integer(c_int) :: ipos
    type(c_ptr) :: junk
    integer(c_int) :: i
    integer(c_int), dimension(6), target :: bval = [ (i, i = 1,6) ]
    character(len=15) :: ltext

    ! Create the window:
    win = gtk_application_window_new(app)
    call gtk_window_set_title(win, "Table/notebook"//c_null_char)

    ! Now make a column box & put it into the window
    base = hl_gtk_box_new()
    call gtk_window_set_child(win, base)

    ! Make a notebook container
    nbook = hl_gtk_notebook_new()
    call hl_gtk_box_pack(base, nbook)

    ! First page is a 3x6 table
    table=hl_gtk_table_new(homogeneous=TRUE)
    ipos = hl_gtk_notebook_add_page(nbook, table, &
         & label="Example table"//c_null_char)

    do i = 1, 6
       write(ltext, "('Table row',I2)") i
       junk = gtk_label_new(trim(ltext)//c_null_char)
       call hl_gtk_table_attach(table, junk, 0_c_int, i-1_c_int, xspan=2_c_int)
       junk = hl_gtk_button_new("Press"//c_null_char, clicked=c_funloc(bpress), &
            & data = c_loc(bval(i)))
       call hl_gtk_table_attach(table, junk, 2_c_int, i-1_c_int)
    end do

    ! Then 4 relocatable dummy pages
    do i = 1,4
       write(ltext, "('Dummy page',I2)") i+1
       junk = gtk_label_new(trim(ltext)//c_null_char)

       ipos = hl_gtk_notebook_add_page(nbook, junk, label=trim(ltext)//c_null_char, &
            & reorderable=TRUE)
    end do

    ! And a quit button
    junk = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base, junk, expand=FALSE)

    ! realize the window
    call gtk_widget_show(win)
  end subroutine activate
end module handlers

program containers
  ! Containers
  ! Test/demo of tables & notebooks.
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_containers"//c_null_char, &
                             & c_funloc(activate))
end program containers

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! PLplot code derived from PLplot's example 30 by Hazen Babcock and Andrew Ross
! Last modifications: vmagnin 2020-06-10 (GTK 4), 2020-07-13
!------------------------------------------------------------------------------

module common_ex30
  use, intrinsic :: iso_c_binding
  use gtk, only: gtk_window_set_child, gtk_widget_queue_draw, &
       & gtk_widget_show, gtk_window_destroy
  use gtk_draw_hl
  use plplot_extra

  implicit none
  integer(c_int) :: height, width
  type(c_ptr) :: window
  type(c_ptr) :: my_gmainloop
end module common_ex30

module plplot_code_ex30
  use plplot, PI => PL_PI
  use common_ex30

  implicit none
  real(plflt) :: xscale, yscale, xoff, yoff

contains
  subroutine x30f95(area)

    type(c_ptr), intent(in) :: area
    type(c_ptr) :: cc
    character(len=20) :: geometry

    ! needed for use as functions instead of subroutines
    integer :: plparseopts_rc
    integer :: plsetopt_rc

    integer, dimension(4) ::  red, green, blue
    real(plflt), dimension (4) :: alpha, px, py
    real(plflt), dimension (2) :: pos, rcoord, gcoord, bcoord, acoord
    logical, dimension(1) :: rev

    data red   / 127, 255, 0, 0 /
    data green / 127, 0, 255, 0 /
    data blue  / 127, 0, 0, 255 /
    data alpha / 1.0_plflt, 1.0_plflt, 1.0_plflt, 1.0_plflt /
    data px / 0.1_plflt, 0.5_plflt, 0.5_plflt, 0.1_plflt /
    data py / 0.1_plflt, 0.1_plflt, 0.5_plflt, 0.5_plflt /
    data pos / 0.0_plflt, 1.0_plflt /
    data rcoord / 1.0_plflt, 1.0_plflt /
    data gcoord / 0.0_plflt, 0.0_plflt /
    data bcoord / 0.0_plflt, 0.0_plflt /
    data acoord / 0.0_plflt, 1.0_plflt /
    data rev / .false. /

    integer i, j
    integer icol, r, g, b
    real(plflt) :: a

    !  Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if (plparseopts_rc /= 0) stop "plparseopts error"

    ! Get a cairo context from the drawing area.
    cc = hl_gtk_drawing_area_cairo_new(area)

    !  Initialize plplot
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    write(geometry, "(I0,'x',I0)") width, height
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

    call plscmap0n(4)

    call plscmap0a (red, green, blue, alpha)

    !  Divide page into 2 plots
    call plstar(2,1)

    ! Tell the "extcairo" driver where the context is located.
    call pl_cmd(PLESC_DEVINIT, cc)
    !
    ! Page 1:
    !
    ! This is a series of red, green and blue rectangles overlaid
    ! on each other with gradually increasing transparency.
    !

    ! Set up the window
    call pladv (0)
    call plvpor (0.0_plflt, 1.0_plflt, 0.0_plflt, 1.0_plflt)
    call plwind (0.0_plflt, 1.0_plflt, 0.0_plflt, 1.0_plflt)
    call plcol0 (0)
    call plbox ("", 1.0_plflt, 0, "", 1.0_plflt, 0)

    ! Draw the boxes
    do i = 1,9
       icol = mod(i-1,3) + 1

       ! Get a color, change its transparency and
       ! set it as the current color.
       call plgcol0a (icol, r, g, b, a)
       call plscol0a (icol, r, g, b, 1.0_plflt - dble(i-1)/9.0_plflt)
       call plcol0 (icol)

       ! Draw the rectangle
       call plfill (px, py)

       ! Shift the rectangles coordinates
       do j = 1,4
          px(j) = px(j) + 0.5_plflt/9.0_plflt
          py(j) = py(j) + 0.5_plflt/9.0_plflt
       enddo
    enddo
    !
    ! Page 2:
    !
    ! This is a bunch of boxes colored red, green or blue with a single
    ! large (red) box of linearly varying transparency overlaid. The
    ! overlaid box is completely transparent at the bottom and completely
    ! opaque at the top.
    !

    ! Set up the window
    call pladv(0)
    call plvpor(0.1_plflt, 0.9_plflt, 0.1_plflt, 0.9_plflt)
    call plwind(0.0_plflt, 1.0_plflt, 0.0_plflt, 1.0_plflt)

    ! Draw the boxes. There are 25 of them drawn on a 5 x 5 grid.
    do i = 1,5
       ! Set box X position
       px(1) = 0.05_plflt + 0.2_plflt * dble(i-1)
       px(2) = px(1) + 0.1_plflt
       px(3) = px(2)
       px(4) = px(1)

       ! We don't want the boxes to be transparent, so since we changed
       ! the colors transparencies in the first example we have to change
       ! the transparencies back to completely opaque.
       icol = mod(i-1,3) + 1
       call plgcol0a (icol, r, g, b, a)
       call plscol0a (icol, r, g, b, 1.0_plflt)
       call plcol0 (icol)
       do j = 1, 5
          ! Set box y position and draw the box.
          py(1) = 0.05_plflt + 0.2_plflt * dble(j-1)
          py(2) = py(1)
          py(3) = py(1) + 0.1_plflt
          py(4) = py(3)
          call plfill(px, py)
       enddo
    enddo

    ! Create the color map with 128 colors and call plscmap1la to initialize
    ! the color values with a linearly varying red transparency (or alpha)
    call plscmap1n(128)
    call plscmap1la(.true., pos, rcoord, gcoord, bcoord, acoord, rev)

    ! Use that cmap1 to create a transparent red gradient for the whole
    ! window.
    px(1) = 0._plflt
    px(2) = 1._plflt
    px(3) = 1._plflt
    px(4) = 0._plflt

    py(1) = 0._plflt
    py(2) = 0._plflt
    py(3) = 1._plflt
    py(4) = 1._plflt

    call plgradient( px, py, 90._plflt )

    !  Don't forget to call PLEND to finish off!
    call plend()
    call gtk_widget_queue_draw(area)
    call hl_gtk_drawing_area_cairo_destroy(cc)

  end subroutine x30f95
end module plplot_code_ex30

module handlers_ex30

  use common_ex30
  use gtk_hl_container
  use gtk_hl_button
  use gtk_draw_hl
  use, intrinsic :: iso_c_binding

  implicit none
  real(c_double), parameter :: pi = acos(-1.0_c_double)

contains

  subroutine quit_cb(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call gtk_window_destroy(window)
  end subroutine quit_cb


  subroutine activate(app, gdata) bind(c)
    use plplot_code_ex30
    use gtk, only: gtk_application_window_new
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: drawing, scroll_w, base, qbut

    height = 600
    width = 1200

    ! Create the window:
    window = gtk_application_window_new(app)

    base = hl_gtk_box_new()
    call gtk_window_set_child(window, base)

    drawing = hl_gtk_drawing_area_new(size=[width, height], &
         & has_alpha = TRUE, &
         & scroll = scroll_w, &
         & ssize=[ 650, 600 ])
    call hl_gtk_box_pack(base, scroll_w)

    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(quit_cb))
    call hl_gtk_box_pack(base, qbut, expand=FALSE)

    call gtk_widget_show(window)

    call x30f95(drawing)
  end subroutine activate
end module handlers_ex30

program cairo_plplot_ex30
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers_ex30
  use gtk_hl_container, only: hl_gtk_application_new
  implicit none
  type(c_ptr) :: my_app

  my_app = hl_gtk_application_new("gtk-fortran.plplot.hl_plplot30e"//c_null_char, &
                             & c_funloc(activate))
end program cairo_plplot_ex30

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! PLplot code derived from PLplot's example 1 by Alan W. Irwin
! Last modifications: vmagnin 2020-06-10 (GTK 4), 2022-04-20
!------------------------------------------------------------------------------

module common_ex1
  use, intrinsic :: iso_c_binding      ! Enable the c-binding routines & constants
  ! These are the gtk & glib routines used explicitly in the code:
  use gtk, only: gtk_widget_show, gtk_window_set_child, gtk_window_destroy
  ! These are the high-level drawing area modules:
  use gtk_draw_hl
  ! This makes the low-level pl_cmd routine accessible:
  use plplot_extra

  ! The size of the drawing area:
  integer(c_int) :: height, width
  ! The top-level window must be here as its destroy signal need not come from it:
  type(c_ptr) :: window
end module common_ex1

module plplot_code_ex1
  use plplot, PI => PL_PI
  use common_ex1

  implicit none
  real(plflt) :: xscale, yscale, xoff, yoff

contains
  subroutine x01f95(area)

    type(c_ptr), intent(in) :: area
    type(c_ptr) :: cc
    character(len=80) :: version
    character(len=20) :: geometry
    integer :: digmax

    ! needed for use as functions instead of subroutines
    integer :: plparseopts_rc
    integer :: plsetopt_rc

    ! Define colour map 0 to match the "GRAFFER" colour table in
    ! place of the PLPLOT default.
    integer, parameter, dimension(16) :: &
      & rval = [255, 0, 255, 0, 0, 0, 255, 255, 255, 127, 0, 0, 127, 255, 85, 170],&
      & gval = [ 255, 0, 0, 255, 0, 255, 0, 255, 127, 255, 255, 127, 0, 0, 85, 170],&
      & bval = [ 255, 0, 0, 0, 255, 255, 255, 0, 0, 0, 127, 255, 255, 127, 85, 170]

    !  Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if (plparseopts_rc /= 0) stop "plparseopts error"

    !  Print plplot version
    call plgver(version)
    write (*,'(a,a)') 'PLplot library version: ', trim(version)

    ! Get a cairo context from the drawing area.
    cc = hl_gtk_drawing_area_cairo_new(area)

    !  Initialize plplot
    call plscmap0(rval, gval, bval)
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    write(geometry, "(I0,'x',I0)") width, height
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

    !  Divide page into 2x2 plots
    call plstar(2,2)

    ! Tell the "extcairo" driver where the context is located. This must be
    ! done AFTER the plstar or plinit call.
    call pl_cmd(PLESC_DEVINIT, cc)

    !  Set up the data
    !  Original case
    xscale = 6._plflt
    yscale = 1._plflt
    xoff = 0._plflt
    yoff = 0._plflt

    !  Do a plot
    call plot1()

    !  Set up the data
    xscale = 1._plflt
    yscale = 0.0014_plflt
    yoff = 0.0185_plflt

    !  Do a plot
    digmax = 5
    call plsyax(digmax,  0)
    call plot1()

    call plot2()
    call plot3()

    !  Don't forget to call PLEND to finish off, and then delete the
    !  cairo context.
    call plend()
    call hl_gtk_drawing_area_cairo_destroy(cc)

  end subroutine x01f95

  !======================================================================
  subroutine plot1()

    real(plflt), dimension(1:60) :: x, y
    real(plflt), dimension(1:6)  :: xs, ys
    real(plflt) :: xmin, xmax, ymin, ymax
    integer :: i

    do i = 1, 60
       x(i) = xoff + xscale * dble(i)/60.0_plflt
       y(i) = yoff + yscale * x(i)**2
    enddo

    xmin = x(1)
    xmax = x(60)
    ymin = y(1)
    ymax = y(60)

    do i = 1, 6
       xs(i) = x((i-1)*10+4)
       ys(i) = y((i-1)*10+4)
    enddo

    !   Set up the viewport and window using PLENV. The range in X is
    !   0.0 to 6.0, and the range in Y is 0.0 to 30.0. The axes are
    !   scaled separately (just = 0), and we just draw a labelled
    !   box (axis = 0).

    call plcol0(1)
    call plenv( xmin, xmax, ymin, ymax, 0, 0 )
    call plcol0(2)
    call pllab( '(x)', '(y)', '#frPLplot Example 1 - y=x#u2' )

    !   Plot the data points
    call plcol0(4)
    call plpoin( xs, ys, 9 )

    !   Draw the line through the data
    call plcol0(3)
    call plline( x, y )

  end subroutine plot1

  !======================================================================
  subroutine plot2()

    real(plflt), dimension(1:100) :: x, y
    integer :: i
    !
    !   Set up the viewport and window using PLENV. The range in X is
    !   -2.0 to 10.0, and the range in Y is -0.4 to 2.0. The axes are
    !   scaled separately (just = 0), and we draw a box with axes
    !   (axis = 1).
    call plcol0(1)
    call plenv(-2.0_plflt, 10.0_plflt, -0.4_plflt, 1.2_plflt, 0, 1 )
    call plcol0(2)
    call pllab( '(x)', 'sin(x)/x', '#frPLplot Example 1 - Sinc Function' )

    !   Fill up the arrays
    do i = 1, 100
       x(i) = (i-20.0_plflt)/6.0_plflt
       y(i) = 1.0_plflt
       if (x(i) /= 0.0_plflt) y(i) = sin(x(i)) / x(i)
    enddo

    !   Draw the line
    call plcol0(3)
    call plwidth(2.0_plflt)
    call plline( x, y )
    call plwidth(1.0_plflt)

  end subroutine plot2

  !======================================================================
  subroutine plot3()
    !
    !   For the final graph we wish to override the default tick intervals,
    !   and so do not use_ PLENV
    real(plflt), dimension(1:101) :: x, y

    integer i
    call pladv(0)

    !   Use_ standard viewport, and define X range from 0 to 360 degrees,
    !   Y range from -1.2 to 1.2.
    call plvsta()
    call plwind( 0.0_plflt, 360.0_plflt, -1.2_plflt, 1.2_plflt )

    !   Draw a box with ticks spaced 60 degrees apart in X, and 0.2 in Y.
    call plcol0(1)
    call plbox( 'bcnst', 60.0_plflt, 2, 'bcnstv', 0.2_plflt, 2 )

    !   Superimpose a dashed line grid, with 1.5 mm marks and spaces. With
    !   only a single mark and space element, we do not need arrays
    call plstyl( [1500], [1500] )
    call plcol0(2)
    call plbox( 'g', 30.0_plflt, 0, 'g', 0.2_plflt, 0 )
    !   remember from the error message:
    !   plstyl: At least one mark or space must be > 0, aborting operation
    call plstyl( [0], [1] )

    call plcol0(3)
    call pllab( 'Angle (degrees)', 'sine', '#frPLplot Example 1 - Sine function' )

    do i = 1, 101
       x(i) = 3.6_plflt * (i-1)
       y(i) = sin( x(i) * PI/180.0_plflt )
    enddo

    call plcol0(4)
    call plline( x, y )
  end subroutine plot3
end module plplot_code_ex1

module handlers_ex1
  use common_Ex1
  use gtk_hl_container
  use gtk_hl_button
  use gtk_draw_hl
  use, intrinsic :: iso_c_binding

  implicit none
  integer(c_int) :: run_status = TRUE
  real(c_double), parameter :: pi = acos(-1.0_c_double)

contains

  subroutine quit_cb(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    call gtk_window_destroy(window)
  end subroutine quit_cb

  subroutine activate(app, gdata) bind(c)
    ! This gives the main program access to the plotting code
    use plplot_code_ex1
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: drawing, scroll_w, base, qbut

    ! Set the size of the drawing area (these are global variables)
    height = 1000
    width = 1200

    ! Create a top-level window and then pack a column box into it:
    window = gtk_application_window_new(app)
    call gtk_window_set_title(window, "PLplot x01 / gtk-fortran (extcairo)"//c_null_char)

    base = hl_gtk_box_new()
    call gtk_window_set_child(window, base)

    ! Create a drawing area, in a 600x500 scrolled window.
    ! The high-level drawing area creator automatically adds a cairo surface as
    ! backing store. Here we use the default expose/draw callback which
    ! just copies the backing store to the drawing surface.
    ! Pack it into the vertical box.
    drawing = hl_gtk_drawing_area_new(size=[width, height], &
         & has_alpha = FALSE, &
         & scroll = scroll_w, &
         & ssize=[ 600, 500 ])
    call hl_gtk_box_pack(base, scroll_w)

    ! Add a quit button, and pack that into the box as well:
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(quit_cb))
    call hl_gtk_box_pack(base, qbut, expand=FALSE)

    ! Display the widgets:
    call gtk_widget_show(window)

    ! Call the plotting routine:
    call x01f95(drawing)
  end subroutine activate
end module handlers_ex1


program cairo_plplot_ex1
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  ! Set the size of the drawing area (these are global variables)
  use handlers_ex1
  use gtk_hl_container, only: hl_gtk_application_new
  implicit none
  type(c_ptr) :: my_app

  ! Initalize GTK, create the GUI and launch the main loop:
  my_app = hl_gtk_application_new("gtk-fortran.plplot.hl_plplot1e"//c_null_char, &
                             & c_funloc(activate))
end program cairo_plplot_ex1

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! PLplot code derived from PLplot's example 17 by Alan W. Irwin
! Last modifications: vmagnin 2020-06-10 (GTK 4), 2020-07-14
!------------------------------------------------------------------------------

module common_ex17_gto
  use, intrinsic :: iso_c_binding
  use gtk_draw_hl
  use g, only: g_timeout_add, g_main_context_pending
  use gtk, only: gtk_window_set_child, gtk_widget_queue_draw, gtk_widget_show, &
               & gtk_window_destroy, TRUE, FALSE
  use plplot_extra

  implicit none
  integer(c_int) :: height, width
  integer(c_int) :: run_status = TRUE
  type(c_ptr) :: window
end module common_ex17_gto

module plplot_code_ex17_gto
  use plplot, PI => PL_PI
  use common_ex17_gto

  implicit none
  integer, save :: id1, n=0
  logical :: autoy, acc

  real(plflt) :: y1, y2, y3, y4, ymin, ymax, xlab, ylab
  real(plflt) :: t, tmin, tmax, tjump, dt, noise
  type(c_ptr) :: cc
  integer :: colbox, collab, colline(4), styline(4)
  character(len=20) :: legline(4)

contains

  subroutine x17f95(area)
    type(c_ptr), intent(in) :: area
    character(len=20) :: geometry
    ! needed for use as functions instead of subroutines
    integer :: plparseopts_rc
    integer :: plsetopt_rc
    ! Define colour map 0 to match the "GRAFFER" colour table in
    ! place of the PLPLOT default.
    integer, parameter, dimension(16) :: rval = [255, 0, 255, &
         & 0, 0, 0, 255, 255, 255, 127, 0, 0, 127, 255, 85, 170],&
         & gval = [ 255, 0, 0, 255, 0, 255, 0, 255, 127, 255, 255, 127,&
         & 0, 0, 85, 170], &
         & bval = [ 255, 0, 0, 0, 255, 255, 255, 0, 0, 0, 127, 255, 255,&
         & 127, 85, 170]

    !  Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if (plparseopts_rc /= 0) stop "plparseopts error"

    ! Get a cairo context from the drawing area.
    cc = hl_gtk_drawing_area_cairo_new(area)

    !  Initialize plplot
    call plscmap0(rval, gval, bval)
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    call hl_gtk_drawing_area_get_size(area, width=width, height=height)
    write(geometry, "(I0,'x',I0)") width, height
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! Specify some reasonable defaults for ymin and ymax
    ! The plot will grow automatically if needed (but not shrink)
    ymin = -0.1_plflt
    ymax = 0.1_plflt

    ! Specify initial tmin and tmax -- this determines length of window.
    ! Also specify maximum jump in t
    ! This can accomodate adaptive timesteps
    tmin = 0._plflt
    tmax = 50._plflt
    ! percentage of plot to jump
    tjump = 0.3_plflt

    ! Axes options same as plbox.
    ! Only automatic tick generation and label placement allowed
    ! Eventually I'll make this fancier
    colbox = 1
    collab = 1
    ! pens color and line style
    styline(1) = 1
    colline(1) = 1
    styline(2) = 3
    colline(2) = 3
    styline(3) = 4
    colline(3) = 4
    styline(4) = 5
    colline(4) = 5

    ! pens legend
    legline(1) = 'sum'
    legline(2) = 'sin'
    legline(3) = 'sin*noi'
    legline(4) = 'sin+noi'

    ! legend position
    xlab = 0._plflt
    ylab = 0.25_plflt

    ! autoscale y
    autoy = .true.
    ! scrip, don't accumulate
    acc = .false.

    ! Initialize plplot
    call plinit()
    ! Tell the "extcairo" driver where the context is located.
    call pl_cmd(PLESC_DEVINIT, cc)

    call pladv(0)
    call plvsta()

    ! Create a 4-pen strip chart
    call plstripc(id1, 'bcnst', 'bcnstv', &
         tmin, tmax, tjump, ymin, ymax, &
         xlab, ylab, &
         autoy, acc, &
         colbox, collab, &
         colline, styline, legline, &
         't', '', 'Strip chart demo')

    ! autoscale y
    autoy = .false.
    ! accumulate
    acc = .true.

    ! This is to represent a loop over time
    ! Let's try a random walk process
    y1 = 0.0_plflt
    y2 = 0.0_plflt
    y3 = 0.0_plflt
    y4 = 0.0_plflt
    dt = 0.1_plflt

    call gtk_widget_queue_draw(area)

  end subroutine x17f95

  function add_point(area) bind(c)
    integer(c_int) :: add_point
    type(c_ptr), intent(in) :: area

    n = n + 1

    t = dble(n) * dt
    noise = plrandd() - 0.5_plflt
    y1 = y1 + noise
    y2 = sin(t*PI/18._plflt)
    y3 = y2 * noise
    y4 = y2 + noise/3._plflt

    if (c_f_logical(g_main_context_pending(c_null_ptr))) add_point = FALSE   ! Exit

    ! There is no need for all pens to have the same number of
    ! points or being equally time spaced.
    if ( mod(n,2) /= 0 ) then
       call plstripa(id1, 0, t, y1)
    endif
    if ( mod(n,3) /= 0 ) then
       call plstripa(id1, 1, t, y2)
    endif
    if ( mod(n,4) /= 0 ) then
       call plstripa(id1, 2, t, y3)
    endif
    if ( mod(n,5) /= 0 ) then
       call plstripa(id1, 3, t, y4)
    end if

    call gtk_widget_queue_draw(area)

    add_point = TRUE
  end function add_point

  subroutine close_strip
    ! Destroy strip chart and its memory
    call plstripd(id1)
    call plend()
    call hl_gtk_drawing_area_cairo_destroy(cc)
  end subroutine close_strip
end module plplot_code_ex17_gto


module handlers_ex17_gto
  use gtk_hl_container
  use gtk_hl_button
  use plplot_code_ex17_gto

  implicit none

contains

  subroutine quit_cb(widget, gdata) bind(c)
    type(c_ptr), value :: widget, gdata

    call close_strip()
    call gtk_window_destroy(window)
  end subroutine quit_cb

  subroutine activate(app, gdata) bind(c)
    use gtk, only: gtk_application_window_new, gtk_window_set_title

    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: drawing, base, qbut
    integer(c_int) :: timeid

    ! Create the window:
    window = gtk_application_window_new(app)
    call gtk_window_set_title(window, "PLplot x17 / gtk-fortran (extcairo) g_timeout version"//c_null_char)

    base = hl_gtk_box_new()
    call gtk_window_set_child(window, base)

    drawing = hl_gtk_drawing_area_new(size=[1000_c_int, 500_c_int], &
         & has_alpha = FALSE)

    call hl_gtk_box_pack(base, drawing)

    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(quit_cb))
    call hl_gtk_box_pack(base, qbut, expand=FALSE)

    call gtk_widget_show(window)

    call x17f95(drawing)

    timeid = g_timeout_add(100_c_int, c_funloc(add_point), drawing)
  end subroutine activate
end module handlers_ex17_gto


program cairo_plplot_ex17_gto
  use, intrinsic :: iso_c_binding
  use handlers_ex17_gto, only: activate
  use gtk_hl_container, only: hl_gtk_application_new

  implicit none
  type(c_ptr) :: my_app

  my_app = hl_gtk_application_new("gtk-fortran.plplot.hl_plplot17e_gto"//c_null_char, &
                             & c_funloc(activate))
end program cairo_plplot_ex17_gto

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by Jerry DeLisle and Vincent Magnin
! Last modification: vmagnin 2023-04-23

module handlers
  use, intrinsic :: iso_c_binding

  use gtk, only: gtk_application_window_new, gtk_drawing_area_new, &
  & gtk_drawing_area_set_content_width, gtk_drawing_area_set_content_height, &
  & gtk_drawing_area_set_draw_func, gtk_window_set_child, gtk_widget_show, &
  & gtk_window_set_default_size, gtk_window_set_title, CAIRO_SVG_VERSION_1_2, &
  & FALSE, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL

  use cairo, only: cairo_arc, cairo_create, cairo_curve_to, cairo_destroy, &
  & cairo_get_target, cairo_line_to, cairo_move_to, cairo_new_sub_path, &
  & cairo_select_font_face, cairo_set_font_size, cairo_set_line_width, &
  & cairo_set_source, cairo_set_source_rgb, cairo_show_text, cairo_stroke, &
  & cairo_surface_write_to_png, cairo_svg_surface_create, &
  & cairo_svg_surface_restrict_to_version, cairo_surface_destroy, &
  & cairo_pdf_surface_create

  implicit none

contains
  ! The GUI is defined here:
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    type(c_ptr)     :: window
    type(c_ptr)     :: my_drawing_area
    integer(c_int)  :: width, height

    window = gtk_application_window_new(app)
    width  = 700
    height = 700
    call gtk_window_set_default_size(window, width, height)
    call gtk_window_set_title(window, "Cairo basics demo"//c_null_char)

    my_drawing_area = gtk_drawing_area_new()
    call gtk_drawing_area_set_content_width(my_drawing_area, width)
    call gtk_drawing_area_set_content_height(my_drawing_area, height)
    call gtk_drawing_area_set_draw_func(my_drawing_area, &
                   & c_funloc(my_draw_function), c_null_ptr, c_null_funptr)

    call gtk_window_set_child(window, my_drawing_area)
    call gtk_widget_show(window)
  end subroutine activate

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  ! https://docs.gtk.org/gtk4/class.DrawingArea.html
  subroutine my_draw_function(widget, my_cairo_context, width, height, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: dp=>c_double
    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height
    integer :: cstatus
    integer :: rendering
    type(c_ptr) :: surface_svg, surface_pdf, cr_svg, cr_pdf

    ! We will draw three times, once for screen, once in a SVG file, once in a PDF:
    do rendering = 1, 3
      if (rendering == 1) then
        ! Rendering on screen:
        call draw(my_cairo_context, width, height)
        ! Save the image as a PNG:
        cstatus = cairo_surface_write_to_png(cairo_get_target(my_cairo_context), &
                                          & "cairo-basics.png"//c_null_char)
        call cairo_destroy(my_cairo_context)
        print *, "Saved in cairo-basics.png"
      else if (rendering == 2) then
        ! Rendering in a SVG file:
        surface_svg = cairo_svg_surface_create("cairo-basics.svg"//c_null_char, &
                                  & real(width, KIND=dp), real(height, KIND=dp))
        cr_svg = cairo_create(surface_svg)
        call cairo_svg_surface_restrict_to_version(surface_svg, CAIRO_SVG_VERSION_1_2)
        call draw(cr_svg, width, height)
        call cairo_destroy(cr_svg)
        call cairo_surface_destroy(surface_svg)
        print *, "Saved in cairo-basics.svg"
      else
        ! Rendering in a PDF file:
        surface_pdf = cairo_pdf_surface_create("cairo-basics.pdf"//c_null_char, &
                                  & real(width, KIND=dp), real(height, KIND=dp))
        cr_pdf = cairo_create(surface_pdf)
        call draw(cr_pdf, width, height)
        call cairo_surface_destroy(surface_pdf)
        print *, "Saved in cairo-basics.pdf"
      end if
    end do
  end subroutine my_draw_function

  ! It will be called two time, for screen and SVG file:
  subroutine draw(cr, width, height)
    use, intrinsic :: iso_c_binding, only: dp=>c_double

    type(c_ptr), value, intent(in)    :: cr
    integer(c_int), value, intent(in) :: width, height
    integer                           :: t
    real(dp), parameter               :: pi = acos(-1.0_dp)

    ! Bezier curve:
    call cairo_set_source_rgb(cr, 0.9_dp, 0.8_dp, 0.8_dp)
    call cairo_set_line_width(cr, 4._dp)
    call cairo_move_to(cr, 0._dp, 0._dp)
    call cairo_curve_to(cr, 600._dp, 50._dp, 115._dp, 545._dp, &
                      & width*1._dp, height*1._dp)
    call cairo_stroke(cr)

    ! Lines:
    call cairo_set_source_rgb(cr, 0._dp, 0.5_dp, 0.5_dp)
    call cairo_set_line_width(cr, 2._dp)
    do t = 0, height, +20
      call cairo_move_to(cr, 0._dp, t*1._dp)
      call cairo_line_to(cr, t*1._dp, height*1._dp)
      call cairo_stroke(cr)
    end do

    ! Text:
    call cairo_set_source_rgb(cr, 0._dp, 0._dp, 1._dp)
    call cairo_select_font_face(cr, "Times"//c_null_char, &
                            & CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
    call cairo_set_font_size (cr, 40._dp)
    call cairo_move_to(cr, 100._dp, 30._dp)
    call cairo_show_text (cr, "gtk-fortran"//c_null_char)
    call cairo_move_to(cr, 100._dp, 75._dp)
    call cairo_show_text (cr, &
                        & "Cairo & Fortran are good friends"//c_null_char)

    ! Circles:
    call cairo_new_sub_path(cr)
    do t = 1, 50
        call cairo_set_source_rgb(cr, t/50._dp, 0._dp, 0._dp)
        call cairo_set_line_width(cr, 5._dp*t/50._dp)
        call cairo_arc(cr, 353._dp + 200._dp*cos(t*2._dp*pi/50), &
                     & 350._dp + 200._dp*sin(t*2._dp*pi/50), 50._dp, 0._dp, 2*pi)
        call cairo_stroke(cr)
    end do
  end subroutine draw

end module handlers

! We create a GtkApplication:
program cairo_basics
  use, intrinsic :: iso_c_binding
  use gtk, only: gtk_application_new, g_signal_connect, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers, only: activate

  implicit none
  integer(c_int) :: exit_status
  type(c_ptr)    :: app

  app = gtk_application_new("gtk-fortran.examples.cairo-basics"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  exit_status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program cairo_basics

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modifications: vmagnin 2020-06-18 (GTK 4 version), 2020-12-17
! Demo of file choosers.
!------------------------------------------------------------------------------

module handlers
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_dialog
  use gtk_hl_chooser
  use gtk_hl_misc
  use gtk_hl_entry
  use gtk, only: gtk_button_new, gtk_window_set_child, &
       & gtk_text_view_new, gtk_widget_set_sensitive, gtk_widget_show, &
       & gtk_window_destroy, &
       & TRUE, FALSE, GTK_BUTTONS_YES_NO, GTK_RESPONSE_NO
  use g, only: alloca, g_file_get_path, g_object_unref

  implicit none
  ! Those widgets that need to be addressed explicitly in the handlers
  type(c_ptr) :: window, sbut, sabut, tedit
  ! Other variables that need to be shared between handlers
  logical, private :: file_is_changed = .FALSE.
  character(len=120), private :: filename=''

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int) :: ok
    character(len=60), dimension(4) :: msg

    msg(1) = "File is changed"
    msg(2) = ""
    msg(3) = "Quitting now will destroy your changes"
    msg(4) = "Do you really want to quit"

    if (file_is_changed) then
       ok = hl_gtk_message_dialog_show(msg, GTK_BUTTONS_YES_NO, &
            & "Really Quit"//c_null_char, parent=window)
       if (ok == GTK_RESPONSE_NO) return
    end if

    print *, "Exit called"
    call gtk_window_destroy(window)
  end subroutine my_destroy

  subroutine open_file(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer(c_int) :: isel
    character(len=120), dimension(:), allocatable :: chfile
    character(len=30), dimension(2) :: filters
    character(len=30), dimension(2) :: filtnames
    character(len=200) :: inln
    integer :: ios
    integer :: idxs

    filters(1) = "*.txt,*.lis"
    filters(2) = "*.f90"
    filtnames(1) = "Text files"
    filtnames(2) = "Fortran code"

    isel = hl_gtk_file_chooser_show(chfile, create=FALSE,&
         & title="Select input file"//c_null_char, filter=filters, &
         & filter_name=filtnames, wsize=[ 600_c_int, 400_c_int ], &
         & edit_filters=TRUE, &
         & parent=window, all=TRUE)
    print *, "isel = hl_gtk_file_chooser_show=", isel
    if (isel == FALSE) return   ! No selection made

    filename = chfile(1)
    deallocate(chfile)

    open(37, file=filename, action='read')
    call hl_gtk_text_view_delete(tedit)
    do
       read(37,"(A)",iostat=ios) inln
       if (ios /= 0) exit
       call hl_gtk_text_view_insert(tedit, [ trim(inln)//c_new_line ])
    end do
    close(37)
    idxs = index(filename, '/', .true.)+1
    call gtk_window_set_title(window, trim(filename(idxs:))//c_null_char)

    ! We manually reset the changed flag as the text box signal handler sets it.

    file_is_changed = .FALSE.
    call gtk_widget_set_sensitive(sabut, TRUE)
    call gtk_widget_set_sensitive(sbut, FALSE)
  end subroutine open_file


  subroutine save_file(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    character(len=200), dimension(:), allocatable :: text
    integer :: i

    call hl_gtk_text_view_get_text(tedit, text)

    open(37, file=filename, action='write')
    do i = 1, size(text)
       write(37, '(A)') trim(text(i))
    end do
    close(37)
    deallocate(text)

    file_is_changed = .FALSE.
    call gtk_widget_set_sensitive(widget, false)
  end subroutine save_file

  subroutine save_file_as(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer(c_int) :: isel
    character(len=120), dimension(:), allocatable :: chfile
    character(len=20), dimension(2) :: filters
    character(len=30), dimension(2) :: filtnames
    integer :: i
    character(len=200), dimension(:), allocatable :: text
    integer :: idxs

    filters(1) = "*.txt,*.lis"
    filters(2) = "*.f90"
    filtnames(1) = "Text files"
    filtnames(2) = "Fortran code"

    isel = hl_gtk_file_chooser_show(chfile, create=TRUE,&
         & title="Select input file"//c_null_char, filter=filters, &
         & filter_name=filtnames, initial_file=trim(filename)//c_null_char, &
         & confirm_overwrite=TRUE, all=TRUE, parent=window)

    if (isel == FALSE) return   ! No selection made

    filename = chfile(1)
    deallocate(chfile)
    idxs = index(filename, '/', .true.)+1
    call gtk_window_set_title(window, trim(filename(idxs:))//c_null_char)
    call hl_gtk_text_view_get_text(tedit, text)

    open(37, file=filename, action='write')
    do i = 1, size(text)
       write(37, '(A)') trim(text(i))
    end do
    close(37)
    deallocate(text)

    file_is_changed = .FALSE.

    call gtk_widget_set_sensitive(sbut, false)
  end subroutine save_file_as

  subroutine file_edited(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    file_is_changed = .true.
    if (filename == '') then
       call gtk_widget_set_sensitive(sabut, TRUE)
    else
       call gtk_widget_set_sensitive(sbut, TRUE)
    end if
  end subroutine file_edited


  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Widgets that don't need to be global
    type(c_ptr) :: base, jb, junk

    ! Create a window and a column box
    window = gtk_application_window_new(app)
    call gtk_window_set_title(window, "Choosers demo"//c_null_char)

    base = hl_gtk_box_new()
    call gtk_window_set_child(window, base)

    ! A row of buttons
    jb = hl_gtk_box_new(horizontal=TRUE, homogeneous=TRUE)
    call hl_gtk_box_pack(base, jb)
    junk = hl_gtk_button_new("Open"//c_null_char, clicked=c_funloc(open_file))
    call hl_gtk_box_pack(jb, junk)
    sbut = hl_gtk_button_new("Save"//c_null_char, clicked=c_funloc(save_file),&
         & sensitive=FALSE)
    call hl_gtk_box_pack(jb, sbut)
    sabut = hl_gtk_button_new("Save as"//c_null_char, clicked=c_funloc(save_file_as), &
         & sensitive=FALSE)
    call hl_gtk_box_pack(jb, sabut)

    ! A multiline text editor in which to display the file.
    tedit = hl_gtk_text_view_new(jb, editable=TRUE, &
         & changed=c_funloc(file_edited), ssize = [ 750_c_int, 400_c_int ] )
    call hl_gtk_box_pack(base, jb)

    ! A quit button
    junk = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base, junk)

    ! Realise & enter event loop
    call gtk_widget_show(window)
  end subroutine activate
end module handlers


program choosers_demo
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_choosers"//c_null_char, &
                             & c_funloc(activate))
end program choosers_demo

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by James Tappin, 2011
! Last modification: vmagnin 2020-05-28 (GTK 4)


!*
! Misc utility functions
module gtk_hl_misc
  ! Assorted functions and subroutines that don't fit anywhere else.
  !/

  use gtk_sup

  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only: error_unit

  use gtk, only: gtk_label_set_markup, gtk_separator_new, &
       & GTK_ORIENTATION_HORIZONTAL, GTK_ORIENTATION_VERTICAL, &
       & TRUE, FALSE, gtk_widget_get_first_child

  implicit none

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! GtkBin has been removed in GTK 4
  !+
  subroutine hl_gtk_bin_set_label_markup(widget, label)
    type(c_ptr) :: widget
    character(kind=c_char), dimension(*), intent(in) :: label

    ! Add a markup label to a button or menu item.
    !
    ! WIDGET |  c_ptr |  required |  The widget to update.
    ! LABEL |  string |  required |  The new label string.
    !-

    type(c_ptr) :: label_w

    label_w = gtk_widget_get_first_child(widget)
    if (.not. c_associated(label_w)) then
       write(error_unit, *) &
            & "ERROR: hl_gtk_bin_set_label_markup: specified widget does not have a label"
       return
    end if

    call gtk_label_set_markup(label_w, label)

  end subroutine hl_gtk_bin_set_label_markup

  !+
  function hl_gtk_separator_new(vertical) result(spacer)
    type(c_ptr) :: spacer
    integer(c_int), intent(in), optional :: vertical

    ! A Version-independent separator.
    !
    ! HORIZONTAL |  boolean  |  optional  |  Set to TRUE to make a vertical separator.
    !-

    integer(c_int) :: direction

    if (present(vertical)) then
       if (c_f_logical(vertical)) then
          direction = GTK_ORIENTATION_VERTICAL
       else
          direction = GTK_ORIENTATION_HORIZONTAL
       end if
    else
       direction = GTK_ORIENTATION_HORIZONTAL
    end if
    spacer = gtk_separator_new(direction)

  end function hl_gtk_separator_new
end module gtk_hl_misc

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 2020-06-09 (GTK 4), 2022-05-06
!
! Based on the C example given in"
! https://www.linuxquestions.org/linux/articles/Technical/New_GTK_Widgets_GtkAssistant
!------------------------------------------------------------------------------

module as_handlers
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_progress
  use gtk_hl_entry
  use gtk_hl_assistant
  use gtk_sup
  use, intrinsic :: iso_c_binding

  !********************************
  ! Gtk modules for hl_assistant.f90
  !********************************
  use g, only: g_usleep, g_main_loop_new, g_main_loop_quit, &
             & g_main_loop_run, g_main_context_iteration, &
             & g_main_context_pending
  use gtk, only: gtk_entry_get_buffer, gtk_entry_buffer_get_text, &
       & gtk_label_new, &
       & gtk_check_button_get_active, gtk_window_destroy, &
       & gtk_widget_set_sensitive, gtk_widget_show, gtk_init, TRUE, FALSE, &
       & GTK_ASSISTANT_PAGE_CONTENT, GTK_ASSISTANT_PAGE_INTRO, &
       & GTK_ASSISTANT_PAGE_CONFIRM, GTK_ASSISTANT_PAGE_PROGRESS, &
       & gtk_widget_set_halign, gtk_widget_set_valign, gtk_widget_set_hexpand,&
       & gtk_widget_set_vexpand, GTK_ALIGN_CENTER, GTK_ALIGN_FILL

  implicit none
  type(c_ptr) :: my_gmainloop
  type(c_ptr) :: asstnt

contains
  subroutine destroy_asstnt(widget, gdata) bind(c)
    type(c_ptr), value :: widget, gdata

    print *, "Exit called"
    call g_main_loop_quit(my_gmainloop)
  end subroutine destroy_asstnt

  subroutine asstnt_close(widget, gdata) bind(c)
    type(c_ptr), value :: widget, gdata

    print *, "Completed"
    call gtk_window_destroy(widget)
  end subroutine asstnt_close

  subroutine name_enter(widget, data) bind(c)
    type(c_ptr), value :: widget, data
    type(c_ptr) :: buffer
    type(c_ptr) :: page, ebox
    character(:), allocatable :: ftext

    if (c_associated(data)) then
       ebox = data
    else
       ebox = widget
    end if

     buffer = gtk_entry_get_buffer(ebox)
    call c_f_string_copy_alloc(gtk_entry_buffer_get_text(buffer), ftext)
    print *, "Entered name as: ", ftext

    page = hl_gtk_assistant_get_current_page(asstnt)
    call hl_gtk_assistant_set_page_complete(asstnt, &
         & f_c_logical(len(ftext) > 0))
  end subroutine name_enter

  subroutine check_tog(widget, data) bind(c)
    type(c_ptr), value :: widget, data

    call hl_gtk_assistant_set_page_complete(asstnt, &
         & gtk_check_button_get_active(widget))
  end subroutine check_tog

  subroutine start_pb(widget, data) bind(c)
    type(c_ptr), value :: widget, data

    integer(c_int) :: i, iev
    type(c_ptr) :: page

    call gtk_widget_set_sensitive(widget, FALSE)

    page = hl_gtk_assistant_get_current_page(asstnt)
    do i = 1, 10
       do
          if (.not. c_f_logical(g_main_context_pending(c_null_ptr))) exit
          iev = g_main_context_iteration(c_null_ptr, FALSE)
       end do

       call g_usleep(500000_c_long)
       call hl_gtk_progress_bar_set(data, i, 10_c_int, string=TRUE)
    end do
    call hl_gtk_assistant_set_page_complete(asstnt, TRUE)

  end subroutine start_pb
end module as_handlers

program hl_assistant

  use as_handlers

  implicit none
  type(c_ptr) :: junk, jb, ebox, pbar

  call gtk_init()

  asstnt = hl_gtk_assistant_new(title="GtkAssistant Example"//c_null_char, &
       & destroy=c_funloc(destroy_asstnt), wsize=[450_c_int, 300_c_int], &
       & close=c_funloc(asstnt_close))

  ! Intro page
  junk = gtk_label_new("This is an example of a GtkAssistant"//c_new_line// &
       & "by clicking the forward button,"//c_new_line// &
       & " you can continue to the next section!"//c_null_char)

  call hl_gtk_assistant_add_page(asstnt, junk, GTK_ASSISTANT_PAGE_INTRO, &
       & page_title="Introduction"//c_null_char)

  ! Name entry
  jb = hl_gtk_box_new(horizontal=TRUE, spacing=5_c_int)
  call gtk_widget_set_halign (jb, GTK_ALIGN_FILL)
  call gtk_widget_set_valign (jb, GTK_ALIGN_CENTER)
  call gtk_widget_set_hexpand (jb, TRUE)
  call gtk_widget_set_vexpand (jb, FALSE)

  junk = gtk_label_new("Your name:"//c_null_char)
  call hl_gtk_box_pack(jb, junk, expand=FALSE)

  ebox = hl_gtk_entry_new(editable=TRUE, activate=c_funloc(name_enter))
  call hl_gtk_box_pack(jb, ebox)

  junk = hl_gtk_button_new("Apply"//c_null_char, clicked=c_funloc(name_enter), &
       & data=ebox)
  call hl_gtk_box_pack(jb, junk, expand=FALSE)

  call hl_gtk_assistant_add_page(asstnt, jb, GTK_ASSISTANT_PAGE_CONTENT)

  ! Check button
  junk = hl_gtk_check_button_new("Click to continue"//c_null_char, &
       &toggled = c_funloc(check_tog))
  call hl_gtk_assistant_add_page(asstnt, junk, GTK_ASSISTANT_PAGE_CONTENT, &
       & page_title="Click the Check Button"//c_null_char)

  ! Progress
  jb = hl_gtk_box_new(horizontal=TRUE)
  call gtk_widget_set_halign (jb, GTK_ALIGN_FILL)
  call gtk_widget_set_valign (jb, GTK_ALIGN_CENTER)
  call gtk_widget_set_hexpand (jb, TRUE)
  call gtk_widget_set_vexpand (jb, FALSE)

  pbar = hl_gtk_progress_bar_new()
  call hl_gtk_box_pack(jb, pbar)

  junk = hl_gtk_button_new("Click to start"//c_null_char, &
       & clicked=c_funloc(start_pb), data=pbar)
  call hl_gtk_box_pack(jb, junk, expand=false)
  call hl_gtk_assistant_add_page(asstnt, jb, GTK_ASSISTANT_PAGE_PROGRESS, &
       & page_title="Applying"//c_null_char)

  ! Confirmation page
  junk = gtk_label_new ("Text has been entered in the label and"//c_new_line// &
       & "the combo box is clicked. If you are done, then"//c_new_line// &
       & "it is time to leave!"//c_null_char)
  call hl_gtk_assistant_add_page(asstnt, junk, GTK_ASSISTANT_PAGE_CONFIRM, &
       & page_title = "Completed?"//c_null_char)

  call gtk_widget_show(asstnt)

  ! Event loop
  my_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
  call g_main_loop_run(my_gmainloop)

end program hl_assistant

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by Jens Hunger, vmagnin
! Last modifications: vmagnin 2020-05-28, 2022-07-20

module widgets
  use, intrinsic :: iso_c_binding

  implicit none
  type(c_ptr) :: mainwindow
  type(c_ptr) :: button
  type(c_ptr) :: table
  type(c_ptr) :: notebook_1, notebook_2
  type(c_ptr) :: frame
  type(c_ptr) :: label
  type(c_ptr) :: checkbutton
end module


module handlers
  use, intrinsic :: iso_c_binding

  use gtk, only: gtk_window_set_title, gtk_notebook_popup_enable, &
  & g_signal_connect, g_signal_connect_swapped, gtk_notebook_set_scrollable, &
  & gtk_window_destroy, gtk_widget_show, gtk_application_window_new, &
  & FALSE, TRUE, GTK_POS_TOP, &
  & gtk_button_new, gtk_button_new_with_label, &
  & gtk_check_button_new, gtk_check_button_new_with_label, &
  & gtk_window_set_child, gtk_frame_set_child, &
  & gtk_frame_new, gtk_label_new, gtk_notebook_append_page, &
  & gtk_notebook_get_current_page, gtk_notebook_get_n_pages, &
  & gtk_notebook_get_show_border, &
  & gtk_notebook_get_show_tabs, gtk_notebook_get_tab_pos, &
  & gtk_notebook_insert_page, gtk_notebook_new, gtk_notebook_next_page, &
  & gtk_notebook_prepend_page, gtk_notebook_prev_page, &
  & gtk_notebook_remove_page, &
  & gtk_notebook_set_current_page, gtk_notebook_set_show_border, &
  & gtk_notebook_set_show_tabs, gtk_notebook_set_tab_detachable, &
  & gtk_notebook_set_tab_pos, &
  & gtk_notebook_set_tab_reorderable, gtk_grid_attach, &
  & gtk_grid_new, gtk_widget_queue_draw, gtk_widget_set_size_request, &
  & gtk_notebook_set_group_name, gtk_notebook_get_group_name, &
  & gtk_widget_set_margin_start, gtk_widget_set_margin_end, &
  & gtk_widget_set_margin_top, gtk_widget_set_margin_bottom

  use gtk_sup, only: convert_c_string_scalar

  use widgets

  implicit none

contains
  !*************************************
  ! User defined event handlers go here
  !*************************************

  ! Next page
  subroutine next_page_book(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_notebook_get_current_page(notebook_1) == gtk_notebook_get_n_pages(notebook_1) - 1) then
      call gtk_notebook_set_current_page(notebook_1, 0_c_int)
    else
      call gtk_notebook_next_page(notebook_1)
    endif
  end subroutine next_page_book

  ! Previous page
  subroutine prev_page_book(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_notebook_get_current_page(notebook_1) == 0) then
      call gtk_notebook_set_current_page(notebook_1, -1_c_int)
    else
      call gtk_notebook_prev_page(notebook_1)
    endif
  end subroutine prev_page_book

  ! Rotate the position of the tabs
  subroutine rotate_book(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call gtk_notebook_set_tab_pos(notebook_1, gtk_notebook_get_tab_pos(notebook_1) + 1_c_int)
  end subroutine rotate_book

  ! Add/Remove the page tabs and the borders of notebook 1:
  subroutine tabsborder_book(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    if (gtk_notebook_get_show_tabs(notebook_1) == FALSE) then
      call gtk_notebook_set_show_tabs(notebook_1, TRUE)
    else
      call gtk_notebook_set_show_tabs(notebook_1, FALSE)
    end if

    if (gtk_notebook_get_show_border(notebook_1) == FALSE) then
      call gtk_notebook_set_show_border(notebook_1, TRUE)
    else
      call gtk_notebook_set_show_border(notebook_1, FALSE)
    end if
  end subroutine tabsborder_book

  ! Remove a page from the notebook
  subroutine remove_book(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    integer(c_int) :: page

    page = gtk_notebook_get_current_page(notebook_1)

    if (page >= 0) then
      call gtk_notebook_remove_page(notebook_1, page)
      ! Need to refresh the widget -- This forces the widget to redraw itself.
      call gtk_widget_queue_draw(notebook_1)
    end if
  end subroutine remove_book

  ! Callback function for the signal "activate" emitted by g_application_run().
  ! We use a subroutine because it should return void.
  ! The GUI is defined here.
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointer toward our GTK window
    type(c_ptr) :: mainwindow
    ! Other variables
    integer :: i
    ! A string version of the i counter:
    character(kind=c_char, len=12) :: istr
    integer(c_int) :: nb
    character(kind=c_char), dimension(:), pointer :: textptr
    character(len=512) :: my_string

    ! Create the window:
    mainwindow = gtk_application_window_new(app)
    ! Don't forget that C strings must end with a null char:
    call gtk_window_set_title(mainwindow, "Notebooks Example"//c_null_char)

    !******************************************************************
    ! Adding widgets in the window:
    !******************************************************************
    ! Container for notebook
    table = gtk_grid_new()
    ! Set the border width (10 pixels) around the container:
    call gtk_widget_set_margin_start(table, 10_c_int)
    call gtk_widget_set_margin_end(table, 10_c_int)
    call gtk_widget_set_margin_top(table, 10_c_int)
    call gtk_widget_set_margin_bottom(table, 10_c_int)

    call gtk_window_set_child(mainwindow, table)

    ! Create a new notebook, place the position of the tabs
    ! https://docs.gtk.org/gtk4/class.Notebook.html
    notebook_1 = gtk_notebook_new()
    call gtk_notebook_set_tab_pos(notebook_1, GTK_POS_TOP)
    call gtk_grid_attach(table, notebook_1, 0_c_int, 0_c_int, 6_c_int, 1_c_int)

    ! Attach notebook to group, necessary to enable drag and drop
    ! between the two notebooks
    call gtk_notebook_set_group_name(notebook_1,"group"//c_null_char)
    call c_f_pointer(gtk_notebook_get_group_name(notebook_1), textptr, [64])
    call convert_c_string_scalar(textptr, my_string)
    print *, "group name = <"//trim(my_string)//">"

    !append a bunch of pages to the notebook
    do i = 1, 3
      write(istr,*) i

      frame = gtk_frame_new("Append Frame "//trim(adjustl(istr))//c_null_char)
      ! Set the border width (10 pixels) around the frame:
      call gtk_widget_set_margin_start(frame, 10_c_int)
      call gtk_widget_set_margin_end(frame, 10_c_int)
      call gtk_widget_set_margin_top(frame, 10_c_int)
      call gtk_widget_set_margin_bottom(frame, 10_c_int)

      call gtk_widget_set_size_request(frame, 100_c_int, 75_c_int)

      label = gtk_label_new("Append Frame "//trim(adjustl(istr))//c_null_char)
      call gtk_frame_set_child(frame, label)

      label = gtk_label_new("Page "//trim(adjustl(istr))//c_null_char)
      nb = gtk_notebook_append_page(notebook_1, frame, label)
      call gtk_notebook_set_tab_reorderable(notebook_1, frame, TRUE)
      call gtk_notebook_set_tab_detachable(notebook_1, frame, TRUE)
    end do

    call gtk_notebook_popup_enable(notebook_1)
    call gtk_notebook_set_scrollable(notebook_1, TRUE)

    ! Add a page to a specific spot
    checkbutton = gtk_check_button_new_with_label("Check me please!"//c_null_char)
    call gtk_widget_set_size_request(checkbutton, 20_c_int, 75_c_int)

    label = gtk_label_new("Add page"//c_null_char)
    nb = gtk_notebook_insert_page(notebook_1, checkbutton, label, 2_c_int)
    call gtk_notebook_set_tab_reorderable(notebook_1, checkbutton, TRUE)
    call gtk_notebook_set_tab_detachable(notebook_1, checkbutton, TRUE)

    ! Prepend pages to the notebook
    do i = 1, 3
      write(istr,*) i

      frame = gtk_frame_new("Prepend Frame "//trim(adjustl(istr))//c_null_char)
      ! Set the border width (10 pixels) around the frame:
      call gtk_widget_set_margin_start(frame, 10_c_int)
      call gtk_widget_set_margin_end(frame, 10_c_int)
      call gtk_widget_set_margin_top(frame, 10_c_int)
      call gtk_widget_set_margin_bottom(frame, 10_c_int)

      call gtk_widget_set_size_request(frame, 100_c_int, 75_c_int)

      label = gtk_label_new("Prepend Frame "//trim(adjustl(istr))//c_null_char)
      call gtk_frame_set_child(frame, label)

      label = gtk_label_new("PPage "//trim(adjustl(istr))//c_null_char)
      nb = gtk_notebook_prepend_page(notebook_1, frame, label)
      call gtk_notebook_set_tab_reorderable(notebook_1, frame, TRUE)
      call gtk_notebook_set_tab_detachable(notebook_1, frame, TRUE)
    end do

    ! Set what page to start at (page 4)
    call gtk_notebook_set_current_page(notebook_1, 4_c_int)

    ! Create a bunch of buttons
    button = gtk_button_new_with_label("close"//c_null_char)
    ! Here the gtk_window_destroy() function will be applied
    ! to the window instead of the 'close' button:
    call g_signal_connect_swapped(button, "clicked"//c_null_char, &
                                & c_funloc(gtk_window_destroy), mainwindow)

    call gtk_grid_attach(table, button, 0_c_int, 1_c_int, 1_c_int, 1_c_int)

    button = gtk_button_new_with_label("next page"//c_null_char)
    call g_signal_connect(button, "clicked"//c_null_char, c_funloc(next_page_book))
    call gtk_grid_attach(table, button, 1_c_int, 1_c_int, 1_c_int, 1_c_int)

    button = gtk_button_new_with_label("prev page"//c_null_char)
    call g_signal_connect(button, "clicked"//c_null_char, c_funloc(prev_page_book))
    call gtk_grid_attach(table, button, 2_c_int, 1_c_int, 1_c_int, 1_c_int)

    button = gtk_button_new_with_label("tab position"//c_null_char)
    call g_signal_connect(button, "clicked"//c_null_char, c_funloc(rotate_book))
    call gtk_grid_attach(table, button, 3_c_int, 1_c_int, 1_c_int, 1_c_int)

    button = gtk_button_new_with_label("tabs/border on/off"//c_null_char)
    call g_signal_connect(button, "clicked"//c_null_char, c_funloc(tabsborder_book))
    call gtk_grid_attach(table, button, 4_c_int, 1_c_int, 1_c_int, 1_c_int)

    button = gtk_button_new_with_label("remove page"//c_null_char)
    call g_signal_connect(button, "clicked"//c_null_char, c_funloc(remove_book))
    call gtk_grid_attach(table, button, 5_c_int, 1_c_int, 1_c_int, 1_c_int)

    ! Create second notebook, place the position of the tabs
    notebook_2 = gtk_notebook_new()
    call gtk_notebook_set_tab_pos(notebook_2, GTK_POS_TOP)
    call gtk_grid_attach(table, notebook_2, 0_c_int, 2_c_int, 6_c_int, 1_c_int)

    ! Attach notebook to group, necessary to enable drag and drop
    ! between the two notebooks
    call gtk_notebook_set_group_name(notebook_2,"group"//c_null_char)

    ! Append a bunch of pages to the second notebook
    do i = 1, 3
      write(istr,*) i

      frame = gtk_frame_new("Notebook 2 - Frame "//trim(adjustl(istr))//c_null_char)
      ! Set the border width (10 pixels) around the frame:
      call gtk_widget_set_margin_start(frame, 10_c_int)
      call gtk_widget_set_margin_end(frame, 10_c_int)
      call gtk_widget_set_margin_top(frame, 10_c_int)
      call gtk_widget_set_margin_bottom(frame, 10_c_int)

      call gtk_widget_set_size_request(frame, 100_c_int, 75_c_int)

      label = gtk_label_new("Notebook 2 - Frame "//trim(adjustl(istr))//c_null_char)
      call gtk_frame_set_child(frame, label)

      label = gtk_label_new("Notebook 2 - Page "//trim(adjustl(istr))//c_null_char)
      nb = gtk_notebook_append_page(notebook_2, frame, label)
      call gtk_notebook_set_tab_reorderable(notebook_2, frame, TRUE)
      call gtk_notebook_set_tab_detachable(notebook_2, frame, TRUE)
    end do

    call gtk_notebook_popup_enable(notebook_2)
    call gtk_notebook_set_scrollable(notebook_2, TRUE)

    ! If you don't show it, nothing will appear on screen...
    call gtk_widget_show(mainwindow)

  end subroutine activate
end module handlers

!*******************************************************************************
! In the main program, we declare the GTK application, connect it to its
! "activate" function where we will create the GUI,
! and finally call the GLib main loop.
!*******************************************************************************
program notebooks
  use, intrinsic :: iso_c_binding
  ! We will use those GTK functions and values. The "only" statement can improve
  ! significantly the compilation time:
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers

  implicit none
  integer(c_int) :: status
  type(c_ptr)    :: app

  ! First, let's create a GTK application (it will initialize GTK).
  ! The application ID must contain at least one point:
  ! https://docs.gtk.org/gio/type_func.Application.id_is_valid.html
  app = gtk_application_new("gtk-fortran.examples.notebooks"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  ! The activate signal will be sent by g_application_run().
  ! The c_funloc() function returns the C address of the callback function.
  ! The c_null_ptr means no data is transfered to the callback function.
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  ! Now, the whole application will be managed by GLib (=> main loop).
  ! Note that commandline arguments argc, argv are not passed.
  ! https://docs.gtk.org/gio/method.Application.run.html
  status = g_application_run(app, 0_c_int, [c_null_ptr])

  print *, "You have exited the GLib main loop, bye, bye..."

  ! Memory is freed:
  call g_object_unref(app)
end program notebooks

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
! -----------------------------------------------------------------------------
! Contributed by James Tappin
! Some code derived from a demo program by "tadeboro" posted on the gtk forums.
! Last modifications: 2013-01-31, vmagnin 2020-06-17 (GTK 4), 2022-03-29
! -----------------------------------------------------------------------------

!*
! gtk_draw_hl
module gtk_draw_hl
  ! This module provides a high-level drawing interface which automatically
  ! handles redrawing on exposure, and bundles the most likely events to
  ! be needed.
  !
  ! Note:
  !
  ! This module has undergone a major rewrite which has considerably
  ! streamlined the code. To the ordinary user, the most noticable difference
  ! is that the backing image is now a cairo image surface rather than a
  ! GDK pixbuf. When using PLplot, the "memcairo" device is not readily usable
  ! any more (extcairo is now the only supported driver), however
  ! cumulative plotting (e.g. PLplot's strip charts) now
  ! works correctly.
  !
  ! **Routine list:**
  !
  ! * hl_gtk_drawing_area_new; Create the drawing area.
  ! * hl_gtk_drawing_area_get_surface; Get the backing cairo surface
  ! * hl_gtk_drawing_area_get_gdk_pixbuf; Get the contents to a GdkPixbuf
  ! * hl_gtk_drawing_area_expose_cb; Default callback for expose events.
  ! * hl_gtk_drawing_area_destroy_cb; Default callback for destroy signal
  ! * hl_gtk_drawing_area_resize_cb; Default callback for resize signal
  ! * hl_gtk_drawing_area_cairo_new; Create a cairo context attached to the
  ! backing surface.
  ! * hl_gtk_drawing_area_resize: Resize the drawing area and the backing
  ! surface
  ! * hl_gtk_drawing_area_cairo_destroy; Destroy the context.
  !/

  !********************************
  ! Gtk modules for gtk-draw-hl.f90
  !********************************
  use cairo, only: cairo_create, cairo_destroy, cairo_get_target, &
       & cairo_image_surface_create, cairo_image_surface_get_data, &
       & cairo_image_surface_get_format, cairo_image_surface_get_height, &
       & cairo_image_surface_get_stride, cairo_image_surface_get_width, &
       & cairo_paint, cairo_set_source_surface, cairo_surface_destroy, &
       & cairo_surface_get_reference_count, cairo_surface_get_type, &
       & cairo_surface_reference, cairo_surface_status, cairo_status_to_string

  use g, only: g_object_get_data, g_object_set_data

  use gdk, only: gdk_pixbuf_get_from_surface, gdk_cairo_set_source_pixbuf

  use gtk, only: gtk_drawing_area_new, gtk_scrolled_window_set_child, &
       & gtk_scrolled_window_new, gtk_scrolled_window_set_policy, &
       & gtk_widget_get_allocation, gtk_widget_set_can_focus, &
       & gtk_widget_set_size_request, gtk_widget_set_tooltip_text, &
       & g_signal_connect, gtk_widget_queue_draw, &
       & gtk_widget_get_realized, gtk_drawing_area_set_draw_func, &
       & TRUE, FALSE, &
       & CAIRO_FORMAT_ARGB32, &
       & CAIRO_FORMAT_RGB24, CAIRO_STATUS_SUCCESS, &
       & GTK_POLICY_AUTOMATIC, &
       & gtk_gesture_click_new, gtk_widget_add_controller, &
       & gtk_event_controller_motion_new, &
       & gtk_gesture_single_set_button, gtk_event_controller_scroll_new, &
       & gtk_event_controller_key_new, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL, &
       & gtk_widget_set_focusable

  use gtk_sup

  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only: error_unit

  implicit none
  type, bind(c) :: gtkallocation
     integer(c_int) :: x,y,width,height
  end type gtkallocation

contains

  !+
  function hl_gtk_drawing_area_new(scroll, size, ssize, expose_event, &
       & data_expose, button_press_event, data_button_press, &
       & button_release_event, data_button_release, scroll_event, &
       & data_scroll, motion_event, data_motion, realize, data_realize, &
       & configure_event, data_configure, key_press_event, data_key_press, &
       & key_release_event, data_key_release, enter_event, data_enter, &
       & leave_event, data_leave, destroy, data_destroy, &
       & tooltip, has_alpha, size_allocate, data_size_allocate, &
       & cairo_status, hscroll_policy, vscroll_policy) result(plota)

    type(c_ptr) :: plota
    type(c_ptr), intent(out), optional :: scroll
    integer(c_int), intent(in), optional, dimension(2) :: size, ssize
    type(c_funptr), optional :: expose_event, button_press_event, &
         & button_release_event, scroll_event, key_press_event, &
         & key_release_event, motion_event, realize, configure_event,&
         & enter_event, leave_event, destroy, size_allocate
    type(c_ptr), intent(in), optional :: data_expose, data_button_press, &
         & data_button_release, data_scroll, data_motion, data_realize, &
         & data_configure, data_key_press, data_key_release, data_enter, &
         & data_leave, data_destroy, data_size_allocate
    character(kind=c_char), dimension(*), optional, intent(in) :: tooltip
    integer(c_int), intent(in), optional :: has_alpha
    integer(c_int), intent(out), optional :: cairo_status
    integer(c_int), intent(in), optional :: hscroll_policy, vscroll_policy

    ! A high-level drawing area
    !
    ! SCROLL |  c_ptr |  optional |  If present, then the drawing area will be placed in a scrollable window, whose pointer will be returned here. If it is present, then it rather than the drawable should be used for packing.
    ! SIZE |  c_int() |  optional |  The requested size for the area. If no size is given then a default size of 256x256 is used.
    ! SSIZE |  c_int() : |  optional |  The requested size for a scrolling window
    ! EXPOSE_EVENT |  c_funptr |  optional |  Callback for expose-event signal. **N.B.** In GTK 3 the signal is called "draw". If this is not given then a default handler is provided which copies the image surface to the drawing area.
    ! DATA_EXPOSE |  c_ptr |  optional |  Data for expose_event callback
    ! BUTTON_PRESS_EVENT |  c_funptr |  optional |  Callback for button-press-event signal
    ! DATA_BUTTON_PRESS |  c_ptr |  optional |  Data for button_press_event callback
    ! BUTTON_RELEASE_EVENT |  c_funptr |  optional |  Callback for button-release-event signal
    ! DATA_BUTTON_RELEASE |  c_ptr |  optional |  Data for button_release_event callback
    ! SCROLL_EVENT |  c_funptr |  optional |  Callback for scroll-event signal
    ! DATA_SCROLL |  c_ptr |  optional |  Data for scroll_event callback
    ! REALIZE |  c_funptr |  optional |  Callback for realize signal
    ! DATA_REALIZE |  c_ptr |  optional |  Data for realize callback
    ! CONFIGURE_EVENT | c_funptr |  optional |  Callback for configure-event signal
    ! DATA_CONFIGURE |  c_ptr |  optional |  Data for configure_event callback
    ! KEY_PRESS_EVENT |  c_funptr |  optional |  Callback for key-press-event signal
    ! DATA_KEY_PRESS |  c_ptr |  optional |  Data for key_press_event callback
    ! KEY_RELEASE_EVENT |  c_funptr |  optional |  Callback for key-release-event signal
    ! DATA_KEY_RELEASE |  c_ptr |  optional |  Data for key_release_event callback
    ! MOTION_EVENT |  c_funptr |  optional |  Callback for the motion-notify-event signal
    ! DATA_MOTION |  c_ptr |  optional |  Data for motion_event
    ! ENTER_EVENT |  c_funptr |  optional |  Callback for the enter-notify-event signal
    ! DATA_ENTER |  c_ptr |  optional |  Data for enter_event
    ! LEAVE_EVENT |  c_funptr |  optional |  Callback for the leave-notify-event signal
    ! DATA_LEAVE |  c_ptr |  optional |  Data for leave_event
    ! DESTROY |  c_funptr |  optional |  Callback when the widget is destroyed.
    ! DATA_DESTROY |  c_ptr |  optional |  Data to pass to the destroy callback.
    ! TOOLTIP |  string |  optional |  Tooltip for the drawing area.
    ! HAS_ALPHA |  boolean |  optional |  If a pixbuf is used, should it have an alpha (transparency) channel (default=FALSE)
    ! SIZE_ALLOCATE |  c_funptr |  optional |  Callback for the 'resize' signal ('size-allocate' in GTK 3).
    ! DATA_SIZE_ALLOCATE |  c_ptr |  optional |  Data for size_allocate.
    ! CAIRO_STATUS |  c_int |  optional |  Status code from the cairo surface.
    ! HSCROLL_POLICY |  int |  optional |  Horizontal scrolling policy for the containing scroll window (default AUTOMATIC).
    ! VSCROLL_POLICY |  int |  optional |  Vertical scrolling policy for the containing scroll window (default AUTOMATIC).
    !
    ! * If an explicit size is given then the drawing area cannot be made
    ! smaller than that by resizing the containing window
    !-

    type(c_ptr) :: isurface, cstat_cstr
    integer(c_int) :: s_type
    integer(c_int) :: szx, szy
    logical :: rgba
    integer(c_int) :: cstat, hpolicy, vpolicy
    character(len=120) :: cstat_fstr
    ! GtkEventControllers:
    type(c_ptr) :: controller_m, controller_s, controller_c, controller_k

    plota = gtk_drawing_area_new()
    if (present(size)) then
       call gtk_widget_set_size_request(plota, size(1), size(2))
       szx = size(1)
       szy = size(2)
    else
       call gtk_widget_set_size_request(plota, -1_c_int, -1_c_int)
       szx = 1   ! Negative values give a cairo error
       szy = 1
    end if

    ! Add it to a scrolling window if one is requested
    if (present(scroll)) then
       scroll = gtk_scrolled_window_new()
       if (present(hscroll_policy)) then
          hpolicy = hscroll_policy
       else
          hpolicy = GTK_POLICY_AUTOMATIC
       end if
       if (present(vscroll_policy)) then
          vpolicy = vscroll_policy
       else
          vpolicy = GTK_POLICY_AUTOMATIC
       end if
       call gtk_scrolled_window_set_policy(scroll, hpolicy, vpolicy)
       if (present(ssize)) &
            & call gtk_widget_set_size_request(scroll, ssize(1), ssize(2))
       call gtk_scrolled_window_set_child(scroll, plota)
    end if

    ! Create the backing surface
    if (present(has_alpha)) then
       rgba = c_f_logical(has_alpha)
    else
       rgba = .false.
    end if

    if (rgba) then
       s_type = CAIRO_FORMAT_ARGB32
    else
       s_type = CAIRO_FORMAT_RGB24
    end if
    isurface = cairo_image_surface_create(s_type, szx, szy)
    isurface = cairo_surface_reference(isurface)   ! Prevent accidental deletion
    call g_object_set_data(plota, "backing-surface"//c_null_char, isurface)

    ! Realize signal
    if (present(realize)) then
       if (present(data_realize)) then
          call g_signal_connect(plota, "realize"//c_null_char, realize, &
               & data_realize)
       else
          call g_signal_connect(plota, "realize"//c_null_char, realize)
       endif
    end if

    ! Destroy signal
    if (present(destroy)) then
       if (present(data_destroy)) then
          call g_signal_connect(plota, "destroy"//c_null_char, destroy, &
               & data_destroy)
       else
          call g_signal_connect(plota, "destroy"//c_null_char, destroy)
       end if
    else
       call g_signal_connect(plota, "destroy"//c_null_char, &
            & c_funloc(hl_gtk_drawing_area_destroy_cb))
    end if

    ! Size-allocate (resize) signal
    if (present(size_allocate)) then
       if (present(data_size_allocate)) then
          call g_signal_connect(plota, "resize"//c_null_char, &
               & size_allocate, data_size_allocate)
       else
          call g_signal_connect(plota, "resize"//c_null_char, &
               & size_allocate)
       end if
    else
       call g_signal_connect(plota, "resize"//c_null_char, &
            & c_funloc(hl_gtk_drawing_area_resize_cb))
    end if

    ! Expose event (GTK 4):
    if (present(expose_event)) then
       if (present(data_expose)) then
         call gtk_drawing_area_set_draw_func(plota, &
                           & expose_event, data_expose, c_null_funptr)
       else
         call gtk_drawing_area_set_draw_func(plota, &
                           & expose_event, c_null_ptr, c_null_funptr)
       endif
    else
      call gtk_drawing_area_set_draw_func(plota, &
         & c_funloc(hl_gtk_drawing_area_expose_cb), c_null_ptr, c_null_funptr)
    end if

    ! We need a gesture controller to detect mouse clicks:
    ! https://developer.gnome.org/gtk4/stable/GtkGestureClick.html
    ! https://developer.gnome.org/gtk4/stable/GtkWidget.html#gtk-widget-add-controller
    if (present(button_press_event).OR.present(button_release_event)) then
       controller_c = gtk_gesture_click_new()
       ! 0 to listen to all buttons (button 1 by default):
       call gtk_gesture_single_set_button (controller_c, 0_c_int)

       if (present(button_press_event)) then
         if (present(data_button_press)) then
           call g_signal_connect(controller_c, "pressed"//c_null_char, &
                               & button_press_event, data_button_press)
         else
           call g_signal_connect(controller_c, "pressed"//c_null_char, &
                               & button_press_event)
         endif
       end if

       if (present(button_release_event)) then
         if (present(data_button_release)) then
           call g_signal_connect(controller_c, "released"//c_null_char, &
                               & button_release_event, data_button_release)
         else
           call g_signal_connect(controller_c, "released"//c_null_char, &
                               & button_release_event)
         endif
       end if

       call gtk_widget_add_controller(plota, controller_c)
    end if

    ! And a controller for scrolling:
    ! https://developer.gnome.org/gtk4/stable/GtkEventControllerScroll.html
    if (present(scroll_event)) then
       controller_s = gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL)
       if (present(data_scroll)) then
         call g_signal_connect(controller_s, "scroll"//c_null_char, &
                             & scroll_event, data_scroll)
       else
         call g_signal_connect(controller_s, "scroll"//c_null_char, &
                             & scroll_event)
       endif
       call gtk_widget_add_controller(plota, controller_s)
    end if

    ! And a controller for key events:
    ! https://developer.gnome.org/gtk4/stable/GtkEventControllerKey.html
    if (present(key_press_event).or.present(key_release_event)) then
      controller_k = gtk_event_controller_key_new()
      call g_signal_connect(controller_k, "im-update"//c_null_char, &
               & c_funloc(im_update_event_h))

      if (present(key_press_event)) then
        if (present(data_key_press)) then
          call g_signal_connect(controller_k, "key-pressed"//c_null_char, &
               & key_press_event, data_key_press)
        else
          call g_signal_connect(controller_k, "key-pressed"//c_null_char, &
               & key_press_event)
        endif
      end if

      if (present(key_release_event)) then
        if (present(data_key_release)) then
          call g_signal_connect(controller_k, "key-released"//c_null_char, &
               & key_press_event, data_key_release)
        else
          call g_signal_connect(controller_k, "key-released"//c_null_char, &
               & key_press_event)
        endif
      endif

      call gtk_widget_add_controller(plota, controller_k)
      ! Note: For keyboard events, the drawing area must be able to
      ! accept input focus:
      call gtk_widget_set_focusable(plota, TRUE)
    end if

    ! And a controller to detect motion and know where is the mouse:
    ! https://developer.gnome.org/gtk4/stable/GtkEventControllerMotion.html
    if (present(motion_event).or.present(enter_event).or.present(leave_event)) then
      controller_m = gtk_event_controller_motion_new ()

      if (present(data_motion)) then
        call g_signal_connect(controller_m, "motion"//c_null_char, &
                            & motion_event, data_motion)
      else
        call g_signal_connect(controller_m, "motion"//c_null_char, &
                            & motion_event)
      endif

      ! Enter event
      if (present(data_enter)) then
        call g_signal_connect(controller_m, "enter"//c_null_char, &
             & enter_event, data_enter)
      else
        call g_signal_connect(controller_m, "enter"//c_null_char, &
             & enter_event)
      endif

      ! Leave event
      if (present(data_leave)) then
        call g_signal_connect(controller_m, "leave"//c_null_char, &
             & leave_event, data_leave)
      else
        call g_signal_connect(controller_m, "leave"//c_null_char, &
             & leave_event)
      endif

      call gtk_widget_add_controller(plota, controller_m)
    end if

    ! Configure event
    if (present(configure_event)) then
       if (present(data_configure)) then
          call g_signal_connect(plota, "configure-event"//c_null_char, &
               & configure_event,  data_configure)
       else
          call g_signal_connect(plota, "configure-event"//c_null_char, &
               & configure_event)
       endif
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(plota, tooltip)

    ! If we fail to create the cairo surface we need to warn the user.
    ! Cairo does not generate error messages, just a propagated error state.

    if (present(cairo_status)) then
       cairo_status = cairo_surface_status(isurface)
    else
       cstat = cairo_surface_status(isurface)
       if (cstat /= CAIRO_STATUS_SUCCESS) then
          cstat_cstr = cairo_status_to_string(cstat)
          call c_f_string(cstat_cstr, cstat_fstr)
          write(error_unit, "(A)") &
               & "HL_GTK_DRAWING_AREA_NEW: Error creating backing store", &
               & trim(cstat_fstr)
       end if
    end if
  end function hl_gtk_drawing_area_new

  subroutine im_update_event_h(controller, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    print *, "im_update event detected"
  end subroutine im_update_event_h

  !+
  function hl_gtk_drawing_area_get_surface(area) result(isurface)
    type(c_ptr) :: isurface
    type(c_ptr), intent(in) :: area

    ! Convenience routine to get the backing surface of a drawing area.
    !
    ! AREA |  c_ptr |  required |  The drawing area whose surface is required.
    !-

    isurface = g_object_get_data(area, "backing-surface"//c_null_char)

  end function hl_gtk_drawing_area_get_surface

  !+
  function hl_gtk_drawing_area_get_gdk_pixbuf(area, x0, y0, xsize, ysize) &
       & result(pixb)
    type(c_ptr) :: pixb
    type(c_ptr), intent(in) :: area
    integer(c_int), intent(in), optional :: x0, y0, xsize, ysize

    ! Read a drawing area (strictly the cairo surface
    ! backing store) to a GDK pixbuf.
    !
    ! AREA |  c_ptr |  required |  The drawing area
    ! X0, Y0 |  c_int |  optional |  The origin of the area to return (defaults 0)
    ! XSIZE, YSIZE |  c_int |  optional |  The size of the region to return (defaults, from the origin to the top right of the surface).
    !-

    type(c_ptr) :: surface
    integer(c_int) :: nx, ny, rs, fmt, lpix
    integer(c_int) :: xorig, yorig, xrange, yrange

    if (present(x0)) then
       xorig = max(x0, 0)
    else
       xorig = 0
    end if
    if (present(y0)) then
       yorig = max(y0, 0)
    else
       yorig = 0
    end if
    surface = hl_gtk_drawing_area_get_surface(area)
    nx = cairo_image_surface_get_width(surface)
    ny = cairo_image_surface_get_height(surface)
    rs = cairo_image_surface_get_stride(surface)
    fmt = cairo_image_surface_get_format(surface)
    lpix = rs*(ny-1)+nx*4

    if (present(xsize)) then
       xrange = min(xsize, nx - xorig)
    else
       xrange = nx - xorig
    end if
    if (present(ysize)) then
       yrange = min(ysize, ny - yorig)
    else
       yrange = ny - yorig
    end if

    pixb = gdk_pixbuf_get_from_surface(surface, xorig, yorig, &
         & xrange, yrange)

  end function hl_gtk_drawing_area_get_gdk_pixbuf

  !+
  subroutine hl_gtk_drawing_area_draw_pixbuf(area, pixbuf, x, y)
    type(c_ptr), intent(in) :: area, pixbuf
    integer(c_int), intent(in), optional :: x, y

    ! Render a GdkPixbuf on a drawing area
    !
    ! AREA |  c_ptr |  required |  The drawing area.
    ! PIXBUF |  c_ptr |  required |  The pixbuf to draw.
    ! X, Y |  c_int |  optional |  The coordinate of the upper left corner of the pixbuf on the drawing area (defaults 0).
    !
    ! If you are rendering a pixbuf among other operations then just use
    ! gdk_cairo_set_source_pixbuf directly on the context with which you
    ! are working.
    !-

    type(c_ptr) :: cc
    real(c_double) :: xx, yy

    if (present(x)) then
       xx = real(x,c_double)
    else
       xx = 0._c_double
    end if
    if (present(y)) then
       yy = real(y, c_double)
    else
      yy = 0._c_double
    end if

    cc = hl_gtk_drawing_area_cairo_new(area)

    call gdk_cairo_set_source_pixbuf(cc, pixbuf, xx, yy)
    call cairo_paint(cc)

    call gtk_widget_queue_draw(area)
    call hl_gtk_drawing_area_cairo_destroy(cc)

  end subroutine hl_gtk_drawing_area_draw_pixbuf

  !+
  function hl_gtk_drawing_area_expose_cb(area, event, data) bind(c) &
       & result(rv)
    integer(c_int) :: rv
    type(c_ptr), value :: area, event, data

    ! Default callback for exposing a drawing area. For this to be connected
    ! no explicit expose callback should be specified.
    !
    ! AREA |  c_ptr |  required |  The drawing area
    ! EVENT |  c_ptr |  required |  event structure in GTK+2, a cairo context in GTK>=3
    ! DATA |  c_ptr |  required |  A pointer to user data (not used).
    !-

    type(c_ptr) :: cr, isurface

    rv = FALSE

    isurface = g_object_get_data(area, "backing-surface"//c_null_char)
    if (.not. c_associated(isurface)) then
       write(error_unit,*) &
            & 'hl_gtk_drawing_area_expose_cb: Backing surface is NULL'
       return
    end if

    ! Note for plplot users, this cairo context is a different one from
    ! the context used by plplot for the actual drawing.

    cr = event
    call cairo_set_source_surface(cr, isurface, 0._c_double, 0._c_double)
    call cairo_paint(cr)

  end function hl_gtk_drawing_area_expose_cb

  !+
  subroutine hl_gtk_drawing_area_destroy_cb(area, data) bind(c)
    type(c_ptr), value :: area, data

    ! Default callback for the destroy signal on the drawing area.
    ! Just destroys the backing surface.
    !
    ! AREA |  c_ptr |  required |  The drawing area being destroyed.
    ! DATA |  c_ptr |  required |  User data for the callback (not used)
    !-

    type(c_ptr) :: isurface

    isurface = g_object_get_data(area, "backing-surface"//c_null_char)
    if (c_associated(isurface)) call cairo_surface_destroy(isurface)

  end subroutine hl_gtk_drawing_area_destroy_cb

  !+
  subroutine hl_gtk_drawing_area_resize_cb(area, data) bind(c)
    type(c_ptr), value :: area, data

    ! Default call back for resizing the drawing area, just
    ! copies the old backing store to the new one
    !
    ! AREA |  c_ptr |  required |  The drawing area being destroyed.
    ! DATA |  c_ptr |  required |  User data for the callback (not used)
    !-

    call hl_gtk_drawing_area_resize(area, copy=.true.)
  end subroutine hl_gtk_drawing_area_resize_cb

  !+
  function hl_gtk_drawing_area_cairo_new(area) result(cr)
    type(c_ptr) :: cr
    type(c_ptr), intent(in) :: area

    ! Create a cairo context which will draw into the backing surface
    !
    ! AREA |  c_ptr |  required |  The drawing area to which we will draw.
    !
    ! After the drawing operations, you should call `gtk_widget_queue_draw`
    ! to update the plot on the screen and `hl_gtk_pixbuf_cairo_destroy`
    ! to destroy the cairo context.
    !-

    type(c_ptr) :: isurface

    isurface = g_object_get_data(area, "backing-surface"//c_null_char)
    if (.not. c_associated(isurface)) then
       cr = C_NULL_PTR
       write(error_unit,*) "hl_gtk_pixbuf_cairo_new:: Backing surface is NULL"
       return
    end if

    cr = cairo_create(isurface)

  end function hl_gtk_drawing_area_cairo_new

  !+
  subroutine hl_gtk_drawing_area_cairo_destroy(cr, destroy_surface)

    type(c_ptr), intent(inout) :: cr
    integer(c_int), intent(in), optional :: destroy_surface

    ! Update the backing surface and destroy the cairo context
    !
    ! CR |  c_ptr |  required |  The cairo context to put in the pixbuf
    ! DESTROY_SURFACE |  boolean  |  optional |  Set to TRUE to destroy the cairo_surface as well as the context. Normally the cairo surface is destroyed by the destroy callback of the drawing area, so does not need to be explicitly destroyed.
    !
    ! This is called following drawing operations to the context created by
    ! `hl_gtk_drawing_area_cairo_new`. N.B. This does not update the window,
    ! use gtk_widget_queue_draw to do that.
    !-

    type(c_ptr) :: isurface

    if (present(destroy_surface)) then
       if (destroy_surface == TRUE) then
          ! Get the cairo surface and destroy it
          isurface = cairo_get_target(cr)
          call cairo_surface_destroy(isurface)
       end if
    end if

    call cairo_destroy(cr)

  end subroutine hl_gtk_drawing_area_cairo_destroy

  !+
  subroutine hl_gtk_drawing_area_resize(area, size, copy)
    type(c_ptr), intent(in) :: area
    integer(c_int), intent(in), optional, dimension(2) :: size
    logical, optional, intent(in) :: copy

    ! Resize a drawing area and its backing store.
    !
    ! AREA |  c_ptr |  required |  The area to resize.
    ! SIZE |  int(2)  |  optional |  The new size, if omitted, then the backing store is resized to match the drawing area (e.g. after resizing the containing window).
    ! COPY |  logical |  optional |  Set to .true. to copy the surface contents to the new backing store.
    !-

    type(c_ptr) :: cback, cback_old, cr
    integer(c_int) :: szx, szy, s_type
    type(gtkallocation), target:: alloc
    logical :: copy_surface

    if (present(copy)) then
       copy_surface = copy
    else
       copy_surface = .false.
    end if

    ! If the SIZE keyword is present then resize the window
    if (present(size)) then
       call gtk_widget_set_size_request(area, size(1), size(2))
       szx = size(1)
       szy = size(2)
    endif

    ! Ensure that the allocation is up-to-date
    call gtk_widget_get_allocation(area,c_loc(alloc))
    szx = alloc%width
    szy = alloc%height

    ! Get the backing store and make a new one with the right type. Then
    ! make that into the backing store.
    cback_old = g_object_get_data(area, "backing-surface"//c_null_char)
    s_type = cairo_image_surface_get_format(cback_old)
    cback = cairo_image_surface_create(s_type, szx, szy)
    cback = cairo_surface_reference(cback)   ! Prevent accidental deletion
    call g_object_set_data(area, "backing-surface"//c_null_char, cback)

    ! If the copy keyword is set then make a copy from the old
    ! backing store to the new if the gdk surface is really there.
    if (copy_surface) then
       if (c_f_logical(gtk_widget_get_realized(area))) then
          cr = cairo_create(cback)
          call cairo_set_source_surface(cr, cback_old, &
               & 0._c_double, 0._c_double)
          call cairo_paint(cr)
          call cairo_destroy(cr)
       end if
    end if

    ! Ensure that the old backing store is fully dereferenced.
    do
       if (cairo_surface_get_reference_count(cback_old) <= 0) exit
       call cairo_surface_destroy(cback_old)
    end do

  end subroutine hl_gtk_drawing_area_resize

  !+
  subroutine hl_gtk_drawing_area_get_size(area, width, height)
    type(c_ptr), intent(in) :: area
    integer(c_int), intent(out), optional :: width, height

    ! Convenience routine to get the current size of a drawing area
    !
    ! AREA |  c_ptr |  required |  The drawing area whose size is needed.
    ! WIDTH |  c_int |  optional |  The width of the area.
    ! HEIGHT |  c_int |  optional |  The height of the area
    !-

    type(gtkallocation), target :: alloc

    call gtk_widget_get_allocation(area,c_loc(alloc))
    if (present(width)) width = alloc%width
    if (present(height)) height = alloc%height

  end subroutine hl_gtk_drawing_area_get_size

end module gtk_draw_hl

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by Vincent Magnin, Jerry DeLisle, "jtappin" and Tobias Burnus, 2011-01-23
! Last modification: 2022-09-29, 2023-03-10
!
! This module is needed for every gtk-fortran application. The gtkenums-auto.in
! and gtk-auto.in files are automatically included.
module gtk
  use, intrinsic :: iso_c_binding
  implicit none
  public :: FALSE, TRUE, gtk_init, function_g_signal_connect, &
            & g_signal_connect, function_g_signal_connect_swapped, &
            & g_signal_connect_swapped

  !**************************************************************************
  ! The enums automatically generated by cfwrapper.py are included here:
  include "gtkenums-auto.in"
  !**************************************************************************

  interface
    ! In GTK 4, the gtk_init() and gtk_init_check() functions no longer
    ! accept commandline arguments:
    !   void gtk_init (void);
    ! https://developer.gnome.org/gtk4/stable/gtk4-General.html#gtk-init
    ! https://developer.gnome.org/gtk4/3.98/ch31s02.html#id-1.6.4.4.36
    subroutine gtk_init() bind(c)
      implicit none
    end subroutine

    !**************************************************************************
    ! The interfaces automatically generated by cfwrapper.py are included here:
    include "gtk-auto.in"
    !**************************************************************************
  end interface

  ! We define the GLib FALSE and TRUE constants, which type is
  ! gboolean, which is gint, which corresponds to the standard C int.
  ! FALSE is defined as 0, all non-zero values in C evaluate to "true".
  ! https://developer.gnome.org/glib/stable/glib-Basic-Types.html#gboolean
  ! https://developer.gnome.org/glib/stable/glib-Basic-Types.html#gint
  ! https://developer.gnome.org/glib/stable/glib-Standard-Macros.html#TRUE:CAPS
  integer(c_int), parameter   :: FALSE = 0
  integer(c_int), parameter   :: TRUE = 1

contains
  ! For convenience, /usr/include/glib-2.0/gobject/gsignal.h defines a macro based
  ! on the g_signal_connect_data() function:
  ! #define g_signal_connect(instance, detailed_signal, c_handler, data) \
  !  g_signal_connect_data ((instance), (detailed_signal), (c_handler), (data), NULL, (GConnectFlags) 0)
  ! It returns the handler ID, of type #gulong (always greater than 0 for successful connections).
  ! https://developer.gnome.org/gobject/stable/gobject-Signals.html#g-signal-connect
  ! Historically, in gtk-fortran g_signal_connect() was declared as a subroutine, because the handler_id
  ! returned by the GLib function is usually never used. Here we define both a g_signal_connect()
  ! function and a subroutine. You will generally use the subroutine in your programs.

  function function_g_signal_connect (instance, detailed_signal, c_handler, data0) result(handler_id)
    use g, only: g_signal_connect_data

    type(c_ptr), intent(in)             :: instance
    character(kind=c_char), intent(in)  :: detailed_signal(*)
    type(c_funptr), intent(in)          :: c_handler
    type(c_ptr), optional, intent(in)   :: data0
    integer(c_long)                     :: handler_id

    if (present(data0)) then
      handler_id =  g_signal_connect_data (instance, detailed_signal, &
                     & c_handler, data0, c_null_funptr, 0_c_int)
    else
      handler_id =  g_signal_connect_data (instance, detailed_signal, &
                     & c_handler, c_null_ptr, c_null_funptr, 0_c_int)
    end if
  end function function_g_signal_connect

  subroutine g_signal_connect (instance, detailed_signal, c_handler, data0)
    type(c_ptr), intent(in)             :: instance
    character(kind=c_char), intent(in)  :: detailed_signal(*)
    type(c_funptr), intent(in)          :: c_handler
    type(c_ptr), optional, intent(in)   :: data0
    integer(c_long)                     :: handler_id

    handler_id = function_g_signal_connect (instance, detailed_signal, c_handler, data0)
  end subroutine g_signal_connect

  ! #define g_signal_connect_swapped(instance, detailed_signal, c_handler, data) \
  !  g_signal_connect_data ((instance), (detailed_signal), (c_handler), (data), NULL, G_CONNECT_SWAPPED)
  ! The instance on which the signal is emitted and data will be swapped when calling the handler.
  ! https://developer.gnome.org/gobject/stable/gobject-Signals.html#g-signal-connect-swapped
  ! We define both a g_signal_connect() function and a subroutine.
  ! You will generally use the subroutine in your programs.

  function function_g_signal_connect_swapped (instance, detailed_signal, c_handler, data0) result(handler_id)
    use g, only: g_signal_connect_data

    type(c_ptr), intent(in)             :: instance
    character(kind=c_char), intent(in)  :: detailed_signal(*)
    type(c_funptr), intent(in)          :: c_handler
    type(c_ptr), intent(in)             :: data0
    integer(c_long)                     :: handler_id

    handler_id =  g_signal_connect_data (instance, detailed_signal, &
                     & c_handler, data0, c_null_funptr, G_CONNECT_SWAPPED)
  end function function_g_signal_connect_swapped

  subroutine g_signal_connect_swapped (instance, detailed_signal, c_handler, data0)
    type(c_ptr), intent(in)             :: instance
    character(kind=c_char), intent(in)  :: detailed_signal(*)
    type(c_funptr), intent(in)          :: c_handler
    type(c_ptr), intent(in)             :: data0
    integer(c_long)                     :: handler_id

    handler_id = function_g_signal_connect_swapped (instance, detailed_signal, c_handler, data0)
  end subroutine g_signal_connect_swapped

end module gtk

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! GTK 4 version contributed by Vincent Magnin
! Last modification: vmagnin 2020-05-28, 2022-04-05

module handlers
  use, intrinsic :: iso_fortran_env, only: wp=>real64
  use, intrinsic :: iso_c_binding, only: c_int, c_ptr, c_null_ptr, c_null_funptr, &
                         & c_funloc, c_null_char, c_double, c_bool

  use gtk, only: gtk_application_window_new, gtk_drawing_area_new, &
  & gtk_drawing_area_set_content_width, gtk_drawing_area_set_content_height, &
  & gtk_drawing_area_set_draw_func, gtk_window_set_child, gtk_widget_show, &
  & gtk_window_set_default_size, gtk_window_set_title, FALSE, &
  & gtk_gesture_click_new, gtk_widget_add_controller, &
  & gtk_event_controller_get_widget, g_signal_connect, &
  & gtk_widget_get_width, gtk_widget_get_height, &
  & gtk_gesture_single_get_current_button, gtk_gesture_single_set_button, &
  & gtk_event_controller_scroll_new, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL, &
  & gtk_widget_queue_draw

  use cairo, only: cairo_arc, cairo_line_to, cairo_move_to, &
  & cairo_set_line_width, cairo_set_source_rgb, cairo_stroke, &
  & cairo_get_target, cairo_surface_write_to_png

  implicit none
  ! Circle radius:
  real(wp) :: radius = 100.0_wp

contains
  ! The GUI is defined here:
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    type(c_ptr)     :: window
    type(c_ptr)     :: my_drawing_area, controller, controller2
    integer(c_int)  :: width, height

    window = gtk_application_window_new(app)
    width  = 700
    height = 700
    call gtk_window_set_default_size(window, width, height)
    call gtk_window_set_title(window, "Click or scroll and I will tell you..."//c_null_char)

    my_drawing_area = gtk_drawing_area_new()
    call gtk_drawing_area_set_content_width(my_drawing_area, width)
    call gtk_drawing_area_set_content_height(my_drawing_area, height)
    call gtk_drawing_area_set_draw_func(my_drawing_area, &
                   & c_funloc(my_draw_function), c_null_ptr, c_null_funptr)

    ! We need a gesture controller to detect mouse clicks:
    ! https://developer.gnome.org/gtk4/stable/GtkGestureClick.html
    ! https://developer.gnome.org/gtk4/stable/GtkWidget.html#gtk-widget-add-controller
    controller = gtk_gesture_click_new()
    ! 0 to listen to all buttons (button 1 by default):
    call gtk_gesture_single_set_button (controller, 0_c_int)
    call g_signal_connect(controller, "pressed"//c_null_char, &
                                        & c_funloc(click_cb))
    call gtk_widget_add_controller(my_drawing_area, controller)

    ! And a controller for scrolling (modifies the circle radius):
    ! https://developer.gnome.org/gtk4/stable/GtkEventControllerScroll.html
    controller2 = gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL)
    call g_signal_connect(controller2, "scroll"//c_null_char, &
                                        & c_funloc(scroll_cb))
    call gtk_widget_add_controller(my_drawing_area, controller2)

    call gtk_window_set_child(window, my_drawing_area)
    call gtk_widget_show(window)
  end subroutine activate

  ! Click callback function ("pressed" signal):
  subroutine click_cb(gesture, n_press, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: gesture, gdata
    integer(c_int), value, intent(in) :: n_press
    real(c_double), value, intent(in) :: x, y
    type(c_ptr) :: widget
    integer(c_int) :: width, height
    real(wp) :: d

    print *, "Button ", gtk_gesture_single_get_current_button(gesture)

    widget = gtk_event_controller_get_widget(gesture)
    print *, n_press, " click(s) at ", int(x), int(y)

    width  = gtk_widget_get_width(widget)
    height = gtk_widget_get_height(widget)
    d = sqrt((x - width/2.0_wp)**2 + (y - height/2.0_wp)**2)
    print *, "Distance from the centre of the circle: ", d
  end subroutine click_cb

  ! Scroll callback function ("scroll" signal):
  subroutine scroll_cb(controller, x, y, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: controller, gdata
    real(c_double), value, intent(in) :: x, y
    type(c_ptr) :: widget

    radius = radius + y
    print *, "Scroll and new circle radius: ", x, y, radius
    ! We need to redraw the area:
    widget = gtk_event_controller_get_widget(controller)
    call gtk_widget_queue_draw(widget)
  end subroutine scroll_cb

  ! "It is called whenever GTK needs to draw the contents of the drawing area
  ! to the screen."
  ! https://developer.gnome.org/gtk4/stable/GtkDrawingArea.html#gtk-drawing-area-set-draw-func
  subroutine my_draw_function(widget, my_cairo_context, width, height, gdata) bind(c)
    type(c_ptr), value, intent(in)    :: widget, my_cairo_context, gdata
    integer(c_int), value, intent(in) :: width, height
    integer(c_int)                    :: cstatus
    integer                           :: t
    real(wp), parameter               :: pi = acos(-1.0_wp)

    print *, "draw"

    ! https://cairographics.org/manual/
    ! Note that Cairo numerical parameters are generally doubles.

    ! Horizontal and vertical thin blue lines:
    call cairo_set_source_rgb(my_cairo_context, 0d0, 0d0, 1d0)
    call cairo_set_line_width(my_cairo_context, 1d0)

    do t = 0, height, +100
      ! https://cairographics.org/manual/cairo-Paths.html#cairo-move-to
      call cairo_move_to(my_cairo_context, 0d0,       t*1d0)
      call cairo_line_to(my_cairo_context, width*1d0, t*1d0)
      call cairo_stroke(my_cairo_context)
    end do

    do t = 0, width, +100
      call cairo_move_to(my_cairo_context, t*1d0, 0d0)
      call cairo_line_to(my_cairo_context, t*1d0, height*1d0)
      call cairo_stroke(my_cairo_context)
    end do

    ! A thick red circle at the centre:
    call cairo_set_source_rgb(my_cairo_context, 1d0, 0d0, 0d0)
    call cairo_set_line_width(my_cairo_context, 5d0)
    call cairo_arc(my_cairo_context, width/2d0, height/2d0, radius, 0d0, 2*pi)
    call cairo_stroke(my_cairo_context)

    ! Save the image as a PNG
    ! https://cairographics.org/manual/cairo-PNG-Support.html#cairo-surface-write-to-png
    cstatus = cairo_surface_write_to_png(cairo_get_target(my_cairo_context), &
                                       & "cairo-basics-click.png"//c_null_char)
  end subroutine my_draw_function
end module handlers

! We create a GtkApplication:
program cairo_basics_click
  use, intrinsic :: iso_c_binding, only: c_int, c_ptr, c_funloc, c_null_char, c_null_ptr
  use gtk, only: gtk_application_new, g_signal_connect, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers, only: activate

  implicit none
  integer(c_int) :: exit_status
  type(c_ptr)    :: app

  app = gtk_application_new("gtk-fortran.examples.cairo-basics-click"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  exit_status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program cairo_basics_click

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modifications: vmagnin 2020-06-12 (GTK 4), 2020-07-15
!------------------------------------------------------------------------------

module ln_handlers
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_tree
  use gtk_hl_entry
  use gdk_pixbuf_hl

  use gtk, only: gtk_button_new, gtk_window_set_child, &
               & gtk_widget_show, gtk_window_destroy
  use g, only: g_object_set_property
  use gdk_pixbuf_hl

  implicit none
  ! The widgets. (Strictly only those that need to be accessed
  ! by the handlers need to go here).
  type(c_ptr) :: ihwin,ihscrollcontain,ihlist, base, qbut, lbl

contains
  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Exit called"
    call gtk_window_destroy(ihwin)
  end subroutine my_destroy

  subroutine list_select(list, gdata) bind(c)
    type(c_ptr), value, intent(in) :: list, gdata
    integer(c_int) :: nsel
    integer(c_int), dimension(:), allocatable :: selections
    real(c_double) :: x, x3
    integer(c_int64_t) :: n4
    real(c_float) :: nlog
    character(len=30) :: name
    character(len=10) :: nodd
    character :: code
    type(c_ptr) :: pixbuf
    integer(c_short), dimension(:,:,:), allocatable :: pixels

    nsel = hl_gtk_listn_get_selections(C_NULL_PTR, selections, list)
    if (nsel == 0) then
       print *, "No selection"
       return
    end if

    ! Find and print the selected row(s)
    print *, nsel,"Rows selected"
    print *, selections
    if (nsel == 1) then
       call hl_gtk_listn_get_cell(ihlist, selections(1), 0_c_int, svalue=name)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 1_c_int, dvalue=x)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 2_c_int, dvalue=x3)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 4_c_int, l64value=n4)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 3_c_int, fvalue=nlog)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 5_c_int, svalue=nodd)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 6_c_int, svalue=code)
       call hl_gtk_listn_get_cell(ihlist, selections(1), 8_c_int, &
            & pbvalue=pixbuf)
       call hl_gdk_pixbuf_get_pixels(pixbuf, pixels)
       print "('Row:',I3,' Name: ',a,' X:',F7.2,' 3X:',F7.2,' X**4:',I7,&
            &' log(n):',F7.5,' Odd?: ',a, ' Code:',a)", &
            & selections(1), trim(name), x, x3, n4, nlog, nodd, code
       print *, "Pixels: ", pixels(:,3,3)
    end if

    deallocate(selections)
  end subroutine list_select

  subroutine cell_edited(renderer, path, text, gdata) bind(c)
    type(c_ptr), value, intent(in) :: renderer, path, text, gdata

    ! Callback for edited cells.
    character(len=200) :: fpath, ftext
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    integer :: ios
    type(c_ptr) :: pcol, list
    real(c_double) :: x

    call convert_c_string(path, fpath)
    read(fpath, *) irow
    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)
    call convert_c_string(text, ftext)
    list = g_object_get_data(renderer, "view"//c_null_char)

    print *, "Edit in column", icol

    if (icol == 0) then
       call hl_gtk_listn_set_cell(list, irow, icol, &
            & svalue=trim(ftext))
    else
       read(ftext, *, iostat=ios) x
       if (ios /= 0) return
       call hl_gtk_listn_set_cell(ihlist, irow, 2_c_int, dvalue=3*x)
       call hl_gtk_listn_set_cell(ihlist, irow, 3_c_int, dvalue=log10(x))
       call hl_gtk_listn_set_cell(ihlist, irow, 4_c_int, &
            & l64value=int(x**4,c_int64_t))
       call hl_gtk_listn_set_cell(ihlist, irow, 5_c_int, &
            & ivalue=mod(int(x, c_int),2_c_int))
       call hl_gtk_listn_set_cell(ihlist, irow, 7_c_int, &
            & ivalue=mod(int(3*x, c_int),100_c_int))
       call hl_gtk_listn_set_cell(ihlist, irow, 1_c_int, dvalue=x)
    end if
  end subroutine cell_edited

  subroutine ccell_edit(renderer, path, text, gdata) bind(c)
    type(c_ptr), value, intent(in) :: renderer, path, text, gdata

    ! Basic callback to report what's called
    character(len=200) :: fpath, ftext
    integer(c_int) :: irow

    call c_f_string(path, fpath)
    call c_f_string(text, ftext)
    read(fpath, *) irow

    print *, "Combo sent edited signal from ", trim(fpath)
    print *, "Text was ", trim(ftext)
    call hl_gtk_listn_set_cell(ihlist, irow, 9_c_int, svalue=trim(ftext))

  end subroutine ccell_edit

  subroutine ccell_changed(renderer, path, iter, gdata) bind(c)
    type(c_ptr), value, intent(in) :: renderer, path, iter, gdata

    ! Basic callback to report what's called
    character(len=200) :: fpath

    call c_f_string(path, fpath)
    print *, "Combo sent changed signal from ", trim(fpath)

  end subroutine ccell_changed

  subroutine cell_clicked(renderer, path, gdata) bind(c)
    type(c_ptr), value, intent(in) :: renderer, path, gdata

    character(len=200) :: fpath
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    type(c_ptr) :: pcol, list
    logical :: state

    call convert_c_string(path, fpath)
    read(fpath, *) irow

    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)

    list = g_object_get_data(renderer, "view"//c_null_char)

    state = c_f_logical(gtk_cell_renderer_toggle_get_active(renderer))

    print *, "Changed state in row", irow, " to ", .not. state

    call hl_gtk_listn_set_cell(list, irow, icol, &
         & logvalue= .not. state)

  end subroutine cell_clicked

  subroutine rcell_clicked(renderer, path, gdata) bind(c)
    type(c_ptr), value, intent(in) :: renderer, path, gdata

    ! Default callback for a toggle button in a list
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! GDATA |  c_ptr |  required |  User data, Not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    ! This routine is not normally called by the application developer.
    !-
    character(len=200) :: fpath
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    integer(c_int) :: i
    type(c_ptr) :: pcol, list
    logical :: state
    integer(c_int) :: nrows

    call convert_c_string(path, fpath)
    read(fpath, *) irow

    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)

    list = g_object_get_data(renderer, "view"//c_null_char)

    state = c_f_logical(gtk_cell_renderer_toggle_get_active(renderer))
    print *, irow, state

    if (state) return ! Don't act on an unset

    ! Find the first iterator
    nrows = gtk_tree_model_iter_n_children (gtk_tree_view_get_model(list), &
         & c_null_ptr)
    do i = 0,nrows-1
       call hl_gtk_listn_set_cell(list, i, icol, &
            & logvalue= i == irow)
    end do
  end subroutine rcell_clicked

  subroutine display_dbl(col, cell, model, iter, data) bind(c)
    type(c_ptr), value, intent(in) :: col, cell, model, iter, data

    ! Formatting routine attached via hl_gtk_listn_set_cell_data_func
    ! Note that the column index is passed via the DATA argument, so
    ! far as I can see the only other way is to use constants.
    character(len=20) :: rstring
    real(c_double) :: dval
    type(gvalue), target :: dvalue, svalue
    type(c_ptr) :: val_ptr
    integer(c_int), pointer :: colno

    call c_f_pointer(data, colno)

    call gtk_tree_model_get_value(model, iter, colno, c_loc(dvalue))
    dval = g_value_get_double(c_loc(dvalue))

    write(rstring, "(f8.1)") dval

    val_ptr = c_loc(svalue)
    val_ptr = g_value_init(val_ptr, G_TYPE_STRING)

    call g_value_set_string(val_ptr, trim(rstring)//c_null_char)
    call g_object_set_property(cell, "text"//c_null_char, val_ptr)
  end subroutine display_dbl


  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    integer, parameter :: ncols = 11, nrows=10
    character(len=35) :: line
    integer(c_int) :: i, ltr
    integer(type_kind), dimension(ncols) :: ctypes
    character(len=20), dimension(ncols) :: titles, renderers
    integer(c_int), dimension(ncols) :: editable
    integer(c_int), dimension(ncols) :: widths
    integer(c_int), dimension(2), target :: fmt_col = [1, 2]
    integer(c_short), dimension(3, 100, 24) :: image
    integer(c_short), dimension(nrows) :: red, green, blue
    type(c_ptr) :: pixbuf

    red =   [0_c_short, 255_c_short, 255_c_short,   0_c_short,   0_c_short,&
            &0_c_short, 255_c_short, 255_c_short, 85_c_short, 170_c_short]
    green = [0_c_short, 255_c_short,   0_c_short, 255_c_short,   0_c_short,&
            &255_c_short,   0_c_short, 255_c_short, 85_c_short, 170_c_short]
    blue =  [0_c_short, 255_c_short,   0_c_short,   0_c_short, 255_c_short,&
            &255_c_short, 255_c_short,   0_c_short, 85_c_short, 170_c_short]

    ! Create the window:
    ihwin = gtk_application_window_new(app)
    call gtk_window_set_title(ihwin, "Renderers list demo"//c_null_char)

    ! Now make a column box & put it into the window
    base = hl_gtk_box_new()
    call gtk_window_set_child(ihwin, base)

    ! Now make a multi column list with multiple selections enabled
    ctypes = [ G_TYPE_STRING, G_TYPE_DOUBLE, G_TYPE_DOUBLE, G_TYPE_DOUBLE, &
         & G_TYPE_UINT64, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_INT,&
         & gdk_pixbuf_get_type(), G_TYPE_STRING , G_TYPE_BOOLEAN ]
    editable = [ TRUE, TRUE, FALSE, FALSE, FALSE, FALSE, TRUE, FALSE, &
         & FALSE, TRUE, TRUE ]
    widths = [-1, -1, -1, -1, -1, -1, -1, 150, -1, -1, -1]

    titles = [ character(len=20) :: "Name", "N", "3N", "Log(n)", &
         & "N**4", "Odd?", "Select?", "Fraction", "Colour", "Choose", "Pick" ]
    renderers = [ hl_gtk_cell_text, hl_gtk_cell_spin, hl_gtk_cell_text, &
         & hl_gtk_cell_text, hl_gtk_cell_text, hl_gtk_cell_text,&
         & hl_gtk_cell_toggle, hl_gtk_cell_progress, hl_gtk_cell_pixbuf, &
         & hl_gtk_cell_combo, hl_gtk_cell_radio ]

    ihlist = hl_gtk_listn_new(types=ctypes, &
         & changed=c_funloc(list_select),&
         & multiple=TRUE, titles=titles, width=widths, &
         & renderers=renderers, editable=editable, &
         & edited=c_funloc(cell_edited), toggled=c_funloc(cell_clicked), &
         & toggled_radio=c_funloc(rcell_clicked), &
         & edited_combo=c_funloc(ccell_edit), &
         & changed_combo=c_funloc(ccell_changed))

    call hl_gtk_listn_config_spin(ihlist, 1_c_int, vmax = huge(1._c_double), &
         & step = 0.1_c_double, digits=1_c_int)
    call hl_gtk_listn_config_combo(ihlist, 9_c_int, &
         & vals=['one  ', 'two  ', 'three'], &
         & has_entry=FALSE)

    do i = 1, size(fmt_col)
       call hl_gtk_listn_set_cell_data_func(ihlist, fmt_col(i), &
            & func=c_funloc(display_dbl), &
            & data=c_loc(fmt_col(i)))
    end do
    ! Now put <nrows> rows into it
    call hl_gtk_listn_ins(ihlist, count=nrows)
    do i=1,nrows
       write(line,"('List entry number ',I0)") i
       ltr=len_trim(line)+1
       line(ltr:ltr)=c_null_char
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 0_c_int, svalue=line)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 1_c_int, &
            & dvalue=real(i, c_double))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 2_c_int, &
            & dvalue=real(3*i, c_double))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 3_c_int, &
            & fvalue=log10(real(i)))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 4_c_int, &
            & l64value=int(i, c_int64_t)**4)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 5_c_int, &
            & ivalue=mod(i,2_c_int))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 6_c_int, &
            & logvalue=mod(i,3_c_int) == 0)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 7_c_int, &
            & ivalue=mod(3_c_int*i, 100_c_int))
       image(1,:,:) = red(i)
       image(2,:,:) = green(i)
       image(3,:,:) = blue(i)
       pixbuf = hl_gdk_pixbuf_new(image)
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 8_c_int, pbvalue=pixbuf)
       call hl_gtk_listn_combo_set_select(ihlist, i-1_c_int, 9_c_int, &
            & selection=mod(i,3_c_int))
       call hl_gtk_listn_set_cell(ihlist, i-1_c_int, 10_c_int, logvalue= i==4)
    end do

    ! It is the scrollcontainer that is placed into the box.
    call hl_gtk_box_pack(base, ihlist)

    ! Add a note about editable columns
    lbl = gtk_label_new('The "Name", "N" and "Select?" columns are editable'&
         &//c_null_char)
    call hl_gtk_box_pack(base, lbl)

    ! Also a quit button
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(base,qbut)

    ! realize the window
    call gtk_widget_show(ihwin)
    end subroutine activate
end module ln_handlers


program list_rend
  ! LIST_REND
  ! Demo of multi column list, with renderers
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use ln_handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_list_renderers"//c_null_char, &
                             & c_funloc(activate))
end program list_rend

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin
! Last modifications: 2012-12-31, vmagnin 2020-12-18
! https://developer.gnome.org/gtk4/stable/GtkDialog.html
!------------------------------------------------------------------------------
!*
! Dialog
module gtk_hl_dialog
  ! The message dialogue provided is here because, the built-in message
  ! dialogue GtkMessageDialog cannot be created without calling variadic
  ! functions which are not compatible with Fortran, therefore this is
  ! based around the plain GtkDialog family.
  !
  ! There are two functions provided, one; hl_gtk_message_dialog_new,
  ! just creates a dialogue and the other; hl_gtk_message_dialog_show,
  ! creates the dialogue and also displays it and returns the response.
  ! Unless you need to add other non-standard buttons to the dialogue
  ! it is easier to use  hl_gtk_message_dialog_show.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding

  ! autogenerated use's
  use gtk, only: g_signal_connect, &
       & gtk_about_dialog_new, gtk_about_dialog_set_artists, &
       & gtk_about_dialog_set_authors, gtk_about_dialog_set_comments, &
       & gtk_about_dialog_set_copyright, gtk_about_dialog_set_documenters, &
       & gtk_about_dialog_set_license, gtk_about_dialog_set_program_name, &
       & gtk_about_dialog_set_translator_credits, &
       & gtk_about_dialog_set_logo, &
       & gtk_about_dialog_set_version, gtk_about_dialog_set_website, &
       & gtk_about_dialog_set_website_label, gtk_box_append, &
       & gtk_box_new, gtk_about_dialog_set_license_type, &
       & gtk_dialog_add_button, gtk_dialog_get_content_area, gtk_dialog_new, &
       & gtk_image_new_from_icon_name, gtk_label_new, &
       & gtk_label_set_markup, gtk_window_destroy, gtk_widget_show, &
       & gtk_window_set_destroy_with_parent, gtk_window_set_modal, &
       & gtk_window_set_title, gtk_window_set_transient_for, TRUE, &
       & GTK_RESPONSE_NONE, GTK_RESPONSE_OK, GTK_RESPONSE_CANCEL, &
       & GTK_RESPONSE_CLOSE, GTK_RESPONSE_YES, GTK_RESPONSE_NO, &
       & GTK_MESSAGE_INFO, GTK_MESSAGE_WARNING, &
       & GTK_MESSAGE_QUESTION, GTK_MESSAGE_ERROR, GTK_MESSAGE_OTHER, &
       & GTK_BUTTONS_NONE, GTK_BUTTONS_OK, GTK_BUTTONS_CLOSE, &
       & GTK_ORIENTATION_HORIZONTAL,  GTK_ORIENTATION_VERTICAL, &
       & GTK_LICENSE_GPL_3_0, &
       & GTK_BUTTONS_CANCEL, GTK_BUTTONS_YES_NO, GTK_BUTTONS_OK_CANCEL, &
       & GTK_RESPONSE_DELETE_EVENT, &
       & gtk_image_set_icon_size, GTK_ICON_SIZE_LARGE

  use g, only: g_main_loop_new, g_main_loop_run, g_main_loop_quit

  implicit none
  integer(c_int) :: dialog_response
  type(c_ptr) :: dialog_gmainloop

contains

  !+
  function hl_gtk_message_dialog_new(message, button_set, title, type, &
       & parent) result(dialog)

    type(c_ptr) :: dialog
    character(len=*), dimension(:), intent(in) :: message
    integer(c_int), intent(in) :: button_set
    character(kind=c_char), dimension(*), intent(in), optional :: title
    integer(c_int), intent(in), optional :: type
    type(c_ptr), intent(in), optional :: parent

    ! A DIY version of the message dialogue, needed because both creators
    ! for the built in one are variadic and so not callable from Fortran.
    !
    ! MESSAGE |  string(n) |  required |  The message to display. Since this is a string array, the C_NULL_CHAR terminations are provided internally
    ! BUTTON_SET |  integer |  required |  The set of buttons to display
    ! TITLE |  string |  optional |  Title for the window.
    ! TYPE |  c_int |  optional |  Message type (a GTK_MESSAGE_ value)
    ! PARENT |  c_ptr |  optional |  An optional parent for the dialogue.
    !-

    type(c_ptr) :: content, junk, hb, vb
    integer :: i
    integer(c_int) :: itype

    ! Create the dialog window and make it modal.

    dialog=gtk_dialog_new()
    call gtk_window_set_modal(dialog, TRUE)
    if (present(title)) call gtk_window_set_title(dialog, title)

    if (present(parent)) then
       call gtk_window_set_transient_for(dialog, parent)
       call gtk_window_set_destroy_with_parent(dialog, TRUE)
    end if

    ! Get the content area and put the message in it.
    content = gtk_dialog_get_content_area(dialog)
    if (present(type)) then
       itype = type
    else if (button_set == GTK_BUTTONS_YES_NO) then
       itype = GTK_MESSAGE_QUESTION
    else
       itype = GTK_MESSAGE_OTHER
    end if

    if (itype /= GTK_MESSAGE_OTHER) then
       hb = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0_c_int)
       call gtk_box_append(content, hb)

       ! For the new icon names, replacing the GTK_STOCK, see:
       ! https://developer.gnome.org/gtk3/stable/gtk3-Stock-Items.html
       select case (itype)
       case (GTK_MESSAGE_ERROR)
          junk = gtk_image_new_from_icon_name("dialog-error"//c_null_char)
       case (GTK_MESSAGE_WARNING)
          junk = gtk_image_new_from_icon_name("dialog-warning"//c_null_char)
       case (GTK_MESSAGE_INFO)
          junk = gtk_image_new_from_icon_name("dialog-information"//c_null_char)
       case (GTK_MESSAGE_QUESTION)
          junk = gtk_image_new_from_icon_name("dialog-question"//c_null_char)
       case default
          junk=C_NULL_PTR
       end select

       if (c_associated(junk)) then
         call gtk_image_set_icon_size (junk, GTK_ICON_SIZE_LARGE)
         call gtk_box_append(hb, junk)
       end if

       vb = gtk_box_new(GTK_ORIENTATION_VERTICAL, 0_c_int)
       call gtk_box_append(hb, vb)
    else
       vb = content
    end if

    do i = 1, size(message)
       if (i == 1) then
          junk = gtk_label_new(c_null_char)
          call gtk_label_set_markup(junk, '<b><big>'//trim(message(i))// &
               & '</big></b>'//c_null_char)
       else
          junk = gtk_label_new(trim(message(i))//c_null_char)
       end if
       call gtk_box_append(vb, junk)
    end do

    select case (button_set)
    case (GTK_BUTTONS_NONE)
    case (GTK_BUTTONS_OK)
       junk = gtk_dialog_add_button(dialog, "_OK"//C_NULL_CHAR, GTK_RESPONSE_OK)
    case (GTK_BUTTONS_CLOSE)
       junk = gtk_dialog_add_button(dialog, "_Close"//C_NULL_CHAR, &
            & GTK_RESPONSE_CLOSE)
    case (GTK_BUTTONS_CANCEL)
       junk = gtk_dialog_add_button(dialog, "_Cancel"//C_NULL_CHAR, &
            & GTK_RESPONSE_CANCEL)
    case (GTK_BUTTONS_YES_NO)
       junk = gtk_dialog_add_button(dialog, "Yes"//C_NULL_CHAR, GTK_RESPONSE_YES)
       junk = gtk_dialog_add_button(dialog, "No"//C_NULL_CHAR, GTK_RESPONSE_NO)
    case (GTK_BUTTONS_OK_CANCEL)
       junk = gtk_dialog_add_button(dialog, "_OK"//C_NULL_CHAR, GTK_RESPONSE_OK)
       junk = gtk_dialog_add_button(dialog, "_Cancel"//C_NULL_CHAR, &
            & GTK_RESPONSE_CANCEL)
    case default
       call gtk_window_destroy(dialog)
       dialog = c_null_ptr

    end select

  end function hl_gtk_message_dialog_new

  !+
  function hl_gtk_message_dialog_show(message, button_set, title, type, &
       & parent) result(resp)

    integer(c_int) :: resp
    character(len=*), dimension(:), intent(in) :: message
    integer(c_int), intent(in) :: button_set
    character(kind=c_char), dimension(*), intent(in), optional :: title
    integer(c_int), intent(in), optional :: type
    type(c_ptr), intent(in), optional :: parent

    ! A DIY version of the message dialogue, needed because both creators
    ! for the built in one are variadic and so not callable from Fortran.
    ! This version runs the dialog as well as creating it.
    !
    ! MESSAGE |  string(n) |  required |  The message to display. Since this is a string array, the C_NULL_CHAR terminations are provided internally
    ! BUTTON_SET |  integer |  required |  The set of buttons to display
    ! TITLE |  string |  optional |  Title for the window.
    ! TYPE |  c_int |  optional |  Message type (a GTK_MESSAGE_ value)
    ! PARENT |  c_ptr |  optional |  An optional parent for the dialogue.
    !
    ! This version returns a response code, not a widget pointer.
    !-

    type(c_ptr) :: dialog

    dialog = hl_gtk_message_dialog_new(message, button_set, title, type, &
         & parent)

    if (c_associated(dialog)) then
       call gtk_widget_show(dialog)
       call g_signal_connect(dialog, "response"//c_null_char, &
                                    & c_funloc(dialog_callback))
       dialog_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
       call g_main_loop_run(dialog_gmainloop)
       resp = dialog_response
    else
       resp = GTK_RESPONSE_NONE
    end if
  end function hl_gtk_message_dialog_show

! https://developer.gnome.org/gtk4/stable/GtkDialog.html#GtkDialog-response
  subroutine dialog_callback(dialog, response_id, user_data) bind(c)
    type(c_ptr), value, intent(in) :: dialog, user_data
    integer(c_int), value, intent(in) :: response_id

    ! Global variable:
    dialog_response = response_id

    call gtk_window_destroy(dialog)
    call g_main_loop_quit(dialog_gmainloop)
  end subroutine dialog_callback

  !+
  function hl_gtk_about_dialog_new(name, license, license_type, &
       & comments, authors, website, website_label, copyright, version, &
       & documenters, translators, artists, logo, parent) result(about)
    type(c_ptr) :: about
    character(kind=c_char, len=*), intent(in), optional :: name
    character(kind=c_char, len=*), intent(in), optional :: license
    integer(c_int), intent(in), optional :: license_type
    character(kind=c_char, len=*), intent(in), optional :: comments
    character(len=*, kind=c_char), dimension(:), optional, target :: authors, &
         & documenters, artists
    character(kind=c_char, len=*), intent(in), optional :: website, &
         & website_label, translators, copyright, version
    type(c_ptr), intent(in), optional :: logo, parent

    ! A convenience interface for about dialogues.
    !
    ! NAME |  string |  optional |  The name of the program etc.
    ! LICENCE |  string |  optional |  The license for the program.
    ! LICENCE_TYPE |  c_int |  optional |  Specify a license from the GtkLicence enumerator. (Only valid in  GTK 3.0 and later)
    ! COMMENTS |  string |  optional |  A description of the program/library...
    ! AUTHORS |  string() |  optional |  A list of the authors.
    ! WEBSITE |  string |  optional |  The website.
    ! WEBSITE_LABEL |  string |  optional |  A label to describe the website.
    ! COPYRIGHT |  string |  optional |  The copyright message.
    ! VERSION |  string |  optional |  The version of the program.
    ! DOCUMENTERS |  string() |  optional |  The documentation authors.
    ! TRANSLATORS |  string |  optional |  The translators (N.B. unlike the other credits, this is a single string).
    ! ARTISTS |  string() |  optional |  The artists involved.
    ! LOGO |  c_ptr |  optional |  A gdk_pixbuf with the project's logo.
    ! PARENT |  c_ptr |  optional |  The parent widget of the window.
    !-

    character(kind=c_char), dimension(:), allocatable :: string
    character(kind=c_char), pointer, dimension(:) :: credit
    type(c_ptr), dimension(:), allocatable :: cptr
    integer :: i

    about = gtk_about_dialog_new()
    call gtk_window_set_modal(about, TRUE)
    if (present(parent)) call gtk_window_set_transient_for(about, parent)

    if (present(logo)) call gtk_about_dialog_set_logo(about, logo)

    if (present(name)) then
       call f_c_string(name, string)
       call gtk_about_dialog_set_program_name(about, string)
       deallocate(string)
    end if

    if (present(license)) then
       call f_c_string(license, string)
       call gtk_about_dialog_set_license(about, string)
       deallocate(string)
    else if (present(license_type)) then
       call gtk_about_dialog_set_license_type(about, license_type)
    end if

    if (present(comments)) then
       call f_c_string(comments, string)
       call gtk_about_dialog_set_comments(about, string)
       deallocate(string)
    end if
    if (present(website)) then
       call f_c_string(website, string)
       call gtk_about_dialog_set_website(about, string)
       deallocate(string)
    end if
    if (present(website_label)) then
       call f_c_string(website_label, string)
       call gtk_about_dialog_set_website_label(about, string)
       deallocate(string)
    end if
    if (present(translators)) then
       call f_c_string(translators, string)
       call gtk_about_dialog_set_translator_credits(about, string)
       deallocate(string)
    end if
    if (present(copyright)) then
       call f_c_string(copyright, string)
       call gtk_about_dialog_set_copyright(about, string)
       deallocate(string)
    end if
    if (present(version)) then
       call f_c_string(version, string)
       call gtk_about_dialog_set_version(about, string)
       deallocate(string)
    end if

    if (present(authors)) then
       allocate(cptr(size(authors)+1))
       do i = 1, size(authors)
          call f_c_string(authors(i), string)
          allocate(credit(size(string)))
          credit(:) = string(:)
          cptr(i) = c_loc(credit(1))
          nullify(credit)
       end do
       cptr(size(authors)+1) = c_null_ptr
       call gtk_about_dialog_set_authors(about, cptr)
       deallocate(cptr)
    end if
    if (present(documenters)) then
       allocate(cptr(size(documenters)+1))
       do i = 1, size(documenters)
          call f_c_string(documenters(i), string)
          allocate(credit(size(string)))
          credit(:) = string(:)
          cptr(i) = c_loc(credit(1))
          nullify(credit)
       end do
       cptr(size(documenters)+1) = c_null_ptr
       call gtk_about_dialog_set_documenters(about, cptr)
       deallocate(cptr)
    end if
    if (present(artists)) then
       allocate(cptr(size(artists)+1))
       do i = 1, size(artists)
          call f_c_string(artists(i), string)
          allocate(credit(size(string)))
          credit(:) = string(:)
          cptr(i) = c_loc(credit(1))
          nullify(credit)
       end do
       cptr(size(artists)+1) = c_null_ptr
       call gtk_about_dialog_set_artists(about, cptr)
       deallocate(cptr)
    end if

  end function hl_gtk_about_dialog_new

  subroutine hl_gtk_about_dialog_show(name, license, license_type, &
       & comments, authors, website, website_label, copyright, version, &
       & documenters, translators, artists, logo, parent)

    character(kind=c_char, len=*), intent(in), optional :: name
    character(kind=c_char, len=*), intent(in), optional :: license
    integer(c_int), intent(in), optional :: license_type
    character(kind=c_char, len=*), intent(in), optional :: comments
    character(len=*, kind=c_char), dimension(:), optional, target :: authors, &
         & documenters, artists
    character(kind=c_char, len=*), intent(in), optional :: website, &
         & website_label, translators, copyright, version
    type(c_ptr), intent(in), optional :: logo, parent

    ! A convenience interface for about dialogues, displays the dialogue
    ! as well as creating it.
    ! The arguments are identical to hl_gtk_about_dialog_new.
    !-

    type(c_ptr) :: about

    about = hl_gtk_about_dialog_new(name, license, license_type, &
         & comments, authors, website, website_label, copyright, version, &
         & documenters, translators, artists, logo, parent)

    call gtk_widget_show(about)
    call g_signal_connect(about, "close-request"//c_null_char, &
                                    & c_funloc(dialog_callback))
    dialog_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
    call g_main_loop_run(dialog_gmainloop)
  end subroutine hl_gtk_about_dialog_show

  !+
  subroutine hl_gtk_about_dialog_gtk_fortran(parent)
    type(c_ptr), intent(in), optional :: parent

    ! A standard "About" dialogue for gtk-fortran
    !
    ! PARENT |  c_ptr |  optional |  A parent widget for the dialogue.
    !-

    call hl_gtk_about_dialog_show(name="Gtk-fortran", &
         & authors = [character(len=14) :: "Jerry DeLisle", &
         & "Vincent Magnin", "James Tappin", "Jens Hunger", "Kyle Horne"], &
         & license_type=GTK_LICENSE_GPL_3_0, &
         & comments = &
         &"The gtk-fortran project aims to offer scientists programming "//&
         &"in Fortran a cross-platform library to build Graphical User "//&
         &"Interfaces (GUI)."//c_new_line// &
         &"Gtk-fortran is a partial GTK / Fortran binding 100% written "//&
         &"in Fortran, thanks to the ISO_C_BINDING module for "//&
         &"interoperability between C and Fortran, which is a part of the "//&
         &"Fortran 2003 standard. Gtk-Fortran also provides a number of "//&
         &"'high-level' interfaces to common widgets."//&
         &c_new_line//c_new_line// &
         &"GTK is a free software cross-platform graphical library "//&
         &"available for Linux, Unix, Windows and MacOs X."//C_NULL_CHAR, &
         & website="https://github.com/jerryd/gtk-fortran/wiki"//C_NULL_CHAR,&
         & parent=parent)

  end subroutine hl_gtk_about_dialog_gtk_fortran
end module gtk_hl_dialog

! Do not modify this file automatically generated by cfwrapper.py using:
! gtk-fortran 4.8.0, GTK 4.18.4, GLib 2.84.1, Fedora 42 x86_64
! This file is part of the gtk-fortran library, distributed under
! GNU General Public License version 3.

module gsk
use, intrinsic :: iso_c_binding
implicit none
interface

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskrenderer.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gsk_renderer_get_type (void) ;
function gsk_renderer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_renderer_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderer * gsk_renderer_new_for_surface (GdkSurface *surface);
function gsk_renderer_new_for_surface(surface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_renderer_new_for_surface
  type(c_ptr), value :: surface
end function

! GDK_AVAILABLE_IN_ALL
!GdkSurface * gsk_renderer_get_surface (GskRenderer *renderer);
function gsk_renderer_get_surface(renderer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_renderer_get_surface
  type(c_ptr), value :: renderer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_renderer_realize (GskRenderer *renderer, GdkSurface *surface, GError **error);
function gsk_renderer_realize(renderer, surface, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_renderer_realize
  type(c_ptr), value :: renderer
  type(c_ptr), value :: surface
  type(c_ptr), value :: error
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_renderer_realize_for_display (GskRenderer *renderer, GdkDisplay *display, GError **error);
function gsk_renderer_realize_for_display(renderer, display, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_renderer_realize_for_display
  type(c_ptr), value :: renderer
  type(c_ptr), value :: display
  type(c_ptr), value :: error
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_renderer_unrealize (GskRenderer *renderer);
subroutine gsk_renderer_unrealize(renderer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: renderer
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_renderer_is_realized (GskRenderer *renderer);
function gsk_renderer_is_realized(renderer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_renderer_is_realized
  type(c_ptr), value :: renderer
end function

! GDK_AVAILABLE_IN_ALL
!GdkTexture * gsk_renderer_render_texture (GskRenderer *renderer, GskRenderNode *root, const graphene_rect_t *viewport);
function gsk_renderer_render_texture(renderer, root, viewport) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_renderer_render_texture
  type(c_ptr), value :: renderer
  type(c_ptr), value :: root
  type(c_ptr), value :: viewport
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_renderer_render (GskRenderer *renderer, GskRenderNode *root, const cairo_region_t *region);
subroutine gsk_renderer_render(renderer, root, region) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: renderer
  type(c_ptr), value :: root
  type(c_ptr), value :: region
end subroutine

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gsktransform.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gsk_transform_get_type (void) ;
function gsk_transform_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_transform_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_ref (GskTransform *self);
function gsk_transform_ref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_ref
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_unref (GskTransform *self);
subroutine gsk_transform_unref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
end subroutine

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_print (GskTransform *self, GString *string);
subroutine gsk_transform_print(self, string) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: string
end subroutine

! GDK_AVAILABLE_IN_ALL
!char * gsk_transform_to_string (GskTransform *self);
function gsk_transform_to_string(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_to_string
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_transform_parse (const char *string, GskTransform **out_transform);
function gsk_transform_parse(string, out_transform) bind(c)
  import :: c_int, c_char, c_ptr
  implicit none
  integer(c_int) :: gsk_transform_parse
  character(kind=c_char), dimension(*) :: string
  type(c_ptr), value :: out_transform
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_to_matrix (GskTransform *self, graphene_matrix_t *out_matrix);
subroutine gsk_transform_to_matrix(self, out_matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: out_matrix
end subroutine

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_to_2d (GskTransform *self, float *out_xx, float *out_yx, float *out_xy, float *out_yy, float *out_dx, float *out_dy);
subroutine gsk_transform_to_2d(self, out_xx, out_yx, out_xy, out_yy, out_dx,&
& out_dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: out_xx
  type(c_ptr), value :: out_yx
  type(c_ptr), value :: out_xy
  type(c_ptr), value :: out_yy
  type(c_ptr), value :: out_dx
  type(c_ptr), value :: out_dy
end subroutine

! GDK_AVAILABLE_IN_4_6
!void gsk_transform_to_2d_components (GskTransform *self, float *out_skew_x, float *out_skew_y, float *out_scale_x, float *out_scale_y, float *out_angle, float *out_dx, float *out_dy);
subroutine gsk_transform_to_2d_components(self, out_skew_x, out_skew_y,&
& out_scale_x, out_scale_y, out_angle, out_dx, out_dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: out_skew_x
  type(c_ptr), value :: out_skew_y
  type(c_ptr), value :: out_scale_x
  type(c_ptr), value :: out_scale_y
  type(c_ptr), value :: out_angle
  type(c_ptr), value :: out_dx
  type(c_ptr), value :: out_dy
end subroutine

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_to_affine (GskTransform *self, float *out_scale_x, float *out_scale_y, float *out_dx, float *out_dy);
subroutine gsk_transform_to_affine(self, out_scale_x, out_scale_y, out_dx,&
& out_dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: out_scale_x
  type(c_ptr), value :: out_scale_y
  type(c_ptr), value :: out_dx
  type(c_ptr), value :: out_dy
end subroutine

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_to_translate (GskTransform *self, float *out_dx, float *out_dy);
subroutine gsk_transform_to_translate(self, out_dx, out_dy) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: out_dx
  type(c_ptr), value :: out_dy
end subroutine

! GDK_AVAILABLE_IN_ALL
!GskTransformCategory gsk_transform_get_category (GskTransform *self) ;
function gsk_transform_get_category(self) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_transform_get_category
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_transform_equal (GskTransform *first, GskTransform *second) ;
function gsk_transform_equal(first, second) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_transform_equal
  type(c_ptr), value :: first
  type(c_ptr), value :: second
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_new (void);
function gsk_transform_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_new
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_transform (GskTransform *next, GskTransform *other) ;
function gsk_transform_transform(next, other) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_transform
  type(c_ptr), value :: next
  type(c_ptr), value :: other
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_invert (GskTransform *self) ;
function gsk_transform_invert(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_invert
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_matrix (GskTransform *next, const graphene_matrix_t *matrix) ;
function gsk_transform_matrix(next, matrix) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_matrix
  type(c_ptr), value :: next
  type(c_ptr), value :: matrix
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_translate (GskTransform *next, const graphene_point_t *point) ;
function gsk_transform_translate(next, point) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_translate
  type(c_ptr), value :: next
  type(c_ptr), value :: point
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_translate_3d (GskTransform *next, const graphene_point3d_t *point) ;
function gsk_transform_translate_3d(next, point) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_translate_3d
  type(c_ptr), value :: next
  type(c_ptr), value :: point
end function

! GDK_AVAILABLE_IN_4_6
!GskTransform * gsk_transform_skew (GskTransform *next, float skew_x, float skew_y) ;
function gsk_transform_skew(next, skew_x, skew_y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_transform_skew
  type(c_ptr), value :: next
  real(c_float), value :: skew_x
  real(c_float), value :: skew_y
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_rotate (GskTransform *next, float angle) ;
function gsk_transform_rotate(next, angle) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_transform_rotate
  type(c_ptr), value :: next
  real(c_float), value :: angle
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_rotate_3d (GskTransform *next, float angle, const graphene_vec3_t *axis) ;
function gsk_transform_rotate_3d(next, angle, axis) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_transform_rotate_3d
  type(c_ptr), value :: next
  real(c_float), value :: angle
  type(c_ptr), value :: axis
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_scale (GskTransform *next, float factor_x, float factor_y) ;
function gsk_transform_scale(next, factor_x, factor_y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_transform_scale
  type(c_ptr), value :: next
  real(c_float), value :: factor_x
  real(c_float), value :: factor_y
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_scale_3d (GskTransform *next, float factor_x, float factor_y, float factor_z) ;
function gsk_transform_scale_3d(next, factor_x, factor_y, factor_z) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_transform_scale_3d
  type(c_ptr), value :: next
  real(c_float), value :: factor_x
  real(c_float), value :: factor_y
  real(c_float), value :: factor_z
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_perspective (GskTransform *next, float depth) ;
function gsk_transform_perspective(next, depth) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_transform_perspective
  type(c_ptr), value :: next
  real(c_float), value :: depth
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_transform_bounds (GskTransform *self, const graphene_rect_t *rect, graphene_rect_t *out_rect);
subroutine gsk_transform_transform_bounds(self, rect, out_rect) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: rect
  type(c_ptr), value :: out_rect
end subroutine

! GDK_AVAILABLE_IN_ALL
!void gsk_transform_transform_point (GskTransform *self, const graphene_point_t *point, graphene_point_t *out_point);
subroutine gsk_transform_transform_point(self, point, out_point) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: point
  type(c_ptr), value :: out_point
end subroutine

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskglshader.h
!--------------------------------------------------
! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskGLShader * gsk_gl_shader_new_from_bytes (GBytes *sourcecode);
function gsk_gl_shader_new_from_bytes(sourcecode) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_shader_new_from_bytes
  type(c_ptr), value :: sourcecode
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskGLShader * gsk_gl_shader_new_from_resource (const char *resource_path);
function gsk_gl_shader_new_from_resource(resource_path) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gsk_gl_shader_new_from_resource
  character(kind=c_char), dimension(*) :: resource_path
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!gboolean gsk_gl_shader_compile (GskGLShader *shader, GskRenderer *renderer, GError **error);
function gsk_gl_shader_compile(shader, renderer, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_compile
  type(c_ptr), value :: shader
  type(c_ptr), value :: renderer
  type(c_ptr), value :: error
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GBytes * gsk_gl_shader_get_source (GskGLShader *shader);
function gsk_gl_shader_get_source(shader) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_shader_get_source
  type(c_ptr), value :: shader
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!const char * gsk_gl_shader_get_resource (GskGLShader *shader);
function gsk_gl_shader_get_resource(shader) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_shader_get_resource
  type(c_ptr), value :: shader
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!int gsk_gl_shader_get_n_textures (GskGLShader *shader);
function gsk_gl_shader_get_n_textures(shader) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_get_n_textures
  type(c_ptr), value :: shader
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!int gsk_gl_shader_get_n_uniforms (GskGLShader *shader);
function gsk_gl_shader_get_n_uniforms(shader) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_get_n_uniforms
  type(c_ptr), value :: shader
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!const char * gsk_gl_shader_get_uniform_name (GskGLShader *shader, int idx);
function gsk_gl_shader_get_uniform_name(shader, idx) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_gl_shader_get_uniform_name
  type(c_ptr), value :: shader
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!int gsk_gl_shader_find_uniform_by_name (GskGLShader *shader, const char *name);
function gsk_gl_shader_find_uniform_by_name(shader, name) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gsk_gl_shader_find_uniform_by_name
  type(c_ptr), value :: shader
  character(kind=c_char), dimension(*) :: name
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskGLUniformType gsk_gl_shader_get_uniform_type (GskGLShader *shader, int idx);
function gsk_gl_shader_get_uniform_type(shader, idx) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_get_uniform_type
  type(c_ptr), value :: shader
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!int gsk_gl_shader_get_uniform_offset (GskGLShader *shader, int idx);
function gsk_gl_shader_get_uniform_offset(shader, idx) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_get_uniform_offset
  type(c_ptr), value :: shader
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!gsize gsk_gl_shader_get_args_size (GskGLShader *shader);
function gsk_gl_shader_get_args_size(shader) bind(c)
  import :: c_size_t, c_ptr
  implicit none
  integer(c_size_t) :: gsk_gl_shader_get_args_size
  type(c_ptr), value :: shader
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GBytes * gsk_gl_shader_format_args_va (GskGLShader *shader, va_list uniforms);
function gsk_gl_shader_format_args_va(shader, uniforms) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_shader_format_args_va
  type(c_ptr), value :: shader
  type(c_ptr), value :: uniforms
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!float gsk_gl_shader_get_arg_float (GskGLShader *shader, GBytes *args, int idx);
function gsk_gl_shader_get_arg_float(shader, args, idx) bind(c)
  import :: c_float, c_ptr, c_int
  implicit none
  real(c_float) :: gsk_gl_shader_get_arg_float
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!gint32 gsk_gl_shader_get_arg_int (GskGLShader *shader, GBytes *args, int idx);
function gsk_gl_shader_get_arg_int(shader, args, idx) bind(c)
  import :: c_int32_t, c_ptr, c_int
  implicit none
  integer(c_int32_t) :: gsk_gl_shader_get_arg_int
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!guint32 gsk_gl_shader_get_arg_uint (GskGLShader *shader, GBytes *args, int idx);
function gsk_gl_shader_get_arg_uint(shader, args, idx) bind(c)
  import :: c_int32_t, c_ptr, c_int
  implicit none
  integer(c_int32_t) :: gsk_gl_shader_get_arg_uint
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!gboolean gsk_gl_shader_get_arg_bool (GskGLShader *shader, GBytes *args, int idx);
function gsk_gl_shader_get_arg_bool(shader, args, idx) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_get_arg_bool
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_gl_shader_get_arg_vec2 (GskGLShader *shader, GBytes *args, int idx, graphene_vec2_t *out_value);
subroutine gsk_gl_shader_get_arg_vec2(shader, args, idx, out_value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
  type(c_ptr), value :: out_value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_gl_shader_get_arg_vec3 (GskGLShader *shader, GBytes *args, int idx, graphene_vec3_t *out_value);
subroutine gsk_gl_shader_get_arg_vec3(shader, args, idx, out_value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
  type(c_ptr), value :: out_value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_gl_shader_get_arg_vec4 (GskGLShader *shader, GBytes *args, int idx, graphene_vec4_t *out_value);
subroutine gsk_gl_shader_get_arg_vec4(shader, args, idx, out_value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: shader
  type(c_ptr), value :: args
  integer(c_int), value :: idx
  type(c_ptr), value :: out_value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GType gsk_shader_args_builder_get_type (void) ;
function gsk_shader_args_builder_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_shader_args_builder_get_type
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskShaderArgsBuilder *gsk_shader_args_builder_new (GskGLShader *shader, GBytes *initial_values);
function gsk_shader_args_builder_new(shader, initial_values) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_shader_args_builder_new
  type(c_ptr), value :: shader
  type(c_ptr), value :: initial_values
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GBytes * gsk_shader_args_builder_to_args (GskShaderArgsBuilder *builder);
function gsk_shader_args_builder_to_args(builder) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_shader_args_builder_to_args
  type(c_ptr), value :: builder
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GBytes * gsk_shader_args_builder_free_to_args (GskShaderArgsBuilder *builder);
function gsk_shader_args_builder_free_to_args(builder) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_shader_args_builder_free_to_args
  type(c_ptr), value :: builder
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskShaderArgsBuilder *gsk_shader_args_builder_ref (GskShaderArgsBuilder *builder);
function gsk_shader_args_builder_ref(builder) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_shader_args_builder_ref
  type(c_ptr), value :: builder
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_unref (GskShaderArgsBuilder *builder);
subroutine gsk_shader_args_builder_unref(builder) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: builder
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_float (GskShaderArgsBuilder *builder, int idx, float value);
subroutine gsk_shader_args_builder_set_float(builder, idx, value) bind(c)
  import :: c_ptr, c_int, c_float
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  real(c_float), value :: value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_int (GskShaderArgsBuilder *builder, int idx, gint32 value);
subroutine gsk_shader_args_builder_set_int(builder, idx, value) bind(c)
  import :: c_ptr, c_int, c_int32_t
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  integer(c_int32_t), value :: value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_uint (GskShaderArgsBuilder *builder, int idx, guint32 value);
subroutine gsk_shader_args_builder_set_uint(builder, idx, value) bind(c)
  import :: c_ptr, c_int, c_int32_t
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  integer(c_int32_t), value :: value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_bool (GskShaderArgsBuilder *builder, int idx, gboolean value);
subroutine gsk_shader_args_builder_set_bool(builder, idx, value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  integer(c_int), value :: value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_vec2 (GskShaderArgsBuilder *builder, int idx, const graphene_vec2_t *value);
subroutine gsk_shader_args_builder_set_vec2(builder, idx, value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  type(c_ptr), value :: value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_vec3 (GskShaderArgsBuilder *builder, int idx, const graphene_vec3_t *value);
subroutine gsk_shader_args_builder_set_vec3(builder, idx, value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  type(c_ptr), value :: value
end subroutine

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!void gsk_shader_args_builder_set_vec4 (GskShaderArgsBuilder *builder, int idx, const graphene_vec4_t *value);
subroutine gsk_shader_args_builder_set_vec4(builder, idx, value) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: builder
  integer(c_int), value :: idx
  type(c_ptr), value :: value
end subroutine

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskstroke.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_4_14
!GType gsk_stroke_get_type (void) ;
function gsk_stroke_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_stroke_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskStroke * gsk_stroke_new (float line_width);
function gsk_stroke_new(line_width) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_stroke_new
  real(c_float), value :: line_width
end function

! GDK_AVAILABLE_IN_4_14
!GskStroke * gsk_stroke_copy (const GskStroke *other);
function gsk_stroke_copy(other) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_stroke_copy
  type(c_ptr), value :: other
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_free (GskStroke *self);
subroutine gsk_stroke_free(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
end subroutine

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_stroke_equal (gconstpointer stroke1, gconstpointer stroke2);
function gsk_stroke_equal(stroke1, stroke2) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_stroke_equal
  type(c_ptr), value :: stroke1
  type(c_ptr), value :: stroke2
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_set_line_width (GskStroke *self, float line_width);
subroutine gsk_stroke_set_line_width(self, line_width) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: line_width
end subroutine

! GDK_AVAILABLE_IN_4_14
!float gsk_stroke_get_line_width (const GskStroke *self);
function gsk_stroke_get_line_width(self) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_stroke_get_line_width
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_set_line_cap (GskStroke *self, GskLineCap line_cap);
subroutine gsk_stroke_set_line_cap(self, line_cap) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: self
  integer(c_int), value :: line_cap
end subroutine

! GDK_AVAILABLE_IN_4_14
!GskLineCap gsk_stroke_get_line_cap (const GskStroke *self);
function gsk_stroke_get_line_cap(self) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_stroke_get_line_cap
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_set_line_join (GskStroke *self, GskLineJoin line_join);
subroutine gsk_stroke_set_line_join(self, line_join) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: self
  integer(c_int), value :: line_join
end subroutine

! GDK_AVAILABLE_IN_4_14
!GskLineJoin gsk_stroke_get_line_join (const GskStroke *self);
function gsk_stroke_get_line_join(self) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_stroke_get_line_join
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_set_miter_limit (GskStroke *self, float limit);
subroutine gsk_stroke_set_miter_limit(self, limit) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: limit
end subroutine

! GDK_AVAILABLE_IN_4_14
!float gsk_stroke_get_miter_limit (const GskStroke *self);
function gsk_stroke_get_miter_limit(self) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_stroke_get_miter_limit
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_set_dash (GskStroke *self, const float *dash, gsize n_dash);
subroutine gsk_stroke_set_dash(self, dash, n_dash) bind(c)
  import :: c_ptr, c_size_t
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: dash
  integer(c_size_t), value :: n_dash
end subroutine

! GDK_AVAILABLE_IN_4_14
!const float * gsk_stroke_get_dash (const GskStroke *self, gsize *n_dash);
function gsk_stroke_get_dash(self, n_dash) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_stroke_get_dash
  type(c_ptr), value :: self
  type(c_ptr), value :: n_dash
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_set_dash_offset (GskStroke *self, float offset);
subroutine gsk_stroke_set_dash_offset(self, offset) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: offset
end subroutine

! GDK_AVAILABLE_IN_4_14
!float gsk_stroke_get_dash_offset (const GskStroke *self);
function gsk_stroke_get_dash_offset(self) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_stroke_get_dash_offset
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_stroke_to_cairo (const GskStroke *self, cairo_t *cr);
subroutine gsk_stroke_to_cairo(self, cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: cr
end subroutine

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskpathbuilder.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_4_14
!GType gsk_path_builder_get_type (void) ;
function gsk_path_builder_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_path_builder_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskPathBuilder * gsk_path_builder_new (void);
function gsk_path_builder_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_builder_new
end function

! GDK_AVAILABLE_IN_4_14
!GskPathBuilder * gsk_path_builder_ref (GskPathBuilder *self);
function gsk_path_builder_ref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_builder_ref
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_unref (GskPathBuilder *self);
subroutine gsk_path_builder_unref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
end subroutine

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_path_builder_free_to_path (GskPathBuilder *self) ;
function gsk_path_builder_free_to_path(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_builder_free_to_path
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_path_builder_to_path (GskPathBuilder *self) ;
function gsk_path_builder_to_path(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_builder_to_path
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!const graphene_point_t *gsk_path_builder_get_current_point (GskPathBuilder *self);
function gsk_path_builder_get_current_point(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_builder_get_current_point
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_path (GskPathBuilder *self, GskPath *path);
subroutine gsk_path_builder_add_path(self, path) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: path
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_reverse_path (GskPathBuilder *self, GskPath *path);
subroutine gsk_path_builder_add_reverse_path(self, path) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: path
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_cairo_path (GskPathBuilder *self, const cairo_path_t *path);
subroutine gsk_path_builder_add_cairo_path(self, path) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: path
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_layout (GskPathBuilder *self, PangoLayout *layout);
subroutine gsk_path_builder_add_layout(self, layout) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: layout
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_rect (GskPathBuilder *self, const graphene_rect_t *rect);
subroutine gsk_path_builder_add_rect(self, rect) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: rect
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_rounded_rect (GskPathBuilder *self, const GskRoundedRect *rect);
subroutine gsk_path_builder_add_rounded_rect(self, rect) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: rect
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_circle (GskPathBuilder *self, const graphene_point_t *center, float radius);
subroutine gsk_path_builder_add_circle(self, center, radius) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: center
  real(c_float), value :: radius
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_add_segment (GskPathBuilder *self, GskPath *path, const GskPathPoint *start, const GskPathPoint *end);
subroutine gsk_path_builder_add_segment(self, path, start, end) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: path
  type(c_ptr), value :: start
  type(c_ptr), value :: end
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_move_to (GskPathBuilder *self, float x, float y);
subroutine gsk_path_builder_move_to(self, x, y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x
  real(c_float), value :: y
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_move_to (GskPathBuilder *self, float x, float y);
subroutine gsk_path_builder_rel_move_to(self, x, y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x
  real(c_float), value :: y
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_line_to (GskPathBuilder *self, float x, float y);
subroutine gsk_path_builder_line_to(self, x, y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x
  real(c_float), value :: y
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_line_to (GskPathBuilder *self, float x, float y);
subroutine gsk_path_builder_rel_line_to(self, x, y) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x
  real(c_float), value :: y
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_quad_to (GskPathBuilder *self, float x1, float y1, float x2, float y2);
subroutine gsk_path_builder_quad_to(self, x1, y1, x2, y2) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_quad_to (GskPathBuilder *self, float x1, float y1, float x2, float y2);
subroutine gsk_path_builder_rel_quad_to(self, x1, y1, x2, y2) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_cubic_to (GskPathBuilder *self, float x1, float y1, float x2, float y2, float x3, float y3);
subroutine gsk_path_builder_cubic_to(self, x1, y1, x2, y2, x3, y3) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
  real(c_float), value :: x3
  real(c_float), value :: y3
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_cubic_to (GskPathBuilder *self, float x1, float y1, float x2, float y2, float x3, float y3);
subroutine gsk_path_builder_rel_cubic_to(self, x1, y1, x2, y2, x3, y3) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
  real(c_float), value :: x3
  real(c_float), value :: y3
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_conic_to (GskPathBuilder *self, float x1, float y1, float x2, float y2, float weight);
subroutine gsk_path_builder_conic_to(self, x1, y1, x2, y2, weight) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
  real(c_float), value :: weight
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_conic_to (GskPathBuilder *self, float x1, float y1, float x2, float y2, float weight);
subroutine gsk_path_builder_rel_conic_to(self, x1, y1, x2, y2, weight) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
  real(c_float), value :: weight
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_arc_to (GskPathBuilder *self, float x1, float y1, float x2, float y2);
subroutine gsk_path_builder_arc_to(self, x1, y1, x2, y2) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_arc_to (GskPathBuilder *self, float x1, float y1, float x2, float y2);
subroutine gsk_path_builder_rel_arc_to(self, x1, y1, x2, y2) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_svg_arc_to (GskPathBuilder *self, float rx, float ry, float x_axis_rotation, gboolean large_arc, gboolean positive_sweep, float x, float y);
subroutine gsk_path_builder_svg_arc_to(self, rx, ry, x_axis_rotation,&
& large_arc, positive_sweep, x, y) bind(c)
  import :: c_ptr, c_float, c_int
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: rx
  real(c_float), value :: ry
  real(c_float), value :: x_axis_rotation
  integer(c_int), value :: large_arc
  integer(c_int), value :: positive_sweep
  real(c_float), value :: x
  real(c_float), value :: y
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_svg_arc_to (GskPathBuilder *self, float rx, float ry, float x_axis_rotation, gboolean large_arc, gboolean positive_sweep, float x, float y);
subroutine gsk_path_builder_rel_svg_arc_to(self, rx, ry, x_axis_rotation,&
& large_arc, positive_sweep, x, y) bind(c)
  import :: c_ptr, c_float, c_int
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: rx
  real(c_float), value :: ry
  real(c_float), value :: x_axis_rotation
  integer(c_int), value :: large_arc
  integer(c_int), value :: positive_sweep
  real(c_float), value :: x
  real(c_float), value :: y
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_html_arc_to (GskPathBuilder *self, float x1, float y1, float x2, float y2, float radius);
subroutine gsk_path_builder_html_arc_to(self, x1, y1, x2, y2, radius) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
  real(c_float), value :: radius
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_rel_html_arc_to (GskPathBuilder *self, float x1, float y1, float x2, float y2, float radius);
subroutine gsk_path_builder_rel_html_arc_to(self, x1, y1, x2, y2, radius)&
& bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr), value :: self
  real(c_float), value :: x1
  real(c_float), value :: y1
  real(c_float), value :: x2
  real(c_float), value :: y2
  real(c_float), value :: radius
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_builder_close (GskPathBuilder *self);
subroutine gsk_path_builder_close(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
end subroutine

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskroundedrect.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GskRoundedRect * gsk_rounded_rect_init (GskRoundedRect *self, const graphene_rect_t *bounds, const graphene_size_t *top_left, const graphene_size_t *top_right, const graphene_size_t *bottom_right, const graphene_size_t *bottom_left);
function gsk_rounded_rect_init(self, bounds, top_left, top_right, bottom_right,&
& bottom_left) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_rounded_rect_init
  type(c_ptr), value :: self
  type(c_ptr), value :: bounds
  type(c_ptr), value :: top_left
  type(c_ptr), value :: top_right
  type(c_ptr), value :: bottom_right
  type(c_ptr), value :: bottom_left
end function

! GDK_AVAILABLE_IN_ALL
!GskRoundedRect * gsk_rounded_rect_init_copy (GskRoundedRect *self, const GskRoundedRect *src);
function gsk_rounded_rect_init_copy(self, src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_rounded_rect_init_copy
  type(c_ptr), value :: self
  type(c_ptr), value :: src
end function

! GDK_AVAILABLE_IN_ALL
!GskRoundedRect * gsk_rounded_rect_init_from_rect (GskRoundedRect *self, const graphene_rect_t *bounds, float radius);
function gsk_rounded_rect_init_from_rect(self, bounds, radius) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_rounded_rect_init_from_rect
  type(c_ptr), value :: self
  type(c_ptr), value :: bounds
  real(c_float), value :: radius
end function

! GDK_AVAILABLE_IN_ALL
!GskRoundedRect * gsk_rounded_rect_normalize (GskRoundedRect *self);
function gsk_rounded_rect_normalize(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_rounded_rect_normalize
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_ALL
!GskRoundedRect * gsk_rounded_rect_offset (GskRoundedRect *self, float dx, float dy);
function gsk_rounded_rect_offset(self, dx, dy) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_rounded_rect_offset
  type(c_ptr), value :: self
  real(c_float), value :: dx
  real(c_float), value :: dy
end function

! GDK_AVAILABLE_IN_ALL
!GskRoundedRect * gsk_rounded_rect_shrink (GskRoundedRect *self, float top, float right, float bottom, float left);
function gsk_rounded_rect_shrink(self, top, right, bottom, left) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_rounded_rect_shrink
  type(c_ptr), value :: self
  real(c_float), value :: top
  real(c_float), value :: right
  real(c_float), value :: bottom
  real(c_float), value :: left
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_rounded_rect_is_rectilinear (const GskRoundedRect *self) ;
function gsk_rounded_rect_is_rectilinear(self) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_rounded_rect_is_rectilinear
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_rounded_rect_contains_point (const GskRoundedRect *self, const graphene_point_t *point) ;
function gsk_rounded_rect_contains_point(self, point) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_rounded_rect_contains_point
  type(c_ptr), value :: self
  type(c_ptr), value :: point
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_rounded_rect_contains_rect (const GskRoundedRect *self, const graphene_rect_t *rect) ;
function gsk_rounded_rect_contains_rect(self, rect) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_rounded_rect_contains_rect
  type(c_ptr), value :: self
  type(c_ptr), value :: rect
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_rounded_rect_intersects_rect (const GskRoundedRect *self, const graphene_rect_t *rect) ;
function gsk_rounded_rect_intersects_rect(self, rect) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_rounded_rect_intersects_rect
  type(c_ptr), value :: self
  type(c_ptr), value :: rect
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskcairorenderer.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gsk_cairo_renderer_get_type (void) ;
function gsk_cairo_renderer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_cairo_renderer_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderer * gsk_cairo_renderer_new (void);
function gsk_cairo_renderer_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_cairo_renderer_new
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gsk.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskpath.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_4_14
!GType gsk_path_get_type (void) ;
function gsk_path_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_path_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_path_ref (GskPath *self);
function gsk_path_ref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_ref
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_unref (GskPath *self);
subroutine gsk_path_unref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_print (GskPath *self, GString *string);
subroutine gsk_path_print(self, string) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: string
end subroutine

! GDK_AVAILABLE_IN_4_14
!char * gsk_path_to_string (GskPath *self);
function gsk_path_to_string(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_to_string
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_path_parse (const char *string);
function gsk_path_parse(string) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gsk_path_parse
  character(kind=c_char), dimension(*) :: string
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_to_cairo (GskPath *self, cairo_t *cr);
subroutine gsk_path_to_cairo(self, cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
  type(c_ptr), value :: cr
end subroutine

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_is_empty (GskPath *self);
function gsk_path_is_empty(self) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_is_empty
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_is_closed (GskPath *self);
function gsk_path_is_closed(self) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_is_closed
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_get_bounds (GskPath *self, graphene_rect_t *bounds);
function gsk_path_get_bounds(self, bounds) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_get_bounds
  type(c_ptr), value :: self
  type(c_ptr), value :: bounds
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_get_stroke_bounds (GskPath *self, const GskStroke *stroke, graphene_rect_t *bounds);
function gsk_path_get_stroke_bounds(self, stroke, bounds) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_get_stroke_bounds
  type(c_ptr), value :: self
  type(c_ptr), value :: stroke
  type(c_ptr), value :: bounds
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_in_fill (GskPath *self, const graphene_point_t *point, GskFillRule fill_rule);
function gsk_path_in_fill(self, point, fill_rule) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_in_fill
  type(c_ptr), value :: self
  type(c_ptr), value :: point
  integer(c_int), value :: fill_rule
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_get_start_point (GskPath *self, GskPathPoint *result);
function gsk_path_get_start_point(self, result) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_get_start_point
  type(c_ptr), value :: self
  type(c_ptr), value :: result
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_get_end_point (GskPath *self, GskPathPoint *result);
function gsk_path_get_end_point(self, result) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_get_end_point
  type(c_ptr), value :: self
  type(c_ptr), value :: result
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_get_closest_point (GskPath *self, const graphene_point_t *point, float threshold, GskPathPoint *result, float *distance);
function gsk_path_get_closest_point(self, point, threshold, result, distance)&
& bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: gsk_path_get_closest_point
  type(c_ptr), value :: self
  type(c_ptr), value :: point
  real(c_float), value :: threshold
  type(c_ptr), value :: result
  type(c_ptr), value :: distance
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_foreach (GskPath *self, GskPathForeachFlags flags, GskPathForeachFunc func, gpointer user_data);
function gsk_path_foreach(self, flags, func, user_data) bind(c)
  import :: c_int, c_ptr, c_funptr
  implicit none
  integer(c_int) :: gsk_path_foreach
  type(c_ptr), value :: self
  integer(c_int), value :: flags
  type(c_funptr), value :: func
  type(c_ptr), value :: user_data
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskenumtypes.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskpathpoint.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_4_14
!GType gsk_path_point_get_type (void) ;
function gsk_path_point_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_path_point_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskPathPoint * gsk_path_point_copy (GskPathPoint *point);
function gsk_path_point_copy(point) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_point_copy
  type(c_ptr), value :: point
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_point_free (GskPathPoint *point);
subroutine gsk_path_point_free(point) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: point
end subroutine

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_point_equal (const GskPathPoint *point1, const GskPathPoint *point2) ;
function gsk_path_point_equal(point1, point2) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_point_equal
  type(c_ptr), value :: point1
  type(c_ptr), value :: point2
end function

! GDK_AVAILABLE_IN_4_14
!int gsk_path_point_compare (const GskPathPoint *point1, const GskPathPoint *point2) ;
function gsk_path_point_compare(point1, point2) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_path_point_compare
  type(c_ptr), value :: point1
  type(c_ptr), value :: point2
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_point_get_position (const GskPathPoint *point, GskPath *path, graphene_point_t *position);
subroutine gsk_path_point_get_position(point, path, position) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: point
  type(c_ptr), value :: path
  type(c_ptr), value :: position
end subroutine

! GDK_AVAILABLE_IN_4_14
!void gsk_path_point_get_tangent (const GskPathPoint *point, GskPath *path, GskPathDirection direction, graphene_vec2_t *tangent);
subroutine gsk_path_point_get_tangent(point, path, direction, tangent) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: point
  type(c_ptr), value :: path
  integer(c_int), value :: direction
  type(c_ptr), value :: tangent
end subroutine

! GDK_AVAILABLE_IN_4_14
!float gsk_path_point_get_rotation (const GskPathPoint *point, GskPath *path, GskPathDirection direction);
function gsk_path_point_get_rotation(point, path, direction) bind(c)
  import :: c_float, c_ptr, c_int
  implicit none
  real(c_float) :: gsk_path_point_get_rotation
  type(c_ptr), value :: point
  type(c_ptr), value :: path
  integer(c_int), value :: direction
end function

! GDK_AVAILABLE_IN_4_14
!float gsk_path_point_get_curvature (const GskPathPoint *point, GskPath *path, GskPathDirection direction, graphene_point_t *center);
function gsk_path_point_get_curvature(point, path, direction, center) bind(c)
  import :: c_float, c_ptr, c_int
  implicit none
  real(c_float) :: gsk_path_point_get_curvature
  type(c_ptr), value :: point
  type(c_ptr), value :: path
  integer(c_int), value :: direction
  type(c_ptr), value :: center
end function

! GDK_AVAILABLE_IN_4_14
!float gsk_path_point_get_distance (const GskPathPoint *point, GskPathMeasure *measure);
function gsk_path_point_get_distance(point, measure) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_path_point_get_distance
  type(c_ptr), value :: point
  type(c_ptr), value :: measure
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gsktypes.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskenums.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskrendernode.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gsk_render_node_get_type (void) ;
function gsk_render_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_render_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GQuark gsk_serialization_error_quark (void);
function gsk_serialization_error_quark() bind(c)
  import :: c_int32_t
  implicit none
  integer(c_int32_t) :: gsk_serialization_error_quark
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_render_node_ref (GskRenderNode *node);
function gsk_render_node_ref(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_render_node_ref
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_render_node_unref (GskRenderNode *node);
subroutine gsk_render_node_unref(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: node
end subroutine

! GDK_AVAILABLE_IN_ALL
!GskRenderNodeType gsk_render_node_get_node_type (const GskRenderNode *node);
function gsk_render_node_get_node_type(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_render_node_get_node_type
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_render_node_get_bounds (GskRenderNode *node, graphene_rect_t *bounds);
subroutine gsk_render_node_get_bounds(node, bounds) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: node
  type(c_ptr), value :: bounds
end subroutine

! GDK_AVAILABLE_IN_4_16
!gboolean gsk_render_node_get_opaque_rect (GskRenderNode *self, graphene_rect_t *out_opaque) ;
function gsk_render_node_get_opaque_rect(self, out_opaque) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_render_node_get_opaque_rect
  type(c_ptr), value :: self
  type(c_ptr), value :: out_opaque
end function

! GDK_AVAILABLE_IN_ALL
!void gsk_render_node_draw (GskRenderNode *node, cairo_t *cr);
subroutine gsk_render_node_draw(node, cr) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: node
  type(c_ptr), value :: cr
end subroutine

! GDK_AVAILABLE_IN_ALL
!GBytes * gsk_render_node_serialize (GskRenderNode *node);
function gsk_render_node_serialize(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_render_node_serialize
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gsk_render_node_write_to_file (GskRenderNode *node, const char *filename, GError **error);
function gsk_render_node_write_to_file(node, filename, error) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gsk_render_node_write_to_file
  type(c_ptr), value :: node
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: error
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_render_node_deserialize (GBytes *bytes, GskParseErrorFunc error_func, gpointer user_data);
function gsk_render_node_deserialize(bytes, error_func, user_data) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr) :: gsk_render_node_deserialize
  type(c_ptr), value :: bytes
  type(c_funptr), value :: error_func
  type(c_ptr), value :: user_data
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_debug_node_get_type (void) ;
function gsk_debug_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_debug_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_debug_node_new (GskRenderNode *child, char *message);
function gsk_debug_node_new(child, message) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gsk_debug_node_new
  type(c_ptr), value :: child
  character(kind=c_char), dimension(*) :: message
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_debug_node_get_child (const GskRenderNode *node) ;
function gsk_debug_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_debug_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const char * gsk_debug_node_get_message (const GskRenderNode *node) ;
function gsk_debug_node_get_message(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_debug_node_get_message
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_color_node_get_type (void) ;
function gsk_color_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_color_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_color_node_new (const GdkRGBA *rgba, const graphene_rect_t *bounds);
function gsk_color_node_new(rgba, bounds) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_color_node_new
  type(c_ptr), value :: rgba
  type(c_ptr), value :: bounds
end function

! GDK_AVAILABLE_IN_ALL
!const GdkRGBA * gsk_color_node_get_color (const GskRenderNode *node) ;
function gsk_color_node_get_color(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_color_node_get_color
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_texture_node_get_type (void) ;
function gsk_texture_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_texture_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_texture_node_new (GdkTexture *texture, const graphene_rect_t *bounds);
function gsk_texture_node_new(texture, bounds) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_texture_node_new
  type(c_ptr), value :: texture
  type(c_ptr), value :: bounds
end function

! GDK_AVAILABLE_IN_ALL
!GdkTexture * gsk_texture_node_get_texture (const GskRenderNode *node) ;
function gsk_texture_node_get_texture(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_texture_node_get_texture
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_10
!GType gsk_texture_scale_node_get_type (void) ;
function gsk_texture_scale_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_texture_scale_node_get_type
end function

! GDK_AVAILABLE_IN_4_10
!GskRenderNode * gsk_texture_scale_node_new (GdkTexture *texture, const graphene_rect_t *bounds, GskScalingFilter filter);
function gsk_texture_scale_node_new(texture, bounds, filter) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_texture_scale_node_new
  type(c_ptr), value :: texture
  type(c_ptr), value :: bounds
  integer(c_int), value :: filter
end function

! GDK_AVAILABLE_IN_4_10
!GdkTexture * gsk_texture_scale_node_get_texture (const GskRenderNode *node) ;
function gsk_texture_scale_node_get_texture(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_texture_scale_node_get_texture
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_10
!GskScalingFilter gsk_texture_scale_node_get_filter (const GskRenderNode *node) ;
function gsk_texture_scale_node_get_filter(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_texture_scale_node_get_filter
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_linear_gradient_node_get_type (void) ;
function gsk_linear_gradient_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_linear_gradient_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_linear_gradient_node_new (const graphene_rect_t *bounds, const graphene_point_t *start, const graphene_point_t *end, const GskColorStop *color_stops, gsize n_color_stops);
function gsk_linear_gradient_node_new(bounds, start, end, color_stops,&
& n_color_stops) bind(c)
  import :: c_ptr, c_size_t
  implicit none
  type(c_ptr) :: gsk_linear_gradient_node_new
  type(c_ptr), value :: bounds
  type(c_ptr), value :: start
  type(c_ptr), value :: end
  type(c_ptr), value :: color_stops
  integer(c_size_t), value :: n_color_stops
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_point_t * gsk_linear_gradient_node_get_start (const GskRenderNode *node) ;
function gsk_linear_gradient_node_get_start(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_linear_gradient_node_get_start
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_point_t * gsk_linear_gradient_node_get_end (const GskRenderNode *node) ;
function gsk_linear_gradient_node_get_end(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_linear_gradient_node_get_end
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!gsize gsk_linear_gradient_node_get_n_color_stops (const GskRenderNode *node) ;
function gsk_linear_gradient_node_get_n_color_stops(node) bind(c)
  import :: c_size_t, c_ptr
  implicit none
  integer(c_size_t) :: gsk_linear_gradient_node_get_n_color_stops
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GskColorStop * gsk_linear_gradient_node_get_color_stops (const GskRenderNode *node, gsize *n_stops);
function gsk_linear_gradient_node_get_color_stops(node, n_stops) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_linear_gradient_node_get_color_stops
  type(c_ptr), value :: node
  type(c_ptr), value :: n_stops
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_repeating_linear_gradient_node_get_type (void) ;
function gsk_repeating_linear_gradient_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_repeating_linear_gradient_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_repeating_linear_gradient_node_new (const graphene_rect_t *bounds, const graphene_point_t *start, const graphene_point_t *end, const GskColorStop *color_stops, gsize n_color_stops);
function gsk_repeating_linear_gradient_node_new(bounds, start, end,&
& color_stops, n_color_stops) bind(c)
  import :: c_ptr, c_size_t
  implicit none
  type(c_ptr) :: gsk_repeating_linear_gradient_node_new
  type(c_ptr), value :: bounds
  type(c_ptr), value :: start
  type(c_ptr), value :: end
  type(c_ptr), value :: color_stops
  integer(c_size_t), value :: n_color_stops
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_conic_gradient_node_get_type (void) ;
function gsk_conic_gradient_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_conic_gradient_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_conic_gradient_node_new (const graphene_rect_t *bounds, const graphene_point_t *center, float rotation, const GskColorStop *color_stops, gsize n_color_stops);
function gsk_conic_gradient_node_new(bounds, center, rotation, color_stops,&
& n_color_stops) bind(c)
  import :: c_ptr, c_float, c_size_t
  implicit none
  type(c_ptr) :: gsk_conic_gradient_node_new
  type(c_ptr), value :: bounds
  type(c_ptr), value :: center
  real(c_float), value :: rotation
  type(c_ptr), value :: color_stops
  integer(c_size_t), value :: n_color_stops
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_point_t * gsk_conic_gradient_node_get_center (const GskRenderNode *node) ;
function gsk_conic_gradient_node_get_center(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_conic_gradient_node_get_center
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_conic_gradient_node_get_rotation (const GskRenderNode *node) ;
function gsk_conic_gradient_node_get_rotation(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_conic_gradient_node_get_rotation
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_2
!float gsk_conic_gradient_node_get_angle (const GskRenderNode *node) ;
function gsk_conic_gradient_node_get_angle(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_conic_gradient_node_get_angle
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!gsize gsk_conic_gradient_node_get_n_color_stops (const GskRenderNode *node) ;
function gsk_conic_gradient_node_get_n_color_stops(node) bind(c)
  import :: c_size_t, c_ptr
  implicit none
  integer(c_size_t) :: gsk_conic_gradient_node_get_n_color_stops
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GskColorStop * gsk_conic_gradient_node_get_color_stops (const GskRenderNode *node, gsize *n_stops);
function gsk_conic_gradient_node_get_color_stops(node, n_stops) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_conic_gradient_node_get_color_stops
  type(c_ptr), value :: node
  type(c_ptr), value :: n_stops
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_radial_gradient_node_get_type (void) ;
function gsk_radial_gradient_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_radial_gradient_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_radial_gradient_node_new (const graphene_rect_t *bounds, const graphene_point_t *center, float hradius, float vradius, float start, float end, const GskColorStop *color_stops, gsize n_color_stops);
function gsk_radial_gradient_node_new(bounds, center, hradius, vradius, start,&
& end, color_stops, n_color_stops) bind(c)
  import :: c_ptr, c_float, c_size_t
  implicit none
  type(c_ptr) :: gsk_radial_gradient_node_new
  type(c_ptr), value :: bounds
  type(c_ptr), value :: center
  real(c_float), value :: hradius
  real(c_float), value :: vradius
  real(c_float), value :: start
  real(c_float), value :: end
  type(c_ptr), value :: color_stops
  integer(c_size_t), value :: n_color_stops
end function

! GDK_AVAILABLE_IN_ALL
!gsize gsk_radial_gradient_node_get_n_color_stops (const GskRenderNode *node) ;
function gsk_radial_gradient_node_get_n_color_stops(node) bind(c)
  import :: c_size_t, c_ptr
  implicit none
  integer(c_size_t) :: gsk_radial_gradient_node_get_n_color_stops
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GskColorStop * gsk_radial_gradient_node_get_color_stops (const GskRenderNode *node, gsize *n_stops);
function gsk_radial_gradient_node_get_color_stops(node, n_stops) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_radial_gradient_node_get_color_stops
  type(c_ptr), value :: node
  type(c_ptr), value :: n_stops
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_point_t *gsk_radial_gradient_node_get_center (const GskRenderNode *node) ;
function gsk_radial_gradient_node_get_center(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_radial_gradient_node_get_center
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_radial_gradient_node_get_hradius (const GskRenderNode *node) ;
function gsk_radial_gradient_node_get_hradius(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_radial_gradient_node_get_hradius
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_radial_gradient_node_get_vradius (const GskRenderNode *node) ;
function gsk_radial_gradient_node_get_vradius(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_radial_gradient_node_get_vradius
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_radial_gradient_node_get_start (const GskRenderNode *node) ;
function gsk_radial_gradient_node_get_start(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_radial_gradient_node_get_start
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_radial_gradient_node_get_end (const GskRenderNode *node) ;
function gsk_radial_gradient_node_get_end(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_radial_gradient_node_get_end
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_repeating_radial_gradient_node_get_type (void) ;
function gsk_repeating_radial_gradient_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_repeating_radial_gradient_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_repeating_radial_gradient_node_new (const graphene_rect_t *bounds, const graphene_point_t *center, float hradius, float vradius, float start, float end, const GskColorStop *color_stops, gsize n_color_stops);
function gsk_repeating_radial_gradient_node_new(bounds, center, hradius,&
& vradius, start, end, color_stops, n_color_stops) bind(c)
  import :: c_ptr, c_float, c_size_t
  implicit none
  type(c_ptr) :: gsk_repeating_radial_gradient_node_new
  type(c_ptr), value :: bounds
  type(c_ptr), value :: center
  real(c_float), value :: hradius
  real(c_float), value :: vradius
  real(c_float), value :: start
  real(c_float), value :: end
  type(c_ptr), value :: color_stops
  integer(c_size_t), value :: n_color_stops
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_border_node_get_type (void) ;
function gsk_border_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_border_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!const GskRoundedRect * gsk_border_node_get_outline (const GskRenderNode *node) ;
function gsk_border_node_get_outline(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_border_node_get_outline
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const float * gsk_border_node_get_widths (const GskRenderNode *node) ;
function gsk_border_node_get_widths(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_border_node_get_widths
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GdkRGBA * gsk_border_node_get_colors (const GskRenderNode *node) ;
function gsk_border_node_get_colors(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_border_node_get_colors
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_inset_shadow_node_get_type (void) ;
function gsk_inset_shadow_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_inset_shadow_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_inset_shadow_node_new (const GskRoundedRect *outline, const GdkRGBA *color, float dx, float dy, float spread, float blur_radius);
function gsk_inset_shadow_node_new(outline, color, dx, dy, spread, blur_radius)&
& bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_inset_shadow_node_new
  type(c_ptr), value :: outline
  type(c_ptr), value :: color
  real(c_float), value :: dx
  real(c_float), value :: dy
  real(c_float), value :: spread
  real(c_float), value :: blur_radius
end function

! GDK_AVAILABLE_IN_ALL
!const GskRoundedRect * gsk_inset_shadow_node_get_outline (const GskRenderNode *node) ;
function gsk_inset_shadow_node_get_outline(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_inset_shadow_node_get_outline
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GdkRGBA * gsk_inset_shadow_node_get_color (const GskRenderNode *node) ;
function gsk_inset_shadow_node_get_color(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_inset_shadow_node_get_color
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_inset_shadow_node_get_dx (const GskRenderNode *node) ;
function gsk_inset_shadow_node_get_dx(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_inset_shadow_node_get_dx
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_inset_shadow_node_get_dy (const GskRenderNode *node) ;
function gsk_inset_shadow_node_get_dy(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_inset_shadow_node_get_dy
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_inset_shadow_node_get_spread (const GskRenderNode *node) ;
function gsk_inset_shadow_node_get_spread(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_inset_shadow_node_get_spread
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_inset_shadow_node_get_blur_radius (const GskRenderNode *node) ;
function gsk_inset_shadow_node_get_blur_radius(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_inset_shadow_node_get_blur_radius
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_outset_shadow_node_get_type (void) ;
function gsk_outset_shadow_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_outset_shadow_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_outset_shadow_node_new (const GskRoundedRect *outline, const GdkRGBA *color, float dx, float dy, float spread, float blur_radius);
function gsk_outset_shadow_node_new(outline, color, dx, dy, spread,&
& blur_radius) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_outset_shadow_node_new
  type(c_ptr), value :: outline
  type(c_ptr), value :: color
  real(c_float), value :: dx
  real(c_float), value :: dy
  real(c_float), value :: spread
  real(c_float), value :: blur_radius
end function

! GDK_AVAILABLE_IN_ALL
!const GskRoundedRect * gsk_outset_shadow_node_get_outline (const GskRenderNode *node) ;
function gsk_outset_shadow_node_get_outline(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_outset_shadow_node_get_outline
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GdkRGBA * gsk_outset_shadow_node_get_color (const GskRenderNode *node) ;
function gsk_outset_shadow_node_get_color(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_outset_shadow_node_get_color
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_outset_shadow_node_get_dx (const GskRenderNode *node) ;
function gsk_outset_shadow_node_get_dx(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_outset_shadow_node_get_dx
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_outset_shadow_node_get_dy (const GskRenderNode *node) ;
function gsk_outset_shadow_node_get_dy(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_outset_shadow_node_get_dy
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_outset_shadow_node_get_spread (const GskRenderNode *node) ;
function gsk_outset_shadow_node_get_spread(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_outset_shadow_node_get_spread
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_outset_shadow_node_get_blur_radius (const GskRenderNode *node) ;
function gsk_outset_shadow_node_get_blur_radius(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_outset_shadow_node_get_blur_radius
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_cairo_node_get_type (void) ;
function gsk_cairo_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_cairo_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_cairo_node_new (const graphene_rect_t *bounds);
function gsk_cairo_node_new(bounds) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_cairo_node_new
  type(c_ptr), value :: bounds
end function

! GDK_AVAILABLE_IN_ALL
!cairo_t * gsk_cairo_node_get_draw_context (GskRenderNode *node);
function gsk_cairo_node_get_draw_context(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_cairo_node_get_draw_context
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!cairo_surface_t * gsk_cairo_node_get_surface (GskRenderNode *node);
function gsk_cairo_node_get_surface(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_cairo_node_get_surface
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_container_node_get_type (void) ;
function gsk_container_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_container_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_container_node_new (GskRenderNode **children, guint n_children);
function gsk_container_node_new(children, n_children) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_container_node_new
  type(c_ptr), value :: children
  integer(c_int), value :: n_children
end function

! GDK_AVAILABLE_IN_ALL
!guint gsk_container_node_get_n_children (const GskRenderNode *node) ;
function gsk_container_node_get_n_children(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_container_node_get_n_children
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_container_node_get_child (const GskRenderNode *node, guint idx) ;
function gsk_container_node_get_child(node, idx) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_container_node_get_child
  type(c_ptr), value :: node
  integer(c_int), value :: idx
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_transform_node_get_type (void) ;
function gsk_transform_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_transform_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_transform_node_new (GskRenderNode *child, GskTransform *transform);
function gsk_transform_node_new(child, transform) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: transform
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_transform_node_get_child (const GskRenderNode *node) ;
function gsk_transform_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GskTransform * gsk_transform_node_get_transform (const GskRenderNode *node) ;
function gsk_transform_node_get_transform(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_transform_node_get_transform
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_opacity_node_get_type (void) ;
function gsk_opacity_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_opacity_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_opacity_node_new (GskRenderNode *child, float opacity);
function gsk_opacity_node_new(child, opacity) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_opacity_node_new
  type(c_ptr), value :: child
  real(c_float), value :: opacity
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_opacity_node_get_child (const GskRenderNode *node) ;
function gsk_opacity_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_opacity_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_opacity_node_get_opacity (const GskRenderNode *node) ;
function gsk_opacity_node_get_opacity(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_opacity_node_get_opacity
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_color_matrix_node_get_type (void) ;
function gsk_color_matrix_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_color_matrix_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_color_matrix_node_new (GskRenderNode *child, const graphene_matrix_t *color_matrix, const graphene_vec4_t *color_offset);
function gsk_color_matrix_node_new(child, color_matrix, color_offset) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_color_matrix_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: color_matrix
  type(c_ptr), value :: color_offset
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_color_matrix_node_get_child (const GskRenderNode *node) ;
function gsk_color_matrix_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_color_matrix_node_get_child
  type(c_ptr), value :: node
end function

! 
!const graphene_matrix_t * gsk_color_matrix_node_get_color_matrix (const GskRenderNode *node) ;
function gsk_color_matrix_node_get_color_matrix(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_color_matrix_node_get_color_matrix
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_vec4_t * gsk_color_matrix_node_get_color_offset (const GskRenderNode *node) ;
function gsk_color_matrix_node_get_color_offset(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_color_matrix_node_get_color_offset
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_repeat_node_get_type (void) ;
function gsk_repeat_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_repeat_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_repeat_node_new (const graphene_rect_t *bounds, GskRenderNode *child, const graphene_rect_t *child_bounds);
function gsk_repeat_node_new(bounds, child, child_bounds) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_repeat_node_new
  type(c_ptr), value :: bounds
  type(c_ptr), value :: child
  type(c_ptr), value :: child_bounds
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_repeat_node_get_child (const GskRenderNode *node) ;
function gsk_repeat_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_repeat_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_rect_t * gsk_repeat_node_get_child_bounds (const GskRenderNode *node) ;
function gsk_repeat_node_get_child_bounds(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_repeat_node_get_child_bounds
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_clip_node_get_type (void) ;
function gsk_clip_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_clip_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_clip_node_new (GskRenderNode *child, const graphene_rect_t *clip);
function gsk_clip_node_new(child, clip) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_clip_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: clip
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_clip_node_get_child (const GskRenderNode *node) ;
function gsk_clip_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_clip_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_rect_t * gsk_clip_node_get_clip (const GskRenderNode *node) ;
function gsk_clip_node_get_clip(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_clip_node_get_clip
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_rounded_clip_node_get_type (void) ;
function gsk_rounded_clip_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_rounded_clip_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_rounded_clip_node_new (GskRenderNode *child, const GskRoundedRect *clip);
function gsk_rounded_clip_node_new(child, clip) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_rounded_clip_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: clip
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_rounded_clip_node_get_child (const GskRenderNode *node) ;
function gsk_rounded_clip_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_rounded_clip_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GskRoundedRect * gsk_rounded_clip_node_get_clip (const GskRenderNode *node) ;
function gsk_rounded_clip_node_get_clip(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_rounded_clip_node_get_clip
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!GType gsk_fill_node_get_type (void) ;
function gsk_fill_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_fill_node_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskRenderNode * gsk_fill_node_new (GskRenderNode *child, GskPath *path, GskFillRule fill_rule);
function gsk_fill_node_new(child, path, fill_rule) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_fill_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: path
  integer(c_int), value :: fill_rule
end function

! GDK_AVAILABLE_IN_4_14
!GskRenderNode * gsk_fill_node_get_child (const GskRenderNode *node);
function gsk_fill_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_fill_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_fill_node_get_path (const GskRenderNode *node);
function gsk_fill_node_get_path(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_fill_node_get_path
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!GskFillRule gsk_fill_node_get_fill_rule (const GskRenderNode *node);
function gsk_fill_node_get_fill_rule(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_fill_node_get_fill_rule
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!GType gsk_stroke_node_get_type (void) ;
function gsk_stroke_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_stroke_node_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskRenderNode * gsk_stroke_node_new (GskRenderNode *child, GskPath *path, const GskStroke *stroke);
function gsk_stroke_node_new(child, path, stroke) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_stroke_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: path
  type(c_ptr), value :: stroke
end function

! GDK_AVAILABLE_IN_4_14
!GskRenderNode * gsk_stroke_node_get_child (const GskRenderNode *node);
function gsk_stroke_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_stroke_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_stroke_node_get_path (const GskRenderNode *node);
function gsk_stroke_node_get_path(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_stroke_node_get_path
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!const GskStroke * gsk_stroke_node_get_stroke (const GskRenderNode *node);
function gsk_stroke_node_get_stroke(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_stroke_node_get_stroke
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_shadow_node_get_type (void) ;
function gsk_shadow_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_shadow_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_shadow_node_new (GskRenderNode *child, const GskShadow *shadows, gsize n_shadows);
function gsk_shadow_node_new(child, shadows, n_shadows) bind(c)
  import :: c_ptr, c_size_t
  implicit none
  type(c_ptr) :: gsk_shadow_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: shadows
  integer(c_size_t), value :: n_shadows
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_shadow_node_get_child (const GskRenderNode *node) ;
function gsk_shadow_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_shadow_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const GskShadow * gsk_shadow_node_get_shadow (const GskRenderNode *node, gsize i) ;
function gsk_shadow_node_get_shadow(node, i) bind(c)
  import :: c_ptr, c_size_t
  implicit none
  type(c_ptr) :: gsk_shadow_node_get_shadow
  type(c_ptr), value :: node
  integer(c_size_t), value :: i
end function

! GDK_AVAILABLE_IN_ALL
!gsize gsk_shadow_node_get_n_shadows (const GskRenderNode *node) ;
function gsk_shadow_node_get_n_shadows(node) bind(c)
  import :: c_size_t, c_ptr
  implicit none
  integer(c_size_t) :: gsk_shadow_node_get_n_shadows
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_blend_node_get_type (void) ;
function gsk_blend_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_blend_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_blend_node_new (GskRenderNode *bottom, GskRenderNode *top, GskBlendMode blend_mode);
function gsk_blend_node_new(bottom, top, blend_mode) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_blend_node_new
  type(c_ptr), value :: bottom
  type(c_ptr), value :: top
  integer(c_int), value :: blend_mode
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_blend_node_get_bottom_child (const GskRenderNode *node) ;
function gsk_blend_node_get_bottom_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_blend_node_get_bottom_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_blend_node_get_top_child (const GskRenderNode *node) ;
function gsk_blend_node_get_top_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_blend_node_get_top_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GskBlendMode gsk_blend_node_get_blend_mode (const GskRenderNode *node) ;
function gsk_blend_node_get_blend_mode(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_blend_node_get_blend_mode
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_cross_fade_node_get_type (void) ;
function gsk_cross_fade_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_cross_fade_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_cross_fade_node_new (GskRenderNode *start, GskRenderNode *end, float progress);
function gsk_cross_fade_node_new(start, end, progress) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_cross_fade_node_new
  type(c_ptr), value :: start
  type(c_ptr), value :: end
  real(c_float), value :: progress
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_cross_fade_node_get_start_child (const GskRenderNode *node) ;
function gsk_cross_fade_node_get_start_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_cross_fade_node_get_start_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_cross_fade_node_get_end_child (const GskRenderNode *node) ;
function gsk_cross_fade_node_get_end_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_cross_fade_node_get_end_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_cross_fade_node_get_progress (const GskRenderNode *node) ;
function gsk_cross_fade_node_get_progress(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_cross_fade_node_get_progress
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_text_node_get_type (void) ;
function gsk_text_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_text_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_text_node_new (PangoFont *font, PangoGlyphString *glyphs, const GdkRGBA *color, const graphene_point_t *offset);
function gsk_text_node_new(font, glyphs, color, offset) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_text_node_new
  type(c_ptr), value :: font
  type(c_ptr), value :: glyphs
  type(c_ptr), value :: color
  type(c_ptr), value :: offset
end function

! GDK_AVAILABLE_IN_ALL
!PangoFont * gsk_text_node_get_font (const GskRenderNode *node) ;
function gsk_text_node_get_font(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_text_node_get_font
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_2
!gboolean gsk_text_node_has_color_glyphs (const GskRenderNode *node) ;
function gsk_text_node_has_color_glyphs(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_text_node_has_color_glyphs
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!guint gsk_text_node_get_num_glyphs (const GskRenderNode *node) ;
function gsk_text_node_get_num_glyphs(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_text_node_get_num_glyphs
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const PangoGlyphInfo *gsk_text_node_get_glyphs (const GskRenderNode *node, guint *n_glyphs);
function gsk_text_node_get_glyphs(node, n_glyphs) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_text_node_get_glyphs
  type(c_ptr), value :: node
  type(c_ptr), value :: n_glyphs
end function

! GDK_AVAILABLE_IN_ALL
!const GdkRGBA * gsk_text_node_get_color (const GskRenderNode *node) ;
function gsk_text_node_get_color(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_text_node_get_color
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!const graphene_point_t *gsk_text_node_get_offset (const GskRenderNode *node) ;
function gsk_text_node_get_offset(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_text_node_get_offset
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_blur_node_get_type (void) ;
function gsk_blur_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_blur_node_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_blur_node_new (GskRenderNode *child, float radius);
function gsk_blur_node_new(child, radius) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_blur_node_new
  type(c_ptr), value :: child
  real(c_float), value :: radius
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderNode * gsk_blur_node_get_child (const GskRenderNode *node) ;
function gsk_blur_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_blur_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_ALL
!float gsk_blur_node_get_radius (const GskRenderNode *node) ;
function gsk_blur_node_get_radius(node) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_blur_node_get_radius
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_10
!GType gsk_mask_node_get_type (void) ;
function gsk_mask_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_mask_node_get_type
end function

! GDK_AVAILABLE_IN_4_10
!GskRenderNode * gsk_mask_node_new (GskRenderNode *source, GskRenderNode *mask, GskMaskMode mask_mode);
function gsk_mask_node_new(source, mask, mask_mode) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_mask_node_new
  type(c_ptr), value :: source
  type(c_ptr), value :: mask
  integer(c_int), value :: mask_mode
end function

! GDK_AVAILABLE_IN_4_10
!GskRenderNode * gsk_mask_node_get_source (const GskRenderNode *node);
function gsk_mask_node_get_source(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_mask_node_get_source
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_10
!GskRenderNode * gsk_mask_node_get_mask (const GskRenderNode *node);
function gsk_mask_node_get_mask(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_mask_node_get_mask
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_10
!GskMaskMode gsk_mask_node_get_mask_mode (const GskRenderNode *node);
function gsk_mask_node_get_mask_mode(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_mask_node_get_mask_mode
  type(c_ptr), value :: node
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GType gsk_gl_shader_node_get_type (void) ;
function gsk_gl_shader_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_gl_shader_node_get_type
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskRenderNode * gsk_gl_shader_node_new (GskGLShader *shader, const graphene_rect_t *bounds, GBytes *args, GskRenderNode **children, guint n_children);
function gsk_gl_shader_node_new(shader, bounds, args, children, n_children)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_gl_shader_node_new
  type(c_ptr), value :: shader
  type(c_ptr), value :: bounds
  type(c_ptr), value :: args
  type(c_ptr), value :: children
  integer(c_int), value :: n_children
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!guint gsk_gl_shader_node_get_n_children (const GskRenderNode *node) ;
function gsk_gl_shader_node_get_n_children(node) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gsk_gl_shader_node_get_n_children
  type(c_ptr), value :: node
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskRenderNode * gsk_gl_shader_node_get_child (const GskRenderNode *node, guint idx) ;
function gsk_gl_shader_node_get_child(node, idx) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gsk_gl_shader_node_get_child
  type(c_ptr), value :: node
  integer(c_int), value :: idx
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GBytes * gsk_gl_shader_node_get_args (const GskRenderNode *node) ;
function gsk_gl_shader_node_get_args(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_shader_node_get_args
  type(c_ptr), value :: node
end function

! GDK_DEPRECATED_IN_4_16_FOR(GtkGLArea)
!GskGLShader * gsk_gl_shader_node_get_shader (const GskRenderNode *node) ;
function gsk_gl_shader_node_get_shader(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_shader_node_get_shader
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!GType gsk_subsurface_node_get_type (void) ;
function gsk_subsurface_node_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_subsurface_node_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskRenderNode * gsk_subsurface_node_new (GskRenderNode *child, gpointer subsurface);
function gsk_subsurface_node_new(child, subsurface) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_subsurface_node_new
  type(c_ptr), value :: child
  type(c_ptr), value :: subsurface
end function

! GDK_AVAILABLE_IN_4_14
!GskRenderNode * gsk_subsurface_node_get_child (const GskRenderNode *node) ;
function gsk_subsurface_node_get_child(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_subsurface_node_get_child
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_14
!gpointer gsk_subsurface_node_get_subsurface (const GskRenderNode *node);
function gsk_subsurface_node_get_subsurface(node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_subsurface_node_get_subsurface
  type(c_ptr), value :: node
end function

! GDK_AVAILABLE_IN_4_4
!void gsk_value_set_render_node (GValue *value, GskRenderNode *node);
subroutine gsk_value_set_render_node(value, node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: value
  type(c_ptr), value :: node
end subroutine

! GDK_AVAILABLE_IN_4_4
!void gsk_value_take_render_node (GValue *value, GskRenderNode *node);
subroutine gsk_value_take_render_node(value, node) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: value
  type(c_ptr), value :: node
end subroutine

! GDK_AVAILABLE_IN_4_4
!GskRenderNode * gsk_value_get_render_node (const GValue *value);
function gsk_value_get_render_node(value) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_value_get_render_node
  type(c_ptr), value :: value
end function

! GDK_AVAILABLE_IN_4_4
!GskRenderNode * gsk_value_dup_render_node (const GValue *value);
function gsk_value_dup_render_node(value) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_value_dup_render_node
  type(c_ptr), value :: value
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gskpathmeasure.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_4_14
!GType gsk_path_measure_get_type (void) ;
function gsk_path_measure_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_path_measure_get_type
end function

! GDK_AVAILABLE_IN_4_14
!GskPathMeasure * gsk_path_measure_new (GskPath *path);
function gsk_path_measure_new(path) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_measure_new
  type(c_ptr), value :: path
end function

! GDK_AVAILABLE_IN_4_14
!GskPathMeasure * gsk_path_measure_new_with_tolerance (GskPath *path, float tolerance);
function gsk_path_measure_new_with_tolerance(path, tolerance) bind(c)
  import :: c_ptr, c_float
  implicit none
  type(c_ptr) :: gsk_path_measure_new_with_tolerance
  type(c_ptr), value :: path
  real(c_float), value :: tolerance
end function

! GDK_AVAILABLE_IN_4_14
!GskPathMeasure * gsk_path_measure_ref (GskPathMeasure *self);
function gsk_path_measure_ref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_measure_ref
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!void gsk_path_measure_unref (GskPathMeasure *self);
subroutine gsk_path_measure_unref(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: self
end subroutine

! GDK_AVAILABLE_IN_4_14
!GskPath * gsk_path_measure_get_path (GskPathMeasure *self) ;
function gsk_path_measure_get_path(self) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_path_measure_get_path
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!float gsk_path_measure_get_tolerance (GskPathMeasure *self) ;
function gsk_path_measure_get_tolerance(self) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_path_measure_get_tolerance
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!float gsk_path_measure_get_length (GskPathMeasure *self);
function gsk_path_measure_get_length(self) bind(c)
  import :: c_float, c_ptr
  implicit none
  real(c_float) :: gsk_path_measure_get_length
  type(c_ptr), value :: self
end function

! GDK_AVAILABLE_IN_4_14
!gboolean gsk_path_measure_get_point (GskPathMeasure *self, float distance, GskPathPoint *result);
function gsk_path_measure_get_point(self, distance, result) bind(c)
  import :: c_int, c_ptr, c_float
  implicit none
  integer(c_int) :: gsk_path_measure_get_point
  type(c_ptr), value :: self
  real(c_float), value :: distance
  type(c_ptr), value :: result
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gl/gskglrenderer.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/broadway/gskbroadwayrenderer.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gsk_broadway_renderer_get_type (void) ;
function gsk_broadway_renderer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_broadway_renderer_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderer * gsk_broadway_renderer_new (void);
function gsk_broadway_renderer_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_broadway_renderer_new
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gpu/gskvulkanrenderer.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gsk_vulkan_renderer_get_type (void) ;
function gsk_vulkan_renderer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_vulkan_renderer_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GskRenderer * gsk_vulkan_renderer_new (void);
function gsk_vulkan_renderer_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_vulkan_renderer_new
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/gsk/gpu/gskglrenderer.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GskRenderer *gsk_gl_renderer_new (void);
function gsk_gl_renderer_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_gl_renderer_new
end function

! GDK_AVAILABLE_IN_ALL
!GType gsk_gl_renderer_get_type (void) ;
function gsk_gl_renderer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_gl_renderer_get_type
end function

! GDK_DEPRECATED_IN_4_18_FOR (gsk_gl_renderer_get_type)
!GType gsk_ngl_renderer_get_type (void) ;
function gsk_ngl_renderer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gsk_ngl_renderer_get_type
end function

! GDK_DEPRECATED_IN_4_18_FOR (gsk_gl_renderer_new)
!GskRenderer *gsk_ngl_renderer_new (void);
function gsk_ngl_renderer_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gsk_ngl_renderer_new
end function

end interface
end module gsk

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! GTK Fortran Code Sketcher using UI definitions
! Contributed by Jens Hunger
! Last modifications: Harris Snyder 2020-07-11
! vmagnin 2020-10-16, 2022-04-07

module widgets
  ! declares the used GTK widgets
  use, intrinsic :: iso_c_binding

  implicit none
  type(c_ptr) :: window
  type(c_ptr) :: builder
  type(c_ptr) :: textbuffer
  type(c_ptr) :: license_selector
  type(c_ptr) :: appwindow_selector
  type(c_ptr) :: toplevel_widgets
  type(c_ptr) :: create_subdir_button
  type(c_ptr) :: create_handlerfiles_button
  type(c_ptr) :: overwrite_handlerfiles_button
  type(c_ptr) :: widget_symbols_button
  type(c_ptr) :: update_used_functions_button
  type(c_ptr) :: use_hl_gtk_button
  type(c_ptr) :: include_files_button
  type(c_ptr) :: widgetshandlers_button
  type(c_ptr) :: about_dialog
  type(c_ptr) :: my_gmainloop

  character(len=256,kind=c_char)::filename
  character(len=256,kind=c_char)::working_dir, base_dir
  character(len=65000,kind=c_char)::fileinfo
  logical::files_written=.false.
  logical::file_loaded=.false.

! options
  logical::create_subdir=.true.
  logical::create_handlerfiles=.true.
  logical::overwrite_handlerfiles=.false.
  logical::widget_symbols=.false.
  logical::update_used_functions=.false.
  logical::use_hl_gtk=.true.
  logical::include_files=.true.
  logical::widgetshandlers=.false.
end module


module connect
  use widgets

  use gtk, only: gtk_builder_add_from_file, gtk_builder_get_object, &
  & gtk_builder_new, gtk_widget_show, gtk_widget_hide, &
  & FALSE, c_null_char, c_null_ptr, TRUE, gtk_init, gtk_builder_get_objects, &
  & gtk_buildable_get_buildable_id, gtk_text_buffer_set_text,&
  & gtk_combo_box_get_active, gtk_combo_box_set_active, &
  & gtk_combo_box_get_model, gtk_widget_get_root, &
  & gtk_tree_model_get_value, gtk_tree_model_iter_nth_child,&
  & gtk_check_button_get_active, gtk_check_button_set_active,GTK_BUTTONS_OK,&
  & gtk_list_store_append, gtk_list_store_set_value, gtk_list_store_clear,&
  & gtk_window_destroy, g_signal_connect_swapped, g_signal_connect

  use g, only: g_object_unref, g_slist_length, g_slist_nth_data, &
  & g_value_get_string, g_slist_free, g_chdir, &
  & g_mkdir_with_parents, g_value_init, &
  & g_value_set_string, g_value_unset, &
  & g_main_loop_new, g_main_loop_run, g_main_loop_quit

  use gtk_hl, only: hl_gtk_file_chooser_show, hl_gtk_message_dialog_show

  use gtk_sup, only: gtktreeiter, gvalue, G_TYPE_STRING, c_f_logical, &
  & f_c_logical, fdate, copy_file, C_F_string_chars, C_F_string_ptr

  implicit none

  type signal_connection
    character(len=64)::object_name
    character(len=64)::signal_name
    character(len=64)::handler_name
  end type signal_connection

  integer::n_connections
  type(signal_connection), dimension(:), allocatable::connections
  type(c_ptr) :: gslist !list containing the widgets

  contains

! FIXME: In GTK 3, those two callback functions were used with gtk_builder_connect_signals_full()
! to obtain informations about signals defined in the UI file.
! In GTK 4, gtk_builder_connect_signals_full() is gone. We have not yet found a solution
! to replace it.
  subroutine count_connections (builder, object, signal_name, handler_name, connect_object, flags, user_data) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_char, c_int
    type(c_ptr), value                     :: builder        !a GtkBuilder
    type(c_ptr), value                     :: object         !object to connect a signal to
    character(kind=c_char), dimension(*)   :: signal_name    !name of the signal
    character(kind=c_char), dimension(*)   :: handler_name   !name of the handler
    type(c_ptr), value                     :: connect_object !a GObject, if non-NULL, use g_signal_connect_object()
    integer(c_int), value                  :: flags          !GConnectFlags to use
    type(c_ptr), value                     :: user_data      !user data

    n_connections=n_connections+1
  end subroutine count_connections

  subroutine get_connections (builder, object, signal_name, handler_name, connect_object, flags, user_data) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_char, c_int
    type(c_ptr), value                     :: builder        !a GtkBuilder
    type(c_ptr), value                     :: object         !object to connect a signal to
    character(kind=c_char), dimension(*)   :: signal_name    !name of the signal
    character(kind=c_char), dimension(*)   :: handler_name   !name of the handler
    type(c_ptr), value                     :: connect_object !a GObject, if non-NULL, use g_signal_connect_object()
    integer(c_int), value                  :: flags          !GConnectFlags to use
    type(c_ptr), value                     :: user_data      !user data

    character(len=64)                      :: sname
    character(len=64)                      :: hname
    type(c_ptr)                            :: object_name_ptr
    character(len=64)                      :: oname

    call C_F_string_chars(signal_name, sname)
    call C_F_string_chars(handler_name, hname)
    object_name_ptr=gtk_buildable_get_buildable_id (object)
    if (.not. C_associated(object_name_ptr)) then
      oname="unknown"
    else
      call C_F_string_ptr(object_name_ptr, oname)
    endif
    fileinfo=fileinfo(1:len_trim(fileinfo))//c_new_line//"object: "//trim(adjustl(oname))//"  signal: "//&
       trim(adjustl(sname))//"  handler: "//trim(adjustl(hname))
    n_connections=n_connections+1
    connections(n_connections)%object_name=oname
    connections(n_connections)%signal_name=sname
    connections(n_connections)%handler_name=hname
  end subroutine get_connections
end module connect


module handlers
  use connect

  implicit none
  integer :: log_unit

contains

  subroutine destroy (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: destroy
    type(c_ptr), value :: widget, gdata
    logical::lopened

    if (allocated(connections)) deallocate(connections)

    ! Closes the gtkf-sketcher.log file if necessary:
    inquire(unit=log_unit,opened=lopened)
    if (lopened) close(log_unit)

    call g_slist_free(gslist)

    print *, "my destroy"
    call g_main_loop_quit (my_gmainloop)
  end subroutine destroy


  subroutine create_subdir_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: create_subdir_toggled
    type(c_ptr), value :: widget, gdata
    create_subdir=c_f_logical(gtk_check_button_get_active(create_subdir_button))
    write(*,*)"subdir creation = ",create_subdir
  end subroutine create_subdir_toggled


  subroutine create_handlerfiles_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: create_handlerfiles_toggled
    type(c_ptr), value :: widget, gdata
    create_handlerfiles=c_f_logical(gtk_check_button_get_active(create_handlerfiles_button))
    write(*,*)"handlerfiles creation = ",create_handlerfiles
  end subroutine create_handlerfiles_toggled


  subroutine overwrite_handlerfiles_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: overwrite_handlerfiles_toggled
    type(c_ptr), value :: widget, gdata
    overwrite_handlerfiles=c_f_logical(gtk_check_button_get_active(overwrite_handlerfiles_button))
    write(*,*)"handlerfiles overwrite = ",overwrite_handlerfiles
  end subroutine overwrite_handlerfiles_toggled


  subroutine widget_symbols_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: widget_symbols_toggled
    type(c_ptr), value :: widget, gdata
    widget_symbols=c_f_logical(gtk_check_button_get_active(widget_symbols_button))
    write(*,*)"symbols for all widgets = ",widget_symbols
  end subroutine widget_symbols_toggled


  subroutine update_used_functions_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: update_used_functions_toggled
    type(c_ptr), value :: widget, gdata
    update_used_functions=c_f_logical(gtk_check_button_get_active(update_used_functions_button))
    write(*,*)"update used functions = ",update_used_functions
  end subroutine update_used_functions_toggled


  subroutine use_hl_gtk_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: use_hl_gtk_toggled
    type(c_ptr), value :: widget, gdata
    use_hl_gtk=c_f_logical(gtk_check_button_get_active(use_hl_gtk_button))
    write(*,*)"use high level interface = ",use_hl_gtk
  end subroutine use_hl_gtk_toggled


  subroutine include_files_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: include_files_toggled
    type(c_ptr), value :: widget, gdata
    include_files=c_f_logical(gtk_check_button_get_active(include_files_button))
    write(*,*)"generate include files = ",include_files
  end subroutine include_files_toggled


  subroutine widgetshandlers_toggled (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: widgetshandlers_toggled
    type(c_ptr), value :: widget, gdata
    widgetshandlers=c_f_logical(gtk_check_button_get_active(widgetshandlers_button))
    write(*,*)"generate separate files for widgets and handlers = ",widgetshandlers
  end subroutine widgetshandlers_toggled


  subroutine file_open (widget, gdata ) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int
    use gtk_sup, only: is_UNIX_OS
    !GCC$ ATTRIBUTES DLLEXPORT :: file_open
    type(c_ptr), value :: widget, gdata

    integer(c_int) :: isel
    character(len=120), dimension(:), allocatable :: chfile
    character(len=30), dimension(2) :: filters
    character(len=30), dimension(2) :: filtnames

    integer(c_int) :: guint, i
    type(c_ptr) :: error = c_null_ptr
    type(c_ptr) :: gpointer,object_name_ptr, root
    type(c_ptr) :: b
    character(len=128) :: f_string, last_root
    type(c_ptr) :: val
    type(gtktreeiter), target :: iter
    type(gvalue), target :: value

    filters(1) = "*.glade"
    filtnames(1) = "Glade UI file"
    filters(2) = "*.ui"
    filtnames(2) = "UI file"

    isel = hl_gtk_file_chooser_show(chfile, cdir=working_dir, create=FALSE,&
         & title="Select input file"//c_null_char, filter=filters, &
         & filter_name=filtnames, wsize=[ 600_c_int, 400_c_int ], edit_filters=TRUE, &
         & parent=window)
    if (.not. is_UNIX_OS()) then
        do i = 1, len(working_dir)
            if( working_dir(i:i)=="\" ) working_dir(i:i)="/"
        end do
    end if

    if (isel == FALSE) return   ! No selection made

    filename = chfile(1)
    deallocate(chfile)

    if (.not. is_UNIX_OS()) then
        do i = 1, len(filename)
            if( filename(i:i)=="\" ) filename(i:i)="/"
        end do
    end if

    files_written=.false.

    val = c_loc(value)
    val = g_value_init(val, G_TYPE_STRING)
    call gtk_list_store_clear(toplevel_widgets)

    ! Will contain the text to show in the gtk_text_buffer:
    fileinfo=filename(1:len_trim(filename))

    b = gtk_builder_new ()
    guint = gtk_builder_add_from_file (b, filename(1:len_trim(filename))//c_null_char, error)

    ! We count and print the list of objects found in the UI file:
    gslist = gtk_builder_get_objects(b)
    write(f_string,*) g_slist_length(gslist)," objects found"
    fileinfo=fileinfo(1:len_trim(fileinfo))//c_new_line//f_string
    last_root=""
    do i=0, g_slist_length(gslist)-1
      gpointer=g_slist_nth_data (gslist,i)
      object_name_ptr=gtk_buildable_get_buildable_id (gpointer)
      call C_F_string_ptr(object_name_ptr, f_string)
      fileinfo=fileinfo(1:len_trim(fileinfo))//c_new_line//f_string
      ! We add the names of the toplevel widgets in a list:
      root =  gtk_buildable_get_buildable_id(gtk_widget_get_root(gpointer))
      call C_F_string_ptr(root, f_string)
      if ((f_string /= last_root).and.(f_string /= "")) then
        call gtk_list_store_append (toplevel_widgets,c_loc(iter))
        call g_value_set_string(val, f_string(1:len_trim(f_string))//c_null_char)
        call gtk_list_store_set_value (toplevel_widgets,c_loc(iter),0_c_int,val)
      end if
      if (f_string /= "") last_root = f_string
    enddo

    n_connections=0
    ! FIXME: here, we need to count connections for the allocation of the connections array
    ! But in GTK 4, gtk_builder_connect_signals_full() is gone.
    write(f_string,*) n_connections," signal connections found"
    fileinfo=fileinfo(1:len_trim(fileinfo))//c_new_line//f_string
    ! Need to be unreferenced because b will be used a second time:
    call g_object_unref (b)

    ! Necessary if file_open() is called several times:
    if (allocated(connections)) deallocate(connections)

    allocate(connections(n_connections))

    ! Connections will be recounted as they are put into the connections array:
    n_connections=0

    b = gtk_builder_new ()
    guint = gtk_builder_add_from_file (b, filename(1:len_trim(filename))//c_null_char, error)
    ! FIXME: here, we must get connections.
    ! But in GTK 4, gtk_builder_connect_signals_full() is gone.
    fileinfo=fileinfo(1:len_trim(fileinfo))//c_new_line//"The GTK 4 version of gtkf-sketcher&
                     & can not detect signals in the UI file,"//c_new_line//" for the moment!"
    call g_object_unref (b)

    ! All the infos are printed in the GtkTextBuffer:
    call gtk_text_buffer_set_text (textbuffer, fileinfo(1:len_trim(fileinfo))//c_null_char, -1_c_int)

    call gtk_combo_box_set_active(appwindow_selector,0_c_int)
    call g_value_unset(val)

    file_loaded=.true.
  end subroutine file_open


  subroutine combobox_get_active_string_value(combobox,column,text)
    type(c_ptr)       :: combobox
    integer(c_int)    :: column
    character(len=256,kind=c_char)::text

    type(c_ptr):: model, val, textptr
    type(gtktreeiter), target :: iter
    integer(c_int) :: valid
    type(gvalue), target :: value

    model = gtk_combo_box_get_model(combobox)
    valid = gtk_tree_model_iter_nth_child(model, c_loc(iter), c_null_ptr, gtk_combo_box_get_active (combobox))
    val = c_loc(value)
    call gtk_tree_model_get_value(model, c_loc(iter), column, val)
    textptr = g_value_get_string(val)
    call C_F_string_ptr(textptr, text)
  end subroutine combobox_get_active_string_value


  subroutine write_files (widget, gdata ) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int
    !GCC$ ATTRIBUTES DLLEXPORT :: write_files
    type(c_ptr), value :: widget, gdata
    integer(c_int) :: valid
    character(len=256,kind=c_char)::subdir, license_file, line, &
         & handlerfile, appwindow
    integer::status_read, wunit, hunit, shellout_err
    integer(c_int)::i,j
    logical::already_used, lexist
    type(c_ptr) :: gpointer,object_name_ptr
    character(len=128) :: f_string, f_string_ori
    ! The text between "at signs" will be repplaced by CMake before compiling:
    character(len=*), parameter :: gtkf_prog_prefix= &
    &"@GTKF_PROG_PREFIX@"

    if (.not.file_loaded) then
      status_read=hl_gtk_message_dialog_show(["Please load some UI file first!"],&
        & GTK_BUTTONS_OK, title="No UI file loaded yet"//c_null_char, &
        & parent=window)
      return
    else
      print *, "1) Working dir: ", TRIM(ADJUSTL(working_dir))
      valid = g_chdir(TRIM(ADJUSTL(working_dir))//c_null_char)
      if (valid /= 0) print *, "1) g_chdir() problem <= ", valid

      subdir=filename(index(filename,"/",.true.)+1:index(filename,".",.true.)-1)
      if (create_subdir) then
        if (g_mkdir_with_parents (subdir(1:len_trim(subdir))//c_null_char,488_c_int) >= 0) then
          working_dir=working_dir(1:len_trim(working_dir))//"/"//subdir

          print *, "2) Working dir: ", TRIM(ADJUSTL(working_dir))
          valid = g_chdir(TRIM(ADJUSTL(working_dir))//c_null_char)
          if (valid /= 0) print *, "2) g_chdir() problem <= ", valid

          call copy_file(filename(1:len_trim(filename)),filename(index(filename,"/",.true.)+1:len_trim(filename)))
        else
          print *,"Unable to create subdirectory "//subdir
        endif
      endif

      print *, "Generating the .f90 files..."
      call combobox_get_active_string_value(license_selector, 1_c_int, license_file)
      license_file=adjustl(license_file)

      open(50, file=subdir(1:len_trim(subdir))//".f90", action='write')
      open(60, file=base_dir(1:len_trim(base_dir))//"/data/"//license_file(1:len_trim(license_file)), action='read')
      if (widgetshandlers) then
        wunit=80
        open(wunit, file=subdir(1:len_trim(subdir))//"_widgets.f90", action='write')
        write(wunit,'(A)')"! "//subdir(1:len_trim(subdir))//" widget module generated by gtkf-sketcher, "//fdate()
        write(wunit,'(A)')"!"
        write(wunit,'(A)')"! gtkf-sketcher is part of the gtk-fortran GTK Fortran Interface Library."
        write(wunit,'(A)')"!"
        write(wunit,'(A)')"!"
        rewind(60)
        do
          read(60,'(A)',iostat=status_read) line
          if ( status_read /= 0 ) exit
          write(wunit,'(A)')"! "//line(1:len_trim(line))
        enddo
        hunit=90
        open(hunit, file=subdir(1:len_trim(subdir))//"_handlers.f90", action='write')
        write(hunit,'(A)')"! "//subdir(1:len_trim(subdir))//" handler module generated by gtkf-sketcher, "//fdate()
        write(hunit,'(A)')"!"
        write(hunit,'(A)')"! gtkf-sketcher is part of the gtk-fortran GTK Fortran Interface Library."
        write(hunit,'(A)')"!"
        write(hunit,'(A)')"!"
        rewind(60)
        do
          read(60,'(A)',iostat=status_read) line
          if ( status_read /= 0 ) exit
          write(hunit,'(A)')"! "//line(1:len_trim(line))
        enddo
      else
        wunit=50
        hunit=50
      endif

      write(50,'(A)')"! "//subdir(1:len_trim(subdir))//" main program generated by gtkf-sketcher, "//fdate()
      write(50,'(A)')"!"
      write(50,'(A)')"! gtkf-sketcher is part of the gtk-fortran GTK Fortran Interface Library."
      write(50,'(A)')"!"
      write(50,'(A)')"!"
      rewind(60)
      do
        read(60,'(A)',iostat=status_read) line
        if ( status_read /= 0 ) exit
        write(50,'(A)')"! "//line(1:len_trim(line))
      enddo
      close(60)

      write(50,'(A)')"!"
      write(50,'(A)')"!"
      write(50,'(A)')"! Compile with:"
      write(50,'(A)')"! $ gfortran "//&
        subdir(1:len_trim(subdir))//".f90 -o "//subdir(1:len_trim(subdir))//&
        " $(pkg-config --cflags --libs gtk-4-fortran)"
      write(50,'(A)')"! With some systems, you may also need to export the PKG_CONFIG_PATH, for example in Fedora:"
      write(50,'(A)')"! $ export PKG_CONFIG_PATH=/usr/local/lib64/pkgconfig/"
      write(50,'(A)')"!"

      write(wunit,'(A)')""
      write(wunit,'(A)')"module widgets"
      write(wunit,'(A)')"! declares the used GTK widgets"
      write(wunit,'(A)')"  use, intrinsic :: iso_c_binding"
      write(wunit,'(A)')"  implicit none"
      write(wunit,'(A)')""
      if (widget_symbols) then
        do i=0, g_slist_length(gslist)-1
          gpointer=g_slist_nth_data (gslist,i)
          object_name_ptr=gtk_buildable_get_buildable_id (gpointer)
          call C_F_string_ptr(object_name_ptr, F_string)
          if (len_trim(f_string) > 0) then
            do
              j=index(f_string,"-")
              if (j > 0) then
                f_string(j:j)="_"
              else
                exit
              endif
            enddo
            write(wunit,'(A)')"  type(c_ptr) :: "//f_string(1:len_trim(f_string))
          endif
        enddo
      else
        write(wunit,'(A)')"  type(c_ptr) :: window"
      endif
      write(wunit,'(A)')"  type(c_ptr) :: builder"
      write(wunit,'(A)')""
      write(wunit,'(A)')"end module"
      write(wunit,'(A)')""

      write(hunit,'(A)')""
      write(hunit,'(A)')"module handlers"
      write(hunit,'(A)')"  use gtk, only: gtk_builder_add_from_file, &"
      write(hunit,'(A)')"  & gtk_builder_get_object, gtk_builder_new, &"
      write(hunit,'(A)')"  & gtk_widget_show, FALSE, c_null_char, c_null_ptr, gtk_init"
      write(hunit,'(A)')"  use g, only: g_object_unref, g_main_loop_new, g_main_loop_run, g_main_loop_quit"

      if (update_used_functions) then

        write(*,*)working_dir

        call execute_command_line("python3 usemodules.py .", exitstat=shellout_err)
        if(shellout_err /= 0) then
            write(*,*) "usemodules.py failed or not found, trying "//gtkf_prog_prefix//"-pymodscan"
            call execute_command_line("python3 "//gtkf_prog_prefix//"-pymodscan .", exitstat=shellout_err)
            if(shellout_err /= 0) then
                write(*,*) gtkf_prog_prefix//"-pymodscan failed or not found, aborting"
                stop
            end if
        end if

        open (40, file="usemodules.txt", action='read')
        do
          read(40,'(A)',iostat=status_read) line
          if ( status_read /= 0 ) exit
          if (index(line,"handler") > 0) then
            read(40,'(A)',iostat=status_read) line
            do
              read(40,'(A)',iostat=status_read) line
              if ((status_read /= 0).or.(len_trim(line) == 0)) exit
              write(hunit,'(A)')"  "//line(1:len_trim(line))
            enddo
          endif
        enddo
        close (40)

        print *, "4) Working dir: ", TRIM(ADJUSTL(working_dir))
        valid = g_chdir(TRIM(ADJUSTL(working_dir))//c_null_char)
        if (valid /= 0) print *, "4) g_chdir() problem <= ", valid
      endif

      if (use_hl_gtk) then
        write(hunit,'(A)')"  use gtk_hl"
      endif

      if (include_files) then
        inquire(file=subdir(1:len_trim(subdir))//"_used_modules.inc",exist=lexist)
        if ((.not.lexist).or.(overwrite_handlerfiles)) then
          open(70,file=subdir(1:len_trim(subdir))//"_used_modules.inc",action='write')
          write(70,'(A)')"! Additionally used modules for "//subdir(1:len_trim(subdir))
          write(70,'(A)')"!########## INSERT YOUR USE STATEMENTS HERE ##########"
          write(70,'(A)')""
          write(70,'(A)')"!#####################################################"
          close(70)
        endif
        write(hunit,'(A)')"  include """//subdir(1:len_trim(subdir))//"_used_modules.inc"""
      endif

      write(hunit,'(A)')"  use widgets"
      write(hunit,'(A)')"  implicit none"
      write(hunit,'(A)')"  type(c_ptr) :: my_gmainloop"
      write(hunit,'(A)')""

      if (include_files) then
        inquire(file=subdir(1:len_trim(subdir))//"_global_variables.inc",exist=lexist)
        if ((.not.lexist).or.(overwrite_handlerfiles)) then
          open(70,file=subdir(1:len_trim(subdir))//"_global_variables.inc",action='write')
          write(70,'(A)')"! Global variables for "//subdir(1:len_trim(subdir))
          write(70,'(A)')"!########## INSERT YOUR DECLARATIONS HERE ##########"
          write(70,'(A)')""
          write(70,'(A)')"!###################################################"
          close(70)
        endif
        write(hunit,'(A)')"  include """//subdir(1:len_trim(subdir))//"_global_variables.inc"""
      endif

      write(hunit,'(A)')""
      write(hunit,'(A)')"contains"
      write(hunit,'(A)')"  !*************************************"
      write(hunit,'(A)')"  ! User defined event handlers go here"
      write(hunit,'(A)')"  !*************************************"

      do i=1,n_connections
        already_used=.false.
        if (i > 1) then
          do j=1,i-1
            if (connections(i)%handler_name == connections(j)%handler_name) then
              already_used=.true.
              exit
            endif
          enddo
        endif
        if (.not.already_used) then
          write(hunit,'(A)')"! handler function for signal "//connections(i)%signal_name(1:len_trim(connections(i)%signal_name))//&
            " ("//connections(i)%object_name(1:len_trim(connections(i)%object_name))//")"
          if (index(connections(i)%signal_name,"event") > 0) then
            write(hunit,'(A)')"  function "//connections(i)%handler_name(1:len_trim(connections(i)%handler_name))//&
              " (widget, event, gdata) result(ret) bind(c)"
            write(hunit,'(A)')"    use, intrinsic :: iso_c_binding, only: c_ptr, c_int"
            write(hunit,'(A)')"    !GCC$ ATTRIBUTES DLLEXPORT :: "//&
              connections(i)%handler_name(1:len_trim(connections(i)%handler_name))
            write(hunit,'(A)')"    integer(c_int)     :: ret"
            write(hunit,'(A)')"    type(c_ptr), value :: widget, event, gdata"
          else
            write(hunit,'(A)')"  function "//connections(i)%handler_name(1:len_trim(connections(i)%handler_name))//&
              " (widget, gdata) result(ret) bind(c)"
            write(hunit,'(A)')"    use, intrinsic :: iso_c_binding, only: c_ptr, c_int"
            write(hunit,'(A)')"    !GCC$ ATTRIBUTES DLLEXPORT :: "//&
              connections(i)%handler_name(1:len_trim(connections(i)%handler_name))
            write(hunit,'(A)')"    integer(c_int)     :: ret"
            write(hunit,'(A)')"    type(c_ptr), value :: widget, gdata"
          endif
          if (create_handlerfiles) then
            handlerfile="handler_"//connections(i)%handler_name(1:len_trim(connections(i)%handler_name))//".f90"
            write(hunit,'(A)')"!########## INSERT YOUR HANDLER CODE IN FILE "//handlerfile(1:len_trim(handlerfile))//" ##########"
            write(hunit,'(A)')"    INCLUDE '"//handlerfile(1:len_trim(handlerfile))//"'"
            inquire(file=handlerfile,exist=lexist)
            if ((.not.lexist).or.(overwrite_handlerfiles)) then
              open(70,file=handlerfile,action='write')
              write(70,'(A)')"! handler for signal "//connections(i)%signal_name(1:len_trim(connections(i)%signal_name))//&
                " ("//connections(i)%object_name(1:len_trim(connections(i)%object_name))//")"
              write(70,'(A)')"!########## INSERT YOUR HANDLER CODE HERE ##########"
              write(70,'(A)')"print*,""handler function: "//connections(i)%handler_name(1:len_trim(connections(i)%handler_name))//&
                """"
              write(70,'(A)')"!###################################################"
              close(70)
            endif
          else
            write(hunit,'(A)')"!########## INSERT YOUR HANDLER CODE HERE ##########"
            write(hunit,'(A)')"print*,""handler function: "//connections(i)%handler_name(1:len_trim(connections(i)%handler_name))//&
              """"
            write(hunit,'(A)')"!###################################################"
          endif
          write(hunit,'(A)')"    ret = FALSE"
          write(hunit,'(A)')"  end function "//connections(i)%handler_name(1:len_trim(connections(i)%handler_name))
          write(hunit,'(A)')""
        endif
      enddo
      write(hunit,'(A)')"end module handlers"
      write(hunit,'(A)')""

      write(50,'(A)')""
      write(50,'(A)')"program "//subdir(1:len_trim(subdir))
      write(50,'(A)')""
      write(50,'(A)')"  use handlers"
      write(50,'(A)')""
      write(50,'(A)')"  implicit none"
      write(50,'(A)')""
      write(50,'(A)')"  integer(c_int) :: guint"
      write(50,'(A)')"  type(c_ptr) :: error"
      write(50,'(A)')"  error = c_null_ptr"
      write(50,'(A)')""
      write(50,'(A)')"  ! Initialize the GTK Library"
      write(50,'(A)')"  call gtk_init ()"
      write(50,'(A)')""
      write(50,'(A)')"  ! create a new GtkBuilder object"
      write(50,'(A)')"  builder = gtk_builder_new ()"
      write(50,'(A)')""
      write(50,'(A)')"  ! parse the UI XML file 'gtkbuilder.glade' and add it's contents to the GtkBuilder object"
      write(50,'(A)')"  guint = gtk_builder_add_from_file (builder, """//subdir(1:len_trim(subdir))//".glade""//c_null_char, error)"
      write(50,'(A)')""
      call combobox_get_active_string_value(appwindow_selector, 0_c_int, appwindow)
      if (widget_symbols) then
        write(50,'(A)')"  ! get pointers to all GObjects from GtkBuilder"
        do i=0, g_slist_length(gslist)-1
          gpointer=g_slist_nth_data (gslist,i)
          object_name_ptr=gtk_buildable_get_buildable_id (gpointer)
          call C_F_string_ptr(object_name_ptr, F_string)
          if (len_trim(f_string) > 0) then
            f_string_ori=f_string
            do
              j=index(f_string,"-")
              if (j > 0) then
                f_string(j:j)="_"
              else
                exit
              endif
            enddo
            write(50,'(A)')"  "//f_string(1:len_trim(f_string))//"&"
            write(50,'(A)')"    = gtk_builder_get_object (builder, """//f_string_ori(1:len_trim(f_string_ori))//"""//c_null_char)"
          endif
        enddo
      else
        write(50,'(A)')"  ! get a pointer to the application window """//appwindow(1:len_trim(appwindow))//&
          """ from GtkBuilder"
        write(50,'(A)')"  "//appwindow(1:len_trim(appwindow))//" = gtk_builder_get_object (builder, """//&
          appwindow(1:len_trim(appwindow))//"""//c_null_char)"
      endif
      write(50,'(A)')""
      write(50,'(A)')"  ! use GModule to look at the applications symbol table to find the function name"
      write(50,'(A)')"  ! that matches the handler name specified in the UI file"
      write(50,'(A)')""
      write(50,'(A)')"  ! free all memory used by XML stuff"
      write(50,'(A)')"  call g_object_unref (builder)"
      write(50,'(A)')""
      write(50,'(A)')"  ! show the application window"
      write(50,'(A)')"  call gtk_widget_show ("//appwindow(1:len_trim(appwindow))//")"
      write(50,'(A)')""
      write(50,'(A)')"  ! enter the GTK main loop"
      write(50,'(A)')"  my_gmainloop = g_main_loop_new(c_null_ptr, FALSE)"
      write(50,'(A)')"  call g_main_loop_run(my_gmainloop)"
      write(50,'(A)')""
      write(50,'(A)')"end program "//subdir(1:len_trim(subdir))
      close(50)
      if (widgetshandlers) then
        close(wunit)
        close(hunit)
      endif

      files_written=.true.
    endif
  end subroutine write_files


  subroutine save_default_options (widget, gdata ) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int
    !GCC$ ATTRIBUTES DLLEXPORT :: save_default_options
    type(c_ptr), value :: widget, gdata
    character(len=20)::defaultsfile="default.options"

    open(111,file=base_dir(1:len_trim(base_dir))//"/"//defaultsfile, action='write')
    write(111,'(8L1)')create_subdir,create_handlerfiles,overwrite_handlerfiles,widget_symbols,update_used_functions,&
      use_hl_gtk,include_files,widgetshandlers
    write(111,'(I2)')gtk_combo_box_get_active(license_selector)
    close(111)
  end subroutine save_default_options


  subroutine load_default_options
    character(len=20)::defaultsfile="default.options"
    integer(c_int) ::license_no

    open(111,file=base_dir(1:len_trim(base_dir))//"/"//defaultsfile, action='read')
    read(111,'(8L1)')create_subdir,create_handlerfiles,overwrite_handlerfiles,widget_symbols,update_used_functions,&
      use_hl_gtk,include_files,widgetshandlers
    read(111,'(I2)')license_no
    call gtk_combo_box_set_active(license_selector,license_no)
    close(111)
  end subroutine load_default_options


  subroutine default_options (widget, gdata ) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int
    use gtk_sup, only: is_UNIX_OS
    !GCC$ ATTRIBUTES DLLEXPORT :: default_options
    type(c_ptr), value :: widget, gdata
    integer :: i

    call get_environment_variable("PWD", working_dir)
    if (.not. is_UNIX_OS()) then
        do i = 1, len(working_dir)
            if( working_dir(i:i)=="\" ) working_dir(i:i)="/"
        end do
    end if
    print *, "PWD: ", TRIM(ADJUSTL(working_dir))

    call load_default_options
    call gtk_check_button_set_active (create_subdir_button, f_c_logical(create_subdir))
    call gtk_check_button_set_active (create_handlerfiles_button, f_c_logical(create_handlerfiles))
    call gtk_check_button_set_active (overwrite_handlerfiles_button, f_c_logical(overwrite_handlerfiles))
    call gtk_check_button_set_active (widget_symbols_button, f_c_logical(widget_symbols))
    call gtk_check_button_set_active (update_used_functions_button, f_c_logical(update_used_functions))
    call gtk_check_button_set_active (use_hl_gtk_button, f_c_logical(use_hl_gtk))
    call gtk_check_button_set_active (include_files_button, f_c_logical(include_files))
    call gtk_check_button_set_active (widgetshandlers_button, f_c_logical(widgetshandlers))
  end subroutine default_options


  subroutine show_about_dialog (widget, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr
    !GCC$ ATTRIBUTES DLLEXPORT :: show_about_dialog
    type(c_ptr), value :: widget, gdata

    call gtk_widget_show(about_dialog)
    call g_signal_connect(about_dialog, "close-request"//c_null_char, &
                                    & c_funloc(gtk_widget_hide))
  end subroutine show_about_dialog
end module handlers


program gtkfsketcher
  use handlers

  implicit none
  integer(c_int) :: guint
  type(c_ptr) :: error
  error = c_null_ptr

  call get_environment_variable("PWD", base_dir)
  open(newunit=log_unit, file="gtkf-sketcher.log", action='write')

  ! Initialize the GTK Library
  call gtk_init ()

  ! create a new GtkBuilder object
  builder = gtk_builder_new ()

  ! parse the UI XML file 'gtkbuilder.glade' and add it's contents to the GtkBuilder object
  guint = gtk_builder_add_from_file (builder, "gtkf-sketcher.glade"//c_null_char, error)
  if (guint == 0) then
     print *, "Could not open gtkf-sketcher.glade"
     stop
  end if

  ! get a pointer to the GObject "window" from GtkBuilder
  window = gtk_builder_get_object (builder, "window"//c_null_char)

  ! get a pointer to the file info text field buffer
  textbuffer = gtk_builder_get_object (builder, "fileinfo_buffer"//c_null_char)

  ! get a pointer to the selection combo boxes
  license_selector = gtk_builder_get_object (builder, "license"//c_null_char)
  appwindow_selector = gtk_builder_get_object (builder, "appwindow"//c_null_char)
  toplevel_widgets = gtk_builder_get_object (builder, "toplevel_widgets"//c_null_char)

  ! get pointers to the option check buttons
  create_subdir_button = gtk_builder_get_object (builder, "create_subdir"//c_null_char)
  create_handlerfiles_button = gtk_builder_get_object (builder, "create_handlerfiles"//c_null_char)
  overwrite_handlerfiles_button = gtk_builder_get_object (builder, "overwrite_handlerfiles"//c_null_char)
  widget_symbols_button = gtk_builder_get_object (builder, "widget_symbols"//c_null_char)
  update_used_functions_button = gtk_builder_get_object (builder, "update_used_functions"//c_null_char)
  use_hl_gtk_button = gtk_builder_get_object (builder, "use_hl_gtk"//c_null_char)
  include_files_button = gtk_builder_get_object (builder, "include_files"//c_null_char)
  widgetshandlers_button = gtk_builder_get_object (builder, "widgetshandlers"//c_null_char)

  ! get pointers to the about dialog
  about_dialog = gtk_builder_get_object (builder, "about"//c_null_char)

  ! get default options
  call default_options (builder, error)

  ! free all memory used by XML stuff
  call g_object_unref (builder)

  ! Show the Application Window
  call gtk_widget_show (window)

  ! Enter the GTK Main Loop
  my_gmainloop = g_main_loop_new(c_null_ptr, FALSE)
  call g_main_loop_run(my_gmainloop)
end program gtkfsketcher

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
! Contributed by James Tappin (2011)
! Last modifications: vmagnin 2020-06-18

module gtk_hl
  !*
  ! High Level GTK Fortran interfaces
  !
  ! A collection of procedures to implement higher level creators for
  ! the gtk-fortran widgets. Some settings and operations are also
  ! provided for the more intricate widgets.
  !
  ! Many ideas in this module were taken from the pilib gtk<->fortran
  ! interface.
  !/

  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_entry
  use gtk_hl_tree
  use gtk_hl_progress
  use gtk_hl_dialog
  use gtk_hl_chooser
  use gtk_hl_spin_slider
  use gtk_hl_combobox
  use gtk_hl_infobar
  use gtk_hl_assistant

  use gtk_hl_misc

end module gtk_hl

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
! ---------------------------------------------------------
! Contributed by James Tappin
! Last modification: 2012-18-09
! Last modification: vmagnin (GTK 4) 2020-07-15
! ---------------------------------------------------------

!*
! Sliders and Spin buttons
module gtk_hl_spin_slider
  ! GTK sliders and spin buttons use floating point values, the HL interface
  ! implements an automatic interface selection between a floating point or
  ! an integer slider.
  !
  ! Although they belong to completely different widget families in GTK, the
  ! interfaces are very similar, which is why they are grouped together here.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding
  ! Autogenerated use's
  use gtk, only:  gtk_range_get_value, gtk_range_set_value,&
       & gtk_scale_new_with_range,&
       & gtk_scale_set_digits, gtk_scale_set_draw_value,&
       & gtk_spin_button_get_value, gtk_spin_button_new,&
       & gtk_spin_button_new_with_range, gtk_spin_button_set_digits,&
       & gtk_spin_button_set_numeric, gtk_spin_button_set_value,&
       & gtk_spin_button_set_wrap, gtk_widget_set_sensitive,&
       & gtk_widget_set_size_request, gtk_widget_set_tooltip_text, &
       & gtk_spin_button_get_adjustment, gtk_adjustment_get_lower, &
       & gtk_adjustment_get_upper, gtk_range_get_adjustment, &
       & gtk_spin_button_set_range, gtk_range_set_range, &
       & gtk_range_set_increments, gtk_spin_button_set_increments, &
       & GTK_ORIENTATION_HORIZONTAL,  GTK_ORIENTATION_VERTICAL, &
       & TRUE, FALSE, g_signal_connect

  implicit none

  ! A slider or a spin button can use integers or floats for its settings.
  interface hl_gtk_slider_new
     module procedure hl_gtk_slider_flt_new
     module procedure hl_gtk_slider_int_new
  end interface hl_gtk_slider_new
  interface hl_gtk_slider_set_value
     module procedure hl_gtk_slider_set_flt
     module procedure hl_gtk_slider_set_int
  end interface hl_gtk_slider_set_value

  interface hl_gtk_spin_button_new
     module procedure hl_gtk_spin_button_flt_new
     module procedure hl_gtk_spin_button_int_new
  end interface hl_gtk_spin_button_new
  interface hl_gtk_spin_button_set_value
     module procedure hl_gtk_spin_button_set_flt
     module procedure hl_gtk_spin_button_set_int
  end interface hl_gtk_spin_button_set_value

contains

  !+
  function hl_gtk_slider_flt_new(vmin, vmax, step, vertical, initial_value, &
       & value_changed, data, digits, sensitive, tooltip, draw, length) &
       & result(slider)

    type(c_ptr) :: slider
    real(c_double), intent(in) :: vmin, vmax, step
    integer(c_int), intent(in), optional :: vertical
    real(c_double), intent(in), optional :: initial_value
    type(c_funptr), optional :: value_changed
    type(c_ptr), optional :: data
    integer(c_int), optional, intent(in) :: digits
    integer(c_int), optional, intent(in) :: sensitive
    character(len=*), intent(in), optional:: tooltip
    integer(c_int), intent(in), optional :: draw
    integer(c_int), intent(in), optional :: length

    ! Floating point version of a slider
    !
    ! VMIN |  c_double |  required |  The minimum value for the slider
    ! VMAX |  c_double |  required |  The maximum value for the slider
    ! STEP |  c_double |  required |  The step for the slider.
    ! VERTICAL |  boolean |  optional |  if TRUE then a vertical slider is created if FALSE or absent, then a horizontal silder is created.
    ! INITIAL_VALUE |  c_double |  optional |  Set the intial value of the slider
    ! VALUE_CHANGED |  c_funptr |  optional |  Callback function for the "value-changed" signal.
    ! DATA |  c_ptr |  optional |  User data to pass the the value_changed callback.
    ! DIGITS |  c_int |  optional |  Number of decimal places to show.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is created in the sensitive state.
    ! TOOLTIP |  string |  optional |  A tooltip to display.
    ! DRAW |  boolean |  optional |  Set to FALSE to suppress writing the value.
    ! LENGTH |  c_int |  optional |  Set the length of the slider in pixels
    !
    ! This routine is usually called via its generic interface
    ! hl_gtk_slider_new
    !-

    integer(c_int) :: isvertical, idraw

    ! Create the slider
    if (present(vertical)) then
       isvertical = vertical
    else
       isvertical = FALSE
    end if
    if (isvertical == TRUE) then
       slider = gtk_scale_new_with_range(GTK_ORIENTATION_VERTICAL, &
            & vmin, vmax, step)
       if (present(length)) &
            & call gtk_widget_set_size_request(slider, -1_c_int, length)
    else
       slider = gtk_scale_new_with_range(GTK_ORIENTATION_HORIZONTAL, &
            & vmin, vmax, step)
       if (present(length)) &
            & call gtk_widget_set_size_request(slider, length, -1_c_int)
    end if

    ! Formatting
    if (present(draw)) then
       idraw = draw
    else
       idraw = TRUE
    end if
    call gtk_scale_set_draw_value(slider, idraw)
    if (present(digits)) call gtk_scale_set_digits(slider, digits)

    ! Initial value
    if (present(initial_value)) call gtk_range_set_value(slider, initial_value)

    ! Callback connection
    if (present(value_changed)) then
       if (present(data)) then
          call g_signal_connect(slider, "value-changed"//c_null_char, &
               & value_changed, data)
       else
          call g_signal_connect(slider, "value-changed"//c_null_char, &
               & value_changed)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(slider, &
         & trim(tooltip)//c_null_char)

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(slider, sensitive)
  end function hl_gtk_slider_flt_new

  !+
  function hl_gtk_slider_int_new(imin, imax, vertical, initial_value, &
       & value_changed, data, sensitive, tooltip, draw, length) result(slider)

    type(c_ptr) :: slider
    integer(c_int), intent(in) :: imin, imax
    integer(c_int), intent(in), optional :: vertical
    integer(c_int), intent(in), optional :: initial_value
    type(c_funptr), optional :: value_changed
    type(c_ptr), optional :: data
    integer(c_int), optional, intent(in) :: sensitive
    character(len=*), intent(in), optional:: tooltip ! NB the C-type confuses generic interfaces.
    integer(c_int), intent(in), optional :: draw
    integer(c_int), intent(in), optional :: length

    ! Integer version of a slider
    !
    ! IMIN |  c_int |  required |  The minimum value for the slider
    ! IMAX |  c_int |  required |  The maximum value for the slider
    ! VERTICAL |  boolean |  optional |  if TRUE then a vertical slider is created if FALSE or absent, then a horizontal silder is created.
    ! INITIAL_VALUE |  c_int |  optional |  Set the intial value of the slider
    ! VALUE_CHANGED |  c_funptr |  optional |  Callback function for the "value-changed" signal.
    ! DATA |  c_ptr |  optional |  User data to pass the the value_changed callback.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is created in the sensitive state.
    ! TOOLTIP |  string |  optional |  A tooltip to display.
    ! DRAW |  boolean |  optional |  Set to FALSE to suppress writing the value.
    ! LENGTH |  c_int |  optional |  Set the length of the slider in pixels
    !
    ! This routine is usually called via its generic interface
    ! hl_gtk_slider_new
    !-

    if (present(initial_value)) then
       slider = hl_gtk_slider_flt_new(real(imin, c_double), &
         & real(imax, c_double), 1.0_c_double, &
         & vertical=vertical, initial_value=real(initial_value, c_double), &
         & value_changed=value_changed, data=data, sensitive=sensitive, &
         & tooltip=tooltip, draw=draw, length=length)
    else
       slider = hl_gtk_slider_flt_new(real(imin, c_double), &
         & real(imax, c_double), 1.0_c_double, &
         & vertical=vertical, &
         & value_changed=value_changed, data=data, sensitive=sensitive, &
         & tooltip=tooltip, draw=draw, length=length)
    end if
  end function hl_gtk_slider_int_new

  !+
  function hl_gtk_slider_get_value(slider) result(val)

    real(c_double) :: val
    type(c_ptr) :: slider

    ! Get the value of a slider
    !
    ! SLIDER |  c_ptr |  required |  The slider to read.
    !
    ! Note even for an integer slider we get a float value but there's
    ! no problem letting Fortran do the truncation
    !-

    val = gtk_range_get_value(slider)
  end function hl_gtk_slider_get_value

  !+
  subroutine hl_gtk_slider_set_flt(slider, val)

    type(c_ptr), intent(in) :: slider
    real(c_double), intent(in) :: val

    ! Set a floating point value for a slider
    !
    ! SLIDER |  c_ptr |  required |  The slider to set.
    ! VAL |  c_double |  required |  The value to set.
    !
    ! This is usually accessed via the generic interface
    ! hl_gtk_slider_set_value. Note that since GTK implements all sliders
    ! a doubles, either type of value may be used to set any slider.
    !-

    call gtk_range_set_value(slider, val)
  end subroutine hl_gtk_slider_set_flt

  !+
  subroutine hl_gtk_slider_set_int(slider, val)

    type(c_ptr), intent(in) :: slider
    integer(c_int), intent(in) :: val

    ! Set an integer value for a slider
    !
    ! SLIDER |  c_ptr |  required |  The slider to set.
    ! VAL |  c_int |  required |  The value to set.
    !
    ! This is usually accessed via the generic interface
    ! hl_gtk_slider_set_value. Note that since GTK implements all sliders
    ! a doubles, either type of value may be used to set any slider.
    !-

    call gtk_range_set_value(slider, real(val, c_double))
  end subroutine hl_gtk_slider_set_int

  !+
  subroutine hl_gtk_slider_set_range(slider, lower, upper, step, digits)
    type(c_ptr), intent(in) :: slider
    real(c_double), intent(in), optional :: lower, upper, step
    integer(c_int), intent(in), optional :: digits

    ! Adjust the bounds of a slider
    !
    ! SLIDER |  c_ptr |  required |  The slider to modify
    ! LOWER |  c_double |  optional |  The new lower bound
    ! UPPER |  c_double |  optional |  The new uppper bound
    ! STEP |  c_double |  optional |  The new step size.
    ! DIGITS |  c_int |  optional |  The new number of decimals.
    !
    ! **Note** This routine is not a generic interface as
    ! overloading requires that the interface be distinguishable by its
    ! required arguments, and it seems less annoying to have to convert to
    ! doubles or use a separate call than to specify an unchanged bound.
    !-

    type(c_ptr) :: adjustment
    real(c_double) :: nlower, nupper

    if (present(upper) .or. present(lower)) then

       adjustment = gtk_range_get_adjustment(slider)
       if (present(lower)) then
          nlower = lower
       else
          nlower = gtk_adjustment_get_lower(adjustment)
       end if

       if (present(upper)) then
          nupper = upper
       else
          nupper = gtk_adjustment_get_upper(adjustment)
       end if

       call gtk_range_set_range(slider, nlower, nupper)
    end if

    if (present(step)) &
         & call gtk_range_set_increments(slider, step, 10.*step)
    if (present(digits)) call gtk_scale_set_digits(slider, digits)

  end subroutine hl_gtk_slider_set_range

  !+
  subroutine hl_gtk_slider_set_range_int(slider, lower, upper)
    type(c_ptr), intent(in) :: slider
    integer(c_int), intent(in), optional :: lower, upper

    ! Adjust the bounds of a slider, integer values
    !
    ! SLIDER |  c_ptr |  required |  The slider to modify
    ! LOWER |  c_int |  optional |  The new lower bound
    ! UPPER |  c_int |  optional |  The new uppper bound
    !
    ! **Note** This routine is not a generic interface as
    ! overloading requires that the interface be distinguishable by its
    ! required arguments, and it seems less annoying to use a separate
    ! call than to specify an unchanged bound.
    !-

    type(c_ptr) :: adjustment
    real(c_double) :: nlower, nupper

    ! Check it's not a do-nothing
    if (.not. (present(upper) .or. present(lower))) return

    adjustment = gtk_range_get_adjustment(slider)
    if (present(lower)) then
       nlower = real(lower, c_double)
    else
       nlower = gtk_adjustment_get_lower(adjustment)
    end if

    if (present(upper)) then
       nupper = real(upper, c_double)
    else
       nupper = gtk_adjustment_get_upper(adjustment)
    end if

    call gtk_range_set_range(slider, nlower, nupper)

  end subroutine hl_gtk_slider_set_range_int

  !+
  function hl_gtk_spin_button_flt_new(vmin, vmax, step, initial_value, &
       & value_changed, data, digits, sensitive, tooltip, wrap, &
       & focus_in_event, focus_out_event, data_focus_in, data_focus_out) &
       & result(spin_button)

    type(c_ptr) :: spin_button
    real(c_double), intent(in) :: vmin, vmax, step
    real(c_double), intent(in), optional :: initial_value
    type(c_funptr), optional :: value_changed
    type(c_ptr), optional :: data
    integer(c_int), optional, intent(in) :: digits
    integer(c_int), optional, intent(in) :: sensitive
    character(len=*), intent(in), optional:: tooltip ! NB the C-type confuses generic interfaces.
    integer(c_int), intent(in), optional :: wrap
    type(c_funptr), optional :: focus_in_event, focus_out_event
    type(c_ptr), optional :: data_focus_in, data_focus_out

    ! Floating point version of a spin_button
    !
    ! VMIN |  c_double |  required |  The minimum value for the spin_button
    ! VMAX |  c_double |  required |  The maximum value for the spin_button
    ! STEP |  c_double |  required |  The step for the spin_button.
    ! INITIAL_VALUE |  c_double |  optional |  Set the intial value of the spin_button
    ! VALUE_CHANGED |  c_funptr |  optional |  Callback function for the "value-changed" signal.
    ! DATA |  c_ptr |  optional |  User data to pass the the value_changed callback.
    ! DIGITS |  c_int |  optional |  Number of decimal places to show.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is created in the sensitive state.
    ! TOOLTIP |  string |  optional |  A tooltip to display.
    ! WRAP |  boolean |  optional |  If set to TRUE then wrap around if limit is exceeded
    ! FOCUS_OUT_EVENT |  c_funptr |  optional |  Callback for the "focus-out-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_OUT |  c_ptr |  optional |  Data to pass to the focus_out_event callback
    ! FOCUS_IN_EVENT |  c_funptr |  optional |  Callback for the "focus-in-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_IN |  c_ptr |  optional |  Data to pass to the focus_in_event callback
    !
    ! This routine is usually called via its generic interface
    ! hl_gtk_spin_button_new
    !-

    ! Create the spin_button
    spin_button = gtk_spin_button_new_with_range(vmin, vmax, step)

    ! Formatting
    call gtk_spin_button_set_numeric(spin_button, TRUE)
    if (present(digits)) call gtk_spin_button_set_digits(spin_button, digits)
    if (present(wrap)) call gtk_spin_button_set_wrap(spin_button, wrap)

    ! Initial value
    if (present(initial_value)) &
         & call gtk_spin_button_set_value(spin_button, initial_value)

    ! Callback connection
    if (present(value_changed)) then
       if (present(data)) then
          call g_signal_connect(spin_button, "value-changed"//c_null_char,&
               & value_changed,  data)
       else
          call g_signal_connect(spin_button, "value-changed"//c_null_char ,&
               & value_changed)
       end if
    end if
    if (present(focus_out_event)) then
       if (present(data_focus_out)) then
          call g_signal_connect(spin_button, &
               & "focus-out-event"//C_NULL_CHAR, focus_out_event,&
               &  data_focus_out)
       else
          call g_signal_connect(spin_button, &
               & "focus-out-event"//C_NULL_CHAR, focus_out_event)
       end if
    end if

    if (present(focus_in_event)) then
       if (present(data_focus_in)) then
          call g_signal_connect(spin_button, &
               & "focus-in-event"//C_NULL_CHAR, focus_in_event, data_focus_in)
       else
          call g_signal_connect(spin_button, &
               & "focus-in-event"//C_NULL_CHAR, focus_in_event)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(spin_button, &
         & trim(tooltip)//c_null_char)

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(spin_button, sensitive)
  end function hl_gtk_spin_button_flt_new

  !+
  function hl_gtk_spin_button_int_new(imin, imax, initial_value, &
       & value_changed, data, sensitive, tooltip, wrap, &
       & focus_in_event, focus_out_event, data_focus_in, data_focus_out) &
       & result(spin_button)

    type(c_ptr) :: spin_button
    integer(c_int), intent(in) :: imin, imax
    integer(c_int), intent(in), optional :: initial_value
    type(c_funptr), optional :: value_changed
    type(c_ptr), optional :: data
    integer(c_int), optional, intent(in) :: sensitive
    character(len=*), intent(in), optional:: tooltip ! NB the C-type confuses generic interfaces.
    integer(c_int), intent(in), optional :: wrap
    type(c_funptr), optional :: focus_in_event, focus_out_event
    type(c_ptr), optional :: data_focus_in, data_focus_out

    ! Integer version of a spin_button
    !
    ! IMIN |  c_int |  required |  The minimum value for the spin_button
    ! IMAX |  c_int |  required |  The maximum value for the spin_button
    ! INITIAL_VALUE |  c_int |  optional |  Set the intial value of the spin_button
    ! VALUE_CHANGED |  c_funptr |  optional |  Callback function for the "value-changed" signal.
    ! DATA |  c_ptr |  optional |  User data to pass the the value_changed callback.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is created in the sensitive state.
    ! TOOLTIP |  string |  optional |  A tooltip to display.
    ! WRAP |  boolean |  optional |  If set to TRUE then wrap around if limit is exceeded
    ! FOCUS_OUT_EVENT |  c_funptr |  optional |  Callback for the "focus-out-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_OUT |  c_ptr |  optional |  Data to pass to the focus_out_event callback
    ! FOCUS_IN_EVENT |  c_funptr |  optional |  Callback for the "focus-in-event" signal, this is a GDK event rather than a GTK signal, so the call back is a function of 3 arguments returning gboolean.
    ! DATA_FOCUS_IN |  c_ptr |  optional |  Data to pass to the focus_in_event callback
    !
    ! This routine is usually called via its generic interface
    ! hl_gtk_spin_button_new
    !-

    ! Create the spin_button
    if (present(initial_value))  then
       spin_button = hl_gtk_spin_button_flt_new(real(imin, c_double), &
            & real(imax, c_double), 1.0_c_double, &
            & value_changed=value_changed, &
            & initial_value=real(initial_value, c_double), &
            & data=data, sensitive=sensitive, tooltip=tooltip, &
            & wrap=wrap, focus_out_event=focus_out_event, &
            & data_focus_out=data_focus_out, focus_in_event=focus_in_event, &
            & data_focus_in=data_focus_in)
    else
       spin_button = hl_gtk_spin_button_flt_new(real(imin, c_double), &
            & real(imax, c_double), 1.0_c_double, &
            & value_changed=value_changed, &
            & data=data, sensitive=sensitive, tooltip=tooltip, &
            & wrap=wrap, focus_out_event=focus_out_event, &
            & data_focus_out=data_focus_out, focus_in_event=focus_in_event, &
            & data_focus_in=data_focus_in)
    end if

  end function hl_gtk_spin_button_int_new

  !+
  function hl_gtk_spin_button_get_value(spin_button) result(val)

    real(c_double) :: val
    type(c_ptr) :: spin_button

    ! Get the value of a spin_button
    !
    ! SPIN_BUTTON |  c_ptr |  required |  The spin_button to read.
    !
    ! Note even for an integer spin_button we get a float value but there's
    ! no problem letting Fortran do the truncation
    !-

    val = gtk_spin_button_get_value(spin_button)
  end function hl_gtk_spin_button_get_value

  !+
  subroutine hl_gtk_spin_button_set_flt(spin_button, val)

    type(c_ptr), intent(in) :: spin_button
    real(c_double), intent(in) :: val

    ! Set a floating point value for a spin_button
    !
    ! SPIN_BUTTON |  c_ptr |  required |  The spin_button to set.
    ! VAL |  c_double |  required |  The value to set.
    !
    ! This is usually accessed via the generic interface
    ! hl_gtk_spin_button_set_value. Note that since  GTK implements
    ! all spin buttons as double either type may be used for any button.
    !-

    call gtk_spin_button_set_value(spin_button, val)
  end subroutine hl_gtk_spin_button_set_flt

  !+
  subroutine hl_gtk_spin_button_set_int(spin_button, val)

    type(c_ptr), intent(in) :: spin_button
    integer(c_int), intent(in) :: val

    ! Set an integer value for a spin_button
    !
    ! SPIN_BUTTON |  c_ptr |  required |  The spin_button to set.
    ! VAL |  c_int |  required |  The value to set.
    !
    ! This is usually accessed via the generic interface
    ! hl_gtk_spin_button_set_value. Note that since  GTK implements
    ! all spin buttons as double either type may be used for any button.
    !-

    call gtk_spin_button_set_value(spin_button, real(val, c_double))
  end subroutine hl_gtk_spin_button_set_int

  !+
  subroutine hl_gtk_spin_button_set_range(spin_button, lower, upper, &
       & step, digits)
    type(c_ptr), intent(in) :: spin_button
    real(c_double), intent(in), optional :: lower, upper, step
    integer(c_int), intent(in), optional :: digits

    ! Adjust the bounds of a spin box
    !
    ! SLIDER |  c_ptr |  required |  The slider to modify
    ! LOWER |  c_double |  optional |  The new lower bound
    ! UPPER |  c_double |  optional |  The new uppper bound
    ! STEP |  c_double |  optional |  The new step size.
    ! DIGITS |  c_int |  optional |  The new number of decimals.
    !
    ! **Note** This routine is not a generic interface as
    ! overloading requires that the interface be distinguishable by its
    ! required arguments, and it seems less annoying to have to convert to
    ! doubles or use a separate call than to specify an unchanged bound.
    !-

    type(c_ptr) :: adjustment
    real(c_double) :: nlower, nupper

    if (present(upper) .or. present(lower)) then
       adjustment = gtk_spin_button_get_adjustment(spin_button)

       if (present(lower)) then
          nlower = lower
       else
          nlower = gtk_adjustment_get_lower(adjustment)
       end if

       if (present(upper)) then
          nupper = upper
       else
          nupper = gtk_adjustment_get_upper(adjustment)
       end if

       call gtk_spin_button_set_range(spin_button, nlower, nupper)
    end if
    if (present(step)) call gtk_spin_button_set_increments(spin_button,&
         &  step, 10.*step)

    if (present(digits)) call gtk_spin_button_set_digits(spin_button, digits)

  end subroutine hl_gtk_spin_button_set_range

  !+
  subroutine hl_gtk_spin_button_set_range_int(spin_button, lower, upper)
    type(c_ptr), intent(in) :: spin_button
    integer(c_int), intent(in), optional :: lower, upper

    ! Adjust the bounds of a spin box, integer values
    !
    ! SLIDER |  c_ptr |  required |  The slider to modify
    ! LOWER |  c_int |  optional |  The new lower bound
    ! UPPER |  c_int |  optional |  The new uppper bound
    !
    ! **Note** This routine is not a generic interface as
    ! overloading requires that the interface be distinguishable by its
    ! required arguments, and it seems less annoying to use a separate
    ! call than to specify an unchanged bound.
    !-

    type(c_ptr) :: adjustment
    real(c_double) :: nlower, nupper

    ! Check it's not a do-nothing
    if (.not. (present(upper) .or. present(lower))) return

    adjustment = gtk_spin_button_get_adjustment(spin_button)

    if (present(lower)) then
       nlower = real(lower, c_double)
    else
       nlower = gtk_adjustment_get_lower(adjustment)
    end if

    if (present(upper)) then
       nupper = real(upper, c_double)
    else
       nupper = gtk_adjustment_get_upper(adjustment)
    end if

    call gtk_spin_button_set_range(spin_button, nlower, nupper)

  end subroutine hl_gtk_spin_button_set_range_int
end module gtk_hl_spin_slider

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2020 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http:!www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Draw a Sierpinski triangle in a PNG file, without any GUI
! https://en.wikipedia.org/wiki/Sierpi%C5%84ski_triangle#Chaos_game
! Contributed by Vincent Magnin, 2022-04-16
!------------------------------------------------------------------------------

program pixbuf_without_gui
  use, intrinsic :: iso_fortran_env, only: wp=>real64
  use, intrinsic :: iso_c_binding, only: c_ptr, c_null_char, c_null_ptr, &
                         & c_f_pointer, c_char, c_int
  use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, &
                      & gdk_pixbuf_get_rowstride, gdk_pixbuf_new
  use gtk, only: GDK_COLORSPACE_RGB, FALSE
  use gdk_pixbuf, only: gdk_pixbuf_savev

  implicit none
  type(c_ptr) :: my_pixbuf
  ! We use chars because we need unsigned integers:
  character(c_char), dimension(:), pointer :: pixel
  integer(c_int) :: nch, rowstride, pixwidth, pixheight
  integer(c_int) :: cstatus   ! Command status
  real(wp), dimension(1:3) :: x, y
  real(wp) :: xx, yy, diag, r
  integer  :: s            ! Triangle vertex number
  integer  :: n = 300000   ! Number of points
  integer  :: i, p

  ! We create a "pixbuffer" to store the pixels of the image.
  ! This pixbuffer has no Alpha channel (15% faster), only RGB.
  ! https://developer.gnome.org/gdk-pixbuf/stable/gdk-pixbuf-The-GdkPixbuf-Structure.html
  pixwidth  = 800
  pixheight = 800
  my_pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8_c_int, &
                           & pixwidth, pixheight)
  nch = gdk_pixbuf_get_n_channels(my_pixbuf)
  rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)
  print *, "Channels= ", nch, "      Rowstride=", rowstride
  call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf), pixel, &
                 & [pixwidth*pixheight*nch])

  ! The background is black (red=0, green=0, blue=0):
  pixel = char(0)
  ! Diagonal of the image:
  diag = sqrt(real(pixwidth*pixwidth + pixheight*pixheight, kind(0.0_wp)))
  ! Coordinates of the triangle vertices:
  x = [ pixwidth/2.0_wp,  0.0_wp,                      (pixwidth-1)*1.0_wp        ]
  y = [ 0.0_wp,           pixheight*sqrt(3.0_wp)/2.0_wp,  pixheight*sqrt(3.0_wp)/2.0_wp ]
  ! We start at an arbitrary position:
  xx = (x(1) + x(2)) / 2.0_wp
  yy = (y(1) + y(2)) / 2.0_wp

  do i = 1, n
      ! We choose randomly a vertex number (1, 2 or 3):
      call random_number(r)
      s = 1 + int(3*r)
      ! We compute the coordinates of the new point:
      xx = (xx + x(s)) / 2.0_wp
      yy = (yy + y(s)) / 2.0_wp
      ! Position of the corresponding pixel in the pixbuffer:
      p = 1 + nint(xx)*nch + nint(yy)*rowstride
      ! Red, Green, Blue values computed from the distances to vertices:
      pixel(p)   = char(int(255 * sqrt((xx-x(1))**2 + (yy-y(1))**2) / diag))
      pixel(p+1) = char(int(255 * sqrt((xx-x(2))**2 + (yy-y(2))**2) / diag))
      pixel(p+2) = char(int(255 * sqrt((xx-x(3))**2 + (yy-y(3))**2) / diag))
  end do

  ! Save the picture as a PNG:
  ! https://developer.gnome.org/gdk-pixbuf/stable/gdk-pixbuf-File-saving.html
  ! https://mail.gnome.org/archives/gtk-list/2004-October/msg00186.html
  cstatus = gdk_pixbuf_savev(my_pixbuf, "sierpinski_triangle.png"//c_null_char,&
              & "png"//c_null_char, c_null_ptr, c_null_ptr, c_null_ptr)
end program pixbuf_without_gui

! Do not modify this file automatically generated by cfwrapper.py using:
! gtk-fortran 4.8.0, GTK 4.18.4, GLib 2.84.1, Fedora 42 x86_64
! This file is part of the gtk-fortran library, distributed under
! GNU General Public License version 3.

module gdk_pixbuf
use, intrinsic :: iso_c_binding
implicit none
interface

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-autocleanups.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-simple-anim.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_simple_anim_get_type (void) ;
function gdk_pixbuf_simple_anim_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_simple_anim_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_simple_anim_iter_get_type (void) ;
function gdk_pixbuf_simple_anim_iter_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_simple_anim_iter_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_2_8
!GdkPixbufSimpleAnim *gdk_pixbuf_simple_anim_new (gint width, gint height, gfloat rate);
function gdk_pixbuf_simple_anim_new(width, height, rate) bind(c)
  import :: c_ptr, c_int, c_float
  implicit none
  type(c_ptr) :: gdk_pixbuf_simple_anim_new
  integer(c_int), value :: width
  integer(c_int), value :: height
  real(c_float), value :: rate
end function

! GDK_PIXBUF_AVAILABLE_IN_2_8
!void gdk_pixbuf_simple_anim_add_frame (GdkPixbufSimpleAnim *animation, GdkPixbuf *pixbuf);
subroutine gdk_pixbuf_simple_anim_add_frame(animation, pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: animation
  type(c_ptr), value :: pixbuf
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_simple_anim_set_loop (GdkPixbufSimpleAnim *animation, gboolean loop);
subroutine gdk_pixbuf_simple_anim_set_loop(animation, loop) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: animation
  integer(c_int), value :: loop
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_simple_anim_get_loop (GdkPixbufSimpleAnim *animation);
function gdk_pixbuf_simple_anim_get_loop(animation) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_simple_anim_get_loop
  type(c_ptr), value :: animation
end function

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-enum-types.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_alpha_mode_get_type (void) ;
function gdk_pixbuf_alpha_mode_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_alpha_mode_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_colorspace_get_type (void) ;
function gdk_colorspace_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_colorspace_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_error_get_type (void) ;
function gdk_pixbuf_error_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_error_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_interp_type_get_type (void) ;
function gdk_interp_type_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_interp_type_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_rotation_get_type (void) ;
function gdk_pixbuf_rotation_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_rotation_get_type
end function

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-transform.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_scale (const GdkPixbuf *src, GdkPixbuf *dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type);
subroutine gdk_pixbuf_scale(src, dest, dest_x, dest_y, dest_width, dest_height,&
& offset_x, offset_y, scale_x, scale_y, interp_type) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: src
  type(c_ptr), value :: dest
  integer(c_int), value :: dest_x
  integer(c_int), value :: dest_y
  integer(c_int), value :: dest_width
  integer(c_int), value :: dest_height
  real(c_double), value :: offset_x
  real(c_double), value :: offset_y
  real(c_double), value :: scale_x
  real(c_double), value :: scale_y
  integer(c_int), value :: interp_type
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_composite (const GdkPixbuf *src, GdkPixbuf *dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type, int overall_alpha);
subroutine gdk_pixbuf_composite(src, dest, dest_x, dest_y, dest_width,&
& dest_height, offset_x, offset_y, scale_x, scale_y, interp_type,&
& overall_alpha) bind(c)
  import :: c_ptr, c_int, c_double
  implicit none
  type(c_ptr), value :: src
  type(c_ptr), value :: dest
  integer(c_int), value :: dest_x
  integer(c_int), value :: dest_y
  integer(c_int), value :: dest_width
  integer(c_int), value :: dest_height
  real(c_double), value :: offset_x
  real(c_double), value :: offset_y
  real(c_double), value :: scale_x
  real(c_double), value :: scale_y
  integer(c_int), value :: interp_type
  integer(c_int), value :: overall_alpha
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_composite_color (const GdkPixbuf *src, GdkPixbuf *dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, guint32 color1, guint32 color2);
subroutine gdk_pixbuf_composite_color(src, dest, dest_x, dest_y, dest_width,&
& dest_height, offset_x, offset_y, scale_x, scale_y, interp_type,&
& overall_alpha, check_x, check_y, check_size, color1, color2) bind(c)
  import :: c_ptr, c_int, c_double, c_int32_t
  implicit none
  type(c_ptr), value :: src
  type(c_ptr), value :: dest
  integer(c_int), value :: dest_x
  integer(c_int), value :: dest_y
  integer(c_int), value :: dest_width
  integer(c_int), value :: dest_height
  real(c_double), value :: offset_x
  real(c_double), value :: offset_y
  real(c_double), value :: scale_x
  real(c_double), value :: scale_y
  integer(c_int), value :: interp_type
  integer(c_int), value :: overall_alpha
  integer(c_int), value :: check_x
  integer(c_int), value :: check_y
  integer(c_int), value :: check_size
  integer(c_int32_t), value :: color1
  integer(c_int32_t), value :: color2
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_scale_simple (const GdkPixbuf *src, int dest_width, int dest_height, GdkInterpType interp_type);
function gdk_pixbuf_scale_simple(src, dest_width, dest_height, interp_type)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_scale_simple
  type(c_ptr), value :: src
  integer(c_int), value :: dest_width
  integer(c_int), value :: dest_height
  integer(c_int), value :: interp_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_composite_color_simple (const GdkPixbuf *src, int dest_width, int dest_height, GdkInterpType interp_type, int overall_alpha, int check_size, guint32 color1, guint32 color2);
function gdk_pixbuf_composite_color_simple(src, dest_width, dest_height,&
& interp_type, overall_alpha, check_size, color1, color2) bind(c)
  import :: c_ptr, c_int, c_int32_t
  implicit none
  type(c_ptr) :: gdk_pixbuf_composite_color_simple
  type(c_ptr), value :: src
  integer(c_int), value :: dest_width
  integer(c_int), value :: dest_height
  integer(c_int), value :: interp_type
  integer(c_int), value :: overall_alpha
  integer(c_int), value :: check_size
  integer(c_int32_t), value :: color1
  integer(c_int32_t), value :: color2
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!GdkPixbuf *gdk_pixbuf_rotate_simple (const GdkPixbuf *src, GdkPixbufRotation angle);
function gdk_pixbuf_rotate_simple(src, angle) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_rotate_simple
  type(c_ptr), value :: src
  integer(c_int), value :: angle
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!GdkPixbuf *gdk_pixbuf_flip (const GdkPixbuf *src, gboolean horizontal);
function gdk_pixbuf_flip(src, horizontal) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_flip
  type(c_ptr), value :: src
  integer(c_int), value :: horizontal
end function

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-loader.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_loader_get_type (void) ;
function gdk_pixbuf_loader_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_loader_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufLoader * gdk_pixbuf_loader_new (void);
function gdk_pixbuf_loader_new() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_loader_new
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufLoader * gdk_pixbuf_loader_new_with_type (const char *image_type, GError **error);
function gdk_pixbuf_loader_new_with_type(image_type, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_loader_new_with_type
  character(kind=c_char), dimension(*) :: image_type
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_4
!GdkPixbufLoader * gdk_pixbuf_loader_new_with_mime_type (const char *mime_type, GError **error);
function gdk_pixbuf_loader_new_with_mime_type(mime_type, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_loader_new_with_mime_type
  character(kind=c_char), dimension(*) :: mime_type
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!void gdk_pixbuf_loader_set_size (GdkPixbufLoader *loader, int width, int height);
subroutine gdk_pixbuf_loader_set_size(loader, width, height) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: loader
  integer(c_int), value :: width
  integer(c_int), value :: height
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_loader_write (GdkPixbufLoader *loader, const guchar *buf, gsize count, GError **error);
function gdk_pixbuf_loader_write(loader, buf, count, error) bind(c)
  import :: c_int, c_ptr, c_char, c_size_t
  implicit none
  integer(c_int) :: gdk_pixbuf_loader_write
  type(c_ptr), value :: loader
  character(kind=c_char), dimension(*) :: buf
  integer(c_size_t), value :: count
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_30
!gboolean gdk_pixbuf_loader_write_bytes (GdkPixbufLoader *loader, GBytes *buffer, GError **error);
function gdk_pixbuf_loader_write_bytes(loader, buffer, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_loader_write_bytes
  type(c_ptr), value :: loader
  type(c_ptr), value :: buffer
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf * gdk_pixbuf_loader_get_pixbuf (GdkPixbufLoader *loader);
function gdk_pixbuf_loader_get_pixbuf(loader) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_loader_get_pixbuf
  type(c_ptr), value :: loader
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufAnimation * gdk_pixbuf_loader_get_animation (GdkPixbufLoader *loader);
function gdk_pixbuf_loader_get_animation(loader) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_loader_get_animation
  type(c_ptr), value :: loader
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_loader_close (GdkPixbufLoader *loader, GError **error);
function gdk_pixbuf_loader_close(loader, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_loader_close
  type(c_ptr), value :: loader
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!GdkPixbufFormat *gdk_pixbuf_loader_get_format (GdkPixbufLoader *loader);
function gdk_pixbuf_loader_get_format(loader) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_loader_get_format
  type(c_ptr), value :: loader
end function

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-marshal.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-features.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-macros.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-io.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_2_40
!gboolean gdk_pixbuf_init_modules (const char *path, GError **error);
function gdk_pixbuf_init_modules(path, error) bind(c)
  import :: c_int, c_char, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_init_modules
  character(kind=c_char), dimension(*) :: path
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_format_get_type (void) ;
function gdk_pixbuf_format_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_format_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GSList *gdk_pixbuf_get_formats (void);
function gdk_pixbuf_get_formats() bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_formats
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!gchar *gdk_pixbuf_format_get_name (GdkPixbufFormat *format);
function gdk_pixbuf_format_get_name(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_format_get_name
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!gchar *gdk_pixbuf_format_get_description (GdkPixbufFormat *format);
function gdk_pixbuf_format_get_description(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_format_get_description
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!gchar **gdk_pixbuf_format_get_mime_types (GdkPixbufFormat *format);
function gdk_pixbuf_format_get_mime_types(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_format_get_mime_types
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!gchar **gdk_pixbuf_format_get_extensions (GdkPixbufFormat *format);
function gdk_pixbuf_format_get_extensions(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_format_get_extensions
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_36
!gboolean gdk_pixbuf_format_is_save_option_supported (GdkPixbufFormat *format, const gchar *option_key);
function gdk_pixbuf_format_is_save_option_supported(format, option_key) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_format_is_save_option_supported
  type(c_ptr), value :: format
  character(kind=c_char), dimension(*) :: option_key
end function

! GDK_PIXBUF_AVAILABLE_IN_2_2
!gboolean gdk_pixbuf_format_is_writable (GdkPixbufFormat *format);
function gdk_pixbuf_format_is_writable(format) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_format_is_writable
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!gboolean gdk_pixbuf_format_is_scalable (GdkPixbufFormat *format);
function gdk_pixbuf_format_is_scalable(format) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_format_is_scalable
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!gboolean gdk_pixbuf_format_is_disabled (GdkPixbufFormat *format);
function gdk_pixbuf_format_is_disabled(format) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_format_is_disabled
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!void gdk_pixbuf_format_set_disabled (GdkPixbufFormat *format, gboolean disabled);
subroutine gdk_pixbuf_format_set_disabled(format, disabled) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: format
  integer(c_int), value :: disabled
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_2_6
!gchar *gdk_pixbuf_format_get_license (GdkPixbufFormat *format);
function gdk_pixbuf_format_get_license(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_format_get_license
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_2_4
!GdkPixbufFormat *gdk_pixbuf_get_file_info (const gchar *filename, gint *width, gint *height);
function gdk_pixbuf_get_file_info(filename, width, height) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_file_info
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: width
  type(c_ptr), value :: height
end function

! GDK_PIXBUF_AVAILABLE_IN_2_32
!void gdk_pixbuf_get_file_info_async (const gchar *filename, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data);
subroutine gdk_pixbuf_get_file_info_async(filename, cancellable, callback,&
& user_data) bind(c)
  import :: c_char, c_ptr, c_funptr
  implicit none
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: cancellable
  type(c_funptr), value :: callback
  type(c_ptr), value :: user_data
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_2_32
!GdkPixbufFormat *gdk_pixbuf_get_file_info_finish (GAsyncResult *async_result, gint *width, gint *height, GError **error);
function gdk_pixbuf_get_file_info_finish(async_result, width, height, error)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_file_info_finish
  type(c_ptr), value :: async_result
  type(c_ptr), value :: width
  type(c_ptr), value :: height
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufFormat *gdk_pixbuf_format_copy (const GdkPixbufFormat *format);
function gdk_pixbuf_format_copy(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_format_copy
  type(c_ptr), value :: format
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_format_free (GdkPixbufFormat *format);
subroutine gdk_pixbuf_format_free(format) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: format
end subroutine

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-core.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_ALL
!GQuark gdk_pixbuf_error_quark (void);
function gdk_pixbuf_error_quark() bind(c)
  import :: c_int32_t
  implicit none
  integer(c_int32_t) :: gdk_pixbuf_error_quark
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_get_type (void) ;
function gdk_pixbuf_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_get_type
end function

! GDK_PIXBUF_DEPRECATED_IN_2_0_FOR(g_object_ref)
!GdkPixbuf *gdk_pixbuf_ref (GdkPixbuf *pixbuf);
function gdk_pixbuf_ref(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_ref
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_DEPRECATED_IN_2_0_FOR(g_object_unref)
!void gdk_pixbuf_unref (GdkPixbuf *pixbuf);
subroutine gdk_pixbuf_unref(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: pixbuf
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkColorspace gdk_pixbuf_get_colorspace (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_colorspace(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_colorspace
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_get_n_channels (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_n_channels(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_n_channels
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_get_has_alpha (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_has_alpha(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_has_alpha
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_get_bits_per_sample (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_bits_per_sample(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_bits_per_sample
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!guchar *gdk_pixbuf_get_pixels (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_pixels(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_pixels
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_get_width (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_width(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_width
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_get_height (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_height(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_height
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_get_rowstride (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_rowstride(pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_get_rowstride
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_2_26
!gsize gdk_pixbuf_get_byte_length (const GdkPixbuf *pixbuf);
function gdk_pixbuf_get_byte_length(pixbuf) bind(c)
  import :: c_size_t, c_ptr
  implicit none
  integer(c_size_t) :: gdk_pixbuf_get_byte_length
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_2_26
!guchar *gdk_pixbuf_get_pixels_with_length (const GdkPixbuf *pixbuf, guint *length);
function gdk_pixbuf_get_pixels_with_length(pixbuf, length) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_pixels_with_length
  type(c_ptr), value :: pixbuf
  type(c_ptr), value :: length
end function

! GDK_PIXBUF_AVAILABLE_IN_2_32
!const guint8* gdk_pixbuf_read_pixels (const GdkPixbuf *pixbuf);
function gdk_pixbuf_read_pixels(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_read_pixels
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_2_32
!GBytes * gdk_pixbuf_read_pixel_bytes (const GdkPixbuf *pixbuf);
function gdk_pixbuf_read_pixel_bytes(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_read_pixel_bytes
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new (GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height);
function gdk_pixbuf_new(colorspace, has_alpha, bits_per_sample, width, height)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new
  integer(c_int), value :: colorspace
  integer(c_int), value :: has_alpha
  integer(c_int), value :: bits_per_sample
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! GDK_PIXBUF_AVAILABLE_IN_2_36
!gint gdk_pixbuf_calculate_rowstride (GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height);
function gdk_pixbuf_calculate_rowstride(colorspace, has_alpha, bits_per_sample,&
& width, height) bind(c)
  import :: c_int
  implicit none
  integer(c_int) :: gdk_pixbuf_calculate_rowstride
  integer(c_int), value :: colorspace
  integer(c_int), value :: has_alpha
  integer(c_int), value :: bits_per_sample
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_copy (const GdkPixbuf *pixbuf);
function gdk_pixbuf_copy(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_copy
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new_subpixbuf (GdkPixbuf *src_pixbuf, int src_x, int src_y, int width, int height);
function gdk_pixbuf_new_subpixbuf(src_pixbuf, src_x, src_y, width, height)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_subpixbuf
  type(c_ptr), value :: src_pixbuf
  integer(c_int), value :: src_x
  integer(c_int), value :: src_y
  integer(c_int), value :: width
  integer(c_int), value :: height
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new_from_file_utf8 (const char *filename, GError **error);
function gdk_pixbuf_new_from_file_utf8(filename, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_file_utf8
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_4
!GdkPixbuf *gdk_pixbuf_new_from_file_at_size_utf8 (const char *filename, int width, int height, GError **error);
function gdk_pixbuf_new_from_file_at_size_utf8(filename, width, height, error)&
& bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_file_at_size_utf8
  character(kind=c_char), dimension(*) :: filename
  integer(c_int), value :: width
  integer(c_int), value :: height
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!GdkPixbuf *gdk_pixbuf_new_from_file_at_scale_utf8 (const char *filename, int width, int height, gboolean preserve_aspect_ratio, GError **error);
function gdk_pixbuf_new_from_file_at_scale_utf8(filename, width, height,&
& preserve_aspect_ratio, error) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_file_at_scale_utf8
  character(kind=c_char), dimension(*) :: filename
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: preserve_aspect_ratio
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new_from_file (const char *filename, GError **error);
function gdk_pixbuf_new_from_file(filename, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_file
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_4
!GdkPixbuf *gdk_pixbuf_new_from_file_at_size (const char *filename, int width, int height, GError **error);
function gdk_pixbuf_new_from_file_at_size(filename, width, height, error)&
& bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_file_at_size
  character(kind=c_char), dimension(*) :: filename
  integer(c_int), value :: width
  integer(c_int), value :: height
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_6
!GdkPixbuf *gdk_pixbuf_new_from_file_at_scale (const char *filename, int width, int height, gboolean preserve_aspect_ratio, GError **error);
function gdk_pixbuf_new_from_file_at_scale(filename, width, height,&
& preserve_aspect_ratio, error) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_file_at_scale
  character(kind=c_char), dimension(*) :: filename
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: preserve_aspect_ratio
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_26
!GdkPixbuf *gdk_pixbuf_new_from_resource (const char *resource_path, GError **error);
function gdk_pixbuf_new_from_resource(resource_path, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_resource
  character(kind=c_char), dimension(*) :: resource_path
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_26
!GdkPixbuf *gdk_pixbuf_new_from_resource_at_scale (const char *resource_path, int width, int height, gboolean preserve_aspect_ratio, GError **error);
function gdk_pixbuf_new_from_resource_at_scale(resource_path, width, height,&
& preserve_aspect_ratio, error) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_resource_at_scale
  character(kind=c_char), dimension(*) :: resource_path
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: preserve_aspect_ratio
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new_from_data (const guchar *data, GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height, int rowstride, GdkPixbufDestroyNotify destroy_fn, gpointer destroy_fn_data);
function gdk_pixbuf_new_from_data(data, colorspace, has_alpha, bits_per_sample,&
& width, height, rowstride, destroy_fn, destroy_fn_data) bind(c)
  import :: c_ptr, c_char, c_int, c_funptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_data
  character(kind=c_char), dimension(*) :: data
  integer(c_int), value :: colorspace
  integer(c_int), value :: has_alpha
  integer(c_int), value :: bits_per_sample
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: rowstride
  type(c_funptr), value :: destroy_fn
  type(c_ptr), value :: destroy_fn_data
end function

! GDK_PIXBUF_AVAILABLE_IN_2_32
!GdkPixbuf *gdk_pixbuf_new_from_bytes (GBytes *data, GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, int width, int height, int rowstride);
function gdk_pixbuf_new_from_bytes(data, colorspace, has_alpha,&
& bits_per_sample, width, height, rowstride) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_bytes
  type(c_ptr), value :: data
  integer(c_int), value :: colorspace
  integer(c_int), value :: has_alpha
  integer(c_int), value :: bits_per_sample
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: rowstride
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new_from_xpm_data (const char **data);
function gdk_pixbuf_new_from_xpm_data(data) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_xpm_data
  type(c_ptr), dimension(*) :: data
end function

! GDK_PIXBUF_DEPRECATED_IN_2_32
!GdkPixbuf* gdk_pixbuf_new_from_inline (gint data_length, const guint8 *data, gboolean copy_pixels, GError **error);
function gdk_pixbuf_new_from_inline(data_length, data, copy_pixels, error)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_inline
  integer(c_int), value :: data_length
  type(c_ptr), value :: data
  integer(c_int), value :: copy_pixels
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_fill (GdkPixbuf *pixbuf, guint32 pixel);
subroutine gdk_pixbuf_fill(pixbuf, pixel) bind(c)
  import :: c_ptr, c_int32_t
  implicit none
  type(c_ptr), value :: pixbuf
  integer(c_int32_t), value :: pixel
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_savev (GdkPixbuf *pixbuf, const char *filename, const char *type, char **option_keys, char **option_values, GError **error);
function gdk_pixbuf_savev(pixbuf, filename, type, option_keys, option_values,&
& error) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_savev
  type(c_ptr), value :: pixbuf
  character(kind=c_char), dimension(*) :: filename
  character(kind=c_char), dimension(*) :: type
  type(c_ptr), dimension(*) :: option_keys
  type(c_ptr), dimension(*) :: option_values
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_savev_utf8 (GdkPixbuf *pixbuf, const char *filename, const char *type, char **option_keys, char **option_values, GError **error);
function gdk_pixbuf_savev_utf8(pixbuf, filename, type, option_keys,&
& option_values, error) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_savev_utf8
  type(c_ptr), value :: pixbuf
  character(kind=c_char), dimension(*) :: filename
  character(kind=c_char), dimension(*) :: type
  type(c_ptr), dimension(*) :: option_keys
  type(c_ptr), dimension(*) :: option_values
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_4
!gboolean gdk_pixbuf_save_to_callbackv (GdkPixbuf *pixbuf, GdkPixbufSaveFunc save_func, gpointer user_data, const char *type, char **option_keys, char **option_values, GError **error);
function gdk_pixbuf_save_to_callbackv(pixbuf, save_func, user_data, type,&
& option_keys, option_values, error) bind(c)
  import :: c_int, c_ptr, c_funptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_save_to_callbackv
  type(c_ptr), value :: pixbuf
  type(c_funptr), value :: save_func
  type(c_ptr), value :: user_data
  character(kind=c_char), dimension(*) :: type
  type(c_ptr), dimension(*) :: option_keys
  type(c_ptr), dimension(*) :: option_values
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_4
!gboolean gdk_pixbuf_save_to_bufferv (GdkPixbuf *pixbuf, gchar **buffer, gsize *buffer_size, const char *type, char **option_keys, char **option_values, GError **error);
function gdk_pixbuf_save_to_bufferv(pixbuf, buffer, buffer_size, type,&
& option_keys, option_values, error) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_save_to_bufferv
  type(c_ptr), value :: pixbuf
  type(c_ptr), dimension(*) :: buffer
  type(c_ptr), value :: buffer_size
  character(kind=c_char), dimension(*) :: type
  type(c_ptr), dimension(*) :: option_keys
  type(c_ptr), dimension(*) :: option_values
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_14
!GdkPixbuf *gdk_pixbuf_new_from_stream (GInputStream *stream, GCancellable *cancellable, GError **error);
function gdk_pixbuf_new_from_stream(stream, cancellable, error) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_stream
  type(c_ptr), value :: stream
  type(c_ptr), value :: cancellable
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_new_from_stream_async (GInputStream *stream, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data);
subroutine gdk_pixbuf_new_from_stream_async(stream, cancellable, callback,&
& user_data) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: stream
  type(c_ptr), value :: cancellable
  type(c_funptr), value :: callback
  type(c_ptr), value :: user_data
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_new_from_stream_finish (GAsyncResult *async_result, GError **error);
function gdk_pixbuf_new_from_stream_finish(async_result, error) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_stream_finish
  type(c_ptr), value :: async_result
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_14
!GdkPixbuf *gdk_pixbuf_new_from_stream_at_scale (GInputStream *stream, gint width, gint height, gboolean preserve_aspect_ratio, GCancellable *cancellable, GError **error);
function gdk_pixbuf_new_from_stream_at_scale(stream, width, height,&
& preserve_aspect_ratio, cancellable, error) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_new_from_stream_at_scale
  type(c_ptr), value :: stream
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: preserve_aspect_ratio
  type(c_ptr), value :: cancellable
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_new_from_stream_at_scale_async (GInputStream *stream, gint width, gint height, gboolean preserve_aspect_ratio, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data);
subroutine gdk_pixbuf_new_from_stream_at_scale_async(stream, width, height,&
& preserve_aspect_ratio, cancellable, callback, user_data) bind(c)
  import :: c_ptr, c_int, c_funptr
  implicit none
  type(c_ptr), value :: stream
  integer(c_int), value :: width
  integer(c_int), value :: height
  integer(c_int), value :: preserve_aspect_ratio
  type(c_ptr), value :: cancellable
  type(c_funptr), value :: callback
  type(c_ptr), value :: user_data
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_save_to_stream_finish (GAsyncResult *async_result, GError **error);
function gdk_pixbuf_save_to_stream_finish(async_result, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_save_to_stream_finish
  type(c_ptr), value :: async_result
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_36
!void gdk_pixbuf_save_to_streamv_async (GdkPixbuf *pixbuf, GOutputStream *stream, const gchar *type, gchar **option_keys, gchar **option_values, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data);
subroutine gdk_pixbuf_save_to_streamv_async(pixbuf, stream, type, option_keys,&
& option_values, cancellable, callback, user_data) bind(c)
  import :: c_ptr, c_char, c_funptr
  implicit none
  type(c_ptr), value :: pixbuf
  type(c_ptr), value :: stream
  character(kind=c_char), dimension(*) :: type
  type(c_ptr), dimension(*) :: option_keys
  type(c_ptr), dimension(*) :: option_values
  type(c_ptr), value :: cancellable
  type(c_funptr), value :: callback
  type(c_ptr), value :: user_data
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_2_36
!gboolean gdk_pixbuf_save_to_streamv (GdkPixbuf *pixbuf, GOutputStream *stream, const char *type, char **option_keys, char **option_values, GCancellable *cancellable, GError **error);
function gdk_pixbuf_save_to_streamv(pixbuf, stream, type, option_keys,&
& option_values, cancellable, error) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_save_to_streamv
  type(c_ptr), value :: pixbuf
  type(c_ptr), value :: stream
  character(kind=c_char), dimension(*) :: type
  type(c_ptr), dimension(*) :: option_keys
  type(c_ptr), dimension(*) :: option_values
  type(c_ptr), value :: cancellable
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_add_alpha (const GdkPixbuf *pixbuf, gboolean substitute_color, guchar r, guchar g, guchar b);
function gdk_pixbuf_add_alpha(pixbuf, substitute_color, r, g, b) bind(c)
  import :: c_ptr, c_int, c_int8_t
  implicit none
  type(c_ptr) :: gdk_pixbuf_add_alpha
  type(c_ptr), value :: pixbuf
  integer(c_int), value :: substitute_color
  integer(kind=c_int8_t), value :: r
  integer(kind=c_int8_t), value :: g
  integer(kind=c_int8_t), value :: b
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_copy_area (const GdkPixbuf *src_pixbuf, int src_x, int src_y, int width, int height, GdkPixbuf *dest_pixbuf, int dest_x, int dest_y);
subroutine gdk_pixbuf_copy_area(src_pixbuf, src_x, src_y, width, height,&
& dest_pixbuf, dest_x, dest_y) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: src_pixbuf
  integer(c_int), value :: src_x
  integer(c_int), value :: src_y
  integer(c_int), value :: width
  integer(c_int), value :: height
  type(c_ptr), value :: dest_pixbuf
  integer(c_int), value :: dest_x
  integer(c_int), value :: dest_y
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!void gdk_pixbuf_saturate_and_pixelate (const GdkPixbuf *src, GdkPixbuf *dest, gfloat saturation, gboolean pixelate);
subroutine gdk_pixbuf_saturate_and_pixelate(src, dest, saturation, pixelate)&
& bind(c)
  import :: c_ptr, c_float, c_int
  implicit none
  type(c_ptr), value :: src
  type(c_ptr), value :: dest
  real(c_float), value :: saturation
  integer(c_int), value :: pixelate
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_2_12
!GdkPixbuf *gdk_pixbuf_apply_embedded_orientation (GdkPixbuf *src);
function gdk_pixbuf_apply_embedded_orientation(src) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_apply_embedded_orientation
  type(c_ptr), value :: src
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_set_option (GdkPixbuf *pixbuf, const gchar *key, const gchar *value);
function gdk_pixbuf_set_option(pixbuf, key, value) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_set_option
  type(c_ptr), value :: pixbuf
  character(kind=c_char), dimension(*) :: key
  character(kind=c_char), dimension(*) :: value
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!const gchar * gdk_pixbuf_get_option (GdkPixbuf *pixbuf, const gchar *key);
function gdk_pixbuf_get_option(pixbuf, key) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_option
  type(c_ptr), value :: pixbuf
  character(kind=c_char), dimension(*) :: key
end function

! GDK_PIXBUF_AVAILABLE_IN_2_36
!gboolean gdk_pixbuf_remove_option (GdkPixbuf *pixbuf, const gchar *key);
function gdk_pixbuf_remove_option(pixbuf, key) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gdk_pixbuf_remove_option
  type(c_ptr), value :: pixbuf
  character(kind=c_char), dimension(*) :: key
end function

! GDK_PIXBUF_AVAILABLE_IN_2_32
!GHashTable * gdk_pixbuf_get_options (GdkPixbuf *pixbuf);
function gdk_pixbuf_get_options(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_get_options
  type(c_ptr), value :: pixbuf
end function

! GDK_PIXBUF_AVAILABLE_IN_2_36
!gboolean gdk_pixbuf_copy_options (GdkPixbuf *src_pixbuf, GdkPixbuf *dest_pixbuf);
function gdk_pixbuf_copy_options(src_pixbuf, dest_pixbuf) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_copy_options
  type(c_ptr), value :: src_pixbuf
  type(c_ptr), value :: dest_pixbuf
end function

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixdata.h
!--------------------------------------------------
! GDK_PIXBUF_DEPRECATED_IN_2_32
!guint8* gdk_pixdata_serialize (const GdkPixdata *pixdata, guint *stream_length_p);
function gdk_pixdata_serialize(pixdata, stream_length_p) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixdata_serialize
  type(c_ptr), value :: pixdata
  type(c_ptr), value :: stream_length_p
end function

! GDK_PIXBUF_DEPRECATED_IN_2_32
!gboolean gdk_pixdata_deserialize (GdkPixdata *pixdata, guint stream_length, const guint8 *stream, GError **error);
function gdk_pixdata_deserialize(pixdata, stream_length, stream, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixdata_deserialize
  type(c_ptr), value :: pixdata
  integer(c_int), value :: stream_length
  type(c_ptr), value :: stream
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_DEPRECATED_IN_2_32
!gpointer gdk_pixdata_from_pixbuf (GdkPixdata *pixdata, const GdkPixbuf *pixbuf, gboolean use_rle);
function gdk_pixdata_from_pixbuf(pixdata, pixbuf, use_rle) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixdata_from_pixbuf
  type(c_ptr), value :: pixdata
  type(c_ptr), value :: pixbuf
  integer(c_int), value :: use_rle
end function

! GDK_PIXBUF_DEPRECATED_IN_2_32
!GdkPixbuf* gdk_pixbuf_from_pixdata (const GdkPixdata *pixdata, gboolean copy_pixels, GError **error);
function gdk_pixbuf_from_pixdata(pixdata, copy_pixels, error) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr) :: gdk_pixbuf_from_pixdata
  type(c_ptr), value :: pixdata
  integer(c_int), value :: copy_pixels
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_DEPRECATED_IN_2_32
!GString* gdk_pixdata_to_csource (GdkPixdata *pixdata, const gchar *name, GdkPixdataDumpType dump_type);
function gdk_pixdata_to_csource(pixdata, name, dump_type) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gdk_pixdata_to_csource
  type(c_ptr), value :: pixdata
  character(kind=c_char), dimension(*) :: name
  integer(c_int), value :: dump_type
end function

!--------------------------------------------------
! /usr/include/gdk-pixbuf-2.0/gdk-pixbuf/gdk-pixbuf-animation.h
!--------------------------------------------------
! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_animation_get_type (void) ;
function gdk_pixbuf_animation_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_animation_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufAnimation *gdk_pixbuf_animation_new_from_file_utf8 (const char *filename, GError **error);
function gdk_pixbuf_animation_new_from_file_utf8(filename, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_new_from_file_utf8
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufAnimation *gdk_pixbuf_animation_new_from_file (const char *filename, GError **error);
function gdk_pixbuf_animation_new_from_file(filename, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_new_from_file
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_28
!GdkPixbufAnimation *gdk_pixbuf_animation_new_from_stream (GInputStream *stream, GCancellable *cancellable, GError **error);
function gdk_pixbuf_animation_new_from_stream(stream, cancellable, error)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_new_from_stream
  type(c_ptr), value :: stream
  type(c_ptr), value :: cancellable
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_28
!void gdk_pixbuf_animation_new_from_stream_async (GInputStream *stream, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data);
subroutine gdk_pixbuf_animation_new_from_stream_async(stream, cancellable,&
& callback, user_data) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: stream
  type(c_ptr), value :: cancellable
  type(c_funptr), value :: callback
  type(c_ptr), value :: user_data
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_2_28
!GdkPixbufAnimation *gdk_pixbuf_animation_new_from_stream_finish (GAsyncResult*async_result, GError **error);
function gdk_pixbuf_animation_new_from_stream_finish(async_result, error)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_new_from_stream_finish
  type(c_ptr), value :: async_result
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_AVAILABLE_IN_2_28
!GdkPixbufAnimation *gdk_pixbuf_animation_new_from_resource(const char *resource_path, GError **error);
function gdk_pixbuf_animation_new_from_resource(resource_path, error) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_new_from_resource
  character(kind=c_char), dimension(*) :: resource_path
  type(c_ptr), value :: error
end function

! GDK_PIXBUF_DEPRECATED_IN_2_0_FOR(g_object_ref)
!GdkPixbufAnimation *gdk_pixbuf_animation_ref (GdkPixbufAnimation *animation);
function gdk_pixbuf_animation_ref(animation) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_ref
  type(c_ptr), value :: animation
end function

! GDK_PIXBUF_DEPRECATED_IN_2_0_FOR(g_object_unref)
!void gdk_pixbuf_animation_unref (GdkPixbufAnimation *animation);
subroutine gdk_pixbuf_animation_unref(animation) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: animation
end subroutine

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_animation_get_width (GdkPixbufAnimation *animation);
function gdk_pixbuf_animation_get_width(animation) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_animation_get_width
  type(c_ptr), value :: animation
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_animation_get_height (GdkPixbufAnimation *animation);
function gdk_pixbuf_animation_get_height(animation) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_animation_get_height
  type(c_ptr), value :: animation
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_animation_is_static_image (GdkPixbufAnimation *animation);
function gdk_pixbuf_animation_is_static_image(animation) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_animation_is_static_image
  type(c_ptr), value :: animation
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_animation_get_static_image (GdkPixbufAnimation *animation);
function gdk_pixbuf_animation_get_static_image(animation) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_get_static_image
  type(c_ptr), value :: animation
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufAnimationIter *gdk_pixbuf_animation_get_iter (GdkPixbufAnimation *animation, const GTimeVal *start_time);
function gdk_pixbuf_animation_get_iter(animation, start_time) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_get_iter
  type(c_ptr), value :: animation
  type(c_ptr), value :: start_time
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_animation_iter_get_type (void) ;
function gdk_pixbuf_animation_iter_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_animation_iter_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!int gdk_pixbuf_animation_iter_get_delay_time (GdkPixbufAnimationIter *iter);
function gdk_pixbuf_animation_iter_get_delay_time(iter) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_animation_iter_get_delay_time
  type(c_ptr), value :: iter
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbuf *gdk_pixbuf_animation_iter_get_pixbuf (GdkPixbufAnimationIter *iter);
function gdk_pixbuf_animation_iter_get_pixbuf(iter) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_animation_iter_get_pixbuf
  type(c_ptr), value :: iter
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_animation_iter_on_currently_loading_frame (GdkPixbufAnimationIter *iter);
function gdk_pixbuf_animation_iter_on_currently_loading_frame(iter) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_animation_iter_on_currently_loading_frame
  type(c_ptr), value :: iter
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!gboolean gdk_pixbuf_animation_iter_advance (GdkPixbufAnimationIter *iter, const GTimeVal *current_time);
function gdk_pixbuf_animation_iter_advance(iter, current_time) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gdk_pixbuf_animation_iter_advance
  type(c_ptr), value :: iter
  type(c_ptr), value :: current_time
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GType gdk_pixbuf_non_anim_get_type (void) ;
function gdk_pixbuf_non_anim_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gdk_pixbuf_non_anim_get_type
end function

! GDK_PIXBUF_AVAILABLE_IN_ALL
!GdkPixbufAnimation* gdk_pixbuf_non_anim_new (GdkPixbuf *pixbuf);
function gdk_pixbuf_non_anim_new(pixbuf) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gdk_pixbuf_non_anim_new
  type(c_ptr), value :: pixbuf
end function

end interface
end module gdk_pixbuf

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
! ----------------------------------------------------------------------
! Contributed by James Tappin
! Last modifications: 2012-07-09, vmagnin 2020-06-24 (GTK 4 version),
!                     2020-08-25
! ----------------------------------------------------------------------
!*
! Containers
module gtk_hl_container
  ! The high-level interface provides convenience interfaces for:
  ! * Window, the gtk top-level window.
  ! * Box, Horizontal and vertical boxes to pack widgets. This was added
  !   because the gtk_box_pack_start_defaults procedure is removed from GTK3.x
  ! * Table, a grid layout of widgets
  !   Note that the weird convention where rows comes before columns in sizing
  !   tables, but X before Y in adding widgets follows the convention of
  !   GTK proper.
  ! * Notebook, a tabbed container to pack widgets
  ! * ScrolledWindow, a scrolled window into which to place another widget.
  !/

  use gtk_sup
  use, intrinsic :: iso_c_binding
  ! autogenerated use's
  use gtk, only: gtk_label_new, &
       & gtk_scrolled_window_set_child, gtk_box_append, &
       & gtk_notebook_append_page, gtk_notebook_insert_page,&
       & gtk_notebook_new, gtk_notebook_popup_disable,&
       & gtk_notebook_popup_enable, gtk_notebook_prepend_page,&
       & gtk_notebook_set_scrollable,&
       & gtk_notebook_set_show_tabs, gtk_notebook_set_tab_detachable,&
       & gtk_notebook_set_tab_pos, gtk_notebook_set_tab_reorderable,&
       & gtk_grid_new, gtk_grid_set_row_homogeneous, &
       & gtk_grid_set_column_homogeneous, gtk_grid_set_row_spacing, &
       & gtk_grid_set_column_spacing, gtk_grid_attach, &
       & gtk_widget_set_margin_start, gtk_widget_set_margin_end, &
       & gtk_widget_set_margin_top, gtk_widget_set_margin_bottom, &
       & gtk_widget_set_hexpand, gtk_widget_set_vexpand,  &
       & gtk_widget_set_halign, gtk_widget_set_valign, &
       & gtk_box_new, gtk_box_set_homogeneous, &
       & gtk_widget_set_sensitive, &
       & gtk_window_new, gtk_window_set_decorated,&
       & gtk_window_set_default_size,&
       & gtk_window_set_deletable, gtk_window_set_resizable,&
       & gtk_window_set_title, gtk_window_set_transient_for, &
       & gtk_window_set_icon_name, gtk_window_set_modal, &
       & gtk_notebook_set_group_name, &
       & gtk_scrolled_window_new, gtk_scrolled_window_set_policy, &
       & gtk_widget_set_size_request, GTK_ALIGN_FILL, GTK_ALIGN_CENTER, &
       & GTK_ORIENTATION_HORIZONTAL,  GTK_ORIENTATION_VERTICAL, &
       & TRUE, FALSE, g_signal_connect, &
       & GTK_POLICY_AUTOMATIC

  use g, only: g_object_set_data, g_object_get_data, g_value_get_int

  implicit none

contains
  !+
  function hl_gtk_application_new(app_id, activate, flags, data) result(app)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
    use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE
    use g, only: g_application_run, g_object_unref

    type(c_ptr) :: app
    character(kind=c_char), dimension(*), intent(in) :: app_id
    type(c_funptr), intent(in) :: activate
    integer(c_int), optional, intent(in) :: flags
    type(c_ptr), optional, intent(in) :: data
    integer(c_int) :: the_flags

    ! Higher-level interface to make a GtkApplication
    !
    ! APP_ID |  C string |  compulsory |  name of the GtkApplication. must contain at least one point
    ! ACTIVATE |  c_funptr |  compulsory |  Callback for the "activate" signal (defines the GUI)
    ! FLAGS |  integer |  optional |  flags
    ! DATA |  c_ptr |  optional |  Data to be passed to the "activate" callback function
    !
    !-

    integer(c_int) :: status

    if (present(flags)) then
      the_flags = flags
    else
      the_flags = G_APPLICATION_FLAGS_NONE
    end if

    ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-id-is-valid
    app = gtk_application_new(app_id, the_flags)

    if (present(data)) then
      call g_signal_connect(app, "activate"//c_null_char, activate, data)
    else
      call g_signal_connect(app, "activate"//c_null_char, activate, c_null_ptr)
    end if

    ! Commandline arguments argc, argv are not passed.
    ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-run
    status = g_application_run(app, 0_c_int, [c_null_ptr])

    call g_object_unref(app)
  end function hl_gtk_application_new


  !+
  function hl_gtk_window_new(title, destroy, delete_event, data_destroy, &
       & data_delete_event, border, wsize, sensitive, resizable, decorated, &
       & deletable, above, below, parent, icon, icon_file,&
       & icon_name, modal) result(win)

    type(c_ptr) :: win
    character(kind=c_char), dimension(*), intent(in), optional :: title
    type(c_funptr), optional :: destroy, delete_event
    type(c_ptr), optional :: data_destroy, data_delete_event
    integer(c_int), optional, intent(in) :: border
    integer(c_int), optional, intent(in), dimension(2) :: wsize
    integer(c_int), intent(in), optional :: sensitive, resizable, decorated
    integer(c_int), intent(in), optional :: deletable, above, below
    type(c_ptr), intent(in), optional :: parent
    type(c_ptr), intent(in), optional :: icon
    character(kind=c_char), dimension(*), intent(in), optional :: icon_name, &
         & icon_file
    integer(c_int), intent(in), optional :: modal

    ! Higher-level interface to make a gtk_window
    !
    ! TITLE |  String |  optional |  Title for the window
    ! DESTROY |  c_funptr |  optional |  Callback for the "destroy" signal
    ! DELETE_EVENT |  c_funptr |  optional |  Callback for the "delete-event" signal. **Removed from GTK 4.**
    ! DATA_DESTROY |  c_ptr |  optional |  Data to be passed to the destroy signal handler
    ! DATA_DELETE_EVENT |  c_ptr |  optional |  Data to be passed to the delete_event signal handler
    ! BORDER |  integer |  optional |  Size of the window border
    ! WSIZE |  integer(2) |  optional |  Size of the window
    ! SENSITIVE |  boolean |  optional |  Whether the widget should initially be sensitive or not.
    ! RESIZABLE |  boolean |  optional |  Is the window resizable.
    ! DECORATED |  boolean |  optional |  Set FALSE to disable window decorations.
    ! DELETABLE |  boolean |  optional |  Set to FALSE to remove the "delete" button.
    ! ABOVE | boolean |  optional | Set to TRUE to make the window stay on top of others. **Removed from GTK 4.**
    ! BELOW | boolean |  optional | Set to TRUE to make the window stay below others. **Removed from GTK 4.**
    ! PARENT |  c_ptr |  optional |  An optional parent window for the new window.
    ! ICON |  c_ptr |  optional  |  A GdkPixbuf containing the icon for the window. **Removed from GTK 4.**
    ! ICON_FILE |  String  |  optional  |  A file from which to read the icon for the window. **Removed from GTK 4.**
    ! ICON_NAME |  String  |  optional  |  The name of a standard icon to use for the window.
    ! MODAL |  boolean |  optional |  Set to true to make the window modal (only meaningful if PARENT is also set).
    !
    !-

    win = gtk_window_new()
    if (present(title)) call gtk_window_set_title(win, title)

    if (present(border)) then
      call gtk_widget_set_margin_start (win, border)
      call gtk_widget_set_margin_end (win, border)
      call gtk_widget_set_margin_top (win, border)
      call gtk_widget_set_margin_bottom (win, border)
    end if

    if (present(wsize)) &
         & call gtk_window_set_default_size(win, wsize(1), wsize(2))

    if (present(delete_event)) then
        print *, "Removed from GTK 4: delete-event (use destroy event instead)"
    end if

    if (present(destroy)) then
       if (present(data_destroy)) then
          call g_signal_connect(win, "destroy"//C_NULL_CHAR, destroy, &
               & data_destroy)
       else
          call g_signal_connect(win, "destroy"//C_NULL_CHAR, destroy)
       end if
    end if

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(win, sensitive)

    if (present(resizable)) &
         & call gtk_window_set_resizable(win, resizable)
    if (present(decorated)) &
         & call gtk_window_set_decorated(win, decorated)
    if (present(deletable)) &
         & call gtk_window_set_deletable(win, deletable)

    if (present(above)) print *, "Removed from GTK 4: call gtk_window_set_keep_above(win, above)"
    if (present(below)) print *, "Removed from GTK 4: call gtk_window_set_keep_below(win, below)"

    if (present(parent)) then
       call gtk_window_set_transient_for(win, parent)
       if (present(modal)) call gtk_window_set_modal(win, modal)
    end if

    if (present(icon)) then
       print *, "Removed from GTK 4: call gtk_window_set_icon(win, icon)"
       print *, "=> use icon_name instead"
    else if (present(icon_file)) then
       print *, "Removed from GTK 4: icon_ok = gtk_window_set_icon_from_file (win, icon_file, c_null_ptr)"
       print *, "=> use icon_name instead"
    else if (present(icon_name)) then
       call gtk_window_set_icon_name(win, icon_name)
    end if
  end function hl_gtk_window_new

  !+
  function hl_gtk_box_new(horizontal, homogeneous, spacing) result(box)

    type(c_ptr) :: box
    integer(c_int), intent(in), optional :: horizontal, homogeneous
    integer(c_int), intent(in), optional :: spacing

    ! Generic packing box
    !
    ! HORIZONTAL |  boolean |  optional |  Set to TRUE to make a row box. FALSE or absent implies a column box.
    ! HOMOGENEOUS |  boolean |  optional |  If set to TRUE then all children are the same size, FALSE or absent allows each widget to take its natural size.
    ! SPACING |  c_int |  optional |  Set the space between children.
    !-

    integer(c_int) :: grid, space

    if (present(homogeneous)) then
       grid = homogeneous
    else
       grid=FALSE
    end if

    if (present(spacing)) then
       space = spacing
    else
       space=0
    end if

    if (present(horizontal)) then
       if (horizontal == TRUE) then
          box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, space)
          ! To keep track of the orientation inside the box object.
          ! Just the string matters (not the value of the pointer).
          call g_object_set_data (box, "horizontal"//c_null_char, box)
       else
          box = gtk_box_new(GTK_ORIENTATION_VERTICAL, space)
          call g_object_set_data (box, "vertical"//c_null_char, box)
       end if
    else
       box = gtk_box_new(GTK_ORIENTATION_VERTICAL, space)
       call g_object_set_data (box, "vertical"//c_null_char, box)
    end if

    call gtk_box_set_homogeneous(box, grid)
  end function hl_gtk_box_new

  !+
  subroutine hl_gtk_box_pack(box, child, expand, fill, padding, atend)

    type(c_ptr), intent(in) :: box, child
    integer(c_int), intent(in), optional :: expand, fill
    integer(c_int), intent(in), optional :: padding
    integer(c_int), intent(in), optional :: atend

    ! Put a widget into a box
    !
    ! BOX |  c_ptr |  required |  The box into which to put the child
    ! CHILD |  c_ptr |  required |  The child to pack
    ! EXPAND |  boolean |  optional |  If TRUE then expand this child when filling the box, if FALSE don't, (Default TRUE)
    ! FILL |  boolean |  optional |  If TRUE, then expand the widget when expanding, if FALSE, then put space round it. (Default TRUE, ignored if EXPAND==FALSE.
    ! PADDING |  c_int |  optional |  Extra space to put around the child in the fill direction.
    ! ATEND |  boolean |  optional |  If present and TRUE, then put the child at the end of the box rather than the start.
    !-

    integer(c_int) :: iexp, ifill, ipad, iend

    if (present(expand)) then
       iexp = expand
    else
       iexp = TRUE
    end if
    if (present(fill)) then
       ifill = fill
    else
       ifill = TRUE
    end if
    if (present(padding)) then
       ipad = padding
    else
       ipad = 0
    end if
    if (present(atend)) then
       iend = atend
    else
       iend = FALSE
    end if

    ! We retrieve the orientation of the box:
    if (c_associated(g_object_get_data(box, "horizontal"//c_null_char))) then
      call gtk_widget_set_hexpand (child, iexp)
      call gtk_widget_set_halign (child, ifill)
    else
      call gtk_widget_set_vexpand (child, iexp)
      call gtk_widget_set_valign (child, ifill)
    end if

    call gtk_widget_set_margin_start (child, ipad)
    call gtk_widget_set_margin_end (child, ipad)
    call gtk_widget_set_margin_top (child, ipad)
    call gtk_widget_set_margin_bottom (child, ipad)

    call gtk_box_append(box, child)
  end subroutine hl_gtk_box_pack

  !+
  function hl_gtk_table_new(nrows, ncols, homogeneous, row_spacing, &
       & col_spacing, row_homogeneous, col_homogeneous) result(table)

    type(c_ptr) :: table
    integer(c_int), intent(in), optional :: nrows, ncols
    integer(c_int), intent(in), optional :: homogeneous
    integer(c_int), intent(in), optional :: row_spacing, col_spacing
    integer(c_int), intent(in), optional :: row_homogeneous,&
         & col_homogeneous

    ! Utility interface to create a table container
    !
    ! NROWS |  c_int |  optional |  The initial number of rows.
    ! NCOLS |  c_int |  optional |  The initial number of columns.
    ! HOMOGENEOUS |  boolean |  optional |  Whether the cells all have the same size.
    ! ROW_HOMOGENEOUS |  boolean |  optional |  Whether the rows all have the same size.
    ! COL_HOMOGENEOUS |  boolean |  optional |  Whether the columns all have the same size.
    ! ROW_SPACING |  c_int |  optional |  Spacing between rows.
    ! COL_SPACING |  c_int |  optional |  Spacing between columns.
    !
    ! Note
    ! This is implemented as a GtkTable for Gtk+2.x and as a GtkGrid for 3.x
    ! For 2.x, the ROW and COL_HOMOGENEOUS settings are treated as HOMOGENOUS
    ! except that if both are given and their values differ then homogenous is
    ! not set.
    ! For 3.x the ROW and COL settings take precedence over the common setting.
    ! The NROWS and NCOLS arguments are ignored for  GTK 3.x
    !-

    integer(c_int) :: gridr, gridc
    if (present(homogeneous)) then
       gridr = homogeneous
       gridc = homogeneous
    else
       gridr = FALSE
       gridc = FALSE
    end if
    if (present(row_homogeneous)) gridr = row_homogeneous
    if (present(col_homogeneous)) gridc = col_homogeneous
    table = gtk_grid_new()
    call gtk_grid_set_row_homogeneous(table, gridr)
    call gtk_grid_set_column_homogeneous(table, gridc)
    if (present(row_spacing)) &
         & call gtk_grid_set_row_spacing(table, row_spacing)
    if (present(col_spacing)) &
         & call gtk_grid_set_column_spacing(table, col_spacing)

  end function hl_gtk_table_new

  !+
  subroutine hl_gtk_table_attach(table, widget, ix, iy, xspan, yspan, &
       & xpad, ypad, xopts, yopts)

    type(c_ptr), intent(in) :: table, widget
    integer(c_int), intent(in) :: ix, iy
    integer(c_int), intent(in), optional :: xspan, yspan
    integer(c_int), intent(in), optional :: xpad, ypad
    integer(c_int), intent(in), optional :: xopts, yopts

    ! Attach a widget to a table
    !
    ! TABLE |  c_ptr |  required |  The table to which to attach
    ! WIDGET |  c_ptr |  required |  The widget to attach to the table
    ! IX |  c_int |  required |  The cell number of the left edge of the widget
    ! IY |  c_int |  required |  The cell number of the top edge of the widget.
    ! XSPAN |  c_int |  optional |  How many cells to span in the X direction (1)
    ! YSPAN |  c_int |  optional |  How many cells to span in the Y direction (1)
    ! XPAD |  c_int |  optional |  Padding around the cell in the X direction
    ! YPAD |  c_int |  optional |  Padding in the Y direction
    ! XOPTS | c_int |  optional | X fill/expand options (from the GtkAttachOptions enumerator, or 0 for none). **Removed from GTK 4.**
    ! YOPTS | c_int |  optional | Y fill/expand options. **Removed from GTK 4.**
    !
    ! N.B. GTK_SHRINK in the options is ignored in  GTK 3.x
    !-

    integer(c_int) :: ixsz, iysz
    integer(c_int) :: ixexp, iyexp, ixfill, iyfill

    if (present(xspan)) then
       ixsz = xspan
    else
       ixsz = 1
    end if
    if (present(yspan)) then
       iysz = yspan
    else
       iysz = 1
    end if

    if (present(xopts)) then
       print *, "Removed from GTK 4: GTK_EXPAND and GTK_FILL"
    else
       ixexp = TRUE
       ixfill = GTK_ALIGN_FILL
    end if
    if (present(yopts)) then
       print *, "Removed from GTK 4: GTK_EXPAND and GTK_FILL"
    else
       iyexp = TRUE
       iyfill = GTK_ALIGN_FILL
    end if

    call gtk_grid_attach(table, widget, ix, iy, ixsz, iysz)
    if (present(xpad)) then
       call gtk_widget_set_margin_start(widget, xpad)
       call gtk_widget_set_margin_end(widget, xpad)
    end if
    if (present(ypad)) then
       call gtk_widget_set_margin_top(widget, ypad)
       call gtk_widget_set_margin_bottom(widget, ypad)
    end if
    call gtk_widget_set_hexpand (widget, ixexp)
    call gtk_widget_set_vexpand (widget, iyexp)
    call gtk_widget_set_halign (widget, ixfill)
    call gtk_widget_set_valign (widget, iyfill)

  end subroutine hl_gtk_table_attach

  !+
  subroutine hl_gtk_table_expand(table, ny, nx)

    type(c_ptr), intent(in) :: table
    integer(c_int), intent(in), optional :: ny, nx

    ! Add rows and/or columns to a table
    !
    ! TABLE |  c_ptr |  required |  The table to enlarge
    ! NY |  c_int |  optional |  How many rows to add
    ! NX |  c_int |  optional |  How many columns to add
    !
    ! To set an absolute size, use gtk_table_resize
    ! directly. Negative NX and/or NY will reduce the table.
    ! For  GTK3.x this is a do-nothing routine.
    !-

  end subroutine hl_gtk_table_expand

  !+
  function hl_gtk_notebook_new(show_tabs, tab_position, popup, &
       & scrollable, group, switch_page, data) result(nbook)

    type(c_ptr) :: nbook
    integer(c_int), intent(in), optional :: show_tabs
    integer(c_int), intent(in), optional :: tab_position
    integer(c_int), intent(in), optional :: popup, scrollable
    character(kind=c_char), intent(in), optional, dimension(*), target :: group
    type(c_funptr), optional :: switch_page
    type(c_ptr), intent(in), optional :: data

    ! Convenience function to create a notebook (tabbed) container
    !
    ! SHOW_TABS |  boolean |  optional |  Whether the tabs are visible
    ! TAB_POSITION |  c_int |  optional |   Where the tabs are placed (from the GtkPositionType enumerator).
    ! POPUP |  boolean |  optional |  Whether to have a popup tab selector.
    ! SCROLLABLE |  boolean |  optional |  Whether the tabs are scrollable if there are too many to fit.
    ! GROUP |  string |  optional |  A group name for the notebook (needed if you want to drag tabs from one book to another). **N.B.** For GTK+2, this probably has to be a variable to work.
    ! SWITCH_PAGE |  c_funptr |  optional |  A callback to be called when the page selection is changed (signal switch-page). Note that this callback has 4 arguments; the notebook, the selected page, the index of that page and the user data.
    ! DATA |  c_ptr |  optional |  Data to pass the the switch-page callback.
    !-

    nbook = gtk_notebook_new()

    if (present(show_tabs)) &
         & call gtk_notebook_set_show_tabs(nbook, show_tabs)

    if (present(tab_position)) &
         & call gtk_notebook_set_tab_pos(nbook, tab_position)

    if (present(popup)) then
       if (popup == FALSE) then
          call gtk_notebook_popup_disable(nbook)
       else
          call gtk_notebook_popup_enable(nbook)
       end if
    end if

    if (present(scrollable)) &
         & call gtk_notebook_set_scrollable(nbook, scrollable)

    if (present(group)) &
         & call gtk_notebook_set_group_name(nbook, group)

    if (present(switch_page)) then
       if (present(data)) then
          call g_signal_connect(nbook, "switch-page"//c_null_char, &
               & switch_page, data)
       else
          call g_signal_connect(nbook, "switch-page"//c_null_char, &
               & switch_page)
       end if
    end if

  end function hl_gtk_notebook_new

  !+
  function hl_gtk_notebook_add_page(nbook, page, position, at_start, &
       & reorderable, detachable, label) result(location)

    integer(c_int) :: location
    type(c_ptr), intent(in) :: nbook, page
    integer(c_int), intent(in), optional :: position
    integer(c_int), intent(in), optional :: at_start, reorderable, &
         & detachable
    character(kind=c_char), dimension(*), intent(in), optional :: label

    ! Convenience function to add a page to a notebook.
    !
    ! NBOOK |  c_ptr |  required |  The book to which to add the page
    ! PAGE |  c_ptr |  required |  The page to at to the book.
    ! POSITION |  c_int |  optional |  The position at which to add the page.
    ! AT_START |  boolean |  optional |  Set to TRUE to add at the start. (If neither AT_START nor POSITION is given the page is added at the end).
    ! REORDERABLE |  boolean |  optional |  Whether the tab can be reordered by drag and drop
    ! DETACHABLE |  boolean |  optional |  Whether the tab can be dragged to a different notebook (requires a group name for the notebooks).
    ! LABEL |  string |  optional |  A label to show on the tab.
    !
    ! Returns the location at which the tab was added or -1 for failure.
    !-

    type(c_ptr) :: lwidget
    integer(c_int) :: istart

    if (present(label)) then
       lwidget = gtk_label_new(label)
    else
       lwidget = C_NULL_PTR
    end if

    if (present(position)) then
       location = gtk_notebook_insert_page(nbook, page, lwidget, position)
    else
       if (present(at_start)) then
          istart = at_start
       else
          istart = FALSE
       end if
       if (istart == FALSE) then
          location = gtk_notebook_append_page(nbook, page, lwidget)
       else
          location = gtk_notebook_prepend_page(nbook, page, lwidget)
       end if
    end if

    if (location < 0) return

    if (present(reorderable)) &
         & call gtk_notebook_set_tab_reorderable(nbook, page, reorderable)

    if (present(detachable)) &
         & call gtk_notebook_set_tab_detachable(nbook, page, detachable)

  end function hl_gtk_notebook_add_page

  !+
  function hl_gtk_scrolled_window_new(hpolicy, vpolicy, &
       & hsize, vsize, hadjustment, vadjustment) result(win)

    type(c_ptr) :: win
    integer(c_int), intent(in), optional :: hpolicy, vpolicy
    integer(c_int), intent(in), optional :: hsize, vsize
    type(c_ptr), intent(in), optional :: hadjustment, vadjustment

    ! Create a scrolled window, with convenient settings.
    !
    ! HPOLICY |  c_int |  optional |  Whether to show the horizontal scrollbar default- GTK_POLICY_AUTOMATIC, allowed- any GTK_POLICY_TYPE
    ! VPOLICY |  c_int |  optional |  Whether to show the vertical scrollbar default- GTK_POLICY_AUTOMATIC, allowed- any GTK_POLICY_TYPE
    ! HSIZE |  c_int |  optional |  The size of the window in the horizontal direction.
    ! VSIZE |  c_int |  optional |  The size of the window in the vertical direction.
    ! HADJUSTMENT |  c_ptr |  optional |  An adjustment widget to use in place of the automatically generated scrollbar in the horizontal direction. **Removed from GTK 4.**
    ! VADJUSTMENT |  c_ptr |  optional |  An adjustment widget to use in place of the automatically generated scrollbar in the vertical direction. **Removed from GTK 4.**
    !-

    integer(c_int) :: hpol, vpol, hsz, vsz
    logical :: have_size, have_policy

    ! Set up the scroll bar policies.
    have_policy = .false.
    if (present(hpolicy)) then
       hpol = hpolicy
       have_policy = .true.
    else
       hpol = GTK_POLICY_AUTOMATIC
    end if
    if (present(vpolicy)) then
       vpol = vpolicy
       have_policy = .true.
    else
       vpol = GTK_POLICY_AUTOMATIC
    end if

    ! Set up the sizes
    have_size = .false.
    if (present(hsize)) then
       hsz = hsize
       have_size = .true.
    else
       hsz = -1
    end if
    if (present(vsize)) then
       vsz = vsize
       have_size = .true.
    else
       vsz = -1
    end if

    ! Set up the adjustments
    if (present(hadjustment)) then
       print *, "Removed from GTK 4: hadjustment in gtk_scrolled_window_new()"
    end if
    if (present(vadjustment)) then
       print *, "Removed from GTK 4: vadjustment in gtk_scrolled_window_new()"
    end if

    win = gtk_scrolled_window_new()

    if (have_policy) call gtk_scrolled_window_set_policy(win, hpol, vpol)
    if (have_size) call gtk_widget_set_size_request(win, hsz, vsz)
  end function hl_gtk_scrolled_window_new

  !+
  subroutine hl_gtk_scrolled_window_add(win, child, viewport)
    type(c_ptr), intent(in) :: win, child
    integer(c_int), intent(in), optional :: viewport

    ! Add a widget to a scrolled window.
    !
    ! WIN |  c_ptr |  required |  The scrolled window.
    ! CHILD |  c_ptr |  required |  The widget to insert.
    ! VIEWPORT |  c_int |  optional |  Set this to true if the child widget requires a viewport between it and the scrolled window. Unfortunately I can't see a way to determine automatically whether this is needed.
    !-

    call gtk_scrolled_window_set_child(win, child)
  end subroutine hl_gtk_scrolled_window_add

end module gtk_hl_container

! $ gfortran -Wall -Wextra -std=f2008 -pedantic -g my_first_gtk_app2.f90 $(pkg-config --cflags --libs gtk-4-fortran)

module handlers
  use, intrinsic :: iso_c_binding
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref

  implicit none

  contains

end module handlers

program my_first_gtk_app
  use handlers

  implicit none
  type(c_ptr)    :: app
  integer(c_int) :: status

  app = gtk_application_new("gtk-fortran.my_first_gtk_app"//c_null_char, &
                          & G_APPLICATION_FLAGS_NONE)
  status = g_application_run(app, 0_c_int, [c_null_ptr])
  call g_object_unref(app)
end program

! Do not modify this file automatically generated by cfwrapper.py using:
! gtk-fortran 4.8.0, GTK 4.18.4, GLib 2.84.1, Fedora 42 x86_64
! This file is part of the gtk-fortran library, distributed under
! GNU General Public License version 3.

module unix_print
use, intrinsic :: iso_c_binding
implicit none
interface

!--------------------------------------------------
! /usr/include/gtk-4.0/unix-print/gtk/gtkunixprint.h
!--------------------------------------------------
!--------------------------------------------------
! /usr/include/gtk-4.0/unix-print/gtk/print/gtkprintunixdialog.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gtk_print_unix_dialog_get_type (void) ;
function gtk_print_unix_dialog_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gtk_print_unix_dialog_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GtkWidget * gtk_print_unix_dialog_new (const char *title, GtkWindow *parent);
function gtk_print_unix_dialog_new(title, parent) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gtk_print_unix_dialog_new
  character(kind=c_char), dimension(*) :: title
  type(c_ptr), value :: parent
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_page_setup (GtkPrintUnixDialog *dialog, GtkPageSetup *page_setup);
subroutine gtk_print_unix_dialog_set_page_setup(dialog, page_setup) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: dialog
  type(c_ptr), value :: page_setup
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPageSetup * gtk_print_unix_dialog_get_page_setup (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_page_setup(dialog) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_unix_dialog_get_page_setup
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_current_page (GtkPrintUnixDialog *dialog, int current_page);
subroutine gtk_print_unix_dialog_set_current_page(dialog, current_page) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: dialog
  integer(c_int), value :: current_page
end subroutine

! GDK_AVAILABLE_IN_ALL
!int gtk_print_unix_dialog_get_current_page (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_current_page(dialog) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_unix_dialog_get_current_page
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_settings (GtkPrintUnixDialog *dialog, GtkPrintSettings *settings);
subroutine gtk_print_unix_dialog_set_settings(dialog, settings) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: dialog
  type(c_ptr), value :: settings
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPrintSettings * gtk_print_unix_dialog_get_settings (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_settings(dialog) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_unix_dialog_get_settings
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrinter * gtk_print_unix_dialog_get_selected_printer (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_selected_printer(dialog) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_unix_dialog_get_selected_printer
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_add_custom_tab (GtkPrintUnixDialog *dialog, GtkWidget *child, GtkWidget *tab_label);
subroutine gtk_print_unix_dialog_add_custom_tab(dialog, child, tab_label)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: dialog
  type(c_ptr), value :: child
  type(c_ptr), value :: tab_label
end subroutine

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_manual_capabilities (GtkPrintUnixDialog *dialog, GtkPrintCapabilities capabilities);
subroutine gtk_print_unix_dialog_set_manual_capabilities(dialog, capabilities)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: dialog
  integer(c_int), value :: capabilities
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPrintCapabilities gtk_print_unix_dialog_get_manual_capabilities (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_manual_capabilities(dialog) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_unix_dialog_get_manual_capabilities
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_support_selection (GtkPrintUnixDialog *dialog, gboolean support_selection);
subroutine gtk_print_unix_dialog_set_support_selection(dialog,&
& support_selection) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: dialog
  integer(c_int), value :: support_selection
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_unix_dialog_get_support_selection (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_support_selection(dialog) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_unix_dialog_get_support_selection
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_has_selection (GtkPrintUnixDialog *dialog, gboolean has_selection);
subroutine gtk_print_unix_dialog_set_has_selection(dialog, has_selection)&
& bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: dialog
  integer(c_int), value :: has_selection
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_unix_dialog_get_has_selection (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_has_selection(dialog) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_unix_dialog_get_has_selection
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_unix_dialog_set_embed_page_setup (GtkPrintUnixDialog *dialog, gboolean embed);
subroutine gtk_print_unix_dialog_set_embed_page_setup(dialog, embed) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: dialog
  integer(c_int), value :: embed
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_unix_dialog_get_embed_page_setup (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_embed_page_setup(dialog) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_unix_dialog_get_embed_page_setup
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_unix_dialog_get_page_setup_set (GtkPrintUnixDialog *dialog);
function gtk_print_unix_dialog_get_page_setup_set(dialog) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_unix_dialog_get_page_setup_set
  type(c_ptr), value :: dialog
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/unix-print/gtk/print/gtkprintjob.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gtk_print_job_get_type (void) ;
function gtk_print_job_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gtk_print_job_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrintJob *gtk_print_job_new (const char *title, GtkPrinter *printer, GtkPrintSettings *settings, GtkPageSetup *page_setup);
function gtk_print_job_new(title, printer, settings, page_setup) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gtk_print_job_new
  character(kind=c_char), dimension(*) :: title
  type(c_ptr), value :: printer
  type(c_ptr), value :: settings
  type(c_ptr), value :: page_setup
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrintSettings *gtk_print_job_get_settings (GtkPrintJob *job);
function gtk_print_job_get_settings(job) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_job_get_settings
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrinter *gtk_print_job_get_printer (GtkPrintJob *job);
function gtk_print_job_get_printer(job) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_job_get_printer
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!const char * gtk_print_job_get_title (GtkPrintJob *job);
function gtk_print_job_get_title(job) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_job_get_title
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrintStatus gtk_print_job_get_status (GtkPrintJob *job);
function gtk_print_job_get_status(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_status
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_job_set_source_file (GtkPrintJob *job, const char *filename, GError **error);
function gtk_print_job_set_source_file(job, filename, error) bind(c)
  import :: c_int, c_ptr, c_char
  implicit none
  integer(c_int) :: gtk_print_job_set_source_file
  type(c_ptr), value :: job
  character(kind=c_char), dimension(*) :: filename
  type(c_ptr), value :: error
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_job_set_source_fd (GtkPrintJob *job, int fd, GError **error);
function gtk_print_job_set_source_fd(job, fd, error) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_set_source_fd
  type(c_ptr), value :: job
  integer(c_int), value :: fd
  type(c_ptr), value :: error
end function

! GDK_AVAILABLE_IN_ALL
!cairo_surface_t *gtk_print_job_get_surface (GtkPrintJob *job, GError **error);
function gtk_print_job_get_surface(job, error) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_job_get_surface
  type(c_ptr), value :: job
  type(c_ptr), value :: error
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_track_print_status (GtkPrintJob *job, gboolean track_status);
subroutine gtk_print_job_set_track_print_status(job, track_status) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: track_status
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_job_get_track_print_status (GtkPrintJob *job);
function gtk_print_job_get_track_print_status(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_track_print_status
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_send (GtkPrintJob *job, GtkPrintJobCompleteFunc callback, gpointer user_data, GDestroyNotify dnotify);
subroutine gtk_print_job_send(job, callback, user_data, dnotify) bind(c)
  import :: c_ptr, c_funptr
  implicit none
  type(c_ptr), value :: job
  type(c_funptr), value :: callback
  type(c_ptr), value :: user_data
  type(c_funptr), value :: dnotify
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPrintPages gtk_print_job_get_pages (GtkPrintJob *job);
function gtk_print_job_get_pages(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_pages
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_pages (GtkPrintJob *job, GtkPrintPages pages);
subroutine gtk_print_job_set_pages(job, pages) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: pages
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPageRange * gtk_print_job_get_page_ranges (GtkPrintJob *job, int *n_ranges);
function gtk_print_job_get_page_ranges(job, n_ranges) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_print_job_get_page_ranges
  type(c_ptr), value :: job
  type(c_ptr), value :: n_ranges
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_page_ranges (GtkPrintJob *job, GtkPageRange *ranges, int n_ranges);
subroutine gtk_print_job_set_page_ranges(job, ranges, n_ranges) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  type(c_ptr), value :: ranges
  integer(c_int), value :: n_ranges
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPageSet gtk_print_job_get_page_set (GtkPrintJob *job);
function gtk_print_job_get_page_set(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_page_set
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_page_set (GtkPrintJob *job, GtkPageSet page_set);
subroutine gtk_print_job_set_page_set(job, page_set) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: page_set
end subroutine

! GDK_AVAILABLE_IN_ALL
!int gtk_print_job_get_num_copies (GtkPrintJob *job);
function gtk_print_job_get_num_copies(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_num_copies
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_num_copies (GtkPrintJob *job, int num_copies);
subroutine gtk_print_job_set_num_copies(job, num_copies) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: num_copies
end subroutine

! GDK_AVAILABLE_IN_ALL
!double gtk_print_job_get_scale (GtkPrintJob *job);
function gtk_print_job_get_scale(job) bind(c)
  import :: c_double, c_ptr
  implicit none
  real(c_double) :: gtk_print_job_get_scale
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_scale (GtkPrintJob *job, double scale);
subroutine gtk_print_job_set_scale(job, scale) bind(c)
  import :: c_ptr, c_double
  implicit none
  type(c_ptr), value :: job
  real(c_double), value :: scale
end subroutine

! GDK_AVAILABLE_IN_ALL
!guint gtk_print_job_get_n_up (GtkPrintJob *job);
function gtk_print_job_get_n_up(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_n_up
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_n_up (GtkPrintJob *job, guint n_up);
subroutine gtk_print_job_set_n_up(job, n_up) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: n_up
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkNumberUpLayout gtk_print_job_get_n_up_layout (GtkPrintJob *job);
function gtk_print_job_get_n_up_layout(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_n_up_layout
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_n_up_layout (GtkPrintJob *job, GtkNumberUpLayout layout);
subroutine gtk_print_job_set_n_up_layout(job, layout) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: layout
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_job_get_rotate (GtkPrintJob *job);
function gtk_print_job_get_rotate(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_rotate
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_rotate (GtkPrintJob *job, gboolean rotate);
subroutine gtk_print_job_set_rotate(job, rotate) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: rotate
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_job_get_collate (GtkPrintJob *job);
function gtk_print_job_get_collate(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_collate
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_collate (GtkPrintJob *job, gboolean collate);
subroutine gtk_print_job_set_collate(job, collate) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: collate
end subroutine

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_print_job_get_reverse (GtkPrintJob *job);
function gtk_print_job_get_reverse(job) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_print_job_get_reverse
  type(c_ptr), value :: job
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_print_job_set_reverse (GtkPrintJob *job, gboolean reverse);
subroutine gtk_print_job_set_reverse(job, reverse) bind(c)
  import :: c_ptr, c_int
  implicit none
  type(c_ptr), value :: job
  integer(c_int), value :: reverse
end subroutine

!--------------------------------------------------
! /usr/include/gtk-4.0/unix-print/gtk/print/gtkpagesetupunixdialog.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gtk_page_setup_unix_dialog_get_type (void) ;
function gtk_page_setup_unix_dialog_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gtk_page_setup_unix_dialog_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GtkWidget * gtk_page_setup_unix_dialog_new (const char *title, GtkWindow *parent);
function gtk_page_setup_unix_dialog_new(title, parent) bind(c)
  import :: c_ptr, c_char
  implicit none
  type(c_ptr) :: gtk_page_setup_unix_dialog_new
  character(kind=c_char), dimension(*) :: title
  type(c_ptr), value :: parent
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_page_setup_unix_dialog_set_page_setup (GtkPageSetupUnixDialog *dialog, GtkPageSetup *page_setup);
subroutine gtk_page_setup_unix_dialog_set_page_setup(dialog, page_setup)&
& bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: dialog
  type(c_ptr), value :: page_setup
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPageSetup * gtk_page_setup_unix_dialog_get_page_setup (GtkPageSetupUnixDialog *dialog);
function gtk_page_setup_unix_dialog_get_page_setup(dialog) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_page_setup_unix_dialog_get_page_setup
  type(c_ptr), value :: dialog
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_page_setup_unix_dialog_set_print_settings (GtkPageSetupUnixDialog *dialog, GtkPrintSettings *print_settings);
subroutine gtk_page_setup_unix_dialog_set_print_settings(dialog,&
& print_settings) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: dialog
  type(c_ptr), value :: print_settings
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPrintSettings *gtk_page_setup_unix_dialog_get_print_settings (GtkPageSetupUnixDialog *dialog);
function gtk_page_setup_unix_dialog_get_print_settings(dialog) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_page_setup_unix_dialog_get_print_settings
  type(c_ptr), value :: dialog
end function

!--------------------------------------------------
! /usr/include/gtk-4.0/unix-print/gtk/print/gtkprinter.h
!--------------------------------------------------
! GDK_AVAILABLE_IN_ALL
!GType gtk_print_capabilities_get_type (void) ;
function gtk_print_capabilities_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gtk_print_capabilities_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GType gtk_printer_get_type (void) ;
function gtk_printer_get_type() bind(c)
  import :: c_size_t
  implicit none
  integer(c_size_t) :: gtk_printer_get_type
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrinter *gtk_printer_new (const char *name, GtkPrintBackend *backend, gboolean virtual_);
function gtk_printer_new(name, backend, virtual_) bind(c)
  import :: c_ptr, c_char, c_int
  implicit none
  type(c_ptr) :: gtk_printer_new
  character(kind=c_char), dimension(*) :: name
  type(c_ptr), value :: backend
  integer(c_int), value :: virtual_
end function

! GDK_AVAILABLE_IN_ALL
!GtkPrintBackend *gtk_printer_get_backend (GtkPrinter *printer);
function gtk_printer_get_backend(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_backend
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!const char * gtk_printer_get_name (GtkPrinter *printer);
function gtk_printer_get_name(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_name
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!const char * gtk_printer_get_state_message (GtkPrinter *printer);
function gtk_printer_get_state_message(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_state_message
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!const char * gtk_printer_get_description (GtkPrinter *printer);
function gtk_printer_get_description(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_description
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!const char * gtk_printer_get_location (GtkPrinter *printer);
function gtk_printer_get_location(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_location
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!const char * gtk_printer_get_icon_name (GtkPrinter *printer);
function gtk_printer_get_icon_name(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_icon_name
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!int gtk_printer_get_job_count (GtkPrinter *printer);
function gtk_printer_get_job_count(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_get_job_count
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_is_active (GtkPrinter *printer);
function gtk_printer_is_active(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_is_active
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_is_paused (GtkPrinter *printer);
function gtk_printer_is_paused(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_is_paused
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_is_accepting_jobs (GtkPrinter *printer);
function gtk_printer_is_accepting_jobs(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_is_accepting_jobs
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_is_virtual (GtkPrinter *printer);
function gtk_printer_is_virtual(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_is_virtual
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_is_default (GtkPrinter *printer);
function gtk_printer_is_default(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_is_default
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_accepts_pdf (GtkPrinter *printer);
function gtk_printer_accepts_pdf(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_accepts_pdf
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_accepts_ps (GtkPrinter *printer);
function gtk_printer_accepts_ps(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_accepts_ps
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!GList *gtk_printer_list_papers (GtkPrinter *printer);
function gtk_printer_list_papers(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_list_papers
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!GtkPageSetup *gtk_printer_get_default_page_size (GtkPrinter *printer);
function gtk_printer_get_default_page_size(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr) :: gtk_printer_get_default_page_size
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!int gtk_printer_compare (GtkPrinter *a, GtkPrinter *b);
function gtk_printer_compare(a, b) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_compare
  type(c_ptr), value :: a
  type(c_ptr), value :: b
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_has_details (GtkPrinter *printer);
function gtk_printer_has_details(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_has_details
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_printer_request_details (GtkPrinter *printer);
subroutine gtk_printer_request_details(printer) bind(c)
  import :: c_ptr
  implicit none
  type(c_ptr), value :: printer
end subroutine

! GDK_AVAILABLE_IN_ALL
!GtkPrintCapabilities gtk_printer_get_capabilities (GtkPrinter *printer);
function gtk_printer_get_capabilities(printer) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_get_capabilities
  type(c_ptr), value :: printer
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_get_hard_margins (GtkPrinter *printer, double *top, double *bottom, double *left, double *right);
function gtk_printer_get_hard_margins(printer, top, bottom, left, right)&
& bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_get_hard_margins
  type(c_ptr), value :: printer
  type(c_ptr), value :: top
  type(c_ptr), value :: bottom
  type(c_ptr), value :: left
  type(c_ptr), value :: right
end function

! GDK_AVAILABLE_IN_ALL
!gboolean gtk_printer_get_hard_margins_for_paper_size (GtkPrinter *printer, GtkPaperSize *paper_size, double *top, double *bottom, double *left, double *right);
function gtk_printer_get_hard_margins_for_paper_size(printer, paper_size, top,&
& bottom, left, right) bind(c)
  import :: c_int, c_ptr
  implicit none
  integer(c_int) :: gtk_printer_get_hard_margins_for_paper_size
  type(c_ptr), value :: printer
  type(c_ptr), value :: paper_size
  type(c_ptr), value :: top
  type(c_ptr), value :: bottom
  type(c_ptr), value :: left
  type(c_ptr), value :: right
end function

! GDK_AVAILABLE_IN_ALL
!void gtk_enumerate_printers (GtkPrinterFunc func, gpointer data, GDestroyNotify destroy, gboolean wait);
subroutine gtk_enumerate_printers(func, data, destroy, wait) bind(c)
  import :: c_funptr, c_ptr, c_int
  implicit none
  type(c_funptr), value :: func
  type(c_ptr), value :: data
  type(c_funptr), value :: destroy
  integer(c_int), value :: wait
end subroutine

end interface
end module unix_print

! This gtk_os_dependent module is present only for API compatibility,
! as the mswindowsonly-auto.f90 and unixonly-auto.f90 files were
! removed in GTK 4.2.0 (in 2022). These functions are now declared
! in the gdk_pixbuf module (gdk-pixbuf-auto.f90 file).

! This file is part of the gtk-fortran library, distributed under
! GNU General Public License version 3.

module gtk_os_dependent
  use gdk_pixbuf, only: gdk_pixbuf_new_from_file, gdk_pixbuf_new_from_file_at_size, &
                        gdk_pixbuf_new_from_file_at_scale, gdk_pixbuf_savev
end module gtk_os_dependent

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public
!  License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-----------------------------------------------------------------------------
! Contributed by James Tappin
! Last modifications: 2012-12-13
!   vmagnin 2022-04-09
!-----------------------------------------------------------------------------

!*
! gdk_pixbuf_hl
module gdk_pixbuf_hl
  ! Some routines to facilitate the use of GDK pixbufs from Fortran.
  ! Allows the use of short-int images to avoid the issues that may result
  ! from Fortran's 8-bit integers being signed while GdkPixbuf pixels are
  ! unsigned.
  !/

  use g, only: g_slist_free, g_slist_length, g_slist_nth_data

  use gdk_pixbuf, only: gdk_pixbuf_format_get_description, &
       & gdk_pixbuf_format_get_extensions, gdk_pixbuf_format_get_license, &
       & gdk_pixbuf_format_get_mime_types, gdk_pixbuf_format_get_name, &
       & gdk_pixbuf_format_is_scalable, gdk_pixbuf_format_is_writable, &
       & gdk_pixbuf_get_bits_per_sample, gdk_pixbuf_get_formats, &
       & gdk_pixbuf_get_has_alpha, gdk_pixbuf_get_height, &
       & gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, &
       & gdk_pixbuf_get_rowstride, gdk_pixbuf_get_width, gdk_pixbuf_new, &
       & gdk_pixbuf_new_from_file, &
       & gdk_pixbuf_new_from_file_at_scale, gdk_pixbuf_savev

  use gtk, only: TRUE, FALSE, GDK_COLORSPACE_RGB

  use gtk_sup

  use, intrinsic :: iso_c_binding, only: c_null_ptr
  use, intrinsic :: iso_fortran_env, only: error_unit

  implicit none

  interface hl_gdk_pixbuf_new
     module procedure hl_gdk_pixbuf_new_empty
     module procedure hl_gdk_pixbuf_new_file
     module procedure hl_gdk_pixbuf_new_data8
     module procedure hl_gdk_pixbuf_new_data16
     module procedure hl_gdk_pixbuf_new_data8g
     module procedure hl_gdk_pixbuf_new_data16g
  end interface hl_gdk_pixbuf_new

  interface hl_gdk_pixbuf_get_pixels
     module procedure hl_gdk_pixbuf_get_pixels8
     module procedure hl_gdk_pixbuf_get_pixels16
  end interface hl_gdk_pixbuf_get_pixels

  interface hl_gdk_pixbuf_set_pixels
     module procedure hl_gdk_pixbuf_set_pixels8
     module procedure hl_gdk_pixbuf_set_pixels16
     module procedure hl_gdk_pixbuf_set_pixels8g
     module procedure hl_gdk_pixbuf_set_pixels16g
  end interface hl_gdk_pixbuf_set_pixels

  integer, parameter :: hl_gdk_pixbuf_type_len=20
  integer, parameter :: hl_gdk_pixbuf_option_len=80

contains

  !+
  function hl_gdk_pixbuf_new_empty(width, height, alpha, bits) &
       & result(pixbuf)
    type(c_ptr) :: pixbuf
    integer(c_int), intent(in) :: width, height
    integer(c_int), intent(in), optional :: alpha, bits

    ! Create a new empty pixbuf of the given size
    !
    ! WIDTH |  int |  required |  The width in pixels of the pixbuf
    ! HEIGHT |  int |  required |  The height in pixels of the pixbuf
    ! ALPHA |  boolean |  optional |  Whether to include an alpha channel (default=FALSE)
    ! BITS |  int |  optional |  The nuber of bits per sample (default=8).
    !
    ! This routine will usually be called via the generic interface
    ! hl_gdk_pixbuf_new.
    !-

    integer(c_int) :: isalpha, bpp

    if (present(alpha)) then
       isalpha = alpha
    else
       isalpha = FALSE
    end if
    if (present(bits)) then
       bpp = bits
    else
       bpp = 8
    end if

    pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, isalpha, bpp, width, height)

  end function hl_gdk_pixbuf_new_empty

  !+
  function hl_gdk_pixbuf_new_file(file, width, height, aspect, &
       & error) result(pixbuf)
    type(c_ptr) :: pixbuf
    character(len=*), intent(in) :: file
    integer(c_int), optional, intent(in) :: width, height, aspect
    character(len=*), optional, intent(out) :: error

    ! Read an image file into a new pixbuf
    !
    ! FILE |  string |  required |  The file to read
    ! WIDTH |  int |  optional |  The desired width for the pixbuf
    ! HEIGHT |  int |  optional |  The desired height for the pixbuf
    ! ASPECT |  boolean |  optional |  If sizing is given then set to TRUE to preserve the aspect ratio, or FALSE not to. If both dimensions are given, then the default is FALSE, if one is given, the default is TRUE.
    ! ERROR |  gerror |  optional |  The error code & message.
    !
    ! This routine will usually be called via the generic interface
    ! hl_gdk_pixbuf_new.
    !-

    integer(c_int) :: nx, ny, keep_asp
    type(gerror), pointer :: error_struct
    type(c_ptr), target :: error_str
    character(len=120) :: errmsg

    error_str = c_null_ptr
    if (present(width) .or. present(height)) then
       if (present(width)) then
          nx = width
       else
          nx = -1
       end if
       if (present(height)) then
          ny = height
       else
          ny = -1
       end if
       if (present(aspect)) then
          keep_asp = aspect
       else if (present(width) .and. present(height)) then
          keep_asp = FALSE
       else
          keep_asp = TRUE
       end if
       pixbuf = gdk_pixbuf_new_from_file_at_scale(trim(file)//c_null_char, &
            & nx, ny, keep_asp, c_loc(error_str))
    else
       pixbuf = gdk_pixbuf_new_from_file(trim(file)//c_null_char, &
            & c_loc(error_str))
    end if

    if (.not. c_associated(pixbuf)) then
       call c_f_pointer(error_str, error_struct)
       call convert_c_string(error_struct%message, &
            & errmsg)
       if (present(error)) then
          error = errmsg
       else
          write(error_unit, *) "HL_GDK_PIXBUF_NEW_FILE: ",trim(errmsg)
       end if
    else if (present(error)) then
       error = ''
    end if

  end function hl_gdk_pixbuf_new_file

  !+
  function hl_gdk_pixbuf_new_data8(data) result(pixbuf)
    type(c_ptr) :: pixbuf
    integer(c_int8_t), dimension(:,:,:), intent(in) :: data

    ! Create a pixbuf from an RGB(A) array of values.
    !
    ! DATA |  int8 |  required |  The data values as a 1..4 x n x m array.
    !
    ! This routine will usually be called via the generic interface
    ! hl_gdk_pixbuf_new.
    !-

    integer(c_int), dimension(3) :: sz
    integer(c_int) :: alpha

    sz = shape(data)
    select case (sz(1))
    case(1,3)
       alpha = FALSE
    case(2,4)
       alpha = TRUE
    case default
       pixbuf = c_null_ptr
       write(error_unit, *) &
            & "HL_GDK_PIXBUF_NEW_DATA8: first dimension of the data"//&
            & " must be between 1 and 4"
       return
    end select

    pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, alpha, 8_c_int, &
         & sz(2), sz(3))

    call hl_gdk_pixbuf_set_pixels(pixbuf, data)
  end function hl_gdk_pixbuf_new_data8


  !+
  function hl_gdk_pixbuf_new_data8g(data) result(pixbuf)
    type(c_ptr) :: pixbuf
    integer(c_int8_t), dimension(:,:), intent(in) :: data

    ! Create a pixbuf from a greyscale array of values.
    !
    ! DATA |  int8 |  required |  The data values as a n x m array.
    !
    ! This routine will usually be called via the generic interface
    ! hl_gdk_pixbuf_new.
    !-

    integer(c_int), dimension(2) :: sz

    sz = shape(data)

    pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8_c_int, &
         & sz(1), sz(2))

    call hl_gdk_pixbuf_set_pixels(pixbuf, data)
  end function hl_gdk_pixbuf_new_data8g


  !+
  function hl_gdk_pixbuf_new_data16(data) result(pixbuf)
    type(c_ptr) :: pixbuf
    integer(c_short), dimension(:,:,:), intent(in) :: data

    ! Create a pixbuf from an RGB(A) array of values. This version
    ! uses 2-byte integers to avoid the signing issues of the c_int8_t type.
    !
    ! DATA |  short |  required |  The data values as a 1..4 x n x m array.
    !
    ! This routine will usually be called via the generic interface
    ! hl_gdk_pixbuf_new.
    !-

    integer(c_int), dimension(3) :: sz
    integer(c_int) :: alpha

    sz = shape(data)

    select case (sz(1))
    case(1,3)
       alpha = FALSE
    case(2,4)
       alpha = TRUE
    case default
       pixbuf = c_null_ptr
       write(error_unit, *) &
            & "HL_GDK_PIXBUF_NEW_DATA16: first dimension of the data"//&
            & " must be between 1 and 4"
       return
    end select

    pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, alpha, 8_c_int, &
         & sz(2), sz(3))

    call hl_gdk_pixbuf_set_pixels(pixbuf, data)
  end function hl_gdk_pixbuf_new_data16

  !+
  function hl_gdk_pixbuf_new_data16g(data) result(pixbuf)
    type(c_ptr) :: pixbuf
    integer(c_short), dimension(:,:), intent(in) :: data

    ! Create a pixbuf from a greyscale array of values. This version
    ! uses 2-byte integers to avoid the signing issues of the c_int8_t type.
    !
    ! DATA |  short |  required |  The data values as a n x m array.
    !
    ! This routine will usually be called via the generic interface
    ! hl_gdk_pixbuf_new.
    !-

    integer(c_int), dimension(2) :: sz

    sz = shape(data)

    pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8_c_int, &
         & sz(1), sz(2))

    call hl_gdk_pixbuf_set_pixels(pixbuf, data)
  end function hl_gdk_pixbuf_new_data16g

  !+
  subroutine hl_gdk_pixbuf_get_pixels8(pixbuf, pixels)
    type(c_ptr), intent(in) :: pixbuf
    integer(c_int8_t), dimension(:,:,:), allocatable, intent(out) :: pixels

    ! Get the pixels of a pixbuf and return them as a Fortran 3xnxm or 4xnxm
    ! array
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to read
    ! PIXELS |  int8 |  required |  Will contain the image.
    !
    ! This is normally called via the generic hl_gdk_pixbuf_get_pixels
    ! interface. Implemented as a subroutine to allow this.
    !-

    type(c_ptr), target :: cpixels
    integer(c_int8_t), pointer, dimension(:) :: fpixels
    integer :: i,j, iroff, ioff
    integer(c_int) :: rowstr, nrows, ncols, nchans
    integer :: lpix

    call hl_gdk_pixbuf_info(pixbuf, nchannels=nchans, height=nrows, &
         & width=ncols, rowstride=rowstr)

    allocate(pixels(nchans, ncols, nrows))

    lpix = int(rowstr*(nrows-1) + ncols*nchans)

    cpixels = gdk_pixbuf_get_pixels(pixbuf)
    call c_f_pointer(cpixels, fpixels, [lpix])

    do j = 0,nrows-1
       iroff = j*rowstr + 1
       do i = 0, ncols-1
          ioff = iroff + i*nchans
          pixels(:,i+1,j+1) = fpixels(ioff:ioff+nchans-1)
       end do
    end do
  end subroutine hl_gdk_pixbuf_get_pixels8

  !+
  subroutine hl_gdk_pixbuf_get_pixels16(pixbuf, pixels)
    type(c_ptr), intent(in) :: pixbuf
    integer(c_short), dimension(:,:,:), allocatable, intent(out) :: pixels

    ! Get the pixels of a pixbuf and return them as a Fortran 3xnxm or 4xnxm
    ! array. This version returns as a short array to evade the signing issues
    ! of 8-bit integers in Fortran
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to read
    ! PIXELS |  short |  required |  Will contain the image.
    !
    ! This is normally called via the generic hl_gdk_pixbuf_get_pixels
    ! interface. Implemented as a subroutine to allow this.
    !-

    type(c_ptr), target :: cpixels
    integer(c_int8_t), pointer, dimension(:) :: fpixels
    integer :: i,j, iroff, ioff
    integer(c_int) :: rowstr, nrows, ncols, nchans
    integer :: lpix

    call hl_gdk_pixbuf_info(pixbuf, nchannels=nchans, height=nrows, &
         & width=ncols, rowstride=rowstr)

    allocate(pixels(nchans, ncols, nrows))
    lpix = int(rowstr*(nrows-1) + ncols*nchans)

    cpixels = gdk_pixbuf_get_pixels(pixbuf)
    call c_f_pointer(cpixels, fpixels, [lpix])

    do j = 0,nrows-1
       iroff = j*rowstr + 1
       do i = 0, ncols-1
          ioff = iroff + i*nchans
          pixels(:,i+1,j+1) = iand(int(fpixels(ioff:ioff+nchans-1), c_short), &
               & 255_c_short)
       end do
    end do
  end subroutine hl_gdk_pixbuf_get_pixels16

  !+
  subroutine hl_gdk_pixbuf_set_pixels8(pixbuf, pixels, xoff, yoff)
    type(c_ptr), intent(in) :: pixbuf
    integer(c_int8_t), dimension(:,:,:), intent(in) :: pixels
    integer, intent(in), optional :: xoff, yoff

    ! Set the pixels of a pixbuf from a Fortran array.
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to update
    ! PIXELS |  int8 |  required |  Contains the image to insert.
    ! XOFF |  int |  optional |  The X-offset at which to write the image.
    ! YOFF |  int |  optional |  The Y-offset at which to write the image.
    !
    ! This is normally called via the generic hl_gdk_pixbuf_set_pixels
    ! interface.
    ! N.B. To leave a gap at the "high" sides of the pixbuf, just use a
    ! smaller input array or array slice than the pixbuf size.
    !-

    integer :: i,j, ioff, iroff, xstart, ystart, xtop, ytop, lput
    integer(c_int) :: rowstr, nrows, ncols, nchans
    integer :: lpix
    type(c_ptr), target :: cpixels
    integer(c_int8_t), pointer, dimension(:) :: fpixels
    integer, dimension(3) :: sz
    logical :: salpha, gscale

    sz=shape(pixels)
    if (present(xoff)) then
       xstart = xoff
    else
       xstart = 0
    end if
    if (present(yoff)) then
       ystart = yoff
    else
       ystart = 0
    end if

    call hl_gdk_pixbuf_info(pixbuf, nchannels=nchans, height=nrows, &
         & width=ncols, rowstride=rowstr)
    lpix = int(rowstr*(nrows-1) + ncols*nchans)

    ! Checks on sizes etc.

    if (sz(2) > ncols-xstart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS8: Input image has too many columns,"// &
            & " using lower part."
       xtop = ncols-xstart
    else
       xtop = sz(2)
    end if
    if (sz(3) > nrows-ystart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS8: Input image has too many rows,"// &
            & " using lower part."
       ytop = nrows-ystart
    else
       ytop = sz(3)
    end if

    salpha = .false.
    gscale = .false.

    select case (sz(1))
    case(3)
       if (nchans == 4) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS8: No alpha channel in input, using opaque."
          salpha = .true.
       end if
    case(4)
       if (nchans == 3) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS8: No alpha channel in output, omitting."
       end if
    case(2)
       gscale = .true.
       if (nchans == 3) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS8: No alpha channel in output, omitting."
       end if
    case(1)
       gscale = .true.
       if (nchans == 4) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS8: No alpha channel in input, using opaque."
          salpha = .true.
       end if
    case(5:)
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS8: too many channels in input, omitting excess."
    end select
    lput = min(sz(1), nchans)

    ! Actually set the pixels.
    cpixels = gdk_pixbuf_get_pixels(pixbuf)
    call c_f_pointer(cpixels, fpixels, [lpix])

    if (gscale) then
       do j = 0, ytop-1
          iroff = (j+ystart)*rowstr + 1 + xstart
          do i = 0,xtop-1
             ioff = iroff + i*nchans
             fpixels(ioff:ioff+2) = pixels(1, i+1,j+1)
             if (salpha) then
                fpixels(ioff+3) = -1_c_int8_t
             else if (nchans == 4) then
                fpixels(ioff+3) = pixels(2, i+1,j+1)
             end if
          end do
       end do
    else
       do j = 0, ytop-1
          iroff = (j+ystart)*rowstr + 1 + xstart
          do i = 0,xtop-1
             ioff = iroff + i*nchans
             fpixels(ioff:ioff+lput-1) = pixels(:lput, i+1,j+1)
             if (salpha) fpixels(ioff+lput) = -1_c_int8_t
          end do
       end do
    end if

  end subroutine hl_gdk_pixbuf_set_pixels8

  !+
  subroutine hl_gdk_pixbuf_set_pixels8g(pixbuf, pixels, xoff, yoff)
    type(c_ptr), intent(in) :: pixbuf
    integer(c_int8_t), dimension(:,:), intent(in) :: pixels
    integer, intent(in), optional :: xoff, yoff

    ! Set the pixels of a pixbuf from a Fortran array (greyscale).
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to update
    ! PIXELS |  int8 |  required |  Contains the image to insert.
    ! XOFF |  int |  optional |  The X-offset at which to write the image.
    ! YOFF |  int |  optional |  The Y-offset at which to write the image.
    !
    ! This is normally called via the generic hl_gdk_pixbuf_set_pixels
    ! interface.
    ! N.B. To leave a gap at the "high" sides of the pixbuf, just use a
    ! smaller input array or array slice than the pixbuf size.
    !-

    integer :: i,j, ioff, iroff, xstart, ystart, xtop, ytop
    integer(c_int) :: rowstr, nrows, ncols, nchans
    integer :: lpix
    type(c_ptr), target :: cpixels
    integer(c_int8_t), pointer, dimension(:) :: fpixels
    integer, dimension(2) :: sz

    sz=shape(pixels)
    if (present(xoff)) then
       xstart = xoff
    else
       xstart = 0
    end if
    if (present(yoff)) then
       ystart = yoff
    else
       ystart = 0
    end if

    call hl_gdk_pixbuf_info(pixbuf, nchannels=nchans, height=nrows, &
         & width=ncols, rowstride=rowstr)
    lpix = int(rowstr*(nrows-1) + ncols*nchans)

    ! Checks on sizes etc.

    if (sz(1) > ncols-xstart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS8G: Input image has too many columns,"// &
            & " using lower part."
       xtop = ncols-xstart
    else
       xtop = sz(1)
    end if
    if (sz(2) > nrows-ystart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS8G: Input image has too many rows,"// &
            & " using lower part."
       ytop = nrows-ystart
    else
       ytop = sz(2)
    end if

    ! Actually set the pixels.
    cpixels = gdk_pixbuf_get_pixels(pixbuf)
    call c_f_pointer(cpixels, fpixels, [lpix])

    do j = 0, ytop-1
       iroff = (j+ystart)*rowstr + 1 + xstart
       do i = 0,xtop-1
          ioff = iroff + i*nchans
          fpixels(ioff:ioff+2) = pixels(i+1,j+1)
          if (nchans == 4) fpixels(ioff+3) = -1_c_int8_t
       end do
    end do

  end subroutine hl_gdk_pixbuf_set_pixels8g

  !+
  subroutine hl_gdk_pixbuf_set_pixels16(pixbuf, pixels, xoff, yoff)
    type(c_ptr), intent(in) :: pixbuf
    integer(c_short), dimension(:,:,:), intent(in) :: pixels
    integer, intent(in), optional :: xoff, yoff

    ! Set the pixels of a pixbuf from a Fortran array (16-bit).
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to update
    ! PIXELS |  short |  required |  Contains the image to insert.
    ! XOFF |  int |  optional |  The X-offset at which to write the image.
    ! YOFF |  int |  optional |  The Y-offset at which to write the image.
    !
    ! This is normally called via the generic hl_gdk_pixbuf_set_pixels
    ! interface.
    ! N.B. To leave a gap at the "high" sides of the pixbuf, just use a
    ! smaller input array or array slice than the pixbuf size.
    !-

    integer :: i,j, ioff, iroff, xstart, ystart, xtop, ytop, lput
    integer(c_int) :: rowstr, nrows, ncols, nchans
    integer :: lpix
    type(c_ptr), target :: cpixels
    integer(c_int8_t), pointer, dimension(:) :: fpixels
    integer, dimension(3) :: sz
    logical :: salpha, gscale

    sz=shape(pixels)
    if (present(xoff)) then
       xstart = xoff
    else
       xstart = 0
    end if
    if (present(yoff)) then
       ystart = yoff
    else
       ystart = 0
    end if

    call hl_gdk_pixbuf_info(pixbuf, nchannels=nchans, height=nrows, &
         & width=ncols, rowstride=rowstr)
    lpix = int(rowstr*(nrows-1) + ncols*nchans)

    ! Checks on sizes etc.

    if (sz(2) > ncols-xstart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS16: Input image has too many columns,"// &
            & " using lower part."
       xtop = ncols-xstart
    else
       xtop = sz(2)
    end if
    if (sz(3) > nrows-ystart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS16: Input image has too many rows,"// &
            & " using lower part."
       ytop = nrows-ystart
    else
       ytop = sz(3)
    end if

    salpha = .false.
    gscale = .false.

    select case (sz(1))
    case(3)
       if (nchans == 4) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS16: No alpha channel in input, using opaque."
          salpha = .true.
       end if
    case(4)
       if (nchans == 3) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS16: No alpha channel in output, omitting."
       end if
    case(2)
       gscale = .true.
       if (nchans == 3) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS16: No alpha channel in output, omitting."
       end if
    case(1)
       gscale = .true.
       if (nchans == 4) then
          write(error_unit, *) &
               & "HL_GDK_SET_PIXELS16: No alpha channel in input, using opaque."
          salpha = .true.
       end if
    case(5:)
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS16: too many channels in input, omitting excess."
    end select
    lput = min(sz(1), nchans)

    ! Actually set the pixels.
    cpixels = gdk_pixbuf_get_pixels(pixbuf)
    call c_f_pointer(cpixels, fpixels, [lpix])

    if (gscale) then
       do j = 0, ytop-1
          iroff = (j+ystart)*rowstr + 1 + xstart
          do i = 0,xtop-1
             ioff = iroff + i*nchans
             fpixels(ioff:ioff+2) = int(pixels(1, i+1,j+1), c_int8_t)
             if (salpha) then
                fpixels(ioff+3) = -1_c_int8_t
             else if (nchans == 4) then
                fpixels(ioff+3) = int(pixels(2, i+1,j+1), c_int8_t)
             end if
          end do
       end do
    else
       do j = 0, ytop-1
          iroff = (j+ystart)*rowstr + 1 + xstart
          do i = 0,xtop-1
             ioff = iroff + i*nchans
             fpixels(ioff:ioff+lput-1) = int(pixels(:lput, i+1,j+1), c_int8_t)
             if (salpha) fpixels(ioff+lput) = -1_c_int8_t
          end do
       end do
    end if
  end subroutine hl_gdk_pixbuf_set_pixels16

  !+
  subroutine hl_gdk_pixbuf_set_pixels16g(pixbuf, pixels, xoff, yoff)
    type(c_ptr), intent(in) :: pixbuf
    integer(c_short), dimension(:,:), intent(in) :: pixels
    integer, intent(in), optional :: xoff, yoff

    ! Set the pixels of a pixbuf from a Fortran array (16-bit, greyscale).
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to update
    ! PIXELS |  short |  required |  Contains the image to insert.
    ! XOFF |  int |  optional |  The X-offset at which to write the image.
    ! YOFF |  int |  optional |  The Y-offset at which to write the image.
    !
    ! This is normally called via the generic hl_gdk_pixbuf_set_pixels
    ! interface.
    ! N.B. To leave a gap at the "high" sides of the pixbuf, just use a
    ! smaller input array or array slice than the pixbuf size.
    !-

    integer :: i,j, ioff, iroff, xstart, ystart, xtop, ytop
    integer(c_int) :: rowstr, nrows, ncols, nchans
    integer :: lpix
    type(c_ptr), target :: cpixels
    integer(c_int8_t), pointer, dimension(:) :: fpixels
    integer, dimension(2) :: sz

    sz=shape(pixels)
    if (present(xoff)) then
       xstart = xoff
    else
       xstart = 0
    end if
    if (present(yoff)) then
       ystart = yoff
    else
       ystart = 0
    end if

    call hl_gdk_pixbuf_info(pixbuf, nchannels=nchans, height=nrows, &
         & width=ncols, rowstride=rowstr)
    lpix = int(rowstr*(nrows-1) + ncols*nchans)

    ! Checks on sizes etc.

    if (sz(1) > ncols-xstart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS16G: Input image has too many columns,"// &
            & " using lower part."
       xtop = ncols-xstart
    else
       xtop = sz(1)
    end if
    if (sz(2) > nrows-ystart) then
       write(error_unit, *) &
            & "HL_GDK_SET_PIXELS16G: Input image has too many rows,"// &
            & " using lower part."
       ytop = nrows-ystart
    else
       ytop = sz(2)
    end if


    ! Actually set the pixels.
    cpixels = gdk_pixbuf_get_pixels(pixbuf)
    call c_f_pointer(cpixels, fpixels, [lpix])

    do j = 0, ytop-1
       iroff = (j+ystart)*rowstr + 1 + xstart
       do i = 0,xtop-1
          ioff = iroff + i*nchans
          fpixels(ioff:ioff+2) = int(pixels(i+1,j+1), c_int8_t)
          if (nchans == 4)  fpixels(ioff+3) = -1_c_int8_t
       end do
    end do
  end subroutine hl_gdk_pixbuf_set_pixels16g

  !+
  subroutine hl_gdk_pixbuf_info(pixbuf, nchannels, bits, alpha, &
       & height, width, rowstride)

    type(c_ptr), intent(in) :: pixbuf
    integer(c_int), optional, intent(out) :: nchannels, bits, alpha, &
         & height, width, rowstride

    ! Return information about an existing pixbuf.
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to be queried.
    ! NCHANNELS |  int |  optional |  How many channels does the pixbuf have?
    ! BITS |  int |  optional |  How many bits per pixel?
    ! ALPHA |  boolean |  optional |  Does the pixbuf have an alpha channel?
    ! HEIGHT |  int |  optional |  How many rows in the image.
    ! WIDTH |  int |  optional |  How many columns in the image.
    ! ROWSTRIDE |  int |  optional |  How many bytes between the start of successive rows.
    !-

    if (present(nchannels)) nchannels = gdk_pixbuf_get_n_channels(pixbuf)
    if (present(alpha)) alpha = gdk_pixbuf_get_has_alpha(pixbuf)
    if (present(bits)) bits = gdk_pixbuf_get_bits_per_sample(pixbuf)
    if (present(width)) width = gdk_pixbuf_get_width(pixbuf)
    if (present(height)) height = gdk_pixbuf_get_height(pixbuf)
    if (present(rowstride)) rowstride = gdk_pixbuf_get_rowstride(pixbuf)

  end subroutine hl_gdk_pixbuf_info

  !+
  subroutine hl_gdk_pixbuf_save(pixbuf, file, type, options, ok, error)
    type(c_ptr), intent(in) :: pixbuf
    character(len=*), intent(in) :: file
    character(len=*), intent(in), optional :: type
    character(len=*), dimension(:), intent(in), optional :: options
    logical, intent(out), optional :: ok
    character(len=*), intent(out), optional :: error

    ! Save a pixbuf to a file.
    !
    ! PIXBUF |  c_ptr |  required |  The pixbuf to save
    ! FILE |  f_string |  required |  The filename to which to save.
    ! TYPE |  f_string |  optional |  The file type to use, if not given then it is deduced from the extension.
    ! OPTIONS |  f_string() |  optional |  A list of options in the form "option=value".
    ! OK |  logical |  optional |  Was the write successful.
    ! ERROR |  f_string |  optional |  An error message if the write failed.
    !-

    character(len=hl_gdk_pixbuf_type_len) :: ftype
    integer :: pd
    type(c_ptr), target :: err
    type(gerror), pointer :: ferr
    integer(c_int) :: iok
    character(len=120) :: ferrmsg
    type(c_ptr), dimension(:), allocatable :: copt_names, copt_vals
    character(len=hl_gdk_pixbuf_option_len), target, &
         & dimension(:), allocatable :: opt_names, opt_vals
    integer :: peq, i, nopt

    if (.not. present(type)) then
       pd = index(file, '.', back=.true.)
       if (pd == 0) then
          if (present(ok)) ok = .false.
          if (present(error)) then
             error = "No file type given and no extension to filename"
          else
             write(error_unit, *) "HL_GDK_PIXBUF_SAVE: "// &
                  & "No file type given and no extension to filename"
          end if
          return
       end if
       ftype = hl_gdk_pixbuf_format_find(extension=trim(file(pd+1:)))
       if (ftype == '') then
          if (present(ok)) ok = .false.
          if (present(error)) then
             error = "No file type found for extension: "//trim(file(pd+1:))
          else
             write(error_unit, *) "HL_GDK_PIXBUF_SAVE: "// &
                  & "No file type found for extension: "//trim(file(pd+1:))
          end if
          return
       end if
    else
       ftype = type
    end if

    err = c_null_ptr
    if (present(options)) then
       nopt = size(options)
    else
       nopt = 0
    end if
    allocate(copt_names(nopt+1), copt_vals(nopt+1))
    allocate(opt_names(nopt), opt_vals(nopt))

    copt_names(nopt+1) = c_null_ptr
    copt_vals(nopt+1) = c_null_ptr

    do i = 1, nopt
       peq = index(options(i), "=")
       opt_names(i) = options(i)(:peq-1)//c_null_char
       opt_vals(i) = trim(options(i)(peq+1:))//c_null_char
       copt_names(i) = c_loc(opt_names(i))
       copt_vals(i) = c_loc(opt_vals(i))
    end do
    iok = gdk_pixbuf_savev(pixbuf, trim(file)//c_null_char, &
         & trim(ftype)//c_null_char, copt_names, copt_vals, c_loc(err))

    if (.not. c_f_logical(iok)) then
       if (present(ok)) ok = .false.
       call c_f_pointer(err, ferr)
       call c_f_string(ferr%message, ferrmsg)
       if (present(error)) then
          error=trim(ferrmsg)
       else
          write(error_unit, *) "HL_GDK_PIXBUF_SAVE: "//trim(ferrmsg)
       end if
    else if (present(ok)) then
       ok = .true.
    end if
  end subroutine hl_gdk_pixbuf_save

  ! The routines below here deal with GdkPixbufFormat

  !+
  subroutine hl_gdk_pixbuf_get_formats(names, writable, description, &
       & scalable, license)

    character(len=*), intent(out), dimension(:), allocatable :: names
    logical, intent(out), dimension(:), allocatable, optional :: writable, &
         & scalable
    character(len=*), intent(out), dimension(:), allocatable, &
         & optional :: license
    character(len=*), intent(out), dimension(:), allocatable, &
         & optional :: description

    ! Get information about the available file formats for reading/writing
    ! pixbufs.
    !
    ! NAMES |  f_string() |  required |  The names found
    ! WRITABLE |  logical() |  optional |  Whether the formats are writable.
    ! DESCRIPTION |  f_string() |  optional |  Descriptions of the formats.
    ! SCALABLE |  logical() |  optional |  Whether the formats are scalable.
    ! LICENSE |  f_string() |  optional |  The licence of the format module.
    !-

    type(c_ptr) :: flist, fmt
    integer(c_int) :: nfmt, i

    flist = gdk_pixbuf_get_formats()

    nfmt = g_slist_length(flist)

    allocate(names(nfmt))
    if (present(writable)) allocate(writable(nfmt))
    if (present(description)) allocate(description(nfmt))
    if (present(scalable)) allocate(scalable(nfmt))
    if (present(license)) allocate(license(nfmt))

    do i = 0, nfmt-1
       fmt = g_slist_nth_data(flist, i)
       call c_f_string(gdk_pixbuf_format_get_name(fmt), names(i+1))
       if (present(description)) &
            & call c_f_string(gdk_pixbuf_format_get_description(fmt), &
            & description(i+1))
       if (present(license)) &
            & call c_f_string(gdk_pixbuf_format_get_license(fmt), &
            & license(i+1))
       if (present(writable)) &
            & writable(i+1) = c_f_logical(gdk_pixbuf_format_is_writable(fmt))
       if (present(scalable)) &
            & scalable(i+1) = c_f_logical(gdk_pixbuf_format_is_scalable(fmt))
    end do

    call g_slist_free(flist)

  end subroutine hl_gdk_pixbuf_get_formats

  !+
  function hl_gdk_pixbuf_format_info(name, mime_types, extensions, &
       & writable, scalable, description, license) result(found)

    logical :: found
    character(len=*), intent(in) :: name
    character(len=*), intent(out), optional, allocatable, &
         & dimension(:) :: mime_types, extensions
    logical, intent(out), optional :: writable, scalable
    character(len=*), intent(out), optional :: description, license

    ! Get information about a specific file type.
    !
    ! NAME |  string |  required |  The file type to query.
    ! MIME_TYPE |  fstring() |  optional |  Will contain a list of mime-types associated with this file type.
    ! EXTENSIONS |  fstring() |  optional |  Will contain a list of file extensions normally used for this type.
    ! WRITABLE |  logical |  optional |  Whether the type is writable.
    ! SCALABLE |  logical |  optional |  Whether the type is scalable.
    ! DESCRIPTION |  f_string |  optional |  A description of the file type.
    ! LICENSE |  f_string |  optional |  The license of the module for the file type.
    !
    ! Returns .true. if the type is found, .false. if it is not.
    !-

    character(len=hl_gdk_pixbuf_type_len), dimension(:), allocatable :: names
    integer(c_int) :: idx, i
    type(c_ptr) :: flist, fmt
    type(c_ptr), target :: vlist
    type(c_ptr), dimension(:), pointer :: val

    call hl_gdk_pixbuf_get_formats(names)
    if (all(names /= name)) then
       found = .false.
       return
    end if
    found = .true.

    ! Extract the matching format.
    do i = 1,size(names)
       if (names(i) == name) then
          idx = i-1
          exit
       end if
    end do
    flist = gdk_pixbuf_get_formats()
    fmt = g_slist_nth_data(flist, idx)
    call g_slist_free(flist)

    ! Extract the requested information

    if (present(writable)) &
         & writable = c_f_logical(gdk_pixbuf_format_is_writable(fmt))
    if (present(scalable)) &
         & scalable = c_f_logical(gdk_pixbuf_format_is_scalable(fmt))

    if (present(description)) &
         & call c_f_string(gdk_pixbuf_format_get_description(fmt), &
         & description)
    if (present(license)) &
         & call c_f_string(gdk_pixbuf_format_get_license(fmt), &
         & license)

    if (present(mime_types)) then
       vlist = gdk_pixbuf_format_get_mime_types(fmt)
       ! A size of 20 should be enough for all formats:
       call c_f_pointer(vlist, val, [20])
       i = 1
       idx = 0
       ! Get the size of the val() array:
       do
          if (.not. c_associated(val(i))) then
             idx = i-1
             exit
          end if
          i = i+1
       end do

       if (idx > 0) then
          allocate(mime_types(idx))
          do i = 1, idx
             call c_f_string(val(i), mime_types(i))
          end do
       end if
    end if
    if (present(extensions)) then
       vlist = gdk_pixbuf_format_get_extensions(fmt)
       ! A size of 20 should be enough for all formats:
       call c_f_pointer(vlist, val, [20])
       i = 1
       idx = 0
       ! Get the size of the val() array:
       do
          if (.not. c_associated(val(i))) then
             idx = i-1
             exit
          end if
          i = i+1
       end do

       if (idx > 0) then
          allocate(extensions(idx))
          do i = 1, idx
             call c_f_string(val(i), extensions(i))
          end do
       end if
    end if
  end function hl_gdk_pixbuf_format_info

  !+
  function hl_gdk_pixbuf_format_find(mime_type, extension) result(name)
    character(len=hl_gdk_pixbuf_type_len) :: name
    character(len=*), intent(in), optional :: mime_type, extension

    ! Find the format type appropriate to a mime_type or a
    ! filename extension.
    !
    ! MIME_TYPE |  f_string |  optional |  The mime-type to match.
    ! EXTENSION |  f_string |  optional |  The file extension to match.
    !
    ! If no match is found then an empty string is returned.
    ! Mime_type has precedence over extension.
    !-

    character(len=hl_gdk_pixbuf_type_len), dimension(:), allocatable :: names
    character(len=20), dimension(:), allocatable :: types
    integer :: i, zidx
    logical :: found

    call hl_gdk_pixbuf_get_formats(names)

    name = ''

    if (present(mime_type)) then
       zidx = index(mime_type, c_null_char)
       if (zidx == 0) zidx=len(mime_type)+1
       do i = 1, size(names)
          found = hl_gdk_pixbuf_format_info(names(i), mime_types=types)
          if (any(types == mime_type(:zidx-1))) then
             name = names(i)
             exit
          end if
       end do
    else if (present(extension)) then
       zidx = index(extension, c_null_char)
       if (zidx == 0) zidx=len_trim(extension)+1
       do i = 1, size(names)
          found = hl_gdk_pixbuf_format_info(names(i), extensions=types)
          if (any(types == extension(:zidx-1))) then
             name = names(i)
             exit
          end if
       end do
    end if
  end function hl_gdk_pixbuf_format_find

end module gdk_pixbuf_hl

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2012 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by: James Tappin
! PLplot code derived from PLplot's example 4 by Alan W. Irwin
! Last modifications: vmagnin 2020-06-10 (GTK 4), 2020-07-14
!------------------------------------------------------------------------------

module common_ex4
  use, intrinsic :: iso_c_binding
  use cairo, only: cairo_get_target, cairo_image_surface_get_height, &
       & cairo_image_surface_get_width
  use gtk, only: gtk_window_destroy, gtk_widget_show, FALSE, &
               & gtk_window_set_child
  use gtk_draw_hl
  use plplot_extra
  use gtk_hl_container
  use gtk_hl_button

  implicit none
  type(c_ptr) :: window
end module common_ex4

module plplot_code_ex4
  use plplot, PI => PL_PI
  use common_ex4

  implicit none

contains

  subroutine plot_04(area)
    type(c_ptr), intent(in), dimension(2) :: area

    type(c_ptr), dimension(2) :: cc, cs
    integer :: i
    character(len=25) :: geometry

    ! needed for use as functions instead of subroutines
    integer :: plparseopts_rc
    integer :: plsetopt_rc

    ! Define colour map 0 to match the "GRAFFER" colour table in
    ! place of the PLPLOT default.
    integer, parameter, dimension(16) :: rval = [255, 0, 255, &
         & 0, 0, 0, 255, 255, 255, 127, 0, 0, 127, 255, 85, 170],&
         & gval = [ 255, 0, 0, 255, 0, 255, 0, 255, 127, 255, 255, 127,&
         & 0, 0, 85, 170], &
         & bval = [ 255, 0, 0, 0, 255, 255, 255, 0, 0, 0, 127, 255, 255,&
         & 127, 85, 170]

    !  Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if (plparseopts_rc /= 0) stop "plparseopts error"


    ! Get a cairo context from the drawing area.
    do i=1,2
       cc(i) = hl_gtk_drawing_area_cairo_new(area(i))
       cs(i) = cairo_get_target(cc(i))
    end do

    !  Initialize plplot
    call plscmap0(rval, gval, bval)
    call plsdev("extcairo")

    ! By default the "extcairo" driver does not reset the background
    ! This is equivalent to the command line option "-drvopt set_background=1"
    plsetopt_rc = plsetopt("drvopt", "set_background=1")
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! The "extcairo" device doesn't read the size from the context.
    write(geometry, "(I0,'x',I0)") cairo_image_surface_get_width(cs(1)), &
         & cairo_image_surface_get_height(cs(1))
    plsetopt_rc = plsetopt( 'geometry', geometry)
    if (plsetopt_rc /= 0) stop "plsetopt error"

    ! Initialize
    call plinit

    ! Tell the "extcairo" driver where the context is located. This must be
    ! done AFTER the plstar or plinit call.
    call pl_cmd(PLESC_DEVINIT, cc(1))

    call plfont(2)   ! Roman font
    call plot1(0)

    ! Now continue the plot on the other surface
    call pl_cmd(PLESC_DEVINIT, cc(2))

    call plot1(1)

    call plend

    call hl_gtk_drawing_area_cairo_destroy(cc(1))
    call hl_gtk_drawing_area_cairo_destroy(cc(2))

  end subroutine plot_04

  subroutine plot1(type)
    use plplot, PI => PL_PI
    implicit none
    integer, parameter :: MAX_NLEGEND = 2

    real(plflt) :: freql(0:100),ampl(0:100),phase(0:100), freq, f0
    integer          :: i, type
    integer          :: nlegend

    real(plflt) :: legend_width, legend_height
    integer          :: opt_array(MAX_NLEGEND), text_colors(MAX_NLEGEND), line_colors(MAX_NLEGEND), &
         line_styles(MAX_NLEGEND), symbol_colors(MAX_NLEGEND), symbol_numbers(MAX_NLEGEND)

    ! For plplot 5.9.9 or lower the next declarations should be integers
    ! For 5.9.10 or higher they should be reals
!    real(plflt) :: symbol_scales(MAX_NLEGEND), box_scales(0)
!    integer :: line_widths(MAX_NLEGEND), box_line_widths(0)
    real(plflt) :: symbol_scales(MAX_NLEGEND), box_scales(MAX_NLEGEND)

!    real(plflt) :: line_widths(MAX_NLEGEND), box_line_widths(0)
!    integer          :: box_colors(0), box_patterns(0)

    real(plflt) :: line_widths(MAX_NLEGEND), box_line_widths(MAX_NLEGEND)
    integer          :: box_colors(MAX_NLEGEND), box_patterns(MAX_NLEGEND)

    character(len=20):: text(MAX_NLEGEND)
    character(len=1) :: symbols(MAX_NLEGEND)

    call pladv(0)
    !      Set up data for log plot.
    f0 = 1._plflt
    do i=0,100
       freql(i)= -2.0_plflt + dble (i)/20.0_plflt
       freq=10.0_plflt**freql(i)
       ampl(i)=20.0_plflt*log10(1.0_plflt/sqrt(1.0_plflt+(freq/f0)**2))
       phase(i)=-(180.0_plflt/PI)*atan(freq/f0)
    enddo
    call plvpor(0.15_plflt, 0.85_plflt, 0.1_plflt, 0.9_plflt)
    call plwind(-2.0_plflt, 3.0_plflt, -80.0_plflt, 0.0_plflt)
    call plcol0(1)
    !      Try different axis and labelling styles.
    if (type == 0) then
       call plbox('bclnst', 0.0_plflt, 0, 'bnstv', 0.0_plflt, 0)
    elseif (type == 1) then
       call plbox('bcfghlnst', 0.0_plflt, 0, 'bcghnstv', 0.0_plflt, 0)
    else
       stop 'plot1: invalid type'
    endif
    !      Plot ampl vs freq.
    call plcol0(2)
    call plline(freql,ampl)
    call plcol0(2)
    call plptex(1.6_plflt, -30.0_plflt, 1.0_plflt, -20.0_plflt, 0.5_plflt, &
         '-20 dB/decade')
    !      Put labels on.
    call plcol0(1)
    call plmtex('b', 3.2_plflt, 0.5_plflt, 0.5_plflt, 'Frequency')
    call plmtex('t', 2.0_plflt, 0.5_plflt, 0.5_plflt, &
         'Single Pole Low-Pass Filter')
    call plcol0(2)
    call plmtex('l', 5.0_plflt, 0.5_plflt, 0.5_plflt, 'Amplitude (dB)')
    nlegend = 1
    !      For the gridless case, put phase vs freq on same plot.
    if (type == 0) then
       call plcol0(1)
       call plwind(-2.0_plflt, 3.0_plflt, -100.0_plflt, 0.0_plflt)
       call plbox(' ', 0.0_plflt, 0, 'cmstv', 30.0_plflt, 3)
       call plcol0(3)
       call plline(freql, phase)
       call plstring(freql, phase, '*')
       call plcol0(3)
       call plmtex('r', 5.0_plflt, 0.5_plflt, 0.5_plflt, &
            'Phase shift (degrees)')
       nlegend = 2
    endif

    !     Draw a legend
    !     First legend entry.
    opt_array(1)   = PL_LEGEND_LINE
    text_colors(1) = 2
    text(1)        = 'Amplitude'
    line_colors(1) = 2
    line_styles(1) = 1
    ! For plplot 5.9.9 or lower comment out the real assignment,
    ! for 5.9.10 or higher, comment out the integer assignment.
!    line_widths(1) = 1
    line_widths(1) = 1.0_plflt
    !     note from the above opt_array the first symbol (and box) indices
    !     do not have to be specified

    !     Second legend entry.
    opt_array(2)      = PL_LEGEND_LINE + PL_LEGEND_SYMBOL
    text_colors(2)    = 3
    text(2)           = 'Phase shift'
    line_colors(2)    = 3
    line_styles(2)    = 1
    ! For plplot 5.9.9 or lower comment out the real assignment,
    ! for 5.9.10 or higher, comment out the integer assignment.
!    line_widths(2)    = 1
    line_widths(2)    = 1.0_plflt
    symbol_colors(2)  = 3
    symbol_scales(2)  = 1.0
    symbol_numbers(2) = 4
    symbols(2)        = '*'

    !     from the above opt_arrays we can completely ignore everything
    !     to do with boxes. (Hence the size 0 for the associated arrays)
    !     (note: use the argument nlegend explicitly)

    call plscol0a( 15, 32, 32, 32, 0.70_plflt )
    call pllegend( legend_width, legend_height, &
         PL_LEGEND_BOUNDING_BOX, 0, &
         0.0_plflt, 0.0_plflt, 0.1_plflt, 15, &
         1, 1, 0, 0, &
         opt_array, &
         1.0_plflt, 1.0_plflt, 2.0_plflt, &
         1.0_plflt, &           !
         text_colors, text, &
         box_colors, box_patterns, box_scales, box_line_widths, &
         line_colors, line_styles, line_widths, &
         symbol_colors, symbol_scales, symbol_numbers, symbols )
  end subroutine plot1
end module plplot_code_ex4


module handlers_ex4
  use common_ex4
  implicit none

contains

  subroutine quit_cb(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    call gtk_window_destroy(window)
  end subroutine quit_cb

  subroutine activate(app, gdata) bind(c)
    use plplot_code_ex4
    use common_ex4
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr), dimension(2) :: drawing
    type(c_ptr) :: base, nbook, qbut
    integer :: pno

    ! Create the window:
    window = gtk_application_window_new(app)
    call gtk_window_set_title(window, "PLplot x04 / gtk-fortran (extcairo)"//c_null_char)

    base = hl_gtk_box_new()
    call gtk_window_set_child(window, base)

    nbook = hl_gtk_notebook_new()
    call hl_gtk_box_pack(base, nbook)
    drawing(1) = hl_gtk_drawing_area_new(size=[800,600], &
         & has_alpha=FALSE)

    pno = hl_gtk_notebook_add_page(nbook, drawing(1), &
         & label="Plot 1 (No grid)"//c_null_char)

    drawing(2) = hl_gtk_drawing_area_new(size=[800,600], &
         & has_alpha=FALSE)

    pno= hl_gtk_notebook_add_page(nbook, drawing(2), &
         & label="Plot 2 (With grid)"//c_null_char)

    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(quit_cb))
    call hl_gtk_box_pack(base, qbut, expand=FALSE)

    call gtk_widget_show(window)

    call plot_04(drawing)
  end subroutine activate
end module handlers_ex4


program cairo_plplot_ex4
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers_ex4
  use gtk_hl_container, only: hl_gtk_application_new
  implicit none
  type(c_ptr) :: my_app

  my_app = hl_gtk_application_new("gtk-fortran.plplot.hl_plplot4e"//c_null_char, &
                             & c_funloc(activate))
end program cairo_plplot_ex4

! $ gfortran -Wall -Wextra -std=f2008 -pedantic -g my_first_gtk_app1.f90 $(pkg-config --cflags --libs gtk-4-fortran)

module handlers
  use, intrinsic :: iso_c_binding
  use gtk, only:
  use g, only:

  implicit none

  contains

end module handlers

program my_first_gtk_app
  use handlers

  implicit none

end program

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! A translation into Fortran of the "hello_world" tree demo from
! the GTK TreeView Tutorial.
! Original version by: Tim-Philipp Müller (2005)
! http://scentric.net/tutorial/ch-treeview.html#sec-TreeView-HelloWorld
! varargs calls replaced & translated into Fortran: James Tappin 21-Mar-2011
! GTK 4 version: vmagnin 2020-05-28

module handlers
  use, intrinsic :: iso_c_binding, only: c_null_char, c_null_ptr
  use gtk_sup  ! Contains iter structure and gtypes definitions
  use gtk, only: gtk_cell_renderer_text_new, gtk_window_set_child, &
  & gtk_list_store_append, gtk_list_store_newv, gtk_list_store_set_value,&
  & gtk_tree_view_column_add_attribute, gtk_tree_view_column_new, &
  & gtk_tree_view_column_pack_start, gtk_tree_view_column_set_title, &
  & gtk_tree_view_insert_column, gtk_tree_view_new, gtk_tree_view_set_model, &
  & gtk_widget_show, gtk_window_new, gtk_window_set_title, FALSE, &
  & gtk_application_window_new, g_signal_connect
  use g, only: g_object_unref, g_value_init, g_value_set_static_string, &
             & g_value_set_uint

  implicit none

  enum, bind(c)
     enumerator :: COL_NAME = 0
     enumerator :: COL_AGE
     enumerator :: NUM_COLS
  end enum

contains
  ! Callback function for the signal "activate" emitted by g_application_run().
  ! We use a subroutine because it should return void.
  ! The GUI is defined here.
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in)  :: app, gdata
    ! Pointers toward our GTK widgets:
    type(c_ptr) :: window, view

    ! Create the window:
    window = gtk_application_window_new(app)
    ! Don't forget that C strings must end with a null char:
    call gtk_window_set_title(window, "List Demo"//c_null_char)

    !******************************************************************
    ! Adding widgets in the window:
    !******************************************************************
    view = create_view_and_model ()
    call gtk_window_set_child(window, view)
    !******************************************************************

    ! If you don't show it, nothing will appear on screen...
    call gtk_widget_show(window)
  end subroutine activate


  function create_and_fill_model() result(store)
    type(c_ptr) :: store
    integer(type_kind), dimension(2), target :: ctypes = &
         & [g_type_string, g_type_uint]
    type(gtktreeiter), target :: iter
    type(gvalue), target :: valt, vali
    type(c_ptr) :: val

    ! Initialize the GValues
    val = c_loc(valt)
    val = g_value_init(val, G_TYPE_STRING)
    val = c_loc(vali)
    val = g_value_init(val, G_TYPE_UINT)

    ! Create the list store
    store = gtk_list_store_newv(NUM_COLS, c_loc(ctypes))

    ! Append row 1 and add data
    call gtk_list_store_append(store, c_loc(iter))
    call g_value_set_static_string(c_loc(valt), "Heinz El-Mann"//c_null_char)
    call gtk_list_store_set_value(store, c_loc(iter), COL_NAME, &
         & c_loc(valt))
    call g_value_set_uint(c_loc(vali), 51_c_int)
    call gtk_list_store_set_value(store, c_loc(iter), COL_AGE, c_loc(vali))

    ! append another row and fill in some data
    call gtk_list_store_append (store, c_loc(iter))
    call g_value_set_static_string(c_loc(valt), "Jane Doe"//c_null_char)
    call gtk_list_store_set_value(store, c_loc(iter), COL_NAME, c_loc(valt))
    call g_value_set_uint(c_loc(vali), 23_c_int)
    call gtk_list_store_set_value(store, c_loc(iter), COL_AGE, c_loc(vali))

    ! And a third
    call gtk_list_store_append (store, c_loc(iter))
    call g_value_set_static_string(c_loc(valt), "Joe Bungop"//c_null_char)
    call gtk_list_store_set_value(store, c_loc(iter), COL_NAME, c_loc(valt))
    call g_value_set_uint(c_loc(vali), 91_c_int)
    call gtk_list_store_set_value(store, c_loc(iter), COL_AGE, c_loc(vali))
  end function create_and_fill_model


  function create_view_and_model() result(view)
    type(c_ptr) :: view

    type(c_ptr) :: col, renderer, model
    integer(c_int) :: ncol

    view = gtk_tree_view_new ()

    ! --- Column #1 ---
    renderer = gtk_cell_renderer_text_new ()
    col = gtk_tree_view_column_new()
    call gtk_tree_view_column_pack_start(col, renderer, FALSE)
    ncol= gtk_tree_view_insert_column(view, col, -1_c_int)
    call gtk_tree_view_column_add_attribute(col, renderer, &
         & "text"//c_null_char, COL_NAME)
    call gtk_tree_view_column_set_title(col, "Name"//c_null_char)

    ! --- Column #2 ---
    col = gtk_tree_view_column_new()
    renderer = gtk_cell_renderer_text_new ()
    call gtk_tree_view_column_pack_start(col, renderer, FALSE)
    ncol = gtk_tree_view_insert_column(view, col, -1_c_int)
    call gtk_tree_view_column_set_title(col, "Age"//c_null_char)
    call gtk_tree_view_column_add_attribute(col, renderer, &
         & "text"//c_null_char, COL_AGE)

    model = create_and_fill_model ()
    call gtk_tree_view_set_model (view, model)
    call g_object_unref (model)  ! destroy model automatically with view
  end function create_view_and_model
end module handlers

!*******************************************************************************
! In the main program, we declare the GTK application, connect it to its
! "activate" function where we will create the GUI,
! and finally call the GLib main loop.
!*******************************************************************************
program list_demo

  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char, c_null_ptr
  ! We will use those GTK functions and values. The "only" statement can improve
  ! significantly the compilation time:
  use gtk, only: gtk_application_new, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref
  use handlers

  implicit none
  integer(c_int)     :: status
  type(c_ptr)        :: app

  ! First, let's create a GTK application (it will initialize GTK).
  ! The application ID must contain at least one point:
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-id-is-valid
  app = gtk_application_new("gtk-fortran.examples.list_demo"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  ! The activate signal will be sent by g_application_run().
  ! The c_funloc() function returns the C address of the callback function.
  ! The c_null_ptr means no data is transfered to the callback function.
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), &
                      & c_null_ptr)
  ! Now, the whole application will be managed by GLib (=> main loop).
  ! Note that commandline arguments argc, argv are not passed.
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-run
  status = g_application_run(app, 0_c_int, [c_null_ptr])

  print *, "You have exited the GLib main loop, bye, bye..."

  ! Memory is freed:
  call g_object_unref(app)

end program list_demo

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team

! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.

! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.

! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed by James Tappin.
! Last modification: vmagnin 2020-05-28 (GTK 4 version), 2020-07-09
!------------------------------------------------------------------------------

module handlers
  use gtk_hl_container
  use gtk_hl_combobox
  use gtk_hl_button
  use gtk, only: gtk_button_new, gtk_combo_box_get_active, gtk_combo_box_new, &
       & gtk_window_set_child, gtk_window_destroy, &
       & gtk_widget_show, TRUE, FALSE

  implicit none
  type(c_ptr) :: win, box, c1, c2, qbut

contains

  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    print *, "Exit called"
    call gtk_window_destroy(win)
  end subroutine my_destroy

  subroutine c_change(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer, pointer :: index
    integer(c_int) :: isel, nrow
    character(len=40) :: value

    if (c_associated(gdata)) then
       call c_f_pointer(gdata, index)
       print "('Box:',I2)", index
    end if

    isel = hl_gtk_combo_box_get_active(widget, ftext=value)
    nrow = hl_gtk_combo_box_n_entries(widget)

    print "('Choice:',I2,' of ',i2,' Text:',a)", isel, nrow, trim(value)
  end subroutine c_change


  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata
    character(len=20), dimension(8) :: list1
    character(len=20) :: item2
    integer :: i
    integer, target :: d1=1, d2=2

    ! Create the window:
    win = gtk_application_window_new(app)
    call gtk_window_set_title(win, "Combo box demo"//c_null_char)

    ! Column box
    box = hl_gtk_box_new()
    call gtk_window_set_child(win, box)

    ! A list with an entry box
    do i = 1, 8
       write(list1(i), "('Item # ',I0)") i-1
    end do
    c1 = hl_gtk_combo_box_new(has_entry=TRUE, changed=c_funloc(c_change), &
         & initial_choices=list1, data=c_loc(d1))
    call hl_gtk_box_pack(box, c1)

    ! One without
    c2 = hl_gtk_combo_box_new(changed=c_funloc(c_change), data=c_loc(d2))
    call hl_gtk_box_pack(box, c2)

    do i = 1, 5
       write(item2, "('Choice Number',I2)") i
       call hl_gtk_combo_box_add_text(c2, trim(item2)//c_null_char, at_start=TRUE)
    end do

    ! Quit button
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(box, qbut)

    ! Realize & enter event loop
    call gtk_widget_show(win)
  end subroutine activate
end module handlers


program combo_demo
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_combo"//c_null_char, &
                             & c_funloc(activate))
end program combo_demo

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-----------------------------------------------------------
! Contributed by James Tappin
! Last modification: 2012-07-30, vmagnin 2020-08-25 (GTK 4)
!-----------------------------------------------------------

!*
! Lists and Trees
module gtk_hl_tree
  ! These functions attempt to hide some of the complexity of the GtkTreeView
  ! system of widgets and object, while still allowing the main functionality
  ! to be accessed. Most possible renderers are supported (spinner is not).
  !
  ! There are three types of list and tree supported.
  !
  ! 1. listn; A multi-column flat list.
  ! 2. list1; A single-column flat list, that allows only string values.
  !    (This is now implemented by calls to the corresponding listn routines).
  !    Editability is not available for list1.
  ! 3. tree; A tree view (similar to listn but with child rows).
  !/

  use gtk_sup
  use gtk_hl_container
  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only: error_unit

  ! Auto generated use's
  use gtk, only: gtk_cell_layout_get_cells,&
       & gtk_cell_renderer_set_alignment,&
       & gtk_cell_renderer_set_padding, gtk_cell_renderer_text_new,&
       & gtk_list_store_append,&
       & gtk_list_store_clear, gtk_list_store_insert,&
       & gtk_list_store_move_after, gtk_list_store_move_before,&
       & gtk_list_store_newv, gtk_list_store_remove,&
       & gtk_list_store_reorder, gtk_list_store_set_value,&
       & gtk_list_store_swap, gtk_scrolled_window_new,&
       & gtk_scrolled_window_set_policy,&
       & gtk_scrolled_window_set_child,&
       & gtk_tree_model_get_column_type, gtk_tree_model_get_iter,&
       & gtk_tree_model_get_iter_first, gtk_tree_model_get_value,&
       & gtk_tree_model_iter_children, gtk_tree_model_iter_n_children,&
       & gtk_tree_model_iter_next, gtk_tree_model_iter_nth_child,&
       & gtk_tree_model_iter_parent, gtk_tree_path_free,&
       & gtk_tree_model_get_string_from_iter, &
       & gtk_tree_model_get_iter_from_string, &
       & gtk_tree_path_get_depth, gtk_tree_path_get_indices,&
       & gtk_tree_path_get_indices_with_depth,&
       & gtk_tree_selection_get_selected,&
       & gtk_tree_selection_get_selected_rows,&
       & gtk_tree_selection_select_iter, gtk_tree_selection_set_mode,&
       & gtk_tree_selection_unselect_all, gtk_tree_store_append,&
       & gtk_tree_store_clear, gtk_tree_store_insert,&
       & gtk_tree_store_insert_before, gtk_tree_store_newv,&
       & gtk_tree_store_prepend, gtk_tree_store_remove,&
       & gtk_tree_store_set_value, gtk_tree_view_append_column,&
       & gtk_tree_view_column_add_attribute, gtk_tree_view_column_new,&
       & gtk_tree_view_column_pack_start,&
       & gtk_tree_view_column_set_cell_data_func,&
       & gtk_tree_view_column_set_fixed_width,&
       & gtk_tree_view_column_set_resizable,&
       & gtk_tree_view_column_set_sizing,&
       & gtk_tree_view_column_set_sort_column_id,&
       & gtk_tree_view_column_set_sort_indicator,&
       & gtk_tree_view_column_set_title, gtk_tree_view_get_column,&
       & gtk_tree_view_get_model, gtk_tree_view_get_selection,&
       & gtk_tree_view_new, gtk_tree_view_new_with_model,&
       & gtk_tree_model_get_type, &
       & gtk_widget_set_sensitive, gtk_widget_set_size_request,&
       & gtk_widget_set_tooltip_text, &
       & gtk_adjustment_set_lower, gtk_adjustment_set_upper, &
       & gtk_adjustment_set_step_increment, gtk_adjustment_new, &
       & gtk_adjustment_set_page_increment, gtk_adjustment_set_value, &
       & gtk_cell_renderer_toggle_new, gtk_cell_renderer_spin_new, &
       & gtk_cell_renderer_toggle_get_active, gtk_cell_renderer_progress_new, &
       & gtk_cell_renderer_set_fixed_size, gtk_cell_renderer_pixbuf_new, &
       & gtk_cell_renderer_combo_new, gtk_combo_box_set_active, &
       & gtk_cell_renderer_toggle_set_radio, &
       & GTK_POLICY_AUTOMATIC, GTK_TREE_VIEW_COLUMN_FIXED, &
       & GTK_SELECTION_MULTIPLE, &
       & TRUE, FALSE, g_signal_connect

  use g, only: g_list_foreach, g_list_free, g_list_length, g_list_nth,&
       & g_list_nth_data, g_object_get_data, g_object_set_data,&
       & g_object_set_property, g_value_get_boolean, &
       & g_value_get_schar, g_value_set_schar, &
       & g_value_get_double, g_value_get_float, g_value_get_int,&
       & g_value_get_int64, g_value_get_long, g_value_get_string,&
       & g_value_get_uchar, g_value_get_uint, g_value_get_uint64,&
       & g_value_get_ulong, g_value_init, g_value_set_boolean,&
       & g_value_set_double, g_value_set_float,&
       & g_value_set_int, g_value_set_int64, g_value_set_long,&
       & g_value_set_string, g_value_set_uchar, g_value_set_uint,&
       & g_value_set_uint64, g_value_set_ulong, g_value_unset, &
       & g_object_get_property, g_value_get_object, g_value_set_object, &
       & g_value_take_object, g_object_ref

  use gdk_pixbuf, only: gdk_pixbuf_get_type

  implicit none

  ! Interfaces to give suitable names to procedures that are
  ! identical between lists and trees. (Yes I know this is the
  ! reverse of how the construct is usually meant to be used).

  interface hl_gtk_listn_set_cell_data_func
     module procedure hl_gtk_list_tree_set_cell_data_func
  end interface hl_gtk_listn_set_cell_data_func
  interface hl_gtk_tree_set_cell_data_func
     module procedure hl_gtk_list_tree_set_cell_data_func
  end interface hl_gtk_tree_set_cell_data_func

  interface hl_gtk_listn_config_spin
     module procedure hl_gtk_list_tree_config_spin
  end interface hl_gtk_listn_config_spin
  interface hl_gtk_tree_config_spin
     module procedure hl_gtk_list_tree_config_spin
  end interface hl_gtk_tree_config_spin

  interface hl_gtk_listn_config_combo
     module procedure hl_gtk_list_tree_combo_model_config
  end interface hl_gtk_listn_config_combo
  interface hl_gtk_tree_config_combo
     module procedure hl_gtk_list_tree_combo_model_config
  end interface hl_gtk_tree_config_combo

  interface hl_gtk_listn_combo_set_model
     module procedure  hl_gtk_list_tree_combo_model_attach
  end interface hl_gtk_listn_combo_set_model
  interface hl_gtk_tree_combo_set_model
     module procedure  hl_gtk_list_tree_combo_model_attach
  end interface hl_gtk_tree_combo_set_model


  ! Renderer types (convenience constants)

  character(len=10), parameter :: hl_gtk_cell_text = 'text'
  character(len=10), parameter :: hl_gtk_cell_toggle = 'toggle'
  character(len=10), parameter :: hl_gtk_cell_radio = 'radio'
  character(len=10), parameter :: hl_gtk_cell_combo = 'combo'
  character(len=10), parameter :: hl_gtk_cell_spin  = 'spin'
  character(len=10), parameter :: hl_gtk_cell_pixbuf = 'pixbuf'
  character(len=10), parameter :: hl_gtk_cell_progress = 'progress'
  character(len=10), parameter :: hl_gtk_cell_spinner = 'spinner'

  ! Make the code-saver routines private
  private :: hl_gtk_list_tree_add_column, hl_gtk_list_tree_set_gvalue, &
       & hl_gtk_list_tree_get_gvalue, hl_gtk_list_tree_set_cell_data_func, &
       & hl_gtk_list_tree_type_adjust, hl_gtk_list_tree_config_spin, &
       & hl_gtk_list_tree_combo_model_attach, &
       & hl_gtk_list_tree_combo_model_config

contains
  !+
  function hl_gtk_listn_new(scroll, ncols, types, changed, data, multiple,&
       & width, titles, height, swidth, align, ixpad, iypad, renderers, &
       & sensitive, tooltip, sortable, editable, colnos, edited, &
       & data_edited, edited_text, data_edited_text, toggled,&
       & data_toggled, edited_spin, data_edited_spin, &
       & edited_combo, data_edited_combo, changed_combo, data_changed_combo,&
       & toggled_radio, data_toggled_radio,  &
       & hscroll_policy, vscroll_policy) result(list)

    type(c_ptr) :: list
    type(c_ptr), intent(out), optional :: scroll
    integer(c_int), intent(in), optional :: ncols
    integer(type_kind), dimension(:), intent(in), optional :: types
    type(c_funptr), optional :: changed
    type(c_ptr), intent(in), optional :: data
    integer(c_int), intent(in), optional :: multiple
    integer(c_int), intent(in), optional, dimension(:) :: width
    character(len=*), dimension(:), intent(in), optional :: titles, renderers
    integer(c_int), intent(in), optional :: height, swidth
    real(c_float), intent(in), optional, dimension(:) :: align
    integer(c_int), intent(in), optional, dimension(:) :: ixpad, iypad
    integer(c_int), intent(in), optional :: sensitive
    character(kind=c_char), dimension(*), intent(in), optional :: tooltip
    integer(c_int), intent(in), optional, dimension(:) :: sortable, editable
    type(c_funptr), optional :: edited, edited_text, toggled, edited_spin, &
         & edited_combo, changed_combo, toggled_radio
    type(c_ptr), optional, intent(in) :: data_edited, data_edited_text, &
         & data_toggled, data_edited_spin, data_edited_combo, &
         & data_changed_combo, data_toggled_radio
    integer(c_int), dimension(:), allocatable, intent(out), optional, target :: colnos
    integer(c_int), intent(in), optional :: hscroll_policy, vscroll_policy

    ! Make a multi column list
    !
    ! SCROLL |  c_ptr |  optional |  A scrollable widget containing the list. (If present, then this is used to pack the list)
    ! NCOLS |  c_int |  optional |  The number of columns.
    ! TYPES |  GType() |  optional |  The types for each column.
    ! CHANGED |  c_funptr |  optional |  Callback function for the "changed" signal to the associated selection object.
    ! DATA |  c_ptr |  optional |  Data to be passed to/from the callback.
    ! MULTIPLE |  boolean |  optional |  Whether multiple selections are allowed.
    ! WIDTH |  integer() |  optional |  The width of the displayed columns.
    ! TITLES |  string() |  optional |  Titles for the visible columns.
    ! HEIGHT |  c_int |  optional |  The height of the display (this is actually the height of the scroll box).
    ! SWIDTH |  c_int |  Optional |  The width for the scroll box
    ! ALIGN |  c_float() |  optional |  The alignment of the columns
    ! IXPAD |  c_int() |  optional |  The X-padding around the cells.
    ! IYPAD |  c_int() |  optional |  The Y-Padding around the cells.
    ! RENDERERS |  f_string() |  optional |  List of renderer types.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is intially sensitive.
    ! TOOLTIP |  string |  optional |  Tooltip for the widget
    ! SORTABLE |  boolean() |  optional |  Set whether the list can be sorted on that column.
    ! EDITABLE |  boolean() |  optional |  Set whether the column can be edited.
    ! EDITED |  c_funptr |  optional |  An alternative callback for the "edited" signal on edited cells. N.B. Only a single callback can be set if different actions are needed for different columns, you must use the column number inside the callback. See hl_gtk_listn_edit_cb for how to access the column numbers. Used for all "text" dereived renderers unless overridden by specific callbacks.
    ! DATA_EDITED |  c_ptr |  optional |  Data to pass to the edited callback.
    ! EDITED_TEXT |  c_funptr |  optional |  An alternative callback for text renderers (not applied to derived renderers).
    ! DATA_EDITED_TEXT |  c_ptr |  optional |  Data to pass to the edited_text  callback.
    ! EDITED_SPIN |  c_funptr |  optional |  An alternative callback for spin button.
    ! DATA_EDITED_SPIN |  c_ptr |  optional |  Data to pass to the edited_spin  callback.
    ! EDITED_COMBO |  c_funptr |  optional |  An alternative callback for the "edited" signal from a combo cell
    ! DATA_EDITED_COMBO |  c_ptr |  optional |  Data to pass to the edited_combo  callback.
    ! TOGGLED |  c_funptr |  optional |  An alternative callback for the "toggled" signal from toggle renderers.
    ! DATA_TOGGLED |  c_ptr |  optional |  Data to pass to the toggled callback.
    ! TOGGLED_RADIO |  c_funptr |  optional |  An alternative callback for the "toggled" signal from radio toggle renderers.
    ! DATA_TOGGLED_RADIO |  c_ptr |  optional |  Data to pass to the toggled callback for radio toggle renderers
    ! CHANGED_COMBO |  c_funptr |  optional |  Callback for the "changed" signal from a combo cell. This is not actually all that useful as the edited signal will be emitted as soon as focus leaves the combo.
    ! DATA_CHANGED_COMBO |  c_ptr |  optional |  Data to pass to the changed callback.
    ! HSCROLL_POLICY |  int |  optional |  Horizontal scrolling policy for the containing scroll window (default AUTOMATIC).
    ! VSCROLL_POLICY |  int |  optional |  Vertical scrolling policy for the containing scroll window (default AUTOMATIC).
    !
    ! At least one of the array arguments or NCOLS must be given.
    ! If TYPES is not given, then strings are assumed.
    !
    ! The following types of renderer are implemented.
    !
    ! * "text" (hl_gtk_cell_text) A standard text box (can also have
    ! 		numeric types.)
    ! * "toggle" (hl_gtk_cell_toggle) A toggle button (always
    ! 		G_TYPE_BOOLEAN).
    ! * "radio" (hl_gtk_cell_radio) A toggle button with radio button
    ! 		renderering. As far as I can see it is the programmer's
    ! 		responsibility to deal with the exclusivity--there does not
    ! 		appear to be an equivalent of the group for normal
    ! 		radio buttons.
    ! * "combo" (hl_gtk_cell_combo) A combo box--the default model supports
    ! 		strings only but user-defined models are possible.
    ! * "spin" (hl_gtk_cell_spin) A spin button. Always of type G_TYPE_DOUBLE.
    ! * "pixbuf" (hl_gtk_cell_pixbuf) A gdk_pixbuf. Always of type
    ! 		gdk_pixbuf_get_type()
    ! * "progress" (hl_gtk_cell_progress) A progress bar. Always of type
    ! 		G_TYPE_INT, not editable.
    ! * The spinner type is not (yet) implemented.
    !-

    integer(c_int) :: ncols_all, i, hscroll, vscroll
    integer(type_kind), dimension(:), allocatable, target :: types_all

    type(c_ptr) :: model, select

    ! Warn if the obsolete COLNOS argument is present
    if (present(colnos)) write(error_unit, *) "hl_gtk_listn_new: "//&
         & "The COLNOS argument is no longer needed."

    ! First find how many columns there are.

    if (present(ncols)) then
       ncols_all = ncols
    else if (present(types)) then
       ncols_all = size(types)
    else if (present(titles)) then
       ncols_all = size(titles)
    else if (present(align)) then
       ncols_all = size(align)
    else if (present(width)) then
       ncols_all = size(width)
    else if (present(sortable)) then
       ncols_all = size(sortable)
    else if (present(ixpad)) then
       ncols_all = size(ixpad)
    else if (present(iypad)) then
       ncols_all = size(iypad)
    else if (present(editable)) then
       ncols_all = size(editable)
    else if (present(renderers)) then
       ncols_all = size(renderers)
    else
       write(error_unit,*) &
            & "hl_gtk_listn_new: Cannot determine the number of columns"
       list = C_NULL_PTR
       scroll=C_NULL_PTR
       return
    end if

    ! Now determine the column types.
    allocate(types_all(ncols_all))
    if (present(types)) then
       types_all = types
    else
       types_all(:) = G_TYPE_STRING
    end if
    if (present(renderers)) &
         & call hl_gtk_list_tree_type_adjust(types_all, renderers)

    ! Create the storage model and the list.
    model = gtk_list_store_newv(ncols_all, c_loc(types_all))
    list = gtk_tree_view_new_with_model(model)

    if (present(scroll)) then
       if (present(hscroll_policy)) then
          hscroll = hscroll_policy
       else
          hscroll = GTK_POLICY_AUTOMATIC
       end if
       if (present(vscroll_policy)) then
          vscroll = vscroll_policy
       else
          vscroll = GTK_POLICY_AUTOMATIC
       end if

       ! Pack the list in the scroll box
       scroll = gtk_scrolled_window_new()
       call gtk_scrolled_window_set_policy(scroll, hscroll, &
            & vscroll)
       call gtk_scrolled_window_set_child(scroll, list)

       if (present(height) .and. present(swidth)) then
          call gtk_widget_set_size_request(scroll,swidth,height)
       else if (present(height)) then
          call gtk_widget_set_size_request(scroll,-1_c_int,height)
       else if (present(swidth)) then
          call gtk_widget_set_size_request(scroll,swidth,1_c_int)
       end if
    else
       if (present(height) .and. present(swidth)) then
          call gtk_widget_set_size_request(list,swidth,height)
       else if (present(height)) then
          call gtk_widget_set_size_request(list,-1_c_int,height)
       else if (present(swidth)) then
          call gtk_widget_set_size_request(list,swidth,1_c_int)
       end if
    end if

    ! Now the visible columns
    do i = 1, ncols_all
       call hl_gtk_list_tree_add_column(i, list, .true., type=types_all(i), &
            & editable=editable, &
            & ixpad=ixpad, iypad=iypad, align=align, titles=titles, &
            & sortable=sortable, width=width, &
            & renderers=renderers, edited=edited, data_edited=data_edited, &
            & edited_text=edited_text, data_edited_text=data_edited_text, &
            & edited_spin=edited_spin, data_edited_spin=data_edited_spin, &
            & toggled=toggled, data_toggled=data_toggled, &
            & edited_combo=edited_combo, data_edited_combo=data_edited_combo, &
            & changed_combo=changed_combo, &
            & data_changed_combo=data_changed_combo, &
            & toggled_radio=toggled_radio, &
            & data_toggled_radio=data_toggled_radio)

    end do

    ! The event handler is attached to the selection object, as is
    ! the multiple selection property.

    select = gtk_tree_view_get_selection(list)

    if (present(multiple)) then
       if (multiple == TRUE) &
            & call gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE)
    end if

    if (present(changed)) then
       if (present(data)) then
          call g_signal_connect(select, "changed"//c_null_char, &
               & changed, data)
       else
          call g_signal_connect(select, "changed"//c_null_char, changed)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(list, tooltip)

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(list, sensitive)

    deallocate(types_all)
  end function hl_gtk_listn_new

  !+
  subroutine hl_gtk_listn_ins(list, row, count)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in), optional :: row, count

    ! Insert a row into a tabular list.
    !
    ! LIST |  c_ptr |  required |  The list into which to insert the row.
    ! ROW |  c_int |  optional |  The row BEFORE which to insert the row (append if absent)
    ! COUNT |  c_int |  optional |  How many rows to add (default 1)
    !-

    type(c_ptr) :: store
    type(gtktreeiter), target :: iter
    integer(c_int) :: i, n

    ! Get the ListStore
    store = gtk_tree_view_get_model(list)

    if (present(count)) then
       n = count
    else
       n = 1
    end if

    ! Insert the row(s)
    if (present(row)) then
       do i = 1, n
          call gtk_list_store_insert(store, c_loc(iter), row)
       end do
    else
       do i = 1, n
          call gtk_list_store_append(store, c_loc(iter))
       end do
    end if
  end subroutine hl_gtk_listn_ins

  !+
  subroutine hl_gtk_listn_rem(list, row)

    type(c_ptr), intent(in) :: list
    integer(c_int), optional, intent(in) :: row

    ! Remove a row or clear a list
    !
    ! LIST |  c_ptr |  required |  The list to modify
    ! ROW |  integer |  optional |  The row to remove, if absent clear the list
    !-

    integer(c_int) :: valid
    type(c_ptr) :: store
    type(gtktreeiter), target :: iter

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! If 2 arguments, then remove a row
    if (present(row)) then
       valid = gtk_tree_model_iter_nth_child(store, c_loc(iter), &
            & C_NULL_PTR, row)
       if (valid==FALSE) return

       valid = gtk_list_store_remove(store, c_loc(iter))

    else   ! 1 argument clear the whole list
       call gtk_list_store_clear(store)
    end if
  end subroutine hl_gtk_listn_rem

  !+
  function hl_gtk_listn_get_selections(list, indices, selection) result(count)

    integer(c_int) :: count
    type(c_ptr), intent(in) :: list
    integer(c_int), dimension(:), allocatable, target, &
         & intent(out), optional :: indices
    type(c_ptr), optional :: selection

    ! Get the indices of the selected rows
    !
    ! LIST |  c_ptr |  required |  The list whose selections are to be found.
    ! INDICES |  integer |  optional |  An allocatable array to return the list of selections. (If count = 0 it will not be allocated). If this argument is not given, then the number of selected rows is returned.
    ! SELECTION |  c_ptr |  optional |  A selection. If this is given then LIST is ignored. This is most often used in the callback routine for the changed signal when that needs to find which element(s) are selected.
    !
    ! Returns the number of selections.
    !-

    type(c_ptr) :: slist, vselection
    integer(c_int) :: i
    type(c_ptr) :: cindex
    integer(c_int), pointer :: findex

    if (present(selection)) then
       vselection = selection
    else
       vselection = gtk_tree_view_get_selection(list)
    end if

    slist = gtk_tree_selection_get_selected_rows(vselection, &
         & c_null_ptr)

    ! If no selections, then set the count to 0 and return
    if (.not. c_associated(slist)) then
       count=0
       return
    end if

    ! Determine how many rows are selected. Then if no output list was
    ! supplied, return, otherwise go on and make a list.
    count = g_list_length(slist)
    if (.not. present(indices)) return

    allocate(indices(count))

    ! For each of the elements in the selection list, find its index
    ! from the hidden first column
    do i = 1, count
       cindex = gtk_tree_path_get_indices(g_list_nth_data(slist, i-1_c_int))
       call c_f_pointer(cindex, findex)
       indices(i) = findex
    end do

    ! Free the selection list.
    call g_list_foreach(slist, c_funloc(gtk_tree_path_free), C_NULL_PTR)
    call g_list_free(slist)

  end function hl_gtk_listn_get_selections


  !+
  subroutine  hl_gtk_listn_set_selection(list, row)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in), optional :: row

    ! Set the selected row in a list (single row only).
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! ROW |  c_int |  optional |  The row to select (absent or less than 0 is  clear selection)
    !-

    type(c_ptr) :: selection, store
    type(gtktreeiter), target :: iter
    integer(c_int) :: valid

    ! Get list store and selection
    store = gtk_tree_view_get_model(list)
    selection = gtk_tree_view_get_selection(list)

    if (.not. present(row)) then
       call gtk_tree_selection_unselect_all(selection)
    else if (row < 0) then
       call gtk_tree_selection_unselect_all(selection)
    else
       valid = gtk_tree_model_iter_nth_child(store, c_loc(iter), &
            & C_NULL_PTR, row)
       if (valid == FALSE) return
       call gtk_tree_selection_select_iter(selection, c_loc(iter))
    end if
  end subroutine hl_gtk_listn_set_selection

  !+
  subroutine hl_gtk_listn_set_cell(list, row, col, &
       & svalue, fvalue, dvalue, ivalue, lvalue, l64value, logvalue, &
       & i8value, pbvalue)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row, col
    character(len=*), intent(in), optional :: svalue
    real(c_float), intent(in), optional :: fvalue
    real(c_double), intent(in), optional :: dvalue
    integer(c_int), intent(in), optional :: ivalue
    integer(c_long), intent(in), optional :: lvalue
    integer(c_int64_t), intent(in), optional :: l64value
    logical, intent(in), optional :: logvalue
    integer(c_int8_t), intent(in), optional :: i8value
    type(c_ptr), intent(in), optional :: pbvalue

    ! Set the value of a cell.
    !
    ! LIST |  c_ptr |  required |  The list containing the cell.
    ! ROW |  c_int |  required |  The row of the cell
    ! COL |  c_int |  required |  The column of the cell.
    ! SVALUE |  string |  optional |  A string value for the cell.
    ! FVALUE |  float |  optional |  A single precision FP value for the cell.
    ! DVALUE |  double |  optional |  A double precision FP value for the cell.
    ! IVALUE |  c_int |  optional |  A normal integer value for the cell.
    ! LVALUE |  c_long |  optional |  A long integer value for the cell.
    ! L64VALUE |  c_int64_t |  optional |  A 64-bit integer value for the cell.
    ! LOGVALUE |  logical |  optional |  A logical value for the cell.
    ! I8VALUE |  int8_t |  optional |  An 8-bit integer value for the cell.
    ! PBVALUE |  c_ptr |  optional |  A pixbuf pointer value for the cell.
    !
    ! Note that reasonable conversions are made between types.
    !-

    integer(type_kind) :: ctype
    type(c_ptr) :: store, val
    integer(c_int) :: valid
    type(gtktreeiter), target :: iter
    type(gvalue), target :: value

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! Find the type for the requested column
    ctype = gtk_tree_model_get_column_type(store, col)

    ! Get the iterator of the row
    valid = gtk_tree_model_iter_nth_child(store, c_loc(iter), C_NULL_PTR, row)
    if (valid == FALSE) return

    ! Set up the GValue to the right type.
    val = c_loc(value)

    call hl_gtk_list_tree_set_gvalue(val, ctype, svalue=svalue, fvalue=fvalue, &
         & dvalue=dvalue, ivalue=ivalue, lvalue=lvalue, l64value=l64value, &
         & logvalue=logvalue, i8value=i8value, pbvalue=pbvalue)

    call gtk_list_store_set_value(store, c_loc(iter), col, val)

  end subroutine hl_gtk_listn_set_cell

  !+
  subroutine hl_gtk_listn_get_cell(list, row, col, &
       & svalue, fvalue, dvalue, ivalue, lvalue, l64value, logvalue, &
       & i8value, pbvalue)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row, col
    character(len=*), intent(out), optional :: svalue
    real(c_float), intent(out), optional :: fvalue
    real(c_double), intent(out), optional :: dvalue
    integer(c_int), intent(out), optional :: ivalue
    integer(c_long), intent(out), optional :: lvalue
    integer(c_int64_t), intent(out), optional :: l64value
    logical, intent(out), optional :: logvalue
    integer(c_int8_t), intent(out), optional :: i8value
    type(c_ptr), intent(out), optional :: pbvalue

    ! Retrieve the value of a cell.
    !
    ! LIST |  c_ptr |  required |  The list containing the cell.
    ! ROW |  c_int |  required |  The row of the cell
    ! COL |  c_int |  required |  The column of the cell.
    ! SVALUE |  string |  optional |  A string value from the cell.
    ! FVALUE |  float |  optional |  A single precision FP value from the cell.
    ! DVALUE |  double |  optional |  A double precision FP value from the cell.
    ! IVALUE |  c_int |  optional |  A normal integer value from the cell.
    ! LVALUE |  c_long |  optional |  A long integer value from the cell.
    ! L64VALUE |  c_int64_t |  optional |  A 64-bit integer value from the cell.
    ! LOGVALUE |  logical  |  optional |  A logical value from the cell.
    ! I8VALUE |  int8_t |  optional |  An 8-bit integer value from the cell.
    ! PBVALUE |  c_ptr |  optional |  A pixbuf pointer from the cell.
    !
    ! Note that a similar conversion system to the set_cell routine
    ! except that strings can only be returned to SVALUE.
    !-

    integer(type_kind) :: ctype
    type(c_ptr) :: store, val
    integer(c_int) :: valid
    type(gtktreeiter), target :: iter
    type(gvalue), target :: value

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! Find the type for the requested column
    ctype = gtk_tree_model_get_column_type(store, col)

    ! Get the iterator of the row
    valid = gtk_tree_model_iter_nth_child(store, c_loc(iter), C_NULL_PTR, row)
    if (valid == FALSE) return

    ! Set up the GValue pointer (for convenience) gtk_tree_model_get_value
    ! does the initialization.
    val = c_loc(value)

    ! Get the GValue of the cell.
    call gtk_tree_model_get_value(store, c_loc(iter), col, val)

    call hl_gtk_list_tree_get_gvalue(val, ctype, &
         & svalue=svalue, fvalue=fvalue, dvalue=dvalue, ivalue=ivalue, &
         & lvalue=lvalue, l64value=l64value, logvalue=logvalue, &
         & i8value=i8value, pbvalue=pbvalue)

  end subroutine hl_gtk_listn_get_cell

  !+
  subroutine hl_gtk_listn_move_row(list, row1, row2, after)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row1
    integer(c_int), intent(in), optional :: row2
    integer(c_int), intent(in), optional :: after

    ! Move a row in a list to a new location
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! ROW1 |  c_int |  required |  The index of the row to move.
    ! ROW2 |  c_int |  optional |  The location before which to place the row. (If omitted, then move to start (or end if AFTER is TRUE)).
    ! AFTER |  boolean |  optional |   Set this to TRUE to put the row after the location instead of before.
    !-

    type(c_ptr) :: store
    type(gtktreeiter), target :: iter1, iter2
    integer(c_int) :: isafter
    integer(c_int) :: valid

    if (present(after)) then
       isafter = after
    else
       isafter = FALSE
    end if

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! Get the iterator of the row to move
    valid = gtk_tree_model_iter_nth_child(store, c_loc(iter1), &
         & C_NULL_PTR, row1)
    if (valid == FALSE) return
    ! And of the target location
    if (present(row2)) then
       valid = gtk_tree_model_iter_nth_child(store, c_loc(iter2), &
            & C_NULL_PTR, row2)
       if (valid == FALSE) return
    end if

    ! Move it
    if (isafter == TRUE) then
       if (present(row2)) then
          call gtk_list_store_move_after(store, c_loc(iter1), c_loc(iter2))
       else
          call gtk_list_store_move_before(store, c_loc(iter1), C_NULL_PTR)
       end if
    else
       if (present(row2)) then
          call gtk_list_store_move_before(store, c_loc(iter1), c_loc(iter2))
       else
          call gtk_list_store_move_after(store, c_loc(iter1), C_NULL_PTR)
       end if
    end if
  end subroutine hl_gtk_listn_move_row

  !+
  subroutine hl_gtk_listn_swap_rows(list, row1, row2)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row1, row2

    ! Move a row in a list to a new location
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! ROW1 |  c_int |  required |  The index of the first row to move.
    ! ROW2 |  c_int |  required |  The index of the second row to move
    !-

    type(c_ptr) :: store
    type(gtktreeiter), target :: iter1, iter2
    integer(c_int) :: valid

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! Get the iterator of the first row to move
    valid = gtk_tree_model_iter_nth_child(store, c_loc(iter1), &
         & C_NULL_PTR, row1)
    if (valid == FALSE) return
    ! And of the second
    valid = gtk_tree_model_iter_nth_child(store, c_loc(iter2), &
         & C_NULL_PTR, row2)
    if (valid == FALSE) return

    ! Exchange the rows
    call gtk_list_store_swap(store, c_loc(iter1), c_loc(iter2))

  end subroutine hl_gtk_listn_swap_rows

  !+
  subroutine hl_gtk_listn_reorder(list, indices)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in), dimension(:) :: indices

    ! Move a row in a list to a new location
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! INDICES |  c_int() |  required |  The sorting array. The ith element contains the old location of the new (i-1)th row.
    !-

    type(c_ptr) :: store
    integer(c_int), dimension(:), allocatable, target :: idx

    allocate(idx(size(indices)))
    idx = indices

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! Reorder the list
    call gtk_list_store_reorder(store, c_loc(idx))

    deallocate(idx)

  end subroutine hl_gtk_listn_reorder

  !+
  function hl_gtk_listn_get_n_rows(list) result(nrows)

    integer(c_int) :: nrows
    type(c_ptr), intent(in) :: list

    ! Return the number of rows in a list.
    !
    ! LIST |  c_ptr |  required |  the list to query
    !-

    type(c_ptr) :: store

    ! Get list store
    store = gtk_tree_view_get_model(list)

    ! Find how many rows
    nrows = gtk_tree_model_iter_n_children(store, C_NULL_PTR)

  end function hl_gtk_listn_get_n_rows

  !+
  function hl_gtk_list1_new(scroll, width, changed, data, multiple, &
       & sensitive, tooltip, title, height) result(list)

    type(c_ptr) :: list
    type(c_ptr), intent(out), optional :: scroll
    integer(c_int), intent(in), optional :: width
    type(c_funptr), intent(in), optional :: changed
    type(c_ptr), intent(in), optional :: data
    integer(c_int), intent(in),  optional :: multiple, sensitive
    character(kind=c_char), dimension(*), intent(in), optional :: tooltip
    character(len=*), intent(in), optional :: title
    integer(c_int), intent(in), optional :: height

    ! A single column selectable list based on the GTK Tree View
    !
    ! SCROLL |  c_ptr |  optional |  A scroll box that will contain the list (used for packing etc.)
    ! WIDTH |  integer |  optional |  The width of the displayed column.
    ! CHANGED |  c_funptr |  optional |  Callback function for the "changed" signal to the associated selection object.
    ! DATA |  c_ptr |  optional |  Data to be passed to/from the callback.
    ! MULTIPLE |  boolean |  optional |  Whether multiple selections are allowed.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is intially sensitive.
    ! TOOLTIP |  string |  optional |  Tooltip for the widget
    ! TITLE |  string |  optional |  Title for the visible column.
    ! HEIGHT |  integer |  optional |  The height of the display (this is actually the height of the scroll box).
    !
    ! If other options (e.g. sortable columns or editable cells are needed,
    ! the use hl_gtk_listn_new with 1 column).
    !-

    integer(type_kind), target, dimension(1) :: types

    ! Create list storage with 2 colums (one is a dummy, to provide an index)

    types = [ G_TYPE_STRING ]

    ! This slightly clunky if /else cascade is needed because the attempt to convert
    ! an unset scalar argument to an array causes a segfault.
    if (present(title) .and. present(width)) then
       list = hl_gtk_listn_new(scroll, ncols=1_c_int, types=types, &
            & changed=changed, &
            & data=data, multiple=multiple, sensitive=sensitive, &
            & tooltip=tooltip, width=[width], titles=[title], height=height)
    else if (present(title)) then
       list = hl_gtk_listn_new(scroll, ncols=1_c_int, types=types, &
            & changed=changed, &
            & data=data, multiple=multiple, sensitive=sensitive, &
            & tooltip=tooltip, titles=[title], height=height)
    else if (present(width)) then
       list = hl_gtk_listn_new(scroll, ncols=1_c_int, types=types, &
            & changed=changed, &
            & data=data, multiple=multiple, sensitive=sensitive, &
            & tooltip=tooltip, width=[width], height=height)
    else
       list = hl_gtk_listn_new(scroll, ncols=1_c_int, types=types, &
            & changed=changed, &
            & data=data, multiple=multiple, sensitive=sensitive, &
            & tooltip=tooltip, height=height)
    end if
  end function hl_gtk_list1_new

  !+
  subroutine hl_gtk_list1_ins(list, text, row)

    type(c_ptr), intent(in) :: list
    character(kind=c_char, len=*), intent(in), optional :: text
    integer(c_int), intent(in), optional :: row

    ! Insert a row into a list
    !
    ! LIST |  c_ptr |  required |  The list to insert to.
    ! TEXT |  string |  optional |  The text to insert.
    ! ROW |  integer |  optional |  The row at which to insert the text (omit to append)
    !-

    integer(c_int) :: irow
    type(c_ptr) :: store

    call hl_gtk_listn_ins(list, row)
    if (.not. present(text)) return

    if (present(row)) then
       irow = row
    else
       store = gtk_tree_view_get_model(list)
       irow=gtk_tree_model_iter_n_children (store, C_NULL_PTR)-1
    end if

    call hl_gtk_listn_set_cell(list, irow, 0_c_int, svalue=text)

  end subroutine hl_gtk_list1_ins

  !+
  subroutine hl_gtk_list1_rem(list, row)

    type(c_ptr), intent(in) :: list
    integer(c_int), optional, intent(in) :: row

    ! Remove a row or clear a list
    !
    ! LIST |  c_ptr |  required |  The list to modify
    ! ROW |  integer |  optional |  The row to remove, if absent clear the list
    !-

    call hl_gtk_listn_rem(list, row)

  end subroutine hl_gtk_list1_rem

  !+
  function hl_gtk_list1_get_selections(list, indices, selection) result(count)

    integer(c_int) :: count
    type(c_ptr), intent(in) :: list
    integer(c_int), dimension(:), allocatable, target, &
         & intent(out), optional :: indices
    type(c_ptr), optional :: selection

    ! Get the indices of the selected rows
    !
    ! LIST |  c_ptr |  required |  The list whose selections are to be found.
    ! INDICES |  integer |  optional |  An allocatable array to return the list of selections. (If count = 0 it will not be allocated). If this argument is not given, then the number of selected rows is returned.
    ! SELECTION |  c_ptr |  optional |  A selection. If this is given then LIST is ignored. This is most often used in the callback routine for the changed signal when that needs to find which element(s) are selected.
    !
    ! Returns the number of selections.
    !-

    count = hl_gtk_listn_get_selections(list, indices, selection)

  end function hl_gtk_list1_get_selections

  !+
  subroutine  hl_gtk_list1_set_selection(list, row)
    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in), optional :: row

    ! Set the selected row in a list (single row only)
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! ROW |  c_int |  optional |  The row to select (absent or < 0 is clear selection)
    !-

    call hl_gtk_listn_set_selection(list, row)

  end subroutine hl_gtk_list1_set_selection

  !+
  subroutine hl_gtk_list1_set_cell(list, row, svalue)
    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row
    character(len=*), intent(in) :: svalue

    ! Set a cell in a single column list
    !
    ! LIST |  c_ptr |  required |  The list containing the cell.
    ! ROW |  c_int |  required |  The row of the cell
    ! SVALUE |  string |  required |  A string value for the cell.
    !-

    call hl_gtk_listn_set_cell(list, row, 0_c_int, svalue=svalue)

  end subroutine hl_gtk_list1_set_cell

  !+
  subroutine hl_gtk_list1_get_cell(list, row, svalue)
    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row
    character(len=*), intent(out) :: svalue

    ! Set a cell in a single column list
    !
    ! LIST |  c_ptr |  required |  The list containing the cell.
    ! ROW |  c_int |  required |  The row of the cell
    ! SVALUE |  string |  required |  A string value from the cell.
    !-

    call hl_gtk_listn_get_cell(list, row, 0_c_int, svalue=svalue)

  end subroutine hl_gtk_list1_get_cell

  !+
  subroutine hl_gtk_list1_move_row(list, row1, row2, after)
    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row1
    integer(c_int), intent(in), optional :: row2
    integer(c_int), intent(in), optional :: after

    ! Move a row in a list to a new location
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! ROW1 |  c_int |  required |  The index of the row to move.
    ! ROW2 |  c_int |  optional |  The location before which to place the row.
    ! AFTER |  boolean |  optional |   Set this to TRUE to put the row after the location instead of before.
    !-

    call hl_gtk_listn_move_row(list, row1, row2, after)

  end subroutine hl_gtk_list1_move_row

  !+
  subroutine hl_gtk_list1_swap_rows(list, row1, row2)
    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: row1, row2

    ! Move a row in a list to a new location
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! ROW1 |  c_int |  required |  The index of the first row to move.
    ! ROW2 |  c_int |  required |  The index of the second row to move
    !-

    call hl_gtk_listn_swap_rows(list, row1, row2)

  end subroutine hl_gtk_list1_swap_rows

  !+
  subroutine hl_gtk_list1_reorder(list, indices)
    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in), dimension(:), target :: indices

    ! Move a row in a list to a new location
    !
    ! LIST |  c_ptr |  required |  The list to work on.
    ! INDICES |  c_int() |  required |  The sorting array. The ith element contains the old location of the new (i-1)th row.
    !-

    call hl_gtk_listn_reorder(list, indices)

  end subroutine hl_gtk_list1_reorder

  !+
  function hl_gtk_list1_get_n_rows(list) result(nrows)

    integer(c_int) :: nrows
    type(c_ptr), intent(in) :: list

    ! Return the number of rows in a list.
    !
    ! LIST |  c_ptr |  required |  the list to query
    !-

    nrows=hl_gtk_listn_get_n_rows(list)
  end function hl_gtk_list1_get_n_rows

  !+
  subroutine hl_gtk_list1_set_cell_data_func(list, func, &
       & data, destroy_notify)

    type(c_ptr), intent(in) :: list
    type(c_funptr), optional :: func
    type(c_ptr), optional :: data
    type(c_funptr), optional :: destroy_notify

    ! Add a custom rendering function to a column of a list
    !
    ! LIST |  c_ptr |  required |  The list to which to apply the rendering function
    ! FUNC |  c_funptr |  optional |  The function (actually subroutine) to do the rendering (see GtkTreeCellDataFunc, for details). Omit or set to C_NULL_FUNPTR to remove a function.
    ! DATA |  c_ptr |  optional |  User data to pass to the function.
    ! DESTROY_NOTIFY |  c_funptr |  optional |  A destroy notify subroutine.
    !-

    call hl_gtk_listn_set_cell_data_func(list, 0_c_int, func, &
         & data, destroy_notify)
  end subroutine hl_gtk_list1_set_cell_data_func

  !+
  function hl_gtk_tree_new(scroll, ncols, types, changed, data, multiple,&
       & width, titles, height, swidth, align, ixpad, iypad, renderers, &
       & sensitive, tooltip, sortable, editable, colnos, edited, data_edited, &
       & edited_text, data_edited_text, toggled, data_toggled, &
       & edited_spin, data_edited_spin, &
       & edited_combo, data_edited_combo, changed_combo, data_changed_combo, &
       & toggled_radio, data_toggled_radio,  &
       & hscroll_policy, vscroll_policy) result(tree)

    type(c_ptr) :: tree
    type(c_ptr), intent(out), optional :: scroll
    integer(c_int), intent(in), optional :: ncols
    integer(type_kind), dimension(:), intent(in), optional :: types
    type(c_funptr), optional :: changed
    type(c_ptr), intent(in), optional :: data
    integer(c_int), intent(in), optional :: multiple
    integer(c_int), intent(in), optional, dimension(:) :: width
    character(len=*), dimension(:), intent(in), optional :: titles, renderers
    integer(c_int), intent(in), optional :: height, swidth
    real(c_float), intent(in), optional, dimension(:) :: align
    integer(c_int), intent(in), optional, dimension(:) :: ixpad, iypad
    integer(c_int), intent(in), optional :: sensitive
    character(kind=c_char), dimension(*), intent(in), optional :: tooltip
    integer(c_int), intent(in), optional, dimension(:) :: sortable, editable
    integer(c_int), dimension(:), allocatable, intent(out), optional, target :: colnos
    type(c_funptr), optional :: edited, edited_text, toggled, edited_spin, &
         & edited_combo, changed_combo, toggled_radio
    type(c_ptr), optional, intent(in) :: data_edited, data_edited_text,&
         & data_toggled, data_edited_spin, data_edited_combo, &
         & data_changed_combo, data_toggled_radio
    integer(c_int), intent(in), optional :: hscroll_policy, vscroll_policy

    ! Make a tree view
    !
    ! SCROLL |  c_ptr |  optional |  A scrollable widget to contain the tree. (This is used to pack the tree)
    ! NCOLS |  c_int |  optional |  The number of columns.
    ! TYPES |  GType() |  optional |  The types for each column.
    ! CHANGED |  c_funptr |  optional |  Callback function for the "changed" signal to the associated selection object.
    ! DATA |  c_ptr |  optional |  Data to be passed to/from the callback.
    ! MULTIPLE |  boolean |  optional |  Whether multiple selections are allowed.
    ! WIDTH |  integer() |  optional |  The width of the displayed columns.
    ! TITLES |  string() |  optional |  Titles for the visible columns.
    ! HEIGHT |  c_int |  optional |  The height of the display (this is actually the height of the scroll box).
    ! SWIDTH |  c_int |  Optional |  The width for the scroll box
    ! ALIGN |  c_float() |  optional |  The alignment of the columns
    ! IXPAD |  c_int() |  optional |  The X-padding around the cells.
    ! IYPAD |  c_int() |  optional |  The Y-Padding around the cells.
    ! RENDERERS | f_string() | List of renderer types.
    ! SENSITIVE |  boolean |  optional |  Whether the widget is intially sensitive.
    ! TOOLTIP |  string |  optional |  Tooltip for the widget
    ! SORTABLE |  boolean() |  optional |  Set whether the tree can be sorted on that column.
    ! EDITABLE |  boolean() |  optional |  Set whether the column can be edited.
    ! EDITED |  f_funptr |  optional |  An alternative callback for the "edited" signal on edited cells. N.B. Only a single callback can be set if different actions are needed for different columns, you must use the column number inside the callback.
    ! DATA_EDITED |  c_ptr |  optional |  Data to pass to the edited callback.
    ! EDITED_TEXT |  c_funptr |  optional |  An alternative callback for text renderers (not applied to derived renderers).
    ! DATA_EDITED_TEXT |  c_ptr |  optional |  Data to pass to the edited_text  callback.
    ! EDITED_SPIN |  c_funptr |  optional |  An alternative callback for spin button.
    ! DATA_EDITED_SPIN |  c_ptr |  optional |  Data to pass to the edited_spin  callback.
    ! EDITED_COMBO |  c_funptr |  optional |  An alternative callback for the "edited" signal from a combo cell
    ! DATA_EDITED_COMBO |  c_ptr |  optional |  Data to pass to the edited_combo  callback.
    ! TOGGLED |  c_funptr |  optional |  An alternative callback for the "toggled" signal from toggle renderers.
    ! DATA_TOGGLED |  c_ptr |  optional |  Data to pass to the toggled callback.
    ! TOGGLED_RADIO |  c_funptr |  optional |  An alternative callback for the "toggled" signal from radio toggle renderers.
    ! DATA_TOGGLED_RADIO |  c_ptr |  optional |  Data to pass to the toggled callback for radio toggle renderers
    ! CHANGED_COMBO |  c_funptr |  optional |  Callback for the "changed" signal from a combo cell. This is not actually all that useful as the edited signal will be emitted as soon as focus leaves the combo.
    ! DATA_CHANGED_COMBO |  c_ptr |  optional |  Data to pass to the changed callback.
    ! HSCROLL_POLICY |  int |  optional |  Horizontal scrolling policy for the containing scroll window (default AUTOMATIC).
    ! VSCROLL_POLICY |  int |  optional |  Vertical scrolling policy for the containing scroll window (default AUTOMATIC).
    !
    ! At least one of the array arguments or NCOLS must be given.
    ! If TYPES is not given, then strings are assumed.
    !
    ! For renderer types see HL_GTK_LISTN_NEW.
    !-

    integer(c_int) :: ncols_all, i, hscroll, vscroll
    integer(type_kind), dimension(:), allocatable, target :: types_all

    type(c_ptr) :: model, select

    ! Warn if the obsolete COLNOS argument is present
    if (present(colnos)) write(error_unit, *) "hl_gtk_tree_new: "//&
         & "The COLNOS argument is no longer needed."

    ! First find how many columns there are.

    if (present(ncols)) then
       ncols_all = ncols
    else if (present(types)) then
       ncols_all = size(types)
    else if (present(titles)) then
       ncols_all = size(titles)
    else if (present(align)) then
       ncols_all = size(align)
    else if (present(width)) then
       ncols_all = size(width)
    else if (present(sortable)) then
       ncols_all = size(sortable)
    else if (present(ixpad)) then
       ncols_all = size(ixpad)
    else if (present(iypad)) then
       ncols_all = size(iypad)
    else if (present(editable)) then
       ncols_all = size(editable)
    else if (present(renderers)) then
       ncols_all = size(renderers)
    else
       write(error_unit,*) &
            & "hl_gtk_tree_new: Cannot determine the number of columns"
       tree = C_NULL_PTR
       scroll=C_NULL_PTR
       return
    end if

    ! Now determine the column types.
    allocate(types_all(ncols_all))
    if (present(types)) then
       types_all = types
    else
       types_all(:) = G_TYPE_STRING
    end if
    if (present(renderers)) &
         & call hl_gtk_list_tree_type_adjust(types_all, renderers)


    ! Create the storage model
    model = gtk_tree_store_newv(ncols_all, c_loc(types_all))
    tree = gtk_tree_view_new_with_model(model)

    if (present(scroll)) then
       if (present(hscroll_policy)) then
          hscroll = hscroll_policy
       else
          hscroll = GTK_POLICY_AUTOMATIC
       end if
       if (present(vscroll_policy)) then
          vscroll = vscroll_policy
       else
          vscroll = GTK_POLICY_AUTOMATIC
       end if


       ! Pack the tree in the scroll box
       scroll = gtk_scrolled_window_new()
       call gtk_scrolled_window_set_policy(scroll, hscroll, vscroll)

       call gtk_scrolled_window_set_child(scroll, tree)

       if (present(height) .and. present(swidth)) then
          call gtk_widget_set_size_request(scroll,swidth,height)
       else if (present(height)) then
          call gtk_widget_set_size_request(scroll,-1_c_int,height)
       else if (present(swidth)) then
          call gtk_widget_set_size_request(scroll,swidth,-1_c_int)
       end if
    else
       if (present(height) .and. present(swidth)) then
          call gtk_widget_set_size_request(tree,swidth,height)
       else if (present(height)) then
          call gtk_widget_set_size_request(tree,-1_c_int,height)
       else if (present(swidth)) then
          call gtk_widget_set_size_request(tree,swidth,-1_c_int)
       end if
    end if

    ! Set up the columns
    do i = 1, ncols_all
       call hl_gtk_list_tree_add_column(i, tree, .false., type=types_all(i), &
            & editable=editable, &
            & ixpad=ixpad, iypad=iypad, align=align, titles=titles, &
            & sortable=sortable, width=width, &
            & renderers=renderers, edited=edited, data_edited=data_edited, &
            & edited_text=edited_text, data_edited_text=data_edited_text, &
            & edited_spin=edited_spin, data_edited_spin=data_edited_spin, &
            & toggled=toggled, data_toggled=data_toggled, &
            & edited_combo=edited_combo, data_edited_combo=data_edited_combo, &
            & changed_combo=changed_combo, &
            & data_changed_combo=data_changed_combo, &
            & toggled_radio=toggled_radio, &
            & data_toggled_radio=data_toggled_radio)
    end do

    ! The event handler is attached to the selection object, as is
    ! the multiple selection property.

    select = gtk_tree_view_get_selection(tree)

    if (present(multiple)) then
       if (multiple == TRUE) &
            & call gtk_tree_selection_set_mode(select, GTK_SELECTION_MULTIPLE)
    end if

    if (present(changed)) then
       if (present(data)) then
          call g_signal_connect(select, "changed"//c_null_char, changed, data)
       else
          call g_signal_connect(select, "changed"//c_null_char, changed)
       end if
    end if

    if (present(tooltip)) call gtk_widget_set_tooltip_text(tree, tooltip)

    if (present(sensitive)) &
         & call gtk_widget_set_sensitive(tree, sensitive)

    deallocate(types_all)
  end function hl_gtk_tree_new

  !+
  subroutine hl_gtk_tree_ins(tree, row, absrow, count)

    type(c_ptr), intent(in) :: tree
    integer(c_int), intent(in), optional, dimension(:) :: row
    integer(c_int), intent(in), optional :: absrow, count

    ! Insert a row into a tabular tree.
    !
    ! TREE |  c_ptr |  required |  The tree into which to insert the row.
    ! ROW |  c_int() |  optional |  The row BEFORE which to insert the row (append if an element is -1) For example; to put a new row after all other children of the second child of the fifth top-level row use [ 4, 1, -1 ].
    ! ABSROW |  c_int |  optional |  The row BEFORE which to insert the new row treating the tree as a flat list.
    ! COUNT |  c_int |  optional |  How many rows to add (default 1)
    !-

    type(c_ptr) :: store
    type(gtktreeiter), target :: iter1, iter2
    integer(c_int) :: valid
    integer :: i, ndep, n

    if (present(count)) then
       n = count
    else
       n = 1
    end if

    ! Get the TreeStore
    store = gtk_tree_view_get_model(tree)

    ! Insert the row (we don't use the "scanner" here because of the
    ! special case of -1 for append at a level).

    if (present(row)) then
       ndep = size(row)
       if (ndep == 1) then
          if (row(1) < 0) then
             do i = 1, n
                call gtk_tree_store_append(store, c_loc(iter1), C_NULL_PTR)
             end do
          else
             do i = 1, n
                call gtk_tree_store_insert(store, c_loc(iter1), C_NULL_PTR, &
                     & row(1))
             end do
          end if
       else
          do i = 1, size(row)-1
             if (i == 1) then
                valid=gtk_tree_model_iter_nth_child(store, c_loc(iter1), &
                     & C_NULL_PTR, row(1))
             else
                valid=gtk_tree_model_iter_nth_child(store, c_loc(iter1), &
                     & c_loc(iter2), row(i))
             end if
             if (valid == FALSE) then
                write(error_unit,*) "hl_gtk_tree_ins:: "//&
                     & "Row description does not point to an insertable location"
                return
             end if
             iter2 = iter1
          end do
          call clear_gtktreeiter(iter1)
          if (row(ndep) < 0) then
             do i = 1, n
                call gtk_tree_store_append(store, c_loc(iter1), c_loc(iter2))
             end do
          else
             do i = 1, n
                call gtk_tree_store_insert(store, c_loc(iter1), &
                     & c_loc(iter2), row(ndep))
             end do
          end if
       end if
    else if (present(absrow)) then
       if (absrow < 0) then
          do i = 1, n
             call gtk_tree_store_append(store, c_loc(iter1), C_NULL_PTR)
          end do
       else if (absrow == 0) then
          do i = 1, n
             call gtk_tree_store_prepend(store, c_loc(iter1), C_NULL_PTR)
          end do
       else
          valid = hl_gtk_tree_abs_iter(tree, iter1, absrow)
          if (valid == FALSE) then
             write(error_unit,*) "hl_gtk_tree_ins:: "//&
                  & "Row description does not point to an insertable location"
             return
          end if
          do i = 1, n
             call clear_gtktreeiter(iter2)
             call gtk_tree_store_insert_before(store, c_loc(iter2), &
                  & C_NULL_PTR, c_loc(iter1))
          end do
       end if
    end if
  end subroutine hl_gtk_tree_ins

  !+
  function hl_gtk_tree_abs_iter(tree, iter, index, model) result(valid)

    integer(c_int) :: valid
    type(c_ptr), intent(in) :: tree
    type(gtktreeiter), intent(out), target :: iter
    integer(c_int), intent(in) :: index
    type(c_ptr), intent(in), optional :: model

    ! Get the indexth iterator of a tree (treating it as a flat list)
    !
    ! TREE |  c_ptr |  required |  The tree to traverse
    ! ITER |  gtktreeiter |  required |  The iterator found
    ! INDEX |  c_int |  required |   The location to be identified
    ! MODEL |  c_ptr |  optional |  The tree model (if this is given then TREE is ignored)
    !
    ! Returns TRUE if the search was successful, FALSE otherwise (not usually
    ! called directly by applications).
    !-

    type(gtktreeiter), target :: iter2
    integer(c_int) :: irow
    type(c_ptr) :: store

    ! Get the TreeStore
    if (present(model)) then
       store = model
    else
       store = gtk_tree_view_get_model(tree)
    end if

    irow=0
    ! Get the first iterator
    valid = gtk_tree_model_get_iter_first(store, c_loc(iter))
    if (valid==FALSE .or. index == 0) return
    do
       valid = gtk_tree_model_iter_children(store, c_loc(iter2), c_loc(iter))
       if (valid == FALSE) then  ! no children
          valid = gtk_tree_model_iter_next(store, c_loc(iter))
          if (valid == FALSE) then ! no later sibling
             valid = gtk_tree_model_iter_parent(store, c_loc(iter2),&
                  & c_loc(iter))
             if (valid == FALSE) return ! back to the top level
             iter=iter2
          else
             irow = irow+1
             if (irow == index) return
          end if
       else
          irow = irow+1
          iter = iter2
          if (irow == index) return
       end if
    end do
  end function hl_gtk_tree_abs_iter

  !+
  function hl_gtk_tree_row_iter(tree, iter, row, model) result(valid)

    type(gtktreeiter), target :: iter
    type(c_ptr), intent(in) :: tree
    integer(c_int), intent(in), dimension(:) :: row
    type(c_ptr), intent(in), optional :: model

    ! Get the iterator for a given row of the tree
    !
    ! TREE |  c_ptr |  required |  The tree to traverse
    ! ITER |  gtktreeiter |  required |  The iterator found
    ! ROW |  c_int() |  required |  The row specifier
    ! MODEL |  c_ptr |  optional |  The tree model (if this is given then TREE is ignored)
    !-

    type(gtktreeiter), target :: iter2
    integer :: i, ndep
    type(c_ptr) :: store
    integer(c_int) :: valid

    ! Get the TreeStore
    if (present(model)) then
       store = model
    else
       store = gtk_tree_view_get_model(tree)
    end if

    ndep = size(row)
    valid = gtk_tree_model_iter_nth_child(store, c_loc(iter), &
         & C_NULL_PTR, row(1))

    if (ndep == 1) return
    do i = 2, size(row)
       iter2 = iter
       valid=gtk_tree_model_iter_nth_child(store, c_loc(iter), &
            & c_loc(iter2), row(i))
       if (valid == FALSE) return   ! Invalid specifier
    end do
  end function hl_gtk_tree_row_iter

  !+
  subroutine hl_gtk_tree_rem(tree, row, absrow)

    type(c_ptr), intent(in) :: tree
    integer(c_int), optional, intent(in), dimension(:) :: row
    integer(c_int), intent(in), optional :: absrow

    ! Remove a row or clear a tree
    !
    ! TREE |  c_ptr |  required |  The tree to modify
    ! ROW |  integer() |  optional |  The row to remove, if absent clear the tree
    ! ABSROW |  c_int |  optional |  The row to remove, treating the tree as a flat list.
    !-

    integer(c_int) :: valid
    type(c_ptr) :: store
    type(gtktreeiter), target :: iter

    ! Get tree store
    store = gtk_tree_view_get_model(tree)

    ! If 2 arguments, then remove a row
    if (present(row)) then
       valid = hl_gtk_tree_row_iter(tree, iter, row)
    else if (present(absrow)) then
       valid = hl_gtk_tree_abs_iter(tree, iter, absrow)
    else
       call gtk_tree_store_clear(store)
       return
    end if
    if (valid == FALSE) then
       write(error_unit,*) "hl_gtk_tree_rem: Specified row does not exist"
       return
    end if

    valid = gtk_tree_store_remove(store, c_loc(iter))
  end subroutine hl_gtk_tree_rem

  !+
  function hl_gtk_tree_get_selections(tree, indices, depths, &
       & selection) result(count)

    integer(c_int) :: count
    type(c_ptr), intent(in) :: tree
    integer(c_int), dimension(:,:), allocatable, target, &
         & intent(out), optional :: indices
    integer(c_int), dimension(:), allocatable, target, &
         & intent(out), optional :: depths
    type(c_ptr), intent(in), optional :: selection

    ! Get the indices of the selected rows
    !
    ! TREE |  c_ptr |  required |  The tree whose selections are to be found.
    ! INDICES |  c_int(,) |  optional |  An allocatable array to return the tree of selections. (If count = 0 it will not be allocated). If this argument is not given, then the number of selected rows is returned.
    ! DEPTHS |  c_int() |  optional |  An allocatable array to return the depth of each selection. (Strictly the last meaningful element of each row of INDICES).
    ! SELECTION |  c_ptr |  optional |  A selection. If this is given then TREE is ignored. This is most often used in the callback routine for the changed signal when that needs to find which element(s) are selected.
    !
    ! Returns the number of selections.
    !-

    type(c_ptr) :: slist, vselection
    integer(c_int) :: i
    integer(c_int) :: maxdepth
    integer(c_int), dimension(:), pointer :: idxl
    integer(c_int), target :: dep
    type(c_ptr) :: idxlc

    if (present(selection)) then
       vselection = selection
    else
       vselection = gtk_tree_view_get_selection(tree)
    end if

    slist = gtk_tree_selection_get_selected_rows(vselection, &
         & c_null_ptr)

    ! If no selections, then set the count to 0 and return
    if (.not. c_associated(slist)) then
       count=0
       return
    end if

    ! Determine how many rows are selected. Then if no output list was
    ! supplied, return, otherwise go on and make a list.
    count = g_list_length(slist)
    if (.not. present(indices)) return

    ! For each of the elements in the selection list, find its index
    ! from the hidden first column
    maxdepth = 0
    do i = 1, count
       maxdepth = max(maxdepth, &
            & gtk_tree_path_get_depth(g_list_nth_data(slist, i-1_c_int)))
    end do

    allocate(indices(maxdepth,count))
    if (present(depths)) allocate(depths(count))

    do i = 1, count
       idxlc = gtk_tree_path_get_indices_with_depth( &
            & g_list_nth_data(slist, i-1_c_int), &
            & c_loc(dep))
       call c_f_pointer(idxlc, idxl, [ int(dep) ] )
       indices(:dep,i) = idxl
       if (present(depths)) depths(i) = dep
    end do

    ! Free the selection list.
    call g_list_foreach(slist, c_funloc(gtk_tree_path_free), C_NULL_PTR)
    call g_list_free(slist)

  end function hl_gtk_tree_get_selections

  !+
  subroutine hl_gtk_tree_set_cell(tree, row, col, absrow, &
       & svalue, fvalue, dvalue, ivalue, lvalue, l64value, &
       & logvalue, i8value, pbvalue)

    type(c_ptr), intent(in) :: tree
    integer(c_int), intent(in), optional :: absrow, col
    integer(c_int), intent(in), optional, dimension(:) :: row
    character(len=*), intent(in), optional :: svalue
    real(c_float), intent(in), optional :: fvalue
    real(c_double), intent(in), optional :: dvalue
    integer(c_int), intent(in), optional :: ivalue
    integer(c_long), intent(in), optional :: lvalue
    integer(c_int64_t), intent(in), optional :: l64value
    logical, intent(in), optional :: logvalue
    integer(c_int8_t), intent(in), optional :: i8value
    type(c_ptr), intent(in), optional :: pbvalue

    ! Set the value of a cell.
    !
    ! TREE |  c_ptr |  required |  The tree containing the cell.
    ! ROW |  c_int() |  optional |  The row of the cell
    ! COL |  c_int |  optional |  The column of the cell, (Only optional to allow format similar to the LISTs).
    ! ABSROW |  c_int |  optional |  The row, treating the tree as a flat list.
    ! SVALUE |  string |  optional |  A string value for the cell.
    ! FVALUE |  float |  optional |  A single precision FP value for the cell.
    ! DVALUE |  double |  optional |  A double precision FP value for the cell.
    ! IVALUE |  c_int |  optional |  A normal integer value for the cell.
    ! LVALUE |  c_long |  optional |  A long integer value for the cell.
    ! L64VALUE |  c_int64_t |  optional |  A 64-bit integer value for the cell.
    ! LOGVALUE |  logical |  optional |  A logical value for the cell.
    ! I8VALUE |  int8_t |  optional |  An 8-bit integer value for the cell.
    ! PBVALUE |  c_ptr |  optional |  A pixbuf pointer value for the cell.
    !
    ! Note that reasonable conversions are made between types.
    !-

    integer(type_kind) :: ctype
    type(c_ptr) :: store, val
    integer(c_int) :: valid, icol
    type(gtktreeiter), target :: iter
    type(gvalue), target :: value

    ! Get tree store
    store = gtk_tree_view_get_model(tree)

    if (present(col)) then
       icol=col
    else
       icol=0
    end if

    ! Find the type for the requested column
    ctype = gtk_tree_model_get_column_type(store, icol)

    ! Get the iterator of the row
    if (present(row)) then
       valid = hl_gtk_tree_row_iter(C_NULL_PTR, iter, row, model=store)
    else if (present(absrow)) then
       valid = hl_gtk_tree_abs_iter(C_NULL_PTR, iter, absrow, model=store)
    else
       valid=FALSE
       return
    end if

    if (valid == FALSE) return

    ! Set up the GValue to the right type.
    val = c_loc(value)

    call hl_gtk_list_tree_set_gvalue(val, ctype, svalue=svalue, fvalue=fvalue, &
         & dvalue=dvalue, ivalue=ivalue, lvalue=lvalue, l64value=l64value, &
         & logvalue=logvalue, i8value=i8value, pbvalue=pbvalue)

    call gtk_tree_store_set_value(store, c_loc(iter), icol, val)

  end subroutine hl_gtk_tree_set_cell

  !+
  subroutine hl_gtk_tree_get_cell(tree, row, col, absrow, &
       & svalue, fvalue, dvalue, ivalue, lvalue, l64value, logvalue, &
       & i8value, pbvalue)

    type(c_ptr), intent(in) :: tree
    integer(c_int), intent(in), optional :: absrow, col
    integer(c_int), intent(in), optional, dimension(:) :: row
    character(len=*), intent(out), optional :: svalue
    real(c_float), intent(out), optional :: fvalue
    real(c_double), intent(out), optional :: dvalue
    integer(c_int), intent(out), optional :: ivalue
    integer(c_long), intent(out), optional :: lvalue
    integer(c_int64_t), intent(out), optional :: l64value
    logical, intent(out), optional :: logvalue
    integer(c_int8_t), intent(out), optional :: i8value
    type(c_ptr), intent(out), optional :: pbvalue

    ! Retrieve the value of a cell.
    !
    ! TREE |  c_ptr |  required |  The tree containing the cell.
    ! ROW |  c_int() |  optional |  The row of the cell
    ! COL |  c_int |  optional |  The column of the cell. (Only optional to allow format similar to the LISTs i.e. tree, row, column).
    ! ABSROW |  c_int |  optional |  The row of the cell, treating the tree as a flat list.
    ! SVALUE |  string |  optional |  A string value from the cell.
    ! FVALUE |  float |  optional |  A single precision FP value from the cell.
    ! DVALUE |  double |  optional |  A double precision FP value from the cell.
    ! IVALUE |  c_int |  optional |  A normal integer value from the cell.
    ! LVALUE |  c_long |  optional |  A long integer value from the cell.
    ! L64VALUE |  c_int64_t |  optional |  A 64-bit integer value from the cell.
    ! LOGVALUE |  logical  |  optional |  A logical value from the cell.
    ! I8VALUE |  int8_t |  optional |  An 8-bit integer value from the cell.
    ! PBVALUE |  c_ptr |  optional |  A pixbuf pointer from the cell.
    !
    ! Note that a similar conversion system to the set_cell routine
    ! except that strings can only be returned to SVALUE.
    !-

    integer(type_kind) :: ctype
    type(c_ptr) :: store, val
    integer(c_int) :: valid, icol
    type(gtktreeiter), target :: iter
    type(gvalue), target :: value

    if (present(col)) then
       icol=col
    else
       icol=0
    end if

    ! Get tree store
    store = gtk_tree_view_get_model(tree)

    ! Find the type for the requested column
    ctype = gtk_tree_model_get_column_type(store, icol)

    ! Get the iterator of the row
    if (present(row)) then
       valid = hl_gtk_tree_row_iter(C_NULL_PTR, iter, row, model=store)
    else if (present(absrow)) then
       valid = hl_gtk_tree_abs_iter(C_NULL_PTR, iter, absrow, model=store)
    else
       valid = FALSE
    end if
    if (valid == FALSE) return

    ! Set up the GValue pointer (for convenience) gtk_tree_model_get_value
    ! does the initialization.
    val = c_loc(value)

    ! Get the GValue of the cell.
    call gtk_tree_model_get_value(store, c_loc(iter), icol, val)

    ! Now extract the value to a useful form according to the type
    ! of cell.
    call hl_gtk_list_tree_get_gvalue(val, ctype, &
         & svalue=svalue, fvalue=fvalue, dvalue=dvalue, ivalue=ivalue, &
         & lvalue=lvalue, l64value=l64value, logvalue=logvalue, &
         & i8value=i8value, pbvalue=pbvalue)

  end subroutine hl_gtk_tree_get_cell

  !+
  subroutine hl_gtk_listn_combo_set_select(view, row, colno, selection)
    type(c_ptr), intent(in) :: view
    integer(c_int), intent(in) :: row, colno, selection

    ! Set the selected item in a combo cell renderer.
    !
    ! VIEW |  c_ptr |  required |  The list view containing the cell.
    ! ROW |  int |  required |  The row number of the cell
    ! COLNO |  int |  required |  The column number with the cell
    ! SELECTION |  int |  required |  The element of the combo to set.
    !-

    type(c_ptr) :: store, pstring, col, rlist, renderer, pmodel, model
    type(gvalue), target :: stringv, modelv
    type(gtktreeiter), target :: viter, citer
    integer(c_int) :: valid

    ! Get list store
    store = gtk_tree_view_get_model(view)

    ! Get the iterator of the row
    call clear_gtktreeiter(viter)
    valid = gtk_tree_model_iter_nth_child(store, c_loc(viter), C_NULL_PTR, row)
    if (.not. c_f_logical(valid)) return

    ! Find the renderer for the column
    col = gtk_tree_view_get_column(view, colno)
    rlist = gtk_cell_layout_get_cells(col)
    renderer = g_list_nth_data(rlist, 0_c_int)
    call g_list_free(rlist)

    ! Find the model for the combobox
    pmodel = c_loc(modelv)
    pmodel = g_value_init(pmodel, gtk_tree_model_get_type())
    call g_object_get_property(renderer, "model"//c_null_char, pmodel)
    model = g_value_get_object(pmodel)

    call clear_gtktreeiter(citer)
    valid = gtk_tree_model_iter_nth_child(model, c_loc(citer), &
         & c_null_ptr, selection)
    if (c_f_logical(valid)) then
       pstring = c_loc(stringv)
       pstring = g_value_init(pstring, G_TYPE_STRING)
       call g_value_unset(pstring)
       call gtk_tree_model_get_value(model, c_loc(citer), 0_c_int, pstring)
       call gtk_list_store_set_value(store, c_loc(viter), colno, pstring)
    end if
  end subroutine hl_gtk_listn_combo_set_select
  !+
  subroutine hl_gtk_tree_combo_set_select(view, row, colno, absrow, selection)
    type(c_ptr), intent(in) :: view
    integer(c_int), dimension(:), intent(in), optional :: row
    integer(c_int), intent(in), optional ::  colno, absrow, selection

    ! Set the selected item in a combo cell renderer.
    !
    ! VIEW |  c_ptr |  required |  The list view containing the cell.
    ! ROW |  int() |  optional |  The row number of the cell
    ! COLNO |  int |  optional |  The column number with the cell (Only optional to allow format similar to the LISTs).
    ! ABSROW |  c_int |  optional |  The row, treating the tree as a flat list.
    ! SELECTION |  int |  required |  The element of the combo to set.
    !-

    type(c_ptr) :: store, pstring, col, rlist, renderer, pmodel, model
    type(gvalue), target :: modelv
    type(gtktreeiter), target :: viter, citer
    integer(c_int) :: valid

    ! Get list store
    store = gtk_tree_view_get_model(view)

    ! Get the iterator of the row
    if (present(row)) then
       valid = hl_gtk_tree_row_iter(C_NULL_PTR, viter, row, model=store)
    else if (present(absrow)) then
       valid = hl_gtk_tree_abs_iter(C_NULL_PTR, viter, absrow, model=store)
    else
       valid=FALSE
    end if
    if (.not. c_f_logical(valid)) return

    ! Find the renderer for the column
    col = gtk_tree_view_get_column(view, colno)
    rlist = gtk_cell_layout_get_cells(col)
    renderer = g_list_nth_data(rlist, 0_c_int)
    call g_list_free(rlist)

    ! Find the model for the combobox
    pmodel = c_loc(modelv)
    pmodel = g_value_init(pmodel, gtk_tree_model_get_type())
    call g_object_get_property(renderer, "model"//c_null_char, pmodel)
    model = g_value_get_object(pmodel)

    call clear_gtktreeiter(citer)
    valid = gtk_tree_model_iter_nth_child(model, c_loc(citer), &
         & c_null_ptr, selection)
    if (c_f_logical(valid)) then
       call g_value_unset(pstring)
       pstring = g_value_init(pstring, G_TYPE_STRING)
       call gtk_tree_model_get_value(model, c_loc(citer), 0_c_int, pstring)
       call gtk_list_store_set_value(store, c_loc(viter), colno, pstring)
    end if
  end subroutine hl_gtk_tree_combo_set_select

  ! ================================================================
  ! Default Callback routines for editable cells in lists & trees
  !=================================================================

  !+
  subroutine hl_gtk_listn_edit_cb(renderer, path, text, gdata) bind(c)
    type(c_ptr), value :: renderer, path, text, gdata
    ! Default callback for list cell edited.
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! TEXT |  c_ptr |  required |  The text to insert
    ! GDATA |  c_ptr |  required |  User data, Not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    ! This routine is not normally called by the application developer.
    !-

    character(len=200) :: fpath, ftext
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    type(c_ptr) :: pcol, list

    call convert_c_string(path, fpath)
    read(fpath, *) irow
    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)
    call convert_c_string(text, ftext)
    list = g_object_get_data(renderer, "view"//c_null_char)
    call hl_gtk_listn_set_cell(list, irow, icol, &
         & svalue=trim(ftext))
  end subroutine hl_gtk_listn_edit_cb

  !+
  subroutine hl_gtk_listn_toggle_cb(renderer, path, gdata) bind(c)
    type(c_ptr), value :: renderer, path, gdata

    ! Default call back for a toggle button in a list
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! GDATA |  c_ptr |  required |  User data, Not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    ! This routine is not normally called by the application developer.
    !-
    character(len=200) :: fpath
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    type(c_ptr) :: pcol, list
    logical :: state

    call convert_c_string(path, fpath)
    read(fpath, *) irow

    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)

    list = g_object_get_data(renderer, "view"//c_null_char)
    state = c_f_logical(gtk_cell_renderer_toggle_get_active(renderer))
    call hl_gtk_listn_set_cell(list, irow, icol, &
         & logvalue= .not. state)
  end subroutine hl_gtk_listn_toggle_cb

  !+
  subroutine hl_gtk_listn_rtoggle_cb(renderer, path, gdata) bind(c)
    type(c_ptr), value :: renderer, path, gdata

    ! Default callback for a toggle button in a list
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! GDATA |  c_ptr |  required |  User data, Not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    ! This routine is not normally called by the application developer.
    !-
    character(len=200) :: fpath
    integer(c_int) :: irow
    integer(c_int), pointer :: icol
    integer(c_int) :: i
    type(c_ptr) :: pcol, list
    logical :: state
    integer(c_int) :: nrows

    call convert_c_string(path, fpath)
    read(fpath, *) irow

    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)

    list = g_object_get_data(renderer, "view"//c_null_char)
    state = c_f_logical(gtk_cell_renderer_toggle_get_active(renderer))
    if (state) return ! Don't act on an unset

    ! Find the first iterator
    nrows = gtk_tree_model_iter_n_children (gtk_tree_view_get_model(list), &
         & c_null_ptr)
    do i = 0,nrows-1
       call hl_gtk_listn_set_cell(list, i, icol, &
            & logvalue= i == irow)
    end do
  end subroutine hl_gtk_listn_rtoggle_cb

  !+
  subroutine hl_gtk_tree_edit_cb(renderer, path, text, gdata) bind(c)
    type(c_ptr), value :: renderer, path, text, gdata

    ! Default callback for tree cell edited.
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! TEXT |  c_ptr |  required |  The text to insert
    ! GDATA |  c_ptr |  required |  User data, not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    !
    ! This routine is not normally called by the application developer.
    !-

    character(len=200) :: fpath, ftext
    integer(c_int), allocatable, dimension(:) :: irow
    integer(c_int), pointer :: icol
    integer :: i, n
    type(c_ptr) :: tree, pcol

    call convert_c_string(path, fpath)
    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)
    call convert_c_string(text, ftext)

    n = 0
    do i = 1, len_trim(fpath)
       if (fpath(i:i) == ":") then
          n = n+1
          fpath(i:i) = ' '   ! : is not a separator for a Fortran read
       end if
    end do
    allocate(irow(n+1))
    read(fpath, *) irow
    tree = g_object_get_data(renderer, "view"//c_null_char)

    call hl_gtk_tree_set_cell(tree, irow, icol, &
         & svalue=trim(ftext))

    deallocate(irow)
  end subroutine hl_gtk_tree_edit_cb

  !+
  subroutine hl_gtk_tree_toggle_cb(renderer, path, gdata) bind(c)
    type(c_ptr), value :: renderer, path, gdata

    ! Default call back for a toggle button in a tree
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! GDATA |  c_ptr |  required |  User data, Not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    ! This routine is not normally called by the application developer.
    !-
    character(len=200) :: fpath
    integer(c_int), allocatable, dimension(:) :: irow
    integer(c_int), pointer :: icol
    integer :: i, n
    type(c_ptr) :: pcol, tree
    logical :: state

    call convert_c_string(path, fpath)
    n = 0
    do i = 1, len_trim(fpath)
       if (fpath(i:i) == ":") then
          n = n+1
          fpath(i:i) = ' '   ! : is not a separator for a Fortran read
       end if
    end do
    allocate(irow(n+1))
    read(fpath, *) irow

    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)

    tree = g_object_get_data(renderer, "view"//c_null_char)

    state = c_f_logical(gtk_cell_renderer_toggle_get_active(renderer))
    call hl_gtk_tree_set_cell(tree, irow, icol, &
         & logvalue= .not. state)
  end subroutine hl_gtk_tree_toggle_cb
  !+
  subroutine hl_gtk_tree_rtoggle_cb(renderer, path, gdata) bind(c)
    type(c_ptr), value :: renderer, path, gdata

    ! Default call back for a toggle button in a tree with the radio
    ! option set.
    !
    ! RENDERER |  c_ptr |  required |  The renderer which sent the signal
    ! PATH |  c_ptr |  required |  The path at which to insert
    ! GDATA |  c_ptr |  required |  User data, Not used.
    !
    ! The column number is passed via the "column-number" gobject data value.
    ! The treeview containing the cell is passed via the "view" gobject
    ! data value.
    ! The row number is passed as a string in the PATH argument.
    ! This routine is not normally called by the application developer.
    ! The routine clears the settings on all buttons at the same level as
    ! the button that was pressed.
    !-
    character(len=200) :: fpath
    integer(c_int), allocatable, dimension(:) :: irow, jrow
    integer(c_int), pointer :: icol
    integer :: i, n
    type(c_ptr) :: pcol, tree, ipath, tree_model
    logical :: state
    type(gtktreeiter), target :: iter, piter
    integer(c_int) :: valid

    call convert_c_string(path, fpath)
    n = 0
    do i = 1, len_trim(fpath)
       if (fpath(i:i) == ":") then
          n = n+1
          fpath(i:i) = ' '   ! : is not a separator for a Fortran read
       end if
    end do
    allocate(irow(n+1))
    read(fpath, *) irow

    pcol = g_object_get_data(renderer, "column-number"//c_null_char)
    call c_f_pointer(pcol, icol)

    tree = g_object_get_data(renderer, "view"//c_null_char)
    tree_model = gtk_tree_view_get_model(tree)

    state = c_f_logical(gtk_cell_renderer_toggle_get_active(renderer))
    if (state) return ! Don't act on a release of a selected toggle

    ! Clear all the siblings of the chosen
    valid = gtk_tree_model_get_iter_from_string(tree_model, c_loc(iter), fpath)
    valid = gtk_tree_model_iter_parent (tree_model, c_loc(piter), c_loc(iter))
    call clear_gtktreeiter(iter)
    if (c_f_logical(valid)) then
       valid = gtk_tree_model_iter_children (tree_model, c_loc(iter),&
            & c_loc(piter))
    else
       valid = gtk_tree_model_iter_children (tree_model, c_loc(iter),&
            & c_null_ptr)
    end if

    do
       ipath = gtk_tree_model_get_string_from_iter (tree_model, c_loc(iter))
       call convert_c_string(ipath, fpath)
       n = 0
       do i = 1, len_trim(fpath)
          if (fpath(i:i) == ":") then
             n = n+1
             fpath(i:i) = ' '   ! : is not a separator for a Fortran read
          end if
       end do
       allocate(jrow(n+1))
       read(fpath, *) jrow
       call hl_gtk_tree_set_cell(tree, jrow, icol, logvalue=.false.)
       deallocate(jrow)
       valid = gtk_tree_model_iter_next (tree_model, c_loc(iter))
       if (.not. c_f_logical(valid)) exit
    end do
    call hl_gtk_tree_set_cell(tree, irow, icol, &
         & logvalue= .true.)
  end subroutine hl_gtk_tree_rtoggle_cb


  ! ================================================================
  ! The routines from here to the end are, private subroutines that
  ! are used to prevent excessive code duplication between lists
  ! and trees.
  ! ================================================================

  !+
  subroutine hl_gtk_list_tree_set_cell_data_func(list, colno, func, &
       & data, destroy_notify)

    type(c_ptr), intent(in) :: list
    integer(c_int), intent(in) :: colno
    type(c_funptr), optional :: func
    type(c_ptr), optional :: data
    type(c_funptr), optional :: destroy_notify

    ! Add a custom rendering function to a column of a list or tree
    !
    ! LIST |  c_ptr |  required |  The list to which to apply the rendering function
    ! COLNO |  c_int |  required |  The column index to which to apply it.
    ! FUNC |  c_funptr |  optional |  The function (actually subroutine) to do the rendering (see GtkTreeCellDataFunc, for details). Omit or set to C_NULL_FUNPTR to remove a function.
    ! DATA |  c_ptr |  optional |  User data to pass to the function.
    ! DESTROY_NOTIFY |  c_funptr |  optional |  A destroy notify subroutine.
    !
    ! This routine is always accessed by one of the interfaces,
    ! hl_gtk_tree_set_cell_data_func or hl_gtk_listn_set_cell_data_func.
    !-

    type(c_funptr) :: funpass, destpass
    type(c_ptr) :: datapass

    type(c_ptr) :: col, renderer, rlist

    if (present(func)) then
       funpass = func
    else
       funpass = C_NULL_FUNPTR
    end if

    if (present(data)) then
       datapass = data
    else
       datapass = C_NULL_PTR
    end if

    if (present(destroy_notify)) then
       destpass = destroy_notify
    else
       destpass = C_NULL_FUNPTR
    end if

    col = gtk_tree_view_get_column(list, colno)
    rlist = gtk_cell_layout_get_cells(col)
    renderer = g_list_nth_data(rlist, 0_c_int)
    call g_list_free(rlist)

    call gtk_tree_view_column_set_cell_data_func(col, renderer,&
         & funpass, datapass, destpass)

  end subroutine hl_gtk_list_tree_set_cell_data_func

  !+
  subroutine hl_gtk_list_tree_add_column(icol, view, is_list, type, &
       & editable, ixpad, iypad, align, titles, sortable, width,&
       & renderers, edited, data_edited, edited_text, data_edited_text, &
       & toggled, data_toggled, edited_spin, data_edited_spin, edited_combo, &
       & data_edited_combo, changed_combo, data_changed_combo, toggled_radio, &
       & data_toggled_radio)
    integer(c_int), intent(in) :: icol
    type(c_ptr), intent(in), target :: view
    logical, intent(in) :: is_list
    integer(type_kind), intent(in) :: type
    integer(c_int), dimension(:), optional, intent(in) :: editable, &
         & ixpad, iypad, sortable, width
    real(c_float), intent(in), optional, dimension(:) :: align
    character(len=*), dimension(:), intent(in), optional :: titles, renderers
    type(c_funptr), optional :: edited, edited_text, toggled, edited_spin, &
         & edited_combo, changed_combo, toggled_radio
    type(c_ptr), optional, intent(in) :: data_edited, data_edited_text, &
         & data_toggled, data_edited_spin, data_edited_combo, &
         & data_changed_combo, data_toggled_radio

    ! Add a column to a list or tree view. (private)
    !
    ! ICOL |  int |  required |  The column number
    ! VIEW |  c_ptr |  required |  The list or tree view to modify
    ! IS_LIST |  logical |  required |  .true. for a list, .false. for a tree.
    !
    ! The optional arguments are identical to the corresponding arguments in
    ! hl_gtk_listn_new and hl_gtk_tree_new.
    !
    ! This routine is not called by the application developer, but exists to
    ! reduce code duplication.
    !-

    type(c_ptr) :: renderer, column
    integer(c_int), pointer :: coldat
    type(gvalue), target :: isedit, adjval, crate
    type(c_ptr) :: pisedit, padjval, pcrate
    integer(c_int) :: nc
    character(len=20) :: render_id
    character(len=16) :: editable_property
    type(c_ptr) :: adjust

    if (present(renderers)) then
       render_id = renderers(icol)
    else
       render_id = hl_gtk_cell_text
    end if

    select case (render_id)
    case(hl_gtk_cell_text)
       renderer = gtk_cell_renderer_text_new()
       editable_property = "editable"//c_null_char

    case(hl_gtk_cell_toggle)
       renderer = gtk_cell_renderer_toggle_new()
       editable_property = "activatable"//c_null_char

    case(hl_gtk_cell_radio)
       renderer = gtk_cell_renderer_toggle_new()
       call gtk_cell_renderer_toggle_set_radio(renderer, TRUE)
       editable_property = "activatable"//c_null_char

    case(hl_gtk_cell_spin)
       renderer = gtk_cell_renderer_spin_new()
       ! We make the adjustment with default parameters, these can be
       ! adjusted with hl_gtk_listn_config_spin or hl_gtk_tree_config_spin.
       adjust = gtk_adjustment_new(0._c_double, 0._c_double, 1._c_double, &
            & 0.01_c_double, 0.1_c_double, 0._c_double)
       padjval = c_loc(adjval)
       padjval = g_value_init(padjval, G_TYPE_OBJECT)
       call g_value_take_object(padjval, adjust)
       call g_object_set_property(renderer, "adjustment"//c_null_char, &
            & padjval)
       editable_property = "editable"//c_null_char

       pcrate = c_loc(crate)
       pcrate = g_value_init(pcrate, G_TYPE_DOUBLE)
       call g_value_set_double(pcrate, 1.0_c_double)
       call g_object_set_property(renderer, "climb-rate"//c_null_char, &
            & pcrate)

    case(hl_gtk_cell_progress)
       renderer = gtk_cell_renderer_progress_new()
       editable_property = ""

    case(hl_gtk_cell_pixbuf)
       renderer = gtk_cell_renderer_pixbuf_new()
       editable_property = ""

    case(hl_gtk_cell_combo)
       renderer = gtk_cell_renderer_combo_new()
       call hl_gtk_list_tree_combo_model_attach(renderer)
       editable_property = "editable"//c_null_char

    case(hl_gtk_cell_spinner)
       write(error_unit, *) "hl_gtk_list_tree_add_column: "//&
            & "Renderer type ",trim(render_id)," not yet implemented"
       return

    case default
       write(error_unit, *) "hl_gtk_list_tree_add_column: "//&
            & "Renderer type ",trim(render_id)," is not valid."
       return
    end select

    if (present(ixpad) .and. present(iypad)) then
       call gtk_cell_renderer_set_padding(renderer, &
            & ixpad(icol), iypad(icol))
    else if (present(ixpad)) then
       call gtk_cell_renderer_set_padding(renderer, &
            & ixpad(icol), 0_c_int)
    else if (present(iypad)) then
       call gtk_cell_renderer_set_padding(renderer, &
            & 0_c_int, iypad(icol))
    end if

    if (present(editable) .and. editable_property /= '') then
       pisedit = c_loc(isedit)
       pisedit = g_value_init(pisedit, G_TYPE_BOOLEAN)
       call g_value_set_boolean(pisedit, editable(icol))
       call g_object_set_property(renderer, editable_property, pisedit)

       if (editable(icol) == TRUE) then
          allocate(coldat)
          coldat = icol-1
          call g_object_set_data(renderer, "column-number"//c_null_char, &
               & c_loc(coldat))

          call g_object_set_data(renderer, "view"//c_null_char, view)

          select case (render_id)
          case (hl_gtk_cell_text)
             if (present(edited_text)) then
                if (present(data_edited_text)) then
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited_text, data_edited_text)
                else
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited_text)
                end if
             else if (present(edited)) then
                if (present(data_edited)) then
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited, data_edited)
                else
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited)
                end if
             else if (is_list) then
                call g_signal_connect(renderer, "edited"//c_null_char, &
                     & c_funloc(hl_gtk_listn_edit_cb))
             else
                call g_signal_connect(renderer, "edited"//c_null_char, &
                     & c_funloc(hl_gtk_tree_edit_cb))
             endif

          case (hl_gtk_cell_toggle)
             if (present(toggled)) then
                if (present(data_toggled)) then
                   call g_signal_connect(renderer, "toggled"//c_null_char, &
                        & toggled, data_toggled)
                else
                   call g_signal_connect(renderer, "toggled"//c_null_char, &
                        & toggled)
                end if
             else if (is_list) then
                call g_signal_connect(renderer, "toggled"//c_null_char, &
                     & c_funloc(hl_gtk_listn_toggle_cb))
             else
                call g_signal_connect(renderer, "toggled"//c_null_char, &
                     & c_funloc(hl_gtk_tree_toggle_cb))
             end if

          case (hl_gtk_cell_radio)
             if (present(toggled_radio)) then
                if (present(data_toggled_radio)) then
                   call g_signal_connect(renderer, "toggled"//c_null_char, &
                        & toggled_radio, data_toggled_radio)
                else
                   call g_signal_connect(renderer, "toggled"//c_null_char, &
                        & toggled_radio)
                end if
             else if (is_list) then
                call g_signal_connect(renderer, "toggled"//c_null_char, &
                     & c_funloc(hl_gtk_listn_rtoggle_cb))
             else
                call g_signal_connect(renderer, "toggled"//c_null_char, &
                     & c_funloc(hl_gtk_tree_rtoggle_cb))
             end if

          case (hl_gtk_cell_spin)
             if (present(edited_spin)) then
                if (present(data_edited_spin)) then
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited_spin, data_edited_spin)
                else
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited_spin)
                end if
             else if (present(edited)) then
                if (present(data_edited)) then
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited, data_edited)
                else
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited)
                end if
             else if (is_list) then
                call g_signal_connect(renderer, "edited"//c_null_char, &
                     & c_funloc(hl_gtk_listn_edit_cb))
             else
                call g_signal_connect(renderer, "edited"//c_null_char, &
                     & c_funloc(hl_gtk_tree_edit_cb))
             endif

          case(hl_gtk_cell_combo)
             if (present(edited_combo)) then
                if (present(data_edited_combo)) then
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited_combo, data_edited_combo)
                else
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited_combo)
                end if
             else if (present(edited)) then
                if (present(data_edited)) then
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited, data_edited)
                else
                   call g_signal_connect(renderer, "edited"//c_null_char, &
                        & edited)
                end if
             else if (is_list) then
                call g_signal_connect(renderer, "edited"//c_null_char, &
                     & c_funloc(hl_gtk_listn_edit_cb))
             else
                call g_signal_connect(renderer, "edited"//c_null_char, &
                     & c_funloc(hl_gtk_tree_edit_cb))
             endif
             if (present(changed_combo)) then
                if (present(data_changed_combo)) then
                   call g_signal_connect(renderer, "changed"//c_null_char, &
                        & changed_combo, data_changed_combo)
                else
                   call g_signal_connect(renderer, "changed"//c_null_char, &
                        & changed_combo)
                end if
             end if

          case(hl_gtk_cell_pixbuf, hl_gtk_cell_progress, hl_gtk_cell_spinner)
             write(error_unit,*) "hl_gtk_list_tree_add_column: "//&
                  & "Column type ", trim(render_id), &
                  & "cannot be editable."

          case default
             write(error_unit,*) "Invalid renderer type"
          end select
       end if
    end if

    if (present(align)) then
       call gtk_cell_renderer_set_alignment(renderer, align(icol), 0.)
    else if (type == G_TYPE_STRING) then
       call gtk_cell_renderer_set_alignment(renderer, 0., 0.)
    else
       call gtk_cell_renderer_set_alignment(renderer, 1., 0.)
    end if

    column = gtk_tree_view_column_new()
    call gtk_tree_view_column_pack_start(column, renderer, FALSE)

    if (present(titles)) call gtk_tree_view_column_set_title(column, &
         &trim(titles(icol))//c_null_char)

    select case (render_id)
    case(hl_gtk_cell_text, hl_gtk_cell_spin)
       call gtk_tree_view_column_add_attribute(column, renderer, &
            & "text"//C_NULL_CHAR, icol-1_c_int)
    case(hl_gtk_cell_toggle, hl_gtk_cell_radio)
       call gtk_tree_view_column_add_attribute(column, renderer, &
            & "active"//C_NULL_CHAR, icol-1_c_int)
    case(hl_gtk_cell_progress)
       call gtk_tree_view_column_add_attribute(column, renderer, &
            & "value"//c_null_char, icol-1_c_int)
       call gtk_tree_view_column_add_attribute(column, renderer, &
            & "text"//C_NULL_CHAR, icol-1_c_int)
    case(hl_gtk_cell_pixbuf)
       call gtk_tree_view_column_add_attribute(column, renderer, &
            & "pixbuf"//c_null_char, icol-1_c_int)
    case(hl_gtk_cell_combo)
       call gtk_tree_view_column_add_attribute(column, renderer, &
            & "text"//c_null_char, icol-1_c_int)
    end select

    nc = gtk_tree_view_append_column(view, column)
    if (present(sortable)) then
       if (sortable(icol) == TRUE) then
          call gtk_tree_view_column_set_sort_column_id(column, icol-1_c_int)
          call gtk_tree_view_column_set_sort_indicator(column, TRUE)
       end if
    end if
    if (present(width)) then
       if (width(icol) > 0) then
          call gtk_tree_view_column_set_sizing (column, &
               & GTK_TREE_VIEW_COLUMN_FIXED)
          call gtk_tree_view_column_set_fixed_width(column, width(icol))
          call gtk_cell_renderer_set_fixed_size(renderer, width(icol), &
               & -1_c_int)
       end if
    end if
    call gtk_tree_view_column_set_resizable(column,TRUE)

  end subroutine hl_gtk_list_tree_add_column

  !+
  subroutine hl_gtk_list_tree_set_gvalue(val, ctype, svalue, fvalue, dvalue, &
       & ivalue, lvalue, l64value, logvalue, i8value, pbvalue)
    type(c_ptr), intent(inout) :: val
    integer(type_kind) :: ctype
    character(len=*), intent(in), optional :: svalue
    real(c_float), intent(in), optional :: fvalue
    real(c_double), intent(in), optional :: dvalue
    integer(c_int), intent(in), optional :: ivalue
    integer(c_long), intent(in), optional :: lvalue
    integer(c_int64_t), intent(in), optional :: l64value
    logical, intent(in), optional :: logvalue
    integer(c_int8_t), intent(in), optional :: i8value
    type(c_ptr), intent(in), optional :: pbvalue

    ! Set a gvalue to the appropriate type and value to set a list or
    ! tree cell. (private)
    !
    ! VAL |  c_ptr |  required |  The C address of the gvalue.
    ! CTYPE |  int(kind_type)  |  required |  The type of the cell.
    !
    ! The optional arguments are the same as for the set_cell routines.
    !-

    character(len=120) :: sconv
    integer(c_int) :: iconv
    integer(c_long) :: lconv
    integer(c_int64_t) :: l64conv
    real(c_float) :: fconv
    real(c_double) :: dconv
    integer :: ios

    val = g_value_init(val, ctype)

    ! Select according to the cell type
    select case(ctype)
    case(G_TYPE_CHAR)
       if (present(svalue)) then
          call g_value_set_schar(val, int(ichar(svalue(1:1)), c_int8_t))
       else if (present(i8value)) then
          call g_value_set_schar(val, i8value)
       else if (present(ivalue)) then
          call g_value_set_schar(val, int(ivalue, c_int8_t))
       else if (present(lvalue)) then
          call g_value_set_schar(val, int(lvalue, c_int8_t))
       else if (present(l64value)) then
          call g_value_set_schar(val, int(l64value, c_int8_t))
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make a 'char' type from given value(s)"
          return
       end if
    case(G_TYPE_UCHAR)
       if (present(svalue)) then
          call g_value_set_uchar(val, int(ichar(svalue(1:1)), c_int8_t))
       else if (present(i8value)) then
          call g_value_set_uchar(val, int(i8value, c_int8_t))
       else if (present(ivalue)) then
          call g_value_set_uchar(val, int(ivalue, c_int8_t))
       else if (present(lvalue)) then
          call g_value_set_uchar(val, int(lvalue, c_int8_t))
       else if (present(l64value)) then
          call g_value_set_uchar(val, int(l64value, c_int8_t))
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make a 'uchar' type from given value(s)"
          return
       end if

    case (G_TYPE_INT)
       if (present(ivalue)) then
          call g_value_set_int(val, ivalue)
       else if (present(lvalue)) then
          call g_value_set_int(val, int(lvalue, c_int))
       else if (present(l64value)) then
          call g_value_set_int(val, int(l64value, c_int))
       else if (present(i8value)) then
          call g_value_set_int(val, int(i8value, c_int))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) iconv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "// &
                  & "Failed to convert string to 'int'"
             return
          end if
          call g_value_set_int(val, iconv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "// &
               & "Cannot make an 'int' type from given value(s)"
          return
       end if
    case (G_TYPE_UINT)
       if (present(ivalue)) then
          call g_value_set_uint(val, ivalue)
       else if (present(lvalue)) then
          call g_value_set_uint(val, int(lvalue, c_int))
       else if (present(l64value)) then
          call g_value_set_uint(val, int(l64value, c_int))
       else if (present(i8value)) then
          call g_value_set_uint(val, int(i8value, c_int))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) iconv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'uint'"
             return
          end if
          call g_value_set_uint(val, iconv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "// &
               & "Cannot make an 'uint' type from given value(s)"
          return
       end if
    case (G_TYPE_BOOLEAN)
       if (present(logvalue)) then
          call g_value_set_boolean(val, f_c_logical(logvalue))
       else if (present(i8value)) then
          call g_value_set_boolean(val, int(i8value, c_int))
       else if (present(ivalue)) then
          call g_value_set_boolean(val, ivalue)
       else if (present(lvalue)) then
          call g_value_set_boolean(val, int(lvalue, c_int))
       else if (present(l64value)) then
          call g_value_set_boolean(val, int(l64value, c_int))
       else if (present(svalue)) then
          if (svalue=='T' .or. svalue=='t' .or. svalue=='TRUE' .or. &
               & svalue=='true' .or. svalue=='True' .or. svalue=='Y' &
               & .or. svalue=='y' .or. svalue=='YES' .or. svalue=='yes' &
               & .or. svalue=='Yes' .or. svalue=='.TRUE.' .or. &
               & svalue=='.true.') then
             call g_value_set_boolean(val, TRUE)
          else if (svalue=='F' .or. svalue=='f' .or. svalue=='FALSE' .or. &
               & svalue=='false' .or. svalue=='False' .or. svalue=='N' .or. &
               & svalue=='n' .or. svalue=='NO' .or. svalue=='no' .or. &
               & svalue=='No' .or. svalue=='.FALSE.' .or. &
               & svalue=='.false.') then
             call g_value_set_boolean(val, FALSE)
          else
             read(svalue,*,iostat=ios) iconv
             if (ios /= 0) then
                write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                     & "Failed to convert string to 'int'"
                return
             end if
             call g_value_set_boolean(val, iconv)
          end if
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "// &
               & "Cannot make an 'int' type from given value(s)"
          return
       end if

    case (G_TYPE_LONG)
       if (present(lvalue)) then
          call g_value_set_long(val, lvalue)
       else if (present(l64value)) then
          call g_value_set_long(val, int(l64value, c_long))
       else if (present(ivalue)) then
          call g_value_set_long(val, int(ivalue, c_long))
       else if (present(i8value)) then
          call g_value_set_long(val, int(i8value, c_long))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) lconv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'long'"
             return
          end if
          call g_value_set_long(val, lconv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make a 'long' type from given value(s)"
          return
       end if
    case (G_TYPE_ULONG)
       if (present(lvalue)) then
          call g_value_set_ulong(val, lvalue)
       else if (present(l64value)) then
          call g_value_set_ulong(val, int(l64value, c_long))
       else if (present(ivalue)) then
          call g_value_set_ulong(val, int(ivalue, c_long))
       else if (present(i8value)) then
          call g_value_set_ulong(val, int(i8value, c_long))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) lconv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'long'"
             return
          end if
          call g_value_set_ulong(val, lconv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make a 'ulong' type from given value(s)"
          return
       end if

    case (G_TYPE_INT64)
       if (present(l64value)) then
          call g_value_set_int64(val, l64value)
       else if (present(lvalue)) then
          call g_value_set_int64(val, int(lvalue, c_int64_t))
       else if (present(ivalue)) then
          call g_value_set_int64(val, int(ivalue, c_int64_t))
       else if (present(i8value)) then
          call g_value_set_int64(val, int(i8value, c_int64_t))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) l64conv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'int64'"
             return
          end if
          call g_value_set_int64(val, l64conv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make an 'int64' type from given value(s)"
          return
       end if
    case (G_TYPE_UINT64)
       if (present(l64value)) then
          call g_value_set_uint64(val, l64value)
       else if (present(lvalue)) then
          call g_value_set_uint64(val, int(lvalue, c_int64_t))
       else if (present(ivalue)) then
          call g_value_set_uint64(val, int(ivalue, c_int64_t))
       else if (present(i8value)) then
          call g_value_set_uint64(val, int(i8value, c_int64_t))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) l64conv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'int64'"
             return
          end if
          call g_value_set_uint64(val, l64conv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make an 'int64' type from given value(s)"
          return
       end if

    case(G_TYPE_FLOAT)
       if (present(fvalue)) then
          call g_value_set_float(val, fvalue)
       else if (present(dvalue)) then
          call g_value_set_float(val, real(dvalue, c_float))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) fconv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'float'"
             return
          end if
          call g_value_set_float(val, fconv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make a 'float' type from given value(s)"
          return
       end if

    case(G_TYPE_DOUBLE)
       if (present(dvalue)) then
          call g_value_set_double(val, dvalue)
       else if (present(fvalue)) then
          call g_value_set_double(val, real(fvalue, c_double))
       else if (present(svalue)) then
          read(svalue,*,iostat=ios) dconv
          if (ios /= 0) then
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Failed to convert string to 'double'"
             return
          end if
          call g_value_set_double(val, dconv)
       else
          write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cannot make a 'double' type from given value(s)"
          return
       end if

    case (G_TYPE_STRING)
       if (present(svalue)) then
          call g_value_set_string(val, trim(svalue)//c_null_char)
       else
          if (present(ivalue)) then
             write(sconv,*) ivalue
          else if (present(i8value)) then
             write(sconv,*) i8value
          else if (present(lvalue)) then
             write(sconv,*) lvalue
          else if (present(l64value)) then
             write(sconv,*) l64value
          else if (present(fvalue)) then
             write(sconv,*) fvalue
          else if (present(dvalue)) then
             write(sconv,*) dvalue
          else if (present(logvalue)) then
             write(sconv,*) logvalue
          else
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Cannot make a 'string' type from given value(s)"
             return
          end if
          call g_value_set_string(val, trim(sconv)//c_null_char)
       end if


    case default
       if  (ctype == gdk_pixbuf_get_type()) then
          if (present(pbvalue)) then
             call g_value_set_object(val, pbvalue)
          else
             write(error_unit,*) "hl_gtk_list_tree_set_gvalue:: "//&
                  & "Cannot make a 'pixbuf' type from given value(s)"
             return
          end if
       else
          write(error_unit,*)  "hl_gtk_list_tree_set_gvalue:: "//&
               & "Cell type ",ctype," is unknown"
          return
       end if
    end select
  end subroutine hl_gtk_list_tree_set_gvalue

  !+
  subroutine hl_gtk_list_tree_get_gvalue(val, ctype, &
       & svalue, fvalue, dvalue, ivalue, lvalue, l64value, logvalue, &
       & i8value, pbvalue)
    type(c_ptr), intent(in) :: val
    integer(type_kind), intent(in) :: ctype
    character(len=*), intent(out), optional :: svalue
    real(c_float), intent(out), optional :: fvalue
    real(c_double), intent(out), optional :: dvalue
    integer(c_int), intent(out), optional :: ivalue
    integer(c_long), intent(out), optional :: lvalue
    integer(c_int64_t), intent(out), optional :: l64value
    logical, intent(out), optional :: logvalue
    integer(c_int8_t), intent(out), optional :: i8value
    type(c_ptr), intent(out), optional :: pbvalue

    ! Get the contents of a Gvalue (private)
    !
    ! VAL |  c_ptr |  required |  The GValue
    ! CTYPE |  int(type_kind) |  required |  The type of value it contains.
    !
    ! The output arguments are identical to the get_cell routines.
    !-

    type(c_ptr) ::  cstr

    select case(ctype)
    case(G_TYPE_CHAR)
       if (present(i8value)) then
          ivalue = g_value_get_schar(val)
       else if (present(svalue)) then
          svalue(1:1) = char(g_value_get_schar(val))
       else if (present(ivalue)) then
          ivalue = int(g_value_get_schar(val), c_int)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_schar(val), c_long)
       else if (present(l64value)) then
          l64value = int(g_value_get_schar(val), c_int64_t)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'char' type to any available output"
          return
       end if
    case(G_TYPE_UCHAR)
       if (present(i8value)) then
          i8value = g_value_get_uchar(val)
       else if (present(svalue)) then
          svalue(1:1)= char(g_value_get_uchar(val))
       else if (present(ivalue)) then
          ivalue = int(g_value_get_uchar(val), c_int)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_uchar(val), c_long)
       else if (present(l64value)) then
          l64value = int(g_value_get_uchar(val), c_int64_t)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "// &
               & "Cannot return 'uchar' type to any available output"
          return
       end if

    case (G_TYPE_INT)
       if (present(ivalue)) then
          ivalue = g_value_get_int(val)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_int(val), c_long)
       else if (present(l64value)) then
          l64value = int(g_value_get_int(val), c_int64_t)
       else if (present(i8value)) then
          i8value = int(g_value_get_int(val), c_int8_t)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_int(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'int' type to any available output"
          return
       end if
    case (G_TYPE_UINT)
       if (present(ivalue)) then
          ivalue = g_value_get_uint(val)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_uint(val), c_long)
       else if (present(l64value)) then
          l64value = int(g_value_get_uint(val), c_int64_t)
       else if (present(i8value)) then
          i8value = int(g_value_get_uint(val), c_int8_t)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_uint(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'int' type to any available output"
          return
       end if
    case (G_TYPE_BOOLEAN)
       if (present(logvalue)) then
          logvalue = c_f_logical(g_value_get_boolean(val))
       else if (present(i8value)) then
          i8value = int(g_value_get_boolean(val), c_int8_t)
       else if (present(ivalue)) then
          ivalue = g_value_get_boolean(val)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_boolean(val), c_long)
       else if (present(l64value)) then
          l64value = int(g_value_get_boolean(val), c_int64_t)
       else if (present(svalue)) then
          if (g_value_get_boolean(val) == TRUE) then
             svalue = 'True'
          else
             svalue='False'
          end if
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'bool' type to any available output"
          return
       end if

    case (G_TYPE_LONG)
       if (present(lvalue)) then
          lvalue = g_value_get_long(val)
       else if (present(l64value)) then
          l64value = int(g_value_get_long(val), c_int64_t)
       else if (present(ivalue)) then
          ivalue = int(g_value_get_long(val), c_int)
       else if (present(i8value)) then
          i8value = int(g_value_get_long(val), c_int8_t)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_long(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'long' type to any available output"
          return
       end if
    case (G_TYPE_ULONG)
       if (present(lvalue)) then
          lvalue = g_value_get_ulong(val)
       else if (present(l64value)) then
          l64value = int(g_value_get_ulong(val), c_int64_t)
       else if (present(ivalue)) then
          ivalue = int(g_value_get_ulong(val), c_int)
       else if (present(i8value)) then
          i8value = int(g_value_get_ulong(val), c_int8_t)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_ulong(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'long' type to any available output"
          return
       end if

    case (G_TYPE_INT64)
       if (present(l64value)) then
          l64value = g_value_get_int64(val)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_int64(val), c_long)
       else if (present(ivalue)) then
          ivalue = int(g_value_get_int64(val), c_int)
       else if (present(i8value)) then
          i8value = int(g_value_get_int64(val), c_int8_t)
       else if (present(svalue)) then
          write (svalue,*) g_value_get_int64(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'int64' type to any available output"
          return
       end if
    case (G_TYPE_UINT64)
       if (present(l64value)) then
          l64value = g_value_get_uint64(val)
       else if (present(lvalue)) then
          lvalue = int(g_value_get_uint64(val), c_long)
       else if (present(ivalue)) then
          ivalue = int(g_value_get_uint64(val), c_int)
       else if (present(i8value)) then
          i8value = int(g_value_get_uint64(val), c_int8_t)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_uint64(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'int64' type to any available output"
          return
       end if

    case(G_TYPE_FLOAT)
       if (present(fvalue)) then
          fvalue = g_value_get_float(val)
       else if (present(dvalue)) then
          dvalue = real(g_value_get_float(val), c_double)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_float(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'float' type to any available output"
          return
       end if

    case(G_TYPE_DOUBLE)
       if (present(dvalue)) then
          dvalue = g_value_get_double(val)
       else if (present(fvalue)) then
          fvalue = real(g_value_get_double(val), c_float)
       else if (present(svalue)) then
          write(svalue,*) g_value_get_double(val)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'double' type to any available output"
          return
       end if

    case (G_TYPE_STRING)
       if (present(svalue)) then
          cstr = g_value_get_string(val)
          call convert_c_string(cstr, svalue)
       else
          write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cannot return 'string' type to any available output"
       end if

    case default
       if (ctype == gdk_pixbuf_get_type()) then
          if (present(pbvalue)) then
             pbvalue = g_value_get_object(val)
          else
             write(error_unit,*) "hl_gtk_list_tree_get_gvalue:: "//&
                  & "Cannot return 'object' type to any available output"
          end if
       else
          write(error_unit,*)  "hl_gtk_list_tree_get_gvalue:: "//&
               & "Cell type ",ctype," is unknown"
          return
       end if
    end select
  end subroutine hl_gtk_list_tree_get_gvalue

  !+
  subroutine hl_gtk_list_tree_type_adjust(types, renderers)
    integer(type_kind), dimension(:), intent(inout) :: types
    character(len=*), dimension(:), intent(in) :: renderers

    ! Ensure that the types are appropriate to the renderers.
    !
    ! TYPES |  type_kind |  required |  The list of types (updated as needed)
    ! RENDERERS |  f_string() |  required |  The list of renderers.
    !-

    integer :: i, n

    n = size(types)

    do i = 1, n
       select case(renderers(i))
       case(hl_gtk_cell_text)
          if (types(i) == G_TYPE_OBJECT .or. &
               & types(i) == gdk_pixbuf_get_type()) types(i) = G_TYPE_STRING
       case(hl_gtk_cell_toggle, hl_gtk_cell_radio)
          types(i) = G_TYPE_BOOLEAN
       case(hl_gtk_cell_pixbuf)
          types(i) = gdk_pixbuf_get_type()
       case(hl_gtk_cell_spin)
          types(i) = G_TYPE_DOUBLE
       case(hl_gtk_cell_progress)
          types(i) = G_TYPE_INT
       end select
    end do
  end subroutine hl_gtk_list_tree_type_adjust

  !+
  subroutine hl_gtk_list_tree_config_spin(view, colno, vmin, vmax, &
       & step, bigstep, value, digits, rate)
    type(c_ptr), intent(in) :: view
    integer(c_int), intent(in) :: colno
    real(c_double), intent(in), optional :: vmin, vmax, step, &
         & bigstep, value
    integer(c_int), intent(in), optional :: digits
    real(c_double), intent(in), optional :: rate

    ! Set up a spin button in a list or tree.
    !
    ! VIEW |  c_ptr |  required |  The treeview containing the spin button.
    ! COLNO |  int |  required |  The column with the spin button.
    ! MIN |  double |  optional |  The minimum value for the spin button
    ! MAX |  double |  optional |  The maximum value for the spin button.
    ! STEP |  double |  optional |  The step size for the spin button.
    ! BIGSTEP |  double |  optional |  The "jump" size for the spin button (not actually very useful).
    ! VALUE |  double |  optional |  The value for the spin button.
    ! DIGITS |  int |  optional |  How many digits to show.
    ! RATE |  double |  optional |  The climb rate.
    !
    ! This routine is always called through the interfaces,
    ! hl_gtk_listn_config_spin or  hl_gtk_tree_config_spin
    !-

    type(c_ptr) :: col, rlist, renderer, adjust, padjv
    type(gvalue), target :: adjv

    padjv=c_loc(adjv)

    ! Extract the renderer
    col = gtk_tree_view_get_column(view, colno)
    rlist = gtk_cell_layout_get_cells(col)
    renderer = g_list_nth_data(rlist, 0_c_int)
    call g_list_free(rlist)

    ! Get the adjustment from the renderer.
    padjv = g_value_init(padjv, G_TYPE_OBJECT)
    call g_object_get_property(renderer, "adjustment"//c_null_char, &
         & padjv)
    adjust = g_value_get_object(padjv)
    adjust = g_object_ref(adjust)
    if (present(vmin)) call gtk_adjustment_set_lower(adjust, vmin)
    if (present(vmax)) call gtk_adjustment_set_upper(adjust, vmax)
    if (present(step)) call gtk_adjustment_set_step_increment(adjust, step)
    if (present(bigstep)) &
         & call gtk_adjustment_set_page_increment(adjust, bigstep)
    if (present(value)) call gtk_adjustment_set_value(adjust, value)

    call g_value_unset(padjv)

    if (present(digits)) then
       padjv = g_value_init(padjv, G_TYPE_UINT)
       call g_value_set_uint(padjv, digits)
       call g_object_set_property(renderer, "digits"//c_null_char, &
            & padjv)
       call g_value_unset(padjv)
    end if
    if (present(rate)) then
       padjv = g_value_init(padjv, G_TYPE_DOUBLE)
       call g_value_set_double(padjv, rate)
       call g_object_set_property(renderer, "climb-rate"//c_null_char, &
            & padjv)
       call g_value_unset(padjv)
    end if
  end subroutine hl_gtk_list_tree_config_spin

  !+
  subroutine hl_gtk_list_tree_combo_model_attach(renderer, cmodel, colno)
    type(c_ptr), intent(in) :: renderer
    type(c_ptr), intent(in), optional :: cmodel
    integer(c_int), optional, intent(in) :: colno

    ! Create a tree model suitable for a GtkCellRendererCombo and attach
    ! it to the renderer.
    !
    ! RENDERER |  c_ptr |  required |  The renderer to which the model will be attached.
    ! CMODEL |  c_ptr |  optional |  A custom model for the combobox
    ! COLNO |  int |  optional |  Which column of the custom model contains the text.
    !
    ! This routine is automatically called by the list/tree constructor if needed.
    ! To explicitly set a different model, use one of its aliases
    ! hl_gtk_listn_combo_set_model or hl_gtk_tree_combo_set_model.
    ! The default model is a 1-column list with the strings (indices can
    ! be obtained from the PATH argument in the edited hander.
    !-

    integer(c_int), parameter :: ncols=1
    integer(type_kind), dimension(ncols), target :: coltypes = &
         & [G_TYPE_STRING]
    type(gvalue), target :: modelv, columnv
    type(c_ptr) :: pmodel, pcolumn, model
    integer(c_int) :: icol

    ! Create the model
    if (present(cmodel)) then
       model = cmodel
       if (present(colno)) then
          icol = colno
       else
          icol = 0
       end if
    else
       model = gtk_list_store_newv(ncols, c_loc(coltypes))
       icol = 0
    end if

    ! Attach it to the renderer.
    pmodel = c_loc(modelv)
    pmodel = g_value_init(pmodel, gtk_tree_model_get_type())
    call g_value_set_object(pmodel, model)
    call g_object_set_property(renderer, "model"//c_null_char, pmodel)

    ! Tell the renderer that the text is in column 0
    pcolumn = c_loc(columnv)
    pcolumn = g_value_init(pcolumn, G_TYPE_INT)
    call g_value_set_int(pcolumn, icol)
    call g_object_set_property(renderer, "text-column"//c_null_char, &
         & pcolumn)
  end subroutine hl_gtk_list_tree_combo_model_attach

  !+
  subroutine  hl_gtk_list_tree_combo_model_config(view, colno, vals, &
       & append, has_entry)
    type(c_ptr), intent(in) :: view
    integer(c_int), intent(in) :: colno
    character(len=*), intent(in), dimension(:), optional :: vals
    integer(c_int), intent(in), optional :: append, has_entry

    ! Set the strings in the combo model.
    !
    ! VIEW |  c_ptr |  required |  The tree view that contains the combo cell renderer.
    ! COLNO |  c_int |  required |  The column number of the combo renderer.
    ! VALS |  f_string() |  required |  The strings for the combo box.
    ! APPEND |  c_int |  optional |  Set to TRUE to add the strings to those already present, otherwise the strings are replaced.
    ! HAS_ENTRY |  c_int |  optional |  Set to TRUE to add an entry field to the combo. Set to FALSE to remove an entry field.
    !
    ! This routine is always accessed by its aliases hl_gtk_tree_config_combo
    ! or hl_gtk_listn_config_combo
    !-

    type(c_ptr) :: col, rlist, renderer
    type(gvalue), target :: modelv, stringv, entryv
    type(c_ptr) :: pmodel, model, pstring, pentry
    logical :: iappend
    integer(c_int) :: nvals, i, valid
    type(gtktreeiter), target :: iter

    if (present(append)) then
       iappend = c_f_logical(append)
    else
       iappend = .false.
    end if

    ! Find the renderer for the column
    col = gtk_tree_view_get_column(view, colno)
    rlist = gtk_cell_layout_get_cells(col)
    renderer = g_list_nth_data(rlist, 0_c_int)
    call g_list_free(rlist)

    ! Find the model for the combobox
    pmodel = c_loc(modelv)
    pmodel = g_value_init(pmodel, gtk_tree_model_get_type())
    call g_object_get_property(renderer, "model"//c_null_char, pmodel)
    model = g_value_get_object(pmodel)

    pstring = c_loc(stringv)
    pstring = g_value_init(pstring, G_TYPE_STRING)

    if (present(vals)) then
       if (iappend) then
          nvals = gtk_tree_model_iter_n_children(model, c_null_ptr)
          valid = gtk_tree_model_iter_nth_child(model, c_loc(iter), &
               & c_null_ptr, nvals-1_c_int)
          do i = 1, size(vals)
             call clear_gtktreeiter(iter)
             call gtk_list_store_append(model, c_loc(iter))
             call g_value_set_string(pstring, trim(vals(i))//c_null_char)
             call gtk_list_store_set_value(model, c_loc(iter), 0_c_int, pstring)
          end do
       else
          call gtk_list_store_clear(model)
          do i = 1, size(vals)
             call clear_gtktreeiter(iter)
             call gtk_list_store_append(model, c_loc(iter))
             call g_value_set_string(pstring, trim(vals(i))//c_null_char)
             call gtk_list_store_set_value(model, c_loc(iter), 0_c_int, pstring)
          end do
       end if
    end if

    if (present(has_entry)) then
       pentry = c_loc(entryv)
       pentry = g_value_init(pentry, G_TYPE_BOOLEAN)
       call g_value_set_boolean(pentry, has_entry)
       call g_object_set_property(renderer, "has-entry"//c_null_char, pentry)
    end if

  end subroutine hl_gtk_list_tree_combo_model_config
end module gtk_hl_tree

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2022 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!
!==============================================================================
! Contributed by Vincent MAGNIN, 2022-05-06, last modified: 2025-03-26
!
! This program is testing functions of the gtk_sup module.
!==============================================================================

module tests
  use gtk_sup
  use, intrinsic :: iso_c_binding
  use gtk, only: TRUE, FALSE, gtk_init, gtk_label_new, gtk_label_get_text
  use g, only: g_value_init, g_value_unset, g_value_set_int, g_value_get_int, &
             & g_value_set_double, g_value_get_double, g_value_get_pointer, &
             & g_value_set_pointer, g_value_copy

  implicit none

contains

  integer function test_string_conversion_routines() result(errors)
    type(c_ptr) :: str_ptr, widget_ptr
    integer :: status
    character(len=128) :: fortran_string
    character(len=2)   :: short_fortran_string
    character(:), allocatable :: allocatable_fortran_string

    errors = 0

    widget_ptr = gtk_label_new("A label string"//c_null_char)
    str_ptr = gtk_label_get_text(widget_ptr)

    ! ------------------------------------------------
    print '(A)', ">> c_f_string_copy()"

    call c_f_string_copy(str_ptr, fortran_string, status)

    if (trim(fortran_string) /= "A label string") then
      print '(A)', "c_f_string_copy() does not return the expected Fortran string 'A label string'"
      errors = errors + 1
    end if

    if (len(trim(fortran_string)) /= strlen(str_ptr)) then
      print '(A)', "c_f_string_copy(): len() Fortran function and strlen() C function does not return the same value"
      errors = errors + 1
    end if

    call c_f_string_copy(str_ptr, short_fortran_string, status)

    if (status /= -1) then
      print '(A)', "c_f_string_copy() should have return status=-1 (Fortran string too short)"
      errors = errors + 1
    end if

    if (trim(short_fortran_string) /= "A ") then
      print '(A)', "c_f_string_copy() does not return the expected Fortran string 'A '"
      errors = errors + 1
    end if

    ! ------------------------------------------------
    print '(A)', ">> c_f_string_copy_alloc()"

    call c_f_string_copy_alloc(str_ptr, allocatable_fortran_string)

    if (trim(allocatable_fortran_string) /= "A label string") then
      print '(A)', "c_f_string_copy_alloc() does not return the expected Fortran string 'A label string'"
      errors = errors + 1
    end if

    if (len(trim(allocatable_fortran_string)) /= strlen(str_ptr)) then
      print '(A)', "c_f_string_copy_alloc(): len() Fortran function and strlen() C function does not return the same value"
      errors = errors + 1
    end if

  end function test_string_conversion_routines


  integer function test_date_routines() result(errors)
    character(:), allocatable :: today

    print '(A)', ">> fdate()"
    today = fdate()
    print '(A)', today

    errors = 0
  end function test_date_routines

  ! https://docs.gtk.org/gobject/method.Value.init.html
  integer function test_gvalue_routines() result(errors)
    type(gvalue), target :: val, val2   ! GValue (opaque) structures
    type(c_ptr) :: p_val, p_val2        ! C pointers toward GValue structures

    errors = 0

    print '(A)', ">> g_value_init(), g_value_set_int(), g_value_get_int()"
    ! Initialize the GValue:
    p_val = c_loc(val)
    p_val = g_value_init(p_val, G_TYPE_INT)
    call g_value_set_int(p_val, 1234_c_int)

    if (g_value_get_int(p_val) /= 1234_c_int) then
      print '(A)', "Problem!"
      errors = errors + 1
    end if

    print '(A)', ">> g_value_copy()"
    p_val2 = c_loc(val2)
    p_val2 = g_value_init(p_val2, G_TYPE_INT)
    call g_value_copy(p_val, p_val2)

    if (g_value_get_int(p_val2) /= g_value_get_int(p_val)) then
      print '(A)', "Problem!"
      errors = errors + 1
    end if

    print '(A)', ">> g_value_unset(), g_value_set_double(), g_value_get_double()"
    ! Changing the type of the GValue:
    call g_value_unset(p_val)
    p_val = g_value_init(p_val, G_TYPE_DOUBLE)

    call g_value_set_double(p_val, 3.14_c_double)
    if (g_value_get_double(p_val) /= 3.14_c_double) then
      print '(A)', "Problem!"
      errors = errors + 1
    end if

    print '(A)', ">> g_value_set_pointer(), g_value_get_pointer()"
    ! Changing the type of the GValue:
    call g_value_unset(p_val)
    p_val = g_value_init(p_val, G_TYPE_POINTER)

    call g_value_set_pointer(p_val, c_loc(val))
    p_val2 = g_value_get_pointer(p_val)
    ! FIXME: the following lines compiles with Intel ifx but causes an internal
    ! error with GFortran 14.2.0:
!    if (.not.c_associated(p_val2, c_loc(val))) then
!      print '(A)', "Problem!"
!      errors = errors + 1
!    end if

  end function test_gvalue_routines

end module tests


program tests_gtk_sup
  use tests

  implicit none
  integer :: errors = 0

  call gtk_init()

  print '(A)', "Testing some gtk_sup functions..."
  print *
  print '(A)', "> test_string_conversion_routines()"
  errors = errors + test_string_conversion_routines()
  print *
  print '(A)', "> test_date_routines()"
  errors = errors + test_date_routines()
  print *
  print '(A)', "> test_gvalue_routines()"
  errors = errors + test_gvalue_routines()

  print *
  if (errors == 0) then
    print '(A)', "No error"
  else
    print *, errors, "errors"
    print '(A)', "See the 'tests_errors.txt' file"
  end if
end program tests_gtk_sup

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2020 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!-------------------------------------------------------------------------------
! Vincent MAGNIN, 2020-02-18
! Last modified: 2020-05-07
! This example just creates a GTK application with an empty window.
! https://developer.gnome.org/gtk4/unstable/gtk-getting-started.html
! https://developer.gnome.org/gio/stable/GApplication.html
!-------------------------------------------------------------------------------

!*************************************
! User defined event handlers go here
!*************************************
module handlers

  use, intrinsic :: iso_c_binding, only: c_ptr, c_null_char
  use gtk, only: gtk_window_set_default_size, gtk_window_set_title, &
               & gtk_widget_show, gtk_application_window_new
  implicit none

contains
  ! Callback function for the signal "activate" emitted by g_application_run().
  ! We use a subroutine because it should return void.
  ! The GUI is defined here.
  subroutine activate(app, gdata) bind(c)
    type(c_ptr), value, intent(in) :: app, gdata
    type(c_ptr)                    :: window

    ! Create the window:
    window = gtk_application_window_new(app)
    ! Not compulsory, but can be used if you want a larger window:
    call gtk_window_set_default_size(window, 300, 200)
    ! Don't forget that C strings must end with a null char:
    call gtk_window_set_title(window, "Hello GLib & GTK world!"//c_null_char)
    ! If you don't show it, nothing will appear on screen...
    call gtk_widget_show(window)
  end subroutine activate

end module handlers

!*********************************************************************************************
! In the main program, we declare the GTK application, connect it to its "activate" function
! where we will create the GUI, and finally call the GLib main loop.
!*********************************************************************************************
program gtkzero

  use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_null_char, c_null_ptr, c_funloc
  ! We will use those GTK functions and values. The "only" statement can improve
  ! significantly the compilation time:
  use gtk, only: gtk_application_new, g_signal_connect, G_APPLICATION_FLAGS_NONE
  use g, only: g_application_run, g_object_unref

  use handlers

  implicit none
  integer(c_int)     :: status
  type(c_ptr)        :: app

  ! First, let's create a GTK application (it will initialize GTK).
  ! The application ID must contain at least one point:
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-id-is-valid
  app = gtk_application_new("gtk-fortran.examples.gtkzero"//c_null_char, &
                            & G_APPLICATION_FLAGS_NONE)
  ! The activate signal will be sent by g_application_run().
  ! The c_funloc() function returns the C address of the callback function.
  ! The c_null_ptr means no data is transfered to the callback function.
  call g_signal_connect(app, "activate"//c_null_char, c_funloc(activate), c_null_ptr)
  ! Now, the whole application will be managed by GLib (=> main loop).
  ! Note that commandline arguments argc, argv are not passed.
  ! https://developer.gnome.org/gio/stable/GApplication.html#g-application-run
  status = g_application_run(app, 0_c_int, [c_null_ptr])

  print *, "You have exited the GLib main loop, bye, bye..."

  ! Memory is freed:
  call g_object_unref(app)

end program gtkzero

! This file is part of gtk-fortran, a GTK / Fortran interface library.
! Copyright (C) 2011 The gtk-fortran team
!
! This is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 3, or (at your option)
! any later version.
!
! This software is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! Under Section 7 of GPL version 3, you are granted additional
! permissions described in the GCC Runtime Library Exception, version
! 3.1, as published by the Free Software Foundation.
!
! You should have received a copy of the GNU General Public License along with
! this program; see the files LICENSE and LICENSE_EXCEPTION respectively.
! If not, see <http://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! Contributed jtappin.
! Last modifications: vmagnin+Ian Harvey, 2020-02-03
! GTK 4 version: vmagnin 2020-06-02, 2022-05-06
!------------------------------------------------------------------------------

module handlers
  use, intrinsic :: iso_c_binding
!  use gtk_hl
  use gtk_hl_container
  use gtk_hl_button
  use gtk_hl_entry
  use gtk, only: gtk_window_set_child, &
       & gtk_widget_show, gtk_entry_get_text_length, &
       & gtk_entry_get_buffer, gtk_entry_buffer_get_text, &
       & gtk_text_iter_get_text, gtk_window_destroy

  implicit none
  type(c_ptr) ::  win, zedt, contain, qbut, box, entry, box2, &
                & abut, ibut, clbut, infobut

contains

  subroutine my_destroy(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    print *, "Exit called"
    call gtk_window_destroy(win)
  end subroutine my_destroy

  subroutine tv_change(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer(c_int) :: nl, nc
    integer(c_int), dimension(:), allocatable :: ncl

    print *, "CHANGED event"

    call hl_gtk_text_view_get_info(C_NULL_PTR, buffer=widget, nlines=nl, &
         & nchars=nc, ncline=ncl)
    print *, nl, nc
    print *, ncl
    deallocate(ncl)
  end subroutine tv_change

  subroutine tv_ins(widget,iter, text, nins, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    type(c_ptr), value :: iter, text
    integer(c_int), value :: nins

    integer(c_int) :: nl, nc
    integer(c_int), dimension(:), allocatable :: ncl

    character(kind=c_char), dimension(:), pointer :: cf_text
    character(len=100), dimension(:), allocatable :: f_text

    print *, "INSERT event", nins
    call c_f_pointer(text, cf_text, [ int(nins) ])
    call convert_c_string(cf_text, f_text)

    print "(a)", f_text

    call hl_gtk_text_view_get_info(C_NULL_PTR, buffer=widget, nlines=nl, &
         & nchars=nc, ncline=ncl)
    print *, nl, nc
    print *, ncl
  end subroutine tv_ins

  subroutine tv_del(widget, s_iter, e_iter, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    type(c_ptr), value :: s_iter, e_iter

    type(c_ptr) :: ctext
    character(len=100), dimension(:), allocatable :: ftext
    integer(c_int) :: dlen

    print *, "DELETE event"
    dlen = gtk_text_iter_get_offset(e_iter) - &
         & gtk_text_iter_get_offset(s_iter)

    ctext = gtk_text_iter_get_text(s_iter, e_iter)
    call convert_c_string(ctext, ftext)

    print "(A)", ftext(:)(:dlen)
    deallocate(ftext)
  end subroutine tv_del

  subroutine tv_append(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    type(c_ptr) :: buffer
    character(:), allocatable :: ftext

    buffer = gtk_entry_get_buffer(entry)
    call c_f_string_copy_alloc(gtk_entry_buffer_get_text(buffer), ftext)

    call hl_gtk_text_view_insert(zedt, [ ftext ])
  end subroutine tv_append

  subroutine tv_insert(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata
    type(c_ptr) :: buffer
    character(:), allocatable :: ftext

    buffer = gtk_entry_get_buffer(entry)
    call c_f_string_copy_alloc(gtk_entry_buffer_get_text(buffer), ftext)

    call hl_gtk_text_view_insert(zedt, [ ftext ], at_cursor=TRUE)
  end subroutine tv_insert

  subroutine tv_clr(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    call hl_gtk_text_view_delete(zedt)
  end subroutine tv_clr

  subroutine tv_info(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer(c_int), dimension(3) :: cursor, s_start, s_end
    integer(c_int) :: is_modified, has_select

    cursor = hl_gtk_text_view_get_cursor(zedt)
    has_select = hl_gtk_text_view_get_selection(zedt, &
         & s_start, s_end)
    is_modified = hl_gtk_text_view_get_modified(zedt)

    print *, "Cursor: Line",cursor(1),"Column",cursor(2),"Offset",cursor(3)
    if (has_select == TRUE) then
       print *, "Selection Start: Line",s_start(1),"Column",s_start(2), &
            & "Offset",s_start(3)
       print *, "Selection End: Line",s_end(1),"Column",s_end(2),"Offset", &
            & s_end(3)
    else
       print *, "No Selection"
    end if
    if (is_modified == TRUE) then
       print *, "Modified"
    else
       print *, "Not modified"
    end if
    call hl_gtk_text_view_set_modified(zedt, FALSE)
  end subroutine tv_info

  subroutine entry_text(widget, gdata) bind(c)
    type(c_ptr), value, intent(in) :: widget, gdata

    integer(c_int16_t) :: ntext

    ntext = gtk_entry_get_text_length(widget)
    if (ntext > 0) then
       call gtk_widget_set_sensitive(abut, TRUE)
       call gtk_widget_set_sensitive(ibut, TRUE)
    else
       call gtk_widget_set_sensitive(abut, FALSE)
       call gtk_widget_set_sensitive(ibut, FALSE)
    end if
  end subroutine entry_text

  subroutine activate(app, gdata) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
    use gtk, only: gtk_application_window_new, gtk_window_set_title
    implicit none
    type(c_ptr), value, intent(in)  :: app, gdata

    ! Make a window and a vertical box
    win = gtk_application_window_new(app)
    call gtk_window_set_title(win, "Scrolling text"//c_null_char)

    box = hl_gtk_box_new()
    call gtk_window_set_child(win, box)

    ! Make a scrolling text box and put it in the box
    zedt = hl_gtk_text_view_new(contain, editable=TRUE, &
         & changed=c_funloc(tv_change), &
         & insert_text=c_funloc(tv_ins), &
         & delete_range=c_funloc(tv_del), &
         & ssize=[350_c_int, 200_c_int], tooltip = &
         & "Try typing, pasting or cutting text in here"//c_null_char)
    call hl_gtk_box_pack(box, contain)

    ! Make a single line text entry, and buttons to append or place at cursor.
    entry = hl_gtk_entry_new(60_c_int, editable=TRUE, tooltip = &
         & "Enter text here, then click 'append' or 'insert'"//c_null_char, &
         & changed=c_funloc(entry_text))
    call hl_gtk_box_pack(box, entry, expand=FALSE)

    box2 = hl_gtk_box_new(horizontal=TRUE)
    call hl_gtk_box_pack(box, box2, expand=FALSE)

    abut = hl_gtk_button_new("Append"//c_null_char, clicked=c_funloc(tv_append), &
         & tooltip = "Add contents of entry box at end"//c_null_char, sensitive=FALSE)
    call hl_gtk_box_pack(box2, abut)
    ibut = hl_gtk_button_new("Insert"//c_null_char, clicked=c_funloc(tv_insert), &
         & tooltip = "Add contents of entry box at cursor"//c_null_char, &
         & sensitive=FALSE)
    call hl_gtk_box_pack(box2, ibut)

    ! And a clear button, and an info button
    infobut = hl_gtk_button_new("Information"//c_null_char, clicked=c_funloc(tv_info))
    call hl_gtk_box_pack(box, infobut, expand=FALSE)
    clbut = hl_gtk_button_new("Clear"//c_null_char, clicked=c_funloc(tv_clr))
    call hl_gtk_box_pack(box, clbut, expand=FALSE)

    ! Make a quit button and put that in the box, then
    ! put the box in the window.
    qbut = hl_gtk_button_new("Quit"//c_null_char, clicked=c_funloc(my_destroy))
    call hl_gtk_box_pack(box, qbut, expand=FALSE)

    ! Realize the window
    call gtk_widget_show(win)
  end subroutine activate
end module handlers


program ztext
  ! ZTEXT
  ! Simple multiline text box example
  use, intrinsic :: iso_c_binding, only: c_ptr, c_funloc, c_null_char
  use handlers

  implicit none
  type(c_ptr)        :: app

  app = hl_gtk_application_new("gtk-fortran.examples.hl_textview"//c_null_char, &
                             & c_funloc(activate))
end program ztext

#!/bin/sh
# This file is part of gtk-fortran, a GTK / Fortran interface library.
# Copyright (C) 2016 The gtk-fortran team
#
# Interactive script to build and test gtk-fortran with GFortran and Intel ifx
# before release
# Vincent MAGNIN, 2016-06-19
# Last modification: 2023-03-20

# For a safer script:
set -u

# Go to the top of the project:
cd ..

# Does the build directory already exists ?
if [ ! -d build ]; then
    mkdir build
    cd build
else
    cd build
    make clean
fi

echo '-------------------------------------------------------------------------'
echo 'Do you want to build gtk-fortran with the default Fortran compiler? (y/N)'
read -r answer
case ${answer} in
'Y' | 'y')
    cmake -D CMAKE_BUILD_TYPE=debug .. && make -j
    ;;
*)
    echo 'No building'
    ;;
esac

echo '-----------------------------------------------'
echo 'Do you want to launch the tests examples? (y/N)'
read -r answer
case ${answer} in
'Y' | 'y')
    # Launch all the examples, four at at time:
    ctest --timeout 5 -j 4 -VV
    ;;
*)
    echo 'Not testing'
    ;;
esac

echo '--------------------------------------------------------------------'
echo 'Do you want to install the gtk-fortran library on your system? (y/N)'
read -r answer
case ${answer} in
'Y' | 'y')
    sudo make install
    ;;
*)
    echo 'No installation'
    ;;
esac

echo '--------------------------------------------------------------------'
# Is Intel ifx installed on the system?
if ifx --version; then
    echo 'Do you want to build and test gtk-fortran with Intel ifx? (y/N)'
    read -r answer
    case ${answer} in
    'Y' | 'y')
        # Does that directory already exist?
        if [ ! -d /tmp/gtk-fortran/ ]; then
            mkdir /tmp/gtk-fortran/
        fi
        # Copy the gtk-fortran directory in /tmp/
        cp -r ../* /tmp/gtk-fortran/
        cd /tmp/gtk-fortran/build
        rm CMakeCache.txt
        make clean
        cmake -D CMAKE_BUILD_TYPE=debug -D EXCLUDE_PLPLOT=true -D CMAKE_Fortran_COMPILER:FILEPATH="$(which ifx)" .. && make -j && ctest --timeout 5 -j 4 -VV
        ;;
    *)
        echo 'No ifx build'
        ;;
    esac
fi

#!/bin/sh
# This file is part of gtk-fortran, a GTK / Fortran interface library.
# Copyright (C) 2016 The gtk-fortran team
#
# An interactive script to test projects gtk-fortran-extra
# and gtkzero_fpm before release
#
# Contributed by Vincent MAGNIN, 2023-03-20
# Last modification: 2023-03-20

# For a safer script:
set -u

echo '-------------------------------------------------------------------------'
echo 'gtk-fortran installed version:'
echo '-------------------------------------------------------------------------'
gtk-4-fortran | head -n 2

echo '--------------------------------------------------------------------'
echo 'Do you want to install the gtk-fortran library on your system? (y/N)'
read -r answer
case ${answer} in
'Y' | 'y')
    sudo make install
    ;;
*)
    echo 'No installation'
    ;;
esac

echo '-------------------------------------------------------------------------'
echo 'Do you want to test gtk-fortran-extra? (y/N)'
read -r answer
case ${answer} in
'Y' | 'y')
    cd /tmp
    git clone git@github.com:vmagnin/gtk-fortran-extra.git
    cd gtk-fortran-extra
    echo '******************'
    echo 'my_fast_app'
    cd my_fast_app && ./with_GUI.sh
    echo '******************'
    echo 'my_long_app'
    cd ../my_long_app && ./with_GUI.sh
    echo '******************'
    echo 'unknown_pleasures'
    cd ../unknown_pleasures && ./build.sh && ./a.out
    echo '******************'
    echo 'parallel_app'
    cd ../parallel_app && ./build.sh
    ;;
*)
    echo 'Not tested: gtk-fortran-extra'
    ;;
esac

echo '-----------------------------------------------------------------------'
echo 'Do you want to test gtkzero_fpm with the dev branch gtk4-vmagnin? (y/N)'
read -r answer
case ${answer} in
'Y' | 'y')
    cd /tmp
    git clone git@github.com:vmagnin/gtkzero_fpm.git
    cd gtkzero_fpm
    sed -i 's/branch = "gtk4"/branch = "gtk4-vmagnin"/g' fpm.toml
    fpm run
    ;;
*)
    echo 'Not tested: gtkzero_fpm'
    ;;
esac

#! /bin/sh
# This file is part of gtk-fortran, a GTK / Fortran interface library.
# Copyright (C) 2011 The gtk-fortran team
#
# Automatic screenshots of the gtk-fortran built examples
# Parameters: $1 suffix (e.g. -ubuntu11_04), $2 sleep time
# You need to install scrot
# GNU GPL 3
# Contributed by Vincent MAGNIN 2011-04-27
# Updated 2022-05-06

# For a safer script:
set -eu

if [ $# -eq 0 ]; then
  readonly seconds=3
  readonly suffix="-kubuntu_$(lsb_release -rs)"
else
  readonly seconds=${2}
  readonly suffix=${1}
fi

echo "Suffix: ${suffix}"
echo "Sleep time: ${seconds}"
echo "Taking screenshots..."

# Scanning all built examples:
for directory in ../build/examples/ ../build/plplot ../build/sketcher ; do
    cd ${directory}
    pwd
    for file in * ; do
        # Is it an executable file ?
        if [ -x "${file}" ] && [ ! -d "${file}" ] && [ ! "${file}" = "gio_demo" ] && [ ! "${file}" = "tests" ] && [ ! "${file}" = "tests_gtk_sup" ]; then
            echo "${file}"
            #Launch the program:
            ./"${file}" &
            sleep "${seconds}"
            #remove the double extension (seven characters after a point):
            picfile=$(echo "${file}"|sed 's/\..\{7\}$//')
            #Take and save a screenshot of the active window with border:
            scrot -ub ../../screenshots/"${picfile}${suffix}".png
            #Kill the program before launching next one:
            kill $!
        fi
    done
    # Go back to src before next iteration:
    cd ../../src
done

#! /bin/sh
# This file is part of gtk-fortran, a GTK / Fortran interface library.
# Copyright (C) 2011 The gtk-fortran team
#
# An alternative simple build system, using the directory ../build/byscript
# and finally launching one by one the examples for testing.
# - It does not substitute the @..@ strings in gtkf-sketcher.f90,
# and gtk-fortran.f90, unlike CMake.
# - It does not build the PLplot examples.
#
# GNU GPL v3
# Contributed by Vincent MAGNIN
# 2011-04-08, last updated 2022-07-20

# For a safer script:
set -eu

readonly BUILD_DIR='../build/byscript'

# Allow override of default compiler. For example:
#  FC='ifort' ./alt_build_test.sh
# The default compiler is:
: ${FC="gfortran"}

# Major version of GTK for the current branch (from VERSIONS file):
readonly GTKv=$(sed -n -E 's/gtk-fortran;([0-9]+).*/\1/p' ../VERSIONS)
echo "Building gtk-${GTKv}-fortran"

# Compiler and linker options:
readonly gtkoptions="$(pkg-config --cflags --libs gtk"${GTKv}")"

# Go to the top of the project:
cd ..

# Create (if needed) the build/byscript directory and go there:
if [ ! -d build ]; then
    mkdir build
fi
cd build

if [ ! -d byscript ]; then
    mkdir byscript
fi
cd byscript
if [ $? = 0 ]; then
    echo ">>> Removing old files..."
    rm -f ./*.o ./*.mod ./*.out
fi

# Needed to compile High-Level examples:
readonly gtk_hl_obj="gtk-hl-misc.o gtk-hl-button.o gtk-hl-combobox.o gtk-hl-container.o gtk-hl-entry.o gtk-hl-progress.o gtk-hl-spin-slider.o gtk-hl-tree.o  gtk-hl-chooser.o gtk-hl-dialog.o gtk-hl-infobar.o gtk-hl-assistant.o gdk-pixbuf-hl.o"

echo
echo ">>> Compiling the GTK libraries and gtk_hl using ${FC}"
for file in "gdk-auto.f90" "glib-auto.f90" "gtk.f90" "unix-print-auto.f90" "cairo-auto.f90" "gdk-pixbuf-auto.f90" "api_compatibility.f90" "pango-auto.f90" "gsk-auto.f90" "graphene-auto.f90" "gtk-sup.f90" "gtk-hl-misc.f90" "gtk-hl-button.f90" "gtk-hl-combobox.f90" "gtk-hl-container.f90" "gtk-hl-entry.f90" "gtk-hl-infobar.f90" "gtk-hl-assistant.f90" "gtk-hl-progress.f90" "gtk-hl-spin-slider.f90" "gtk-hl-tree.f90" "gtk-hl-chooser.f90" "gtk-hl-dialog.f90" "gtk-hl.f90" "gdkevents-auto.f90" "gtk-draw-hl.f90" "gdk-pixbuf-hl.f90"; do
  echo "${file}"
  #compile that file:
  "${FC}" -c ../../src/${file} ${gtkoptions}
done

echo
echo ">>> Compiling the examples..."
for i in ../../examples/*.f90 ; do
  #remove the 15th first characters '../../examples/':
  f=$(echo "${i}"|sed 's/^.\{15\}//')
  #remove the .f90 extension:
  e=$(echo "${f}"|sed 's/\.f90//')
  echo "${e}"
  #compile that file:
  "${FC}" gtk.o gtk-sup.o gtk-hl.o ${gtk_hl_obj} gtk-draw-hl.o "${i}" ${gtkoptions} -o "${e}.out"
done
# Other examples:
"${FC}" gtk.o ../../examples/gtkbuilder2.f90 -o gtkbuilder2.out ${gtkoptions} $(pkg-config --cflags --libs gmodule-2.0)

"${FC}" gtk.o gtk-sup.o gtk-hl.o ${gtk_hl_obj} ../../sketcher/gtkf-sketcher.f90 ${gtkoptions} $(pkg-config --cflags --libs gmodule-2.0) -o gtkf-sketcher.out

# List the executables:
echo
echo ">>> Executables in ${BUILD_DIR}"
ls ./*.out
echo

# Copy directories and files needed to run the programs:
cp -r ../../sketcher/data/ ../../sketcher/default.options ../../sketcher/*.glade .
cp ../../examples/gtkbuilder.ui .

echo ">>> Running each example (CTRL+C to exit)..."
for i in *.out ; do
  if [ ! "${i}" = "gio_demo.out" ]; then
    echo "${i}"
    ./"${i}"
  fi
done

#! /bin/sh
# This file is part of gtk-fortran, a GTK / Fortran interface library.
# Copyright (C) 2019 The gtk-fortran team
#
# Show libraries and tools versions used in gtk-fortran
# Parameters: none
# Contributed by Vincent MAGNIN, 2019-03-13
# Updated 2023-04-28
# Needs: in Fedora, lsb_release is in the package redhat-lsb-core

# The shell -e option is not used in this script to avoid exiting each time a
# command is not installed on a specific system:
set -u

echo "======="
echo "SYSTEM:"
echo "======="

# Distribution (Linux only):
readonly RELEASE="$(lsb_release -sd)"
echo "${RELEASE}"
# Kernel, release, processor, OS:
readonly SYSTEM="$(uname -srpo)"
echo "${SYSTEM}"

echo "=========="
echo "LIBRARIES:"
echo "=========="

# Default package names (Debian/Ubuntu):
readonly LIB_GTK2="libgtk2.0-dev"
readonly LIB_GTK3="libgtk-3-dev"
readonly LIB_GTK4="libgtk-4-dev"
readonly LIB_GLIB="libglib2.0-dev"
readonly LIB_PLPLOT="libplplot-dev"

if echo "${SYSTEM}" | grep -q MINGW ; then
    pacman -Q mingw-w64-ucrt-x86_64-gtk2
    pacman -Q mingw-w64-ucrt-x86_64-gtk3	
    pacman -Q mingw-w64-ucrt-x86_64-gtk4	
    pacman -Q mingw-w64-ucrt-x86_64-glib2
    pacman -Q mingw-w64-ucrt-x86_64-plplot
elif echo "${SYSTEM}" | grep -q MANJARO ; then
    pacman -Q gtk2
    pacman -Q gtk3
    pacman -Q glib2
    pacman -Q plplot
elif echo "${SYSTEM}" | grep -q fc ; then    # Fedora
    dnf info --installed gtk2-devel | grep Source
    dnf info --installed gtk3-devel | grep Source
    dnf info --installed gtk4-devel | grep Source
    dnf info --installed glib2 | grep Source
    dnf info --installed plplot-devel | grep Source
elif echo "${SYSTEM}" | grep -q FreeBSD ; then
    pkg info gtk2 | grep gtk2-
    pkg info gtk3 | grep gtk3-
    pkg info gtk4 | grep gtk4-
    pkg info glib | grep ^glib
    pkg info plplot | grep plplot-
elif echo "${RELEASE}" | grep -q openSUSE ; then
    zypper info gtk2-devel | grep Source
    zypper info gtk3-devel | grep Source
    zypper info glib2-devel | grep Source
    zypper info plplot-devel | grep Source
else
    dpkg-query --show ${LIB_GTK2}
    dpkg-query --show ${LIB_GTK3}
    dpkg-query --show ${LIB_GTK4}
    dpkg-query --show ${LIB_GLIB}
    dpkg-query --show ${LIB_PLPLOT}
fi

echo "=========="
echo "LANGUAGES:"
echo "=========="

if echo "${SYSTEM}" | grep -q FreeBSD ; then
    gfortran11 --version | head -n 1
else
    gfortran --version | head -n 1
fi

python3 --version
perl --version | head -n 2 | tail -n 1
bash --version | head -n 1

echo "============"
echo "BUILD TOOLS:"
echo "============"

#echo "meson $(meson --version)"
cmake --version | head -n 1
echo "pkg-config $(pkg-config --version)"
make --version | grep "GNU Make"
git --version

#echo "============"
#echo "OTHER TOOLS:"
#echo "============"

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: Bug
assignees: vmagnin

---

**Describe the bug**
A clear and concise description of what the bug is. Tell which branch of the project is concerned (e.g. gtk3).

**Expected behavior**
A clear and concise description of what you expected to happen.
If applicable, add screenshots to help explain your problem.

**To Reproduce**
Steps to reproduce the behavior:
1. 
2. 
...

**Your system:**
 - OS version: [e.g. Ubuntu 18.04 64 bits]
 - Compiler version: [e.g. gfortran 8.2.0]
 - GTK branch: [e.g gtk4]

**Additional context**
Add any other context about the problem here.

Last update: 2025-03-07

Dependencies
================================

If you want to use gtk-fortran as a fpm dependency, you just need:
- A modern Fortran compiler (>= Fortran 2008 standard), for example gfortran, ifort, ifx...
- GTK and the associated development files. For 4.x use the "gtk4" branch.
- The Fortran Package Manager [fpm](https://fpm.fortran-lang.org).

If you want to build and install the whole project (library, tools, examples...), you also need:
- CMake (>=3.10) and pkg-config.
- PLplot (>=5.13) is used if available (you need the development files).

Using gtk-fortran as a fpm dependency
================================

Starting from version 4.2, gtk-fortran can be used as a [fpm](https://fpm.fortran-lang.org) dependency. You simply need to add gtk-fortran in the dependencies section of the `fpm.toml` manifest of your project:

```toml
[dependencies]
gtk-fortran = { git = "https://github.com/vmagnin/gtk-fortran.git", branch = "gtk4" }
```

See the [gtkzero_fpm example](https://github.com/vmagnin/gtkzero_fpm) (MIT license) for a demonstration.


Building & installing gtk-fortran
================================

The build install system uses `cmake`. This file gives quick instructions to install gtk-fortran. **See the [Wiki documentation](https://github.com/vmagnin/gtk-fortran/wiki#installation-and-building) for more detailed instructions.**

UNIX/Linux
----------

To do an "out of source" build from the top-level directory on a
Unix/Linux system:

    mkdir build && cd build
    cmake ..
    make
    sudo make install

If the building of some examples causes an error, you can ignore them with
the `-i` option:

    make -i

cmake variables are set by using `-D<variable>=<value>`, for example to change the default install directory from `/usr/local` to `/usr`:

    cmake -DCMAKE_INSTALL_DIR=/usr ..

Useful variables that are specific to gtk-fortran are:

       EXCLUDE_PLPLOT -- set this to disable building the plplot
         integration even if PLplot is found.
       NO_BUILD_HL -- set this to disable building the High Level sub-library
         (includes PLplot and sketcher).
       NO_BUILD_EXAMPLES -- set this to prevent compiling the example
         programs, also mostly useful for packagers.
       INSTALL_EXAMPLES -- set this to install the source code of the
         examples into
         ${CMAKE_INSTALL_DATAROOTDIR/gtk-fortran/examples<gtkversion>,
         this would for example be useful if you were making a binary
         package of gtk-fortran.

To interactively control the build, use `ccmake` in place of `cmake`

Default compiler options can be overridden, for example:

    cmake -D CMAKE_Fortran_FLAGS_RELEASE="-O2 -std=f2018" ..

The system default Fortran compiler can be overridden, for example to use the Intel ifx compiler:

    cmake -D CMAKE_Fortran_COMPILER:FILEPATH=$(which ifx) ..

**************************************************************************
Sometimes it can help to clean out the build directory and re-run `cmake`:

     cd build
     rm -r *   ## MAKE SURE YOU ARE IN THE BUILD DIRECTORY BEFORE DOING THIS
     cmake ..
**************************************************************************

Other systems (Windows, macOS, FreeBSD...)
-------

See the Wiki documentation for specific and detailed instructions.

Known issues
------------

You can see or post issues on this page:

https://github.com/vmagnin/gtk-fortran/issues

Building your application
=========================

On Linux and Unix systems the build system generates a pkg-config file
and installs it. So building a single source file application should be
as simple as:

    gfortran my_app.f90 $(pkg-config --cflags --libs gtk-4-fortran)

If you have made a default install to `/usr/local` you *may* need to run:

    export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig

(Or

    setenv PKG_CONFIG_PATH /usr/local/lib/pkgconfig

if you use csh or one of its derivatives)

this will depend on your distribution, Ubuntu looks there by default,
Pardus and Manjaro don't.

Uninstalling gtk-fortran
========================

    sudo make uninstall

See https://gitlab.kitware.com/cmake/community/-/wikis/FAQ#can-i-do-make-uninstall-with-cmake

More informations
=================

See the documentation: https://github.com/vmagnin/gtk-fortran/wiki
